#include <stdint.h>
#define XTRACK_MULTIPOLE_NO_SYNRAD
#define XFIELDS_BB3D_NO_BEAMSTR
#define XFIELDS_BB3D_NO_BHABHA
#define XTRACK_GLOBAL_XY_LIMIT 1.0
#define FREEZE_VAR_delta
#define FREEZE_VAR_ptau
#define FREEZE_VAR_rpp
#define FREEZE_VAR_rvv
#define XSUITE_BACKTRACK
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

#ifndef XOBJ_TYPEDEF_ArrNFloat64
#define XOBJ_TYPEDEF_ArrNFloat64
typedef   struct ArrNFloat64_s * ArrNFloat64;
 static inline ArrNFloat64 ArrNFloat64_getp(ArrNFloat64 restrict  obj){
  int64_t offset=0;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ArrNFloat64_len(ArrNFloat64 restrict  obj){
  int64_t offset=0;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ArrNFloat64_get(const ArrNFloat64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ArrNFloat64_set(ArrNFloat64 restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ArrNFloat64_getp1(ArrNFloat64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_LongitudinalProfileQGaussianData
#define XOBJ_TYPEDEF_LongitudinalProfileQGaussianData
typedef   struct LongitudinalProfileQGaussianData_s * LongitudinalProfileQGaussianData;
 static inline LongitudinalProfileQGaussianData LongitudinalProfileQGaussianData_getp(LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  return (LongitudinalProfileQGaussianData)(( char*) obj+offset);
}
 static inline double LongitudinalProfileQGaussianData_get_number_of_particles(const LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalProfileQGaussianData_set_number_of_particles(LongitudinalProfileQGaussianData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalProfileQGaussianData_getp_number_of_particles(LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalProfileQGaussianData_get__q_tol(const LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalProfileQGaussianData_set__q_tol(LongitudinalProfileQGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalProfileQGaussianData_getp__q_tol(LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalProfileQGaussianData_get__z0(const LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalProfileQGaussianData_set__z0(LongitudinalProfileQGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalProfileQGaussianData_getp__z0(LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalProfileQGaussianData_get__sigma_z(const LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalProfileQGaussianData_set__sigma_z(LongitudinalProfileQGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalProfileQGaussianData_getp__sigma_z(LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalProfileQGaussianData_get__q_param(const LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalProfileQGaussianData_set__q_param(LongitudinalProfileQGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalProfileQGaussianData_getp__q_param(LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalProfileQGaussianData_get__cq_param(const LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalProfileQGaussianData_set__cq_param(LongitudinalProfileQGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalProfileQGaussianData_getp__cq_param(LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalProfileQGaussianData_get__beta_param(const LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalProfileQGaussianData_set__beta_param(LongitudinalProfileQGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalProfileQGaussianData_getp__beta_param(LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalProfileQGaussianData_get__sqrt_beta_param(const LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalProfileQGaussianData_set__sqrt_beta_param(LongitudinalProfileQGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalProfileQGaussianData_getp__sqrt_beta_param(LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalProfileQGaussianData_get__support_min(const LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalProfileQGaussianData_set__support_min(LongitudinalProfileQGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalProfileQGaussianData_getp__support_min(LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalProfileQGaussianData_get__support_max(const LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalProfileQGaussianData_set__support_max(LongitudinalProfileQGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalProfileQGaussianData_getp__support_max(LongitudinalProfileQGaussianData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_QGAUSSIAN 
#define XFIELDS_QGAUSSIAN 

 static inline
double LongitudinalProfileQGaussian_line_density_scalar(
		LongitudinalProfileQGaussianData prof, double z){

    const double number_of_particles = 
	    LongitudinalProfileQGaussianData_get_number_of_particles(prof);
    const double q = LongitudinalProfileQGaussianData_get__q_param(prof);
    const double cq = LongitudinalProfileQGaussianData_get__cq_param(prof);
    const double q_tol = LongitudinalProfileQGaussianData_get__q_tol(prof);
    const double z0 = LongitudinalProfileQGaussianData_get__z0(prof);
    const double beta_param = LongitudinalProfileQGaussianData_get__beta_param(prof);
    const double sqrt_beta_param = 
	    LongitudinalProfileQGaussianData_get__sqrt_beta_param(prof);
    const double z_min = LongitudinalProfileQGaussianData_get__support_min(prof);
    const double z_max = LongitudinalProfileQGaussianData_get__support_max(prof);

    const double factor = number_of_particles*sqrt_beta_param/cq; 


    if (fabs(q-1.) < q_tol){
	if (z<z_max && z>z_min){
	    double z_m_z0 = z - z0;
		return factor*exp(-beta_param*z_m_z0*z_m_z0 );
	}
	else{
		return 0; 
	}
    }
    else{
    	double exponent = 1./(1.-q);
	if (z<z_max && z>z_min){
	    double z_m_z0 = z - z0;
    		double q_exp_arg =  -(beta_param*z_m_z0*z_m_z0 );
    		double q_exp_res = pow(
	    	 (1.+(1.-q)*q_exp_arg), exponent );
    		return factor*q_exp_res;
	}
	else{
		return 0; 
	}
    }
}

 static inline
double LongitudinalProfileQGaussian_line_density_derivative_scalar(
		LongitudinalProfileQGaussianData prof, double z){

    const double number_of_particles = 
	    LongitudinalProfileQGaussianData_get_number_of_particles(prof);
    const double q = LongitudinalProfileQGaussianData_get__q_param(prof);
    const double cq = LongitudinalProfileQGaussianData_get__cq_param(prof);
    const double q_tol = LongitudinalProfileQGaussianData_get__q_tol(prof);
    const double z0 = LongitudinalProfileQGaussianData_get__z0(prof);
    const double beta_param = LongitudinalProfileQGaussianData_get__beta_param(prof);
    const double sqrt_beta_param = 
	    LongitudinalProfileQGaussianData_get__sqrt_beta_param(prof);
    const double z_min = LongitudinalProfileQGaussianData_get__support_min(prof);
    const double z_max = LongitudinalProfileQGaussianData_get__support_max(prof);

    const double factor = number_of_particles*sqrt_beta_param/cq;


    if (fabs(q-1.) < q_tol){
	if (z<z_max && z>z_min){
	    double z_m_z0 = z - z0;
		return -2*factor*beta_param*z_m_z0*exp(-beta_param*z_m_z0*z_m_z0 );
	}
	else{
		return 0;
	}
    }
    else{
    	double exponent = 1./(1.-q);
	if (z<z_max && z>z_min){
	    double z_m_z0 = z - z0;
    		double q_exp_arg =  -(beta_param*z_m_z0*z_m_z0 );
    		double q_exp_res = pow((1.+(1.-q)*q_exp_arg), exponent-1.);
    		return -2*factor*beta_param*z_m_z0*q_exp_res;
	}
	else{
		return 0;
	}
    }
}



 
void line_density_qgauss(LongitudinalProfileQGaussianData prof,
		               const int64_t n,
		    const double* z, 
		          double* res){

//   #pragma omp parallel for //only_for_context cpu_openmp 
for (int ii=0; ii<n; ii++){ //autovectorized


       res[ii] = LongitudinalProfileQGaussian_line_density_scalar(prof, z[ii]);
  
}//end autovectorized

}


 
void line_derivative_qgauss(LongitudinalProfileQGaussianData prof,
		               const int64_t n,
		    const double* z, 
		          double* res){

//   #pragma omp parallel for //only_for_context cpu_openmp 
for (int ii=0; ii<n; ii++){ //autovectorized


       res[ii] = LongitudinalProfileQGaussian_line_density_derivative_scalar(prof, z[ii]);
  
}//end autovectorized

}

#endif

#ifndef XOBJ_TYPEDEF_Arr6Float64
#define XOBJ_TYPEDEF_Arr6Float64
typedef   struct Arr6Float64_s * Arr6Float64;
 static inline Arr6Float64 Arr6Float64_getp(Arr6Float64 restrict  obj){
  int64_t offset=0;
  return (Arr6Float64)(( char*) obj+offset);
}
 static inline int64_t Arr6Float64_len(Arr6Float64 restrict  obj){
  return 6;
}
 static inline double Arr6Float64_get(const Arr6Float64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void Arr6Float64_set(Arr6Float64 restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* Arr6Float64_getp1(Arr6Float64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_Arr6x6Float64
#define XOBJ_TYPEDEF_Arr6x6Float64
typedef   struct Arr6x6Float64_s * Arr6x6Float64;
 static inline Arr6x6Float64 Arr6x6Float64_getp(Arr6x6Float64 restrict  obj){
  int64_t offset=0;
  return (Arr6x6Float64)(( char*) obj+offset);
}
 static inline int64_t Arr6x6Float64_len(Arr6x6Float64 restrict  obj){
  return 36;
}
 static inline double Arr6x6Float64_get(const Arr6x6Float64 restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=i0*48+i1*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void Arr6x6Float64_set(Arr6x6Float64 restrict  obj, int64_t i0, int64_t i1, double value){
  int64_t offset=0;
  offset+=i0*48+i1*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* Arr6x6Float64_getp2(Arr6x6Float64 restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=i0*48+i1*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_Arr1Float64
#define XOBJ_TYPEDEF_Arr1Float64
typedef   struct Arr1Float64_s * Arr1Float64;
 static inline Arr1Float64 Arr1Float64_getp(Arr1Float64 restrict  obj){
  int64_t offset=0;
  return (Arr1Float64)(( char*) obj+offset);
}
 static inline int64_t Arr1Float64_len(Arr1Float64 restrict  obj){
  return 1;
}
 static inline double Arr1Float64_get(const Arr1Float64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void Arr1Float64_set(Arr1Float64 restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* Arr1Float64_getp1(Arr1Float64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_Arr2Float64
#define XOBJ_TYPEDEF_Arr2Float64
typedef   struct Arr2Float64_s * Arr2Float64;
 static inline Arr2Float64 Arr2Float64_getp(Arr2Float64 restrict  obj){
  int64_t offset=0;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t Arr2Float64_len(Arr2Float64 restrict  obj){
  return 2;
}
 static inline double Arr2Float64_get(const Arr2Float64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void Arr2Float64_set(Arr2Float64 restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* Arr2Float64_getp1(Arr2Float64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_Arr6x6x6Float64
#define XOBJ_TYPEDEF_Arr6x6x6Float64
typedef   struct Arr6x6x6Float64_s * Arr6x6x6Float64;
 static inline Arr6x6x6Float64 Arr6x6x6Float64_getp(Arr6x6x6Float64 restrict  obj){
  int64_t offset=0;
  return (Arr6x6x6Float64)(( char*) obj+offset);
}
 static inline int64_t Arr6x6x6Float64_len(Arr6x6x6Float64 restrict  obj){
  return 216;
}
 static inline double Arr6x6x6Float64_get(const Arr6x6x6Float64 restrict  obj, int64_t i0, int64_t i1, int64_t i2){
  int64_t offset=0;
  offset+=i0*288+i1*48+i2*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void Arr6x6x6Float64_set(Arr6x6x6Float64 restrict  obj, int64_t i0, int64_t i1, int64_t i2, double value){
  int64_t offset=0;
  offset+=i0*288+i1*48+i2*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* Arr6x6x6Float64_getp3(Arr6x6x6Float64 restrict  obj, int64_t i0, int64_t i1, int64_t i2){
  int64_t offset=0;
  offset+=i0*288+i1*48+i2*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_ArrNInt64
#define XOBJ_TYPEDEF_ArrNInt64
typedef   struct ArrNInt64_s * ArrNInt64;
 static inline ArrNInt64 ArrNInt64_getp(ArrNInt64 restrict  obj){
  int64_t offset=0;
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ArrNInt64_len(ArrNInt64 restrict  obj){
  int64_t offset=0;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ArrNInt64_get(const ArrNInt64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ArrNInt64_set(ArrNInt64 restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ArrNInt64_getp1(ArrNInt64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_BiGaussianFieldMapData
#define XOBJ_TYPEDEF_BiGaussianFieldMapData
typedef   struct BiGaussianFieldMapData_s * BiGaussianFieldMapData;
 static inline BiGaussianFieldMapData BiGaussianFieldMapData_getp(BiGaussianFieldMapData restrict  obj){
  int64_t offset=0;
  return (BiGaussianFieldMapData)(( char*) obj+offset);
}
 static inline double BiGaussianFieldMapData_get_mean_x(const BiGaussianFieldMapData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void BiGaussianFieldMapData_set_mean_x(BiGaussianFieldMapData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BiGaussianFieldMapData_getp_mean_x(BiGaussianFieldMapData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double BiGaussianFieldMapData_get_mean_y(const BiGaussianFieldMapData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BiGaussianFieldMapData_set_mean_y(BiGaussianFieldMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BiGaussianFieldMapData_getp_mean_y(BiGaussianFieldMapData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double BiGaussianFieldMapData_get_sigma_x(const BiGaussianFieldMapData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void BiGaussianFieldMapData_set_sigma_x(BiGaussianFieldMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BiGaussianFieldMapData_getp_sigma_x(BiGaussianFieldMapData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double BiGaussianFieldMapData_get_sigma_y(const BiGaussianFieldMapData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void BiGaussianFieldMapData_set_sigma_y(BiGaussianFieldMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BiGaussianFieldMapData_getp_sigma_y(BiGaussianFieldMapData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double BiGaussianFieldMapData_get_min_sigma_diff(const BiGaussianFieldMapData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void BiGaussianFieldMapData_set_min_sigma_diff(BiGaussianFieldMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BiGaussianFieldMapData_getp_min_sigma_diff(BiGaussianFieldMapData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BiGaussianFieldMapData_get__updatable(const BiGaussianFieldMapData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BiGaussianFieldMapData_set__updatable(BiGaussianFieldMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BiGaussianFieldMapData_getp__updatable(BiGaussianFieldMapData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_RecordIndex
#define XOBJ_TYPEDEF_RecordIndex
typedef   struct RecordIndex_s * RecordIndex;
 static inline RecordIndex RecordIndex_getp(RecordIndex restrict  obj){
  int64_t offset=0;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t RecordIndex_get_capacity(const RecordIndex restrict  obj){
  int64_t offset=0;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RecordIndex_set_capacity(RecordIndex restrict  obj, int64_t value){
  int64_t offset=0;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RecordIndex_getp_capacity(RecordIndex restrict  obj){
  int64_t offset=0;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t RecordIndex_get_num_recorded(const RecordIndex restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void RecordIndex_set_num_recorded(RecordIndex restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=8;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* RecordIndex_getp_num_recorded(RecordIndex restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t RecordIndex_get__dummy(const RecordIndex restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void RecordIndex_set__dummy(RecordIndex restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=16;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* RecordIndex_getp__dummy(RecordIndex restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t RecordIndex_get_buffer_id(const RecordIndex restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RecordIndex_set_buffer_id(RecordIndex restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RecordIndex_getp_buffer_id(RecordIndex restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
#endif


 static inline
int64_t RecordIndex_get_slot(RecordIndex record_index){

    if (record_index == NULL){
        return -2;
    }
    int64_t capacity = RecordIndex_get_capacity(record_index);
      uint32_t* num_recorded = RecordIndex_getp_num_recorded(record_index);

    if(*num_recorded >= capacity){
        return -1;
    }

    uint32_t slot;

//    slot = atomic_add(num_recorded, 1);   //only_for_context opencl
//    slot = atomicAdd(num_recorded, 1);    //only_for_context cuda

//    #pragma omp atomic capture            //only_for_context cpu_openmp
    slot = (*num_recorded)++;             //only_for_context cpu_serial cpu_openmp

    if (slot >= capacity){
        *num_recorded = capacity;
        return -1;
    }
    return (int64_t)slot;
}

#ifndef XOBJ_TYPEDEF_ArrNUint32
#define XOBJ_TYPEDEF_ArrNUint32
typedef   struct ArrNUint32_s * ArrNUint32;
 static inline ArrNUint32 ArrNUint32_getp(ArrNUint32 restrict  obj){
  int64_t offset=0;
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ArrNUint32_len(ArrNUint32 restrict  obj){
  int64_t offset=0;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ArrNUint32_get(const ArrNUint32 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ArrNUint32_set(ArrNUint32 restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ArrNUint32_getp1(ArrNUint32 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_ArrNFloat32
#define XOBJ_TYPEDEF_ArrNFloat32
typedef   struct ArrNFloat32_s * ArrNFloat32;
 static inline ArrNFloat32 ArrNFloat32_getp(ArrNFloat32 restrict  obj){
  int64_t offset=0;
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t ArrNFloat32_len(ArrNFloat32 restrict  obj){
  int64_t offset=0;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float ArrNFloat32_get(const ArrNFloat32 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void ArrNFloat32_set(ArrNFloat32 restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* ArrNFloat32_getp1(ArrNFloat32 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_ArrNString
#define XOBJ_TYPEDEF_ArrNString
typedef   struct ArrNString_s * ArrNString;
 static inline ArrNString ArrNString_getp(ArrNString restrict  obj){
  int64_t offset=0;
  return (ArrNString)(( char*) obj+offset);
}
 static inline int64_t ArrNString_len(ArrNString restrict  obj){
  int64_t offset=0;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline  char* ArrNString_getp1(ArrNString restrict  obj, int64_t i0){
  int64_t offset=0;
  offset=*( int64_t*)(( char*) obj+offset+16+i0*8);
  return ( char*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_BeamPositionMonitorRecord
#define XOBJ_TYPEDEF_BeamPositionMonitorRecord
typedef   struct BeamPositionMonitorRecord_s * BeamPositionMonitorRecord;
 static inline BeamPositionMonitorRecord BeamPositionMonitorRecord_getp(BeamPositionMonitorRecord restrict  obj){
  int64_t offset=0;
  return (BeamPositionMonitorRecord)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamPositionMonitorRecord_getp_count(BeamPositionMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=24;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorRecord_len_count(BeamPositionMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=24;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamPositionMonitorRecord_get_count(const BeamPositionMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorRecord_set_count(BeamPositionMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=24;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorRecord_getp1_count(BeamPositionMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamPositionMonitorRecord_getp_x_sum(BeamPositionMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorRecord_len_x_sum(BeamPositionMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamPositionMonitorRecord_get_x_sum(const BeamPositionMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorRecord_set_x_sum(BeamPositionMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorRecord_getp1_x_sum(BeamPositionMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamPositionMonitorRecord_getp_y_sum(BeamPositionMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorRecord_len_y_sum(BeamPositionMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamPositionMonitorRecord_get_y_sum(const BeamPositionMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorRecord_set_y_sum(BeamPositionMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorRecord_getp1_y_sum(BeamPositionMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_BeamSizeMonitorRecord
#define XOBJ_TYPEDEF_BeamSizeMonitorRecord
typedef   struct BeamSizeMonitorRecord_s * BeamSizeMonitorRecord;
 static inline BeamSizeMonitorRecord BeamSizeMonitorRecord_getp(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  return (BeamSizeMonitorRecord)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorRecord_getp_count(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=40;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorRecord_len_count(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=40;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorRecord_get_count(const BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=40;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorRecord_set_count(BeamSizeMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=40;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorRecord_getp1_count(BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=40;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorRecord_getp_x_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorRecord_len_x_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorRecord_get_x_sum(const BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorRecord_set_x_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorRecord_getp1_x_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorRecord_getp_x2_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorRecord_len_x2_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorRecord_get_x2_sum(const BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorRecord_set_x2_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorRecord_getp1_x2_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorRecord_getp_y_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorRecord_len_y_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorRecord_get_y_sum(const BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorRecord_set_y_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorRecord_getp1_y_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorRecord_getp_y2_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorRecord_len_y2_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorRecord_get_y2_sum(const BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorRecord_set_y2_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorRecord_getp1_y2_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_EmittanceMonitorRecord
#define XOBJ_TYPEDEF_EmittanceMonitorRecord
typedef   struct EmittanceMonitorRecord_s * EmittanceMonitorRecord;
 static inline EmittanceMonitorRecord EmittanceMonitorRecord_getp(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  return (EmittanceMonitorRecord)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_count(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=224;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_count(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=224;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_count(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=224;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_count(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=224;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_count(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=224;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_x_sum1(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_x_sum1(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_x_sum1(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_x_sum1(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_x_sum1(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_px_sum1(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_px_sum1(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_px_sum1(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_px_sum1(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_px_sum1(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_y_sum1(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_y_sum1(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_y_sum1(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_y_sum1(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_y_sum1(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_py_sum1(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_py_sum1(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_py_sum1(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_py_sum1(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_py_sum1(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_zeta_sum1(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_zeta_sum1(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_zeta_sum1(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_zeta_sum1(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_zeta_sum1(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_pzeta_sum1(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_pzeta_sum1(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_pzeta_sum1(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_pzeta_sum1(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_pzeta_sum1(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_x_x_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_x_x_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_x_x_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_x_x_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_x_x_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_x_px_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_x_px_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_x_px_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_x_px_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_x_px_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_x_y_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_x_y_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_x_y_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_x_y_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_x_y_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_x_py_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_x_py_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_x_py_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_x_py_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_x_py_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_x_zeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_x_zeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_x_zeta_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_x_zeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_x_zeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_x_pzeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_x_pzeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_x_pzeta_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_x_pzeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_x_pzeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_px_px_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_px_px_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_px_px_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_px_px_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_px_px_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_px_y_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_px_y_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_px_y_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_px_y_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_px_y_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_px_py_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_px_py_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_px_py_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_px_py_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_px_py_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_px_zeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_px_zeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_px_zeta_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_px_zeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_px_zeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_px_pzeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_px_pzeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_px_pzeta_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_px_pzeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_px_pzeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_y_y_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_y_y_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_y_y_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_y_y_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_y_y_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_y_py_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_y_py_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_y_py_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_y_py_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_y_py_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_y_zeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_y_zeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_y_zeta_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_y_zeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_y_zeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_y_pzeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_y_pzeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_y_pzeta_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_y_pzeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_y_pzeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_py_py_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_py_py_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_py_py_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_py_py_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_py_py_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_py_zeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_py_zeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_py_zeta_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_py_zeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_py_zeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_py_pzeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_py_pzeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_py_pzeta_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_py_pzeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_py_pzeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_zeta_zeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_zeta_zeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_zeta_zeta_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_zeta_zeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_zeta_zeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_zeta_pzeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_zeta_pzeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_zeta_pzeta_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_zeta_pzeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_zeta_pzeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorRecord_getp_pzeta_pzeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorRecord_len_pzeta_pzeta_sum2(EmittanceMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorRecord_get_pzeta_pzeta_sum2(const EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorRecord_set_pzeta_pzeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorRecord_getp1_pzeta_pzeta_sum2(EmittanceMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_BeamProfileMonitorRecord
#define XOBJ_TYPEDEF_BeamProfileMonitorRecord
typedef   struct BeamProfileMonitorRecord_s * BeamProfileMonitorRecord;
 static inline BeamProfileMonitorRecord BeamProfileMonitorRecord_getp(BeamProfileMonitorRecord restrict  obj){
  int64_t offset=0;
  return (BeamProfileMonitorRecord)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamProfileMonitorRecord_getp_counts_x(BeamProfileMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=16;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorRecord_len_counts_x(BeamProfileMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=16;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamProfileMonitorRecord_get_counts_x(const BeamProfileMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorRecord_set_counts_x(BeamProfileMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=16;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorRecord_getp1_counts_x(BeamProfileMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamProfileMonitorRecord_getp_counts_y(BeamProfileMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorRecord_len_counts_y(BeamProfileMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamProfileMonitorRecord_get_counts_y(const BeamProfileMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorRecord_set_counts_y(BeamProfileMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorRecord_getp1_counts_y(BeamProfileMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_GeneralMaterialData
#define XOBJ_TYPEDEF_GeneralMaterialData
typedef   struct GeneralMaterialData_s * GeneralMaterialData;
 static inline GeneralMaterialData GeneralMaterialData_getp(GeneralMaterialData restrict  obj){
  int64_t offset=0;
  return (GeneralMaterialData)(( char*) obj+offset);
}
 static inline double GeneralMaterialData_get_Z(const GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void GeneralMaterialData_set_Z(GeneralMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* GeneralMaterialData_getp_Z(GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double GeneralMaterialData_get_A(const GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void GeneralMaterialData_set_A(GeneralMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* GeneralMaterialData_getp_A(GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double GeneralMaterialData_get_density(const GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void GeneralMaterialData_set_density(GeneralMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* GeneralMaterialData_getp_density(GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double GeneralMaterialData_get_excitation_energy(const GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void GeneralMaterialData_set_excitation_energy(GeneralMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* GeneralMaterialData_getp_excitation_energy(GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double GeneralMaterialData_get_nuclear_radius(const GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void GeneralMaterialData_set_nuclear_radius(GeneralMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* GeneralMaterialData_getp_nuclear_radius(GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double GeneralMaterialData_get_nuclear_elastic_slope(const GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void GeneralMaterialData_set_nuclear_elastic_slope(GeneralMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* GeneralMaterialData_getp_nuclear_elastic_slope(GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr6Float64 GeneralMaterialData_getp_cross_section(GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return (Arr6Float64)(( char*) obj+offset);
}
 static inline int64_t GeneralMaterialData_len_cross_section(GeneralMaterialData restrict  obj){
  return 6;
}
 static inline double GeneralMaterialData_get_cross_section(const GeneralMaterialData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=56;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void GeneralMaterialData_set_cross_section(GeneralMaterialData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=56;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* GeneralMaterialData_getp1_cross_section(GeneralMaterialData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=56;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double GeneralMaterialData_get_hcut(const GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void GeneralMaterialData_set_hcut(GeneralMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* GeneralMaterialData_getp_hcut(GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline  char* GeneralMaterialData_getp_name(GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( char*)(( char*) obj+offset);
}
 static inline int8_t GeneralMaterialData_get__only_mcs(const GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *(( int8_t*) obj+offset);
}
 static inline void GeneralMaterialData_set__only_mcs(GeneralMaterialData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=112;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* GeneralMaterialData_getp__only_mcs(GeneralMaterialData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( int8_t*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_MultiSetterData
#define XOBJ_TYPEDEF_MultiSetterData
typedef   struct MultiSetterData_s * MultiSetterData;
 static inline MultiSetterData MultiSetterData_getp(MultiSetterData restrict  obj){
  int64_t offset=0;
  return (MultiSetterData)(( char*) obj+offset);
}
 static inline ArrNInt64 MultiSetterData_getp_offsets(MultiSetterData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t MultiSetterData_len_offsets(MultiSetterData restrict  obj){
  int64_t offset=0;
  offset+=8;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t MultiSetterData_get_offsets(const MultiSetterData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=8;
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MultiSetterData_set_offsets(MultiSetterData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=8;
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MultiSetterData_getp1_offsets(MultiSetterData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=8;
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
#endif


 
void get_values_at_offsets_float64(
    MultiSetterData data,
      int8_t* buffer,
      double* out){

    int64_t num_offsets = MultiSetterData_len_offsets(data);

for (int ii=0; ii<num_offsets; ii++){ //autovectorized

        int64_t offs = MultiSetterData_get_offsets(data, ii);

        double val = *((  double*)(buffer + offs));
        out[ii] = val;
}//end autovectorized

}

 
void get_values_at_offsets_int64(
    MultiSetterData data,
      int8_t* buffer,
      int64_t* out){

    int64_t num_offsets = MultiSetterData_len_offsets(data);

for (int ii=0; ii<num_offsets; ii++){ //autovectorized

        int64_t offs = MultiSetterData_get_offsets(data, ii);

        int64_t val = *((  int64_t*)(buffer + offs));
        out[ii] = val;
}//end autovectorized

}

 
void set_values_at_offsets_float64(
    MultiSetterData data,
      int8_t* buffer,
      double* input){

    int64_t num_offsets = MultiSetterData_len_offsets(data);

for (int ii=0; ii<num_offsets; ii++){ //autovectorized

        int64_t offs = MultiSetterData_get_offsets(data, ii);

        double val = input[ii];
        *((  double*)(buffer + offs)) = val;
}//end autovectorized

}

 
void set_values_at_offsets_int64(
    MultiSetterData data,
      int8_t* buffer,
      int64_t* input){

    int64_t num_offsets = MultiSetterData_len_offsets(data);

for (int ii=0; ii<num_offsets; ii++){ //autovectorized

        int64_t offs = MultiSetterData_get_offsets(data, ii);

        int64_t val = input[ii];
        *((  int64_t*)(buffer + offs)) = val;
}//end autovectorized

}




#ifndef XOBJ_TYPEDEF_SynchrotronRadiationRecordData
#define XOBJ_TYPEDEF_SynchrotronRadiationRecordData
typedef   struct SynchrotronRadiationRecordData_s * SynchrotronRadiationRecordData;
 static inline SynchrotronRadiationRecordData SynchrotronRadiationRecordData_getp(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  return (SynchrotronRadiationRecordData)(( char*) obj+offset);
}
 static inline RecordIndex SynchrotronRadiationRecordData_getp__index(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t SynchrotronRadiationRecordData_get__index_capacity(const SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set__index_capacity(SynchrotronRadiationRecordData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SynchrotronRadiationRecordData_getp__index_capacity(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t SynchrotronRadiationRecordData_get__index_num_recorded(const SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set__index_num_recorded(SynchrotronRadiationRecordData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=16;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* SynchrotronRadiationRecordData_getp__index_num_recorded(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t SynchrotronRadiationRecordData_get__index__dummy(const SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set__index__dummy(SynchrotronRadiationRecordData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=24;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* SynchrotronRadiationRecordData_getp__index__dummy(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t SynchrotronRadiationRecordData_get__index_buffer_id(const SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set__index_buffer_id(SynchrotronRadiationRecordData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SynchrotronRadiationRecordData_getp__index_buffer_id(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 SynchrotronRadiationRecordData_getp_photon_energy(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t SynchrotronRadiationRecordData_len_photon_energy(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=72;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double SynchrotronRadiationRecordData_get_photon_energy(const SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set_photon_energy(SynchrotronRadiationRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SynchrotronRadiationRecordData_getp1_photon_energy(SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNInt64 SynchrotronRadiationRecordData_getp_at_element(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t SynchrotronRadiationRecordData_len_at_element(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t SynchrotronRadiationRecordData_get_at_element(const SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set_at_element(SynchrotronRadiationRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SynchrotronRadiationRecordData_getp1_at_element(SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 SynchrotronRadiationRecordData_getp_at_turn(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t SynchrotronRadiationRecordData_len_at_turn(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t SynchrotronRadiationRecordData_get_at_turn(const SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set_at_turn(SynchrotronRadiationRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SynchrotronRadiationRecordData_getp1_at_turn(SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 SynchrotronRadiationRecordData_getp_particle_id(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t SynchrotronRadiationRecordData_len_particle_id(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t SynchrotronRadiationRecordData_get_particle_id(const SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set_particle_id(SynchrotronRadiationRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SynchrotronRadiationRecordData_getp1_particle_id(SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 SynchrotronRadiationRecordData_getp_particle_delta(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t SynchrotronRadiationRecordData_len_particle_delta(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double SynchrotronRadiationRecordData_get_particle_delta(const SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set_particle_delta(SynchrotronRadiationRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SynchrotronRadiationRecordData_getp1_particle_delta(SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_BeamstrahlungTableData
#define XOBJ_TYPEDEF_BeamstrahlungTableData
typedef   struct BeamstrahlungTableData_s * BeamstrahlungTableData;
 static inline BeamstrahlungTableData BeamstrahlungTableData_getp(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  return (BeamstrahlungTableData)(( char*) obj+offset);
}
 static inline RecordIndex BeamstrahlungTableData_getp__index(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t BeamstrahlungTableData_get__index_capacity(const BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamstrahlungTableData_set__index_capacity(BeamstrahlungTableData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamstrahlungTableData_getp__index_capacity(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamstrahlungTableData_get__index_num_recorded(const BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamstrahlungTableData_set__index_num_recorded(BeamstrahlungTableData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=16;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamstrahlungTableData_getp__index_num_recorded(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamstrahlungTableData_get__index__dummy(const BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamstrahlungTableData_set__index__dummy(BeamstrahlungTableData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=24;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamstrahlungTableData_getp__index__dummy(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t BeamstrahlungTableData_get__index_buffer_id(const BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamstrahlungTableData_set__index_buffer_id(BeamstrahlungTableData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamstrahlungTableData_getp__index_buffer_id(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 BeamstrahlungTableData_getp_at_element(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BeamstrahlungTableData_len_at_element(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=112;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BeamstrahlungTableData_get_at_element(const BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=112;
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamstrahlungTableData_set_at_element(BeamstrahlungTableData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=112;
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamstrahlungTableData_getp1_at_element(BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=112;
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 BeamstrahlungTableData_getp_at_turn(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BeamstrahlungTableData_len_at_turn(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BeamstrahlungTableData_get_at_turn(const BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamstrahlungTableData_set_at_turn(BeamstrahlungTableData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamstrahlungTableData_getp1_at_turn(BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 BeamstrahlungTableData_getp_particle_id(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BeamstrahlungTableData_len_particle_id(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BeamstrahlungTableData_get_particle_id(const BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamstrahlungTableData_set_particle_id(BeamstrahlungTableData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamstrahlungTableData_getp1_particle_id(BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamstrahlungTableData_getp_primary_energy(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamstrahlungTableData_len_primary_energy(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamstrahlungTableData_get_primary_energy(const BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamstrahlungTableData_set_primary_energy(BeamstrahlungTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamstrahlungTableData_getp1_primary_energy(BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamstrahlungTableData_getp_photon_id(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamstrahlungTableData_len_photon_id(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamstrahlungTableData_get_photon_id(const BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamstrahlungTableData_set_photon_id(BeamstrahlungTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamstrahlungTableData_getp1_photon_id(BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamstrahlungTableData_getp_photon_energy(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamstrahlungTableData_len_photon_energy(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamstrahlungTableData_get_photon_energy(const BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamstrahlungTableData_set_photon_energy(BeamstrahlungTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamstrahlungTableData_getp1_photon_energy(BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamstrahlungTableData_getp_photon_critical_energy(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamstrahlungTableData_len_photon_critical_energy(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamstrahlungTableData_get_photon_critical_energy(const BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamstrahlungTableData_set_photon_critical_energy(BeamstrahlungTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamstrahlungTableData_getp1_photon_critical_energy(BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamstrahlungTableData_getp_rho_inv(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamstrahlungTableData_len_rho_inv(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamstrahlungTableData_get_rho_inv(const BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamstrahlungTableData_set_rho_inv(BeamstrahlungTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamstrahlungTableData_getp1_rho_inv(BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamstrahlungTableData_getp_n_avg(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamstrahlungTableData_len_n_avg(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamstrahlungTableData_get_n_avg(const BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamstrahlungTableData_set_n_avg(BeamstrahlungTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamstrahlungTableData_getp1_n_avg(BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamstrahlungTableData_getp_delta_avg(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamstrahlungTableData_len_delta_avg(BeamstrahlungTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamstrahlungTableData_get_delta_avg(const BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamstrahlungTableData_set_delta_avg(BeamstrahlungTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamstrahlungTableData_getp1_delta_avg(BeamstrahlungTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_BhabhaTableData
#define XOBJ_TYPEDEF_BhabhaTableData
typedef   struct BhabhaTableData_s * BhabhaTableData;
 static inline BhabhaTableData BhabhaTableData_getp(BhabhaTableData restrict  obj){
  int64_t offset=0;
  return (BhabhaTableData)(( char*) obj+offset);
}
 static inline RecordIndex BhabhaTableData_getp__index(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_get__index_capacity(const BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set__index_capacity(BhabhaTableData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BhabhaTableData_getp__index_capacity(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t BhabhaTableData_get__index_num_recorded(const BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set__index_num_recorded(BhabhaTableData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=16;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BhabhaTableData_getp__index_num_recorded(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t BhabhaTableData_get__index__dummy(const BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set__index__dummy(BhabhaTableData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=24;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BhabhaTableData_getp__index__dummy(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_get__index_buffer_id(const BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set__index_buffer_id(BhabhaTableData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BhabhaTableData_getp__index_buffer_id(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 BhabhaTableData_getp_at_element(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_len_at_element(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=136;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BhabhaTableData_get_at_element(const BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=136;
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set_at_element(BhabhaTableData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=136;
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BhabhaTableData_getp1_at_element(BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=136;
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 BhabhaTableData_getp_at_turn(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_len_at_turn(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BhabhaTableData_get_at_turn(const BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set_at_turn(BhabhaTableData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BhabhaTableData_getp1_at_turn(BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 BhabhaTableData_getp_particle_id(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_len_particle_id(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BhabhaTableData_get_particle_id(const BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set_particle_id(BhabhaTableData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BhabhaTableData_getp1_particle_id(BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BhabhaTableData_getp_primary_energy(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_len_primary_energy(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BhabhaTableData_get_primary_energy(const BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set_primary_energy(BhabhaTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BhabhaTableData_getp1_primary_energy(BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNInt64 BhabhaTableData_getp_photon_id(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_len_photon_id(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BhabhaTableData_get_photon_id(const BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set_photon_id(BhabhaTableData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BhabhaTableData_getp1_photon_id(BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BhabhaTableData_getp_photon_x(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_len_photon_x(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BhabhaTableData_get_photon_x(const BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set_photon_x(BhabhaTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BhabhaTableData_getp1_photon_x(BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BhabhaTableData_getp_photon_y(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_len_photon_y(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BhabhaTableData_get_photon_y(const BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set_photon_y(BhabhaTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BhabhaTableData_getp1_photon_y(BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BhabhaTableData_getp_photon_z(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_len_photon_z(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BhabhaTableData_get_photon_z(const BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set_photon_z(BhabhaTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BhabhaTableData_getp1_photon_z(BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BhabhaTableData_getp_photon_px(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_len_photon_px(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BhabhaTableData_get_photon_px(const BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set_photon_px(BhabhaTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BhabhaTableData_getp1_photon_px(BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BhabhaTableData_getp_photon_py(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_len_photon_py(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BhabhaTableData_get_photon_py(const BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set_photon_py(BhabhaTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BhabhaTableData_getp1_photon_py(BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BhabhaTableData_getp_photon_energy(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_len_photon_energy(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BhabhaTableData_get_photon_energy(const BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set_photon_energy(BhabhaTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BhabhaTableData_getp1_photon_energy(BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BhabhaTableData_getp_primary_scattering_angle(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_len_primary_scattering_angle(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BhabhaTableData_get_primary_scattering_angle(const BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set_primary_scattering_angle(BhabhaTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BhabhaTableData_getp1_primary_scattering_angle(BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BhabhaTableData_getp_photon_scattering_angle(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BhabhaTableData_len_photon_scattering_angle(BhabhaTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BhabhaTableData_get_photon_scattering_angle(const BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BhabhaTableData_set_photon_scattering_angle(BhabhaTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BhabhaTableData_getp1_photon_scattering_angle(BhabhaTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_LumiTableData
#define XOBJ_TYPEDEF_LumiTableData
typedef   struct LumiTableData_s * LumiTableData;
 static inline LumiTableData LumiTableData_getp(LumiTableData restrict  obj){
  int64_t offset=0;
  return (LumiTableData)(( char*) obj+offset);
}
 static inline RecordIndex LumiTableData_getp__index(LumiTableData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t LumiTableData_get__index_capacity(const LumiTableData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LumiTableData_set__index_capacity(LumiTableData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LumiTableData_getp__index_capacity(LumiTableData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t LumiTableData_get__index_num_recorded(const LumiTableData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void LumiTableData_set__index_num_recorded(LumiTableData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=16;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* LumiTableData_getp__index_num_recorded(LumiTableData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t LumiTableData_get__index__dummy(const LumiTableData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void LumiTableData_set__index__dummy(LumiTableData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=24;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* LumiTableData_getp__index__dummy(LumiTableData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t LumiTableData_get__index_buffer_id(const LumiTableData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LumiTableData_set__index_buffer_id(LumiTableData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LumiTableData_getp__index_buffer_id(LumiTableData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 LumiTableData_getp_at_element(LumiTableData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t LumiTableData_len_at_element(LumiTableData restrict  obj){
  int64_t offset=0;
  offset+=48;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t LumiTableData_get_at_element(const LumiTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=48;
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LumiTableData_set_at_element(LumiTableData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=48;
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LumiTableData_getp1_at_element(LumiTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=48;
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LumiTableData_getp_luminosity(LumiTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LumiTableData_len_luminosity(LumiTableData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LumiTableData_get_luminosity(const LumiTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LumiTableData_set_luminosity(LumiTableData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LumiTableData_getp1_luminosity(LumiTableData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_ParticlesData
#define XOBJ_TYPEDEF_ParticlesData
typedef   struct ParticlesData_s * ParticlesData;
 static inline ParticlesData ParticlesData_getp(ParticlesData restrict  obj){
  int64_t offset=0;
  return (ParticlesData)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_get__capacity(const ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set__capacity(ParticlesData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp__capacity(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_get__num_active_particles(const ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set__num_active_particles(ParticlesData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp__num_active_particles(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_get__num_lost_particles(const ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set__num_lost_particles(ParticlesData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp__num_lost_particles(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_get_start_tracking_at_element(const ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_start_tracking_at_element(ParticlesData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp_start_tracking_at_element(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ParticlesData_get_q0(const ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_q0(ParticlesData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp_q0(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesData_get_mass0(const ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_mass0(ParticlesData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp_mass0(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesData_get_t_sim(const ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_t_sim(ParticlesData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp_t_sim(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_p0c(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=312;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_p0c(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=312;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_p0c(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=312;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_p0c(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=312;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_p0c(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=312;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_gamma0(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_gamma0(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_gamma0(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_gamma0(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_gamma0(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_beta0(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_beta0(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_beta0(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_beta0(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_beta0(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_s(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_s(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_s(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_s(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_s(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_zeta(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_zeta(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_zeta(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_zeta(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_zeta(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_x(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_x(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_x(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_x(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_x(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_y(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_y(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_y(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_y(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_y(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_px(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_px(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_px(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_px(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_px(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_py(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_py(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_py(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_py(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_py(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_ptau(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_ptau(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_ptau(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_ptau(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_ptau(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_delta(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_delta(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_delta(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_delta(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_delta(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_rpp(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_rpp(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_rpp(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_rpp(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_rpp(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_rvv(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_rvv(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_rvv(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_rvv(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_rvv(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_chi(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_chi(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_chi(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_chi(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_chi(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_charge_ratio(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_charge_ratio(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_charge_ratio(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_charge_ratio(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_charge_ratio(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_weight(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_weight(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_weight(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_weight(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_weight(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_ax(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_ax(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_ax(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_ax(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_ax(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_ay(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_ay(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_ay(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_ay(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_ay(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_spin_x(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_spin_x(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_spin_x(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_spin_x(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_spin_x(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_spin_y(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_spin_y(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_spin_y(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_spin_y(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_spin_y(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_spin_z(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_spin_z(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_spin_z(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_spin_z(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_spin_z(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_anomalous_magnetic_moment(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_anomalous_magnetic_moment(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_anomalous_magnetic_moment(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_anomalous_magnetic_moment(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_anomalous_magnetic_moment(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesData_getp_pdg_id(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_pdg_id(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesData_get_pdg_id(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_pdg_id(ParticlesData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp1_pdg_id(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesData_getp_particle_id(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_particle_id(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesData_get_particle_id(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_particle_id(ParticlesData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp1_particle_id(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesData_getp_at_element(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_at_element(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesData_get_at_element(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_at_element(ParticlesData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp1_at_element(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesData_getp_at_turn(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_at_turn(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesData_get_at_turn(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_at_turn(ParticlesData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp1_at_turn(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesData_getp_state(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_state(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesData_get_state(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_state(ParticlesData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp1_state(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesData_getp_parent_particle_id(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_parent_particle_id(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesData_get_parent_particle_id(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_parent_particle_id(ParticlesData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp1_parent_particle_id(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesData_getp__rng_s1(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len__rng_s1(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesData_get__rng_s1(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set__rng_s1(ParticlesData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesData_getp1__rng_s1(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesData_getp__rng_s2(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len__rng_s2(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesData_get__rng_s2(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set__rng_s2(ParticlesData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesData_getp1__rng_s2(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesData_getp__rng_s3(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len__rng_s3(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesData_get__rng_s3(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set__rng_s3(ParticlesData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesData_getp1__rng_s3(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesData_getp__rng_s4(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len__rng_s4(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesData_get__rng_s4(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set__rng_s4(ParticlesData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesData_getp1__rng_s4(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2024.                 //
// ######################################### //

#ifndef XTRACK_BASE_RNG_H
#define XTRACK_BASE_RNG_H

#include <headers/track.h>

// Only include if compiled standalone, outside of Xsuite
#ifndef START_PER_PARTICLE_BLOCK
#include <stdint.h>
#endif

// Combined LCG-Thausworthe generator from (example 37-4):
// https://developer.nvidia.com/gpugems/gpugems3/part-vi-gpu-computing/chapter-37-efficient-random-number-generation-and-application
#define MASK 0xffffffffUL
#define TAUSWORTHE(s,a,b,c,d) ((((s) &c) <<d) &MASK) ^ (((((s) <<a) &MASK)^(s)) >>b)
#define LCG(s,A,C) ((((A*(s)) &MASK) + C) &MASK)

GPUFUN
uint32_t rng_get_int32 (uint32_t *s1, uint32_t *s2, uint32_t *s3, uint32_t *s4 ){
  *s1 = TAUSWORTHE (*s1, 13, 19, 4294967294UL, 12);  // p1=2^31-1
  *s2 = TAUSWORTHE (*s2, 2, 25, 4294967288UL, 4);    // p2=2^30-1
  *s3 = TAUSWORTHE (*s3, 3, 11, 4294967280UL, 17);   // p3=2^28-1
  *s4 = LCG(*s4, 1664525, 1013904223UL);             // p4=2^32

  // Combined period is lcm(p1,p2,p3,p4) ~ 2^121
  return ((*s1) ^ (*s2) ^ (*s3) ^ (*s4));
}

#ifndef TWO_TO_32
#define TWO_TO_32 4294967296.0
#endif

GPUFUN
double rng_get (uint32_t *s1, uint32_t *s2, uint32_t *s3, uint32_t *s4 ){

  return rng_get_int32(s1, s2, s3, s4) / TWO_TO_32; // uniform in [0, 1) 1e10 resolution

}

GPUFUN
void rng_set (uint32_t *s1, uint32_t *s2, uint32_t *s3, uint32_t *s4, uint32_t s ){
  *s1 = LCG (s, 69069, 0);
  if (*s1 < 2) *s1 += 2UL;
  *s2 = LCG (*s1, 69069, 0);
  if (*s2 < 8) *s2 += 8UL;
  *s3 = LCG (*s2, 69069, 0);
  if (*s3 < 16) *s3 += 16UL;
  *s4 = LCG (*s3, 69069, 0);

  /* "warm it up" */
  rng_get (s1, s2, s3, s4);
  rng_get (s1, s2, s3, s4);
  rng_get (s1, s2, s3, s4);
  rng_get (s1, s2, s3, s4);
  rng_get (s1, s2, s3, s4);
  rng_get (s1, s2, s3, s4);
  return;
}

#endif /* XTRACK_BASE_RNG_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2024.                 //
// ######################################### //

#ifndef XTRACK_PARTICLES_RNG_H
#define XTRACK_PARTICLES_RNG_H

#include <headers/track.h>

GPUKERN
void Particles_initialize_rand_gen(ParticlesData particles,
    GPUGLMEM uint32_t* seeds, int n_init){

    VECTORIZE_OVER(ii, n_init);

        uint32_t s1, s2, s3, s4, s;
        s = seeds[ii];

        rng_set(&s1, &s2, &s3, &s4, s);

        ParticlesData_set__rng_s1(particles, ii, s1);
        ParticlesData_set__rng_s2(particles, ii, s2);
        ParticlesData_set__rng_s3(particles, ii, s3);
        ParticlesData_set__rng_s4(particles, ii, s4);

    END_VECTORIZE;
}

#endif /* XTRACK_PARTICLES_RNG_H */


 
#define ELECTRON_MASS_EV 510998.95
#define MUON_MASS_EV 105658375.5
#define PION_MASS_EV 139570390.0
#define KAON_MASS_EV 493677000.0
#define PROTON_MASS_EV 938272088.16
#define DEUTERON_MASS_EV 1875612945.0
#define TRITON_MASS_EV 2808921136.68
#define He3_MASS_EV 2808391611.12
#define He4_MASS_EV 3727379411.8
#define U_MASS_EV 931494102.42
#define C10_MASS_EV 9330639707.0
#define C11_MASS_EV 10257084532.0
#define C12_MASS_EV 11177929229.0
#define C13_MASS_EV 12112548340.8
#define C14_MASS_EV 13043937327.9
#define C15_MASS_EV 13982284810.0
#define O14_MASS_EV 13048925215.0
#define O15_MASS_EV 13975267170.0
#define O16_MASS_EV 14899168636.6
#define O17_MASS_EV 15834590977.0
#define O18_MASS_EV 16766111027.3
#define O19_MASS_EV 17701720900.0
#define O20_MASS_EV 18633678340.0
#define Ne19_MASS_EV 17700140000.0
#define Ne20_MASS_EV 18622840116.3
#define Ne21_MASS_EV 19555644383.0
#define Ne22_MASS_EV 20484845538.0
#define Ne23_MASS_EV 21419210320.0
#define Ne24_MASS_EV 22349906830.0
#define Ar35_MASS_EV 32579246300.0
#define Ar36_MASS_EV 33503556145.0
#define Ar37_MASS_EV 34434334110.0
#define Ar38_MASS_EV 35362061070.0
#define Ar39_MASS_EV 36295027800.0
#define Ar40_MASS_EV 37224724197.0
#define Ar41_MASS_EV 38158190689.0
#define Ar42_MASS_EV 39088329600.0
#define Ar43_MASS_EV 40022236600.0
#define Ar44_MASS_EV 40953067200.0
#define Ar45_MASS_EV 41887463810.0
#define Ar46_MASS_EV 42818957400.0
#define Ar47_MASS_EV 43754855500.0
#define Fe52_MASS_EV 48389361230.0
#define Fe53_MASS_EV 49318239900.0
#define Fe54_MASS_EV 50244426920.0
#define Fe55_MASS_EV 51174694210.0
#define Fe56_MASS_EV 52103062570.0
#define Fe57_MASS_EV 53034981820.0
#define Fe58_MASS_EV 53964502670.0
#define Fe59_MASS_EV 54897487080.0
#define Fe60_MASS_EV 55828232900.0
#define Fe61_MASS_EV 56762219700.0
#define Fe62_MASS_EV 57693756300.0
#define Fe63_MASS_EV 58628492800.0
#define Fe64_MASS_EV 59560653000.0
#define Xe112_MASS_EV 104267313200.0
#define Xe113_MASS_EV 105196621000.0
#define Xe114_MASS_EV 106123241000.0
#define Xe115_MASS_EV 107053165000.0
#define Xe116_MASS_EV 107980269000.0
#define Xe117_MASS_EV 108910625000.0
#define Xe118_MASS_EV 109838225000.0
#define Xe119_MASS_EV 110769004000.0
#define Xe120_MASS_EV 111697120000.0
#define Xe121_MASS_EV 112628305000.0
#define Xe122_MASS_EV 113556926000.0
#define Xe123_MASS_EV 114488526100.0
#define Xe124_MASS_EV 115417601300.0
#define Xe125_MASS_EV 116349563400.0
#define Xe126_MASS_EV 117279110518.0
#define Xe127_MASS_EV 118211430100.0
#define Xe128_MASS_EV 119141384575.0
#define Xe129_MASS_EV 120074043142.0
#define Xe130_MASS_EV 121004352839.0
#define Xe131_MASS_EV 121937313842.0
#define Xe132_MASS_EV 122867942545.0
#define Xe133_MASS_EV 123801072000.0
#define Xe134_MASS_EV 124732083890.0
#define Xe135_MASS_EV 125665290400.0
#define Xe136_MASS_EV 126596768759.0
#define Xe137_MASS_EV 127532308620.0
#define Xe138_MASS_EV 128466214000.0
#define Xe139_MASS_EV 129402035700.0
#define Xe140_MASS_EV 130336187900.0
#define Xe141_MASS_EV 131272471200.0
#define Xe142_MASS_EV 132206932900.0
#define Au176_MASS_EV 163924444000.0
#define Au177_MASS_EV 164852911000.0
#define Au178_MASS_EV 165783647000.0
#define Au179_MASS_EV 166712456000.0
#define Au180_MASS_EV 167643312800.0
#define Au181_MASS_EV 168572561000.0
#define Au182_MASS_EV 169503622000.0
#define Au183_MASS_EV 170433229200.0
#define Au184_MASS_EV 171364597000.0
#define Au185_MASS_EV 172294550800.0
#define Au186_MASS_EV 173226188000.0
#define Au187_MASS_EV 174156368000.0
#define Au188_MASS_EV 175088520000.0
#define Au189_MASS_EV 176018803000.0
#define Au190_MASS_EV 176951046200.0
#define Au191_MASS_EV 177881575200.0
#define Au192_MASS_EV 178814096000.0
#define Au193_MASS_EV 179744956500.0
#define Au194_MASS_EV 180677644000.0
#define Au195_MASS_EV 181608782900.0
#define Au196_MASS_EV 182541705200.0
#define Au197_MASS_EV 183473198420.0
#define Au198_MASS_EV 184406251470.0
#define Au199_MASS_EV 185338232650.0
#define Au200_MASS_EV 186271581000.0
#define Au201_MASS_EV 187203914200.0
#define Au202_MASS_EV 188137456000.0
#define Au203_MASS_EV 189070159400.0
#define Au204_MASS_EV 190004410000.0
#define Au205_MASS_EV 190937720000.0
#define Au206_MASS_EV 191873600000.0
#define Au207_MASS_EV 192808640000.0
#define Au208_MASS_EV 193744870000.0
#define Au209_MASS_EV 194680040000.0
#define Au210_MASS_EV 195616440000.0
#define Pb185_MASS_EV 172314868000.0
#define Pb186_MASS_EV 173243222000.0
#define Pb187_MASS_EV 174174410200.0
#define Pb188_MASS_EV 175103080000.0
#define Pb189_MASS_EV 176034542000.0
#define Pb190_MASS_EV 176963463000.0
#define Pb191_MASS_EV 177895082400.0
#define Pb192_MASS_EV 178824315800.0
#define Pb193_MASS_EV 179756133000.0
#define Pb194_MASS_EV 180685648000.0
#define Pb195_MASS_EV 181617612000.0
#define Pb196_MASS_EV 182547495900.0
#define Pb197_MASS_EV 183479592800.0
#define Pb198_MASS_EV 184409764900.0
#define Pb199_MASS_EV 185342094600.0
#define Pb200_MASS_EV 186272570000.0
#define Pb201_MASS_EV 187205043000.0
#define Pb202_MASS_EV 188135868100.0
#define Pb203_MASS_EV 189068516300.0
#define Pb204_MASS_EV 189999687100.0
#define Pb205_MASS_EV 190932520900.0
#define Pb206_MASS_EV 191863999600.0
#define Pb207_MASS_EV 192796827200.0
#define Pb208_MASS_EV 193729024800.0
#define Pb209_MASS_EV 194664652900.0
#define Pb210_MASS_EV 195599033100.0
#define Pb211_MASS_EV 196534762600.0
#define Pb212_MASS_EV 197469200800.0
#define Pb213_MASS_EV 198405040200.0
#define Pb214_MASS_EV 199339554900.0
#define Pb215_MASS_EV 200275575000.0
#define Pb216_MASS_EV 201210230000.0
#define Pb217_MASS_EV 202146480000.0
#define Pb218_MASS_EV 203081340000.0
#define Pb219_MASS_EV 204017830000.0
#define Pb220_MASS_EV 204952840000.0
#define PHOTON_MASS_EV 0.0
#define PION0_MASS_EV 134976800.0
#define KAON0_MASS_EV 497611000.0
#define NEUTRON_MASS_EV 939565420.5
typedef struct {
                 int64_t  _capacity;
                 int64_t  _num_active_particles;
                 int64_t  _num_lost_particles;
                 int64_t  start_tracking_at_element;
                 double  q0;
                 double  mass0;
                 double  t_sim;
      double* p0c;
      double* gamma0;
      double* beta0;
      double* s;
      double* zeta;
      double* x;
      double* y;
      double* px;
      double* py;
      double* ptau;
      double* delta;
      double* rpp;
      double* rvv;
      double* chi;
      double* charge_ratio;
      double* weight;
      double* ax;
      double* ay;
      double* spin_x;
      double* spin_y;
      double* spin_z;
      double* anomalous_magnetic_moment;
      int64_t* pdg_id;
      int64_t* particle_id;
      int64_t* at_element;
      int64_t* at_turn;
      int64_t* state;
      int64_t* parent_particle_id;
      uint32_t* _rng_s1;
      uint32_t* _rng_s2;
      uint32_t* _rng_s3;
      uint32_t* _rng_s4;
                 int64_t ipart;
                 int64_t endpart;
      int8_t* io_buffer;
} LocalParticle;


             static inline
            void LocalParticle_add_to_p0c(LocalParticle* part, double value){
#ifndef FREEZE_VAR_p0c
  part->p0c[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_gamma0(LocalParticle* part, double value){
#ifndef FREEZE_VAR_gamma0
  part->gamma0[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_beta0(LocalParticle* part, double value){
#ifndef FREEZE_VAR_beta0
  part->beta0[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_s(LocalParticle* part, double value){
#ifndef FREEZE_VAR_s
  part->s[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_zeta(LocalParticle* part, double value){
#ifndef FREEZE_VAR_zeta
  part->zeta[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_x(LocalParticle* part, double value){
#ifndef FREEZE_VAR_x
  part->x[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_y(LocalParticle* part, double value){
#ifndef FREEZE_VAR_y
  part->y[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_px(LocalParticle* part, double value){
#ifndef FREEZE_VAR_px
  part->px[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_py(LocalParticle* part, double value){
#ifndef FREEZE_VAR_py
  part->py[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_ptau(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ptau
  part->ptau[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_delta(LocalParticle* part, double value){
#ifndef FREEZE_VAR_delta
  part->delta[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_rpp(LocalParticle* part, double value){
#ifndef FREEZE_VAR_rpp
  part->rpp[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_rvv(LocalParticle* part, double value){
#ifndef FREEZE_VAR_rvv
  part->rvv[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_chi(LocalParticle* part, double value){
#ifndef FREEZE_VAR_chi
  part->chi[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_charge_ratio(LocalParticle* part, double value){
#ifndef FREEZE_VAR_charge_ratio
  part->charge_ratio[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_weight(LocalParticle* part, double value){
#ifndef FREEZE_VAR_weight
  part->weight[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_ax(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ax
  part->ax[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_ay(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ay
  part->ay[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_spin_x(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_x
  part->spin_x[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_spin_y(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_y
  part->spin_y[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_spin_z(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_z
  part->spin_z[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_anomalous_magnetic_moment(LocalParticle* part, double value){
#ifndef FREEZE_VAR_anomalous_magnetic_moment
  part->anomalous_magnetic_moment[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_pdg_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_pdg_id
  part->pdg_id[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_particle_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_particle_id
  part->particle_id[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_at_element(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_at_element
  part->at_element[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_at_turn(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_at_turn
  part->at_turn[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_state(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_state
  part->state[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_parent_particle_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_parent_particle_id
  part->parent_particle_id[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to__rng_s1(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s1
  part->_rng_s1[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to__rng_s2(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s2
  part->_rng_s2[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to__rng_s3(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s3
  part->_rng_s3[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to__rng_s4(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s4
  part->_rng_s4[part->ipart] += value;
#endif
}


 static inline
int64_t LocalParticle_get__capacity(LocalParticle* part){
  return part->_capacity;
}
 static inline
int64_t LocalParticle_get__num_active_particles(LocalParticle* part){
  return part->_num_active_particles;
}
 static inline
int64_t LocalParticle_get__num_lost_particles(LocalParticle* part){
  return part->_num_lost_particles;
}
 static inline
int64_t LocalParticle_get_start_tracking_at_element(LocalParticle* part){
  return part->start_tracking_at_element;
}
 static inline
double LocalParticle_get_q0(LocalParticle* part){
  return part->q0;
}
 static inline
double LocalParticle_get_mass0(LocalParticle* part){
  return part->mass0;
}
 static inline
double LocalParticle_get_t_sim(LocalParticle* part){
  return part->t_sim;
}
 static inline
double LocalParticle_get_p0c(LocalParticle* part){
  return part->p0c[part->ipart];
}
 static inline
double LocalParticle_get_gamma0(LocalParticle* part){
  return part->gamma0[part->ipart];
}
 static inline
double LocalParticle_get_beta0(LocalParticle* part){
  return part->beta0[part->ipart];
}
 static inline
double LocalParticle_get_s(LocalParticle* part){
  return part->s[part->ipart];
}
 static inline
double LocalParticle_get_zeta(LocalParticle* part){
  return part->zeta[part->ipart];
}
 static inline
double LocalParticle_get_x(LocalParticle* part){
  return part->x[part->ipart];
}
 static inline
double LocalParticle_get_y(LocalParticle* part){
  return part->y[part->ipart];
}
 static inline
double LocalParticle_get_px(LocalParticle* part){
  return part->px[part->ipart];
}
 static inline
double LocalParticle_get_py(LocalParticle* part){
  return part->py[part->ipart];
}
 static inline
double LocalParticle_get_ptau(LocalParticle* part){
  return part->ptau[part->ipart];
}
 static inline
double LocalParticle_get_delta(LocalParticle* part){
  return part->delta[part->ipart];
}
 static inline
double LocalParticle_get_rpp(LocalParticle* part){
  return part->rpp[part->ipart];
}
 static inline
double LocalParticle_get_rvv(LocalParticle* part){
  return part->rvv[part->ipart];
}
 static inline
double LocalParticle_get_chi(LocalParticle* part){
  return part->chi[part->ipart];
}
 static inline
double LocalParticle_get_charge_ratio(LocalParticle* part){
  return part->charge_ratio[part->ipart];
}
 static inline
double LocalParticle_get_weight(LocalParticle* part){
  return part->weight[part->ipart];
}
 static inline
double LocalParticle_get_ax(LocalParticle* part){
  return part->ax[part->ipart];
}
 static inline
double LocalParticle_get_ay(LocalParticle* part){
  return part->ay[part->ipart];
}
 static inline
double LocalParticle_get_spin_x(LocalParticle* part){
  return part->spin_x[part->ipart];
}
 static inline
double LocalParticle_get_spin_y(LocalParticle* part){
  return part->spin_y[part->ipart];
}
 static inline
double LocalParticle_get_spin_z(LocalParticle* part){
  return part->spin_z[part->ipart];
}
 static inline
double LocalParticle_get_anomalous_magnetic_moment(LocalParticle* part){
  return part->anomalous_magnetic_moment[part->ipart];
}
 static inline
int64_t LocalParticle_get_pdg_id(LocalParticle* part){
  return part->pdg_id[part->ipart];
}
 static inline
int64_t LocalParticle_get_particle_id(LocalParticle* part){
  return part->particle_id[part->ipart];
}
 static inline
int64_t LocalParticle_get_at_element(LocalParticle* part){
  return part->at_element[part->ipart];
}
 static inline
int64_t LocalParticle_get_at_turn(LocalParticle* part){
  return part->at_turn[part->ipart];
}
 static inline
int64_t LocalParticle_get_state(LocalParticle* part){
  return part->state[part->ipart];
}
 static inline
int64_t LocalParticle_get_parent_particle_id(LocalParticle* part){
  return part->parent_particle_id[part->ipart];
}
 static inline
uint32_t LocalParticle_get__rng_s1(LocalParticle* part){
  return part->_rng_s1[part->ipart];
}
 static inline
uint32_t LocalParticle_get__rng_s2(LocalParticle* part){
  return part->_rng_s2[part->ipart];
}
 static inline
uint32_t LocalParticle_get__rng_s3(LocalParticle* part){
  return part->_rng_s3[part->ipart];
}
 static inline
uint32_t LocalParticle_get__rng_s4(LocalParticle* part){
  return part->_rng_s4[part->ipart];
}


             static inline
            void LocalParticle_set_p0c(LocalParticle* part, double value){
#ifndef FREEZE_VAR_p0c
  part->p0c[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_gamma0(LocalParticle* part, double value){
#ifndef FREEZE_VAR_gamma0
  part->gamma0[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_beta0(LocalParticle* part, double value){
#ifndef FREEZE_VAR_beta0
  part->beta0[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_s(LocalParticle* part, double value){
#ifndef FREEZE_VAR_s
  part->s[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_zeta(LocalParticle* part, double value){
#ifndef FREEZE_VAR_zeta
  part->zeta[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_x(LocalParticle* part, double value){
#ifndef FREEZE_VAR_x
  part->x[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_y(LocalParticle* part, double value){
#ifndef FREEZE_VAR_y
  part->y[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_px(LocalParticle* part, double value){
#ifndef FREEZE_VAR_px
  part->px[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_py(LocalParticle* part, double value){
#ifndef FREEZE_VAR_py
  part->py[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_ptau(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ptau
  part->ptau[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_delta(LocalParticle* part, double value){
#ifndef FREEZE_VAR_delta
  part->delta[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_rpp(LocalParticle* part, double value){
#ifndef FREEZE_VAR_rpp
  part->rpp[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_rvv(LocalParticle* part, double value){
#ifndef FREEZE_VAR_rvv
  part->rvv[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_chi(LocalParticle* part, double value){
#ifndef FREEZE_VAR_chi
  part->chi[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_charge_ratio(LocalParticle* part, double value){
#ifndef FREEZE_VAR_charge_ratio
  part->charge_ratio[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_weight(LocalParticle* part, double value){
#ifndef FREEZE_VAR_weight
  part->weight[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_ax(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ax
  part->ax[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_ay(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ay
  part->ay[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_spin_x(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_x
  part->spin_x[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_spin_y(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_y
  part->spin_y[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_spin_z(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_z
  part->spin_z[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_anomalous_magnetic_moment(LocalParticle* part, double value){
#ifndef FREEZE_VAR_anomalous_magnetic_moment
  part->anomalous_magnetic_moment[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_pdg_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_pdg_id
  part->pdg_id[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_particle_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_particle_id
  part->particle_id[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_at_element(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_at_element
  part->at_element[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_at_turn(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_at_turn
  part->at_turn[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_state(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_state
  part->state[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_parent_particle_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_parent_particle_id
  part->parent_particle_id[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set__rng_s1(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s1
  part->_rng_s1[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set__rng_s2(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s2
  part->_rng_s2[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set__rng_s3(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s3
  part->_rng_s3[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set__rng_s4(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s4
  part->_rng_s4[part->ipart] = value;
#endif
}


             static inline
            void LocalParticle_scale_p0c(LocalParticle* part, double value){
#ifndef FREEZE_VAR_p0c
  part->p0c[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_gamma0(LocalParticle* part, double value){
#ifndef FREEZE_VAR_gamma0
  part->gamma0[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_beta0(LocalParticle* part, double value){
#ifndef FREEZE_VAR_beta0
  part->beta0[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_s(LocalParticle* part, double value){
#ifndef FREEZE_VAR_s
  part->s[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_zeta(LocalParticle* part, double value){
#ifndef FREEZE_VAR_zeta
  part->zeta[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_x(LocalParticle* part, double value){
#ifndef FREEZE_VAR_x
  part->x[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_y(LocalParticle* part, double value){
#ifndef FREEZE_VAR_y
  part->y[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_px(LocalParticle* part, double value){
#ifndef FREEZE_VAR_px
  part->px[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_py(LocalParticle* part, double value){
#ifndef FREEZE_VAR_py
  part->py[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_ptau(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ptau
  part->ptau[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_delta(LocalParticle* part, double value){
#ifndef FREEZE_VAR_delta
  part->delta[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_rpp(LocalParticle* part, double value){
#ifndef FREEZE_VAR_rpp
  part->rpp[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_rvv(LocalParticle* part, double value){
#ifndef FREEZE_VAR_rvv
  part->rvv[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_chi(LocalParticle* part, double value){
#ifndef FREEZE_VAR_chi
  part->chi[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_charge_ratio(LocalParticle* part, double value){
#ifndef FREEZE_VAR_charge_ratio
  part->charge_ratio[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_weight(LocalParticle* part, double value){
#ifndef FREEZE_VAR_weight
  part->weight[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_ax(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ax
  part->ax[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_ay(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ay
  part->ay[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_spin_x(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_x
  part->spin_x[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_spin_y(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_y
  part->spin_y[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_spin_z(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_z
  part->spin_z[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_anomalous_magnetic_moment(LocalParticle* part, double value){
#ifndef FREEZE_VAR_anomalous_magnetic_moment
  part->anomalous_magnetic_moment[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_pdg_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_pdg_id
  part->pdg_id[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_particle_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_particle_id
  part->particle_id[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_at_element(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_at_element
  part->at_element[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_at_turn(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_at_turn
  part->at_turn[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_state(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_state
  part->state[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_parent_particle_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_parent_particle_id
  part->parent_particle_id[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale__rng_s1(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s1
  part->_rng_s1[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale__rng_s2(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s2
  part->_rng_s2[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale__rng_s3(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s3
  part->_rng_s3[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale__rng_s4(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s4
  part->_rng_s4[part->ipart] *= value;
#endif
}



         static inline
        void LocalParticle_exchange(LocalParticle* part, int64_t i1, int64_t i2){
        
    {
    double temp = part->p0c[i2];
    part->p0c[i2] = part->p0c[i1];
    part->p0c[i1] = temp;
     }
    {
    double temp = part->gamma0[i2];
    part->gamma0[i2] = part->gamma0[i1];
    part->gamma0[i1] = temp;
     }
    {
    double temp = part->beta0[i2];
    part->beta0[i2] = part->beta0[i1];
    part->beta0[i1] = temp;
     }
    {
    double temp = part->s[i2];
    part->s[i2] = part->s[i1];
    part->s[i1] = temp;
     }
    {
    double temp = part->zeta[i2];
    part->zeta[i2] = part->zeta[i1];
    part->zeta[i1] = temp;
     }
    {
    double temp = part->x[i2];
    part->x[i2] = part->x[i1];
    part->x[i1] = temp;
     }
    {
    double temp = part->y[i2];
    part->y[i2] = part->y[i1];
    part->y[i1] = temp;
     }
    {
    double temp = part->px[i2];
    part->px[i2] = part->px[i1];
    part->px[i1] = temp;
     }
    {
    double temp = part->py[i2];
    part->py[i2] = part->py[i1];
    part->py[i1] = temp;
     }
    {
    double temp = part->ptau[i2];
    part->ptau[i2] = part->ptau[i1];
    part->ptau[i1] = temp;
     }
    {
    double temp = part->delta[i2];
    part->delta[i2] = part->delta[i1];
    part->delta[i1] = temp;
     }
    {
    double temp = part->rpp[i2];
    part->rpp[i2] = part->rpp[i1];
    part->rpp[i1] = temp;
     }
    {
    double temp = part->rvv[i2];
    part->rvv[i2] = part->rvv[i1];
    part->rvv[i1] = temp;
     }
    {
    double temp = part->chi[i2];
    part->chi[i2] = part->chi[i1];
    part->chi[i1] = temp;
     }
    {
    double temp = part->charge_ratio[i2];
    part->charge_ratio[i2] = part->charge_ratio[i1];
    part->charge_ratio[i1] = temp;
     }
    {
    double temp = part->weight[i2];
    part->weight[i2] = part->weight[i1];
    part->weight[i1] = temp;
     }
    {
    double temp = part->ax[i2];
    part->ax[i2] = part->ax[i1];
    part->ax[i1] = temp;
     }
    {
    double temp = part->ay[i2];
    part->ay[i2] = part->ay[i1];
    part->ay[i1] = temp;
     }
    {
    double temp = part->spin_x[i2];
    part->spin_x[i2] = part->spin_x[i1];
    part->spin_x[i1] = temp;
     }
    {
    double temp = part->spin_y[i2];
    part->spin_y[i2] = part->spin_y[i1];
    part->spin_y[i1] = temp;
     }
    {
    double temp = part->spin_z[i2];
    part->spin_z[i2] = part->spin_z[i1];
    part->spin_z[i1] = temp;
     }
    {
    double temp = part->anomalous_magnetic_moment[i2];
    part->anomalous_magnetic_moment[i2] = part->anomalous_magnetic_moment[i1];
    part->anomalous_magnetic_moment[i1] = temp;
     }
    {
    int64_t temp = part->pdg_id[i2];
    part->pdg_id[i2] = part->pdg_id[i1];
    part->pdg_id[i1] = temp;
     }
    {
    int64_t temp = part->particle_id[i2];
    part->particle_id[i2] = part->particle_id[i1];
    part->particle_id[i1] = temp;
     }
    {
    int64_t temp = part->at_element[i2];
    part->at_element[i2] = part->at_element[i1];
    part->at_element[i1] = temp;
     }
    {
    int64_t temp = part->at_turn[i2];
    part->at_turn[i2] = part->at_turn[i1];
    part->at_turn[i1] = temp;
     }
    {
    int64_t temp = part->state[i2];
    part->state[i2] = part->state[i1];
    part->state[i1] = temp;
     }
    {
    int64_t temp = part->parent_particle_id[i2];
    part->parent_particle_id[i2] = part->parent_particle_id[i1];
    part->parent_particle_id[i1] = temp;
     }
    {
    uint32_t temp = part->_rng_s1[i2];
    part->_rng_s1[i2] = part->_rng_s1[i1];
    part->_rng_s1[i1] = temp;
     }
    {
    uint32_t temp = part->_rng_s2[i2];
    part->_rng_s2[i2] = part->_rng_s2[i1];
    part->_rng_s2[i1] = temp;
     }
    {
    uint32_t temp = part->_rng_s3[i2];
    part->_rng_s3[i2] = part->_rng_s3[i1];
    part->_rng_s3[i1] = temp;
     }
    {
    uint32_t temp = part->_rng_s4[i2];
    part->_rng_s4[i2] = part->_rng_s4[i1];
    part->_rng_s4[i1] = temp;
     }}



             static inline
              int8_t* LocalParticle_get_io_buffer(LocalParticle* part){
                return part->io_buffer;
            }

            

             static inline
            void Particles_to_LocalParticle(ParticlesData source,
                                            LocalParticle* dest,
                                            int64_t id,
                                            int64_t eid){
  dest->_capacity = ParticlesData_get__capacity(source);
  dest->_num_active_particles = ParticlesData_get__num_active_particles(source);
  dest->_num_lost_particles = ParticlesData_get__num_lost_particles(source);
  dest->start_tracking_at_element = ParticlesData_get_start_tracking_at_element(source);
  dest->q0 = ParticlesData_get_q0(source);
  dest->mass0 = ParticlesData_get_mass0(source);
  dest->t_sim = ParticlesData_get_t_sim(source);
  dest->p0c = ParticlesData_getp1_p0c(source, 0);
  dest->gamma0 = ParticlesData_getp1_gamma0(source, 0);
  dest->beta0 = ParticlesData_getp1_beta0(source, 0);
  dest->s = ParticlesData_getp1_s(source, 0);
  dest->zeta = ParticlesData_getp1_zeta(source, 0);
  dest->x = ParticlesData_getp1_x(source, 0);
  dest->y = ParticlesData_getp1_y(source, 0);
  dest->px = ParticlesData_getp1_px(source, 0);
  dest->py = ParticlesData_getp1_py(source, 0);
  dest->ptau = ParticlesData_getp1_ptau(source, 0);
  dest->delta = ParticlesData_getp1_delta(source, 0);
  dest->rpp = ParticlesData_getp1_rpp(source, 0);
  dest->rvv = ParticlesData_getp1_rvv(source, 0);
  dest->chi = ParticlesData_getp1_chi(source, 0);
  dest->charge_ratio = ParticlesData_getp1_charge_ratio(source, 0);
  dest->weight = ParticlesData_getp1_weight(source, 0);
  dest->ax = ParticlesData_getp1_ax(source, 0);
  dest->ay = ParticlesData_getp1_ay(source, 0);
  dest->spin_x = ParticlesData_getp1_spin_x(source, 0);
  dest->spin_y = ParticlesData_getp1_spin_y(source, 0);
  dest->spin_z = ParticlesData_getp1_spin_z(source, 0);
  dest->anomalous_magnetic_moment = ParticlesData_getp1_anomalous_magnetic_moment(source, 0);
  dest->pdg_id = ParticlesData_getp1_pdg_id(source, 0);
  dest->particle_id = ParticlesData_getp1_particle_id(source, 0);
  dest->at_element = ParticlesData_getp1_at_element(source, 0);
  dest->at_turn = ParticlesData_getp1_at_turn(source, 0);
  dest->state = ParticlesData_getp1_state(source, 0);
  dest->parent_particle_id = ParticlesData_getp1_parent_particle_id(source, 0);
  dest->_rng_s1 = ParticlesData_getp1__rng_s1(source, 0);
  dest->_rng_s2 = ParticlesData_getp1__rng_s2(source, 0);
  dest->_rng_s3 = ParticlesData_getp1__rng_s3(source, 0);
  dest->_rng_s4 = ParticlesData_getp1__rng_s4(source, 0);
  dest->ipart = id;
  dest->endpart = eid;
}


             static inline
            void LocalParticle_to_Particles(
                                            LocalParticle* source,
                                            ParticlesData dest,
                                            int64_t id,
                                            int64_t set_scalar){
if (set_scalar){
  ParticlesData_set__capacity(dest,      LocalParticle_get__capacity(source));
  ParticlesData_set__num_active_particles(dest,      LocalParticle_get__num_active_particles(source));
  ParticlesData_set__num_lost_particles(dest,      LocalParticle_get__num_lost_particles(source));
  ParticlesData_set_start_tracking_at_element(dest,      LocalParticle_get_start_tracking_at_element(source));
  ParticlesData_set_q0(dest,      LocalParticle_get_q0(source));
  ParticlesData_set_mass0(dest,      LocalParticle_get_mass0(source));
  ParticlesData_set_t_sim(dest,      LocalParticle_get_t_sim(source));
}
  ParticlesData_set_p0c(dest, id,       LocalParticle_get_p0c(source));
  ParticlesData_set_gamma0(dest, id,       LocalParticle_get_gamma0(source));
  ParticlesData_set_beta0(dest, id,       LocalParticle_get_beta0(source));
  ParticlesData_set_s(dest, id,       LocalParticle_get_s(source));
  ParticlesData_set_zeta(dest, id,       LocalParticle_get_zeta(source));
  ParticlesData_set_x(dest, id,       LocalParticle_get_x(source));
  ParticlesData_set_y(dest, id,       LocalParticle_get_y(source));
  ParticlesData_set_px(dest, id,       LocalParticle_get_px(source));
  ParticlesData_set_py(dest, id,       LocalParticle_get_py(source));
  ParticlesData_set_ptau(dest, id,       LocalParticle_get_ptau(source));
  ParticlesData_set_delta(dest, id,       LocalParticle_get_delta(source));
  ParticlesData_set_rpp(dest, id,       LocalParticle_get_rpp(source));
  ParticlesData_set_rvv(dest, id,       LocalParticle_get_rvv(source));
  ParticlesData_set_chi(dest, id,       LocalParticle_get_chi(source));
  ParticlesData_set_charge_ratio(dest, id,       LocalParticle_get_charge_ratio(source));
  ParticlesData_set_weight(dest, id,       LocalParticle_get_weight(source));
  ParticlesData_set_ax(dest, id,       LocalParticle_get_ax(source));
  ParticlesData_set_ay(dest, id,       LocalParticle_get_ay(source));
  ParticlesData_set_spin_x(dest, id,       LocalParticle_get_spin_x(source));
  ParticlesData_set_spin_y(dest, id,       LocalParticle_get_spin_y(source));
  ParticlesData_set_spin_z(dest, id,       LocalParticle_get_spin_z(source));
  ParticlesData_set_anomalous_magnetic_moment(dest, id,       LocalParticle_get_anomalous_magnetic_moment(source));
  ParticlesData_set_pdg_id(dest, id,       LocalParticle_get_pdg_id(source));
  ParticlesData_set_particle_id(dest, id,       LocalParticle_get_particle_id(source));
  ParticlesData_set_at_element(dest, id,       LocalParticle_get_at_element(source));
  ParticlesData_set_at_turn(dest, id,       LocalParticle_get_at_turn(source));
  ParticlesData_set_state(dest, id,       LocalParticle_get_state(source));
  ParticlesData_set_parent_particle_id(dest, id,       LocalParticle_get_parent_particle_id(source));
  ParticlesData_set__rng_s1(dest, id,       LocalParticle_get__rng_s1(source));
  ParticlesData_set__rng_s2(dest, id,       LocalParticle_get__rng_s2(source));
  ParticlesData_set__rng_s3(dest, id,       LocalParticle_get__rng_s3(source));
  ParticlesData_set__rng_s4(dest, id,       LocalParticle_get__rng_s4(source));
}

 static inline
double LocalParticle_get_xp(LocalParticle* part){
    double const px = LocalParticle_get_px(part);
    double const rpp = LocalParticle_get_rpp(part);
    // INFO: this is not the angle, but sin(angle)
    return px*rpp;
}

 static inline
double LocalParticle_get_yp(LocalParticle* part){
    double const py = LocalParticle_get_py(part);
    double const rpp = LocalParticle_get_rpp(part);
    // INFO: this is not the angle, but sin(angle)
    return py*rpp;
}

 static inline
void LocalParticle_set_xp(LocalParticle* part, double xp){
#ifndef FREEZE_VAR_px
    double rpp = LocalParticle_get_rpp(part);
    // INFO: xp is not the angle, but sin(angle)
    LocalParticle_set_px(part, xp/rpp);
#endif
}

 static inline
void LocalParticle_set_yp(LocalParticle* part, double yp){
#ifndef FREEZE_VAR_py
    double rpp = LocalParticle_get_rpp(part);
    // INFO: yp is not the angle, but sin(angle)
    LocalParticle_set_py(part, yp/rpp);
#endif
}

 static inline
void LocalParticle_add_to_xp(LocalParticle* part, double xp){
#ifndef FREEZE_VAR_px
    LocalParticle_set_xp(part, LocalParticle_get_xp(part) + xp);
#endif
}

 static inline
void LocalParticle_scale_xp(LocalParticle* part, double value){
#ifndef FREEZE_VAR_px
    LocalParticle_set_xp(part, LocalParticle_get_xp(part) * value);
#endif
}

 static inline
void LocalParticle_add_to_yp(LocalParticle* part, double yp){
#ifndef FREEZE_VAR_py
    LocalParticle_set_yp(part, LocalParticle_get_yp(part) + yp);
#endif
}

 static inline
void LocalParticle_scale_yp(LocalParticle* part, double value){
#ifndef FREEZE_VAR_py
    LocalParticle_set_yp(part, LocalParticle_get_yp(part) * value);
#endif
}

 static inline
void LocalParticle_set_xp_yp(LocalParticle* part, double xp, double yp){
    double rpp = LocalParticle_get_rpp(part);
#ifndef FREEZE_VAR_px
    LocalParticle_set_px(part, xp/rpp);
#endif
#ifndef FREEZE_VAR_py
    LocalParticle_set_py(part, yp/rpp);
#endif
}

 static inline
void LocalParticle_add_to_xp_yp(LocalParticle* part, double xp, double yp){
    LocalParticle_set_xp_yp(part, LocalParticle_get_xp(part) + xp, LocalParticle_get_yp(part) + yp);
}

 static inline
void LocalParticle_scale_xp_yp(LocalParticle* part, double value_x, double value_y){
    LocalParticle_set_xp_yp(part, LocalParticle_get_xp(part) * value_x, LocalParticle_get_yp(part) * value_y);
}
 static inline
double LocalParticle_get_exact_xp(LocalParticle* part){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);
    double const rpp = 1./sqrt(one_plus_delta*one_plus_delta - px*px - py*py);
    // INFO: this is not the angle, but sin(angle)
    return px*rpp;
}

 static inline
double LocalParticle_get_exact_yp(LocalParticle* part){
    double const py = LocalParticle_get_py(part);
    double const px = LocalParticle_get_px(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);
    double const rpp = 1./sqrt(one_plus_delta*one_plus_delta - px*px - py*py);
    // INFO: this is not the angle, but sin(angle)
    return py*rpp;
}

 static inline
void LocalParticle_set_exact_xp(LocalParticle* part, double xp){
#ifndef FREEZE_VAR_px
    double rpp = LocalParticle_get_rpp(part);
    // Careful! If yp also changes, use LocalParticle_set_exact_xp_yp!
    double const yp = LocalParticle_get_exact_yp(part);
    rpp *= sqrt(1 + xp*xp + yp*yp);
    // INFO: xp is not the angle, but sin(angle)
    LocalParticle_set_px(part, xp/rpp);
#endif
}

 static inline
void LocalParticle_set_exact_yp(LocalParticle* part, double yp){
#ifndef FREEZE_VAR_py
    double rpp = LocalParticle_get_rpp(part);
    // Careful! If xp also changes, use LocalParticle_set_exact_xp_yp!
    double const xp = LocalParticle_get_exact_xp(part);
    rpp *= sqrt(1 + xp*xp + yp*yp);
    // INFO: yp is not the angle, but sin(angle)
    LocalParticle_set_py(part, yp/rpp);
#endif
}

 static inline
void LocalParticle_add_to_exact_xp(LocalParticle* part, double xp){
#ifndef FREEZE_VAR_px
    LocalParticle_set_exact_xp(part, LocalParticle_get_exact_xp(part) + xp);
#endif
}

 static inline
void LocalParticle_scale_exact_xp(LocalParticle* part, double value){
#ifndef FREEZE_VAR_px
    LocalParticle_set_exact_xp(part, LocalParticle_get_exact_xp(part) * value);
#endif
}

 static inline
void LocalParticle_add_to_exact_yp(LocalParticle* part, double yp){
#ifndef FREEZE_VAR_py
    LocalParticle_set_exact_yp(part, LocalParticle_get_exact_yp(part) + yp);
#endif
}

 static inline
void LocalParticle_scale_exact_yp(LocalParticle* part, double value){
#ifndef FREEZE_VAR_py
    LocalParticle_set_exact_yp(part, LocalParticle_get_exact_yp(part) * value);
#endif
}

 static inline
void LocalParticle_set_exact_xp_yp(LocalParticle* part, double xp, double yp){
    double rpp = LocalParticle_get_rpp(part);
    rpp *= sqrt(1 + xp*xp + yp*yp);
#ifndef FREEZE_VAR_px
    LocalParticle_set_px(part, xp/rpp);
#endif
#ifndef FREEZE_VAR_py
    LocalParticle_set_py(part, yp/rpp);
#endif
}

 static inline
void LocalParticle_add_to_exact_xp_yp(LocalParticle* part, double xp, double yp){
    LocalParticle_set_exact_xp_yp(part, LocalParticle_get_exact_xp(part) + xp, LocalParticle_get_exact_yp(part) + yp);
}

 static inline
void LocalParticle_scale_exact_xp_yp(LocalParticle* part, double value_x, double value_y){
    LocalParticle_set_exact_xp_yp(part, LocalParticle_get_exact_xp(part) * value_x, LocalParticle_get_exact_yp(part) * value_y);
}


         static inline
        double LocalParticle_get_energy0(LocalParticle* part){

            double const p0c = LocalParticle_get_p0c(part);
            double const m0  = LocalParticle_get_mass0(part);

            return sqrt( p0c * p0c + m0 * m0 );
        }

         static inline
        void LocalParticle_update_ptau(LocalParticle* part, double new_ptau_value){

            double const beta0 = LocalParticle_get_beta0(part);

            double const ptau = new_ptau_value;

            double const irpp = sqrt(ptau*ptau + 2*ptau/beta0 +1);

            double const new_rpp = 1./irpp;
            LocalParticle_set_delta(part, irpp - 1.);

            double const new_rvv = irpp/(1 + beta0*ptau);
            LocalParticle_set_rvv(part, new_rvv);
            LocalParticle_set_ptau(part, ptau);

            LocalParticle_set_rpp(part, new_rpp );
        }

         static inline
        void LocalParticle_update_delta(LocalParticle* part, double new_delta_value){
            double const beta0 = LocalParticle_get_beta0(part);
            double const delta_beta0 = new_delta_value * beta0;
            double const ptau_beta0  = sqrt( delta_beta0 * delta_beta0 +
                                        2. * delta_beta0 * beta0 + 1. ) - 1.;

            double const one_plus_delta = 1. + new_delta_value;
            double const rvv    = ( one_plus_delta ) / ( 1. + ptau_beta0 );
            double const rpp    = 1. / one_plus_delta;
            double const ptau = ptau_beta0 / beta0;

            LocalParticle_set_delta(part, new_delta_value);

            LocalParticle_set_rvv(part, rvv );
            LocalParticle_set_rpp(part, rpp );
            LocalParticle_set_ptau(part, ptau );

        }

         static inline
        double LocalParticle_get_pzeta(LocalParticle* part){

            double const ptau = LocalParticle_get_ptau(part);
            double const beta0 = LocalParticle_get_beta0(part);

            return ptau/beta0;

        }

         static inline
        void LocalParticle_update_pzeta(LocalParticle* part, double new_pzeta_value){

            double const beta0 = LocalParticle_get_beta0(part);
            LocalParticle_update_ptau(part, beta0*new_pzeta_value);

        }

         static inline
        void increment_at_element(LocalParticle* part0, int64_t const increment){


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

                LocalParticle_add_to_at_element(part, increment);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


        }

         static inline
        void increment_at_turn(LocalParticle* part0, int flag_reset_s){


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            LocalParticle_add_to_at_turn(part, 1);
            LocalParticle_set_at_element(part, 0);
            if (flag_reset_s>0){
                LocalParticle_set_s(part, 0.);
            }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

        }

         static inline
        void increment_at_turn_backtrack(LocalParticle* part0, int flag_reset_s,
                                         double const line_length,
                                         int64_t const num_elements){


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            LocalParticle_add_to_at_turn(part, -1);
            LocalParticle_set_at_element(part, num_elements);
            if (flag_reset_s>0){
                LocalParticle_set_s(part, line_length);
            }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

        }

        // check_is_active has different implementation on CPU and GPU

        #define CPU_SERIAL_IMPLEM //only_for_context cpu_serial
//        #define CPU_OMP_IMPLEM //only_for_context cpu_openmp

        #ifdef CPU_SERIAL_IMPLEM

         static inline
        int64_t check_is_active(LocalParticle* part) {
            int64_t ipart=0;
            while (ipart < part->_num_active_particles){
                #ifdef XSUITE_RESTORE_LOSS
                ipart++;
                #else
                if (part->state[ipart]<1){
                    LocalParticle_exchange(
                        part, ipart, part->_num_active_particles-1);
                    part->_num_active_particles--;
                    part->_num_lost_particles++;
                }
                else{
                    ipart++;
                }
                #endif
            }

            if (part->_num_active_particles==0){
                return 0;//All particles lost
            } else {
                return 1; //Some stable particles are still present
            }
        }

        #else // not CPU_SERIAL_IMPLEM
        #ifdef CPU_OMP_IMPLEM

         static inline
        int64_t check_is_active(LocalParticle* part) {
        #ifndef SKIP_SWAPS
            int64_t ipart = part->ipart;
            int64_t endpart = part->endpart;

            int64_t left = ipart;
            int64_t right = endpart - 1;
            int64_t swap_made = 0;
            int64_t has_alive = 0;

            if (left == right) return part->state[left] > 0;

            while (left < right) {
                if (part->state[left] > 0) {
                    left++;
                    has_alive = 1;
                }
                else if (part->state[right] <= 0) right--;
                else {
                    LocalParticle_exchange(part, left, right);
                    left++;
                    right--;
                    swap_made = 1;
                }
            }

            return swap_made || has_alive;
        #else
            return 1;
        #endif
        }

         static inline
        void count_reorganized_particles(LocalParticle* part) {
            int64_t num_active = 0;
            int64_t num_lost = 0;

            for (int64_t i = part->ipart; i < part->endpart; i++) {
                if (part->state[i] <= -999999999) break;
                else if (part->state[i] > 0) num_active++;
                else num_lost++;
            }

            part->_num_active_particles = num_active;
            part->_num_lost_particles = num_lost;
        }

        #else // not CPU_SERIAL_IMPLEM and not CPU_OMP_IMPLEM

         static inline
        int64_t check_is_active(LocalParticle* part) {
            return LocalParticle_get_state(part)>0;
        };

        #endif // CPU_OMP_IMPLEM
        #endif // CPU_SERIAL_IMPLEM

        #undef CPU_SERIAL_IMPLEM //only_for_context cpu_serial
//        #undef CPU_OMP_IMPLEM //only_for_context cpu_openmp


        
                    #ifdef XTRACK_GLOBAL_XY_LIMIT

                     static inline
                    void global_aperture_check(LocalParticle* part0) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

                            double const x = LocalParticle_get_x(part);
                            double const y = LocalParticle_get_y(part);

                        int64_t const is_alive = (int64_t)(
                                  (x >= -XTRACK_GLOBAL_XY_LIMIT) &&
                                  (x <=  XTRACK_GLOBAL_XY_LIMIT) &&
                                  (y >= -XTRACK_GLOBAL_XY_LIMIT) &&
                                  (y <=  XTRACK_GLOBAL_XY_LIMIT) );

                        // I assume that if I am in the function is because
                            if (!is_alive){
                               LocalParticle_set_state(part, -1);
                        }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

                    }

                    #endif

                     static inline
                    void LocalParticle_add_to_energy(LocalParticle* part, double delta_energy, int pz_only ){
                        double ptau = LocalParticle_get_ptau(part);
                        double const p0c = LocalParticle_get_p0c(part);
                        double const charge_ratio = LocalParticle_get_charge_ratio(part);
                        double const chi = LocalParticle_get_chi(part);
                        double const mass_ratio = charge_ratio / chi;

                        ptau += delta_energy/p0c / mass_ratio;

                        double const old_rpp = LocalParticle_get_rpp(part);

                        LocalParticle_update_ptau(part, ptau);

                        if (!pz_only) {
                            double const new_rpp = LocalParticle_get_rpp(part);
                            double const f = old_rpp / new_rpp;
                            LocalParticle_scale_px(part, f);
                            LocalParticle_scale_py(part, f);
                        }
                    }


                     static inline
                    void LocalParticle_update_p0c(LocalParticle* part, double new_p0c_value){

                        double const mass0 = LocalParticle_get_mass0(part);
                        double const old_p0c = LocalParticle_get_p0c(part);
                        double const old_delta = LocalParticle_get_delta(part);
                        double const old_beta0 = LocalParticle_get_beta0(part);

                        double const ppc = old_p0c * old_delta + old_p0c;
                        double const new_delta = (ppc - new_p0c_value)/new_p0c_value;

                        double const new_energy0 = sqrt(new_p0c_value*new_p0c_value + mass0 * mass0);
                        double const new_beta0 = new_p0c_value / new_energy0;
                        double const new_gamma0 = new_energy0 / mass0;

                        LocalParticle_set_p0c(part, new_p0c_value);
                        LocalParticle_set_gamma0(part, new_gamma0);
                        LocalParticle_set_beta0(part, new_beta0);

                        LocalParticle_update_delta(part, new_delta);

                        LocalParticle_scale_px(part, old_p0c/new_p0c_value);
                        LocalParticle_scale_py(part, old_p0c/new_p0c_value);

                        LocalParticle_scale_zeta(part, new_beta0/old_beta0);

                    }

                     static inline
                    void LocalParticle_kill_particle(LocalParticle* part, int64_t kill_state) {
                        LocalParticle_set_x(part, 1e30);
                        LocalParticle_set_px(part, 1e30);
                        LocalParticle_set_y(part, 1e30);
                        LocalParticle_set_py(part, 1e30);
                        LocalParticle_set_zeta(part, 1e30);
                        LocalParticle_update_delta(part, -1);  // zero energy
                        LocalParticle_set_state(part, kill_state);
                    }
                 

#ifndef XOBJ_TYPEDEF_LastTurnsData
#define XOBJ_TYPEDEF_LastTurnsData
typedef   struct LastTurnsData_s * LastTurnsData;
 static inline LastTurnsData LastTurnsData_getp(LastTurnsData restrict  obj){
  int64_t offset=0;
  return (LastTurnsData)(( char*) obj+offset);
}
 static inline ArrNUint32 LastTurnsData_getp_lost_at_offset(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_lost_at_offset(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=72;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t LastTurnsData_get_lost_at_offset(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_lost_at_offset(LastTurnsData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* LastTurnsData_getp1_lost_at_offset(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 LastTurnsData_getp_particle_id(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_particle_id(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t LastTurnsData_get_particle_id(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_particle_id(LastTurnsData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* LastTurnsData_getp1_particle_id(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 LastTurnsData_getp_at_turn(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_at_turn(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t LastTurnsData_get_at_turn(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_at_turn(LastTurnsData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* LastTurnsData_getp1_at_turn(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsData_getp_x(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_x(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsData_get_x(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_x(LastTurnsData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsData_getp1_x(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsData_getp_px(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_px(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsData_get_px(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_px(LastTurnsData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsData_getp1_px(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsData_getp_y(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_y(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsData_get_y(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_y(LastTurnsData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsData_getp1_y(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsData_getp_py(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_py(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsData_get_py(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_py(LastTurnsData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsData_getp1_py(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsData_getp_delta(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_delta(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsData_get_delta(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_delta(LastTurnsData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsData_getp1_delta(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsData_getp_zeta(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_zeta(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsData_get_zeta(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_zeta(LastTurnsData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsData_getp1_zeta(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_MaterialData
#define XOBJ_TYPEDEF_MaterialData
typedef   struct MaterialData_s * MaterialData;
 static inline MaterialData MaterialData_getp(MaterialData restrict  obj){
  int64_t offset=0;
  return (MaterialData)(( char*) obj+offset);
}
 static inline double MaterialData_get_Z(const MaterialData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MaterialData_set_Z(MaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MaterialData_getp_Z(MaterialData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double MaterialData_get_A(const MaterialData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void MaterialData_set_A(MaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MaterialData_getp_A(MaterialData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double MaterialData_get_density(const MaterialData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void MaterialData_set_density(MaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MaterialData_getp_density(MaterialData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double MaterialData_get_excitation_energy(const MaterialData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void MaterialData_set_excitation_energy(MaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MaterialData_getp_excitation_energy(MaterialData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double MaterialData_get_nuclear_radius(const MaterialData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void MaterialData_set_nuclear_radius(MaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MaterialData_getp_nuclear_radius(MaterialData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double MaterialData_get_nuclear_elastic_slope(const MaterialData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void MaterialData_set_nuclear_elastic_slope(MaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MaterialData_getp_nuclear_elastic_slope(MaterialData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr6Float64 MaterialData_getp_cross_section(MaterialData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return (Arr6Float64)(( char*) obj+offset);
}
 static inline int64_t MaterialData_len_cross_section(MaterialData restrict  obj){
  return 6;
}
 static inline double MaterialData_get_cross_section(const MaterialData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=56;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MaterialData_set_cross_section(MaterialData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=56;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MaterialData_getp1_cross_section(MaterialData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=56;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double MaterialData_get_hcut(const MaterialData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void MaterialData_set_hcut(MaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MaterialData_getp_hcut(MaterialData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline  char* MaterialData_getp_name(MaterialData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( char*)(( char*) obj+offset);
}
 static inline int8_t MaterialData_get__only_mcs(const MaterialData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *(( int8_t*) obj+offset);
}
 static inline void MaterialData_set__only_mcs(MaterialData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=112;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* MaterialData_getp__only_mcs(MaterialData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double MaterialData_get_radiation_length(const MaterialData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void MaterialData_set_radiation_length(MaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MaterialData_getp_radiation_length(MaterialData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_CrystalMaterialData
#define XOBJ_TYPEDEF_CrystalMaterialData
typedef   struct CrystalMaterialData_s * CrystalMaterialData;
 static inline CrystalMaterialData CrystalMaterialData_getp(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  return (CrystalMaterialData)(( char*) obj+offset);
}
 static inline double CrystalMaterialData_get_Z(const CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void CrystalMaterialData_set_Z(CrystalMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CrystalMaterialData_getp_Z(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double CrystalMaterialData_get_A(const CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void CrystalMaterialData_set_A(CrystalMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CrystalMaterialData_getp_A(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double CrystalMaterialData_get_density(const CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void CrystalMaterialData_set_density(CrystalMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CrystalMaterialData_getp_density(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double CrystalMaterialData_get_excitation_energy(const CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void CrystalMaterialData_set_excitation_energy(CrystalMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CrystalMaterialData_getp_excitation_energy(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double CrystalMaterialData_get_nuclear_radius(const CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void CrystalMaterialData_set_nuclear_radius(CrystalMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CrystalMaterialData_getp_nuclear_radius(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double CrystalMaterialData_get_nuclear_elastic_slope(const CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void CrystalMaterialData_set_nuclear_elastic_slope(CrystalMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CrystalMaterialData_getp_nuclear_elastic_slope(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr6Float64 CrystalMaterialData_getp_cross_section(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return (Arr6Float64)(( char*) obj+offset);
}
 static inline int64_t CrystalMaterialData_len_cross_section(CrystalMaterialData restrict  obj){
  return 6;
}
 static inline double CrystalMaterialData_get_cross_section(const CrystalMaterialData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=56;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void CrystalMaterialData_set_cross_section(CrystalMaterialData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=56;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CrystalMaterialData_getp1_cross_section(CrystalMaterialData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=56;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double CrystalMaterialData_get_hcut(const CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void CrystalMaterialData_set_hcut(CrystalMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CrystalMaterialData_getp_hcut(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline  char* CrystalMaterialData_getp_name(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( char*)(( char*) obj+offset);
}
 static inline int8_t CrystalMaterialData_get__only_mcs(const CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *(( int8_t*) obj+offset);
}
 static inline void CrystalMaterialData_set__only_mcs(CrystalMaterialData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=112;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* CrystalMaterialData_getp__only_mcs(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double CrystalMaterialData_get_crystal_radiation_length(const CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void CrystalMaterialData_set_crystal_radiation_length(CrystalMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CrystalMaterialData_getp_crystal_radiation_length(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double CrystalMaterialData_get_crystal_nuclear_length(const CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void CrystalMaterialData_set_crystal_nuclear_length(CrystalMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CrystalMaterialData_getp_crystal_nuclear_length(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double CrystalMaterialData_get_crystal_plane_distance(const CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void CrystalMaterialData_set_crystal_plane_distance(CrystalMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CrystalMaterialData_getp_crystal_plane_distance(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double CrystalMaterialData_get_crystal_potential(const CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void CrystalMaterialData_set_crystal_potential(CrystalMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CrystalMaterialData_getp_crystal_potential(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double CrystalMaterialData_get_nuclear_collision_length(const CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void CrystalMaterialData_set_nuclear_collision_length(CrystalMaterialData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CrystalMaterialData_getp_nuclear_collision_length(CrystalMaterialData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_BeamBeamBiGaussian3DRecordData
#define XOBJ_TYPEDEF_BeamBeamBiGaussian3DRecordData
typedef   struct BeamBeamBiGaussian3DRecordData_s * BeamBeamBiGaussian3DRecordData;
 static inline BeamBeamBiGaussian3DRecordData BeamBeamBiGaussian3DRecordData_getp(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  return (BeamBeamBiGaussian3DRecordData)(( char*) obj+offset);
}
 static inline BeamstrahlungTableData BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return (BeamstrahlungTableData)(( char*) obj+offset);
}
 static inline RecordIndex BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable__index(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_get_beamstrahlungtable__index_capacity(const BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_beamstrahlungtable__index_capacity(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable__index_capacity(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamBeamBiGaussian3DRecordData_get_beamstrahlungtable__index_num_recorded(const BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_beamstrahlungtable__index_num_recorded(BeamBeamBiGaussian3DRecordData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=40;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable__index_num_recorded(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamBeamBiGaussian3DRecordData_get_beamstrahlungtable__index__dummy(const BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_beamstrahlungtable__index__dummy(BeamBeamBiGaussian3DRecordData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=48;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable__index__dummy(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_get_beamstrahlungtable__index_buffer_id(const BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_beamstrahlungtable__index_buffer_id(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable__index_buffer_id(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable_at_element(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_beamstrahlungtable_at_element(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=136;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_get_beamstrahlungtable_at_element(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=136;
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_beamstrahlungtable_at_element(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=136;
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DRecordData_getp1_beamstrahlungtable_at_element(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=136;
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable_at_turn(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_beamstrahlungtable_at_turn(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+40);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_get_beamstrahlungtable_at_turn(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_beamstrahlungtable_at_turn(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DRecordData_getp1_beamstrahlungtable_at_turn(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable_particle_id(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_beamstrahlungtable_particle_id(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+48);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_get_beamstrahlungtable_particle_id(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_beamstrahlungtable_particle_id(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DRecordData_getp1_beamstrahlungtable_particle_id(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable_primary_energy(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_beamstrahlungtable_primary_energy(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+56);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_beamstrahlungtable_primary_energy(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_beamstrahlungtable_primary_energy(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_beamstrahlungtable_primary_energy(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable_photon_id(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_beamstrahlungtable_photon_id(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_beamstrahlungtable_photon_id(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_beamstrahlungtable_photon_id(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_beamstrahlungtable_photon_id(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable_photon_energy(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_beamstrahlungtable_photon_energy(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+72);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_beamstrahlungtable_photon_energy(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_beamstrahlungtable_photon_energy(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_beamstrahlungtable_photon_energy(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable_photon_critical_energy(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_beamstrahlungtable_photon_critical_energy(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+80);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_beamstrahlungtable_photon_critical_energy(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_beamstrahlungtable_photon_critical_energy(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_beamstrahlungtable_photon_critical_energy(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable_rho_inv(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_beamstrahlungtable_rho_inv(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+88);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_beamstrahlungtable_rho_inv(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_beamstrahlungtable_rho_inv(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_beamstrahlungtable_rho_inv(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable_n_avg(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_beamstrahlungtable_n_avg(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+96);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_beamstrahlungtable_n_avg(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_beamstrahlungtable_n_avg(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_beamstrahlungtable_n_avg(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable_delta_avg(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_beamstrahlungtable_delta_avg(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+104);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_beamstrahlungtable_delta_avg(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_beamstrahlungtable_delta_avg(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_beamstrahlungtable_delta_avg(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline BhabhaTableData BeamBeamBiGaussian3DRecordData_getp_bhabhatable(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (BhabhaTableData)(( char*) obj+offset);
}
 static inline RecordIndex BeamBeamBiGaussian3DRecordData_getp_bhabhatable__index(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=8;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_get_bhabhatable__index_capacity(const BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable__index_capacity(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DRecordData_getp_bhabhatable__index_capacity(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamBeamBiGaussian3DRecordData_get_bhabhatable__index_num_recorded(const BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable__index_num_recorded(BeamBeamBiGaussian3DRecordData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamBeamBiGaussian3DRecordData_getp_bhabhatable__index_num_recorded(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamBeamBiGaussian3DRecordData_get_bhabhatable__index__dummy(const BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=24;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable__index__dummy(BeamBeamBiGaussian3DRecordData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=24;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamBeamBiGaussian3DRecordData_getp_bhabhatable__index__dummy(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=24;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_get_bhabhatable__index_buffer_id(const BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable__index_buffer_id(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DRecordData_getp_bhabhatable__index_buffer_id(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 BeamBeamBiGaussian3DRecordData_getp_bhabhatable_at_element(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=136;
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_bhabhatable_at_element(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=136;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_get_bhabhatable_at_element(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=136;
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable_at_element(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=136;
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DRecordData_getp1_bhabhatable_at_element(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=136;
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 BeamBeamBiGaussian3DRecordData_getp_bhabhatable_at_turn(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+40);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_bhabhatable_at_turn(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+40);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_get_bhabhatable_at_turn(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable_at_turn(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DRecordData_getp1_bhabhatable_at_turn(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 BeamBeamBiGaussian3DRecordData_getp_bhabhatable_particle_id(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+48);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_bhabhatable_particle_id(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+48);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_get_bhabhatable_particle_id(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable_particle_id(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DRecordData_getp1_bhabhatable_particle_id(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_bhabhatable_primary_energy(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+56);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_bhabhatable_primary_energy(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+56);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_bhabhatable_primary_energy(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable_primary_energy(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_bhabhatable_primary_energy(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNInt64 BeamBeamBiGaussian3DRecordData_getp_bhabhatable_photon_id(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_bhabhatable_photon_id(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_get_bhabhatable_photon_id(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable_photon_id(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DRecordData_getp1_bhabhatable_photon_id(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_bhabhatable_photon_x(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+72);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_bhabhatable_photon_x(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+72);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_bhabhatable_photon_x(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable_photon_x(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_bhabhatable_photon_x(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_bhabhatable_photon_y(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+80);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_bhabhatable_photon_y(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+80);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_bhabhatable_photon_y(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable_photon_y(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_bhabhatable_photon_y(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_bhabhatable_photon_z(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+88);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_bhabhatable_photon_z(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+88);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_bhabhatable_photon_z(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable_photon_z(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_bhabhatable_photon_z(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_bhabhatable_photon_px(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+96);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_bhabhatable_photon_px(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+96);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_bhabhatable_photon_px(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable_photon_px(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_bhabhatable_photon_px(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_bhabhatable_photon_py(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+104);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_bhabhatable_photon_py(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+104);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_bhabhatable_photon_py(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable_photon_py(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_bhabhatable_photon_py(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_bhabhatable_photon_energy(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+112);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_bhabhatable_photon_energy(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+112);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_bhabhatable_photon_energy(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable_photon_energy(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_bhabhatable_photon_energy(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_bhabhatable_primary_scattering_angle(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+120);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_bhabhatable_primary_scattering_angle(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+120);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_bhabhatable_primary_scattering_angle(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable_primary_scattering_angle(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_bhabhatable_primary_scattering_angle(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_bhabhatable_photon_scattering_angle(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+128);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_bhabhatable_photon_scattering_angle(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+128);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_bhabhatable_photon_scattering_angle(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_bhabhatable_photon_scattering_angle(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_bhabhatable_photon_scattering_angle(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline LumiTableData BeamBeamBiGaussian3DRecordData_getp_lumitable(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (LumiTableData)(( char*) obj+offset);
}
 static inline RecordIndex BeamBeamBiGaussian3DRecordData_getp_lumitable__index(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=8;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_get_lumitable__index_capacity(const BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_lumitable__index_capacity(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DRecordData_getp_lumitable__index_capacity(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamBeamBiGaussian3DRecordData_get_lumitable__index_num_recorded(const BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_lumitable__index_num_recorded(BeamBeamBiGaussian3DRecordData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamBeamBiGaussian3DRecordData_getp_lumitable__index_num_recorded(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamBeamBiGaussian3DRecordData_get_lumitable__index__dummy(const BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=24;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_lumitable__index__dummy(BeamBeamBiGaussian3DRecordData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=24;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamBeamBiGaussian3DRecordData_getp_lumitable__index__dummy(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=24;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_get_lumitable__index_buffer_id(const BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_lumitable__index_buffer_id(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DRecordData_getp_lumitable__index_buffer_id(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 BeamBeamBiGaussian3DRecordData_getp_lumitable_at_element(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=48;
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_lumitable_at_element(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=48;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_get_lumitable_at_element(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=48;
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_lumitable_at_element(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=48;
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DRecordData_getp1_lumitable_at_element(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=48;
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DRecordData_getp_lumitable_luminosity(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=*( int64_t*)(( char*) obj+offset+40);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DRecordData_len_lumitable_luminosity(BeamBeamBiGaussian3DRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=*( int64_t*)(( char*) obj+offset+40);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DRecordData_get_lumitable_luminosity(const BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DRecordData_set_lumitable_luminosity(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DRecordData_getp1_lumitable_luminosity(BeamBeamBiGaussian3DRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_DipoleEdgeData
#define XOBJ_TYPEDEF_DipoleEdgeData
typedef   struct DipoleEdgeData_s * DipoleEdgeData;
 static inline DipoleEdgeData DipoleEdgeData_getp(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  return (DipoleEdgeData)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_r21(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_r21(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_r21(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_r43(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_r43(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_r43(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_hgap(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_hgap(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_hgap(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_k(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_k(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_k(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_e1(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_e1(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_e1(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_e1_fd(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_e1_fd(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_e1_fd(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_fint(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_fint(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_fint(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DipoleEdgeData_get_model(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_model(DipoleEdgeData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DipoleEdgeData_getp_model(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DipoleEdgeData_get_side(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_side(DipoleEdgeData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DipoleEdgeData_getp_side(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_delta_taper(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_delta_taper(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_delta_taper(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get__sin_rot_s(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set__sin_rot_s(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp__sin_rot_s(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get__cos_rot_s(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set__cos_rot_s(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp__cos_rot_s(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get__shift_x(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set__shift_x(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp__shift_x(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get__shift_y(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set__shift_y(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp__shift_y(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get__shift_s(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set__shift_s(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp__shift_s(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/dipoleedge.h>

             static inline
            void DipoleEdge_track_local_particle_with_transformations(DipoleEdgeData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = DipoleEdgeData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = DipoleEdgeData_get__cos_rot_s(el);
    double const shift_x = DipoleEdgeData_get__shift_x(el);
    double const shift_y = DipoleEdgeData_get__shift_y(el);
    double const shift_s = DipoleEdgeData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    DipoleEdge_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = DipoleEdgeData_get__cos_rot_s(el);
    double const shift_x = DipoleEdgeData_get__shift_x(el);
    double const shift_y = DipoleEdgeData_get__shift_y(el);
    double const shift_s = DipoleEdgeData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void DipoleEdge_track_particles(
               DipoleEdgeData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              DipoleEdge_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ExciterData
#define XOBJ_TYPEDEF_ExciterData
typedef   struct ExciterData_s * ExciterData;
 static inline ExciterData ExciterData_getp(ExciterData restrict  obj){
  int64_t offset=0;
  return (ExciterData)(( char*) obj+offset);
}
 static inline int64_t ExciterData_get_order(const ExciterData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ExciterData_set_order(ExciterData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ExciterData_getp_order(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ExciterData_get_nsamples(const ExciterData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ExciterData_set_nsamples(ExciterData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ExciterData_getp_nsamples(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ExciterData_get_sampling_frequency(const ExciterData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ExciterData_set_sampling_frequency(ExciterData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ExciterData_getp_sampling_frequency(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ExciterData_get_frev(const ExciterData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ExciterData_set_frev(ExciterData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ExciterData_getp_frev(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ExciterData_get_start_turn(const ExciterData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ExciterData_set_start_turn(ExciterData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ExciterData_getp_start_turn(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ExciterData_get_nduration(const ExciterData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ExciterData_set_nduration(ExciterData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ExciterData_getp_nduration(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ExciterData_getp_knl(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ExciterData_len_knl(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=112;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ExciterData_get_knl(const ExciterData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=112;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ExciterData_set_knl(ExciterData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=112;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ExciterData_getp1_knl(ExciterData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=112;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ExciterData_getp_ksl(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ExciterData_len_ksl(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ExciterData_get_ksl(const ExciterData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ExciterData_set_ksl(ExciterData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ExciterData_getp1_ksl(ExciterData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat32 ExciterData_getp_samples(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t ExciterData_len_samples(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float ExciterData_get_samples(const ExciterData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void ExciterData_set_samples(ExciterData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* ExciterData_getp1_samples(ExciterData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline double ExciterData_get__sin_rot_s(const ExciterData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void ExciterData_set__sin_rot_s(ExciterData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ExciterData_getp__sin_rot_s(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double ExciterData_get__cos_rot_s(const ExciterData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void ExciterData_set__cos_rot_s(ExciterData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ExciterData_getp__cos_rot_s(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double ExciterData_get__shift_x(const ExciterData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ExciterData_set__shift_x(ExciterData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ExciterData_getp__shift_x(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double ExciterData_get__shift_y(const ExciterData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void ExciterData_set__shift_y(ExciterData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ExciterData_getp__shift_y(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double ExciterData_get__shift_s(const ExciterData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void ExciterData_set__shift_s(ExciterData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ExciterData_getp__shift_s(ExciterData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/exciter.h>

             static inline
            void Exciter_track_local_particle_with_transformations(ExciterData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ExciterData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ExciterData_get__cos_rot_s(el);
    double const shift_x = ExciterData_get__shift_x(el);
    double const shift_y = ExciterData_get__shift_y(el);
    double const shift_s = ExciterData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Exciter_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ExciterData_get__cos_rot_s(el);
    double const shift_x = ExciterData_get__shift_x(el);
    double const shift_y = ExciterData_get__shift_y(el);
    double const shift_s = ExciterData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Exciter_track_particles(
               ExciterData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Exciter_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_XYShiftData
#define XOBJ_TYPEDEF_XYShiftData
typedef   struct XYShiftData_s * XYShiftData;
 static inline XYShiftData XYShiftData_getp(XYShiftData restrict  obj){
  int64_t offset=0;
  return (XYShiftData)(( char*) obj+offset);
}
 static inline double XYShiftData_get_dx(const XYShiftData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void XYShiftData_set_dx(XYShiftData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XYShiftData_getp_dx(XYShiftData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double XYShiftData_get_dy(const XYShiftData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void XYShiftData_set_dy(XYShiftData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XYShiftData_getp_dy(XYShiftData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/xyshift.h>

             static inline
            void XYShift_track_local_particle_with_transformations(XYShiftData el, LocalParticle* part0){
    XYShift_track_local_particle(el, part0);
}


             
            void XYShift_track_particles(
               XYShiftData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              XYShift_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_BeamPositionMonitorData
#define XOBJ_TYPEDEF_BeamPositionMonitorData
typedef   struct BeamPositionMonitorData_s * BeamPositionMonitorData;
 static inline BeamPositionMonitorData BeamPositionMonitorData_getp(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  return (BeamPositionMonitorData)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_get_particle_id_start(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_particle_id_start(BeamPositionMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamPositionMonitorData_getp_particle_id_start(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_get_num_particles(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_num_particles(BeamPositionMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamPositionMonitorData_getp_num_particles(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_get_start_at_turn(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_start_at_turn(BeamPositionMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamPositionMonitorData_getp_start_at_turn(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_get_stop_at_turn(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_stop_at_turn(BeamPositionMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamPositionMonitorData_getp_stop_at_turn(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BeamPositionMonitorData_get_frev(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_frev(BeamPositionMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp_frev(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamPositionMonitorData_get_sampling_frequency(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_sampling_frequency(BeamPositionMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp_sampling_frequency(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIndex BeamPositionMonitorData_getp__index(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_get__index_capacity(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__index_capacity(BeamPositionMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamPositionMonitorData_getp__index_capacity(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamPositionMonitorData_get__index_num_recorded(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__index_num_recorded(BeamPositionMonitorData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=64;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamPositionMonitorData_getp__index_num_recorded(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamPositionMonitorData_get__index__dummy(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__index__dummy(BeamPositionMonitorData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=72;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamPositionMonitorData_getp__index__dummy(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_get__index_buffer_id(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__index_buffer_id(BeamPositionMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamPositionMonitorData_getp__index_buffer_id(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline BeamPositionMonitorRecord BeamPositionMonitorData_getp_data(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return (BeamPositionMonitorRecord)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamPositionMonitorData_getp_data_count(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_len_data_count(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamPositionMonitorData_get_data_count(const BeamPositionMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=152;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_data_count(BeamPositionMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=152;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp1_data_count(BeamPositionMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=152;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamPositionMonitorData_getp_data_x_sum(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_len_data_x_sum(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamPositionMonitorData_get_data_x_sum(const BeamPositionMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_data_x_sum(BeamPositionMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp1_data_x_sum(BeamPositionMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamPositionMonitorData_getp_data_y_sum(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_len_data_y_sum(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamPositionMonitorData_get_data_y_sum(const BeamPositionMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_data_y_sum(BeamPositionMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp1_data_y_sum(BeamPositionMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamPositionMonitorData_get__sin_rot_s(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__sin_rot_s(BeamPositionMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp__sin_rot_s(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamPositionMonitorData_get__cos_rot_s(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__cos_rot_s(BeamPositionMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp__cos_rot_s(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamPositionMonitorData_get__shift_x(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__shift_x(BeamPositionMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp__shift_x(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamPositionMonitorData_get__shift_y(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__shift_y(BeamPositionMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp__shift_y(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamPositionMonitorData_get__shift_s(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__shift_s(BeamPositionMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp__shift_s(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef _ATOMICADD_H_
#define _ATOMICADD_H_

#define ATOMICADD_CPU  //only_for_context cpu_serial cpu_openmp
//#define ATOMICADD_OPENCL //only_for_context opencl
// CUDA provides atomicAdd() natively

#ifdef ATOMICADD_CPU
inline void atomicAdd(double *addr, double val)
{
//   #pragma omp atomic //only_for_context cpu_openmp
   *addr = *addr + val;
}
#endif // ATOMICADD_CPU

#ifdef ATOMICADD_OPENCL
#pragma OPENCL EXTENSION cl_khr_int64_base_atomics : enable
inline void atomicAdd(volatile __global double *addr, double val)
{
	union {
		long u64;
		double f64;
	} next, expected, current;
	current.f64 = *addr;
	do {
		expected.f64 = current.f64;
		next.f64 = expected.f64 + val;
		current.u64 = atom_cmpxchg(
			(volatile __global long *)addr,
		        (long) expected.u64,
			(long) next.u64);
	} while( current.u64 != expected.u64 );
}
#endif // ATOMICADD_OPENCL

#endif

// ##################################
// Beam Monitor
// 
// Author: Rahul Singh, Philipp Niedermayer
// Date: 2023-06-10
// ##################################


#ifndef XTRACK_BEAM_POSITION_MONITOR_H
#define XTRACK_BEAM_POSITION_MONITOR_H

#include <headers/track.h>


GPUFUN
void BeamPositionMonitor_track_local_particle(BeamPositionMonitorData el, LocalParticle* part0){

    // get parameters
    int64_t const start_at_turn = BeamPositionMonitorData_get_start_at_turn(el);
    int64_t particle_id_start = BeamPositionMonitorData_get_particle_id_start(el);
    int64_t particle_id_stop = particle_id_start + BeamPositionMonitorData_get_num_particles(el);
    double const frev = BeamPositionMonitorData_get_frev(el);
    double const sampling_frequency = BeamPositionMonitorData_get_sampling_frequency(el);

    BeamPositionMonitorRecord record = BeamPositionMonitorData_getp_data(el);

    int64_t max_slot = BeamPositionMonitorRecord_len_count(record);

    START_PER_PARTICLE_BLOCK(part0, part);
        int64_t particle_id = LocalParticle_get_particle_id(part);
        if (particle_id_stop < 0 || (particle_id_start <= particle_id && particle_id < particle_id_stop))
        {
            // zeta is the absolute path length deviation from the reference particle: zeta = (s - beta0*c*t)
            // but without limits, i.e. it can exceed the circumference (for coasting beams)
            // as the particle falls behind or overtakes the reference particle
            double const zeta = LocalParticle_get_zeta(part);
            double const at_turn = LocalParticle_get_at_turn(part);
            double const beta0 = LocalParticle_get_beta0(part);

            // compute sample index
            int64_t slot = round(sampling_frequency * ( (at_turn-start_at_turn)/frev - zeta/beta0/C_LIGHT ));

            if (slot >= 0 && slot < max_slot){
                double x = LocalParticle_get_x(part);
                double y = LocalParticle_get_y(part);

                GPUGLMEM double * count = BeamPositionMonitorRecord_getp1_count(record, slot);
                atomicAdd(count, 1.0);

                GPUGLMEM double * x_sum = BeamPositionMonitorRecord_getp1_x_sum(record, slot);
                atomicAdd(x_sum, x);

                GPUGLMEM double * y_sum = BeamPositionMonitorRecord_getp1_y_sum(record, slot);
                atomicAdd(y_sum, y);
            }
        }
    END_PER_PARTICLE_BLOCK;
}

#endif



             static inline
            void BeamPositionMonitor_track_local_particle_with_transformations(BeamPositionMonitorData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = BeamPositionMonitorData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamPositionMonitorData_get__cos_rot_s(el);
    double const shift_x = BeamPositionMonitorData_get__shift_x(el);
    double const shift_y = BeamPositionMonitorData_get__shift_y(el);
    double const shift_s = BeamPositionMonitorData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    BeamPositionMonitor_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamPositionMonitorData_get__cos_rot_s(el);
    double const shift_x = BeamPositionMonitorData_get__shift_x(el);
    double const shift_y = BeamPositionMonitorData_get__shift_y(el);
    double const shift_s = BeamPositionMonitorData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void BeamPositionMonitor_track_particles(
               BeamPositionMonitorData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              BeamPositionMonitor_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_WireData
#define XOBJ_TYPEDEF_WireData
typedef   struct WireData_s * WireData;
 static inline WireData WireData_getp(WireData restrict  obj){
  int64_t offset=0;
  return (WireData)(( char*) obj+offset);
}
 static inline double WireData_get_L_phy(const WireData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set_L_phy(WireData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp_L_phy(WireData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get_L_int(const WireData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set_L_int(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp_L_int(WireData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get_current(const WireData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set_current(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp_current(WireData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get_xma(const WireData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set_xma(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp_xma(WireData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get_yma(const WireData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set_yma(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp_yma(WireData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get_post_subtract_px(const WireData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set_post_subtract_px(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp_post_subtract_px(WireData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get_post_subtract_py(const WireData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set_post_subtract_py(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp_post_subtract_py(WireData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get__sin_rot_s(const WireData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set__sin_rot_s(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp__sin_rot_s(WireData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get__cos_rot_s(const WireData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set__cos_rot_s(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp__cos_rot_s(WireData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get__shift_x(const WireData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set__shift_x(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp__shift_x(WireData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get__shift_y(const WireData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set__shift_y(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp__shift_y(WireData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get__shift_s(const WireData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set__shift_s(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp__shift_s(WireData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/wire.h>

             static inline
            void Wire_track_local_particle_with_transformations(WireData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = WireData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = WireData_get__cos_rot_s(el);
    double const shift_x = WireData_get__shift_x(el);
    double const shift_y = WireData_get__shift_y(el);
    double const shift_s = WireData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Wire_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = WireData_get__cos_rot_s(el);
    double const shift_x = WireData_get__shift_x(el);
    double const shift_y = WireData_get__shift_y(el);
    double const shift_s = WireData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Wire_track_particles(
               WireData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Wire_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_BeamSizeMonitorData
#define XOBJ_TYPEDEF_BeamSizeMonitorData
typedef   struct BeamSizeMonitorData_s * BeamSizeMonitorData;
 static inline BeamSizeMonitorData BeamSizeMonitorData_getp(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  return (BeamSizeMonitorData)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_get_particle_id_start(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_particle_id_start(BeamSizeMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamSizeMonitorData_getp_particle_id_start(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_get_num_particles(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_num_particles(BeamSizeMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamSizeMonitorData_getp_num_particles(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_get_start_at_turn(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_start_at_turn(BeamSizeMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamSizeMonitorData_getp_start_at_turn(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_get_stop_at_turn(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_stop_at_turn(BeamSizeMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamSizeMonitorData_getp_stop_at_turn(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BeamSizeMonitorData_get_frev(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_frev(BeamSizeMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp_frev(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamSizeMonitorData_get_sampling_frequency(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_sampling_frequency(BeamSizeMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp_sampling_frequency(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIndex BeamSizeMonitorData_getp__index(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_get__index_capacity(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__index_capacity(BeamSizeMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamSizeMonitorData_getp__index_capacity(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamSizeMonitorData_get__index_num_recorded(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__index_num_recorded(BeamSizeMonitorData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=64;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamSizeMonitorData_getp__index_num_recorded(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamSizeMonitorData_get__index__dummy(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__index__dummy(BeamSizeMonitorData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=72;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamSizeMonitorData_getp__index__dummy(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_get__index_buffer_id(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__index_buffer_id(BeamSizeMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamSizeMonitorData_getp__index_buffer_id(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline BeamSizeMonitorRecord BeamSizeMonitorData_getp_data(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return (BeamSizeMonitorRecord)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorData_getp_data_count(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_len_data_count(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorData_get_data_count(const BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_data_count(BeamSizeMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp1_data_count(BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorData_getp_data_x_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_len_data_x_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorData_get_data_x_sum(const BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_data_x_sum(BeamSizeMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp1_data_x_sum(BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorData_getp_data_x2_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_len_data_x2_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorData_get_data_x2_sum(const BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_data_x2_sum(BeamSizeMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp1_data_x2_sum(BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorData_getp_data_y_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_len_data_y_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+24);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorData_get_data_y_sum(const BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_data_y_sum(BeamSizeMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp1_data_y_sum(BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorData_getp_data_y2_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_len_data_y2_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+32);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorData_get_data_y2_sum(const BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_data_y2_sum(BeamSizeMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp1_data_y2_sum(BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamSizeMonitorData_get__sin_rot_s(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__sin_rot_s(BeamSizeMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp__sin_rot_s(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamSizeMonitorData_get__cos_rot_s(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__cos_rot_s(BeamSizeMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp__cos_rot_s(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamSizeMonitorData_get__shift_x(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__shift_x(BeamSizeMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp__shift_x(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamSizeMonitorData_get__shift_y(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__shift_y(BeamSizeMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp__shift_y(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamSizeMonitorData_get__shift_s(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__shift_s(BeamSizeMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp__shift_s(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef _ATOMICADD_H_
#define _ATOMICADD_H_

#define ATOMICADD_CPU  //only_for_context cpu_serial cpu_openmp
//#define ATOMICADD_OPENCL //only_for_context opencl
// CUDA provides atomicAdd() natively

#ifdef ATOMICADD_CPU
inline void atomicAdd(double *addr, double val)
{
//   #pragma omp atomic //only_for_context cpu_openmp
   *addr = *addr + val;
}
#endif // ATOMICADD_CPU

#ifdef ATOMICADD_OPENCL
#pragma OPENCL EXTENSION cl_khr_int64_base_atomics : enable
inline void atomicAdd(volatile __global double *addr, double val)
{
	union {
		long u64;
		double f64;
	} next, expected, current;
	current.f64 = *addr;
	do {
		expected.f64 = current.f64;
		next.f64 = expected.f64 + val;
		current.u64 = atom_cmpxchg(
			(volatile __global long *)addr,
		        (long) expected.u64,
			(long) next.u64);
	} while( current.u64 != expected.u64 );
}
#endif // ATOMICADD_OPENCL

#endif

// ##################################
// Beam Size Monitor
// 
// Author: Philipp Niedermayer
// Date: 2023-08-14
// ##################################


#ifndef XTRACK_BEAM_SIZE_MONITOR_H
#define XTRACK_BEAM_SIZE_MONITOR_H

#include <headers/track.h>


GPUFUN
void BeamSizeMonitor_track_local_particle(BeamSizeMonitorData el, LocalParticle* part0){

    // get parameters
    int64_t const start_at_turn = BeamSizeMonitorData_get_start_at_turn(el);
    int64_t particle_id_start = BeamSizeMonitorData_get_particle_id_start(el);
    int64_t particle_id_stop = particle_id_start + BeamSizeMonitorData_get_num_particles(el);
    double const frev = BeamSizeMonitorData_get_frev(el);
    double const sampling_frequency = BeamSizeMonitorData_get_sampling_frequency(el);

    BeamSizeMonitorRecord record = BeamSizeMonitorData_getp_data(el);

    int64_t max_slot = BeamSizeMonitorRecord_len_count(record);

    START_PER_PARTICLE_BLOCK(part0, part);
        int64_t particle_id = LocalParticle_get_particle_id(part);
        if (particle_id_stop < 0 || (particle_id_start <= particle_id && particle_id < particle_id_stop))
        {
            // zeta is the absolute path length deviation from the reference particle: zeta = (s - beta0*c*t)
            // but without limits, i.e. it can exceed the circumference (for coasting beams)
            // as the particle falls behind or overtakes the reference particle
            double const zeta = LocalParticle_get_zeta(part);
            double const at_turn = LocalParticle_get_at_turn(part);
            double const beta0 = LocalParticle_get_beta0(part);

            // compute sample index
            int64_t slot = round(sampling_frequency * ( (at_turn-start_at_turn)/frev - zeta/beta0/C_LIGHT ));

            if (slot >= 0 && slot < max_slot){
                double x = LocalParticle_get_x(part);
                double y = LocalParticle_get_y(part);

                  double* count = BeamSizeMonitorRecord_getp1_count(record, slot);
                atomicAdd(count, 1);

                  double * x_sum = BeamSizeMonitorRecord_getp1_x_sum(record, slot);
                atomicAdd(x_sum, x);

                  double * y_sum = BeamSizeMonitorRecord_getp1_y_sum(record, slot);
                atomicAdd(y_sum, y);

                  double * x2_sum = BeamSizeMonitorRecord_getp1_x2_sum(record, slot);
                atomicAdd(x2_sum, x*x);

                  double * y2_sum = BeamSizeMonitorRecord_getp1_y2_sum(record, slot);
                atomicAdd(y2_sum, y*y);
            }
        }
    END_PER_PARTICLE_BLOCK;
}

#endif



             static inline
            void BeamSizeMonitor_track_local_particle_with_transformations(BeamSizeMonitorData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = BeamSizeMonitorData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamSizeMonitorData_get__cos_rot_s(el);
    double const shift_x = BeamSizeMonitorData_get__shift_x(el);
    double const shift_y = BeamSizeMonitorData_get__shift_y(el);
    double const shift_s = BeamSizeMonitorData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    BeamSizeMonitor_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamSizeMonitorData_get__cos_rot_s(el);
    double const shift_x = BeamSizeMonitorData_get__shift_x(el);
    double const shift_y = BeamSizeMonitorData_get__shift_y(el);
    double const shift_s = BeamSizeMonitorData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void BeamSizeMonitor_track_particles(
               BeamSizeMonitorData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              BeamSizeMonitor_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_LongitudinalLimitRectData
#define XOBJ_TYPEDEF_LongitudinalLimitRectData
typedef   struct LongitudinalLimitRectData_s * LongitudinalLimitRectData;
 static inline LongitudinalLimitRectData LongitudinalLimitRectData_getp(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  return (LongitudinalLimitRectData)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get_min_zeta(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set_min_zeta(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp_min_zeta(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get_max_zeta(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set_max_zeta(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp_max_zeta(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get_min_pzeta(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set_min_pzeta(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp_min_pzeta(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get_max_pzeta(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set_max_pzeta(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp_max_pzeta(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get__sin_rot_s(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set__sin_rot_s(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp__sin_rot_s(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get__cos_rot_s(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set__cos_rot_s(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp__cos_rot_s(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get__shift_x(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set__shift_x(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp__shift_x(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get__shift_y(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set__shift_y(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp__shift_y(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get__shift_s(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set__shift_s(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp__shift_s(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/apertures_src/longitudinallimitrect.h>

             static inline
            void LongitudinalLimitRect_track_local_particle_with_transformations(LongitudinalLimitRectData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LongitudinalLimitRectData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LongitudinalLimitRectData_get__cos_rot_s(el);
    double const shift_x = LongitudinalLimitRectData_get__shift_x(el);
    double const shift_y = LongitudinalLimitRectData_get__shift_y(el);
    double const shift_s = LongitudinalLimitRectData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LongitudinalLimitRect_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LongitudinalLimitRectData_get__cos_rot_s(el);
    double const shift_x = LongitudinalLimitRectData_get__shift_x(el);
    double const shift_y = LongitudinalLimitRectData_get__shift_y(el);
    double const shift_s = LongitudinalLimitRectData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LongitudinalLimitRect_track_particles(
               LongitudinalLimitRectData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LongitudinalLimitRect_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RFMultipoleData
#define XOBJ_TYPEDEF_RFMultipoleData
typedef   struct RFMultipoleData_s * RFMultipoleData;
 static inline RFMultipoleData RFMultipoleData_getp(RFMultipoleData restrict  obj){
  int64_t offset=0;
  return (RFMultipoleData)(( char*) obj+offset);
}
 static inline int64_t RFMultipoleData_get_order(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_order(RFMultipoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RFMultipoleData_getp_order(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get_voltage(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_voltage(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp_voltage(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get_frequency(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_frequency(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp_frequency(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get_lag(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_lag(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp_lag(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 RFMultipoleData_getp_knl(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t RFMultipoleData_len_knl(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double RFMultipoleData_get_knl(const RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=104;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_knl(RFMultipoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=104;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp1_knl(RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=104;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 RFMultipoleData_getp_ksl(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t RFMultipoleData_len_ksl(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double RFMultipoleData_get_ksl(const RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_ksl(RFMultipoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp1_ksl(RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 RFMultipoleData_getp_pn(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t RFMultipoleData_len_pn(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double RFMultipoleData_get_pn(const RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_pn(RFMultipoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp1_pn(RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 RFMultipoleData_getp_ps(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t RFMultipoleData_len_ps(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double RFMultipoleData_get_ps(const RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_ps(RFMultipoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp1_ps(RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get__sin_rot_s(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set__sin_rot_s(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp__sin_rot_s(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get__cos_rot_s(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set__cos_rot_s(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp__cos_rot_s(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get__shift_x(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set__shift_x(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp__shift_x(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get__shift_y(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set__shift_y(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp__shift_y(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get__shift_s(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set__shift_s(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp__shift_s(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/rfmultipole.h>

             static inline
            void RFMultipole_track_local_particle_with_transformations(RFMultipoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = RFMultipoleData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = RFMultipoleData_get__cos_rot_s(el);
    double const shift_x = RFMultipoleData_get__shift_x(el);
    double const shift_y = RFMultipoleData_get__shift_y(el);
    double const shift_s = RFMultipoleData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    RFMultipole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = RFMultipoleData_get__cos_rot_s(el);
    double const shift_x = RFMultipoleData_get__shift_x(el);
    double const shift_y = RFMultipoleData_get__shift_y(el);
    double const shift_s = RFMultipoleData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void RFMultipole_track_particles(
               RFMultipoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              RFMultipole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_XRotationData
#define XOBJ_TYPEDEF_XRotationData
typedef   struct XRotationData_s * XRotationData;
 static inline XRotationData XRotationData_getp(XRotationData restrict  obj){
  int64_t offset=0;
  return (XRotationData)(( char*) obj+offset);
}
 static inline double XRotationData_get_sin_angle(const XRotationData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void XRotationData_set_sin_angle(XRotationData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XRotationData_getp_sin_angle(XRotationData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double XRotationData_get_cos_angle(const XRotationData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void XRotationData_set_cos_angle(XRotationData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XRotationData_getp_cos_angle(XRotationData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double XRotationData_get_tan_angle(const XRotationData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void XRotationData_set_tan_angle(XRotationData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XRotationData_getp_tan_angle(XRotationData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/xrotation.h>

             static inline
            void XRotation_track_local_particle_with_transformations(XRotationData el, LocalParticle* part0){
    XRotation_track_local_particle(el, part0);
}


             
            void XRotation_track_particles(
               XRotationData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              XRotation_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_BeamBeamBiGaussian2DData
#define XOBJ_TYPEDEF_BeamBeamBiGaussian2DData
typedef   struct BeamBeamBiGaussian2DData_s * BeamBeamBiGaussian2DData;
 static inline BeamBeamBiGaussian2DData BeamBeamBiGaussian2DData_getp(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  return (BeamBeamBiGaussian2DData)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get_scale_strength(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set_scale_strength(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp_scale_strength(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get_ref_shift_x(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set_ref_shift_x(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp_ref_shift_x(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get_ref_shift_y(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set_ref_shift_y(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp_ref_shift_y(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get_other_beam_shift_x(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set_other_beam_shift_x(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp_other_beam_shift_x(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get_other_beam_shift_y(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set_other_beam_shift_y(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp_other_beam_shift_y(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get_post_subtract_px(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set_post_subtract_px(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp_post_subtract_px(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get_post_subtract_py(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set_post_subtract_py(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp_post_subtract_py(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get_other_beam_q0(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set_other_beam_q0(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp_other_beam_q0(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get_other_beam_beta0(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set_other_beam_beta0(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp_other_beam_beta0(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get_other_beam_num_particles(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set_other_beam_num_particles(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp_other_beam_num_particles(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get_other_beam_Sigma_11(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set_other_beam_Sigma_11(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp_other_beam_Sigma_11(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get_other_beam_Sigma_13(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set_other_beam_Sigma_13(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp_other_beam_Sigma_13(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get_other_beam_Sigma_33(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set_other_beam_Sigma_33(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp_other_beam_Sigma_33(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get_min_sigma_diff(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set_min_sigma_diff(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp_min_sigma_diff(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get__sin_rot_s(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set__sin_rot_s(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp__sin_rot_s(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get__cos_rot_s(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set__cos_rot_s(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp__cos_rot_s(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get__shift_x(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set__shift_x(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp__shift_x(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get__shift_y(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set__shift_y(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp__shift_y(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian2DData_get__shift_s(const BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian2DData_set__shift_s(BeamBeamBiGaussian2DData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian2DData_getp__shift_s(BeamBeamBiGaussian2DData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


#ifndef XFIELDS_CONSTANTS_H
#define XFIELDS_CONSTANTS_H

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //


// classical electron radius [m]
#if !defined( RE )
    #define   RE ( 2.81794092e-15 )
#endif

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif

// from python scipy version 1.9.0: cst.elementary_charge
#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.8541878128e-12)
#endif

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif

// from python scipy version 1.9.0: cst.epsilon_0
#if !defined( QELEM )
    #define QELEM (1.602176634e-19)
#endif

#if !defined( MPROTON_GEV )
    #define MPROTON_GEV (0.93827208816)
#endif

#if !defined( MELECTRON_GEV )
    #define MELECTRON_GEV (0.00051099895000)
#endif

#if !defined( MELECTRON_KG )
    #define MELECTRON_KG (9.1093837015e-31)
#endif

#if !defined( ALPHA )
    #define ALPHA (7.29735257e-3)
#endif

#if !defined( HBAR_GEVS )
    #define HBAR_GEVS (6.582119569e-25)
#endif

#if !defined( TWO_OVER_SQRT_PI )
    #define TWO_OVER_SQRT_PI (1.128379167095512573896158903121545171688101258657997713688171443418)
#endif

#if !defined( SQRT_TWO )
    #define SQRT_TWO (1.414213562373095048801688724209698078569671875376948073176679738)
#endif

#if !defined( REDUCED_COMPTON_WAVELENGTH_ELECTRON )
    #define REDUCED_COMPTON_WAVELENGTH_ELECTRON (3.8615926796089057e-13)
#endif

#if !defined( REAL_EPSILON )
    #define REAL_EPSILON 2.22044604925031e-16
#endif /* !defined( REAL_EPSILON ) */

#endif /* XFIELDS_CONSTANTS_H */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_SINCOS_H__
#define XFIELDS_SINCOS_H__

#include <math.h> //only_for_context cpu_serial cpu_openmp

/* Define XSUITE_NO_SINCOS as a compiler parameter to never use the inline
 * wrapper function below (the compiler may still decide to use sincos - like
 * intrinsic, but usually enforcing that math functions have to update
 * errno should put an end to this.
 *
 * If XSUITE_NO_SINCOS is not set, then a best-effort attempt is made to
 * use it on platforms that support it (i.e. gnu compiler, no ANSI standards,
 * relaxed errno handling for math functions.
 */

#if ( !defined( XSUITE_NO_SINCOS ) ) && ( defined( __OPENCL_C_VERSION__ ) )
 static inline void xsuite_sincos( double const arg,
    double*  restrict  sin_result, double*  restrict  cos_result ) {
    *sin_result = sincos( arg, cos_result ); }

#elif ( !defined( XSUITE_NO_SINCOS ) ) && \
      ( ( defined( __CUDA_ARCH__ ) ) || \
        ( defined( __GNUC__ ) && !defined( __clang__ ) && \
         !defined( __STRICT_ANSI__ ) && !defined( __INTEL_COMPILER ) && \
         defined( __NO_MATH_ERRNO__ ) ) )
 static inline void xsuite_sincos( double const arg,
    double*  restrict  sin_result, double*  restrict  cos_result ) {
    sincos( arg, sin_result, cos_result ); }

#else
 static inline void xsuite_sincos( double const arg,
    double*  restrict  sin_result, double*  restrict  cos_result ) {
    *sin_result = sin( arg );
    *cos_result = cos( arg ); }

#endif /* XSUITE_NO_SINCOS */
#endif /* XFIELDS_SINCOS_H__ */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_HEADERS_POWER_H_H__
#define XFIELDS_HEADERS_POWER_H_H__

/** \file power_n.h
 *  \note always include constants first!!! */

 static inline double power_n( double x, unsigned int n )
{
    #if defined( __OPENCL_VERSION__ )
    return pown( x, n );
    #else

    double x_n = x;

    unsigned int const n_div_16 = n >> 4u;
    unsigned int const n_mod_16 = n - ( n_div_16 << 4u );

    switch( n_mod_16 )
    {
        case  0u: { x_n = ( double )1.0; break; }
        case  1u: { break; }
        case  2u: { x_n *= x;                                       break; }
        case  3u: { x_n *= x * x;                                   break; }
        case  4u: { x_n *= x;     x_n *= x_n;                       break; }
        case  5u: { x_n *= x;     x_n *= x_n * x;                   break; }
        case  6u: { x_n *= x * x; x_n *= x_n;                       break; }
        case  7u: { x_n *= x * x; x_n *= x_n * x;                   break; }
        case  8u: { x_n *= x;     x_n *= x_n;     x_n *= x_n;       break; }
        case  9u: { x_n *= x * x; x_n *= x_n * x_n;                 break; }
        case 10u: { x_n *= x * x; x_n *= x_n * x_n * x;             break; }
        case 11u: { x_n *= x;     x_n *= x_n * x; x_n *= x_n * x;   break; }
        case 12u: { x_n *= x * x; x_n *= x_n;     x_n *= x_n;       break; }
        case 13u: { x_n *= x * x; x_n *= x_n;     x_n *= x_n * x;   break; }
        case 14u: { x_n *= x * x; x_n *= x_n * x; x_n *= x_n;       break; }
        case 15u: { x_n *= x;     x_n *= x_n * x; x_n *= x_n * x_n; break; }
        default:  { x_n = ( double )0.0; }
    };

    if( n_div_16 > 0u ){ x *= x; x *= x; x *= x; x *= x; }

    switch( n_div_16 )
    {
        case  0u: { x_n  = ( n_mod_16 != 0u ) ? x_n : ( double )1.0; break; }
        case  1u: { x_n *= x;                                           break; }
        case  2u: { x   *= x; x_n *= x;                                 break; }
        case  3u: { x_n *= x * x * x;                                   break; }
        case  4u: { x   *= x; x *= x; x_n *= x;                         break; }
        case  5u: { x_n *= x; x *= x; x *= x; x_n *= x;                 break; }
        case  6u: { x   *= x * x; x *= x; x_n *= x;                     break; }
        case  7u: { x_n *= x; x *= x * x; x *= x; x_n *= x;             break; }
        case  8u: { x *= x; x *= x; x*= x; x_n *= x;                    break; }
        case  9u: { x *= x * x; x *= x * x; x_n *= x;                   break; }
        case 10u: { x_n *= x; x *= x * x; x *= x * x; x_n *= x;         break; }
        case 11u: { x_n *= x * x; x *= x * x; x *= x * x; x_n *= x;     break; }
        case 12u: { x *= x; x *= x; x_n *= x; x *= x; x_n *= x;         break; }
        case 13u: { x_n *= x; x *= x; x *= x; x_n *= x; x *= x;
                    x_n *= x; break; }

        case 14u: { x_n *= x * x; x *= x; x *= x; x_n *= x; x *= x;
                    x_n *= x; break; }

        case 15u: { x *= x * x; x_n *= x * x; x *= x * x; x_n *= x;    break; }

        default:
        {
            unsigned int ii = 0u;
            unsigned int nn = n_div_16 % 16u;

            for( ; ii < nn ; ++ii ) x_n *= x;

            x *= x; x *= x; x *= x; x *= x;
            nn = ( n_div_16 - nn ) >> 4u;

            for( ii = 0u ; ii < nn ; ++ii ) x_n *= x;
        }
    };

    return x_n;
    #endif /* defined( __OPENCL_VERSION__ ) */
}

#endif /* XFIELDS_HEADERS_POWER_H_H__ */

// copyright ############################### //
// This file is part of the Xfields Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XFIELDS_PARTICLE_STATES_H
#define XFIELDS_PARTICLE_STATES_H

#define XF_OUTSIDE_INTERPOL -11
#define XF_TOO_MANY_PHOTONS -12

#endif /* XFIELDS_PARTICLE_STATES_H */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_FADDEEVA_H
#define XFIELDS_FADDEEVA_H


//from file: faddeeva_mit.h

//  -*- mode:c++; tab-width:2; indent-tabs-mode:nil;  -*-

/* Copyright (c) 2012 Massachusetts Institute of Technology
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/* (Note that this file can be compiled with either C++, in which
    case it uses C++ std::complex<double>, or C, in which case it
    uses C99 double complex.) */

/* Available at: http://ab-initio.mit.edu/Faddeeva

   Computes various error functions (erf, erfc, erfi, erfcx),
   including the Dawson integral, in the complex plane, based
   on algorithms for the computation of the Faddeeva function
              w(z) = exp(-z^2) * erfc(-i*z).
   Given w(z), the error functions are mostly straightforward
   to compute, except for certain regions where we have to
   switch to Taylor expansions to avoid cancellation errors
   [e.g. near the origin for erf(z)].

   To compute the Faddeeva function, we use a combination of two
   algorithms:

   For sufficiently large |z|, we use a continued-fraction expansion
   for w(z) similar to those described in:

      Walter Gautschi, "Efficient computation of the complex error
      function," SIAM J. Numer. Anal. 7(1), pp. 187-198 (1970)

      G. P. M. Poppe and C. M. J. Wijers, "More efficient computation
      of the complex error function," ACM Trans. Math. Soft. 16(1),
      pp. 38-46 (1990).

   Unlike those papers, however, we switch to a completely different
   algorithm for smaller |z|:

      Mofreh R. Zaghloul and Ahmed N. Ali, "Algorithm 916: Computing the
      Faddeyeva and Voigt Functions," ACM Trans. Math. Soft. 38(2), 15
      (2011).

   (I initially used this algorithm for all z, but it turned out to be
    significantly slower than the continued-fraction expansion for
    larger |z|.  On the other hand, it is competitive for smaller |z|,
    and is significantly more accurate than the Poppe & Wijers code
    in some regions, e.g. in the vicinity of z=1+1i.)

   Note that this is an INDEPENDENT RE-IMPLEMENTATION of these algorithms,
   based on the description in the papers ONLY.  In particular, I did
   not refer to the authors' Fortran or Matlab implementations, respectively,
   (which are under restrictive ACM copyright terms and therefore unusable
    in free/open-source software).

   Steven G. Johnson, Massachusetts Institute of Technology
   http://math.mit.edu/~stevenj
   October 2012.

    -- Note that Algorithm 916 assumes that the erfc(x) function,
       or rather the scaled function erfcx(x) = exp(x*x)*erfc(x),
       is supplied for REAL arguments x.   I originally used an
       erfcx routine derived from DERFC in SLATEC, but I have
       since replaced it with a much faster routine written by
       me which uses a combination of continued-fraction expansions
       and a lookup table of Chebyshev polynomials.  For speed,
       I implemented a similar algorithm for Im[w(x)] of real x,
       since this comes up frequently in the other error functions.

   A small test program is included the end, which checks
   the w(z) etc. results against several known values.  To compile
   the test function, compile with -DTEST_FADDEEVA (that is,
   #define TEST_FADDEEVA).

   If HAVE_CONFIG_H is #defined (e.g. by compiling with -DHAVE_CONFIG_H),
   then we #include "config.h", which is assumed to be a GNU autoconf-style
   header defining HAVE_* macros to indicate the presence of features. In
   particular, if HAVE_ISNAN and HAVE_ISINF are #defined, we use those
   functions in math.h instead of defining our own, and if HAVE_ERF and/or
   HAVE_ERFC are defined we use those functions from <cmath> for erf and
   erfc of real arguments, respectively, instead of defining our own.

   REVISION HISTORY:
       4 October 2012: Initial public release (SGJ)
       5 October 2012: Revised (SGJ) to fix spelling error,
                       start summation for large x at round(x/a) (> 1)
                       rather than ceil(x/a) as in the original
                       paper, which should slightly improve performance
                       (and, apparently, slightly improves accuracy)
      19 October 2012: Revised (SGJ) to fix bugs for large x, large -y,
                       and 15<x<26. Performance improvements. Prototype
                       now supplies default value for relerr.
      24 October 2012: Switch to continued-fraction expansion for
                       sufficiently large z, for performance reasons.
                       Also, avoid spurious overflow for |z| > 1e154.
                       Set relerr argument to min(relerr,0.1).
      27 October 2012: Enhance accuracy in Re[w(z)] taken by itself,
                       by switching to Alg. 916 in a region near
                       the real-z axis where continued fractions
                       have poor relative accuracy in Re[w(z)].  Thanks
                       to M. Zaghloul for the tip.
      29 October 2012: Replace SLATEC-derived erfcx routine with
                       completely rewritten code by me, using a very
                       different algorithm which is much faster.
      30 October 2012: Implemented special-case code for real z
                       (where real part is exp(-x^2) and imag part is
                        Dawson integral), using algorithm similar to erfx.
                       Export ImFaddeeva_w function to make Dawson's
                       integral directly accessible.
      3 November 2012: Provide implementations of erf, erfc, erfcx,
                       and Dawson functions in Faddeeva:: namespace,
                       in addition to Faddeeva::w.  Provide header
                       file Faddeeva.hh.
      4 November 2012: Slightly faster erf for real arguments.
                       Updated MATLAB and Octave plugins.
     27 November 2012: Support compilation with either C++ or
                       plain C (using C99 complex numbers).
                       For real x, use standard-library erf(x)
                       and erfc(x) if available (for C99 or C++11).
                       #include "config.h" if HAVE_CONFIG_H is #defined.
     15 December 2012: Portability fixes (copysign, Inf/NaN creation),
                       use CMPLX/__builtin_complex if available in C,
                       slight accuracy improvements to erf and dawson
                       functions near the origin.  Use gnulib functions
                       if GNULIB_NAMESPACE is defined.
     18 December 2012: Slight tweaks (remove recomputation of x*x in Dawson)
          12 May 2015: Bugfix for systems lacking copysign function.
*/

/////////////////////////////////////////////////////////////////////////
/* If this file is compiled as a part of a larger project,
   support using an autoconf-style config.h header file
   (with various "HAVE_*" #defines to indicate features)
   if HAVE_CONFIG_H is #defined (in GNU autotools style). */

#ifndef XFIELDS_FADDEEVA_MIT_H
#define XFIELDS_FADDEEVA_MIT_H

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

/////////////////////////////////////////////////////////////////////////
// macros to allow us to use either C++ or C (with C99 features)


// #  include "Faddeeva.h" # I include the full header here
/* Copyright (c) 2012 Massachusetts Institute of Technology
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/* Available at: http://ab-initio.mit.edu/Faddeeva

   Header file for Faddeeva.c; see Faddeeva.cc for more information. */


// Require C99 complex-number support
#include <complex.h>


// compute w(z) = exp(-z^2) erfc(-iz) [ Faddeeva / scaled complex error func ]
static inline double complex Faddeeva_MIT_w(double complex z, double relerr);
double Faddeeva_MIT_w_im(double x); // special-case code for Im[w(x)] of real x

// Various functions that we can compute with the help of w(z)

// compute erfcx(z) = exp(z^2) erfc(z)
double complex Faddeeva_MIT_erfcx(double complex z, double relerr);
double Faddeeva_MIT_erfcx_re(double x); // special case for real x

// compute erf(z), the error function of complex arguments
double complex Faddeeva_MIT_erf(double complex z, double relerr);
double Faddeeva_MIT_erf_re(double x); // special case for real x

// compte erfi(z) = -i erf(iz), the imaginary error function
double complex Faddeeva_MIT_erfi(double complex z, double relerr);
double Faddeeva_MIT_erfi_re(double x); // special case for real x

// compute erfc(z) = 1 - erf(z), the complementary error function
double complex Faddeeva_MIT_erfc(double complex z, double relerr);
double Faddeeva_MIT_erfc_re(double x); // special case for real x

// compute Dawson(z) = sqrt(pi)/2  *  exp(-z^2) * erfi(z)
double complex Faddeeva_MIT_Dawson(double complex z, double relerr);
double Faddeeva_MIT_Dawson_re(double x); // special case for real x


 static inline void faddeeva_w( double x, double y,
    double*  restrict  out_x, double*  restrict  out_y )
{
    double complex z, W;
    z = x + I * y;
    W = Faddeeva_MIT_w(z, 0);
    *out_x = creal(W);
    *out_y = cimag(W);
}

 static inline void faddeeva_w_q1( double x, double y,
    double*  restrict  out_x, double*  restrict  out_y )
{
    faddeeva_w(x, y, out_x, out_y);
}


#  define _GNU_SOURCE // enable GNU libc NAN extension if possible

#  include <float.h>
#  include <math.h>

typedef double complex cmplx;

#  define FADDEEVA(name) Faddeeva_MIT_ ## name
#  define FADDEEVA_RE(name) Faddeeva_MIT_ ## name ## _re

/* Constructing complex numbers like 0+i*NaN is problematic in C99
   without the C11 CMPLX macro, because 0.+I*NAN may give NaN+i*NAN if
   I is a complex (rather than imaginary) constant.  For some reason,
   however, it works fine in (pre-4.7) gcc if I define Inf and NaN as
   1/0 and 0/0 (and only if I compile with optimization -O1 or more),
   but not if I use the INFINITY or NAN macros. */

/* __builtin_complex was introduced in gcc 4.7, but the C11 CMPLX macro
   may not be defined unless we are using a recent (2012) version of
   glibc and compile with -std=c11... note that icc lies about being
   gcc and probably doesn't have this builtin(?), so exclude icc explicitly */
#  if !defined(CMPLX) && (__GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 7)) && !(defined(__ICC) || defined(__INTEL_COMPILER))
#    define CMPLX(a,b) __builtin_complex((double) (a), (double) (b))
#  endif

#  ifdef CMPLX // C11
#    define C(a,b) CMPLX(a,b)
#    define Inf INFINITY // C99 infinity
#    ifdef NAN // GNU libc extension
#      define NaN NAN
#    else
#      define NaN (0./0.) // NaN
#    endif
#  else
#    define C(a,b) ((a) + I*(b))
#    define Inf (1./0.)
#    define NaN (0./0.)
#  endif

static inline cmplx cpolar(double r, double t)
{
  if (r == 0.0 && !isnan(t))
    return 0.0;
  else
    return C(r * cos(t), r * sin(t));
}


/////////////////////////////////////////////////////////////////////////
// Auxiliary routines to compute other special functions based on w(z)

// compute erfcx(z) = exp(z^2) erfz(z)
cmplx FADDEEVA(erfcx)(cmplx z, double relerr)
{
  return FADDEEVA(w)(C(-cimag(z), creal(z)), relerr);
}

// compute the error function erf(x)
double FADDEEVA_RE(erf)(double x)
{
#if !defined(__cplusplus)
  return erf(x); // C99 supplies erf in math.h
#elif (__cplusplus >= 201103L) || defined(HAVE_ERF)
  return ::erf(x); // C++11 supplies std::erf in cmath
#else
  double mx2 = -x*x;
  if (mx2 < -750) // underflow
    return (x >= 0 ? 1.0 : -1.0);

  if (x >= 0) {
    if (x < 8e-2) goto taylor;
    return 1.0 - exp(mx2) * FADDEEVA_RE(erfcx)(x);
  }
  else { // x < 0
    if (x > -8e-2) goto taylor;
    return exp(mx2) * FADDEEVA_RE(erfcx)(-x) - 1.0;
  }

  // Use Taylor series for small |x|, to avoid cancellation inaccuracy
  //   erf(x) = 2/sqrt(pi) * x * (1 - x^2/3 + x^4/10 - x^6/42 + x^8/216 + ...)
 taylor:
  return x * (1.1283791670955125739
              + mx2 * (0.37612638903183752464
                       + mx2 * (0.11283791670955125739
                                + mx2 * (0.026866170645131251760
                                         + mx2 * 0.0052239776254421878422))));
#endif
}

// compute the error function erf(z)
cmplx FADDEEVA(erf)(cmplx z, double relerr)
{
  double x = creal(z), y = cimag(z);

  if (y == 0)
    return C(FADDEEVA_RE(erf)(x),
             y); // preserve sign of 0
  if (x == 0) // handle separately for speed & handling of y = Inf or NaN
    return C(x, // preserve sign of 0
             /* handle y -> Inf limit manually, since
                exp(y^2) -> Inf but Im[w(y)] -> 0, so
                IEEE will give us a NaN when it should be Inf */
             y*y > 720 ? (y > 0 ? Inf : -Inf)
             : exp(y*y) * FADDEEVA(w_im)(y));

  double mRe_z2 = (y - x) * (x + y); // Re(-z^2), being careful of overflow
  double mIm_z2 = -2*x*y; // Im(-z^2)
  if (mRe_z2 < -750) // underflow
    return (x >= 0 ? 1.0 : -1.0);

  /* Handle positive and negative x via different formulas,
     using the mirror symmetries of w, to avoid overflow/underflow
     problems from multiplying exponentially large and small quantities. */
  if (x >= 0) {
    if (x < 8e-2) {
      if (fabs(y) < 1e-2)
        goto taylor;
      else if (fabs(mIm_z2) < 5e-3 && x < 5e-3)
        goto taylor_erfi;
    }
    /* don't use complex exp function, since that will produce spurious NaN
       values when multiplying w in an overflow situation. */
    return 1.0 - exp(mRe_z2) *
      (C(cos(mIm_z2), sin(mIm_z2))
       * FADDEEVA(w)(C(-y,x), relerr));
  }
  else { // x < 0
    if (x > -8e-2) { // duplicate from above to avoid fabs(x) call
      if (fabs(y) < 1e-2)
        goto taylor;
      else if (fabs(mIm_z2) < 5e-3 && x > -5e-3)
        goto taylor_erfi;
    }
    else if (isnan(x))
      return C(NaN, y == 0 ? 0 : NaN);
    /* don't use complex exp function, since that will produce spurious NaN
       values when multiplying w in an overflow situation. */
    return exp(mRe_z2) *
      (C(cos(mIm_z2), sin(mIm_z2))
       * FADDEEVA(w)(C(y,-x), relerr)) - 1.0;
  }

  // Use Taylor series for small |z|, to avoid cancellation inaccuracy
  //   erf(z) = 2/sqrt(pi) * z * (1 - z^2/3 + z^4/10 - z^6/42 + z^8/216 + ...)
 taylor:
  {
    cmplx mz2 = C(mRe_z2, mIm_z2); // -z^2
    return z * (1.1283791670955125739
                + mz2 * (0.37612638903183752464
                         + mz2 * (0.11283791670955125739
                                  + mz2 * (0.026866170645131251760
                                          + mz2 * 0.0052239776254421878422))));
  }

  /* for small |x| and small |xy|,
     use Taylor series to avoid cancellation inaccuracy:
       erf(x+iy) = erf(iy)
          + 2*exp(y^2)/sqrt(pi) *
            [ x * (1 - x^2 * (1+2y^2)/3 + x^4 * (3+12y^2+4y^4)/30 + ...
              - i * x^2 * y * (1 - x^2 * (3+2y^2)/6 + ...) ]
     where:
        erf(iy) = exp(y^2) * Im[w(y)]
  */
 taylor_erfi:
  {
    double x2 = x*x, y2 = y*y;
    double expy2 = exp(y2);
    return C
      (expy2 * x * (1.1283791670955125739
                    - x2 * (0.37612638903183752464
                            + 0.75225277806367504925*y2)
                    + x2*x2 * (0.11283791670955125739
                               + y2 * (0.45135166683820502956
                                       + 0.15045055561273500986*y2))),
       expy2 * (FADDEEVA(w_im)(y)
                - x2*y * (1.1283791670955125739
                          - x2 * (0.56418958354775628695
                                  + 0.37612638903183752464*y2))));
  }
}

// erfi(z) = -i erf(iz)
cmplx FADDEEVA(erfi)(cmplx z, double relerr)
{
  cmplx e = FADDEEVA(erf)(C(-cimag(z),creal(z)), relerr);
  return C(cimag(e), -creal(e));
}

// erfi(x) = -i erf(ix)
double FADDEEVA_RE(erfi)(double x)
{
  return x*x > 720 ? (x > 0 ? Inf : -Inf)
    : exp(x*x) * FADDEEVA(w_im)(x);
}

// erfc(x) = 1 - erf(x)
double FADDEEVA_RE(erfc)(double x)
{
#if !defined(__cplusplus)
  return erfc(x); // C99 supplies erfc in math.h
#elif (__cplusplus >= 201103L) || defined(HAVE_ERFC)
  return ::erfc(x); // C++11 supplies std::erfc in cmath
#else
  if (x*x > 750) // underflow
    return (x >= 0 ? 0.0 : 2.0);
  return x >= 0 ? exp(-x*x) * FADDEEVA_RE(erfcx)(x)
    : 2. - exp(-x*x) * FADDEEVA_RE(erfcx)(-x);
#endif
}

// erfc(z) = 1 - erf(z)
cmplx FADDEEVA(erfc)(cmplx z, double relerr)
{
  double x = creal(z), y = cimag(z);

  if (x == 0.)
    return C(1,
             /* handle y -> Inf limit manually, since
                exp(y^2) -> Inf but Im[w(y)] -> 0, so
                IEEE will give us a NaN when it should be Inf */
             y*y > 720 ? (y > 0 ? -Inf : Inf)
             : -exp(y*y) * FADDEEVA(w_im)(y));
  if (y == 0.) {
    if (x*x > 750) // underflow
      return C(x >= 0 ? 0.0 : 2.0,
               -y); // preserve sign of 0
    return C(x >= 0 ? exp(-x*x) * FADDEEVA_RE(erfcx)(x)
             : 2. - exp(-x*x) * FADDEEVA_RE(erfcx)(-x),
             -y); // preserve sign of zero
  }

  double mRe_z2 = (y - x) * (x + y); // Re(-z^2), being careful of overflow
  double mIm_z2 = -2*x*y; // Im(-z^2)
  if (mRe_z2 < -750) // underflow
    return (x >= 0 ? 0.0 : 2.0);

  if (x >= 0)
    return cexp(C(mRe_z2, mIm_z2))
      * FADDEEVA(w)(C(-y,x), relerr);
  else
    return 2.0 - cexp(C(mRe_z2, mIm_z2))
      * FADDEEVA(w)(C(y,-x), relerr);
}

// compute Dawson(x) = sqrt(pi)/2  *  exp(-x^2) * erfi(x)
double FADDEEVA_RE(Dawson)(double x)
{
  const double spi2 = 0.8862269254527580136490837416705725913990; // sqrt(pi)/2
  return spi2 * FADDEEVA(w_im)(x);
}

// compute Dawson(z) = sqrt(pi)/2  *  exp(-z^2) * erfi(z)
cmplx FADDEEVA(Dawson)(cmplx z, double relerr)
{
  const double spi2 = 0.8862269254527580136490837416705725913990; // sqrt(pi)/2
  double x = creal(z), y = cimag(z);

  // handle axes separately for speed & proper handling of x or y = Inf or NaN
  if (y == 0)
    return C(spi2 * FADDEEVA(w_im)(x),
             -y); // preserve sign of 0
  if (x == 0) {
    double y2 = y*y;
    if (y2 < 2.5e-5) { // Taylor expansion
      return C(x, // preserve sign of 0
               y * (1.
                    + y2 * (0.6666666666666666666666666666666666666667
                            + y2 * 0.26666666666666666666666666666666666667)));
    }
    return C(x, // preserve sign of 0
             spi2 * (y >= 0
                     ? exp(y2) - FADDEEVA_RE(erfcx)(y)
                     : FADDEEVA_RE(erfcx)(-y) - exp(y2)));
  }

  double mRe_z2 = (y - x) * (x + y); // Re(-z^2), being careful of overflow
  double mIm_z2 = -2*x*y; // Im(-z^2)
  cmplx mz2 = C(mRe_z2, mIm_z2); // -z^2

  /* Handle positive and negative x via different formulas,
     using the mirror symmetries of w, to avoid overflow/underflow
     problems from multiplying exponentially large and small quantities. */
  if (y >= 0) {
    if (y < 5e-3) {
      if (fabs(x) < 5e-3)
        goto taylor;
      else if (fabs(mIm_z2) < 5e-3)
        goto taylor_realaxis;
    }
    cmplx res = cexp(mz2) - FADDEEVA(w)(z, relerr);
    return spi2 * C(-cimag(res), creal(res));
  }
  else { // y < 0
    if (y > -5e-3) { // duplicate from above to avoid fabs(x) call
      if (fabs(x) < 5e-3)
        goto taylor;
      else if (fabs(mIm_z2) < 5e-3)
        goto taylor_realaxis;
    }
    else if (isnan(y))
      return C(x == 0 ? 0 : NaN, NaN);
    cmplx res = FADDEEVA(w)(-z, relerr) - cexp(mz2);
    return spi2 * C(-cimag(res), creal(res));
  }

  // Use Taylor series for small |z|, to avoid cancellation inaccuracy
  //     dawson(z) = z - 2/3 z^3 + 4/15 z^5 + ...
 taylor:
  return z * (1.
              + mz2 * (0.6666666666666666666666666666666666666667
                       + mz2 * 0.2666666666666666666666666666666666666667));

  /* for small |y| and small |xy|,
     use Taylor series to avoid cancellation inaccuracy:
       dawson(x + iy)
        = D + y^2 (D + x - 2Dx^2)
            + y^4 (D/2 + 5x/6 - 2Dx^2 - x^3/3 + 2Dx^4/3)
        + iy [ (1-2Dx) + 2/3 y^2 (1 - 3Dx - x^2 + 2Dx^3)
              + y^4/15 (4 - 15Dx - 9x^2 + 20Dx^3 + 2x^4 - 4Dx^5) ] + ...
     where D = dawson(x)

     However, for large |x|, 2Dx -> 1 which gives cancellation problems in
     this series (many of the leading terms cancel).  So, for large |x|,
     we need to substitute a continued-fraction expansion for D.

        dawson(x) = 0.5 / (x-0.5/(x-1/(x-1.5/(x-2/(x-2.5/(x...))))))

     The 6 terms shown here seems to be the minimum needed to be
     accurate as soon as the simpler Taylor expansion above starts
     breaking down.  Using this 6-term expansion, factoring out the
     denominator, and simplifying with Maple, we obtain:

      Re dawson(x + iy) * (-15 + 90x^2 - 60x^4 + 8x^6) / x
        = 33 - 28x^2 + 4x^4 + y^2 (18 - 4x^2) + 4 y^4
      Im dawson(x + iy) * (-15 + 90x^2 - 60x^4 + 8x^6) / y
        = -15 + 24x^2 - 4x^4 + 2/3 y^2 (6x^2 - 15) - 4 y^4

     Finally, for |x| > 5e7, we can use a simpler 1-term continued-fraction
     expansion for the real part, and a 2-term expansion for the imaginary
     part.  (This avoids overflow problems for huge |x|.)  This yields:

     Re dawson(x + iy) = [1 + y^2 (1 + y^2/2 - (xy)^2/3)] / (2x)
     Im dawson(x + iy) = y [ -1 - 2/3 y^2 + y^4/15 (2x^2 - 4) ] / (2x^2 - 1)

 */
 taylor_realaxis:
  {
    double x2 = x*x;
    if (x2 > 1600) { // |x| > 40
      double y2 = y*y;
      if (x2 > 25e14) {// |x| > 5e7
        double xy2 = (x*y)*(x*y);
        return C((0.5 + y2 * (0.5 + 0.25*y2
                              - 0.16666666666666666667*xy2)) / x,
                 y * (-1 + y2 * (-0.66666666666666666667
                                 + 0.13333333333333333333*xy2
                                 - 0.26666666666666666667*y2))
                 / (2*x2 - 1));
      }
      return (1. / (-15 + x2*(90 + x2*(-60 + 8*x2)))) *
        C(x * (33 + x2 * (-28 + 4*x2)
               + y2 * (18 - 4*x2 + 4*y2)),
          y * (-15 + x2 * (24 - 4*x2)
               + y2 * (4*x2 - 10 - 4*y2)));
    }
    else {
      double D = spi2 * FADDEEVA(w_im)(x);
      double y2 = y*y;
      return C
        (D + y2 * (D + x - 2*D*x2)
         + y2*y2 * (D * (0.5 - x2 * (2 - 0.66666666666666666667*x2))
                    + x * (0.83333333333333333333
                           - 0.33333333333333333333 * x2)),
         y * (1 - 2*D*x
              + y2 * 0.66666666666666666667 * (1 - x2 - D*x * (3 - 2*x2))
              + y2*y2 * (0.26666666666666666667 -
                         x2 * (0.6 - 0.13333333333333333333 * x2)
                         - D*x * (1 - x2 * (1.3333333333333333333
                                            - 0.26666666666666666667 * x2)))));
    }
  }
}

/////////////////////////////////////////////////////////////////////////

// return sinc(x) = sin(x)/x, given both x and sin(x)
// [since we only use this in cases where sin(x) has already been computed]
static inline double sinc(double x, double sinx) {
  return fabs(x) < 1e-4 ? 1 - (0.1666666666666666666667)*x*x : sinx / x;
}

// sinh(x) via Taylor series, accurate to machine precision for |x| < 1e-2
static inline double sinh_taylor(double x) {
  return x * (1 + (x*x) * (0.1666666666666666666667
                           + 0.00833333333333333333333 * (x*x)));
}

static inline double sqr(double x) { return x*x; }

// precomputed table of expa2n2[n-1] = exp(-a2*n*n)
// for double-precision a2 = 0.26865... in FADDEEVA(w), below.
static const double expa2n2[] = {
  7.64405281671221563e-01,
  3.41424527166548425e-01,
  8.91072646929412548e-02,
  1.35887299055460086e-02,
  1.21085455253437481e-03,
  6.30452613933449404e-05,
  1.91805156577114683e-06,
  3.40969447714832381e-08,
  3.54175089099469393e-10,
  2.14965079583260682e-12,
  7.62368911833724354e-15,
  1.57982797110681093e-17,
  1.91294189103582677e-20,
  1.35344656764205340e-23,
  5.59535712428588720e-27,
  1.35164257972401769e-30,
  1.90784582843501167e-34,
  1.57351920291442930e-38,
  7.58312432328032845e-43,
  2.13536275438697082e-47,
  3.51352063787195769e-52,
  3.37800830266396920e-57,
  1.89769439468301000e-62,
  6.22929926072668851e-68,
  1.19481172006938722e-73,
  1.33908181133005953e-79,
  8.76924303483223939e-86,
  3.35555576166254986e-92,
  7.50264110688173024e-99,
  9.80192200745410268e-106,
  7.48265412822268959e-113,
  3.33770122566809425e-120,
  8.69934598159861140e-128,
  1.32486951484088852e-135,
  1.17898144201315253e-143,
  6.13039120236180012e-152,
  1.86258785950822098e-160,
  3.30668408201432783e-169,
  3.43017280887946235e-178,
  2.07915397775808219e-187,
  7.36384545323984966e-197,
  1.52394760394085741e-206,
  1.84281935046532100e-216,
  1.30209553802992923e-226,
  5.37588903521080531e-237,
  1.29689584599763145e-247,
  1.82813078022866562e-258,
  1.50576355348684241e-269,
  7.24692320799294194e-281,
  2.03797051314726829e-292,
  3.34880215927873807e-304,
  0.0 // underflow (also prevents reads past array end, below)
};

/////////////////////////////////////////////////////////////////////////

static inline cmplx FADDEEVA(w)(cmplx z, double relerr)
{
  if (creal(z) == 0.0)
    return C(FADDEEVA_RE(erfcx)(cimag(z)),
             creal(z)); // give correct sign of 0 in cimag(w)
  else if (cimag(z) == 0)
    return C(exp(-sqr(creal(z))),
             FADDEEVA(w_im)(creal(z)));

  double a, a2, c;
  if (relerr <= DBL_EPSILON) {
    relerr = DBL_EPSILON;
    a = 0.518321480430085929872; // pi / sqrt(-log(eps*0.5))
    c = 0.329973702884629072537; // (2/pi) * a;
    a2 = 0.268657157075235951582; // a^2
  }
  else {
    const double pi = 3.14159265358979323846264338327950288419716939937510582;
    if (relerr > 0.1) relerr = 0.1; // not sensible to compute < 1 digit
    a = pi / sqrt(-log(relerr*0.5));
    c = (2/pi)*a;
    a2 = a*a;
  }
  const double x = fabs(creal(z));
  const double y = cimag(z), ya = fabs(y);

  cmplx ret = 0.; // return value

  double sum1 = 0, sum2 = 0, sum3 = 0, sum4 = 0, sum5 = 0;

#define USE_CONTINUED_FRACTION 1 // 1 to use continued fraction for large |z|

#if USE_CONTINUED_FRACTION
  if (ya > 7 || (x > 6  // continued fraction is faster
                 /* As pointed out by M. Zaghloul, the continued
                    fraction seems to give a large relative error in
                    Re w(z) for |x| ~ 6 and small |y|, so use
                    algorithm 816 in this region: */
                 && (ya > 0.1 || (x > 8 && ya > 1e-10) || x > 28))) {

    /* Poppe & Wijers suggest using a number of terms
           nu = 3 + 1442 / (26*rho + 77)
       where rho = sqrt((x/x0)^2 + (y/y0)^2) where x0=6.3, y0=4.4.
       (They only use this expansion for rho >= 1, but rho a little less
        than 1 seems okay too.)
       Instead, I did my own fit to a slightly different function
       that avoids the hypotenuse calculation, using NLopt to minimize
       the sum of the squares of the errors in nu with the constraint
       that the estimated nu be >= minimum nu to attain machine precision.
       I also separate the regions where nu == 2 and nu == 1. */
    const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
    double xs = y < 0 ? -creal(z) : creal(z); // compute for -z if y < 0
    if (x + ya > 4000) { // nu <= 2
      if (x + ya > 1e7) { // nu == 1, w(z) = i/sqrt(pi) / z
        // scale to avoid overflow
        if (x > ya) {
          double yax = ya / xs;
          double denom = ispi / (xs + yax*ya);
          ret = C(denom*yax, denom);
        }
        else if (isinf(ya))
          return ((isnan(x) || y < 0)
                  ? C(NaN,NaN) : C(0,0));
        else {
          double xya = xs / ya;
          double denom = ispi / (xya*xs + ya);
          ret = C(denom, denom*xya);
        }
      }
      else { // nu == 2, w(z) = i/sqrt(pi) * z / (z*z - 0.5)
        double dr = xs*xs - ya*ya - 0.5, di = 2*xs*ya;
        double denom = ispi / (dr*dr + di*di);
        ret = C(denom * (xs*di-ya*dr), denom * (xs*dr+ya*di));
      }
    }
    else { // compute nu(z) estimate and do general continued fraction
      const double c0=3.9, c1=11.398, c2=0.08254, c3=0.1421, c4=0.2023; // fit
      double nu = floor(c0 + c1 / (c2*x + c3*ya + c4));
      double wr = xs, wi = ya;
      for (nu = 0.5 * (nu - 1); nu > 0.4; nu -= 0.5) {
        // w <- z - nu/w:
        double denom = nu / (wr*wr + wi*wi);
        wr = xs - wr * denom;
        wi = ya + wi * denom;
      }
      { // w(z) = i/sqrt(pi) / w:
        double denom = ispi / (wr*wr + wi*wi);
        ret = C(denom*wi, denom*wr);
      }
    }
    if (y < 0) {
      // use w(z) = 2.0*exp(-z*z) - w(-z),
      // but be careful of overflow in exp(-z*z)
      //                                = exp(-(xs*xs-ya*ya) -2*i*xs*ya)
      return 2.0*cexp(C((ya-xs)*(xs+ya), 2*xs*y)) - ret;
    }
    else
      return ret;
  }
#else // !USE_CONTINUED_FRACTION
  if (x + ya > 1e7) { // w(z) = i/sqrt(pi) / z, to machine precision
    const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
    double xs = y < 0 ? -creal(z) : creal(z); // compute for -z if y < 0
    // scale to avoid overflow
    if (x > ya) {
      double yax = ya / xs;
      double denom = ispi / (xs + yax*ya);
      ret = C(denom*yax, denom);
    }
    else {
      double xya = xs / ya;
      double denom = ispi / (xya*xs + ya);
      ret = C(denom, denom*xya);
    }
    if (y < 0) {
      // use w(z) = 2.0*exp(-z*z) - w(-z),
      // but be careful of overflow in exp(-z*z)
      //                                = exp(-(xs*xs-ya*ya) -2*i*xs*ya)
      return 2.0*cexp(C((ya-xs)*(xs+ya), 2*xs*y)) - ret;
    }
    else
      return ret;
  }
#endif // !USE_CONTINUED_FRACTION

  /* Note: The test that seems to be suggested in the paper is x <
     sqrt(-log(DBL_MIN)), about 26.6, since otherwise exp(-x^2)
     underflows to zero and sum1,sum2,sum4 are zero.  However, long
     before this occurs, the sum1,sum2,sum4 contributions are
     negligible in double precision; I find that this happens for x >
     about 6, for all y.  On the other hand, I find that the case
     where we compute all of the sums is faster (at least with the
     precomputed expa2n2 table) until about x=10.  Furthermore, if we
     try to compute all of the sums for x > 20, I find that we
     sometimes run into numerical problems because underflow/overflow
     problems start to appear in the various coefficients of the sums,
     below.  Therefore, we use x < 10 here. */
  else if (x < 10) {
    double prod2ax = 1, prodm2ax = 1;
    double expx2;

    if (isnan(y))
      return C(y,y);

    /* Somewhat ugly copy-and-paste duplication here, but I see significant
       speedups from using the special-case code with the precomputed
       exponential, and the x < 5e-4 special case is needed for accuracy. */

    if (relerr == DBL_EPSILON) { // use precomputed exp(-a2*(n*n)) table
      if (x < 5e-4) { // compute sum4 and sum5 together as sum5-sum4
        const double x2 = x*x;
        expx2 = 1 - x2 * (1 - 0.5*x2); // exp(-x*x) via Taylor
        // compute exp(2*a*x) and exp(-2*a*x) via Taylor, to double precision
        const double ax2 = 1.036642960860171859744*x; // 2*a*x
        const double exp2ax =
          1 + ax2 * (1 + ax2 * (0.5 + 0.166666666666666666667*ax2));
        const double expm2ax =
          1 - ax2 * (1 - ax2 * (0.5 - 0.166666666666666666667*ax2));
        for (int n = 1; 1; ++n) {
          const double coef = expa2n2[n-1] * expx2 / (a2*(n*n) + y*y);
          prod2ax *= exp2ax;
          prodm2ax *= expm2ax;
          sum1 += coef;
          sum2 += coef * prodm2ax;
          sum3 += coef * prod2ax;

          // really = sum5 - sum4
          sum5 += coef * (2*a) * n * sinh_taylor((2*a)*n*x);

          // test convergence via sum3
          if (coef * prod2ax < relerr * sum3) break;
        }
      }
      else { // x > 5e-4, compute sum4 and sum5 separately
        expx2 = exp(-x*x);
        const double exp2ax = exp((2*a)*x), expm2ax = 1 / exp2ax;
        for (int n = 1; 1; ++n) {
          const double coef = expa2n2[n-1] * expx2 / (a2*(n*n) + y*y);
          prod2ax *= exp2ax;
          prodm2ax *= expm2ax;
          sum1 += coef;
          sum2 += coef * prodm2ax;
          sum4 += (coef * prodm2ax) * (a*n);
          sum3 += coef * prod2ax;
          sum5 += (coef * prod2ax) * (a*n);
          // test convergence via sum5, since this sum has the slowest decay
          if ((coef * prod2ax) * (a*n) < relerr * sum5) break;
        }
      }
    }
    else { // relerr != DBL_EPSILON, compute exp(-a2*(n*n)) on the fly
      const double exp2ax = exp((2*a)*x), expm2ax = 1 / exp2ax;
      if (x < 5e-4) { // compute sum4 and sum5 together as sum5-sum4
        const double x2 = x*x;
        expx2 = 1 - x2 * (1 - 0.5*x2); // exp(-x*x) via Taylor
        for (int n = 1; 1; ++n) {
          const double coef = exp(-a2*(n*n)) * expx2 / (a2*(n*n) + y*y);
          prod2ax *= exp2ax;
          prodm2ax *= expm2ax;
          sum1 += coef;
          sum2 += coef * prodm2ax;
          sum3 += coef * prod2ax;

          // really = sum5 - sum4
          sum5 += coef * (2*a) * n * sinh_taylor((2*a)*n*x);

          // test convergence via sum3
          if (coef * prod2ax < relerr * sum3) break;
        }
      }
      else { // x > 5e-4, compute sum4 and sum5 separately
        expx2 = exp(-x*x);
        for (int n = 1; 1; ++n) {
          const double coef = exp(-a2*(n*n)) * expx2 / (a2*(n*n) + y*y);
          prod2ax *= exp2ax;
          prodm2ax *= expm2ax;
          sum1 += coef;
          sum2 += coef * prodm2ax;
          sum4 += (coef * prodm2ax) * (a*n);
          sum3 += coef * prod2ax;
          sum5 += (coef * prod2ax) * (a*n);
          // test convergence via sum5, since this sum has the slowest decay
          if ((coef * prod2ax) * (a*n) < relerr * sum5) break;
        }
      }
    }
    const double expx2erfcxy = // avoid spurious overflow for large negative y
      y > -6 // for y < -6, erfcx(y) = 2*exp(y*y) to double precision
      ? expx2*FADDEEVA_RE(erfcx)(y) : 2*exp(y*y-x*x);
    if (y > 5) { // imaginary terms cancel
      const double sinxy = sin(x*y);
      ret = (expx2erfcxy - c*y*sum1) * cos(2*x*y)
        + (c*x*expx2) * sinxy * sinc(x*y, sinxy);
    }
    else {
      double xs = creal(z);
      const double sinxy = sin(xs*y);
      const double sin2xy = sin(2*xs*y), cos2xy = cos(2*xs*y);
      const double coef1 = expx2erfcxy - c*y*sum1;
      const double coef2 = c*xs*expx2;
      ret = C(coef1 * cos2xy + coef2 * sinxy * sinc(xs*y, sinxy),
              coef2 * sinc(2*xs*y, sin2xy) - coef1 * sin2xy);
    }
  }
  else { // x large: only sum3 & sum5 contribute (see above note)
    if (isnan(x))
      return C(x,x);
    if (isnan(y))
      return C(y,y);

#if USE_CONTINUED_FRACTION
    ret = exp(-x*x); // |y| < 1e-10, so we only need exp(-x*x) term
#else
    if (y < 0) {
      /* erfcx(y) ~ 2*exp(y*y) + (< 1) if y < 0, so
         erfcx(y)*exp(-x*x) ~ 2*exp(y*y-x*x) term may not be negligible
         if y*y - x*x > -36 or so.  So, compute this term just in case.
         We also need the -exp(-x*x) term to compute Re[w] accurately
         in the case where y is very small. */
      ret = cpolar(2*exp(y*y-x*x) - exp(-x*x), -2*creal(z)*y);
    }
    else
      ret = exp(-x*x); // not negligible in real part if y very small
#endif
    // (round instead of ceil as in original paper; note that x/a > 1 here)
    double n0 = floor(x/a + 0.5); // sum in both directions, starting at n0
    double dx = a*n0 - x;
    sum3 = exp(-dx*dx) / (a2*(n0*n0) + y*y);
    sum5 = a*n0 * sum3;
    double exp1 = exp(4*a*dx), exp1dn = 1;
    int dn;
    for (dn = 1; n0 - dn > 0; ++dn) { // loop over n0-dn and n0+dn terms
      double np = n0 + dn, nm = n0 - dn;
      double tp = exp(-sqr(a*dn+dx));
      double tm = tp * (exp1dn *= exp1); // trick to get tm from tp
      tp /= (a2*(np*np) + y*y);
      tm /= (a2*(nm*nm) + y*y);
      sum3 += tp + tm;
      sum5 += a * (np * tp + nm * tm);
      if (a * (np * tp + nm * tm) < relerr * sum5) goto finish;
    }
    while (1) { // loop over n0+dn terms only (since n0-dn <= 0)
      double np = n0 + dn++;
      double tp = exp(-sqr(a*dn+dx)) / (a2*(np*np) + y*y);
      sum3 += tp;
      sum5 += a * np * tp;
      if (a * np * tp < relerr * sum5) goto finish;
    }
  }
 finish:
  return ret + C((0.5*c)*y*(sum2+sum3),
                 (0.5*c)*copysign(sum5-sum4, creal(z)));
}

/////////////////////////////////////////////////////////////////////////

/* erfcx(x) = exp(x^2) erfc(x) function, for real x, written by
   Steven G. Johnson, October 2012.

   This function combines a few different ideas.

   First, for x > 50, it uses a continued-fraction expansion (same as
   for the Faddeeva function, but with algebraic simplifications for z=i*x).

   Second, for 0 <= x <= 50, it uses Chebyshev polynomial approximations,
   but with two twists:

      a) It maps x to y = 4 / (4+x) in [0,1].  This simple transformation,
         inspired by a similar transformation in the octave-forge/specfun
         erfcx by Soren Hauberg, results in much faster Chebyshev convergence
         than other simple transformations I have examined.

      b) Instead of using a single Chebyshev polynomial for the entire
         [0,1] y interval, we break the interval up into 100 equal
         subintervals, with a switch/lookup table, and use much lower
         degree Chebyshev polynomials in each subinterval. This greatly
         improves performance in my tests.

   For x < 0, we use the relationship erfcx(-x) = 2 exp(x^2) - erfc(x),
   with the usual checks for overflow etcetera.

   Performance-wise, it seems to be substantially faster than either
   the SLATEC DERFC function [or an erfcx function derived therefrom]
   or Cody's CALERF function (from netlib.org/specfun), while
   retaining near machine precision in accuracy.  */

/* Given y100=100*y, where y = 4/(4+x) for x >= 0, compute erfc(x).

   Uses a look-up table of 100 different Chebyshev polynomials
   for y intervals [0,0.01], [0.01,0.02], ...., [0.99,1], generated
   with the help of Maple and a little shell script.   This allows
   the Chebyshev polynomials to be of significantly lower degree (about 1/4)
   compared to fitting the whole [0,1] interval with a single polynomial. */
static double erfcx_y100(double y100)
{
  switch ((int) y100) {
case 0: {
double t = 2*y100 - 1;
return 0.70878032454106438663e-3 + (0.71234091047026302958e-3 + (0.35779077297597742384e-5 + (0.17403143962587937815e-7 + (0.81710660047307788845e-10 + (0.36885022360434957634e-12 + 0.15917038551111111111e-14 * t) * t) * t) * t) * t) * t;
}
case 1: {
double t = 2*y100 - 3;
return 0.21479143208285144230e-2 + (0.72686402367379996033e-3 + (0.36843175430938995552e-5 + (0.18071841272149201685e-7 + (0.85496449296040325555e-10 + (0.38852037518534291510e-12 + 0.16868473576888888889e-14 * t) * t) * t) * t) * t) * t;
}
case 2: {
double t = 2*y100 - 5;
return 0.36165255935630175090e-2 + (0.74182092323555510862e-3 + (0.37948319957528242260e-5 + (0.18771627021793087350e-7 + (0.89484715122415089123e-10 + (0.40935858517772440862e-12 + 0.17872061464888888889e-14 * t) * t) * t) * t) * t) * t;
}
case 3: {
double t = 2*y100 - 7;
return 0.51154983860031979264e-2 + (0.75722840734791660540e-3 + (0.39096425726735703941e-5 + (0.19504168704300468210e-7 + (0.93687503063178993915e-10 + (0.43143925959079664747e-12 + 0.18939926435555555556e-14 * t) * t) * t) * t) * t) * t;
}
case 4: {
double t = 2*y100 - 9;
return 0.66457513172673049824e-2 + (0.77310406054447454920e-3 + (0.40289510589399439385e-5 + (0.20271233238288381092e-7 + (0.98117631321709100264e-10 + (0.45484207406017752971e-12 + 0.20076352213333333333e-14 * t) * t) * t) * t) * t) * t;
}
case 5: {
double t = 2*y100 - 11;
return 0.82082389970241207883e-2 + (0.78946629611881710721e-3 + (0.41529701552622656574e-5 + (0.21074693344544655714e-7 + (0.10278874108587317989e-9 + (0.47965201390613339638e-12 + 0.21285907413333333333e-14 * t) * t) * t) * t) * t) * t;
}
case 6: {
double t = 2*y100 - 13;
return 0.98039537275352193165e-2 + (0.80633440108342840956e-3 + (0.42819241329736982942e-5 + (0.21916534346907168612e-7 + (0.10771535136565470914e-9 + (0.50595972623692822410e-12 + 0.22573462684444444444e-14 * t) * t) * t) * t) * t) * t;
}
case 7: {
double t = 2*y100 - 15;
return 0.11433927298290302370e-1 + (0.82372858383196561209e-3 + (0.44160495311765438816e-5 + (0.22798861426211986056e-7 + (0.11291291745879239736e-9 + (0.53386189365816880454e-12 + 0.23944209546666666667e-14 * t) * t) * t) * t) * t) * t;
}
case 8: {
double t = 2*y100 - 17;
return 0.13099232878814653979e-1 + (0.84167002467906968214e-3 + (0.45555958988457506002e-5 + (0.23723907357214175198e-7 + (0.11839789326602695603e-9 + (0.56346163067550237877e-12 + 0.25403679644444444444e-14 * t) * t) * t) * t) * t) * t;
}
case 9: {
double t = 2*y100 - 19;
return 0.14800987015587535621e-1 + (0.86018092946345943214e-3 + (0.47008265848816866105e-5 + (0.24694040760197315333e-7 + (0.12418779768752299093e-9 + (0.59486890370320261949e-12 + 0.26957764568888888889e-14 * t) * t) * t) * t) * t) * t;
}
case 10: {
double t = 2*y100 - 21;
return 0.16540351739394069380e-1 + (0.87928458641241463952e-3 + (0.48520195793001753903e-5 + (0.25711774900881709176e-7 + (0.13030128534230822419e-9 + (0.62820097586874779402e-12 + 0.28612737351111111111e-14 * t) * t) * t) * t) * t) * t;
}
case 11: {
double t = 2*y100 - 23;
return 0.18318536789842392647e-1 + (0.89900542647891721692e-3 + (0.50094684089553365810e-5 + (0.26779777074218070482e-7 + (0.13675822186304615566e-9 + (0.66358287745352705725e-12 + 0.30375273884444444444e-14 * t) * t) * t) * t) * t) * t;
}
case 12: {
double t = 2*y100 - 25;
return 0.20136801964214276775e-1 + (0.91936908737673676012e-3 + (0.51734830914104276820e-5 + (0.27900878609710432673e-7 + (0.14357976402809042257e-9 + (0.70114790311043728387e-12 + 0.32252476000000000000e-14 * t) * t) * t) * t) * t) * t;
}
case 13: {
double t = 2*y100 - 27;
return 0.21996459598282740954e-1 + (0.94040248155366777784e-3 + (0.53443911508041164739e-5 + (0.29078085538049374673e-7 + (0.15078844500329731137e-9 + (0.74103813647499204269e-12 + 0.34251892320000000000e-14 * t) * t) * t) * t) * t) * t;
}
case 14: {
double t = 2*y100 - 29;
return 0.23898877187226319502e-1 + (0.96213386835900177540e-3 + (0.55225386998049012752e-5 + (0.30314589961047687059e-7 + (0.15840826497296335264e-9 + (0.78340500472414454395e-12 + 0.36381553564444444445e-14 * t) * t) * t) * t) * t) * t;
}
case 15: {
double t = 2*y100 - 31;
return 0.25845480155298518485e-1 + (0.98459293067820123389e-3 + (0.57082915920051843672e-5 + (0.31613782169164830118e-7 + (0.16646478745529630813e-9 + (0.82840985928785407942e-12 + 0.38649975768888888890e-14 * t) * t) * t) * t) * t) * t;
}
case 16: {
double t = 2*y100 - 33;
return 0.27837754783474696598e-1 + (0.10078108563256892757e-2 + (0.59020366493792212221e-5 + (0.32979263553246520417e-7 + (0.17498524159268458073e-9 + (0.87622459124842525110e-12 + 0.41066206488888888890e-14 * t) * t) * t) * t) * t) * t;
}
case 17: {
double t = 2*y100 - 35;
return 0.29877251304899307550e-1 + (0.10318204245057349310e-2 + (0.61041829697162055093e-5 + (0.34414860359542720579e-7 + (0.18399863072934089607e-9 + (0.92703227366365046533e-12 + 0.43639844053333333334e-14 * t) * t) * t) * t) * t) * t;
}
case 18: {
double t = 2*y100 - 37;
return 0.31965587178596443475e-1 + (0.10566560976716574401e-2 + (0.63151633192414586770e-5 + (0.35924638339521924242e-7 + (0.19353584758781174038e-9 + (0.98102783859889264382e-12 + 0.46381060817777777779e-14 * t) * t) * t) * t) * t) * t;
}
case 19: {
double t = 2*y100 - 39;
return 0.34104450552588334840e-1 + (0.10823541191350532574e-2 + (0.65354356159553934436e-5 + (0.37512918348533521149e-7 + (0.20362979635817883229e-9 + (0.10384187833037282363e-11 + 0.49300625262222222221e-14 * t) * t) * t) * t) * t) * t;
}
case 20: {
double t = 2*y100 - 41;
return 0.36295603928292425716e-1 + (0.11089526167995268200e-2 + (0.67654845095518363577e-5 + (0.39184292949913591646e-7 + (0.21431552202133775150e-9 + (0.10994259106646731797e-11 + 0.52409949102222222221e-14 * t) * t) * t) * t) * t) * t;
}
case 21: {
double t = 2*y100 - 43;
return 0.38540888038840509795e-1 + (0.11364917134175420009e-2 + (0.70058230641246312003e-5 + (0.40943644083718586939e-7 + (0.22563034723692881631e-9 + (0.11642841011361992885e-11 + 0.55721092871111111110e-14 * t) * t) * t) * t) * t) * t;
}
case 22: {
double t = 2*y100 - 45;
return 0.40842225954785960651e-1 + (0.11650136437945673891e-2 + (0.72569945502343006619e-5 + (0.42796161861855042273e-7 + (0.23761401711005024162e-9 + (0.12332431172381557035e-11 + 0.59246802364444444445e-14 * t) * t) * t) * t) * t) * t;
}
case 23: {
double t = 2*y100 - 47;
return 0.43201627431540222422e-1 + (0.11945628793917272199e-2 + (0.75195743532849206263e-5 + (0.44747364553960993492e-7 + (0.25030885216472953674e-9 + (0.13065684400300476484e-11 + 0.63000532853333333334e-14 * t) * t) * t) * t) * t) * t;
}
case 24: {
double t = 2*y100 - 49;
return 0.45621193513810471438e-1 + (0.12251862608067529503e-2 + (0.77941720055551920319e-5 + (0.46803119830954460212e-7 + (0.26375990983978426273e-9 + (0.13845421370977119765e-11 + 0.66996477404444444445e-14 * t) * t) * t) * t) * t) * t;
}
case 25: {
double t = 2*y100 - 51;
return 0.48103121413299865517e-1 + (0.12569331386432195113e-2 + (0.80814333496367673980e-5 + (0.48969667335682018324e-7 + (0.27801515481905748484e-9 + (0.14674637611609884208e-11 + 0.71249589351111111110e-14 * t) * t) * t) * t) * t) * t;
}
case 26: {
double t = 2*y100 - 53;
return 0.50649709676983338501e-1 + (0.12898555233099055810e-2 + (0.83820428414568799654e-5 + (0.51253642652551838659e-7 + (0.29312563849675507232e-9 + (0.15556512782814827846e-11 + 0.75775607822222222221e-14 * t) * t) * t) * t) * t) * t;
}
case 27: {
double t = 2*y100 - 55;
return 0.53263363664388864181e-1 + (0.13240082443256975769e-2 + (0.86967260015007658418e-5 + (0.53662102750396795566e-7 + (0.30914568786634796807e-9 + (0.16494420240828493176e-11 + 0.80591079644444444445e-14 * t) * t) * t) * t) * t) * t;
}
case 28: {
double t = 2*y100 - 57;
return 0.55946601353500013794e-1 + (0.13594491197408190706e-2 + (0.90262520233016380987e-5 + (0.56202552975056695376e-7 + (0.32613310410503135996e-9 + (0.17491936862246367398e-11 + 0.85713381688888888890e-14 * t) * t) * t) * t) * t) * t;
}
case 29: {
double t = 2*y100 - 59;
return 0.58702059496154081813e-1 + (0.13962391363223647892e-2 + (0.93714365487312784270e-5 + (0.58882975670265286526e-7 + (0.34414937110591753387e-9 + (0.18552853109751857859e-11 + 0.91160736711111111110e-14 * t) * t) * t) * t) * t) * t;
}
case 30: {
double t = 2*y100 - 61;
return 0.61532500145144778048e-1 + (0.14344426411912015247e-2 + (0.97331446201016809696e-5 + (0.61711860507347175097e-7 + (0.36325987418295300221e-9 + (0.19681183310134518232e-11 + 0.96952238400000000000e-14 * t) * t) * t) * t) * t) * t;
}
case 31: {
double t = 2*y100 - 63;
return 0.64440817576653297993e-1 + (0.14741275456383131151e-2 + (0.10112293819576437838e-4 + (0.64698236605933246196e-7 + (0.38353412915303665586e-9 + (0.20881176114385120186e-11 + 0.10310784480000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 32: {
double t = 2*y100 - 65;
return 0.67430045633130393282e-1 + (0.15153655418916540370e-2 + (0.10509857606888328667e-4 + (0.67851706529363332855e-7 + (0.40504602194811140006e-9 + (0.22157325110542534469e-11 + 0.10964842115555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 33: {
double t = 2*y100 - 67;
return 0.70503365513338850709e-1 + (0.15582323336495709827e-2 + (0.10926868866865231089e-4 + (0.71182482239613507542e-7 + (0.42787405890153386710e-9 + (0.23514379522274416437e-11 + 0.11659571751111111111e-13 * t) * t) * t) * t) * t) * t;
}
case 34: {
double t = 2*y100 - 69;
return 0.73664114037944596353e-1 + (0.16028078812438820413e-2 + (0.11364423678778207991e-4 + (0.74701423097423182009e-7 + (0.45210162777476488324e-9 + (0.24957355004088569134e-11 + 0.12397238257777777778e-13 * t) * t) * t) * t) * t) * t;
}
case 35: {
double t = 2*y100 - 71;
return 0.76915792420819562379e-1 + (0.16491766623447889354e-2 + (0.11823685320041302169e-4 + (0.78420075993781544386e-7 + (0.47781726956916478925e-9 + (0.26491544403815724749e-11 + 0.13180196462222222222e-13 * t) * t) * t) * t) * t) * t;
}
case 36: {
double t = 2*y100 - 73;
return 0.80262075578094612819e-1 + (0.16974279491709504117e-2 + (0.12305888517309891674e-4 + (0.82350717698979042290e-7 + (0.50511496109857113929e-9 + (0.28122528497626897696e-11 + 0.14010889635555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 37: {
double t = 2*y100 - 75;
return 0.83706822008980357446e-1 + (0.17476561032212656962e-2 + (0.12812343958540763368e-4 + (0.86506399515036435592e-7 + (0.53409440823869467453e-9 + (0.29856186620887555043e-11 + 0.14891851591111111111e-13 * t) * t) * t) * t) * t) * t;
}
case 38: {
double t = 2*y100 - 77;
return 0.87254084284461718231e-1 + (0.17999608886001962327e-2 + (0.13344443080089492218e-4 + (0.90900994316429008631e-7 + (0.56486134972616465316e-9 + (0.31698707080033956934e-11 + 0.15825697795555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 39: {
double t = 2*y100 - 79;
return 0.90908120182172748487e-1 + (0.18544478050657699758e-2 + (0.13903663143426120077e-4 + (0.95549246062549906177e-7 + (0.59752787125242054315e-9 + (0.33656597366099099413e-11 + 0.16815130613333333333e-13 * t) * t) * t) * t) * t) * t;
}
case 40: {
double t = 2*y100 - 81;
return 0.94673404508075481121e-1 + (0.19112284419887303347e-2 + (0.14491572616545004930e-4 + (0.10046682186333613697e-6 + (0.63221272959791000515e-9 + (0.35736693975589130818e-11 + 0.17862931591111111111e-13 * t) * t) * t) * t) * t) * t;
}
case 41: {
double t = 2*y100 - 83;
return 0.98554641648004456555e-1 + (0.19704208544725622126e-2 + (0.15109836875625443935e-4 + (0.10567036667675984067e-6 + (0.66904168640019354565e-9 + (0.37946171850824333014e-11 + 0.18971959040000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 42: {
double t = 2*y100 - 85;
return 0.10255677889470089531e0 + (0.20321499629472857418e-2 + (0.15760224242962179564e-4 + (0.11117756071353507391e-6 + (0.70814785110097658502e-9 + (0.40292553276632563925e-11 + 0.20145143075555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 43: {
double t = 2*y100 - 87;
return 0.10668502059865093318e0 + (0.20965479776148731610e-2 + (0.16444612377624983565e-4 + (0.11700717962026152749e-6 + (0.74967203250938418991e-9 + (0.42783716186085922176e-11 + 0.21385479360000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 44: {
double t = 2*y100 - 89;
return 0.11094484319386444474e0 + (0.21637548491908170841e-2 + (0.17164995035719657111e-4 + (0.12317915750735938089e-6 + (0.79376309831499633734e-9 + (0.45427901763106353914e-11 + 0.22696025653333333333e-13 * t) * t) * t) * t) * t) * t;
}
case 45: {
double t = 2*y100 - 91;
return 0.11534201115268804714e0 + (0.22339187474546420375e-2 + (0.17923489217504226813e-4 + (0.12971465288245997681e-6 + (0.84057834180389073587e-9 + (0.48233721206418027227e-11 + 0.24079890062222222222e-13 * t) * t) * t) * t) * t) * t;
}
case 46: {
double t = 2*y100 - 93;
return 0.11988259392684094740e0 + (0.23071965691918689601e-2 + (0.18722342718958935446e-4 + (0.13663611754337957520e-6 + (0.89028385488493287005e-9 + (0.51210161569225846701e-11 + 0.25540227111111111111e-13 * t) * t) * t) * t) * t) * t;
}
case 47: {
double t = 2*y100 - 95;
return 0.12457298393509812907e0 + (0.23837544771809575380e-2 + (0.19563942105711612475e-4 + (0.14396736847739470782e-6 + (0.94305490646459247016e-9 + (0.54366590583134218096e-11 + 0.27080225920000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 48: {
double t = 2*y100 - 97;
return 0.12941991566142438816e0 + (0.24637684719508859484e-2 + (0.20450821127475879816e-4 + (0.15173366280523906622e-6 + (0.99907632506389027739e-9 + (0.57712760311351625221e-11 + 0.28703099555555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 49: {
double t = 2*y100 - 99;
return 0.13443048593088696613e0 + (0.25474249981080823877e-2 + (0.21385669591362915223e-4 + (0.15996177579900443030e-6 + (0.10585428844575134013e-8 + (0.61258809536787882989e-11 + 0.30412080142222222222e-13 * t) * t) * t) * t) * t) * t;
}
case 50: {
double t = 2*y100 - 101;
return 0.13961217543434561353e0 + (0.26349215871051761416e-2 + (0.22371342712572567744e-4 + (0.16868008199296822247e-6 + (0.11216596910444996246e-8 + (0.65015264753090890662e-11 + 0.32210394506666666666e-13 * t) * t) * t) * t) * t) * t;
}
case 51: {
double t = 2*y100 - 103;
return 0.14497287157673800690e0 + (0.27264675383982439814e-2 + (0.23410870961050950197e-4 + (0.17791863939526376477e-6 + (0.11886425714330958106e-8 + (0.68993039665054288034e-11 + 0.34101266222222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 52: {
double t = 2*y100 - 105;
return 0.15052089272774618151e0 + (0.28222846410136238008e-2 + (0.24507470422713397006e-4 + (0.18770927679626136909e-6 + (0.12597184587583370712e-8 + (0.73203433049229821618e-11 + 0.36087889048888888890e-13 * t) * t) * t) * t) * t) * t;
}
case 53: {
double t = 2*y100 - 107;
return 0.15626501395774612325e0 + (0.29226079376196624949e-2 + (0.25664553693768450545e-4 + (0.19808568415654461964e-6 + (0.13351257759815557897e-8 + (0.77658124891046760667e-11 + 0.38173420035555555555e-13 * t) * t) * t) * t) * t) * t;
}
case 54: {
double t = 2*y100 - 109;
return 0.16221449434620737567e0 + (0.30276865332726475672e-2 + (0.26885741326534564336e-4 + (0.20908350604346384143e-6 + (0.14151148144240728728e-8 + (0.82369170665974313027e-11 + 0.40360957457777777779e-13 * t) * t) * t) * t) * t) * t;
}
case 55: {
double t = 2*y100 - 111;
return 0.16837910595412130659e0 + (0.31377844510793082301e-2 + (0.28174873844911175026e-4 + (0.22074043807045782387e-6 + (0.14999481055996090039e-8 + (0.87348993661930809254e-11 + 0.42653528977777777779e-13 * t) * t) * t) * t) * t) * t;
}
case 56: {
double t = 2*y100 - 113;
return 0.17476916455659369953e0 + (0.32531815370903068316e-2 + (0.29536024347344364074e-4 + (0.23309632627767074202e-6 + (0.15899007843582444846e-8 + (0.92610375235427359475e-11 + 0.45054073102222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 57: {
double t = 2*y100 - 115;
return 0.18139556223643701364e0 + (0.33741744168096996041e-2 + (0.30973511714709500836e-4 + (0.24619326937592290996e-6 + (0.16852609412267750744e-8 + (0.98166442942854895573e-11 + 0.47565418097777777779e-13 * t) * t) * t) * t) * t) * t;
}
case 58: {
double t = 2*y100 - 117;
return 0.18826980194443664549e0 + (0.35010775057740317997e-2 + (0.32491914440014267480e-4 + (0.26007572375886319028e-6 + (0.17863299617388376116e-8 + (0.10403065638343878679e-10 + 0.50190265831111111110e-13 * t) * t) * t) * t) * t) * t;
}
case 59: {
double t = 2*y100 - 119;
return 0.19540403413693967350e0 + (0.36342240767211326315e-2 + (0.34096085096200907289e-4 + (0.27479061117017637474e-6 + (0.18934228504790032826e-8 + (0.11021679075323598664e-10 + 0.52931171733333333334e-13 * t) * t) * t) * t) * t) * t;
}
case 60: {
double t = 2*y100 - 121;
return 0.20281109560651886959e0 + (0.37739673859323597060e-2 + (0.35791165457592409054e-4 + (0.29038742889416172404e-6 + (0.20068685374849001770e-8 + (0.11673891799578381999e-10 + 0.55790523093333333334e-13 * t) * t) * t) * t) * t) * t;
}
case 61: {
double t = 2*y100 - 123;
return 0.21050455062669334978e0 + (0.39206818613925652425e-2 + (0.37582602289680101704e-4 + (0.30691836231886877385e-6 + (0.21270101645763677824e-8 + (0.12361138551062899455e-10 + 0.58770520160000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 62: {
double t = 2*y100 - 125;
return 0.21849873453703332479e0 + (0.40747643554689586041e-2 + (0.39476163820986711501e-4 + (0.32443839970139918836e-6 + (0.22542053491518680200e-8 + (0.13084879235290858490e-10 + 0.61873153262222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 63: {
double t = 2*y100 - 127;
return 0.22680879990043229327e0 + (0.42366354648628516935e-2 + (0.41477956909656896779e-4 + (0.34300544894502810002e-6 + (0.23888264229264067658e-8 + (0.13846596292818514601e-10 + 0.65100183751111111110e-13 * t) * t) * t) * t) * t) * t;
}
case 64: {
double t = 2*y100 - 129;
return 0.23545076536988703937e0 + (0.44067409206365170888e-2 + (0.43594444916224700881e-4 + (0.36268045617760415178e-6 + (0.25312606430853202748e-8 + (0.14647791812837903061e-10 + 0.68453122631111111110e-13 * t) * t) * t) * t) * t) * t;
}
case 65: {
double t = 2*y100 - 131;
return 0.24444156740777432838e0 + (0.45855530511605787178e-2 + (0.45832466292683085475e-4 + (0.38352752590033030472e-6 + (0.26819103733055603460e-8 + (0.15489984390884756993e-10 + 0.71933206364444444445e-13 * t) * t) * t) * t) * t) * t;
}
case 66: {
double t = 2*y100 - 133;
return 0.25379911500634264643e0 + (0.47735723208650032167e-2 + (0.48199253896534185372e-4 + (0.40561404245564732314e-6 + (0.28411932320871165585e-8 + (0.16374705736458320149e-10 + 0.75541379822222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 67: {
double t = 2*y100 - 135;
return 0.26354234756393613032e0 + (0.49713289477083781266e-2 + (0.50702455036930367504e-4 + (0.42901079254268185722e-6 + (0.30095422058900481753e-8 + (0.17303497025347342498e-10 + 0.79278273368888888890e-13 * t) * t) * t) * t) * t) * t;
}
case 68: {
double t = 2*y100 - 137;
return 0.27369129607732343398e0 + (0.51793846023052643767e-2 + (0.53350152258326602629e-4 + (0.45379208848865015485e-6 + (0.31874057245814381257e-8 + (0.18277905010245111046e-10 + 0.83144182364444444445e-13 * t) * t) * t) * t) * t) * t;
}
case 69: {
double t = 2*y100 - 139;
return 0.28426714781640316172e0 + (0.53983341916695141966e-2 + (0.56150884865255810638e-4 + (0.48003589196494734238e-6 + (0.33752476967570796349e-8 + (0.19299477888083469086e-10 + 0.87139049137777777779e-13 * t) * t) * t) * t) * t) * t;
}
case 70: {
double t = 2*y100 - 141;
return 0.29529231465348519920e0 + (0.56288077305420795663e-2 + (0.59113671189913307427e-4 + (0.50782393781744840482e-6 + (0.35735475025851713168e-8 + (0.20369760937017070382e-10 + 0.91262442613333333334e-13 * t) * t) * t) * t) * t) * t;
}
case 71: {
double t = 2*y100 - 143;
return 0.30679050522528838613e0 + (0.58714723032745403331e-2 + (0.62248031602197686791e-4 + (0.53724185766200945789e-6 + (0.37827999418960232678e-8 + (0.21490291930444538307e-10 + 0.95513539182222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 72: {
double t = 2*y100 - 145;
return 0.31878680111173319425e0 + (0.61270341192339103514e-2 + (0.65564012259707640976e-4 + (0.56837930287837738996e-6 + (0.40035151353392378882e-8 + (0.22662596341239294792e-10 + 0.99891109760000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 73: {
double t = 2*y100 - 147;
return 0.33130773722152622027e0 + (0.63962406646798080903e-2 + (0.69072209592942396666e-4 + (0.60133006661885941812e-6 + (0.42362183765883466691e-8 + (0.23888182347073698382e-10 + 0.10439349811555555556e-12 * t) * t) * t) * t) * t) * t;
}
case 74: {
double t = 2*y100 - 149;
return 0.34438138658041336523e0 + (0.66798829540414007258e-2 + (0.72783795518603561144e-4 + (0.63619220443228800680e-6 + (0.44814499336514453364e-8 + (0.25168535651285475274e-10 + 0.10901861383111111111e-12 * t) * t) * t) * t) * t) * t;
}
case 75: {
double t = 2*y100 - 151;
return 0.35803744972380175583e0 + (0.69787978834882685031e-2 + (0.76710543371454822497e-4 + (0.67306815308917386747e-6 + (0.47397647975845228205e-8 + (0.26505114141143050509e-10 + 0.11376390933333333333e-12 * t) * t) * t) * t) * t) * t;
}
case 76: {
double t = 2*y100 - 153;
return 0.37230734890119724188e0 + (0.72938706896461381003e-2 + (0.80864854542670714092e-4 + (0.71206484718062688779e-6 + (0.50117323769745883805e-8 + (0.27899342394100074165e-10 + 0.11862637614222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 77: {
double t = 2*y100 - 155;
return 0.38722432730555448223e0 + (0.76260375162549802745e-2 + (0.85259785810004603848e-4 + (0.75329383305171327677e-6 + (0.52979361368388119355e-8 + (0.29352606054164086709e-10 + 0.12360253370666666667e-12 * t) * t) * t) * t) * t) * t;
}
case 78: {
double t = 2*y100 - 157;
return 0.40282355354616940667e0 + (0.79762880915029728079e-2 + (0.89909077342438246452e-4 + (0.79687137961956194579e-6 + (0.55989731807360403195e-8 + (0.30866246101464869050e-10 + 0.12868841946666666667e-12 * t) * t) * t) * t) * t) * t;
}
case 79: {
double t = 2*y100 - 159;
return 0.41914223158913787649e0 + (0.83456685186950463538e-2 + (0.94827181359250161335e-4 + (0.84291858561783141014e-6 + (0.59154537751083485684e-8 + (0.32441553034347469291e-10 + 0.13387957943111111111e-12 * t) * t) * t) * t) * t) * t;
}
case 80: {
double t = 2*y100 - 161;
return 0.43621971639463786896e0 + (0.87352841828289495773e-2 + (0.10002929142066799966e-3 + (0.89156148280219880024e-6 + (0.62480008150788597147e-8 + (0.34079760983458878910e-10 + 0.13917107176888888889e-12 * t) * t) * t) * t) * t) * t;
}
case 81: {
double t = 2*y100 - 163;
return 0.45409763548534330981e0 + (0.91463027755548240654e-2 + (0.10553137232446167258e-3 + (0.94293113464638623798e-6 + (0.65972492312219959885e-8 + (0.35782041795476563662e-10 + 0.14455745872000000000e-12 * t) * t) * t) * t) * t) * t;
}
case 82: {
double t = 2*y100 - 165;
return 0.47282001668512331468e0 + (0.95799574408860463394e-2 + (0.11135019058000067469e-3 + (0.99716373005509038080e-6 + (0.69638453369956970347e-8 + (0.37549499088161345850e-10 + 0.15003280712888888889e-12 * t) * t) * t) * t) * t) * t;
}
case 83: {
double t = 2*y100 - 167;
return 0.49243342227179841649e0 + (0.10037550043909497071e-1 + (0.11750334542845234952e-3 + (0.10544006716188967172e-5 + (0.73484461168242224872e-8 + (0.39383162326435752965e-10 + 0.15559069118222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 84: {
double t = 2*y100 - 169;
return 0.51298708979209258326e0 + (0.10520454564612427224e-1 + (0.12400930037494996655e-3 + (0.11147886579371265246e-5 + (0.77517184550568711454e-8 + (0.41283980931872622611e-10 + 0.16122419680000000000e-12 * t) * t) * t) * t) * t) * t;
}
case 85: {
double t = 2*y100 - 171;
return 0.53453307979101369843e0 + (0.11030120618800726938e-1 + (0.13088741519572269581e-3 + (0.11784797595374515432e-5 + (0.81743383063044825400e-8 + (0.43252818449517081051e-10 + 0.16692592640000000000e-12 * t) * t) * t) * t) * t) * t;
}
case 86: {
double t = 2*y100 - 173;
return 0.55712643071169299478e0 + (0.11568077107929735233e-1 + (0.13815797838036651289e-3 + (0.12456314879260904558e-5 + (0.86169898078969313597e-8 + (0.45290446811539652525e-10 + 0.17268801084444444444e-12 * t) * t) * t) * t) * t) * t;
}
case 87: {
double t = 2*y100 - 175;
return 0.58082532122519320968e0 + (0.12135935999503877077e-1 + (0.14584223996665838559e-3 + (0.13164068573095710742e-5 + (0.90803643355106020163e-8 + (0.47397540713124619155e-10 + 0.17850211608888888889e-12 * t) * t) * t) * t) * t) * t;
}
case 88: {
double t = 2*y100 - 177;
return 0.60569124025293375554e0 + (0.12735396239525550361e-1 + (0.15396244472258863344e-3 + (0.13909744385382818253e-5 + (0.95651595032306228245e-8 + (0.49574672127669041550e-10 + 0.18435945564444444444e-12 * t) * t) * t) * t) * t) * t;
}
case 89: {
double t = 2*y100 - 179;
return 0.63178916494715716894e0 + (0.13368247798287030927e-1 + (0.16254186562762076141e-3 + (0.14695084048334056083e-5 + (0.10072078109604152350e-7 + (0.51822304995680707483e-10 + 0.19025081422222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 90: {
double t = 2*y100 - 181;
return 0.65918774689725319200e0 + (0.14036375850601992063e-1 + (0.17160483760259706354e-3 + (0.15521885688723188371e-5 + (0.10601827031535280590e-7 + (0.54140790105837520499e-10 + 0.19616655146666666667e-12 * t) * t) * t) * t) * t) * t;
}
case 91: {
double t = 2*y100 - 183;
return 0.68795950683174433822e0 + (0.14741765091365869084e-1 + (0.18117679143520433835e-3 + (0.16392004108230585213e-5 + (0.11155116068018043001e-7 + (0.56530360194925690374e-10 + 0.20209663662222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 92: {
double t = 2*y100 - 185;
return 0.71818103808729967036e0 + (0.15486504187117112279e-1 + (0.19128428784550923217e-3 + (0.17307350969359975848e-5 + (0.11732656736113607751e-7 + (0.58991125287563833603e-10 + 0.20803065333333333333e-12 * t) * t) * t) * t) * t) * t;
}
case 93: {
double t = 2*y100 - 187;
return 0.74993321911726254661e0 + (0.16272790364044783382e-1 + (0.20195505163377912645e-3 + (0.18269894883203346953e-5 + (0.12335161021630225535e-7 + (0.61523068312169087227e-10 + 0.21395783431111111111e-12 * t) * t) * t) * t) * t) * t;
}
case 94: {
double t = 2*y100 - 189;
return 0.78330143531283492729e0 + (0.17102934132652429240e-1 + (0.21321800585063327041e-3 + (0.19281661395543913713e-5 + (0.12963340087354341574e-7 + (0.64126040998066348872e-10 + 0.21986708942222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 95: {
double t = 2*y100 - 191;
return 0.81837581041023811832e0 + (0.17979364149044223802e-1 + (0.22510330592753129006e-3 + (0.20344732868018175389e-5 + (0.13617902941839949718e-7 + (0.66799760083972474642e-10 + 0.22574701262222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 96: {
double t = 2*y100 - 193;
return 0.85525144775685126237e0 + (0.18904632212547561026e-1 + (0.23764237370371255638e-3 + (0.21461248251306387979e-5 + (0.14299555071870523786e-7 + (0.69543803864694171934e-10 + 0.23158593688888888889e-12 * t) * t) * t) * t) * t) * t;
}
case 97: {
double t = 2*y100 - 195;
return 0.89402868170849933734e0 + (0.19881418399127202569e-1 + (0.25086793128395995798e-3 + (0.22633402747585233180e-5 + (0.15008997042116532283e-7 + (0.72357609075043941261e-10 + 0.23737194737777777778e-12 * t) * t) * t) * t) * t) * t;
}
case 98: {
double t = 2*y100 - 197;
return 0.93481333942870796363e0 + (0.20912536329780368893e-1 + (0.26481403465998477969e-3 + (0.23863447359754921676e-5 + (0.15746923065472184451e-7 + (0.75240468141720143653e-10 + 0.24309291271111111111e-12 * t) * t) * t) * t) * t) * t;
}
case 99: {
double t = 2*y100 - 199;
return 0.97771701335885035464e0 + (0.22000938572830479551e-1 + (0.27951610702682383001e-3 + (0.25153688325245314530e-5 + (0.16514019547822821453e-7 + (0.78191526829368231251e-10 + 0.24873652355555555556e-12 * t) * t) * t) * t) * t) * t;
}
  }
  // we only get here if y = 1, i.e. |x| < 4*eps, in which case
  // erfcx is within 1e-15 of 1..
  return 1.0;
}

double FADDEEVA_RE(erfcx)(double x)
{
  if (x >= 0) {
    if (x > 50) { // continued-fraction expansion is faster
      const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
      if (x > 5e7) // 1-term expansion, important to avoid overflow
        return ispi / x;
      /* 5-term expansion (rely on compiler for CSE), simplified from:
                ispi / (x+0.5/(x+1/(x+1.5/(x+2/x))))  */
      return ispi*((x*x) * (x*x+4.5) + 2) / (x * ((x*x) * (x*x+5) + 3.75));
    }
    return erfcx_y100(400/(4+x));
  }
  else
    return x < -26.7 ? HUGE_VAL : (x < -6.1 ? 2*exp(x*x)
                                   : 2*exp(x*x) - erfcx_y100(400/(4-x)));
}

/////////////////////////////////////////////////////////////////////////
/* Compute a scaled Dawson integral
            FADDEEVA(w_im)(x) = 2*Dawson(x)/sqrt(pi)
   equivalent to the imaginary part w(x) for real x.

   Uses methods similar to the erfcx calculation above: continued fractions
   for large |x|, a lookup table of Chebyshev polynomials for smaller |x|,
   and finally a Taylor expansion for |x|<0.01.

   Steven G. Johnson, October 2012. */

/* Given y100=100*y, where y = 1/(1+x) for x >= 0, compute w_im(x).

   Uses a look-up table of 100 different Chebyshev polynomials
   for y intervals [0,0.01], [0.01,0.02], ...., [0.99,1], generated
   with the help of Maple and a little shell script.   This allows
   the Chebyshev polynomials to be of significantly lower degree (about 1/30)
   compared to fitting the whole [0,1] interval with a single polynomial. */
static double w_im_y100(double y100, double x) {
  switch ((int) y100) {
    case 0: {
      double t = 2*y100 - 1;
      return 0.28351593328822191546e-2 + (0.28494783221378400759e-2 + (0.14427470563276734183e-4 + (0.10939723080231588129e-6 + (0.92474307943275042045e-9 + (0.89128907666450075245e-11 + 0.92974121935111111110e-13 * t) * t) * t) * t) * t) * t;
    }
    case 1: {
      double t = 2*y100 - 3;
      return 0.85927161243940350562e-2 + (0.29085312941641339862e-2 + (0.15106783707725582090e-4 + (0.11716709978531327367e-6 + (0.10197387816021040024e-8 + (0.10122678863073360769e-10 + 0.10917479678400000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 2: {
      double t = 2*y100 - 5;
      return 0.14471159831187703054e-1 + (0.29703978970263836210e-2 + (0.15835096760173030976e-4 + (0.12574803383199211596e-6 + (0.11278672159518415848e-8 + (0.11547462300333495797e-10 + 0.12894535335111111111e-12 * t) * t) * t) * t) * t) * t;
    }
    case 3: {
      double t = 2*y100 - 7;
      return 0.20476320420324610618e-1 + (0.30352843012898665856e-2 + (0.16617609387003727409e-4 + (0.13525429711163116103e-6 + (0.12515095552507169013e-8 + (0.13235687543603382345e-10 + 0.15326595042666666667e-12 * t) * t) * t) * t) * t) * t;
    }
    case 4: {
      double t = 2*y100 - 9;
      return 0.26614461952489004566e-1 + (0.31034189276234947088e-2 + (0.17460268109986214274e-4 + (0.14582130824485709573e-6 + (0.13935959083809746345e-8 + (0.15249438072998932900e-10 + 0.18344741882133333333e-12 * t) * t) * t) * t) * t) * t;
    }
    case 5: {
      double t = 2*y100 - 11;
      return 0.32892330248093586215e-1 + (0.31750557067975068584e-2 + (0.18369907582308672632e-4 + (0.15761063702089457882e-6 + (0.15577638230480894382e-8 + (0.17663868462699097951e-10 + (0.22126732680711111111e-12 + 0.30273474177737853668e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 6: {
      double t = 2*y100 - 13;
      return 0.39317207681134336024e-1 + (0.32504779701937539333e-2 + (0.19354426046513400534e-4 + (0.17081646971321290539e-6 + (0.17485733959327106250e-8 + (0.20593687304921961410e-10 + (0.26917401949155555556e-12 + 0.38562123837725712270e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 7: {
      double t = 2*y100 - 15;
      return 0.45896976511367738235e-1 + (0.33300031273110976165e-2 + (0.20423005398039037313e-4 + (0.18567412470376467303e-6 + (0.19718038363586588213e-8 + (0.24175006536781219807e-10 + (0.33059982791466666666e-12 + 0.49756574284439426165e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 8: {
      double t = 2*y100 - 17;
      return 0.52640192524848962855e-1 + (0.34139883358846720806e-2 + (0.21586390240603337337e-4 + (0.20247136501568904646e-6 + (0.22348696948197102935e-8 + (0.28597516301950162548e-10 + (0.41045502119111111110e-12 + 0.65151614515238361946e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 9: {
      double t = 2*y100 - 19;
      return 0.59556171228656770456e-1 + (0.35028374386648914444e-2 + (0.22857246150998562824e-4 + (0.22156372146525190679e-6 + (0.25474171590893813583e-8 + (0.34122390890697400584e-10 + (0.51593189879111111110e-12 + 0.86775076853908006938e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 10: {
      double t = 2*y100 - 21;
      return 0.66655089485108212551e-1 + (0.35970095381271285568e-2 + (0.24250626164318672928e-4 + (0.24339561521785040536e-6 + (0.29221990406518411415e-8 + (0.41117013527967776467e-10 + (0.65786450716444444445e-12 + 0.11791885745450623331e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 11: {
      double t = 2*y100 - 23;
      return 0.73948106345519174661e-1 + (0.36970297216569341748e-2 + (0.25784588137312868792e-4 + (0.26853012002366752770e-6 + (0.33763958861206729592e-8 + (0.50111549981376976397e-10 + (0.85313857496888888890e-12 + 0.16417079927706899860e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 12: {
      double t = 2*y100 - 25;
      return 0.81447508065002963203e-1 + (0.38035026606492705117e-2 + (0.27481027572231851896e-4 + (0.29769200731832331364e-6 + (0.39336816287457655076e-8 + (0.61895471132038157624e-10 + (0.11292303213511111111e-11 + 0.23558532213703884304e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 13: {
      double t = 2*y100 - 27;
      return 0.89166884027582716628e-1 + (0.39171301322438946014e-2 + (0.29366827260422311668e-4 + (0.33183204390350724895e-6 + (0.46276006281647330524e-8 + (0.77692631378169813324e-10 + (0.15335153258844444444e-11 + 0.35183103415916026911e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 14: {
      double t = 2*y100 - 29;
      return 0.97121342888032322019e-1 + (0.40387340353207909514e-2 + (0.31475490395950776930e-4 + (0.37222714227125135042e-6 + (0.55074373178613809996e-8 + (0.99509175283990337944e-10 + (0.21552645758222222222e-11 + 0.55728651431872687605e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 15: {
      double t = 2*y100 - 31;
      return 0.10532778218603311137e0 + (0.41692873614065380607e-2 + (0.33849549774889456984e-4 + (0.42064596193692630143e-6 + (0.66494579697622432987e-8 + (0.13094103581931802337e-9 + (0.31896187409777777778e-11 + 0.97271974184476560742e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 16: {
      double t = 2*y100 - 33;
      return 0.11380523107427108222e0 + (0.43099572287871821013e-2 + (0.36544324341565929930e-4 + (0.47965044028581857764e-6 + (0.81819034238463698796e-8 + (0.17934133239549647357e-9 + (0.50956666166186293627e-11 + (0.18850487318190638010e-12 + 0.79697813173519853340e-14 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 17: {
      double t = 2*y100 - 35;
      return 0.12257529703447467345e0 + (0.44621675710026986366e-2 + (0.39634304721292440285e-4 + (0.55321553769873381819e-6 + (0.10343619428848520870e-7 + (0.26033830170470368088e-9 + (0.87743837749108025357e-11 + (0.34427092430230063401e-12 + 0.10205506615709843189e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 18: {
      double t = 2*y100 - 37;
      return 0.13166276955656699478e0 + (0.46276970481783001803e-2 + (0.43225026380496399310e-4 + (0.64799164020016902656e-6 + (0.13580082794704641782e-7 + (0.39839800853954313927e-9 + (0.14431142411840000000e-10 + 0.42193457308830027541e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 19: {
      double t = 2*y100 - 39;
      return 0.14109647869803356475e0 + (0.48088424418545347758e-2 + (0.47474504753352150205e-4 + (0.77509866468724360352e-6 + (0.18536851570794291724e-7 + (0.60146623257887570439e-9 + (0.18533978397305276318e-10 + (0.41033845938901048380e-13 - 0.46160680279304825485e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 20: {
      double t = 2*y100 - 41;
      return 0.15091057940548936603e0 + (0.50086864672004685703e-2 + (0.52622482832192230762e-4 + (0.95034664722040355212e-6 + (0.25614261331144718769e-7 + (0.80183196716888606252e-9 + (0.12282524750534352272e-10 + (-0.10531774117332273617e-11 - 0.86157181395039646412e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 21: {
      double t = 2*y100 - 43;
      return 0.16114648116017010770e0 + (0.52314661581655369795e-2 + (0.59005534545908331315e-4 + (0.11885518333915387760e-5 + (0.33975801443239949256e-7 + (0.82111547144080388610e-9 + (-0.12357674017312854138e-10 + (-0.24355112256914479176e-11 - 0.75155506863572930844e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 22: {
      double t = 2*y100 - 45;
      return 0.17185551279680451144e0 + (0.54829002967599420860e-2 + (0.67013226658738082118e-4 + (0.14897400671425088807e-5 + (0.40690283917126153701e-7 + (0.44060872913473778318e-9 + (-0.52641873433280000000e-10 - 0.30940587864543343124e-11 * t) * t) * t) * t) * t) * t) * t;
    }
    case 23: {
      double t = 2*y100 - 47;
      return 0.18310194559815257381e0 + (0.57701559375966953174e-2 + (0.76948789401735193483e-4 + (0.18227569842290822512e-5 + (0.41092208344387212276e-7 + (-0.44009499965694442143e-9 + (-0.92195414685628803451e-10 + (-0.22657389705721753299e-11 + 0.10004784908106839254e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 24: {
      double t = 2*y100 - 49;
      return 0.19496527191546630345e0 + (0.61010853144364724856e-2 + (0.88812881056342004864e-4 + (0.21180686746360261031e-5 + (0.30652145555130049203e-7 + (-0.16841328574105890409e-8 + (-0.11008129460612823934e-9 + (-0.12180794204544515779e-12 + 0.15703325634590334097e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 25: {
      double t = 2*y100 - 51;
      return 0.20754006813966575720e0 + (0.64825787724922073908e-2 + (0.10209599627522311893e-3 + (0.22785233392557600468e-5 + (0.73495224449907568402e-8 + (-0.29442705974150112783e-8 + (-0.94082603434315016546e-10 + (0.23609990400179321267e-11 + 0.14141908654269023788e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 26: {
      double t = 2*y100 - 53;
      return 0.22093185554845172146e0 + (0.69182878150187964499e-2 + (0.11568723331156335712e-3 + (0.22060577946323627739e-5 + (-0.26929730679360840096e-7 + (-0.38176506152362058013e-8 + (-0.47399503861054459243e-10 + (0.40953700187172127264e-11 + 0.69157730376118511127e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 27: {
      double t = 2*y100 - 55;
      return 0.23524827304057813918e0 + (0.74063350762008734520e-2 + (0.12796333874615790348e-3 + (0.18327267316171054273e-5 + (-0.66742910737957100098e-7 + (-0.40204740975496797870e-8 + (0.14515984139495745330e-10 + (0.44921608954536047975e-11 - 0.18583341338983776219e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 28: {
      double t = 2*y100 - 57;
      return 0.25058626331812744775e0 + (0.79377285151602061328e-2 + (0.13704268650417478346e-3 + (0.11427511739544695861e-5 + (-0.10485442447768377485e-6 + (-0.34850364756499369763e-8 + (0.72656453829502179208e-10 + (0.36195460197779299406e-11 - 0.84882136022200714710e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 29: {
      double t = 2*y100 - 59;
      return 0.26701724900280689785e0 + (0.84959936119625864274e-2 + (0.14112359443938883232e-3 + (0.17800427288596909634e-6 + (-0.13443492107643109071e-6 + (-0.23512456315677680293e-8 + (0.11245846264695936769e-9 + (0.19850501334649565404e-11 - 0.11284666134635050832e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 30: {
      double t = 2*y100 - 61;
      return 0.28457293586253654144e0 + (0.90581563892650431899e-2 + (0.13880520331140646738e-3 + (-0.97262302362522896157e-6 + (-0.15077100040254187366e-6 + (-0.88574317464577116689e-9 + (0.12760311125637474581e-9 + (0.20155151018282695055e-12 - 0.10514169375181734921e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 31: {
      double t = 2*y100 - 63;
      return 0.30323425595617385705e0 + (0.95968346790597422934e-2 + (0.12931067776725883939e-3 + (-0.21938741702795543986e-5 + (-0.15202888584907373963e-6 + (0.61788350541116331411e-9 + (0.11957835742791248256e-9 + (-0.12598179834007710908e-11 - 0.75151817129574614194e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 32: {
      double t = 2*y100 - 65;
      return 0.32292521181517384379e0 + (0.10082957727001199408e-1 + (0.11257589426154962226e-3 + (-0.33670890319327881129e-5 + (-0.13910529040004008158e-6 + (0.19170714373047512945e-8 + (0.94840222377720494290e-10 + (-0.21650018351795353201e-11 - 0.37875211678024922689e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 33: {
      double t = 2*y100 - 67;
      return 0.34351233557911753862e0 + (0.10488575435572745309e-1 + (0.89209444197248726614e-4 + (-0.43893459576483345364e-5 + (-0.11488595830450424419e-6 + (0.28599494117122464806e-8 + (0.61537542799857777779e-10 - 0.24935749227658002212e-11 * t) * t) * t) * t) * t) * t) * t;
    }
    case 34: {
      double t = 2*y100 - 69;
      return 0.36480946642143669093e0 + (0.10789304203431861366e-1 + (0.60357993745283076834e-4 + (-0.51855862174130669389e-5 + (-0.83291664087289801313e-7 + (0.33898011178582671546e-8 + (0.27082948188277716482e-10 + (-0.23603379397408694974e-11 + 0.19328087692252869842e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 35: {
      double t = 2*y100 - 71;
      return 0.38658679935694939199e0 + (0.10966119158288804999e-1 + (0.27521612041849561426e-4 + (-0.57132774537670953638e-5 + (-0.48404772799207914899e-7 + (0.35268354132474570493e-8 + (-0.32383477652514618094e-11 + (-0.19334202915190442501e-11 + 0.32333189861286460270e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 36: {
      double t = 2*y100 - 73;
      return 0.40858275583808707870e0 + (0.11006378016848466550e-1 + (-0.76396376685213286033e-5 + (-0.59609835484245791439e-5 + (-0.13834610033859313213e-7 + (0.33406952974861448790e-8 + (-0.26474915974296612559e-10 + (-0.13750229270354351983e-11 + 0.36169366979417390637e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 37: {
      double t = 2*y100 - 75;
      return 0.43051714914006682977e0 + (0.10904106549500816155e-1 + (-0.43477527256787216909e-4 + (-0.59429739547798343948e-5 + (0.17639200194091885949e-7 + (0.29235991689639918688e-8 + (-0.41718791216277812879e-10 + (-0.81023337739508049606e-12 + 0.33618915934461994428e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 38: {
      double t = 2*y100 - 77;
      return 0.45210428135559607406e0 + (0.10659670756384400554e-1 + (-0.78488639913256978087e-4 + (-0.56919860886214735936e-5 + (0.44181850467477733407e-7 + (0.23694306174312688151e-8 + (-0.49492621596685443247e-10 + (-0.31827275712126287222e-12 + 0.27494438742721623654e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 39: {
      double t = 2*y100 - 79;
      return 0.47306491195005224077e0 + (0.10279006119745977570e-1 + (-0.11140268171830478306e-3 + (-0.52518035247451432069e-5 + (0.64846898158889479518e-7 + (0.17603624837787337662e-8 + (-0.51129481592926104316e-10 + (0.62674584974141049511e-13 + 0.20055478560829935356e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 40: {
      double t = 2*y100 - 81;
      return 0.49313638965719857647e0 + (0.97725799114772017662e-2 + (-0.14122854267291533334e-3 + (-0.46707252568834951907e-5 + (0.79421347979319449524e-7 + (0.11603027184324708643e-8 + (-0.48269605844397175946e-10 + (0.32477251431748571219e-12 + 0.12831052634143527985e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 41: {
      double t = 2*y100 - 83;
      return 0.51208057433416004042e0 + (0.91542422354009224951e-2 + (-0.16726530230228647275e-3 + (-0.39964621752527649409e-5 + (0.88232252903213171454e-7 + (0.61343113364949928501e-9 + (-0.42516755603130443051e-10 + (0.47910437172240209262e-12 + 0.66784341874437478953e-14 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 42: {
      double t = 2*y100 - 85;
      return 0.52968945458607484524e0 + (0.84400880445116786088e-2 + (-0.18908729783854258774e-3 + (-0.32725905467782951931e-5 + (0.91956190588652090659e-7 + (0.14593989152420122909e-9 + (-0.35239490687644444445e-10 + 0.54613829888448694898e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 43: {
      double t = 2*y100 - 87;
      return 0.54578857454330070965e0 + (0.76474155195880295311e-2 + (-0.20651230590808213884e-3 + (-0.25364339140543131706e-5 + (0.91455367999510681979e-7 + (-0.23061359005297528898e-9 + (-0.27512928625244444444e-10 + 0.54895806008493285579e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 44: {
      double t = 2*y100 - 89;
      return 0.56023851910298493910e0 + (0.67938321739997196804e-2 + (-0.21956066613331411760e-3 + (-0.18181127670443266395e-5 + (0.87650335075416845987e-7 + (-0.51548062050366615977e-9 + (-0.20068462174044444444e-10 + 0.50912654909758187264e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 45: {
      double t = 2*y100 - 91;
      return 0.57293478057455721150e0 + (0.58965321010394044087e-2 + (-0.22841145229276575597e-3 + (-0.11404605562013443659e-5 + (0.81430290992322326296e-7 + (-0.71512447242755357629e-9 + (-0.13372664928000000000e-10 + 0.44461498336689298148e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 46: {
      double t = 2*y100 - 93;
      return 0.58380635448407827360e0 + (0.49717469530842831182e-2 + (-0.23336001540009645365e-3 + (-0.51952064448608850822e-6 + (0.73596577815411080511e-7 + (-0.84020916763091566035e-9 + (-0.76700972702222222221e-11 + 0.36914462807972467044e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 47: {
      double t = 2*y100 - 95;
      return 0.59281340237769489597e0 + (0.40343592069379730568e-2 + (-0.23477963738658326185e-3 + (0.34615944987790224234e-7 + (0.64832803248395814574e-7 + (-0.90329163587627007971e-9 + (-0.30421940400000000000e-11 + 0.29237386653743536669e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 48: {
      double t = 2*y100 - 97;
      return 0.59994428743114271918e0 + (0.30976579788271744329e-2 + (-0.23308875765700082835e-3 + (0.51681681023846925160e-6 + (0.55694594264948268169e-7 + (-0.91719117313243464652e-9 + (0.53982743680000000000e-12 + 0.22050829296187771142e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 49: {
      double t = 2*y100 - 99;
      return 0.60521224471819875444e0 + (0.21732138012345456060e-2 + (-0.22872428969625997456e-3 + (0.92588959922653404233e-6 + (0.46612665806531930684e-7 + (-0.89393722514414153351e-9 + (0.31718550353777777778e-11 + 0.15705458816080549117e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 50: {
      double t = 2*y100 - 101;
      return 0.60865189969791123620e0 + (0.12708480848877451719e-2 + (-0.22212090111534847166e-3 + (0.12636236031532793467e-5 + (0.37904037100232937574e-7 + (-0.84417089968101223519e-9 + (0.49843180828444444445e-11 + 0.10355439441049048273e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 51: {
      double t = 2*y100 - 103;
      return 0.61031580103499200191e0 + (0.39867436055861038223e-3 + (-0.21369573439579869291e-3 + (0.15339402129026183670e-5 + (0.29787479206646594442e-7 + (-0.77687792914228632974e-9 + (0.61192452741333333334e-11 + 0.60216691829459295780e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 52: {
      double t = 2*y100 - 105;
      return 0.61027109047879835868e0 + (-0.43680904508059878254e-3 + (-0.20383783788303894442e-3 + (0.17421743090883439959e-5 + (0.22400425572175715576e-7 + (-0.69934719320045128997e-9 + (0.67152759655111111110e-11 + 0.26419960042578359995e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 53: {
      double t = 2*y100 - 107;
      return 0.60859639489217430521e0 + (-0.12305921390962936873e-2 + (-0.19290150253894682629e-3 + (0.18944904654478310128e-5 + (0.15815530398618149110e-7 + (-0.61726850580964876070e-9 + 0.68987888999111111110e-11 * t) * t) * t) * t) * t) * t;
    }
    case 54: {
      double t = 2*y100 - 109;
      return 0.60537899426486075181e0 + (-0.19790062241395705751e-2 + (-0.18120271393047062253e-3 + (0.19974264162313241405e-5 + (0.10055795094298172492e-7 + (-0.53491997919318263593e-9 + (0.67794550295111111110e-11 - 0.17059208095741511603e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 55: {
      double t = 2*y100 - 111;
      return 0.60071229457904110537e0 + (-0.26795676776166354354e-2 + (-0.16901799553627508781e-3 + (0.20575498324332621581e-5 + (0.51077165074461745053e-8 + (-0.45536079828057221858e-9 + (0.64488005516444444445e-11 - 0.29311677573152766338e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 56: {
      double t = 2*y100 - 113;
      return 0.59469361520112714738e0 + (-0.33308208190600993470e-2 + (-0.15658501295912405679e-3 + (0.20812116912895417272e-5 + (0.93227468760614182021e-9 + (-0.38066673740116080415e-9 + (0.59806790359111111110e-11 - 0.36887077278950440597e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 57: {
      double t = 2*y100 - 115;
      return 0.58742228631775388268e0 + (-0.39321858196059227251e-2 + (-0.14410441141450122535e-3 + (0.20743790018404020716e-5 + (-0.25261903811221913762e-8 + (-0.31212416519526924318e-9 + (0.54328422462222222221e-11 - 0.40864152484979815972e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 58: {
      double t = 2*y100 - 117;
      return 0.57899804200033018447e0 + (-0.44838157005618913447e-2 + (-0.13174245966501437965e-3 + (0.20425306888294362674e-5 + (-0.53330296023875447782e-8 + (-0.25041289435539821014e-9 + (0.48490437205333333334e-11 - 0.42162206939169045177e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 59: {
      double t = 2*y100 - 119;
      return 0.56951968796931245974e0 + (-0.49864649488074868952e-2 + (-0.11963416583477567125e-3 + (0.19906021780991036425e-5 + (-0.75580140299436494248e-8 + (-0.19576060961919820491e-9 + (0.42613011928888888890e-11 - 0.41539443304115604377e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 60: {
      double t = 2*y100 - 121;
      return 0.55908401930063918964e0 + (-0.54413711036826877753e-2 + (-0.10788661102511914628e-3 + (0.19229663322982839331e-5 + (-0.92714731195118129616e-8 + (-0.14807038677197394186e-9 + (0.36920870298666666666e-11 - 0.39603726688419162617e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 61: {
      double t = 2*y100 - 123;
      return 0.54778496152925675315e0 + (-0.58501497933213396670e-2 + (-0.96582314317855227421e-4 + (0.18434405235069270228e-5 + (-0.10541580254317078711e-7 + (-0.10702303407788943498e-9 + (0.31563175582222222222e-11 - 0.36829748079110481422e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 62: {
      double t = 2*y100 - 125;
      return 0.53571290831682823999e0 + (-0.62147030670760791791e-2 + (-0.85782497917111760790e-4 + (0.17553116363443470478e-5 + (-0.11432547349815541084e-7 + (-0.72157091369041330520e-10 + (0.26630811607111111111e-11 - 0.33578660425893164084e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 63: {
      double t = 2*y100 - 127;
      return 0.52295422962048434978e0 + (-0.65371404367776320720e-2 + (-0.75530164941473343780e-4 + (0.16613725797181276790e-5 + (-0.12003521296598910761e-7 + (-0.42929753689181106171e-10 + (0.22170894940444444444e-11 - 0.30117697501065110505e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 64: {
      double t = 2*y100 - 129;
      return 0.50959092577577886140e0 + (-0.68197117603118591766e-2 + (-0.65852936198953623307e-4 + (0.15639654113906716939e-5 + (-0.12308007991056524902e-7 + (-0.18761997536910939570e-10 + (0.18198628922666666667e-11 - 0.26638355362285200932e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 65: {
      double t = 2*y100 - 131;
      return 0.49570040481823167970e0 + (-0.70647509397614398066e-2 + (-0.56765617728962588218e-4 + (0.14650274449141448497e-5 + (-0.12393681471984051132e-7 + (0.92904351801168955424e-12 + (0.14706755960177777778e-11 - 0.23272455351266325318e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 66: {
      double t = 2*y100 - 133;
      return 0.48135536250935238066e0 + (-0.72746293327402359783e-2 + (-0.48272489495730030780e-4 + (0.13661377309113939689e-5 + (-0.12302464447599382189e-7 + (0.16707760028737074907e-10 + (0.11672928324444444444e-11 - 0.20105801424709924499e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 67: {
      double t = 2*y100 - 135;
      return 0.46662374675511439448e0 + (-0.74517177649528487002e-2 + (-0.40369318744279128718e-4 + (0.12685621118898535407e-5 + (-0.12070791463315156250e-7 + (0.29105507892605823871e-10 + (0.90653314645333333334e-12 - 0.17189503312102982646e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 68: {
      double t = 2*y100 - 137;
      return 0.45156879030168268778e0 + (-0.75983560650033817497e-2 + (-0.33045110380705139759e-4 + (0.11732956732035040896e-5 + (-0.11729986947158201869e-7 + (0.38611905704166441308e-10 + (0.68468768305777777779e-12 - 0.14549134330396754575e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 69: {
      double t = 2*y100 - 139;
      return 0.43624909769330896904e0 + (-0.77168291040309554679e-2 + (-0.26283612321339907756e-4 + (0.10811018836893550820e-5 + (-0.11306707563739851552e-7 + (0.45670446788529607380e-10 + (0.49782492549333333334e-12 - 0.12191983967561779442e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 70: {
      double t = 2*y100 - 141;
      return 0.42071877443548481181e0 + (-0.78093484015052730097e-2 + (-0.20064596897224934705e-4 + (0.99254806680671890766e-6 + (-0.10823412088884741451e-7 + (0.50677203326904716247e-10 + (0.34200547594666666666e-12 - 0.10112698698356194618e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 71: {
      double t = 2*y100 - 143;
      return 0.40502758809710844280e0 + (-0.78780384460872937555e-2 + (-0.14364940764532853112e-4 + (0.90803709228265217384e-6 + (-0.10298832847014466907e-7 + (0.53981671221969478551e-10 + (0.21342751381333333333e-12 - 0.82975901848387729274e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 72: {
      double t = 2*y100 - 145;
      return 0.38922115269731446690e0 + (-0.79249269708242064120e-2 + (-0.91595258799106970453e-5 + (0.82783535102217576495e-6 + (-0.97484311059617744437e-8 + (0.55889029041660225629e-10 + (0.10851981336888888889e-12 - 0.67278553237853459757e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 73: {
      double t = 2*y100 - 147;
      return 0.37334112915460307335e0 + (-0.79519385109223148791e-2 + (-0.44219833548840469752e-5 + (0.75209719038240314732e-6 + (-0.91848251458553190451e-8 + (0.56663266668051433844e-10 + (0.23995894257777777778e-13 - 0.53819475285389344313e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 74: {
      double t = 2*y100 - 149;
      return 0.35742543583374223085e0 + (-0.79608906571527956177e-2 + (-0.12530071050975781198e-6 + (0.68088605744900552505e-6 + (-0.86181844090844164075e-8 + (0.56530784203816176153e-10 + (-0.43120012248888888890e-13 - 0.42372603392496813810e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 75: {
      double t = 2*y100 - 151;
      return 0.34150846431979618536e0 + (-0.79534924968773806029e-2 + (0.37576885610891515813e-5 + (0.61419263633090524326e-6 + (-0.80565865409945960125e-8 + (0.55684175248749269411e-10 + (-0.95486860764444444445e-13 - 0.32712946432984510595e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 76: {
      double t = 2*y100 - 153;
      return 0.32562129649136346824e0 + (-0.79313448067948884309e-2 + (0.72539159933545300034e-5 + (0.55195028297415503083e-6 + (-0.75063365335570475258e-8 + (0.54281686749699595941e-10 - 0.13545424295111111111e-12 * t) * t) * t) * t) * t) * t;
    }
    case 77: {
      double t = 2*y100 - 155;
      return 0.30979191977078391864e0 + (-0.78959416264207333695e-2 + (0.10389774377677210794e-4 + (0.49404804463196316464e-6 + (-0.69722488229411164685e-8 + (0.52469254655951393842e-10 - 0.16507860650666666667e-12 * t) * t) * t) * t) * t) * t;
    }
    case 78: {
      double t = 2*y100 - 157;
      return 0.29404543811214459904e0 + (-0.78486728990364155356e-2 + (0.13190885683106990459e-4 + (0.44034158861387909694e-6 + (-0.64578942561562616481e-8 + (0.50354306498006928984e-10 - 0.18614473550222222222e-12 * t) * t) * t) * t) * t) * t;
    }
    case 79: {
      double t = 2*y100 - 159;
      return 0.27840427686253660515e0 + (-0.77908279176252742013e-2 + (0.15681928798708548349e-4 + (0.39066226205099807573e-6 + (-0.59658144820660420814e-8 + (0.48030086420373141763e-10 - 0.20018995173333333333e-12 * t) * t) * t) * t) * t) * t;
    }
    case 80: {
      double t = 2*y100 - 161;
      return 0.26288838011163800908e0 + (-0.77235993576119469018e-2 + (0.17886516796198660969e-4 + (0.34482457073472497720e-6 + (-0.54977066551955420066e-8 + (0.45572749379147269213e-10 - 0.20852924954666666667e-12 * t) * t) * t) * t) * t) * t;
    }
    case 81: {
      double t = 2*y100 - 163;
      return 0.24751539954181029717e0 + (-0.76480877165290370975e-2 + (0.19827114835033977049e-4 + (0.30263228619976332110e-6 + (-0.50545814570120129947e-8 + (0.43043879374212005966e-10 - 0.21228012028444444444e-12 * t) * t) * t) * t) * t) * t;
    }
    case 82: {
      double t = 2*y100 - 165;
      return 0.23230087411688914593e0 + (-0.75653060136384041587e-2 + (0.21524991113020016415e-4 + (0.26388338542539382413e-6 + (-0.46368974069671446622e-8 + (0.40492715758206515307e-10 - 0.21238627815111111111e-12 * t) * t) * t) * t) * t) * t;
    }
    case 83: {
      double t = 2*y100 - 167;
      return 0.21725840021297341931e0 + (-0.74761846305979730439e-2 + (0.23000194404129495243e-4 + (0.22837400135642906796e-6 + (-0.42446743058417541277e-8 + (0.37958104071765923728e-10 - 0.20963978568888888889e-12 * t) * t) * t) * t) * t) * t;
    }
    case 84: {
      double t = 2*y100 - 169;
      return 0.20239979200788191491e0 + (-0.73815761980493466516e-2 + (0.24271552727631854013e-4 + (0.19590154043390012843e-6 + (-0.38775884642456551753e-8 + (0.35470192372162901168e-10 - 0.20470131678222222222e-12 * t) * t) * t) * t) * t) * t;
    }
    case 85: {
      double t = 2*y100 - 171;
      return 0.18773523211558098962e0 + (-0.72822604530339834448e-2 + (0.25356688567841293697e-4 + (0.16626710297744290016e-6 + (-0.35350521468015310830e-8 + (0.33051896213898864306e-10 - 0.19811844544000000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 86: {
      double t = 2*y100 - 173;
      return 0.17327341258479649442e0 + (-0.71789490089142761950e-2 + (0.26272046822383820476e-4 + (0.13927732375657362345e-6 + (-0.32162794266956859603e-8 + (0.30720156036105652035e-10 - 0.19034196304000000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 87: {
      double t = 2*y100 - 175;
      return 0.15902166648328672043e0 + (-0.70722899934245504034e-2 + (0.27032932310132226025e-4 + (0.11474573347816568279e-6 + (-0.29203404091754665063e-8 + (0.28487010262547971859e-10 - 0.18174029063111111111e-12 * t) * t) * t) * t) * t) * t;
    }
    case 88: {
      double t = 2*y100 - 177;
      return 0.14498609036610283865e0 + (-0.69628725220045029273e-2 + (0.27653554229160596221e-4 + (0.92493727167393036470e-7 + (-0.26462055548683583849e-8 + (0.26360506250989943739e-10 - 0.17261211260444444444e-12 * t) * t) * t) * t) * t) * t;
    }
    case 89: {
      double t = 2*y100 - 179;
      return 0.13117165798208050667e0 + (-0.68512309830281084723e-2 + (0.28147075431133863774e-4 + (0.72351212437979583441e-7 + (-0.23927816200314358570e-8 + (0.24345469651209833155e-10 - 0.16319736960000000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 90: {
      double t = 2*y100 - 181;
      return 0.11758232561160626306e0 + (-0.67378491192463392927e-2 + (0.28525664781722907847e-4 + (0.54156999310046790024e-7 + (-0.21589405340123827823e-8 + (0.22444150951727334619e-10 - 0.15368675584000000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 91: {
      double t = 2*y100 - 183;
      return 0.10422112945361673560e0 + (-0.66231638959845581564e-2 + (0.28800551216363918088e-4 + (0.37758983397952149613e-7 + (-0.19435423557038933431e-8 + (0.20656766125421362458e-10 - 0.14422990012444444444e-12 * t) * t) * t) * t) * t) * t;
    }
    case 92: {
      double t = 2*y100 - 185;
      return 0.91090275493541084785e-1 + (-0.65075691516115160062e-2 + (0.28982078385527224867e-4 + (0.23014165807643012781e-7 + (-0.17454532910249875958e-8 + (0.18981946442680092373e-10 - 0.13494234691555555556e-12 * t) * t) * t) * t) * t) * t;
    }
    case 93: {
      double t = 2*y100 - 187;
      return 0.78191222288771379358e-1 + (-0.63914190297303976434e-2 + (0.29079759021299682675e-4 + (0.97885458059415717014e-8 + (-0.15635596116134296819e-8 + (0.17417110744051331974e-10 - 0.12591151763555555556e-12 * t) * t) * t) * t) * t) * t;
    }
    case 94: {
      double t = 2*y100 - 189;
      return 0.65524757106147402224e-1 + (-0.62750311956082444159e-2 + (0.29102328354323449795e-4 + (-0.20430838882727954582e-8 + (-0.13967781903855367270e-8 + (0.15958771833747057569e-10 - 0.11720175765333333333e-12 * t) * t) * t) * t) * t) * t;
    }
    case 95: {
      double t = 2*y100 - 191;
      return 0.53091065838453612773e-1 + (-0.61586898417077043662e-2 + (0.29057796072960100710e-4 + (-0.12597414620517987536e-7 + (-0.12440642607426861943e-8 + (0.14602787128447932137e-10 - 0.10885859114666666667e-12 * t) * t) * t) * t) * t) * t;
    }
    case 96: {
      double t = 2*y100 - 193;
      return 0.40889797115352738582e-1 + (-0.60426484889413678200e-2 + (0.28953496450191694606e-4 + (-0.21982952021823718400e-7 + (-0.11044169117553026211e-8 + (0.13344562332430552171e-10 - 0.10091231402844444444e-12 * t) * t) * t) * t) * t) * t;
    }
  case 97: case 98:
  case 99: case 100: { // use Taylor expansion for small x (|x| <= 0.0309...)
      //  (2/sqrt(pi)) * (x - 2/3 x^3  + 4/15 x^5  - 8/105 x^7 + 16/945 x^9)
      double x2 = x*x;
      return x * (1.1283791670955125739
                  - x2 * (0.75225277806367504925
                          - x2 * (0.30090111122547001970
                                  - x2 * (0.085971746064420005629
                                          - x2 * 0.016931216931216931217))));
    }
  }
  /* Since 0 <= y100 < 101, this is only reached if x is NaN,
     in which case we should return NaN. */
  return NaN;
}

double FADDEEVA(w_im)(double x)
{
  if (x >= 0) {
    if (x > 45) { // continued-fraction expansion is faster
      const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
      if (x > 5e7) // 1-term expansion, important to avoid overflow
        return ispi / x;
      /* 5-term expansion (rely on compiler for CSE), simplified from:
                ispi / (x-0.5/(x-1/(x-1.5/(x-2/x))))  */
      return ispi*((x*x) * (x*x-4.5) + 2) / (x * ((x*x) * (x*x-5) + 3.75));
    }
    return w_im_y100(100/(1+x), x);
  }
  else { // = -FADDEEVA(w_im)(-x)
    if (x < -45) { // continued-fraction expansion is faster
      const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
      if (x < -5e7) // 1-term expansion, important to avoid overflow
        return ispi / x;
      /* 5-term expansion (rely on compiler for CSE), simplified from:
                ispi / (x-0.5/(x-1/(x-1.5/(x-2/x))))  */
      return ispi*((x*x) * (x*x-4.5) + 2) / (x * ((x*x) * (x*x-5) + 3.75));
    }
    return -w_im_y100(100/(1-x), -x);
  }
}

/////////////////////////////////////////////////////////////////////////

// Compile with -DTEST_FADDEEVA to compile a little test program
#ifdef TEST_FADDEEVA

#ifdef __cplusplus
#  include <cstdio>
#else
#  include <stdio.h>
#endif

// compute relative error |b-a|/|a|, handling case of NaN and Inf,
static double relerr(double a, double b) {
  if (isnan(a) || isnan(b) || isinf(a) || isinf(b)) {
    if ((isnan(a) && !isnan(b)) || (!isnan(a) && isnan(b)) ||
        (isinf(a) && !isinf(b)) || (!isinf(a) && isinf(b)) ||
        (isinf(a) && isinf(b) && a*b < 0))
      return Inf; // "infinite" error
    return 0; // matching infinity/nan results counted as zero error
  }
  if (a == 0)
    return b == 0 ? 0 : Inf;
  else
    return fabs((b-a) / a);
}

int main(void) {
  double errmax_all = 0;
  {
    printf("############# w(z) tests #############\n");
#define NTST 57 // define instead of const for C compatibility
    cmplx z[NTST] = {
      C(624.2,-0.26123),
      C(-0.4,3.),
      C(0.6,2.),
      C(-1.,1.),
      C(-1.,-9.),
      C(-1.,9.),
      C(-0.0000000234545,1.1234),
      C(-3.,5.1),
      C(-53,30.1),
      C(0.0,0.12345),
      C(11,1),
      C(-22,-2),
      C(9,-28),
      C(21,-33),
      C(1e5,1e5),
      C(1e14,1e14),
      C(-3001,-1000),
      C(1e160,-1e159),
      C(-6.01,0.01),
      C(-0.7,-0.7),
      C(2.611780000000000e+01, 4.540909610972489e+03),
      C(0.8e7,0.3e7),
      C(-20,-19.8081),
      C(1e-16,-1.1e-16),
      C(2.3e-8,1.3e-8),
      C(6.3,-1e-13),
      C(6.3,1e-20),
      C(1e-20,6.3),
      C(1e-20,16.3),
      C(9,1e-300),
      C(6.01,0.11),
      C(8.01,1.01e-10),
      C(28.01,1e-300),
      C(10.01,1e-200),
      C(10.01,-1e-200),
      C(10.01,0.99e-10),
      C(10.01,-0.99e-10),
      C(1e-20,7.01),
      C(-1,7.01),
      C(5.99,7.01),
      C(1,0),
      C(55,0),
      C(-0.1,0),
      C(1e-20,0),
      C(0,5e-14),
      C(0,51),
      C(Inf,0),
      C(-Inf,0),
      C(0,Inf),
      C(0,-Inf),
      C(Inf,Inf),
      C(Inf,-Inf),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,Inf),
      C(Inf,NaN)
    };
    cmplx w[NTST] = { /* w(z), computed with WolframAlpha
                                   ... note that WolframAlpha is problematic
                                   some of the above inputs, so I had to
                                   use the continued-fraction expansion
                                   in WolframAlpha in some cases, or switch
                                   to Maple */
      C(-3.78270245518980507452677445620103199303131110e-7,
        0.000903861276433172057331093754199933411710053155),
      C(0.1764906227004816847297495349730234591778719532788,
        -0.02146550539468457616788719893991501311573031095617),
      C(0.2410250715772692146133539023007113781272362309451,
        0.06087579663428089745895459735240964093522265589350),
      C(0.30474420525691259245713884106959496013413834051768,
        -0.20821893820283162728743734725471561394145872072738),
      C(7.317131068972378096865595229600561710140617977e34,
        8.321873499714402777186848353320412813066170427e34),
      C(0.0615698507236323685519612934241429530190806818395,
        -0.00676005783716575013073036218018565206070072304635),
      C(0.3960793007699874918961319170187598400134746631,
        -5.593152259116644920546186222529802777409274656e-9),
      C(0.08217199226739447943295069917990417630675021771804,
        -0.04701291087643609891018366143118110965272615832184),
      C(0.00457246000350281640952328010227885008541748668738,
        -0.00804900791411691821818731763401840373998654987934),
      C(0.8746342859608052666092782112565360755791467973338452,
        0.),
      C(0.00468190164965444174367477874864366058339647648741,
        0.0510735563901306197993676329845149741675029197050),
      C(-0.0023193175200187620902125853834909543869428763219,
        -0.025460054739731556004902057663500272721780776336),
      C(9.11463368405637174660562096516414499772662584e304,
        3.97101807145263333769664875189354358563218932e305),
      C(-4.4927207857715598976165541011143706155432296e281,
        -2.8019591213423077494444700357168707775769028e281),
      C(2.820947917809305132678577516325951485807107151e-6,
        2.820947917668257736791638444590253942253354058e-6),
      C(2.82094791773878143474039725787438662716372268e-15,
        2.82094791773878143474039725773333923127678361e-15),
      C(-0.0000563851289696244350147899376081488003110150498,
        -0.000169211755126812174631861529808288295454992688),
      C(-5.586035480670854326218608431294778077663867e-162,
        5.586035480670854326218608431294778077663867e-161),
      C(0.00016318325137140451888255634399123461580248456,
        -0.095232456573009287370728788146686162555021209999),
      C(0.69504753678406939989115375989939096800793577783885,
        -1.8916411171103639136680830887017670616339912024317),
      C(0.0001242418269653279656612334210746733213167234822,
        7.145975826320186888508563111992099992116786763e-7),
      C(2.318587329648353318615800865959225429377529825e-8,
        6.182899545728857485721417893323317843200933380e-8),
      C(-0.0133426877243506022053521927604277115767311800303,
        -0.0148087097143220769493341484176979826888871576145),
      C(1.00000000000000012412170838050638522857747934,
        1.12837916709551279389615890312156495593616433e-16),
      C(0.9999999853310704677583504063775310832036830015,
        2.595272024519678881897196435157270184030360773e-8),
      C(-1.4731421795638279504242963027196663601154624e-15,
        0.090727659684127365236479098488823462473074709),
      C(5.79246077884410284575834156425396800754409308e-18,
        0.0907276596841273652364790985059772809093822374),
      C(0.0884658993528521953466533278764830881245144368,
        1.37088352495749125283269718778582613192166760e-22),
      C(0.0345480845419190424370085249304184266813447878,
        2.11161102895179044968099038990446187626075258e-23),
      C(6.63967719958073440070225527042829242391918213e-36,
        0.0630820900592582863713653132559743161572639353),
      C(0.00179435233208702644891092397579091030658500743634,
        0.0951983814805270647939647438459699953990788064762),
      C(9.09760377102097999924241322094863528771095448e-13,
        0.0709979210725138550986782242355007611074966717),
      C(7.2049510279742166460047102593255688682910274423e-304,
        0.0201552956479526953866611812593266285000876784321),
      C(3.04543604652250734193622967873276113872279682e-44,
        0.0566481651760675042930042117726713294607499165),
      C(3.04543604652250734193622967873276113872279682e-44,
        0.0566481651760675042930042117726713294607499165),
      C(0.5659928732065273429286988428080855057102069081e-12,
        0.056648165176067504292998527162143030538756683302),
      C(-0.56599287320652734292869884280802459698927645e-12,
        0.0566481651760675042929985271621430305387566833029),
      C(0.0796884251721652215687859778119964009569455462,
        1.11474461817561675017794941973556302717225126e-22),
      C(0.07817195821247357458545539935996687005781943386550,
        -0.01093913670103576690766705513142246633056714279654),
      C(0.04670032980990449912809326141164730850466208439937,
        0.03944038961933534137558064191650437353429669886545),
      C(0.36787944117144232159552377016146086744581113103176,
        0.60715770584139372911503823580074492116122092866515),
      C(0,
        0.010259688805536830986089913987516716056946786526145),
      C(0.99004983374916805357390597718003655777207908125383,
        -0.11208866436449538036721343053869621153527769495574),
      C(0.99999999999999999999999999999999999999990000,
        1.12837916709551257389615890312154517168802603e-20),
      C(0.999999999999943581041645226871305192054749891144158,
        0),
      C(0.0110604154853277201542582159216317923453996211744250,
        0),
      C(0,0),
      C(0,0),
      C(0,0),
      C(Inf,0),
      C(0,0),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,0),
      C(NaN,NaN),
      C(NaN,NaN)
    };
    double errmax = 0;
    for (int i = 0; i < NTST; ++i) {
      cmplx fw = FADDEEVA(w)(z[i],0.);
      double re_err = relerr(creal(w[i]), creal(fw));
      double im_err = relerr(cimag(w[i]), cimag(fw));
      printf("w(%g%+gi) = %g%+gi (vs. %g%+gi), re/im rel. err. = %0.2g/%0.2g)\n",
             creal(z[i]),cimag(z[i]), creal(fw),cimag(fw), creal(w[i]),cimag(w[i]),
             re_err, im_err);
      if (re_err > errmax) errmax = re_err;
      if (im_err > errmax) errmax = im_err;
    }
    if (errmax > 1e-13) {
      printf("FAILURE -- relative error %g too large!\n", errmax);
      return 1;
    }
    printf("SUCCESS (max relative error = %g)\n", errmax);
    if (errmax > errmax_all) errmax_all = errmax;
  }
  {
#undef NTST
#define NTST 41 // define instead of const for C compatibility
    cmplx z[NTST] = {
      C(1,2),
      C(-1,2),
      C(1,-2),
      C(-1,-2),
      C(9,-28),
      C(21,-33),
      C(1e3,1e3),
      C(-3001,-1000),
      C(1e160,-1e159),
      C(5.1e-3, 1e-8),
      C(-4.9e-3, 4.95e-3),
      C(4.9e-3, 0.5),
      C(4.9e-4, -0.5e1),
      C(-4.9e-5, -0.5e2),
      C(5.1e-3, 0.5),
      C(5.1e-4, -0.5e1),
      C(-5.1e-5, -0.5e2),
      C(1e-6,2e-6),
      C(0,2e-6),
      C(0,2),
      C(0,20),
      C(0,200),
      C(Inf,0),
      C(-Inf,0),
      C(0,Inf),
      C(0,-Inf),
      C(Inf,Inf),
      C(Inf,-Inf),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,Inf),
      C(Inf,NaN),
      C(1e-3,NaN),
      C(7e-2,7e-2),
      C(7e-2,-7e-4),
      C(-9e-2,7e-4),
      C(-9e-2,9e-2),
      C(-7e-4,9e-2),
      C(7e-2,0.9e-2),
      C(7e-2,1.1e-2)
    };
    cmplx w[NTST] = { // erf(z[i]), evaluated with Maple
      C(-0.5366435657785650339917955593141927494421,
        -5.049143703447034669543036958614140565553),
      C(0.5366435657785650339917955593141927494421,
        -5.049143703447034669543036958614140565553),
      C(-0.5366435657785650339917955593141927494421,
        5.049143703447034669543036958614140565553),
      C(0.5366435657785650339917955593141927494421,
        5.049143703447034669543036958614140565553),
      C(0.3359473673830576996788000505817956637777e304,
        -0.1999896139679880888755589794455069208455e304),
      C(0.3584459971462946066523939204836760283645e278,
        0.3818954885257184373734213077678011282505e280),
      C(0.9996020422657148639102150147542224526887,
        0.00002801044116908227889681753993542916894856),
      C(-1, 0),
      C(1, 0),
      C(0.005754683859034800134412990541076554934877,
        0.1128349818335058741511924929801267822634e-7),
      C(-0.005529149142341821193633460286828381876955,
        0.005585388387864706679609092447916333443570),
      C(0.007099365669981359632319829148438283865814,
        0.6149347012854211635026981277569074001219),
      C(0.3981176338702323417718189922039863062440e8,
        -0.8298176341665249121085423917575122140650e10),
      C(-Inf,
        -Inf),
      C(0.007389128308257135427153919483147229573895,
        0.6149332524601658796226417164791221815139),
      C(0.4143671923267934479245651547534414976991e8,
        -0.8298168216818314211557046346850921446950e10),
      C(-Inf,
        -Inf),
      C(0.1128379167099649964175513742247082845155e-5,
        0.2256758334191777400570377193451519478895e-5),
      C(0,
        0.2256758334194034158904576117253481476197e-5),
      C(0,
        18.56480241457555259870429191324101719886),
      C(0,
        0.1474797539628786202447733153131835124599e173),
      C(0,
        Inf),
      C(1,0),
      C(-1,0),
      C(0,Inf),
      C(0,-Inf),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,NaN),
      C(0.07924380404615782687930591956705225541145,
        0.07872776218046681145537914954027729115247),
      C(0.07885775828512276968931773651224684454495,
        -0.0007860046704118224342390725280161272277506),
      C(-0.1012806432747198859687963080684978759881,
        0.0007834934747022035607566216654982820299469),
      C(-0.1020998418798097910247132140051062512527,
        0.1010030778892310851309082083238896270340),
      C(-0.0007962891763147907785684591823889484764272,
        0.1018289385936278171741809237435404896152),
      C(0.07886408666470478681566329888615410479530,
        0.01010604288780868961492224347707949372245),
      C(0.07886723099940260286824654364807981336591,
        0.01235199327873258197931147306290916629654)
    };
#define TST(f,isc)                                                      \
    printf("############# " #f "(z) tests #############\n");            \
    double errmax = 0;                                                  \
    for (int i = 0; i < NTST; ++i) {                                    \
      cmplx fw = FADDEEVA(f)(z[i],0.);                  \
      double re_err = relerr(creal(w[i]), creal(fw));                   \
      double im_err = relerr(cimag(w[i]), cimag(fw));                   \
      printf(#f "(%g%+gi) = %g%+gi (vs. %g%+gi), re/im rel. err. = %0.2g/%0.2g)\n", \
             creal(z[i]),cimag(z[i]), creal(fw),cimag(fw), creal(w[i]),cimag(w[i]), \
             re_err, im_err);                                           \
      if (re_err > errmax) errmax = re_err;                             \
      if (im_err > errmax) errmax = im_err;                             \
    }                                                                   \
    if (errmax > 1e-13) {                                               \
      printf("FAILURE -- relative error %g too large!\n", errmax);      \
      return 1;                                                         \
    }                                                                   \
    printf("Checking " #f "(x) special case...\n");                     \
    for (int i = 0; i < 10000; ++i) {                                   \
      double x = pow(10., -300. + i * 600. / (10000 - 1));              \
      double re_err = relerr(FADDEEVA_RE(f)(x),                         \
                             creal(FADDEEVA(f)(C(x,x*isc),0.)));        \
      if (re_err > errmax) errmax = re_err;                             \
      re_err = relerr(FADDEEVA_RE(f)(-x),                               \
                      creal(FADDEEVA(f)(C(-x,x*isc),0.)));              \
      if (re_err > errmax) errmax = re_err;                             \
    }                                                                   \
    {                                                                   \
      double re_err = relerr(FADDEEVA_RE(f)(Inf),                       \
                             creal(FADDEEVA(f)(C(Inf,0.),0.))); \
      if (re_err > errmax) errmax = re_err;                             \
      re_err = relerr(FADDEEVA_RE(f)(-Inf),                             \
                      creal(FADDEEVA(f)(C(-Inf,0.),0.)));               \
      if (re_err > errmax) errmax = re_err;                             \
      re_err = relerr(FADDEEVA_RE(f)(NaN),                              \
                      creal(FADDEEVA(f)(C(NaN,0.),0.)));                \
      if (re_err > errmax) errmax = re_err;                             \
    }                                                                   \
    if (errmax > 1e-13) {                                               \
      printf("FAILURE -- relative error %g too large!\n", errmax);      \
      return 1;                                                         \
    }                                                                   \
    printf("SUCCESS (max relative error = %g)\n", errmax);              \
    if (errmax > errmax_all) errmax_all = errmax

    TST(erf, 1e-20);
  }
  {
    // since erfi just calls through to erf, just one test should
    // be sufficient to make sure I didn't screw up the signs or something
#undef NTST
#define NTST 1 // define instead of const for C compatibility
    cmplx z[NTST] = { C(1.234,0.5678) };
    cmplx w[NTST] = { // erfi(z[i]), computed with Maple
      C(1.081032284405373149432716643834106923212,
        1.926775520840916645838949402886591180834)
    };
    TST(erfi, 0);
  }
  {
    // since erfcx just calls through to w, just one test should
    // be sufficient to make sure I didn't screw up the signs or something
#undef NTST
#define NTST 1 // define instead of const for C compatibility
    cmplx z[NTST] = { C(1.234,0.5678) };
    cmplx w[NTST] = { // erfcx(z[i]), computed with Maple
      C(0.3382187479799972294747793561190487832579,
        -0.1116077470811648467464927471872945833154)
    };
    TST(erfcx, 0);
  }
  {
#undef NTST
#define NTST 30 // define instead of const for C compatibility
    cmplx z[NTST] = {
      C(1,2),
      C(-1,2),
      C(1,-2),
      C(-1,-2),
      C(9,-28),
      C(21,-33),
      C(1e3,1e3),
      C(-3001,-1000),
      C(1e160,-1e159),
      C(5.1e-3, 1e-8),
      C(0,2e-6),
      C(0,2),
      C(0,20),
      C(0,200),
      C(2e-6,0),
      C(2,0),
      C(20,0),
      C(200,0),
      C(Inf,0),
      C(-Inf,0),
      C(0,Inf),
      C(0,-Inf),
      C(Inf,Inf),
      C(Inf,-Inf),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,Inf),
      C(Inf,NaN),
      C(88,0)
    };
    cmplx w[NTST] = { // erfc(z[i]), evaluated with Maple
      C(1.536643565778565033991795559314192749442,
        5.049143703447034669543036958614140565553),
      C(0.4633564342214349660082044406858072505579,
        5.049143703447034669543036958614140565553),
      C(1.536643565778565033991795559314192749442,
        -5.049143703447034669543036958614140565553),
      C(0.4633564342214349660082044406858072505579,
        -5.049143703447034669543036958614140565553),
      C(-0.3359473673830576996788000505817956637777e304,
        0.1999896139679880888755589794455069208455e304),
      C(-0.3584459971462946066523939204836760283645e278,
        -0.3818954885257184373734213077678011282505e280),
      C(0.0003979577342851360897849852457775473112748,
        -0.00002801044116908227889681753993542916894856),
      C(2, 0),
      C(0, 0),
      C(0.9942453161409651998655870094589234450651,
        -0.1128349818335058741511924929801267822634e-7),
      C(1,
        -0.2256758334194034158904576117253481476197e-5),
      C(1,
        -18.56480241457555259870429191324101719886),
      C(1,
        -0.1474797539628786202447733153131835124599e173),
      C(1, -Inf),
      C(0.9999977432416658119838633199332831406314,
        0),
      C(0.004677734981047265837930743632747071389108,
        0),
      C(0.5395865611607900928934999167905345604088e-175,
        0),
      C(0, 0),
      C(0, 0),
      C(2, 0),
      C(1, -Inf),
      C(1, Inf),
      C(NaN, NaN),
      C(NaN, NaN),
      C(NaN, NaN),
      C(NaN, 0),
      C(1, NaN),
      C(NaN, NaN),
      C(NaN, NaN),
      C(0,0)
    };
    TST(erfc, 1e-20);
  }
  {
#undef NTST
#define NTST 48 // define instead of const for C compatibility
    cmplx z[NTST] = {
      C(2,1),
      C(-2,1),
      C(2,-1),
      C(-2,-1),
      C(-28,9),
      C(33,-21),
      C(1e3,1e3),
      C(-1000,-3001),
      C(1e-8, 5.1e-3),
      C(4.95e-3, -4.9e-3),
      C(5.1e-3, 5.1e-3),
      C(0.5, 4.9e-3),
      C(-0.5e1, 4.9e-4),
      C(-0.5e2, -4.9e-5),
      C(0.5e3, 4.9e-6),
      C(0.5, 5.1e-3),
      C(-0.5e1, 5.1e-4),
      C(-0.5e2, -5.1e-5),
      C(1e-6,2e-6),
      C(2e-6,0),
      C(2,0),
      C(20,0),
      C(200,0),
      C(0,4.9e-3),
      C(0,-5.1e-3),
      C(0,2e-6),
      C(0,-2),
      C(0,20),
      C(0,-200),
      C(Inf,0),
      C(-Inf,0),
      C(0,Inf),
      C(0,-Inf),
      C(Inf,Inf),
      C(Inf,-Inf),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,Inf),
      C(Inf,NaN),
      C(39, 6.4e-5),
      C(41, 6.09e-5),
      C(4.9e7, 5e-11),
      C(5.1e7, 4.8e-11),
      C(1e9, 2.4e-12),
      C(1e11, 2.4e-14),
      C(1e13, 2.4e-16),
      C(1e300, 2.4e-303)
    };
    cmplx w[NTST] = { // dawson(z[i]), evaluated with Maple
      C(0.1635394094345355614904345232875688576839,
        -0.1531245755371229803585918112683241066853),
      C(-0.1635394094345355614904345232875688576839,
        -0.1531245755371229803585918112683241066853),
      C(0.1635394094345355614904345232875688576839,
        0.1531245755371229803585918112683241066853),
      C(-0.1635394094345355614904345232875688576839,
        0.1531245755371229803585918112683241066853),
      C(-0.01619082256681596362895875232699626384420,
        -0.005210224203359059109181555401330902819419),
      C(0.01078377080978103125464543240346760257008,
        0.006866888783433775382193630944275682670599),
      C(-0.5808616819196736225612296471081337245459,
        0.6688593905505562263387760667171706325749),
      C(Inf,
        -Inf),
      C(0.1000052020902036118082966385855563526705e-7,
        0.005100088434920073153418834680320146441685),
      C(0.004950156837581592745389973960217444687524,
        -0.004899838305155226382584756154100963570500),
      C(0.005100176864319675957314822982399286703798,
        0.005099823128319785355949825238269336481254),
      C(0.4244534840871830045021143490355372016428,
        0.002820278933186814021399602648373095266538),
      C(-0.1021340733271046543881236523269967674156,
        -0.00001045696456072005761498961861088944159916),
      C(-0.01000200120119206748855061636187197886859,
        0.9805885888237419500266621041508714123763e-8),
      C(0.001000002000012000023960527532953151819595,
        -0.9800058800588007290937355024646722133204e-11),
      C(0.4244549085628511778373438768121222815752,
        0.002935393851311701428647152230552122898291),
      C(-0.1021340732357117208743299813648493928105,
        -0.00001088377943049851799938998805451564893540),
      C(-0.01000200120119126652710792390331206563616,
        0.1020612612857282306892368985525393707486e-7),
      C(0.1000000000007333333333344266666666664457e-5,
        0.2000000000001333333333323199999999978819e-5),
      C(0.1999999999994666666666675199999999990248e-5,
        0),
      C(0.3013403889237919660346644392864226952119,
        0),
      C(0.02503136792640367194699495234782353186858,
        0),
      C(0.002500031251171948248596912483183760683918,
        0),
      C(0,0.004900078433419939164774792850907128053308),
      C(0,-0.005100088434920074173454208832365950009419),
      C(0,0.2000000000005333333333341866666666676419e-5),
      C(0,-48.16001211429122974789822893525016528191),
      C(0,0.4627407029504443513654142715903005954668e174),
      C(0,-Inf),
      C(0,0),
      C(-0,0),
      C(0, Inf),
      C(0, -Inf),
      C(NaN, NaN),
      C(NaN, NaN),
      C(NaN, NaN),
      C(NaN, 0),
      C(0, NaN),
      C(NaN, NaN),
      C(NaN, NaN),
      C(0.01282473148489433743567240624939698290584,
        -0.2105957276516618621447832572909153498104e-7),
      C(0.01219875253423634378984109995893708152885,
        -0.1813040560401824664088425926165834355953e-7),
      C(0.1020408163265306334945473399689037886997e-7,
        -0.1041232819658476285651490827866174985330e-25),
      C(0.9803921568627452865036825956835185367356e-8,
        -0.9227220299884665067601095648451913375754e-26),
      C(0.5000000000000000002500000000000000003750e-9,
        -0.1200000000000000001800000188712838420241e-29),
      C(5.00000000000000000000025000000000000000000003e-12,
        -1.20000000000000000000018000000000000000000004e-36),
      C(5.00000000000000000000000002500000000000000000e-14,
        -1.20000000000000000000000001800000000000000000e-42),
      C(5e-301, 0)
    };
    TST(Dawson, 1e-20);
  }
  printf("#####################################\n");
  printf("SUCCESS (max relative error = %g)\n", errmax_all);
}

#endif

#endif

//end file: faddeeva_mit.h


#endif /* XFIELDS_FADDEEVA_H */


// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2023.                   //
// ########################################### //

#ifndef XFIELDS_BIGAUSSIAN_H
#define XFIELDS_BIGAUSSIAN_H


// for quick test with gcc
//#include "constants.h" //only_for_context none
//#include "faddeeva.h" //only_for_context none
//#include "complex_error_function.h" //only_for_context none
//#include "compute_gx_gy.h" //only_for_context none

//from file: compute_gx_gy.h

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_COMPUTE_GX_GY
#define XFIELDS_COMPUTE_GX_GY

 static inline void compute_Gx_Gy(
        const double x,
        const double y,
        const double sigma_x,
        const double sigma_y,
        const double min_sigma_diff,
        const double Ex,
        const double Ey,
        double* Gx_ptr,
        double* Gy_ptr) {

    double Gx, Gy;

    if (fabs(sigma_x-sigma_y) < min_sigma_diff) {
        const double sigma = 0.5 * (sigma_x+sigma_y);
        if ((x*x + y*y) < 1e-14) {
            Gx = 1./(8 * PI * EPSILON_0 * sigma * sigma);
            Gy = Gx;
        }
	    else {
            Gx = 1/(2.*(x*x+y*y))*(y*Ey-x*Ex+1./(2*PI*EPSILON_0*sigma*sigma)
                    *x*x*exp(-(x*x+y*y)/(2.*sigma*sigma)));
            Gy = 1./(2*(x*x+y*y))*(x*Ex-y*Ey+1./(2*PI*EPSILON_0*sigma*sigma)
                    *y*y*exp(-(x*x+y*y)/(2.*sigma*sigma)));
	    }
    }
    else {
        const double Sig_11 = sigma_x*sigma_x;
        const double Sig_33 = sigma_y*sigma_y;

        Gx = -1./(2*(Sig_11-Sig_33))*(x*Ex+y*Ey+1./(2*PI*EPSILON_0)
                *(sigma_y/sigma_x*exp(-x*x/(2*Sig_11)-y*y/(2*Sig_33))-1.));
        Gy = 1./(2*(Sig_11-Sig_33))*(x*Ex+y*Ey+1./(2*PI*EPSILON_0)*
                (sigma_x/sigma_y*exp(-x*x/(2*Sig_11)-y*y/(2*Sig_33))-1.));

    }

    *Gx_ptr = Gx;
    *Gy_ptr = Gy;
}

#endif //XFIELDS_COMPUTE_GX_GY

//end file: compute_gx_gy.h


 static inline
void get_charge_density(const double x,
                      const double y,
                      const double sigma_x,
                      const double sigma_y,
                      double* rho)
{

  // this is a PDF
  double factor = 1 / (2*PI*sigma_x*sigma_y);
  double exp_x = exp(-x*x/(2*sigma_x*sigma_x));
  double exp_y = exp(-y*y/(2*sigma_y*sigma_y));
  *rho = factor * exp_x * exp_y;  // [m^-2]
}

 static inline
void get_transv_field_gauss_round(
    double sigma, double Delta_x, double Delta_y,
    double x, double y,
    double* Ex,
    double* Ey)
{
  double r2, temp;

  r2 = (x-Delta_x)*(x-Delta_x)+(y-Delta_y)*(y-Delta_y);
  double const inv_sig2 = 1./(sigma*sigma);
  double const r2_sig2 = r2 * inv_sig2;
  if (r2_sig2<1e-10) temp = inv_sig2/(4.*PI*EPSILON_0); //linearised
  else temp = inv_sig2 * (1-exp(-0.5*r2_sig2))/(2.*PI*EPSILON_0*r2_sig2);

  (*Ex) = temp * (x-Delta_x);
  (*Ey) = temp * (y-Delta_y);
}

 static inline
void get_transv_field_gauss_ellip(
        double sigma_x,  double sigma_y,
        double Delta_x,  double Delta_y,
        const double x,
	const double y,
        double* Ex_out,
        double* Ey_out)
{
  double sigmax = sigma_x;
  double sigmay = sigma_y;

  // I always go to the first quadrant and then apply the signs a posteriori
  // numerically more stable (see http://inspirehep.net/record/316705/files/slac-pub-5582.pdf)

  double abx = fabs(x - Delta_x);
  double aby = fabs(y - Delta_y);

  double S, factBE, Ex, Ey;
  double etaBE_re, etaBE_im, zetaBE_re, zetaBE_im;
  double w_etaBE_re, w_etaBE_im, w_zetaBE_re, w_zetaBE_im;
  double expBE;


  if (sigmax>sigmay){
    S = sqrt(2.*(sigmax*sigmax-sigmay*sigmay));
    factBE = 1./(2.*EPSILON_0*SQRT_PI*S);

    etaBE_re = sigmay/sigmax*abx;
    etaBE_im = sigmax/sigmay*aby;

    zetaBE_re = abx;
    zetaBE_im = aby;

    //w_zetaBE_re, w_zetaBE_im = wfun(zetaBE_re/S, zetaBE_im/S)
    faddeeva_w(zetaBE_re/S, zetaBE_im/S , &(w_zetaBE_re), &(w_zetaBE_im));

    //w_etaBE_re, w_etaBE_im = wfun(etaBE_re/S, etaBE_im/S)
    faddeeva_w(etaBE_re/S, etaBE_im/S , &(w_etaBE_re), &(w_etaBE_im));

    expBE = exp(-abx*abx/(2*sigmax*sigmax)-aby*aby/(2*sigmay*sigmay));

    Ex = factBE*(w_zetaBE_im - w_etaBE_im*expBE);
    Ey = factBE*(w_zetaBE_re - w_etaBE_re*expBE);

  }
  else if (sigmax<sigmay){
    S = sqrt(2.*(sigmay*sigmay-sigmax*sigmax));
    factBE = 1./(2.*EPSILON_0*SQRT_PI*S);

    etaBE_re = sigmax/sigmay*aby;
    etaBE_im = sigmay/sigmax*abx;

    zetaBE_re = aby;
    zetaBE_im = abx;

    //w_zetaBE_re, w_zetaBE_im = wfun(zetaBE_re/S, zetaBE_im/S)
    faddeeva_w(zetaBE_re/S, zetaBE_im/S , &(w_zetaBE_re), &(w_zetaBE_im));

    //w_etaBE_re, w_etaBE_im = wfun(etaBE_re/S, etaBE_im/S)
    faddeeva_w(etaBE_re/S, etaBE_im/S , &(w_etaBE_re), &(w_etaBE_im));

    expBE = exp(-aby*aby/(2*sigmay*sigmay)-abx*abx/(2*sigmax*sigmax));

    Ey = factBE*(w_zetaBE_im - w_etaBE_im*expBE);
    Ex = factBE*(w_zetaBE_re - w_etaBE_re*expBE);

  }
  else{
    Ex = Ey = 0.;
  }

  if((x - Delta_x)<0) Ex=-Ex;
  if((y - Delta_y)<0) Ey=-Ey;

  (*Ex_out) = Ex;
  (*Ey_out) = Ey;
}

 static inline
void get_Ex_Ey_gauss(
             const double  x,
             const double  y,
             const double  sigma_x,
             const double  sigma_y,
             const double  min_sigma_diff,
             double* Ex_ptr,
             double* Ey_ptr){

        // round beam
	if (fabs(sigma_x-sigma_y)< min_sigma_diff){
	    double sigma = 0.5*(sigma_x+sigma_y);
	    	get_transv_field_gauss_round(sigma, 0., 0., x, y, Ex_ptr, Ey_ptr);
	}

        // elliptical beam
	else{
	    get_transv_field_gauss_ellip(
	            sigma_x, sigma_y, 0., 0., x, y, Ex_ptr, Ey_ptr);

	}
}

#endif // XFIELDS_BIGAUSSIAN_H

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_BEAMBEAM_H
#define XFIELDS_BEAMBEAM_H

#if !defined(mysign)
    #define mysign(a) (((a) >= 0) - ((a) < 0))
#endif

 static inline
void BeamBeamBiGaussian2D_track_local_particle(
        BeamBeamBiGaussian2DData el, LocalParticle* part0){

    double const ref_shift_x = BeamBeamBiGaussian2DData_get_ref_shift_x(el);
    double const ref_shift_y = BeamBeamBiGaussian2DData_get_ref_shift_y(el);

    double const other_beam_shift_x = BeamBeamBiGaussian2DData_get_other_beam_shift_x(el);
    double const other_beam_shift_y = BeamBeamBiGaussian2DData_get_other_beam_shift_y(el);

    double const scale_strength = BeamBeamBiGaussian2DData_get_scale_strength(el);
    double const post_subtract_px = scale_strength*BeamBeamBiGaussian2DData_get_post_subtract_px(el);
    double const post_subtract_py = scale_strength*BeamBeamBiGaussian2DData_get_post_subtract_py(el);

    double const other_beam_q0 = scale_strength*BeamBeamBiGaussian2DData_get_other_beam_q0(el);
    double const other_beam_beta0 = BeamBeamBiGaussian2DData_get_other_beam_beta0(el);

    double const other_beam_num_particles = BeamBeamBiGaussian2DData_get_other_beam_num_particles(el);

    double const other_beam_Sigma_11 = BeamBeamBiGaussian2DData_get_other_beam_Sigma_11(el);
    double const other_beam_Sigma_13 = BeamBeamBiGaussian2DData_get_other_beam_Sigma_13(el);
    double const other_beam_Sigma_33 = BeamBeamBiGaussian2DData_get_other_beam_Sigma_33(el);

    double const min_sigma_diff = BeamBeamBiGaussian2DData_get_min_sigma_diff(el);


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp


        double const x = LocalParticle_get_x(part);
        double const y = LocalParticle_get_y(part);
        double const part_q0 = LocalParticle_get_q0(part);
        double const part_mass0 = LocalParticle_get_mass0(part);
        double const part_chi = LocalParticle_get_chi(part);
        double const part_beta0 = LocalParticle_get_beta0(part);
        double const part_gamma0 = LocalParticle_get_gamma0(part);

        double const x_bar = x - ref_shift_x - other_beam_shift_x;
        double const y_bar = y - ref_shift_y - other_beam_shift_y;

        // Move to rotated frame to account for transverse coupling (if needed)
        double x_hat, y_hat, costheta, sintheta, Sig_11_hat, Sig_33_hat;
        if (fabs(other_beam_Sigma_13) > 1e-13) {
            double const R = other_beam_Sigma_11 - other_beam_Sigma_33;
            double const W = other_beam_Sigma_11 + other_beam_Sigma_33;
            double const T = R * R + 4 * other_beam_Sigma_13 * other_beam_Sigma_13;
            double const sqrtT = sqrt(T);
            double const signR = mysign(R);
            double const cos2theta = signR*R/sqrtT;
            costheta = sqrt(0.5*(1.+cos2theta));
            sintheta = signR*mysign(other_beam_Sigma_13)*sqrt(0.5*(1.-cos2theta));
            x_hat = x_bar*costheta +y_bar*sintheta;
            y_hat = -x_bar*sintheta +y_bar*costheta;
            Sig_11_hat = 0.5*(W+signR*sqrtT);
            Sig_33_hat = 0.5*(W-signR*sqrtT);
        }
        else{
            sintheta = 0;
            costheta = 1;
            x_hat = x_bar;
            y_hat = y_bar;
            Sig_11_hat = other_beam_Sigma_11;
            Sig_33_hat = other_beam_Sigma_33;
        }

        // Get transverse fields
        double Ex, Ey; // Ex = -dphi/dx, Ey = -dphi/dy
        get_Ex_Ey_gauss(x_hat, y_hat,
            sqrt(Sig_11_hat), sqrt(Sig_33_hat),
            min_sigma_diff,
            &Ex, &Ey);

        const double charge_mass_ratio = part_chi*QELEM*part_q0
                    /(part_mass0*QELEM/(C_LIGHT*C_LIGHT));
        const double factor = (charge_mass_ratio
                    * other_beam_num_particles * other_beam_q0 * QELEM
                    / (part_gamma0*part_beta0*C_LIGHT*C_LIGHT)
                    * (1+other_beam_beta0 * part_beta0)
                    / (other_beam_beta0 + part_beta0));

        double const dpx_hat = factor * Ex;
        double const dpy_hat = factor * Ey;

        double const dpx = dpx_hat*costheta - dpy_hat*sintheta;
        double const dpy = dpx_hat*sintheta + dpy_hat*costheta;

        LocalParticle_add_to_px(part, dpx - post_subtract_px);
        LocalParticle_add_to_py(part, dpy - post_subtract_py);


//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


}

#endif


             static inline
            void BeamBeamBiGaussian2D_track_local_particle_with_transformations(BeamBeamBiGaussian2DData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = BeamBeamBiGaussian2DData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamBeamBiGaussian2DData_get__cos_rot_s(el);
    double const shift_x = BeamBeamBiGaussian2DData_get__shift_x(el);
    double const shift_y = BeamBeamBiGaussian2DData_get__shift_y(el);
    double const shift_s = BeamBeamBiGaussian2DData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    BeamBeamBiGaussian2D_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamBeamBiGaussian2DData_get__cos_rot_s(el);
    double const shift_x = BeamBeamBiGaussian2DData_get__shift_x(el);
    double const shift_y = BeamBeamBiGaussian2DData_get__shift_y(el);
    double const shift_s = BeamBeamBiGaussian2DData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void BeamBeamBiGaussian2D_track_particles(
               BeamBeamBiGaussian2DData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              BeamBeamBiGaussian2D_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ZetaShiftData
#define XOBJ_TYPEDEF_ZetaShiftData
typedef   struct ZetaShiftData_s * ZetaShiftData;
 static inline ZetaShiftData ZetaShiftData_getp(ZetaShiftData restrict  obj){
  int64_t offset=0;
  return (ZetaShiftData)(( char*) obj+offset);
}
 static inline double ZetaShiftData_get_dzeta(const ZetaShiftData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void ZetaShiftData_set_dzeta(ZetaShiftData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ZetaShiftData_getp_dzeta(ZetaShiftData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/zetashift.h>

             static inline
            void ZetaShift_track_local_particle_with_transformations(ZetaShiftData el, LocalParticle* part0){
    ZetaShift_track_local_particle(el, part0);
}


             
            void ZetaShift_track_particles(
               ZetaShiftData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ZetaShift_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ParticlesMonitorData
#define XOBJ_TYPEDEF_ParticlesMonitorData
typedef   struct ParticlesMonitorData_s * ParticlesMonitorData;
 static inline ParticlesMonitorData ParticlesMonitorData_getp(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  return (ParticlesMonitorData)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_start_at_turn(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_start_at_turn(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_start_at_turn(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_stop_at_turn(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_stop_at_turn(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_stop_at_turn(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_part_id_start(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_part_id_start(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_part_id_start(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_part_id_end(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_part_id_end(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_part_id_end(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_ebe_mode(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_ebe_mode(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_ebe_mode(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_n_records(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_n_records(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_n_records(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_n_repetitions(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_n_repetitions(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_n_repetitions(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_repetition_period(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_repetition_period(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_repetition_period(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_flag_auto_to_numpy(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_flag_auto_to_numpy(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_flag_auto_to_numpy(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ParticlesData ParticlesMonitorData_getp_data(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return (ParticlesData)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_data__capacity(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data__capacity(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=128;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_data__capacity(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_data__num_active_particles(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data__num_active_particles(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=136;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_data__num_active_particles(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_data__num_lost_particles(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data__num_lost_particles(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_data__num_lost_particles(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_data_start_tracking_at_element(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_start_tracking_at_element(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_data_start_tracking_at_element(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get_data_q0(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_q0(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp_data_q0(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get_data_mass0(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_mass0(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp_data_mass0(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get_data_t_sim(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_t_sim(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=176;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp_data_t_sim(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_p0c(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=432;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_p0c(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=432;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_p0c(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=432;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_p0c(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=432;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_p0c(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=432;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_gamma0(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_gamma0(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_gamma0(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_gamma0(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_gamma0(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_beta0(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_beta0(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+72);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_beta0(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_beta0(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_beta0(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_s(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_s(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+80);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_s(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_s(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_s(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_zeta(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_zeta(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+88);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_zeta(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_zeta(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_zeta(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_x(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_x(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+96);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_x(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_x(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_x(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_y(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_y(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+104);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_y(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_y(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_y(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_px(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_px(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+112);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_px(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_px(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_px(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_py(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_py(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+120);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_py(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_py(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_py(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_ptau(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_ptau(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+128);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_ptau(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_ptau(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_ptau(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_delta(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_delta(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+136);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_delta(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_delta(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_delta(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_rpp(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_rpp(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+144);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_rpp(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_rpp(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_rpp(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_rvv(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_rvv(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+152);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_rvv(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_rvv(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_rvv(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_chi(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_chi(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_chi(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_chi(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_chi(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_charge_ratio(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_charge_ratio(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+168);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_charge_ratio(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_charge_ratio(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_charge_ratio(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_weight(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_weight(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+176);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_weight(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_weight(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_weight(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_ax(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_ax(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+184);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_ax(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_ax(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_ax(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_ay(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_ay(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+192);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_ay(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_ay(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_ay(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_spin_x(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_spin_x(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+200);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_spin_x(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_spin_x(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_spin_x(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_spin_y(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_spin_y(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+208);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_spin_y(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_spin_y(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_spin_y(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_spin_z(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_spin_z(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+216);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_spin_z(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_spin_z(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_spin_z(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_anomalous_magnetic_moment(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_anomalous_magnetic_moment(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+224);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_anomalous_magnetic_moment(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_anomalous_magnetic_moment(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_anomalous_magnetic_moment(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesMonitorData_getp_data_pdg_id(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_pdg_id(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+232);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesMonitorData_get_data_pdg_id(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_pdg_id(ParticlesMonitorData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp1_data_pdg_id(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesMonitorData_getp_data_particle_id(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_particle_id(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+240);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesMonitorData_get_data_particle_id(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_particle_id(ParticlesMonitorData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp1_data_particle_id(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesMonitorData_getp_data_at_element(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_at_element(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+248);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesMonitorData_get_data_at_element(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_at_element(ParticlesMonitorData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp1_data_at_element(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesMonitorData_getp_data_at_turn(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_at_turn(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+256);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesMonitorData_get_data_at_turn(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_at_turn(ParticlesMonitorData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp1_data_at_turn(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesMonitorData_getp_data_state(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_state(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesMonitorData_get_data_state(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_state(ParticlesMonitorData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp1_data_state(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesMonitorData_getp_data_parent_particle_id(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_parent_particle_id(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesMonitorData_get_data_parent_particle_id(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_parent_particle_id(ParticlesMonitorData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp1_data_parent_particle_id(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesMonitorData_getp_data__rng_s1(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data__rng_s1(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+280);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesMonitorData_get_data__rng_s1(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data__rng_s1(ParticlesMonitorData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesMonitorData_getp1_data__rng_s1(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesMonitorData_getp_data__rng_s2(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data__rng_s2(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+288);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesMonitorData_get_data__rng_s2(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data__rng_s2(ParticlesMonitorData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesMonitorData_getp1_data__rng_s2(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesMonitorData_getp_data__rng_s3(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data__rng_s3(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+296);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesMonitorData_get_data__rng_s3(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data__rng_s3(ParticlesMonitorData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesMonitorData_getp1_data__rng_s3(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesMonitorData_getp_data__rng_s4(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data__rng_s4(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+304);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesMonitorData_get_data__rng_s4(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data__rng_s4(ParticlesMonitorData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesMonitorData_getp1_data__rng_s4(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get__sin_rot_s(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set__sin_rot_s(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp__sin_rot_s(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get__cos_rot_s(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set__cos_rot_s(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp__cos_rot_s(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get__shift_x(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set__shift_x(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp__shift_x(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get__shift_y(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set__shift_y(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp__shift_y(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get__shift_s(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set__shift_s(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp__shift_s(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_MONITORS_H
#define XTRACK_MONITORS_H

#include <headers/track.h>


GPUFUN
void ParticlesMonitor_track_local_particle(ParticlesMonitorData el,
                       LocalParticle* part0){

    int64_t const start_at_turn = ParticlesMonitorData_get_start_at_turn(el);
    int64_t const stop_at_turn = ParticlesMonitorData_get_stop_at_turn(el);
    int64_t const part_id_start = ParticlesMonitorData_get_part_id_start(el);
    int64_t const part_id_end= ParticlesMonitorData_get_part_id_end(el);
    int64_t const ebe_mode = ParticlesMonitorData_get_ebe_mode(el);
    int64_t const n_repetitions = ParticlesMonitorData_get_n_repetitions(el);
    int64_t const repetition_period = ParticlesMonitorData_get_repetition_period(el);
    ParticlesData data = ParticlesMonitorData_getp_data(el);

    int64_t n_turns_record = stop_at_turn - start_at_turn;

    START_PER_PARTICLE_BLOCK(part0, part);
        int64_t at_turn;
        if (ebe_mode){
            at_turn = LocalParticle_get_at_element(part);
        }
        else{
            #ifdef XSUITE_BACKTRACK
            return; // do not log (only ebe monitor supported for now in backtrack)
            #else
            at_turn = LocalParticle_get_at_turn(part);
            #endif
        }
        if (n_repetitions == 1){
            if (at_turn>=start_at_turn && at_turn<stop_at_turn){
                int64_t const particle_id = LocalParticle_get_particle_id(part);
                if (particle_id<part_id_end && particle_id>=part_id_start){
                    int64_t const store_at =
                        n_turns_record * (particle_id - part_id_start)
                        + at_turn - start_at_turn;
                    LocalParticle_to_Particles(part, data, store_at, 0);
                }
            }
        }
        else if (n_repetitions > 1){
            if (at_turn < start_at_turn){
//                return; //only_for_context cuda opencl
                break; //only_for_context cpu_serial cpu_openmp
            }
            int64_t const i_frame = (at_turn - start_at_turn) / repetition_period;
            if (i_frame < n_repetitions
                     && at_turn >= start_at_turn + i_frame*repetition_period
                     && at_turn < stop_at_turn + i_frame*repetition_period
                 ){
                int64_t const particle_id = LocalParticle_get_particle_id(part);
                if (particle_id<part_id_end && particle_id>=part_id_start){
                    int64_t const store_at =
                        n_turns_record * (part_id_end  - part_id_start) * i_frame
                        + n_turns_record * (particle_id - part_id_start)
                        + (at_turn - i_frame * repetition_period) - start_at_turn;
                    LocalParticle_to_Particles(part, data, store_at, 0);
                }
            }
        }

        #ifdef XSUITE_RESTORE_LOSS
        LocalParticle_set_state(part, 1);
        #endif
    END_PER_PARTICLE_BLOCK;
}

#endif




             static inline
            void ParticlesMonitor_track_local_particle_with_transformations(ParticlesMonitorData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ParticlesMonitorData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ParticlesMonitorData_get__cos_rot_s(el);
    double const shift_x = ParticlesMonitorData_get__shift_x(el);
    double const shift_y = ParticlesMonitorData_get__shift_y(el);
    double const shift_s = ParticlesMonitorData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ParticlesMonitor_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ParticlesMonitorData_get__cos_rot_s(el);
    double const shift_x = ParticlesMonitorData_get__shift_x(el);
    double const shift_y = ParticlesMonitorData_get__shift_y(el);
    double const shift_s = ParticlesMonitorData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ParticlesMonitor_track_particles(
               ParticlesMonitorData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ParticlesMonitor_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_LimitRectData
#define XOBJ_TYPEDEF_LimitRectData
typedef   struct LimitRectData_s * LimitRectData;
 static inline LimitRectData LimitRectData_getp(LimitRectData restrict  obj){
  int64_t offset=0;
  return (LimitRectData)(( char*) obj+offset);
}
 static inline double LimitRectData_get_min_x(const LimitRectData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set_min_x(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp_min_x(LimitRectData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get_max_x(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set_max_x(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp_max_x(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get_min_y(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set_min_y(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp_min_y(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get_max_y(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set_max_y(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp_max_y(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get__sin_rot_s(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set__sin_rot_s(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp__sin_rot_s(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get__cos_rot_s(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set__cos_rot_s(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp__cos_rot_s(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get__shift_x(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set__shift_x(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp__shift_x(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get__shift_y(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set__shift_y(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp__shift_y(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get__shift_s(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set__shift_s(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp__shift_s(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/apertures_src/limitrect.h>

             static inline
            void LimitRect_track_local_particle_with_transformations(LimitRectData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LimitRectData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitRectData_get__cos_rot_s(el);
    double const shift_x = LimitRectData_get__shift_x(el);
    double const shift_y = LimitRectData_get__shift_y(el);
    double const shift_s = LimitRectData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LimitRect_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitRectData_get__cos_rot_s(el);
    double const shift_x = LimitRectData_get__shift_x(el);
    double const shift_y = LimitRectData_get__shift_y(el);
    double const shift_s = LimitRectData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LimitRect_track_particles(
               LimitRectData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LimitRect_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_SpaceChargeBiGaussianData
#define XOBJ_TYPEDEF_SpaceChargeBiGaussianData
typedef   struct SpaceChargeBiGaussianData_s * SpaceChargeBiGaussianData;
 static inline SpaceChargeBiGaussianData SpaceChargeBiGaussianData_getp(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  return (SpaceChargeBiGaussianData)(( char*) obj+offset);
}
 static inline LongitudinalProfileQGaussianData SpaceChargeBiGaussianData_getp_longitudinal_profile(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  return (LongitudinalProfileQGaussianData)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_longitudinal_profile_number_of_particles(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_longitudinal_profile_number_of_particles(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_longitudinal_profile_number_of_particles(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_longitudinal_profile__q_tol(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_longitudinal_profile__q_tol(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_longitudinal_profile__q_tol(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_longitudinal_profile__z0(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_longitudinal_profile__z0(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_longitudinal_profile__z0(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_longitudinal_profile__sigma_z(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_longitudinal_profile__sigma_z(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_longitudinal_profile__sigma_z(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_longitudinal_profile__q_param(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_longitudinal_profile__q_param(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_longitudinal_profile__q_param(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_longitudinal_profile__cq_param(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_longitudinal_profile__cq_param(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_longitudinal_profile__cq_param(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_longitudinal_profile__beta_param(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_longitudinal_profile__beta_param(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_longitudinal_profile__beta_param(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_longitudinal_profile__sqrt_beta_param(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_longitudinal_profile__sqrt_beta_param(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_longitudinal_profile__sqrt_beta_param(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_longitudinal_profile__support_min(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_longitudinal_profile__support_min(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_longitudinal_profile__support_min(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_longitudinal_profile__support_max(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_longitudinal_profile__support_max(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_longitudinal_profile__support_max(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline BiGaussianFieldMapData SpaceChargeBiGaussianData_getp_fieldmap(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return (BiGaussianFieldMapData)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_fieldmap_mean_x(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_fieldmap_mean_x(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_fieldmap_mean_x(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_fieldmap_mean_y(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_fieldmap_mean_y(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_fieldmap_mean_y(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_fieldmap_sigma_x(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_fieldmap_sigma_x(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_fieldmap_sigma_x(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_fieldmap_sigma_y(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_fieldmap_sigma_y(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_fieldmap_sigma_y(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_fieldmap_min_sigma_diff(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_fieldmap_min_sigma_diff(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_fieldmap_min_sigma_diff(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t SpaceChargeBiGaussianData_get_fieldmap__updatable(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_fieldmap__updatable(SpaceChargeBiGaussianData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=120;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SpaceChargeBiGaussianData_getp_fieldmap__updatable(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get_length(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_length(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp_length(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t SpaceChargeBiGaussianData_get_z_kick_num_integ_per_sigma(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set_z_kick_num_integ_per_sigma(SpaceChargeBiGaussianData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=136;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SpaceChargeBiGaussianData_getp_z_kick_num_integ_per_sigma(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get__sin_rot_s(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set__sin_rot_s(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp__sin_rot_s(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get__cos_rot_s(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set__cos_rot_s(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp__cos_rot_s(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get__shift_x(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set__shift_x(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp__shift_x(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get__shift_y(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set__shift_y(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp__shift_y(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline double SpaceChargeBiGaussianData_get__shift_s(const SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( double*)(( char*) obj+offset);
}
 static inline void SpaceChargeBiGaussianData_set__shift_s(SpaceChargeBiGaussianData restrict  obj, double value){
  int64_t offset=0;
  offset+=176;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SpaceChargeBiGaussianData_getp__shift_s(SpaceChargeBiGaussianData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


#ifndef XFIELDS_CONSTANTS_H
#define XFIELDS_CONSTANTS_H

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //


// classical electron radius [m]
#if !defined( RE )
    #define   RE ( 2.81794092e-15 )
#endif

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif

// from python scipy version 1.9.0: cst.elementary_charge
#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.8541878128e-12)
#endif

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif

// from python scipy version 1.9.0: cst.epsilon_0
#if !defined( QELEM )
    #define QELEM (1.602176634e-19)
#endif

#if !defined( MPROTON_GEV )
    #define MPROTON_GEV (0.93827208816)
#endif

#if !defined( MELECTRON_GEV )
    #define MELECTRON_GEV (0.00051099895000)
#endif

#if !defined( MELECTRON_KG )
    #define MELECTRON_KG (9.1093837015e-31)
#endif

#if !defined( ALPHA )
    #define ALPHA (7.29735257e-3)
#endif

#if !defined( HBAR_GEVS )
    #define HBAR_GEVS (6.582119569e-25)
#endif

#if !defined( TWO_OVER_SQRT_PI )
    #define TWO_OVER_SQRT_PI (1.128379167095512573896158903121545171688101258657997713688171443418)
#endif

#if !defined( SQRT_TWO )
    #define SQRT_TWO (1.414213562373095048801688724209698078569671875376948073176679738)
#endif

#if !defined( REDUCED_COMPTON_WAVELENGTH_ELECTRON )
    #define REDUCED_COMPTON_WAVELENGTH_ELECTRON (3.8615926796089057e-13)
#endif

#if !defined( REAL_EPSILON )
    #define REAL_EPSILON 2.22044604925031e-16
#endif /* !defined( REAL_EPSILON ) */

#endif /* XFIELDS_CONSTANTS_H */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_SINCOS_H__
#define XFIELDS_SINCOS_H__

#include <math.h> //only_for_context cpu_serial cpu_openmp

/* Define XSUITE_NO_SINCOS as a compiler parameter to never use the inline
 * wrapper function below (the compiler may still decide to use sincos - like
 * intrinsic, but usually enforcing that math functions have to update
 * errno should put an end to this.
 *
 * If XSUITE_NO_SINCOS is not set, then a best-effort attempt is made to
 * use it on platforms that support it (i.e. gnu compiler, no ANSI standards,
 * relaxed errno handling for math functions.
 */

#if ( !defined( XSUITE_NO_SINCOS ) ) && ( defined( __OPENCL_C_VERSION__ ) )
 static inline void xsuite_sincos( double const arg,
    double*  restrict  sin_result, double*  restrict  cos_result ) {
    *sin_result = sincos( arg, cos_result ); }

#elif ( !defined( XSUITE_NO_SINCOS ) ) && \
      ( ( defined( __CUDA_ARCH__ ) ) || \
        ( defined( __GNUC__ ) && !defined( __clang__ ) && \
         !defined( __STRICT_ANSI__ ) && !defined( __INTEL_COMPILER ) && \
         defined( __NO_MATH_ERRNO__ ) ) )
 static inline void xsuite_sincos( double const arg,
    double*  restrict  sin_result, double*  restrict  cos_result ) {
    sincos( arg, sin_result, cos_result ); }

#else
 static inline void xsuite_sincos( double const arg,
    double*  restrict  sin_result, double*  restrict  cos_result ) {
    *sin_result = sin( arg );
    *cos_result = cos( arg ); }

#endif /* XSUITE_NO_SINCOS */
#endif /* XFIELDS_SINCOS_H__ */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_HEADERS_POWER_H_H__
#define XFIELDS_HEADERS_POWER_H_H__

/** \file power_n.h
 *  \note always include constants first!!! */

 static inline double power_n( double x, unsigned int n )
{
    #if defined( __OPENCL_VERSION__ )
    return pown( x, n );
    #else

    double x_n = x;

    unsigned int const n_div_16 = n >> 4u;
    unsigned int const n_mod_16 = n - ( n_div_16 << 4u );

    switch( n_mod_16 )
    {
        case  0u: { x_n = ( double )1.0; break; }
        case  1u: { break; }
        case  2u: { x_n *= x;                                       break; }
        case  3u: { x_n *= x * x;                                   break; }
        case  4u: { x_n *= x;     x_n *= x_n;                       break; }
        case  5u: { x_n *= x;     x_n *= x_n * x;                   break; }
        case  6u: { x_n *= x * x; x_n *= x_n;                       break; }
        case  7u: { x_n *= x * x; x_n *= x_n * x;                   break; }
        case  8u: { x_n *= x;     x_n *= x_n;     x_n *= x_n;       break; }
        case  9u: { x_n *= x * x; x_n *= x_n * x_n;                 break; }
        case 10u: { x_n *= x * x; x_n *= x_n * x_n * x;             break; }
        case 11u: { x_n *= x;     x_n *= x_n * x; x_n *= x_n * x;   break; }
        case 12u: { x_n *= x * x; x_n *= x_n;     x_n *= x_n;       break; }
        case 13u: { x_n *= x * x; x_n *= x_n;     x_n *= x_n * x;   break; }
        case 14u: { x_n *= x * x; x_n *= x_n * x; x_n *= x_n;       break; }
        case 15u: { x_n *= x;     x_n *= x_n * x; x_n *= x_n * x_n; break; }
        default:  { x_n = ( double )0.0; }
    };

    if( n_div_16 > 0u ){ x *= x; x *= x; x *= x; x *= x; }

    switch( n_div_16 )
    {
        case  0u: { x_n  = ( n_mod_16 != 0u ) ? x_n : ( double )1.0; break; }
        case  1u: { x_n *= x;                                           break; }
        case  2u: { x   *= x; x_n *= x;                                 break; }
        case  3u: { x_n *= x * x * x;                                   break; }
        case  4u: { x   *= x; x *= x; x_n *= x;                         break; }
        case  5u: { x_n *= x; x *= x; x *= x; x_n *= x;                 break; }
        case  6u: { x   *= x * x; x *= x; x_n *= x;                     break; }
        case  7u: { x_n *= x; x *= x * x; x *= x; x_n *= x;             break; }
        case  8u: { x *= x; x *= x; x*= x; x_n *= x;                    break; }
        case  9u: { x *= x * x; x *= x * x; x_n *= x;                   break; }
        case 10u: { x_n *= x; x *= x * x; x *= x * x; x_n *= x;         break; }
        case 11u: { x_n *= x * x; x *= x * x; x *= x * x; x_n *= x;     break; }
        case 12u: { x *= x; x *= x; x_n *= x; x *= x; x_n *= x;         break; }
        case 13u: { x_n *= x; x *= x; x *= x; x_n *= x; x *= x;
                    x_n *= x; break; }

        case 14u: { x_n *= x * x; x *= x; x *= x; x_n *= x; x *= x;
                    x_n *= x; break; }

        case 15u: { x *= x * x; x_n *= x * x; x *= x * x; x_n *= x;    break; }

        default:
        {
            unsigned int ii = 0u;
            unsigned int nn = n_div_16 % 16u;

            for( ; ii < nn ; ++ii ) x_n *= x;

            x *= x; x *= x; x *= x; x *= x;
            nn = ( n_div_16 - nn ) >> 4u;

            for( ii = 0u ; ii < nn ; ++ii ) x_n *= x;
        }
    };

    return x_n;
    #endif /* defined( __OPENCL_VERSION__ ) */
}

#endif /* XFIELDS_HEADERS_POWER_H_H__ */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_FADDEEVA_H
#define XFIELDS_FADDEEVA_H


//from file: faddeeva_mit.h

//  -*- mode:c++; tab-width:2; indent-tabs-mode:nil;  -*-

/* Copyright (c) 2012 Massachusetts Institute of Technology
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/* (Note that this file can be compiled with either C++, in which
    case it uses C++ std::complex<double>, or C, in which case it
    uses C99 double complex.) */

/* Available at: http://ab-initio.mit.edu/Faddeeva

   Computes various error functions (erf, erfc, erfi, erfcx),
   including the Dawson integral, in the complex plane, based
   on algorithms for the computation of the Faddeeva function
              w(z) = exp(-z^2) * erfc(-i*z).
   Given w(z), the error functions are mostly straightforward
   to compute, except for certain regions where we have to
   switch to Taylor expansions to avoid cancellation errors
   [e.g. near the origin for erf(z)].

   To compute the Faddeeva function, we use a combination of two
   algorithms:

   For sufficiently large |z|, we use a continued-fraction expansion
   for w(z) similar to those described in:

      Walter Gautschi, "Efficient computation of the complex error
      function," SIAM J. Numer. Anal. 7(1), pp. 187-198 (1970)

      G. P. M. Poppe and C. M. J. Wijers, "More efficient computation
      of the complex error function," ACM Trans. Math. Soft. 16(1),
      pp. 38-46 (1990).

   Unlike those papers, however, we switch to a completely different
   algorithm for smaller |z|:

      Mofreh R. Zaghloul and Ahmed N. Ali, "Algorithm 916: Computing the
      Faddeyeva and Voigt Functions," ACM Trans. Math. Soft. 38(2), 15
      (2011).

   (I initially used this algorithm for all z, but it turned out to be
    significantly slower than the continued-fraction expansion for
    larger |z|.  On the other hand, it is competitive for smaller |z|,
    and is significantly more accurate than the Poppe & Wijers code
    in some regions, e.g. in the vicinity of z=1+1i.)

   Note that this is an INDEPENDENT RE-IMPLEMENTATION of these algorithms,
   based on the description in the papers ONLY.  In particular, I did
   not refer to the authors' Fortran or Matlab implementations, respectively,
   (which are under restrictive ACM copyright terms and therefore unusable
    in free/open-source software).

   Steven G. Johnson, Massachusetts Institute of Technology
   http://math.mit.edu/~stevenj
   October 2012.

    -- Note that Algorithm 916 assumes that the erfc(x) function,
       or rather the scaled function erfcx(x) = exp(x*x)*erfc(x),
       is supplied for REAL arguments x.   I originally used an
       erfcx routine derived from DERFC in SLATEC, but I have
       since replaced it with a much faster routine written by
       me which uses a combination of continued-fraction expansions
       and a lookup table of Chebyshev polynomials.  For speed,
       I implemented a similar algorithm for Im[w(x)] of real x,
       since this comes up frequently in the other error functions.

   A small test program is included the end, which checks
   the w(z) etc. results against several known values.  To compile
   the test function, compile with -DTEST_FADDEEVA (that is,
   #define TEST_FADDEEVA).

   If HAVE_CONFIG_H is #defined (e.g. by compiling with -DHAVE_CONFIG_H),
   then we #include "config.h", which is assumed to be a GNU autoconf-style
   header defining HAVE_* macros to indicate the presence of features. In
   particular, if HAVE_ISNAN and HAVE_ISINF are #defined, we use those
   functions in math.h instead of defining our own, and if HAVE_ERF and/or
   HAVE_ERFC are defined we use those functions from <cmath> for erf and
   erfc of real arguments, respectively, instead of defining our own.

   REVISION HISTORY:
       4 October 2012: Initial public release (SGJ)
       5 October 2012: Revised (SGJ) to fix spelling error,
                       start summation for large x at round(x/a) (> 1)
                       rather than ceil(x/a) as in the original
                       paper, which should slightly improve performance
                       (and, apparently, slightly improves accuracy)
      19 October 2012: Revised (SGJ) to fix bugs for large x, large -y,
                       and 15<x<26. Performance improvements. Prototype
                       now supplies default value for relerr.
      24 October 2012: Switch to continued-fraction expansion for
                       sufficiently large z, for performance reasons.
                       Also, avoid spurious overflow for |z| > 1e154.
                       Set relerr argument to min(relerr,0.1).
      27 October 2012: Enhance accuracy in Re[w(z)] taken by itself,
                       by switching to Alg. 916 in a region near
                       the real-z axis where continued fractions
                       have poor relative accuracy in Re[w(z)].  Thanks
                       to M. Zaghloul for the tip.
      29 October 2012: Replace SLATEC-derived erfcx routine with
                       completely rewritten code by me, using a very
                       different algorithm which is much faster.
      30 October 2012: Implemented special-case code for real z
                       (where real part is exp(-x^2) and imag part is
                        Dawson integral), using algorithm similar to erfx.
                       Export ImFaddeeva_w function to make Dawson's
                       integral directly accessible.
      3 November 2012: Provide implementations of erf, erfc, erfcx,
                       and Dawson functions in Faddeeva:: namespace,
                       in addition to Faddeeva::w.  Provide header
                       file Faddeeva.hh.
      4 November 2012: Slightly faster erf for real arguments.
                       Updated MATLAB and Octave plugins.
     27 November 2012: Support compilation with either C++ or
                       plain C (using C99 complex numbers).
                       For real x, use standard-library erf(x)
                       and erfc(x) if available (for C99 or C++11).
                       #include "config.h" if HAVE_CONFIG_H is #defined.
     15 December 2012: Portability fixes (copysign, Inf/NaN creation),
                       use CMPLX/__builtin_complex if available in C,
                       slight accuracy improvements to erf and dawson
                       functions near the origin.  Use gnulib functions
                       if GNULIB_NAMESPACE is defined.
     18 December 2012: Slight tweaks (remove recomputation of x*x in Dawson)
          12 May 2015: Bugfix for systems lacking copysign function.
*/

/////////////////////////////////////////////////////////////////////////
/* If this file is compiled as a part of a larger project,
   support using an autoconf-style config.h header file
   (with various "HAVE_*" #defines to indicate features)
   if HAVE_CONFIG_H is #defined (in GNU autotools style). */

#ifndef XFIELDS_FADDEEVA_MIT_H
#define XFIELDS_FADDEEVA_MIT_H

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

/////////////////////////////////////////////////////////////////////////
// macros to allow us to use either C++ or C (with C99 features)


// #  include "Faddeeva.h" # I include the full header here
/* Copyright (c) 2012 Massachusetts Institute of Technology
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/* Available at: http://ab-initio.mit.edu/Faddeeva

   Header file for Faddeeva.c; see Faddeeva.cc for more information. */


// Require C99 complex-number support
#include <complex.h>


// compute w(z) = exp(-z^2) erfc(-iz) [ Faddeeva / scaled complex error func ]
static inline double complex Faddeeva_MIT_w(double complex z, double relerr);
double Faddeeva_MIT_w_im(double x); // special-case code for Im[w(x)] of real x

// Various functions that we can compute with the help of w(z)

// compute erfcx(z) = exp(z^2) erfc(z)
double complex Faddeeva_MIT_erfcx(double complex z, double relerr);
double Faddeeva_MIT_erfcx_re(double x); // special case for real x

// compute erf(z), the error function of complex arguments
double complex Faddeeva_MIT_erf(double complex z, double relerr);
double Faddeeva_MIT_erf_re(double x); // special case for real x

// compte erfi(z) = -i erf(iz), the imaginary error function
double complex Faddeeva_MIT_erfi(double complex z, double relerr);
double Faddeeva_MIT_erfi_re(double x); // special case for real x

// compute erfc(z) = 1 - erf(z), the complementary error function
double complex Faddeeva_MIT_erfc(double complex z, double relerr);
double Faddeeva_MIT_erfc_re(double x); // special case for real x

// compute Dawson(z) = sqrt(pi)/2  *  exp(-z^2) * erfi(z)
double complex Faddeeva_MIT_Dawson(double complex z, double relerr);
double Faddeeva_MIT_Dawson_re(double x); // special case for real x


 static inline void faddeeva_w( double x, double y,
    double*  restrict  out_x, double*  restrict  out_y )
{
    double complex z, W;
    z = x + I * y;
    W = Faddeeva_MIT_w(z, 0);
    *out_x = creal(W);
    *out_y = cimag(W);
}

 static inline void faddeeva_w_q1( double x, double y,
    double*  restrict  out_x, double*  restrict  out_y )
{
    faddeeva_w(x, y, out_x, out_y);
}


#  define _GNU_SOURCE // enable GNU libc NAN extension if possible

#  include <float.h>
#  include <math.h>

typedef double complex cmplx;

#  define FADDEEVA(name) Faddeeva_MIT_ ## name
#  define FADDEEVA_RE(name) Faddeeva_MIT_ ## name ## _re

/* Constructing complex numbers like 0+i*NaN is problematic in C99
   without the C11 CMPLX macro, because 0.+I*NAN may give NaN+i*NAN if
   I is a complex (rather than imaginary) constant.  For some reason,
   however, it works fine in (pre-4.7) gcc if I define Inf and NaN as
   1/0 and 0/0 (and only if I compile with optimization -O1 or more),
   but not if I use the INFINITY or NAN macros. */

/* __builtin_complex was introduced in gcc 4.7, but the C11 CMPLX macro
   may not be defined unless we are using a recent (2012) version of
   glibc and compile with -std=c11... note that icc lies about being
   gcc and probably doesn't have this builtin(?), so exclude icc explicitly */
#  if !defined(CMPLX) && (__GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 7)) && !(defined(__ICC) || defined(__INTEL_COMPILER))
#    define CMPLX(a,b) __builtin_complex((double) (a), (double) (b))
#  endif

#  ifdef CMPLX // C11
#    define C(a,b) CMPLX(a,b)
#    define Inf INFINITY // C99 infinity
#    ifdef NAN // GNU libc extension
#      define NaN NAN
#    else
#      define NaN (0./0.) // NaN
#    endif
#  else
#    define C(a,b) ((a) + I*(b))
#    define Inf (1./0.)
#    define NaN (0./0.)
#  endif

static inline cmplx cpolar(double r, double t)
{
  if (r == 0.0 && !isnan(t))
    return 0.0;
  else
    return C(r * cos(t), r * sin(t));
}


/////////////////////////////////////////////////////////////////////////
// Auxiliary routines to compute other special functions based on w(z)

// compute erfcx(z) = exp(z^2) erfz(z)
cmplx FADDEEVA(erfcx)(cmplx z, double relerr)
{
  return FADDEEVA(w)(C(-cimag(z), creal(z)), relerr);
}

// compute the error function erf(x)
double FADDEEVA_RE(erf)(double x)
{
#if !defined(__cplusplus)
  return erf(x); // C99 supplies erf in math.h
#elif (__cplusplus >= 201103L) || defined(HAVE_ERF)
  return ::erf(x); // C++11 supplies std::erf in cmath
#else
  double mx2 = -x*x;
  if (mx2 < -750) // underflow
    return (x >= 0 ? 1.0 : -1.0);

  if (x >= 0) {
    if (x < 8e-2) goto taylor;
    return 1.0 - exp(mx2) * FADDEEVA_RE(erfcx)(x);
  }
  else { // x < 0
    if (x > -8e-2) goto taylor;
    return exp(mx2) * FADDEEVA_RE(erfcx)(-x) - 1.0;
  }

  // Use Taylor series for small |x|, to avoid cancellation inaccuracy
  //   erf(x) = 2/sqrt(pi) * x * (1 - x^2/3 + x^4/10 - x^6/42 + x^8/216 + ...)
 taylor:
  return x * (1.1283791670955125739
              + mx2 * (0.37612638903183752464
                       + mx2 * (0.11283791670955125739
                                + mx2 * (0.026866170645131251760
                                         + mx2 * 0.0052239776254421878422))));
#endif
}

// compute the error function erf(z)
cmplx FADDEEVA(erf)(cmplx z, double relerr)
{
  double x = creal(z), y = cimag(z);

  if (y == 0)
    return C(FADDEEVA_RE(erf)(x),
             y); // preserve sign of 0
  if (x == 0) // handle separately for speed & handling of y = Inf or NaN
    return C(x, // preserve sign of 0
             /* handle y -> Inf limit manually, since
                exp(y^2) -> Inf but Im[w(y)] -> 0, so
                IEEE will give us a NaN when it should be Inf */
             y*y > 720 ? (y > 0 ? Inf : -Inf)
             : exp(y*y) * FADDEEVA(w_im)(y));

  double mRe_z2 = (y - x) * (x + y); // Re(-z^2), being careful of overflow
  double mIm_z2 = -2*x*y; // Im(-z^2)
  if (mRe_z2 < -750) // underflow
    return (x >= 0 ? 1.0 : -1.0);

  /* Handle positive and negative x via different formulas,
     using the mirror symmetries of w, to avoid overflow/underflow
     problems from multiplying exponentially large and small quantities. */
  if (x >= 0) {
    if (x < 8e-2) {
      if (fabs(y) < 1e-2)
        goto taylor;
      else if (fabs(mIm_z2) < 5e-3 && x < 5e-3)
        goto taylor_erfi;
    }
    /* don't use complex exp function, since that will produce spurious NaN
       values when multiplying w in an overflow situation. */
    return 1.0 - exp(mRe_z2) *
      (C(cos(mIm_z2), sin(mIm_z2))
       * FADDEEVA(w)(C(-y,x), relerr));
  }
  else { // x < 0
    if (x > -8e-2) { // duplicate from above to avoid fabs(x) call
      if (fabs(y) < 1e-2)
        goto taylor;
      else if (fabs(mIm_z2) < 5e-3 && x > -5e-3)
        goto taylor_erfi;
    }
    else if (isnan(x))
      return C(NaN, y == 0 ? 0 : NaN);
    /* don't use complex exp function, since that will produce spurious NaN
       values when multiplying w in an overflow situation. */
    return exp(mRe_z2) *
      (C(cos(mIm_z2), sin(mIm_z2))
       * FADDEEVA(w)(C(y,-x), relerr)) - 1.0;
  }

  // Use Taylor series for small |z|, to avoid cancellation inaccuracy
  //   erf(z) = 2/sqrt(pi) * z * (1 - z^2/3 + z^4/10 - z^6/42 + z^8/216 + ...)
 taylor:
  {
    cmplx mz2 = C(mRe_z2, mIm_z2); // -z^2
    return z * (1.1283791670955125739
                + mz2 * (0.37612638903183752464
                         + mz2 * (0.11283791670955125739
                                  + mz2 * (0.026866170645131251760
                                          + mz2 * 0.0052239776254421878422))));
  }

  /* for small |x| and small |xy|,
     use Taylor series to avoid cancellation inaccuracy:
       erf(x+iy) = erf(iy)
          + 2*exp(y^2)/sqrt(pi) *
            [ x * (1 - x^2 * (1+2y^2)/3 + x^4 * (3+12y^2+4y^4)/30 + ...
              - i * x^2 * y * (1 - x^2 * (3+2y^2)/6 + ...) ]
     where:
        erf(iy) = exp(y^2) * Im[w(y)]
  */
 taylor_erfi:
  {
    double x2 = x*x, y2 = y*y;
    double expy2 = exp(y2);
    return C
      (expy2 * x * (1.1283791670955125739
                    - x2 * (0.37612638903183752464
                            + 0.75225277806367504925*y2)
                    + x2*x2 * (0.11283791670955125739
                               + y2 * (0.45135166683820502956
                                       + 0.15045055561273500986*y2))),
       expy2 * (FADDEEVA(w_im)(y)
                - x2*y * (1.1283791670955125739
                          - x2 * (0.56418958354775628695
                                  + 0.37612638903183752464*y2))));
  }
}

// erfi(z) = -i erf(iz)
cmplx FADDEEVA(erfi)(cmplx z, double relerr)
{
  cmplx e = FADDEEVA(erf)(C(-cimag(z),creal(z)), relerr);
  return C(cimag(e), -creal(e));
}

// erfi(x) = -i erf(ix)
double FADDEEVA_RE(erfi)(double x)
{
  return x*x > 720 ? (x > 0 ? Inf : -Inf)
    : exp(x*x) * FADDEEVA(w_im)(x);
}

// erfc(x) = 1 - erf(x)
double FADDEEVA_RE(erfc)(double x)
{
#if !defined(__cplusplus)
  return erfc(x); // C99 supplies erfc in math.h
#elif (__cplusplus >= 201103L) || defined(HAVE_ERFC)
  return ::erfc(x); // C++11 supplies std::erfc in cmath
#else
  if (x*x > 750) // underflow
    return (x >= 0 ? 0.0 : 2.0);
  return x >= 0 ? exp(-x*x) * FADDEEVA_RE(erfcx)(x)
    : 2. - exp(-x*x) * FADDEEVA_RE(erfcx)(-x);
#endif
}

// erfc(z) = 1 - erf(z)
cmplx FADDEEVA(erfc)(cmplx z, double relerr)
{
  double x = creal(z), y = cimag(z);

  if (x == 0.)
    return C(1,
             /* handle y -> Inf limit manually, since
                exp(y^2) -> Inf but Im[w(y)] -> 0, so
                IEEE will give us a NaN when it should be Inf */
             y*y > 720 ? (y > 0 ? -Inf : Inf)
             : -exp(y*y) * FADDEEVA(w_im)(y));
  if (y == 0.) {
    if (x*x > 750) // underflow
      return C(x >= 0 ? 0.0 : 2.0,
               -y); // preserve sign of 0
    return C(x >= 0 ? exp(-x*x) * FADDEEVA_RE(erfcx)(x)
             : 2. - exp(-x*x) * FADDEEVA_RE(erfcx)(-x),
             -y); // preserve sign of zero
  }

  double mRe_z2 = (y - x) * (x + y); // Re(-z^2), being careful of overflow
  double mIm_z2 = -2*x*y; // Im(-z^2)
  if (mRe_z2 < -750) // underflow
    return (x >= 0 ? 0.0 : 2.0);

  if (x >= 0)
    return cexp(C(mRe_z2, mIm_z2))
      * FADDEEVA(w)(C(-y,x), relerr);
  else
    return 2.0 - cexp(C(mRe_z2, mIm_z2))
      * FADDEEVA(w)(C(y,-x), relerr);
}

// compute Dawson(x) = sqrt(pi)/2  *  exp(-x^2) * erfi(x)
double FADDEEVA_RE(Dawson)(double x)
{
  const double spi2 = 0.8862269254527580136490837416705725913990; // sqrt(pi)/2
  return spi2 * FADDEEVA(w_im)(x);
}

// compute Dawson(z) = sqrt(pi)/2  *  exp(-z^2) * erfi(z)
cmplx FADDEEVA(Dawson)(cmplx z, double relerr)
{
  const double spi2 = 0.8862269254527580136490837416705725913990; // sqrt(pi)/2
  double x = creal(z), y = cimag(z);

  // handle axes separately for speed & proper handling of x or y = Inf or NaN
  if (y == 0)
    return C(spi2 * FADDEEVA(w_im)(x),
             -y); // preserve sign of 0
  if (x == 0) {
    double y2 = y*y;
    if (y2 < 2.5e-5) { // Taylor expansion
      return C(x, // preserve sign of 0
               y * (1.
                    + y2 * (0.6666666666666666666666666666666666666667
                            + y2 * 0.26666666666666666666666666666666666667)));
    }
    return C(x, // preserve sign of 0
             spi2 * (y >= 0
                     ? exp(y2) - FADDEEVA_RE(erfcx)(y)
                     : FADDEEVA_RE(erfcx)(-y) - exp(y2)));
  }

  double mRe_z2 = (y - x) * (x + y); // Re(-z^2), being careful of overflow
  double mIm_z2 = -2*x*y; // Im(-z^2)
  cmplx mz2 = C(mRe_z2, mIm_z2); // -z^2

  /* Handle positive and negative x via different formulas,
     using the mirror symmetries of w, to avoid overflow/underflow
     problems from multiplying exponentially large and small quantities. */
  if (y >= 0) {
    if (y < 5e-3) {
      if (fabs(x) < 5e-3)
        goto taylor;
      else if (fabs(mIm_z2) < 5e-3)
        goto taylor_realaxis;
    }
    cmplx res = cexp(mz2) - FADDEEVA(w)(z, relerr);
    return spi2 * C(-cimag(res), creal(res));
  }
  else { // y < 0
    if (y > -5e-3) { // duplicate from above to avoid fabs(x) call
      if (fabs(x) < 5e-3)
        goto taylor;
      else if (fabs(mIm_z2) < 5e-3)
        goto taylor_realaxis;
    }
    else if (isnan(y))
      return C(x == 0 ? 0 : NaN, NaN);
    cmplx res = FADDEEVA(w)(-z, relerr) - cexp(mz2);
    return spi2 * C(-cimag(res), creal(res));
  }

  // Use Taylor series for small |z|, to avoid cancellation inaccuracy
  //     dawson(z) = z - 2/3 z^3 + 4/15 z^5 + ...
 taylor:
  return z * (1.
              + mz2 * (0.6666666666666666666666666666666666666667
                       + mz2 * 0.2666666666666666666666666666666666666667));

  /* for small |y| and small |xy|,
     use Taylor series to avoid cancellation inaccuracy:
       dawson(x + iy)
        = D + y^2 (D + x - 2Dx^2)
            + y^4 (D/2 + 5x/6 - 2Dx^2 - x^3/3 + 2Dx^4/3)
        + iy [ (1-2Dx) + 2/3 y^2 (1 - 3Dx - x^2 + 2Dx^3)
              + y^4/15 (4 - 15Dx - 9x^2 + 20Dx^3 + 2x^4 - 4Dx^5) ] + ...
     where D = dawson(x)

     However, for large |x|, 2Dx -> 1 which gives cancellation problems in
     this series (many of the leading terms cancel).  So, for large |x|,
     we need to substitute a continued-fraction expansion for D.

        dawson(x) = 0.5 / (x-0.5/(x-1/(x-1.5/(x-2/(x-2.5/(x...))))))

     The 6 terms shown here seems to be the minimum needed to be
     accurate as soon as the simpler Taylor expansion above starts
     breaking down.  Using this 6-term expansion, factoring out the
     denominator, and simplifying with Maple, we obtain:

      Re dawson(x + iy) * (-15 + 90x^2 - 60x^4 + 8x^6) / x
        = 33 - 28x^2 + 4x^4 + y^2 (18 - 4x^2) + 4 y^4
      Im dawson(x + iy) * (-15 + 90x^2 - 60x^4 + 8x^6) / y
        = -15 + 24x^2 - 4x^4 + 2/3 y^2 (6x^2 - 15) - 4 y^4

     Finally, for |x| > 5e7, we can use a simpler 1-term continued-fraction
     expansion for the real part, and a 2-term expansion for the imaginary
     part.  (This avoids overflow problems for huge |x|.)  This yields:

     Re dawson(x + iy) = [1 + y^2 (1 + y^2/2 - (xy)^2/3)] / (2x)
     Im dawson(x + iy) = y [ -1 - 2/3 y^2 + y^4/15 (2x^2 - 4) ] / (2x^2 - 1)

 */
 taylor_realaxis:
  {
    double x2 = x*x;
    if (x2 > 1600) { // |x| > 40
      double y2 = y*y;
      if (x2 > 25e14) {// |x| > 5e7
        double xy2 = (x*y)*(x*y);
        return C((0.5 + y2 * (0.5 + 0.25*y2
                              - 0.16666666666666666667*xy2)) / x,
                 y * (-1 + y2 * (-0.66666666666666666667
                                 + 0.13333333333333333333*xy2
                                 - 0.26666666666666666667*y2))
                 / (2*x2 - 1));
      }
      return (1. / (-15 + x2*(90 + x2*(-60 + 8*x2)))) *
        C(x * (33 + x2 * (-28 + 4*x2)
               + y2 * (18 - 4*x2 + 4*y2)),
          y * (-15 + x2 * (24 - 4*x2)
               + y2 * (4*x2 - 10 - 4*y2)));
    }
    else {
      double D = spi2 * FADDEEVA(w_im)(x);
      double y2 = y*y;
      return C
        (D + y2 * (D + x - 2*D*x2)
         + y2*y2 * (D * (0.5 - x2 * (2 - 0.66666666666666666667*x2))
                    + x * (0.83333333333333333333
                           - 0.33333333333333333333 * x2)),
         y * (1 - 2*D*x
              + y2 * 0.66666666666666666667 * (1 - x2 - D*x * (3 - 2*x2))
              + y2*y2 * (0.26666666666666666667 -
                         x2 * (0.6 - 0.13333333333333333333 * x2)
                         - D*x * (1 - x2 * (1.3333333333333333333
                                            - 0.26666666666666666667 * x2)))));
    }
  }
}

/////////////////////////////////////////////////////////////////////////

// return sinc(x) = sin(x)/x, given both x and sin(x)
// [since we only use this in cases where sin(x) has already been computed]
static inline double sinc(double x, double sinx) {
  return fabs(x) < 1e-4 ? 1 - (0.1666666666666666666667)*x*x : sinx / x;
}

// sinh(x) via Taylor series, accurate to machine precision for |x| < 1e-2
static inline double sinh_taylor(double x) {
  return x * (1 + (x*x) * (0.1666666666666666666667
                           + 0.00833333333333333333333 * (x*x)));
}

static inline double sqr(double x) { return x*x; }

// precomputed table of expa2n2[n-1] = exp(-a2*n*n)
// for double-precision a2 = 0.26865... in FADDEEVA(w), below.
static const double expa2n2[] = {
  7.64405281671221563e-01,
  3.41424527166548425e-01,
  8.91072646929412548e-02,
  1.35887299055460086e-02,
  1.21085455253437481e-03,
  6.30452613933449404e-05,
  1.91805156577114683e-06,
  3.40969447714832381e-08,
  3.54175089099469393e-10,
  2.14965079583260682e-12,
  7.62368911833724354e-15,
  1.57982797110681093e-17,
  1.91294189103582677e-20,
  1.35344656764205340e-23,
  5.59535712428588720e-27,
  1.35164257972401769e-30,
  1.90784582843501167e-34,
  1.57351920291442930e-38,
  7.58312432328032845e-43,
  2.13536275438697082e-47,
  3.51352063787195769e-52,
  3.37800830266396920e-57,
  1.89769439468301000e-62,
  6.22929926072668851e-68,
  1.19481172006938722e-73,
  1.33908181133005953e-79,
  8.76924303483223939e-86,
  3.35555576166254986e-92,
  7.50264110688173024e-99,
  9.80192200745410268e-106,
  7.48265412822268959e-113,
  3.33770122566809425e-120,
  8.69934598159861140e-128,
  1.32486951484088852e-135,
  1.17898144201315253e-143,
  6.13039120236180012e-152,
  1.86258785950822098e-160,
  3.30668408201432783e-169,
  3.43017280887946235e-178,
  2.07915397775808219e-187,
  7.36384545323984966e-197,
  1.52394760394085741e-206,
  1.84281935046532100e-216,
  1.30209553802992923e-226,
  5.37588903521080531e-237,
  1.29689584599763145e-247,
  1.82813078022866562e-258,
  1.50576355348684241e-269,
  7.24692320799294194e-281,
  2.03797051314726829e-292,
  3.34880215927873807e-304,
  0.0 // underflow (also prevents reads past array end, below)
};

/////////////////////////////////////////////////////////////////////////

static inline cmplx FADDEEVA(w)(cmplx z, double relerr)
{
  if (creal(z) == 0.0)
    return C(FADDEEVA_RE(erfcx)(cimag(z)),
             creal(z)); // give correct sign of 0 in cimag(w)
  else if (cimag(z) == 0)
    return C(exp(-sqr(creal(z))),
             FADDEEVA(w_im)(creal(z)));

  double a, a2, c;
  if (relerr <= DBL_EPSILON) {
    relerr = DBL_EPSILON;
    a = 0.518321480430085929872; // pi / sqrt(-log(eps*0.5))
    c = 0.329973702884629072537; // (2/pi) * a;
    a2 = 0.268657157075235951582; // a^2
  }
  else {
    const double pi = 3.14159265358979323846264338327950288419716939937510582;
    if (relerr > 0.1) relerr = 0.1; // not sensible to compute < 1 digit
    a = pi / sqrt(-log(relerr*0.5));
    c = (2/pi)*a;
    a2 = a*a;
  }
  const double x = fabs(creal(z));
  const double y = cimag(z), ya = fabs(y);

  cmplx ret = 0.; // return value

  double sum1 = 0, sum2 = 0, sum3 = 0, sum4 = 0, sum5 = 0;

#define USE_CONTINUED_FRACTION 1 // 1 to use continued fraction for large |z|

#if USE_CONTINUED_FRACTION
  if (ya > 7 || (x > 6  // continued fraction is faster
                 /* As pointed out by M. Zaghloul, the continued
                    fraction seems to give a large relative error in
                    Re w(z) for |x| ~ 6 and small |y|, so use
                    algorithm 816 in this region: */
                 && (ya > 0.1 || (x > 8 && ya > 1e-10) || x > 28))) {

    /* Poppe & Wijers suggest using a number of terms
           nu = 3 + 1442 / (26*rho + 77)
       where rho = sqrt((x/x0)^2 + (y/y0)^2) where x0=6.3, y0=4.4.
       (They only use this expansion for rho >= 1, but rho a little less
        than 1 seems okay too.)
       Instead, I did my own fit to a slightly different function
       that avoids the hypotenuse calculation, using NLopt to minimize
       the sum of the squares of the errors in nu with the constraint
       that the estimated nu be >= minimum nu to attain machine precision.
       I also separate the regions where nu == 2 and nu == 1. */
    const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
    double xs = y < 0 ? -creal(z) : creal(z); // compute for -z if y < 0
    if (x + ya > 4000) { // nu <= 2
      if (x + ya > 1e7) { // nu == 1, w(z) = i/sqrt(pi) / z
        // scale to avoid overflow
        if (x > ya) {
          double yax = ya / xs;
          double denom = ispi / (xs + yax*ya);
          ret = C(denom*yax, denom);
        }
        else if (isinf(ya))
          return ((isnan(x) || y < 0)
                  ? C(NaN,NaN) : C(0,0));
        else {
          double xya = xs / ya;
          double denom = ispi / (xya*xs + ya);
          ret = C(denom, denom*xya);
        }
      }
      else { // nu == 2, w(z) = i/sqrt(pi) * z / (z*z - 0.5)
        double dr = xs*xs - ya*ya - 0.5, di = 2*xs*ya;
        double denom = ispi / (dr*dr + di*di);
        ret = C(denom * (xs*di-ya*dr), denom * (xs*dr+ya*di));
      }
    }
    else { // compute nu(z) estimate and do general continued fraction
      const double c0=3.9, c1=11.398, c2=0.08254, c3=0.1421, c4=0.2023; // fit
      double nu = floor(c0 + c1 / (c2*x + c3*ya + c4));
      double wr = xs, wi = ya;
      for (nu = 0.5 * (nu - 1); nu > 0.4; nu -= 0.5) {
        // w <- z - nu/w:
        double denom = nu / (wr*wr + wi*wi);
        wr = xs - wr * denom;
        wi = ya + wi * denom;
      }
      { // w(z) = i/sqrt(pi) / w:
        double denom = ispi / (wr*wr + wi*wi);
        ret = C(denom*wi, denom*wr);
      }
    }
    if (y < 0) {
      // use w(z) = 2.0*exp(-z*z) - w(-z),
      // but be careful of overflow in exp(-z*z)
      //                                = exp(-(xs*xs-ya*ya) -2*i*xs*ya)
      return 2.0*cexp(C((ya-xs)*(xs+ya), 2*xs*y)) - ret;
    }
    else
      return ret;
  }
#else // !USE_CONTINUED_FRACTION
  if (x + ya > 1e7) { // w(z) = i/sqrt(pi) / z, to machine precision
    const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
    double xs = y < 0 ? -creal(z) : creal(z); // compute for -z if y < 0
    // scale to avoid overflow
    if (x > ya) {
      double yax = ya / xs;
      double denom = ispi / (xs + yax*ya);
      ret = C(denom*yax, denom);
    }
    else {
      double xya = xs / ya;
      double denom = ispi / (xya*xs + ya);
      ret = C(denom, denom*xya);
    }
    if (y < 0) {
      // use w(z) = 2.0*exp(-z*z) - w(-z),
      // but be careful of overflow in exp(-z*z)
      //                                = exp(-(xs*xs-ya*ya) -2*i*xs*ya)
      return 2.0*cexp(C((ya-xs)*(xs+ya), 2*xs*y)) - ret;
    }
    else
      return ret;
  }
#endif // !USE_CONTINUED_FRACTION

  /* Note: The test that seems to be suggested in the paper is x <
     sqrt(-log(DBL_MIN)), about 26.6, since otherwise exp(-x^2)
     underflows to zero and sum1,sum2,sum4 are zero.  However, long
     before this occurs, the sum1,sum2,sum4 contributions are
     negligible in double precision; I find that this happens for x >
     about 6, for all y.  On the other hand, I find that the case
     where we compute all of the sums is faster (at least with the
     precomputed expa2n2 table) until about x=10.  Furthermore, if we
     try to compute all of the sums for x > 20, I find that we
     sometimes run into numerical problems because underflow/overflow
     problems start to appear in the various coefficients of the sums,
     below.  Therefore, we use x < 10 here. */
  else if (x < 10) {
    double prod2ax = 1, prodm2ax = 1;
    double expx2;

    if (isnan(y))
      return C(y,y);

    /* Somewhat ugly copy-and-paste duplication here, but I see significant
       speedups from using the special-case code with the precomputed
       exponential, and the x < 5e-4 special case is needed for accuracy. */

    if (relerr == DBL_EPSILON) { // use precomputed exp(-a2*(n*n)) table
      if (x < 5e-4) { // compute sum4 and sum5 together as sum5-sum4
        const double x2 = x*x;
        expx2 = 1 - x2 * (1 - 0.5*x2); // exp(-x*x) via Taylor
        // compute exp(2*a*x) and exp(-2*a*x) via Taylor, to double precision
        const double ax2 = 1.036642960860171859744*x; // 2*a*x
        const double exp2ax =
          1 + ax2 * (1 + ax2 * (0.5 + 0.166666666666666666667*ax2));
        const double expm2ax =
          1 - ax2 * (1 - ax2 * (0.5 - 0.166666666666666666667*ax2));
        for (int n = 1; 1; ++n) {
          const double coef = expa2n2[n-1] * expx2 / (a2*(n*n) + y*y);
          prod2ax *= exp2ax;
          prodm2ax *= expm2ax;
          sum1 += coef;
          sum2 += coef * prodm2ax;
          sum3 += coef * prod2ax;

          // really = sum5 - sum4
          sum5 += coef * (2*a) * n * sinh_taylor((2*a)*n*x);

          // test convergence via sum3
          if (coef * prod2ax < relerr * sum3) break;
        }
      }
      else { // x > 5e-4, compute sum4 and sum5 separately
        expx2 = exp(-x*x);
        const double exp2ax = exp((2*a)*x), expm2ax = 1 / exp2ax;
        for (int n = 1; 1; ++n) {
          const double coef = expa2n2[n-1] * expx2 / (a2*(n*n) + y*y);
          prod2ax *= exp2ax;
          prodm2ax *= expm2ax;
          sum1 += coef;
          sum2 += coef * prodm2ax;
          sum4 += (coef * prodm2ax) * (a*n);
          sum3 += coef * prod2ax;
          sum5 += (coef * prod2ax) * (a*n);
          // test convergence via sum5, since this sum has the slowest decay
          if ((coef * prod2ax) * (a*n) < relerr * sum5) break;
        }
      }
    }
    else { // relerr != DBL_EPSILON, compute exp(-a2*(n*n)) on the fly
      const double exp2ax = exp((2*a)*x), expm2ax = 1 / exp2ax;
      if (x < 5e-4) { // compute sum4 and sum5 together as sum5-sum4
        const double x2 = x*x;
        expx2 = 1 - x2 * (1 - 0.5*x2); // exp(-x*x) via Taylor
        for (int n = 1; 1; ++n) {
          const double coef = exp(-a2*(n*n)) * expx2 / (a2*(n*n) + y*y);
          prod2ax *= exp2ax;
          prodm2ax *= expm2ax;
          sum1 += coef;
          sum2 += coef * prodm2ax;
          sum3 += coef * prod2ax;

          // really = sum5 - sum4
          sum5 += coef * (2*a) * n * sinh_taylor((2*a)*n*x);

          // test convergence via sum3
          if (coef * prod2ax < relerr * sum3) break;
        }
      }
      else { // x > 5e-4, compute sum4 and sum5 separately
        expx2 = exp(-x*x);
        for (int n = 1; 1; ++n) {
          const double coef = exp(-a2*(n*n)) * expx2 / (a2*(n*n) + y*y);
          prod2ax *= exp2ax;
          prodm2ax *= expm2ax;
          sum1 += coef;
          sum2 += coef * prodm2ax;
          sum4 += (coef * prodm2ax) * (a*n);
          sum3 += coef * prod2ax;
          sum5 += (coef * prod2ax) * (a*n);
          // test convergence via sum5, since this sum has the slowest decay
          if ((coef * prod2ax) * (a*n) < relerr * sum5) break;
        }
      }
    }
    const double expx2erfcxy = // avoid spurious overflow for large negative y
      y > -6 // for y < -6, erfcx(y) = 2*exp(y*y) to double precision
      ? expx2*FADDEEVA_RE(erfcx)(y) : 2*exp(y*y-x*x);
    if (y > 5) { // imaginary terms cancel
      const double sinxy = sin(x*y);
      ret = (expx2erfcxy - c*y*sum1) * cos(2*x*y)
        + (c*x*expx2) * sinxy * sinc(x*y, sinxy);
    }
    else {
      double xs = creal(z);
      const double sinxy = sin(xs*y);
      const double sin2xy = sin(2*xs*y), cos2xy = cos(2*xs*y);
      const double coef1 = expx2erfcxy - c*y*sum1;
      const double coef2 = c*xs*expx2;
      ret = C(coef1 * cos2xy + coef2 * sinxy * sinc(xs*y, sinxy),
              coef2 * sinc(2*xs*y, sin2xy) - coef1 * sin2xy);
    }
  }
  else { // x large: only sum3 & sum5 contribute (see above note)
    if (isnan(x))
      return C(x,x);
    if (isnan(y))
      return C(y,y);

#if USE_CONTINUED_FRACTION
    ret = exp(-x*x); // |y| < 1e-10, so we only need exp(-x*x) term
#else
    if (y < 0) {
      /* erfcx(y) ~ 2*exp(y*y) + (< 1) if y < 0, so
         erfcx(y)*exp(-x*x) ~ 2*exp(y*y-x*x) term may not be negligible
         if y*y - x*x > -36 or so.  So, compute this term just in case.
         We also need the -exp(-x*x) term to compute Re[w] accurately
         in the case where y is very small. */
      ret = cpolar(2*exp(y*y-x*x) - exp(-x*x), -2*creal(z)*y);
    }
    else
      ret = exp(-x*x); // not negligible in real part if y very small
#endif
    // (round instead of ceil as in original paper; note that x/a > 1 here)
    double n0 = floor(x/a + 0.5); // sum in both directions, starting at n0
    double dx = a*n0 - x;
    sum3 = exp(-dx*dx) / (a2*(n0*n0) + y*y);
    sum5 = a*n0 * sum3;
    double exp1 = exp(4*a*dx), exp1dn = 1;
    int dn;
    for (dn = 1; n0 - dn > 0; ++dn) { // loop over n0-dn and n0+dn terms
      double np = n0 + dn, nm = n0 - dn;
      double tp = exp(-sqr(a*dn+dx));
      double tm = tp * (exp1dn *= exp1); // trick to get tm from tp
      tp /= (a2*(np*np) + y*y);
      tm /= (a2*(nm*nm) + y*y);
      sum3 += tp + tm;
      sum5 += a * (np * tp + nm * tm);
      if (a * (np * tp + nm * tm) < relerr * sum5) goto finish;
    }
    while (1) { // loop over n0+dn terms only (since n0-dn <= 0)
      double np = n0 + dn++;
      double tp = exp(-sqr(a*dn+dx)) / (a2*(np*np) + y*y);
      sum3 += tp;
      sum5 += a * np * tp;
      if (a * np * tp < relerr * sum5) goto finish;
    }
  }
 finish:
  return ret + C((0.5*c)*y*(sum2+sum3),
                 (0.5*c)*copysign(sum5-sum4, creal(z)));
}

/////////////////////////////////////////////////////////////////////////

/* erfcx(x) = exp(x^2) erfc(x) function, for real x, written by
   Steven G. Johnson, October 2012.

   This function combines a few different ideas.

   First, for x > 50, it uses a continued-fraction expansion (same as
   for the Faddeeva function, but with algebraic simplifications for z=i*x).

   Second, for 0 <= x <= 50, it uses Chebyshev polynomial approximations,
   but with two twists:

      a) It maps x to y = 4 / (4+x) in [0,1].  This simple transformation,
         inspired by a similar transformation in the octave-forge/specfun
         erfcx by Soren Hauberg, results in much faster Chebyshev convergence
         than other simple transformations I have examined.

      b) Instead of using a single Chebyshev polynomial for the entire
         [0,1] y interval, we break the interval up into 100 equal
         subintervals, with a switch/lookup table, and use much lower
         degree Chebyshev polynomials in each subinterval. This greatly
         improves performance in my tests.

   For x < 0, we use the relationship erfcx(-x) = 2 exp(x^2) - erfc(x),
   with the usual checks for overflow etcetera.

   Performance-wise, it seems to be substantially faster than either
   the SLATEC DERFC function [or an erfcx function derived therefrom]
   or Cody's CALERF function (from netlib.org/specfun), while
   retaining near machine precision in accuracy.  */

/* Given y100=100*y, where y = 4/(4+x) for x >= 0, compute erfc(x).

   Uses a look-up table of 100 different Chebyshev polynomials
   for y intervals [0,0.01], [0.01,0.02], ...., [0.99,1], generated
   with the help of Maple and a little shell script.   This allows
   the Chebyshev polynomials to be of significantly lower degree (about 1/4)
   compared to fitting the whole [0,1] interval with a single polynomial. */
static double erfcx_y100(double y100)
{
  switch ((int) y100) {
case 0: {
double t = 2*y100 - 1;
return 0.70878032454106438663e-3 + (0.71234091047026302958e-3 + (0.35779077297597742384e-5 + (0.17403143962587937815e-7 + (0.81710660047307788845e-10 + (0.36885022360434957634e-12 + 0.15917038551111111111e-14 * t) * t) * t) * t) * t) * t;
}
case 1: {
double t = 2*y100 - 3;
return 0.21479143208285144230e-2 + (0.72686402367379996033e-3 + (0.36843175430938995552e-5 + (0.18071841272149201685e-7 + (0.85496449296040325555e-10 + (0.38852037518534291510e-12 + 0.16868473576888888889e-14 * t) * t) * t) * t) * t) * t;
}
case 2: {
double t = 2*y100 - 5;
return 0.36165255935630175090e-2 + (0.74182092323555510862e-3 + (0.37948319957528242260e-5 + (0.18771627021793087350e-7 + (0.89484715122415089123e-10 + (0.40935858517772440862e-12 + 0.17872061464888888889e-14 * t) * t) * t) * t) * t) * t;
}
case 3: {
double t = 2*y100 - 7;
return 0.51154983860031979264e-2 + (0.75722840734791660540e-3 + (0.39096425726735703941e-5 + (0.19504168704300468210e-7 + (0.93687503063178993915e-10 + (0.43143925959079664747e-12 + 0.18939926435555555556e-14 * t) * t) * t) * t) * t) * t;
}
case 4: {
double t = 2*y100 - 9;
return 0.66457513172673049824e-2 + (0.77310406054447454920e-3 + (0.40289510589399439385e-5 + (0.20271233238288381092e-7 + (0.98117631321709100264e-10 + (0.45484207406017752971e-12 + 0.20076352213333333333e-14 * t) * t) * t) * t) * t) * t;
}
case 5: {
double t = 2*y100 - 11;
return 0.82082389970241207883e-2 + (0.78946629611881710721e-3 + (0.41529701552622656574e-5 + (0.21074693344544655714e-7 + (0.10278874108587317989e-9 + (0.47965201390613339638e-12 + 0.21285907413333333333e-14 * t) * t) * t) * t) * t) * t;
}
case 6: {
double t = 2*y100 - 13;
return 0.98039537275352193165e-2 + (0.80633440108342840956e-3 + (0.42819241329736982942e-5 + (0.21916534346907168612e-7 + (0.10771535136565470914e-9 + (0.50595972623692822410e-12 + 0.22573462684444444444e-14 * t) * t) * t) * t) * t) * t;
}
case 7: {
double t = 2*y100 - 15;
return 0.11433927298290302370e-1 + (0.82372858383196561209e-3 + (0.44160495311765438816e-5 + (0.22798861426211986056e-7 + (0.11291291745879239736e-9 + (0.53386189365816880454e-12 + 0.23944209546666666667e-14 * t) * t) * t) * t) * t) * t;
}
case 8: {
double t = 2*y100 - 17;
return 0.13099232878814653979e-1 + (0.84167002467906968214e-3 + (0.45555958988457506002e-5 + (0.23723907357214175198e-7 + (0.11839789326602695603e-9 + (0.56346163067550237877e-12 + 0.25403679644444444444e-14 * t) * t) * t) * t) * t) * t;
}
case 9: {
double t = 2*y100 - 19;
return 0.14800987015587535621e-1 + (0.86018092946345943214e-3 + (0.47008265848816866105e-5 + (0.24694040760197315333e-7 + (0.12418779768752299093e-9 + (0.59486890370320261949e-12 + 0.26957764568888888889e-14 * t) * t) * t) * t) * t) * t;
}
case 10: {
double t = 2*y100 - 21;
return 0.16540351739394069380e-1 + (0.87928458641241463952e-3 + (0.48520195793001753903e-5 + (0.25711774900881709176e-7 + (0.13030128534230822419e-9 + (0.62820097586874779402e-12 + 0.28612737351111111111e-14 * t) * t) * t) * t) * t) * t;
}
case 11: {
double t = 2*y100 - 23;
return 0.18318536789842392647e-1 + (0.89900542647891721692e-3 + (0.50094684089553365810e-5 + (0.26779777074218070482e-7 + (0.13675822186304615566e-9 + (0.66358287745352705725e-12 + 0.30375273884444444444e-14 * t) * t) * t) * t) * t) * t;
}
case 12: {
double t = 2*y100 - 25;
return 0.20136801964214276775e-1 + (0.91936908737673676012e-3 + (0.51734830914104276820e-5 + (0.27900878609710432673e-7 + (0.14357976402809042257e-9 + (0.70114790311043728387e-12 + 0.32252476000000000000e-14 * t) * t) * t) * t) * t) * t;
}
case 13: {
double t = 2*y100 - 27;
return 0.21996459598282740954e-1 + (0.94040248155366777784e-3 + (0.53443911508041164739e-5 + (0.29078085538049374673e-7 + (0.15078844500329731137e-9 + (0.74103813647499204269e-12 + 0.34251892320000000000e-14 * t) * t) * t) * t) * t) * t;
}
case 14: {
double t = 2*y100 - 29;
return 0.23898877187226319502e-1 + (0.96213386835900177540e-3 + (0.55225386998049012752e-5 + (0.30314589961047687059e-7 + (0.15840826497296335264e-9 + (0.78340500472414454395e-12 + 0.36381553564444444445e-14 * t) * t) * t) * t) * t) * t;
}
case 15: {
double t = 2*y100 - 31;
return 0.25845480155298518485e-1 + (0.98459293067820123389e-3 + (0.57082915920051843672e-5 + (0.31613782169164830118e-7 + (0.16646478745529630813e-9 + (0.82840985928785407942e-12 + 0.38649975768888888890e-14 * t) * t) * t) * t) * t) * t;
}
case 16: {
double t = 2*y100 - 33;
return 0.27837754783474696598e-1 + (0.10078108563256892757e-2 + (0.59020366493792212221e-5 + (0.32979263553246520417e-7 + (0.17498524159268458073e-9 + (0.87622459124842525110e-12 + 0.41066206488888888890e-14 * t) * t) * t) * t) * t) * t;
}
case 17: {
double t = 2*y100 - 35;
return 0.29877251304899307550e-1 + (0.10318204245057349310e-2 + (0.61041829697162055093e-5 + (0.34414860359542720579e-7 + (0.18399863072934089607e-9 + (0.92703227366365046533e-12 + 0.43639844053333333334e-14 * t) * t) * t) * t) * t) * t;
}
case 18: {
double t = 2*y100 - 37;
return 0.31965587178596443475e-1 + (0.10566560976716574401e-2 + (0.63151633192414586770e-5 + (0.35924638339521924242e-7 + (0.19353584758781174038e-9 + (0.98102783859889264382e-12 + 0.46381060817777777779e-14 * t) * t) * t) * t) * t) * t;
}
case 19: {
double t = 2*y100 - 39;
return 0.34104450552588334840e-1 + (0.10823541191350532574e-2 + (0.65354356159553934436e-5 + (0.37512918348533521149e-7 + (0.20362979635817883229e-9 + (0.10384187833037282363e-11 + 0.49300625262222222221e-14 * t) * t) * t) * t) * t) * t;
}
case 20: {
double t = 2*y100 - 41;
return 0.36295603928292425716e-1 + (0.11089526167995268200e-2 + (0.67654845095518363577e-5 + (0.39184292949913591646e-7 + (0.21431552202133775150e-9 + (0.10994259106646731797e-11 + 0.52409949102222222221e-14 * t) * t) * t) * t) * t) * t;
}
case 21: {
double t = 2*y100 - 43;
return 0.38540888038840509795e-1 + (0.11364917134175420009e-2 + (0.70058230641246312003e-5 + (0.40943644083718586939e-7 + (0.22563034723692881631e-9 + (0.11642841011361992885e-11 + 0.55721092871111111110e-14 * t) * t) * t) * t) * t) * t;
}
case 22: {
double t = 2*y100 - 45;
return 0.40842225954785960651e-1 + (0.11650136437945673891e-2 + (0.72569945502343006619e-5 + (0.42796161861855042273e-7 + (0.23761401711005024162e-9 + (0.12332431172381557035e-11 + 0.59246802364444444445e-14 * t) * t) * t) * t) * t) * t;
}
case 23: {
double t = 2*y100 - 47;
return 0.43201627431540222422e-1 + (0.11945628793917272199e-2 + (0.75195743532849206263e-5 + (0.44747364553960993492e-7 + (0.25030885216472953674e-9 + (0.13065684400300476484e-11 + 0.63000532853333333334e-14 * t) * t) * t) * t) * t) * t;
}
case 24: {
double t = 2*y100 - 49;
return 0.45621193513810471438e-1 + (0.12251862608067529503e-2 + (0.77941720055551920319e-5 + (0.46803119830954460212e-7 + (0.26375990983978426273e-9 + (0.13845421370977119765e-11 + 0.66996477404444444445e-14 * t) * t) * t) * t) * t) * t;
}
case 25: {
double t = 2*y100 - 51;
return 0.48103121413299865517e-1 + (0.12569331386432195113e-2 + (0.80814333496367673980e-5 + (0.48969667335682018324e-7 + (0.27801515481905748484e-9 + (0.14674637611609884208e-11 + 0.71249589351111111110e-14 * t) * t) * t) * t) * t) * t;
}
case 26: {
double t = 2*y100 - 53;
return 0.50649709676983338501e-1 + (0.12898555233099055810e-2 + (0.83820428414568799654e-5 + (0.51253642652551838659e-7 + (0.29312563849675507232e-9 + (0.15556512782814827846e-11 + 0.75775607822222222221e-14 * t) * t) * t) * t) * t) * t;
}
case 27: {
double t = 2*y100 - 55;
return 0.53263363664388864181e-1 + (0.13240082443256975769e-2 + (0.86967260015007658418e-5 + (0.53662102750396795566e-7 + (0.30914568786634796807e-9 + (0.16494420240828493176e-11 + 0.80591079644444444445e-14 * t) * t) * t) * t) * t) * t;
}
case 28: {
double t = 2*y100 - 57;
return 0.55946601353500013794e-1 + (0.13594491197408190706e-2 + (0.90262520233016380987e-5 + (0.56202552975056695376e-7 + (0.32613310410503135996e-9 + (0.17491936862246367398e-11 + 0.85713381688888888890e-14 * t) * t) * t) * t) * t) * t;
}
case 29: {
double t = 2*y100 - 59;
return 0.58702059496154081813e-1 + (0.13962391363223647892e-2 + (0.93714365487312784270e-5 + (0.58882975670265286526e-7 + (0.34414937110591753387e-9 + (0.18552853109751857859e-11 + 0.91160736711111111110e-14 * t) * t) * t) * t) * t) * t;
}
case 30: {
double t = 2*y100 - 61;
return 0.61532500145144778048e-1 + (0.14344426411912015247e-2 + (0.97331446201016809696e-5 + (0.61711860507347175097e-7 + (0.36325987418295300221e-9 + (0.19681183310134518232e-11 + 0.96952238400000000000e-14 * t) * t) * t) * t) * t) * t;
}
case 31: {
double t = 2*y100 - 63;
return 0.64440817576653297993e-1 + (0.14741275456383131151e-2 + (0.10112293819576437838e-4 + (0.64698236605933246196e-7 + (0.38353412915303665586e-9 + (0.20881176114385120186e-11 + 0.10310784480000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 32: {
double t = 2*y100 - 65;
return 0.67430045633130393282e-1 + (0.15153655418916540370e-2 + (0.10509857606888328667e-4 + (0.67851706529363332855e-7 + (0.40504602194811140006e-9 + (0.22157325110542534469e-11 + 0.10964842115555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 33: {
double t = 2*y100 - 67;
return 0.70503365513338850709e-1 + (0.15582323336495709827e-2 + (0.10926868866865231089e-4 + (0.71182482239613507542e-7 + (0.42787405890153386710e-9 + (0.23514379522274416437e-11 + 0.11659571751111111111e-13 * t) * t) * t) * t) * t) * t;
}
case 34: {
double t = 2*y100 - 69;
return 0.73664114037944596353e-1 + (0.16028078812438820413e-2 + (0.11364423678778207991e-4 + (0.74701423097423182009e-7 + (0.45210162777476488324e-9 + (0.24957355004088569134e-11 + 0.12397238257777777778e-13 * t) * t) * t) * t) * t) * t;
}
case 35: {
double t = 2*y100 - 71;
return 0.76915792420819562379e-1 + (0.16491766623447889354e-2 + (0.11823685320041302169e-4 + (0.78420075993781544386e-7 + (0.47781726956916478925e-9 + (0.26491544403815724749e-11 + 0.13180196462222222222e-13 * t) * t) * t) * t) * t) * t;
}
case 36: {
double t = 2*y100 - 73;
return 0.80262075578094612819e-1 + (0.16974279491709504117e-2 + (0.12305888517309891674e-4 + (0.82350717698979042290e-7 + (0.50511496109857113929e-9 + (0.28122528497626897696e-11 + 0.14010889635555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 37: {
double t = 2*y100 - 75;
return 0.83706822008980357446e-1 + (0.17476561032212656962e-2 + (0.12812343958540763368e-4 + (0.86506399515036435592e-7 + (0.53409440823869467453e-9 + (0.29856186620887555043e-11 + 0.14891851591111111111e-13 * t) * t) * t) * t) * t) * t;
}
case 38: {
double t = 2*y100 - 77;
return 0.87254084284461718231e-1 + (0.17999608886001962327e-2 + (0.13344443080089492218e-4 + (0.90900994316429008631e-7 + (0.56486134972616465316e-9 + (0.31698707080033956934e-11 + 0.15825697795555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 39: {
double t = 2*y100 - 79;
return 0.90908120182172748487e-1 + (0.18544478050657699758e-2 + (0.13903663143426120077e-4 + (0.95549246062549906177e-7 + (0.59752787125242054315e-9 + (0.33656597366099099413e-11 + 0.16815130613333333333e-13 * t) * t) * t) * t) * t) * t;
}
case 40: {
double t = 2*y100 - 81;
return 0.94673404508075481121e-1 + (0.19112284419887303347e-2 + (0.14491572616545004930e-4 + (0.10046682186333613697e-6 + (0.63221272959791000515e-9 + (0.35736693975589130818e-11 + 0.17862931591111111111e-13 * t) * t) * t) * t) * t) * t;
}
case 41: {
double t = 2*y100 - 83;
return 0.98554641648004456555e-1 + (0.19704208544725622126e-2 + (0.15109836875625443935e-4 + (0.10567036667675984067e-6 + (0.66904168640019354565e-9 + (0.37946171850824333014e-11 + 0.18971959040000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 42: {
double t = 2*y100 - 85;
return 0.10255677889470089531e0 + (0.20321499629472857418e-2 + (0.15760224242962179564e-4 + (0.11117756071353507391e-6 + (0.70814785110097658502e-9 + (0.40292553276632563925e-11 + 0.20145143075555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 43: {
double t = 2*y100 - 87;
return 0.10668502059865093318e0 + (0.20965479776148731610e-2 + (0.16444612377624983565e-4 + (0.11700717962026152749e-6 + (0.74967203250938418991e-9 + (0.42783716186085922176e-11 + 0.21385479360000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 44: {
double t = 2*y100 - 89;
return 0.11094484319386444474e0 + (0.21637548491908170841e-2 + (0.17164995035719657111e-4 + (0.12317915750735938089e-6 + (0.79376309831499633734e-9 + (0.45427901763106353914e-11 + 0.22696025653333333333e-13 * t) * t) * t) * t) * t) * t;
}
case 45: {
double t = 2*y100 - 91;
return 0.11534201115268804714e0 + (0.22339187474546420375e-2 + (0.17923489217504226813e-4 + (0.12971465288245997681e-6 + (0.84057834180389073587e-9 + (0.48233721206418027227e-11 + 0.24079890062222222222e-13 * t) * t) * t) * t) * t) * t;
}
case 46: {
double t = 2*y100 - 93;
return 0.11988259392684094740e0 + (0.23071965691918689601e-2 + (0.18722342718958935446e-4 + (0.13663611754337957520e-6 + (0.89028385488493287005e-9 + (0.51210161569225846701e-11 + 0.25540227111111111111e-13 * t) * t) * t) * t) * t) * t;
}
case 47: {
double t = 2*y100 - 95;
return 0.12457298393509812907e0 + (0.23837544771809575380e-2 + (0.19563942105711612475e-4 + (0.14396736847739470782e-6 + (0.94305490646459247016e-9 + (0.54366590583134218096e-11 + 0.27080225920000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 48: {
double t = 2*y100 - 97;
return 0.12941991566142438816e0 + (0.24637684719508859484e-2 + (0.20450821127475879816e-4 + (0.15173366280523906622e-6 + (0.99907632506389027739e-9 + (0.57712760311351625221e-11 + 0.28703099555555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 49: {
double t = 2*y100 - 99;
return 0.13443048593088696613e0 + (0.25474249981080823877e-2 + (0.21385669591362915223e-4 + (0.15996177579900443030e-6 + (0.10585428844575134013e-8 + (0.61258809536787882989e-11 + 0.30412080142222222222e-13 * t) * t) * t) * t) * t) * t;
}
case 50: {
double t = 2*y100 - 101;
return 0.13961217543434561353e0 + (0.26349215871051761416e-2 + (0.22371342712572567744e-4 + (0.16868008199296822247e-6 + (0.11216596910444996246e-8 + (0.65015264753090890662e-11 + 0.32210394506666666666e-13 * t) * t) * t) * t) * t) * t;
}
case 51: {
double t = 2*y100 - 103;
return 0.14497287157673800690e0 + (0.27264675383982439814e-2 + (0.23410870961050950197e-4 + (0.17791863939526376477e-6 + (0.11886425714330958106e-8 + (0.68993039665054288034e-11 + 0.34101266222222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 52: {
double t = 2*y100 - 105;
return 0.15052089272774618151e0 + (0.28222846410136238008e-2 + (0.24507470422713397006e-4 + (0.18770927679626136909e-6 + (0.12597184587583370712e-8 + (0.73203433049229821618e-11 + 0.36087889048888888890e-13 * t) * t) * t) * t) * t) * t;
}
case 53: {
double t = 2*y100 - 107;
return 0.15626501395774612325e0 + (0.29226079376196624949e-2 + (0.25664553693768450545e-4 + (0.19808568415654461964e-6 + (0.13351257759815557897e-8 + (0.77658124891046760667e-11 + 0.38173420035555555555e-13 * t) * t) * t) * t) * t) * t;
}
case 54: {
double t = 2*y100 - 109;
return 0.16221449434620737567e0 + (0.30276865332726475672e-2 + (0.26885741326534564336e-4 + (0.20908350604346384143e-6 + (0.14151148144240728728e-8 + (0.82369170665974313027e-11 + 0.40360957457777777779e-13 * t) * t) * t) * t) * t) * t;
}
case 55: {
double t = 2*y100 - 111;
return 0.16837910595412130659e0 + (0.31377844510793082301e-2 + (0.28174873844911175026e-4 + (0.22074043807045782387e-6 + (0.14999481055996090039e-8 + (0.87348993661930809254e-11 + 0.42653528977777777779e-13 * t) * t) * t) * t) * t) * t;
}
case 56: {
double t = 2*y100 - 113;
return 0.17476916455659369953e0 + (0.32531815370903068316e-2 + (0.29536024347344364074e-4 + (0.23309632627767074202e-6 + (0.15899007843582444846e-8 + (0.92610375235427359475e-11 + 0.45054073102222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 57: {
double t = 2*y100 - 115;
return 0.18139556223643701364e0 + (0.33741744168096996041e-2 + (0.30973511714709500836e-4 + (0.24619326937592290996e-6 + (0.16852609412267750744e-8 + (0.98166442942854895573e-11 + 0.47565418097777777779e-13 * t) * t) * t) * t) * t) * t;
}
case 58: {
double t = 2*y100 - 117;
return 0.18826980194443664549e0 + (0.35010775057740317997e-2 + (0.32491914440014267480e-4 + (0.26007572375886319028e-6 + (0.17863299617388376116e-8 + (0.10403065638343878679e-10 + 0.50190265831111111110e-13 * t) * t) * t) * t) * t) * t;
}
case 59: {
double t = 2*y100 - 119;
return 0.19540403413693967350e0 + (0.36342240767211326315e-2 + (0.34096085096200907289e-4 + (0.27479061117017637474e-6 + (0.18934228504790032826e-8 + (0.11021679075323598664e-10 + 0.52931171733333333334e-13 * t) * t) * t) * t) * t) * t;
}
case 60: {
double t = 2*y100 - 121;
return 0.20281109560651886959e0 + (0.37739673859323597060e-2 + (0.35791165457592409054e-4 + (0.29038742889416172404e-6 + (0.20068685374849001770e-8 + (0.11673891799578381999e-10 + 0.55790523093333333334e-13 * t) * t) * t) * t) * t) * t;
}
case 61: {
double t = 2*y100 - 123;
return 0.21050455062669334978e0 + (0.39206818613925652425e-2 + (0.37582602289680101704e-4 + (0.30691836231886877385e-6 + (0.21270101645763677824e-8 + (0.12361138551062899455e-10 + 0.58770520160000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 62: {
double t = 2*y100 - 125;
return 0.21849873453703332479e0 + (0.40747643554689586041e-2 + (0.39476163820986711501e-4 + (0.32443839970139918836e-6 + (0.22542053491518680200e-8 + (0.13084879235290858490e-10 + 0.61873153262222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 63: {
double t = 2*y100 - 127;
return 0.22680879990043229327e0 + (0.42366354648628516935e-2 + (0.41477956909656896779e-4 + (0.34300544894502810002e-6 + (0.23888264229264067658e-8 + (0.13846596292818514601e-10 + 0.65100183751111111110e-13 * t) * t) * t) * t) * t) * t;
}
case 64: {
double t = 2*y100 - 129;
return 0.23545076536988703937e0 + (0.44067409206365170888e-2 + (0.43594444916224700881e-4 + (0.36268045617760415178e-6 + (0.25312606430853202748e-8 + (0.14647791812837903061e-10 + 0.68453122631111111110e-13 * t) * t) * t) * t) * t) * t;
}
case 65: {
double t = 2*y100 - 131;
return 0.24444156740777432838e0 + (0.45855530511605787178e-2 + (0.45832466292683085475e-4 + (0.38352752590033030472e-6 + (0.26819103733055603460e-8 + (0.15489984390884756993e-10 + 0.71933206364444444445e-13 * t) * t) * t) * t) * t) * t;
}
case 66: {
double t = 2*y100 - 133;
return 0.25379911500634264643e0 + (0.47735723208650032167e-2 + (0.48199253896534185372e-4 + (0.40561404245564732314e-6 + (0.28411932320871165585e-8 + (0.16374705736458320149e-10 + 0.75541379822222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 67: {
double t = 2*y100 - 135;
return 0.26354234756393613032e0 + (0.49713289477083781266e-2 + (0.50702455036930367504e-4 + (0.42901079254268185722e-6 + (0.30095422058900481753e-8 + (0.17303497025347342498e-10 + 0.79278273368888888890e-13 * t) * t) * t) * t) * t) * t;
}
case 68: {
double t = 2*y100 - 137;
return 0.27369129607732343398e0 + (0.51793846023052643767e-2 + (0.53350152258326602629e-4 + (0.45379208848865015485e-6 + (0.31874057245814381257e-8 + (0.18277905010245111046e-10 + 0.83144182364444444445e-13 * t) * t) * t) * t) * t) * t;
}
case 69: {
double t = 2*y100 - 139;
return 0.28426714781640316172e0 + (0.53983341916695141966e-2 + (0.56150884865255810638e-4 + (0.48003589196494734238e-6 + (0.33752476967570796349e-8 + (0.19299477888083469086e-10 + 0.87139049137777777779e-13 * t) * t) * t) * t) * t) * t;
}
case 70: {
double t = 2*y100 - 141;
return 0.29529231465348519920e0 + (0.56288077305420795663e-2 + (0.59113671189913307427e-4 + (0.50782393781744840482e-6 + (0.35735475025851713168e-8 + (0.20369760937017070382e-10 + 0.91262442613333333334e-13 * t) * t) * t) * t) * t) * t;
}
case 71: {
double t = 2*y100 - 143;
return 0.30679050522528838613e0 + (0.58714723032745403331e-2 + (0.62248031602197686791e-4 + (0.53724185766200945789e-6 + (0.37827999418960232678e-8 + (0.21490291930444538307e-10 + 0.95513539182222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 72: {
double t = 2*y100 - 145;
return 0.31878680111173319425e0 + (0.61270341192339103514e-2 + (0.65564012259707640976e-4 + (0.56837930287837738996e-6 + (0.40035151353392378882e-8 + (0.22662596341239294792e-10 + 0.99891109760000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 73: {
double t = 2*y100 - 147;
return 0.33130773722152622027e0 + (0.63962406646798080903e-2 + (0.69072209592942396666e-4 + (0.60133006661885941812e-6 + (0.42362183765883466691e-8 + (0.23888182347073698382e-10 + 0.10439349811555555556e-12 * t) * t) * t) * t) * t) * t;
}
case 74: {
double t = 2*y100 - 149;
return 0.34438138658041336523e0 + (0.66798829540414007258e-2 + (0.72783795518603561144e-4 + (0.63619220443228800680e-6 + (0.44814499336514453364e-8 + (0.25168535651285475274e-10 + 0.10901861383111111111e-12 * t) * t) * t) * t) * t) * t;
}
case 75: {
double t = 2*y100 - 151;
return 0.35803744972380175583e0 + (0.69787978834882685031e-2 + (0.76710543371454822497e-4 + (0.67306815308917386747e-6 + (0.47397647975845228205e-8 + (0.26505114141143050509e-10 + 0.11376390933333333333e-12 * t) * t) * t) * t) * t) * t;
}
case 76: {
double t = 2*y100 - 153;
return 0.37230734890119724188e0 + (0.72938706896461381003e-2 + (0.80864854542670714092e-4 + (0.71206484718062688779e-6 + (0.50117323769745883805e-8 + (0.27899342394100074165e-10 + 0.11862637614222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 77: {
double t = 2*y100 - 155;
return 0.38722432730555448223e0 + (0.76260375162549802745e-2 + (0.85259785810004603848e-4 + (0.75329383305171327677e-6 + (0.52979361368388119355e-8 + (0.29352606054164086709e-10 + 0.12360253370666666667e-12 * t) * t) * t) * t) * t) * t;
}
case 78: {
double t = 2*y100 - 157;
return 0.40282355354616940667e0 + (0.79762880915029728079e-2 + (0.89909077342438246452e-4 + (0.79687137961956194579e-6 + (0.55989731807360403195e-8 + (0.30866246101464869050e-10 + 0.12868841946666666667e-12 * t) * t) * t) * t) * t) * t;
}
case 79: {
double t = 2*y100 - 159;
return 0.41914223158913787649e0 + (0.83456685186950463538e-2 + (0.94827181359250161335e-4 + (0.84291858561783141014e-6 + (0.59154537751083485684e-8 + (0.32441553034347469291e-10 + 0.13387957943111111111e-12 * t) * t) * t) * t) * t) * t;
}
case 80: {
double t = 2*y100 - 161;
return 0.43621971639463786896e0 + (0.87352841828289495773e-2 + (0.10002929142066799966e-3 + (0.89156148280219880024e-6 + (0.62480008150788597147e-8 + (0.34079760983458878910e-10 + 0.13917107176888888889e-12 * t) * t) * t) * t) * t) * t;
}
case 81: {
double t = 2*y100 - 163;
return 0.45409763548534330981e0 + (0.91463027755548240654e-2 + (0.10553137232446167258e-3 + (0.94293113464638623798e-6 + (0.65972492312219959885e-8 + (0.35782041795476563662e-10 + 0.14455745872000000000e-12 * t) * t) * t) * t) * t) * t;
}
case 82: {
double t = 2*y100 - 165;
return 0.47282001668512331468e0 + (0.95799574408860463394e-2 + (0.11135019058000067469e-3 + (0.99716373005509038080e-6 + (0.69638453369956970347e-8 + (0.37549499088161345850e-10 + 0.15003280712888888889e-12 * t) * t) * t) * t) * t) * t;
}
case 83: {
double t = 2*y100 - 167;
return 0.49243342227179841649e0 + (0.10037550043909497071e-1 + (0.11750334542845234952e-3 + (0.10544006716188967172e-5 + (0.73484461168242224872e-8 + (0.39383162326435752965e-10 + 0.15559069118222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 84: {
double t = 2*y100 - 169;
return 0.51298708979209258326e0 + (0.10520454564612427224e-1 + (0.12400930037494996655e-3 + (0.11147886579371265246e-5 + (0.77517184550568711454e-8 + (0.41283980931872622611e-10 + 0.16122419680000000000e-12 * t) * t) * t) * t) * t) * t;
}
case 85: {
double t = 2*y100 - 171;
return 0.53453307979101369843e0 + (0.11030120618800726938e-1 + (0.13088741519572269581e-3 + (0.11784797595374515432e-5 + (0.81743383063044825400e-8 + (0.43252818449517081051e-10 + 0.16692592640000000000e-12 * t) * t) * t) * t) * t) * t;
}
case 86: {
double t = 2*y100 - 173;
return 0.55712643071169299478e0 + (0.11568077107929735233e-1 + (0.13815797838036651289e-3 + (0.12456314879260904558e-5 + (0.86169898078969313597e-8 + (0.45290446811539652525e-10 + 0.17268801084444444444e-12 * t) * t) * t) * t) * t) * t;
}
case 87: {
double t = 2*y100 - 175;
return 0.58082532122519320968e0 + (0.12135935999503877077e-1 + (0.14584223996665838559e-3 + (0.13164068573095710742e-5 + (0.90803643355106020163e-8 + (0.47397540713124619155e-10 + 0.17850211608888888889e-12 * t) * t) * t) * t) * t) * t;
}
case 88: {
double t = 2*y100 - 177;
return 0.60569124025293375554e0 + (0.12735396239525550361e-1 + (0.15396244472258863344e-3 + (0.13909744385382818253e-5 + (0.95651595032306228245e-8 + (0.49574672127669041550e-10 + 0.18435945564444444444e-12 * t) * t) * t) * t) * t) * t;
}
case 89: {
double t = 2*y100 - 179;
return 0.63178916494715716894e0 + (0.13368247798287030927e-1 + (0.16254186562762076141e-3 + (0.14695084048334056083e-5 + (0.10072078109604152350e-7 + (0.51822304995680707483e-10 + 0.19025081422222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 90: {
double t = 2*y100 - 181;
return 0.65918774689725319200e0 + (0.14036375850601992063e-1 + (0.17160483760259706354e-3 + (0.15521885688723188371e-5 + (0.10601827031535280590e-7 + (0.54140790105837520499e-10 + 0.19616655146666666667e-12 * t) * t) * t) * t) * t) * t;
}
case 91: {
double t = 2*y100 - 183;
return 0.68795950683174433822e0 + (0.14741765091365869084e-1 + (0.18117679143520433835e-3 + (0.16392004108230585213e-5 + (0.11155116068018043001e-7 + (0.56530360194925690374e-10 + 0.20209663662222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 92: {
double t = 2*y100 - 185;
return 0.71818103808729967036e0 + (0.15486504187117112279e-1 + (0.19128428784550923217e-3 + (0.17307350969359975848e-5 + (0.11732656736113607751e-7 + (0.58991125287563833603e-10 + 0.20803065333333333333e-12 * t) * t) * t) * t) * t) * t;
}
case 93: {
double t = 2*y100 - 187;
return 0.74993321911726254661e0 + (0.16272790364044783382e-1 + (0.20195505163377912645e-3 + (0.18269894883203346953e-5 + (0.12335161021630225535e-7 + (0.61523068312169087227e-10 + 0.21395783431111111111e-12 * t) * t) * t) * t) * t) * t;
}
case 94: {
double t = 2*y100 - 189;
return 0.78330143531283492729e0 + (0.17102934132652429240e-1 + (0.21321800585063327041e-3 + (0.19281661395543913713e-5 + (0.12963340087354341574e-7 + (0.64126040998066348872e-10 + 0.21986708942222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 95: {
double t = 2*y100 - 191;
return 0.81837581041023811832e0 + (0.17979364149044223802e-1 + (0.22510330592753129006e-3 + (0.20344732868018175389e-5 + (0.13617902941839949718e-7 + (0.66799760083972474642e-10 + 0.22574701262222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 96: {
double t = 2*y100 - 193;
return 0.85525144775685126237e0 + (0.18904632212547561026e-1 + (0.23764237370371255638e-3 + (0.21461248251306387979e-5 + (0.14299555071870523786e-7 + (0.69543803864694171934e-10 + 0.23158593688888888889e-12 * t) * t) * t) * t) * t) * t;
}
case 97: {
double t = 2*y100 - 195;
return 0.89402868170849933734e0 + (0.19881418399127202569e-1 + (0.25086793128395995798e-3 + (0.22633402747585233180e-5 + (0.15008997042116532283e-7 + (0.72357609075043941261e-10 + 0.23737194737777777778e-12 * t) * t) * t) * t) * t) * t;
}
case 98: {
double t = 2*y100 - 197;
return 0.93481333942870796363e0 + (0.20912536329780368893e-1 + (0.26481403465998477969e-3 + (0.23863447359754921676e-5 + (0.15746923065472184451e-7 + (0.75240468141720143653e-10 + 0.24309291271111111111e-12 * t) * t) * t) * t) * t) * t;
}
case 99: {
double t = 2*y100 - 199;
return 0.97771701335885035464e0 + (0.22000938572830479551e-1 + (0.27951610702682383001e-3 + (0.25153688325245314530e-5 + (0.16514019547822821453e-7 + (0.78191526829368231251e-10 + 0.24873652355555555556e-12 * t) * t) * t) * t) * t) * t;
}
  }
  // we only get here if y = 1, i.e. |x| < 4*eps, in which case
  // erfcx is within 1e-15 of 1..
  return 1.0;
}

double FADDEEVA_RE(erfcx)(double x)
{
  if (x >= 0) {
    if (x > 50) { // continued-fraction expansion is faster
      const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
      if (x > 5e7) // 1-term expansion, important to avoid overflow
        return ispi / x;
      /* 5-term expansion (rely on compiler for CSE), simplified from:
                ispi / (x+0.5/(x+1/(x+1.5/(x+2/x))))  */
      return ispi*((x*x) * (x*x+4.5) + 2) / (x * ((x*x) * (x*x+5) + 3.75));
    }
    return erfcx_y100(400/(4+x));
  }
  else
    return x < -26.7 ? HUGE_VAL : (x < -6.1 ? 2*exp(x*x)
                                   : 2*exp(x*x) - erfcx_y100(400/(4-x)));
}

/////////////////////////////////////////////////////////////////////////
/* Compute a scaled Dawson integral
            FADDEEVA(w_im)(x) = 2*Dawson(x)/sqrt(pi)
   equivalent to the imaginary part w(x) for real x.

   Uses methods similar to the erfcx calculation above: continued fractions
   for large |x|, a lookup table of Chebyshev polynomials for smaller |x|,
   and finally a Taylor expansion for |x|<0.01.

   Steven G. Johnson, October 2012. */

/* Given y100=100*y, where y = 1/(1+x) for x >= 0, compute w_im(x).

   Uses a look-up table of 100 different Chebyshev polynomials
   for y intervals [0,0.01], [0.01,0.02], ...., [0.99,1], generated
   with the help of Maple and a little shell script.   This allows
   the Chebyshev polynomials to be of significantly lower degree (about 1/30)
   compared to fitting the whole [0,1] interval with a single polynomial. */
static double w_im_y100(double y100, double x) {
  switch ((int) y100) {
    case 0: {
      double t = 2*y100 - 1;
      return 0.28351593328822191546e-2 + (0.28494783221378400759e-2 + (0.14427470563276734183e-4 + (0.10939723080231588129e-6 + (0.92474307943275042045e-9 + (0.89128907666450075245e-11 + 0.92974121935111111110e-13 * t) * t) * t) * t) * t) * t;
    }
    case 1: {
      double t = 2*y100 - 3;
      return 0.85927161243940350562e-2 + (0.29085312941641339862e-2 + (0.15106783707725582090e-4 + (0.11716709978531327367e-6 + (0.10197387816021040024e-8 + (0.10122678863073360769e-10 + 0.10917479678400000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 2: {
      double t = 2*y100 - 5;
      return 0.14471159831187703054e-1 + (0.29703978970263836210e-2 + (0.15835096760173030976e-4 + (0.12574803383199211596e-6 + (0.11278672159518415848e-8 + (0.11547462300333495797e-10 + 0.12894535335111111111e-12 * t) * t) * t) * t) * t) * t;
    }
    case 3: {
      double t = 2*y100 - 7;
      return 0.20476320420324610618e-1 + (0.30352843012898665856e-2 + (0.16617609387003727409e-4 + (0.13525429711163116103e-6 + (0.12515095552507169013e-8 + (0.13235687543603382345e-10 + 0.15326595042666666667e-12 * t) * t) * t) * t) * t) * t;
    }
    case 4: {
      double t = 2*y100 - 9;
      return 0.26614461952489004566e-1 + (0.31034189276234947088e-2 + (0.17460268109986214274e-4 + (0.14582130824485709573e-6 + (0.13935959083809746345e-8 + (0.15249438072998932900e-10 + 0.18344741882133333333e-12 * t) * t) * t) * t) * t) * t;
    }
    case 5: {
      double t = 2*y100 - 11;
      return 0.32892330248093586215e-1 + (0.31750557067975068584e-2 + (0.18369907582308672632e-4 + (0.15761063702089457882e-6 + (0.15577638230480894382e-8 + (0.17663868462699097951e-10 + (0.22126732680711111111e-12 + 0.30273474177737853668e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 6: {
      double t = 2*y100 - 13;
      return 0.39317207681134336024e-1 + (0.32504779701937539333e-2 + (0.19354426046513400534e-4 + (0.17081646971321290539e-6 + (0.17485733959327106250e-8 + (0.20593687304921961410e-10 + (0.26917401949155555556e-12 + 0.38562123837725712270e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 7: {
      double t = 2*y100 - 15;
      return 0.45896976511367738235e-1 + (0.33300031273110976165e-2 + (0.20423005398039037313e-4 + (0.18567412470376467303e-6 + (0.19718038363586588213e-8 + (0.24175006536781219807e-10 + (0.33059982791466666666e-12 + 0.49756574284439426165e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 8: {
      double t = 2*y100 - 17;
      return 0.52640192524848962855e-1 + (0.34139883358846720806e-2 + (0.21586390240603337337e-4 + (0.20247136501568904646e-6 + (0.22348696948197102935e-8 + (0.28597516301950162548e-10 + (0.41045502119111111110e-12 + 0.65151614515238361946e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 9: {
      double t = 2*y100 - 19;
      return 0.59556171228656770456e-1 + (0.35028374386648914444e-2 + (0.22857246150998562824e-4 + (0.22156372146525190679e-6 + (0.25474171590893813583e-8 + (0.34122390890697400584e-10 + (0.51593189879111111110e-12 + 0.86775076853908006938e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 10: {
      double t = 2*y100 - 21;
      return 0.66655089485108212551e-1 + (0.35970095381271285568e-2 + (0.24250626164318672928e-4 + (0.24339561521785040536e-6 + (0.29221990406518411415e-8 + (0.41117013527967776467e-10 + (0.65786450716444444445e-12 + 0.11791885745450623331e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 11: {
      double t = 2*y100 - 23;
      return 0.73948106345519174661e-1 + (0.36970297216569341748e-2 + (0.25784588137312868792e-4 + (0.26853012002366752770e-6 + (0.33763958861206729592e-8 + (0.50111549981376976397e-10 + (0.85313857496888888890e-12 + 0.16417079927706899860e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 12: {
      double t = 2*y100 - 25;
      return 0.81447508065002963203e-1 + (0.38035026606492705117e-2 + (0.27481027572231851896e-4 + (0.29769200731832331364e-6 + (0.39336816287457655076e-8 + (0.61895471132038157624e-10 + (0.11292303213511111111e-11 + 0.23558532213703884304e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 13: {
      double t = 2*y100 - 27;
      return 0.89166884027582716628e-1 + (0.39171301322438946014e-2 + (0.29366827260422311668e-4 + (0.33183204390350724895e-6 + (0.46276006281647330524e-8 + (0.77692631378169813324e-10 + (0.15335153258844444444e-11 + 0.35183103415916026911e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 14: {
      double t = 2*y100 - 29;
      return 0.97121342888032322019e-1 + (0.40387340353207909514e-2 + (0.31475490395950776930e-4 + (0.37222714227125135042e-6 + (0.55074373178613809996e-8 + (0.99509175283990337944e-10 + (0.21552645758222222222e-11 + 0.55728651431872687605e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 15: {
      double t = 2*y100 - 31;
      return 0.10532778218603311137e0 + (0.41692873614065380607e-2 + (0.33849549774889456984e-4 + (0.42064596193692630143e-6 + (0.66494579697622432987e-8 + (0.13094103581931802337e-9 + (0.31896187409777777778e-11 + 0.97271974184476560742e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 16: {
      double t = 2*y100 - 33;
      return 0.11380523107427108222e0 + (0.43099572287871821013e-2 + (0.36544324341565929930e-4 + (0.47965044028581857764e-6 + (0.81819034238463698796e-8 + (0.17934133239549647357e-9 + (0.50956666166186293627e-11 + (0.18850487318190638010e-12 + 0.79697813173519853340e-14 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 17: {
      double t = 2*y100 - 35;
      return 0.12257529703447467345e0 + (0.44621675710026986366e-2 + (0.39634304721292440285e-4 + (0.55321553769873381819e-6 + (0.10343619428848520870e-7 + (0.26033830170470368088e-9 + (0.87743837749108025357e-11 + (0.34427092430230063401e-12 + 0.10205506615709843189e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 18: {
      double t = 2*y100 - 37;
      return 0.13166276955656699478e0 + (0.46276970481783001803e-2 + (0.43225026380496399310e-4 + (0.64799164020016902656e-6 + (0.13580082794704641782e-7 + (0.39839800853954313927e-9 + (0.14431142411840000000e-10 + 0.42193457308830027541e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 19: {
      double t = 2*y100 - 39;
      return 0.14109647869803356475e0 + (0.48088424418545347758e-2 + (0.47474504753352150205e-4 + (0.77509866468724360352e-6 + (0.18536851570794291724e-7 + (0.60146623257887570439e-9 + (0.18533978397305276318e-10 + (0.41033845938901048380e-13 - 0.46160680279304825485e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 20: {
      double t = 2*y100 - 41;
      return 0.15091057940548936603e0 + (0.50086864672004685703e-2 + (0.52622482832192230762e-4 + (0.95034664722040355212e-6 + (0.25614261331144718769e-7 + (0.80183196716888606252e-9 + (0.12282524750534352272e-10 + (-0.10531774117332273617e-11 - 0.86157181395039646412e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 21: {
      double t = 2*y100 - 43;
      return 0.16114648116017010770e0 + (0.52314661581655369795e-2 + (0.59005534545908331315e-4 + (0.11885518333915387760e-5 + (0.33975801443239949256e-7 + (0.82111547144080388610e-9 + (-0.12357674017312854138e-10 + (-0.24355112256914479176e-11 - 0.75155506863572930844e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 22: {
      double t = 2*y100 - 45;
      return 0.17185551279680451144e0 + (0.54829002967599420860e-2 + (0.67013226658738082118e-4 + (0.14897400671425088807e-5 + (0.40690283917126153701e-7 + (0.44060872913473778318e-9 + (-0.52641873433280000000e-10 - 0.30940587864543343124e-11 * t) * t) * t) * t) * t) * t) * t;
    }
    case 23: {
      double t = 2*y100 - 47;
      return 0.18310194559815257381e0 + (0.57701559375966953174e-2 + (0.76948789401735193483e-4 + (0.18227569842290822512e-5 + (0.41092208344387212276e-7 + (-0.44009499965694442143e-9 + (-0.92195414685628803451e-10 + (-0.22657389705721753299e-11 + 0.10004784908106839254e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 24: {
      double t = 2*y100 - 49;
      return 0.19496527191546630345e0 + (0.61010853144364724856e-2 + (0.88812881056342004864e-4 + (0.21180686746360261031e-5 + (0.30652145555130049203e-7 + (-0.16841328574105890409e-8 + (-0.11008129460612823934e-9 + (-0.12180794204544515779e-12 + 0.15703325634590334097e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 25: {
      double t = 2*y100 - 51;
      return 0.20754006813966575720e0 + (0.64825787724922073908e-2 + (0.10209599627522311893e-3 + (0.22785233392557600468e-5 + (0.73495224449907568402e-8 + (-0.29442705974150112783e-8 + (-0.94082603434315016546e-10 + (0.23609990400179321267e-11 + 0.14141908654269023788e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 26: {
      double t = 2*y100 - 53;
      return 0.22093185554845172146e0 + (0.69182878150187964499e-2 + (0.11568723331156335712e-3 + (0.22060577946323627739e-5 + (-0.26929730679360840096e-7 + (-0.38176506152362058013e-8 + (-0.47399503861054459243e-10 + (0.40953700187172127264e-11 + 0.69157730376118511127e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 27: {
      double t = 2*y100 - 55;
      return 0.23524827304057813918e0 + (0.74063350762008734520e-2 + (0.12796333874615790348e-3 + (0.18327267316171054273e-5 + (-0.66742910737957100098e-7 + (-0.40204740975496797870e-8 + (0.14515984139495745330e-10 + (0.44921608954536047975e-11 - 0.18583341338983776219e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 28: {
      double t = 2*y100 - 57;
      return 0.25058626331812744775e0 + (0.79377285151602061328e-2 + (0.13704268650417478346e-3 + (0.11427511739544695861e-5 + (-0.10485442447768377485e-6 + (-0.34850364756499369763e-8 + (0.72656453829502179208e-10 + (0.36195460197779299406e-11 - 0.84882136022200714710e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 29: {
      double t = 2*y100 - 59;
      return 0.26701724900280689785e0 + (0.84959936119625864274e-2 + (0.14112359443938883232e-3 + (0.17800427288596909634e-6 + (-0.13443492107643109071e-6 + (-0.23512456315677680293e-8 + (0.11245846264695936769e-9 + (0.19850501334649565404e-11 - 0.11284666134635050832e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 30: {
      double t = 2*y100 - 61;
      return 0.28457293586253654144e0 + (0.90581563892650431899e-2 + (0.13880520331140646738e-3 + (-0.97262302362522896157e-6 + (-0.15077100040254187366e-6 + (-0.88574317464577116689e-9 + (0.12760311125637474581e-9 + (0.20155151018282695055e-12 - 0.10514169375181734921e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 31: {
      double t = 2*y100 - 63;
      return 0.30323425595617385705e0 + (0.95968346790597422934e-2 + (0.12931067776725883939e-3 + (-0.21938741702795543986e-5 + (-0.15202888584907373963e-6 + (0.61788350541116331411e-9 + (0.11957835742791248256e-9 + (-0.12598179834007710908e-11 - 0.75151817129574614194e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 32: {
      double t = 2*y100 - 65;
      return 0.32292521181517384379e0 + (0.10082957727001199408e-1 + (0.11257589426154962226e-3 + (-0.33670890319327881129e-5 + (-0.13910529040004008158e-6 + (0.19170714373047512945e-8 + (0.94840222377720494290e-10 + (-0.21650018351795353201e-11 - 0.37875211678024922689e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 33: {
      double t = 2*y100 - 67;
      return 0.34351233557911753862e0 + (0.10488575435572745309e-1 + (0.89209444197248726614e-4 + (-0.43893459576483345364e-5 + (-0.11488595830450424419e-6 + (0.28599494117122464806e-8 + (0.61537542799857777779e-10 - 0.24935749227658002212e-11 * t) * t) * t) * t) * t) * t) * t;
    }
    case 34: {
      double t = 2*y100 - 69;
      return 0.36480946642143669093e0 + (0.10789304203431861366e-1 + (0.60357993745283076834e-4 + (-0.51855862174130669389e-5 + (-0.83291664087289801313e-7 + (0.33898011178582671546e-8 + (0.27082948188277716482e-10 + (-0.23603379397408694974e-11 + 0.19328087692252869842e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 35: {
      double t = 2*y100 - 71;
      return 0.38658679935694939199e0 + (0.10966119158288804999e-1 + (0.27521612041849561426e-4 + (-0.57132774537670953638e-5 + (-0.48404772799207914899e-7 + (0.35268354132474570493e-8 + (-0.32383477652514618094e-11 + (-0.19334202915190442501e-11 + 0.32333189861286460270e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 36: {
      double t = 2*y100 - 73;
      return 0.40858275583808707870e0 + (0.11006378016848466550e-1 + (-0.76396376685213286033e-5 + (-0.59609835484245791439e-5 + (-0.13834610033859313213e-7 + (0.33406952974861448790e-8 + (-0.26474915974296612559e-10 + (-0.13750229270354351983e-11 + 0.36169366979417390637e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 37: {
      double t = 2*y100 - 75;
      return 0.43051714914006682977e0 + (0.10904106549500816155e-1 + (-0.43477527256787216909e-4 + (-0.59429739547798343948e-5 + (0.17639200194091885949e-7 + (0.29235991689639918688e-8 + (-0.41718791216277812879e-10 + (-0.81023337739508049606e-12 + 0.33618915934461994428e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 38: {
      double t = 2*y100 - 77;
      return 0.45210428135559607406e0 + (0.10659670756384400554e-1 + (-0.78488639913256978087e-4 + (-0.56919860886214735936e-5 + (0.44181850467477733407e-7 + (0.23694306174312688151e-8 + (-0.49492621596685443247e-10 + (-0.31827275712126287222e-12 + 0.27494438742721623654e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 39: {
      double t = 2*y100 - 79;
      return 0.47306491195005224077e0 + (0.10279006119745977570e-1 + (-0.11140268171830478306e-3 + (-0.52518035247451432069e-5 + (0.64846898158889479518e-7 + (0.17603624837787337662e-8 + (-0.51129481592926104316e-10 + (0.62674584974141049511e-13 + 0.20055478560829935356e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 40: {
      double t = 2*y100 - 81;
      return 0.49313638965719857647e0 + (0.97725799114772017662e-2 + (-0.14122854267291533334e-3 + (-0.46707252568834951907e-5 + (0.79421347979319449524e-7 + (0.11603027184324708643e-8 + (-0.48269605844397175946e-10 + (0.32477251431748571219e-12 + 0.12831052634143527985e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 41: {
      double t = 2*y100 - 83;
      return 0.51208057433416004042e0 + (0.91542422354009224951e-2 + (-0.16726530230228647275e-3 + (-0.39964621752527649409e-5 + (0.88232252903213171454e-7 + (0.61343113364949928501e-9 + (-0.42516755603130443051e-10 + (0.47910437172240209262e-12 + 0.66784341874437478953e-14 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 42: {
      double t = 2*y100 - 85;
      return 0.52968945458607484524e0 + (0.84400880445116786088e-2 + (-0.18908729783854258774e-3 + (-0.32725905467782951931e-5 + (0.91956190588652090659e-7 + (0.14593989152420122909e-9 + (-0.35239490687644444445e-10 + 0.54613829888448694898e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 43: {
      double t = 2*y100 - 87;
      return 0.54578857454330070965e0 + (0.76474155195880295311e-2 + (-0.20651230590808213884e-3 + (-0.25364339140543131706e-5 + (0.91455367999510681979e-7 + (-0.23061359005297528898e-9 + (-0.27512928625244444444e-10 + 0.54895806008493285579e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 44: {
      double t = 2*y100 - 89;
      return 0.56023851910298493910e0 + (0.67938321739997196804e-2 + (-0.21956066613331411760e-3 + (-0.18181127670443266395e-5 + (0.87650335075416845987e-7 + (-0.51548062050366615977e-9 + (-0.20068462174044444444e-10 + 0.50912654909758187264e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 45: {
      double t = 2*y100 - 91;
      return 0.57293478057455721150e0 + (0.58965321010394044087e-2 + (-0.22841145229276575597e-3 + (-0.11404605562013443659e-5 + (0.81430290992322326296e-7 + (-0.71512447242755357629e-9 + (-0.13372664928000000000e-10 + 0.44461498336689298148e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 46: {
      double t = 2*y100 - 93;
      return 0.58380635448407827360e0 + (0.49717469530842831182e-2 + (-0.23336001540009645365e-3 + (-0.51952064448608850822e-6 + (0.73596577815411080511e-7 + (-0.84020916763091566035e-9 + (-0.76700972702222222221e-11 + 0.36914462807972467044e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 47: {
      double t = 2*y100 - 95;
      return 0.59281340237769489597e0 + (0.40343592069379730568e-2 + (-0.23477963738658326185e-3 + (0.34615944987790224234e-7 + (0.64832803248395814574e-7 + (-0.90329163587627007971e-9 + (-0.30421940400000000000e-11 + 0.29237386653743536669e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 48: {
      double t = 2*y100 - 97;
      return 0.59994428743114271918e0 + (0.30976579788271744329e-2 + (-0.23308875765700082835e-3 + (0.51681681023846925160e-6 + (0.55694594264948268169e-7 + (-0.91719117313243464652e-9 + (0.53982743680000000000e-12 + 0.22050829296187771142e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 49: {
      double t = 2*y100 - 99;
      return 0.60521224471819875444e0 + (0.21732138012345456060e-2 + (-0.22872428969625997456e-3 + (0.92588959922653404233e-6 + (0.46612665806531930684e-7 + (-0.89393722514414153351e-9 + (0.31718550353777777778e-11 + 0.15705458816080549117e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 50: {
      double t = 2*y100 - 101;
      return 0.60865189969791123620e0 + (0.12708480848877451719e-2 + (-0.22212090111534847166e-3 + (0.12636236031532793467e-5 + (0.37904037100232937574e-7 + (-0.84417089968101223519e-9 + (0.49843180828444444445e-11 + 0.10355439441049048273e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 51: {
      double t = 2*y100 - 103;
      return 0.61031580103499200191e0 + (0.39867436055861038223e-3 + (-0.21369573439579869291e-3 + (0.15339402129026183670e-5 + (0.29787479206646594442e-7 + (-0.77687792914228632974e-9 + (0.61192452741333333334e-11 + 0.60216691829459295780e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 52: {
      double t = 2*y100 - 105;
      return 0.61027109047879835868e0 + (-0.43680904508059878254e-3 + (-0.20383783788303894442e-3 + (0.17421743090883439959e-5 + (0.22400425572175715576e-7 + (-0.69934719320045128997e-9 + (0.67152759655111111110e-11 + 0.26419960042578359995e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 53: {
      double t = 2*y100 - 107;
      return 0.60859639489217430521e0 + (-0.12305921390962936873e-2 + (-0.19290150253894682629e-3 + (0.18944904654478310128e-5 + (0.15815530398618149110e-7 + (-0.61726850580964876070e-9 + 0.68987888999111111110e-11 * t) * t) * t) * t) * t) * t;
    }
    case 54: {
      double t = 2*y100 - 109;
      return 0.60537899426486075181e0 + (-0.19790062241395705751e-2 + (-0.18120271393047062253e-3 + (0.19974264162313241405e-5 + (0.10055795094298172492e-7 + (-0.53491997919318263593e-9 + (0.67794550295111111110e-11 - 0.17059208095741511603e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 55: {
      double t = 2*y100 - 111;
      return 0.60071229457904110537e0 + (-0.26795676776166354354e-2 + (-0.16901799553627508781e-3 + (0.20575498324332621581e-5 + (0.51077165074461745053e-8 + (-0.45536079828057221858e-9 + (0.64488005516444444445e-11 - 0.29311677573152766338e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 56: {
      double t = 2*y100 - 113;
      return 0.59469361520112714738e0 + (-0.33308208190600993470e-2 + (-0.15658501295912405679e-3 + (0.20812116912895417272e-5 + (0.93227468760614182021e-9 + (-0.38066673740116080415e-9 + (0.59806790359111111110e-11 - 0.36887077278950440597e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 57: {
      double t = 2*y100 - 115;
      return 0.58742228631775388268e0 + (-0.39321858196059227251e-2 + (-0.14410441141450122535e-3 + (0.20743790018404020716e-5 + (-0.25261903811221913762e-8 + (-0.31212416519526924318e-9 + (0.54328422462222222221e-11 - 0.40864152484979815972e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 58: {
      double t = 2*y100 - 117;
      return 0.57899804200033018447e0 + (-0.44838157005618913447e-2 + (-0.13174245966501437965e-3 + (0.20425306888294362674e-5 + (-0.53330296023875447782e-8 + (-0.25041289435539821014e-9 + (0.48490437205333333334e-11 - 0.42162206939169045177e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 59: {
      double t = 2*y100 - 119;
      return 0.56951968796931245974e0 + (-0.49864649488074868952e-2 + (-0.11963416583477567125e-3 + (0.19906021780991036425e-5 + (-0.75580140299436494248e-8 + (-0.19576060961919820491e-9 + (0.42613011928888888890e-11 - 0.41539443304115604377e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 60: {
      double t = 2*y100 - 121;
      return 0.55908401930063918964e0 + (-0.54413711036826877753e-2 + (-0.10788661102511914628e-3 + (0.19229663322982839331e-5 + (-0.92714731195118129616e-8 + (-0.14807038677197394186e-9 + (0.36920870298666666666e-11 - 0.39603726688419162617e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 61: {
      double t = 2*y100 - 123;
      return 0.54778496152925675315e0 + (-0.58501497933213396670e-2 + (-0.96582314317855227421e-4 + (0.18434405235069270228e-5 + (-0.10541580254317078711e-7 + (-0.10702303407788943498e-9 + (0.31563175582222222222e-11 - 0.36829748079110481422e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 62: {
      double t = 2*y100 - 125;
      return 0.53571290831682823999e0 + (-0.62147030670760791791e-2 + (-0.85782497917111760790e-4 + (0.17553116363443470478e-5 + (-0.11432547349815541084e-7 + (-0.72157091369041330520e-10 + (0.26630811607111111111e-11 - 0.33578660425893164084e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 63: {
      double t = 2*y100 - 127;
      return 0.52295422962048434978e0 + (-0.65371404367776320720e-2 + (-0.75530164941473343780e-4 + (0.16613725797181276790e-5 + (-0.12003521296598910761e-7 + (-0.42929753689181106171e-10 + (0.22170894940444444444e-11 - 0.30117697501065110505e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 64: {
      double t = 2*y100 - 129;
      return 0.50959092577577886140e0 + (-0.68197117603118591766e-2 + (-0.65852936198953623307e-4 + (0.15639654113906716939e-5 + (-0.12308007991056524902e-7 + (-0.18761997536910939570e-10 + (0.18198628922666666667e-11 - 0.26638355362285200932e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 65: {
      double t = 2*y100 - 131;
      return 0.49570040481823167970e0 + (-0.70647509397614398066e-2 + (-0.56765617728962588218e-4 + (0.14650274449141448497e-5 + (-0.12393681471984051132e-7 + (0.92904351801168955424e-12 + (0.14706755960177777778e-11 - 0.23272455351266325318e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 66: {
      double t = 2*y100 - 133;
      return 0.48135536250935238066e0 + (-0.72746293327402359783e-2 + (-0.48272489495730030780e-4 + (0.13661377309113939689e-5 + (-0.12302464447599382189e-7 + (0.16707760028737074907e-10 + (0.11672928324444444444e-11 - 0.20105801424709924499e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 67: {
      double t = 2*y100 - 135;
      return 0.46662374675511439448e0 + (-0.74517177649528487002e-2 + (-0.40369318744279128718e-4 + (0.12685621118898535407e-5 + (-0.12070791463315156250e-7 + (0.29105507892605823871e-10 + (0.90653314645333333334e-12 - 0.17189503312102982646e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 68: {
      double t = 2*y100 - 137;
      return 0.45156879030168268778e0 + (-0.75983560650033817497e-2 + (-0.33045110380705139759e-4 + (0.11732956732035040896e-5 + (-0.11729986947158201869e-7 + (0.38611905704166441308e-10 + (0.68468768305777777779e-12 - 0.14549134330396754575e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 69: {
      double t = 2*y100 - 139;
      return 0.43624909769330896904e0 + (-0.77168291040309554679e-2 + (-0.26283612321339907756e-4 + (0.10811018836893550820e-5 + (-0.11306707563739851552e-7 + (0.45670446788529607380e-10 + (0.49782492549333333334e-12 - 0.12191983967561779442e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 70: {
      double t = 2*y100 - 141;
      return 0.42071877443548481181e0 + (-0.78093484015052730097e-2 + (-0.20064596897224934705e-4 + (0.99254806680671890766e-6 + (-0.10823412088884741451e-7 + (0.50677203326904716247e-10 + (0.34200547594666666666e-12 - 0.10112698698356194618e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 71: {
      double t = 2*y100 - 143;
      return 0.40502758809710844280e0 + (-0.78780384460872937555e-2 + (-0.14364940764532853112e-4 + (0.90803709228265217384e-6 + (-0.10298832847014466907e-7 + (0.53981671221969478551e-10 + (0.21342751381333333333e-12 - 0.82975901848387729274e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 72: {
      double t = 2*y100 - 145;
      return 0.38922115269731446690e0 + (-0.79249269708242064120e-2 + (-0.91595258799106970453e-5 + (0.82783535102217576495e-6 + (-0.97484311059617744437e-8 + (0.55889029041660225629e-10 + (0.10851981336888888889e-12 - 0.67278553237853459757e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 73: {
      double t = 2*y100 - 147;
      return 0.37334112915460307335e0 + (-0.79519385109223148791e-2 + (-0.44219833548840469752e-5 + (0.75209719038240314732e-6 + (-0.91848251458553190451e-8 + (0.56663266668051433844e-10 + (0.23995894257777777778e-13 - 0.53819475285389344313e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 74: {
      double t = 2*y100 - 149;
      return 0.35742543583374223085e0 + (-0.79608906571527956177e-2 + (-0.12530071050975781198e-6 + (0.68088605744900552505e-6 + (-0.86181844090844164075e-8 + (0.56530784203816176153e-10 + (-0.43120012248888888890e-13 - 0.42372603392496813810e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 75: {
      double t = 2*y100 - 151;
      return 0.34150846431979618536e0 + (-0.79534924968773806029e-2 + (0.37576885610891515813e-5 + (0.61419263633090524326e-6 + (-0.80565865409945960125e-8 + (0.55684175248749269411e-10 + (-0.95486860764444444445e-13 - 0.32712946432984510595e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 76: {
      double t = 2*y100 - 153;
      return 0.32562129649136346824e0 + (-0.79313448067948884309e-2 + (0.72539159933545300034e-5 + (0.55195028297415503083e-6 + (-0.75063365335570475258e-8 + (0.54281686749699595941e-10 - 0.13545424295111111111e-12 * t) * t) * t) * t) * t) * t;
    }
    case 77: {
      double t = 2*y100 - 155;
      return 0.30979191977078391864e0 + (-0.78959416264207333695e-2 + (0.10389774377677210794e-4 + (0.49404804463196316464e-6 + (-0.69722488229411164685e-8 + (0.52469254655951393842e-10 - 0.16507860650666666667e-12 * t) * t) * t) * t) * t) * t;
    }
    case 78: {
      double t = 2*y100 - 157;
      return 0.29404543811214459904e0 + (-0.78486728990364155356e-2 + (0.13190885683106990459e-4 + (0.44034158861387909694e-6 + (-0.64578942561562616481e-8 + (0.50354306498006928984e-10 - 0.18614473550222222222e-12 * t) * t) * t) * t) * t) * t;
    }
    case 79: {
      double t = 2*y100 - 159;
      return 0.27840427686253660515e0 + (-0.77908279176252742013e-2 + (0.15681928798708548349e-4 + (0.39066226205099807573e-6 + (-0.59658144820660420814e-8 + (0.48030086420373141763e-10 - 0.20018995173333333333e-12 * t) * t) * t) * t) * t) * t;
    }
    case 80: {
      double t = 2*y100 - 161;
      return 0.26288838011163800908e0 + (-0.77235993576119469018e-2 + (0.17886516796198660969e-4 + (0.34482457073472497720e-6 + (-0.54977066551955420066e-8 + (0.45572749379147269213e-10 - 0.20852924954666666667e-12 * t) * t) * t) * t) * t) * t;
    }
    case 81: {
      double t = 2*y100 - 163;
      return 0.24751539954181029717e0 + (-0.76480877165290370975e-2 + (0.19827114835033977049e-4 + (0.30263228619976332110e-6 + (-0.50545814570120129947e-8 + (0.43043879374212005966e-10 - 0.21228012028444444444e-12 * t) * t) * t) * t) * t) * t;
    }
    case 82: {
      double t = 2*y100 - 165;
      return 0.23230087411688914593e0 + (-0.75653060136384041587e-2 + (0.21524991113020016415e-4 + (0.26388338542539382413e-6 + (-0.46368974069671446622e-8 + (0.40492715758206515307e-10 - 0.21238627815111111111e-12 * t) * t) * t) * t) * t) * t;
    }
    case 83: {
      double t = 2*y100 - 167;
      return 0.21725840021297341931e0 + (-0.74761846305979730439e-2 + (0.23000194404129495243e-4 + (0.22837400135642906796e-6 + (-0.42446743058417541277e-8 + (0.37958104071765923728e-10 - 0.20963978568888888889e-12 * t) * t) * t) * t) * t) * t;
    }
    case 84: {
      double t = 2*y100 - 169;
      return 0.20239979200788191491e0 + (-0.73815761980493466516e-2 + (0.24271552727631854013e-4 + (0.19590154043390012843e-6 + (-0.38775884642456551753e-8 + (0.35470192372162901168e-10 - 0.20470131678222222222e-12 * t) * t) * t) * t) * t) * t;
    }
    case 85: {
      double t = 2*y100 - 171;
      return 0.18773523211558098962e0 + (-0.72822604530339834448e-2 + (0.25356688567841293697e-4 + (0.16626710297744290016e-6 + (-0.35350521468015310830e-8 + (0.33051896213898864306e-10 - 0.19811844544000000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 86: {
      double t = 2*y100 - 173;
      return 0.17327341258479649442e0 + (-0.71789490089142761950e-2 + (0.26272046822383820476e-4 + (0.13927732375657362345e-6 + (-0.32162794266956859603e-8 + (0.30720156036105652035e-10 - 0.19034196304000000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 87: {
      double t = 2*y100 - 175;
      return 0.15902166648328672043e0 + (-0.70722899934245504034e-2 + (0.27032932310132226025e-4 + (0.11474573347816568279e-6 + (-0.29203404091754665063e-8 + (0.28487010262547971859e-10 - 0.18174029063111111111e-12 * t) * t) * t) * t) * t) * t;
    }
    case 88: {
      double t = 2*y100 - 177;
      return 0.14498609036610283865e0 + (-0.69628725220045029273e-2 + (0.27653554229160596221e-4 + (0.92493727167393036470e-7 + (-0.26462055548683583849e-8 + (0.26360506250989943739e-10 - 0.17261211260444444444e-12 * t) * t) * t) * t) * t) * t;
    }
    case 89: {
      double t = 2*y100 - 179;
      return 0.13117165798208050667e0 + (-0.68512309830281084723e-2 + (0.28147075431133863774e-4 + (0.72351212437979583441e-7 + (-0.23927816200314358570e-8 + (0.24345469651209833155e-10 - 0.16319736960000000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 90: {
      double t = 2*y100 - 181;
      return 0.11758232561160626306e0 + (-0.67378491192463392927e-2 + (0.28525664781722907847e-4 + (0.54156999310046790024e-7 + (-0.21589405340123827823e-8 + (0.22444150951727334619e-10 - 0.15368675584000000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 91: {
      double t = 2*y100 - 183;
      return 0.10422112945361673560e0 + (-0.66231638959845581564e-2 + (0.28800551216363918088e-4 + (0.37758983397952149613e-7 + (-0.19435423557038933431e-8 + (0.20656766125421362458e-10 - 0.14422990012444444444e-12 * t) * t) * t) * t) * t) * t;
    }
    case 92: {
      double t = 2*y100 - 185;
      return 0.91090275493541084785e-1 + (-0.65075691516115160062e-2 + (0.28982078385527224867e-4 + (0.23014165807643012781e-7 + (-0.17454532910249875958e-8 + (0.18981946442680092373e-10 - 0.13494234691555555556e-12 * t) * t) * t) * t) * t) * t;
    }
    case 93: {
      double t = 2*y100 - 187;
      return 0.78191222288771379358e-1 + (-0.63914190297303976434e-2 + (0.29079759021299682675e-4 + (0.97885458059415717014e-8 + (-0.15635596116134296819e-8 + (0.17417110744051331974e-10 - 0.12591151763555555556e-12 * t) * t) * t) * t) * t) * t;
    }
    case 94: {
      double t = 2*y100 - 189;
      return 0.65524757106147402224e-1 + (-0.62750311956082444159e-2 + (0.29102328354323449795e-4 + (-0.20430838882727954582e-8 + (-0.13967781903855367270e-8 + (0.15958771833747057569e-10 - 0.11720175765333333333e-12 * t) * t) * t) * t) * t) * t;
    }
    case 95: {
      double t = 2*y100 - 191;
      return 0.53091065838453612773e-1 + (-0.61586898417077043662e-2 + (0.29057796072960100710e-4 + (-0.12597414620517987536e-7 + (-0.12440642607426861943e-8 + (0.14602787128447932137e-10 - 0.10885859114666666667e-12 * t) * t) * t) * t) * t) * t;
    }
    case 96: {
      double t = 2*y100 - 193;
      return 0.40889797115352738582e-1 + (-0.60426484889413678200e-2 + (0.28953496450191694606e-4 + (-0.21982952021823718400e-7 + (-0.11044169117553026211e-8 + (0.13344562332430552171e-10 - 0.10091231402844444444e-12 * t) * t) * t) * t) * t) * t;
    }
  case 97: case 98:
  case 99: case 100: { // use Taylor expansion for small x (|x| <= 0.0309...)
      //  (2/sqrt(pi)) * (x - 2/3 x^3  + 4/15 x^5  - 8/105 x^7 + 16/945 x^9)
      double x2 = x*x;
      return x * (1.1283791670955125739
                  - x2 * (0.75225277806367504925
                          - x2 * (0.30090111122547001970
                                  - x2 * (0.085971746064420005629
                                          - x2 * 0.016931216931216931217))));
    }
  }
  /* Since 0 <= y100 < 101, this is only reached if x is NaN,
     in which case we should return NaN. */
  return NaN;
}

double FADDEEVA(w_im)(double x)
{
  if (x >= 0) {
    if (x > 45) { // continued-fraction expansion is faster
      const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
      if (x > 5e7) // 1-term expansion, important to avoid overflow
        return ispi / x;
      /* 5-term expansion (rely on compiler for CSE), simplified from:
                ispi / (x-0.5/(x-1/(x-1.5/(x-2/x))))  */
      return ispi*((x*x) * (x*x-4.5) + 2) / (x * ((x*x) * (x*x-5) + 3.75));
    }
    return w_im_y100(100/(1+x), x);
  }
  else { // = -FADDEEVA(w_im)(-x)
    if (x < -45) { // continued-fraction expansion is faster
      const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
      if (x < -5e7) // 1-term expansion, important to avoid overflow
        return ispi / x;
      /* 5-term expansion (rely on compiler for CSE), simplified from:
                ispi / (x-0.5/(x-1/(x-1.5/(x-2/x))))  */
      return ispi*((x*x) * (x*x-4.5) + 2) / (x * ((x*x) * (x*x-5) + 3.75));
    }
    return -w_im_y100(100/(1-x), -x);
  }
}

/////////////////////////////////////////////////////////////////////////

// Compile with -DTEST_FADDEEVA to compile a little test program
#ifdef TEST_FADDEEVA

#ifdef __cplusplus
#  include <cstdio>
#else
#  include <stdio.h>
#endif

// compute relative error |b-a|/|a|, handling case of NaN and Inf,
static double relerr(double a, double b) {
  if (isnan(a) || isnan(b) || isinf(a) || isinf(b)) {
    if ((isnan(a) && !isnan(b)) || (!isnan(a) && isnan(b)) ||
        (isinf(a) && !isinf(b)) || (!isinf(a) && isinf(b)) ||
        (isinf(a) && isinf(b) && a*b < 0))
      return Inf; // "infinite" error
    return 0; // matching infinity/nan results counted as zero error
  }
  if (a == 0)
    return b == 0 ? 0 : Inf;
  else
    return fabs((b-a) / a);
}

int main(void) {
  double errmax_all = 0;
  {
    printf("############# w(z) tests #############\n");
#define NTST 57 // define instead of const for C compatibility
    cmplx z[NTST] = {
      C(624.2,-0.26123),
      C(-0.4,3.),
      C(0.6,2.),
      C(-1.,1.),
      C(-1.,-9.),
      C(-1.,9.),
      C(-0.0000000234545,1.1234),
      C(-3.,5.1),
      C(-53,30.1),
      C(0.0,0.12345),
      C(11,1),
      C(-22,-2),
      C(9,-28),
      C(21,-33),
      C(1e5,1e5),
      C(1e14,1e14),
      C(-3001,-1000),
      C(1e160,-1e159),
      C(-6.01,0.01),
      C(-0.7,-0.7),
      C(2.611780000000000e+01, 4.540909610972489e+03),
      C(0.8e7,0.3e7),
      C(-20,-19.8081),
      C(1e-16,-1.1e-16),
      C(2.3e-8,1.3e-8),
      C(6.3,-1e-13),
      C(6.3,1e-20),
      C(1e-20,6.3),
      C(1e-20,16.3),
      C(9,1e-300),
      C(6.01,0.11),
      C(8.01,1.01e-10),
      C(28.01,1e-300),
      C(10.01,1e-200),
      C(10.01,-1e-200),
      C(10.01,0.99e-10),
      C(10.01,-0.99e-10),
      C(1e-20,7.01),
      C(-1,7.01),
      C(5.99,7.01),
      C(1,0),
      C(55,0),
      C(-0.1,0),
      C(1e-20,0),
      C(0,5e-14),
      C(0,51),
      C(Inf,0),
      C(-Inf,0),
      C(0,Inf),
      C(0,-Inf),
      C(Inf,Inf),
      C(Inf,-Inf),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,Inf),
      C(Inf,NaN)
    };
    cmplx w[NTST] = { /* w(z), computed with WolframAlpha
                                   ... note that WolframAlpha is problematic
                                   some of the above inputs, so I had to
                                   use the continued-fraction expansion
                                   in WolframAlpha in some cases, or switch
                                   to Maple */
      C(-3.78270245518980507452677445620103199303131110e-7,
        0.000903861276433172057331093754199933411710053155),
      C(0.1764906227004816847297495349730234591778719532788,
        -0.02146550539468457616788719893991501311573031095617),
      C(0.2410250715772692146133539023007113781272362309451,
        0.06087579663428089745895459735240964093522265589350),
      C(0.30474420525691259245713884106959496013413834051768,
        -0.20821893820283162728743734725471561394145872072738),
      C(7.317131068972378096865595229600561710140617977e34,
        8.321873499714402777186848353320412813066170427e34),
      C(0.0615698507236323685519612934241429530190806818395,
        -0.00676005783716575013073036218018565206070072304635),
      C(0.3960793007699874918961319170187598400134746631,
        -5.593152259116644920546186222529802777409274656e-9),
      C(0.08217199226739447943295069917990417630675021771804,
        -0.04701291087643609891018366143118110965272615832184),
      C(0.00457246000350281640952328010227885008541748668738,
        -0.00804900791411691821818731763401840373998654987934),
      C(0.8746342859608052666092782112565360755791467973338452,
        0.),
      C(0.00468190164965444174367477874864366058339647648741,
        0.0510735563901306197993676329845149741675029197050),
      C(-0.0023193175200187620902125853834909543869428763219,
        -0.025460054739731556004902057663500272721780776336),
      C(9.11463368405637174660562096516414499772662584e304,
        3.97101807145263333769664875189354358563218932e305),
      C(-4.4927207857715598976165541011143706155432296e281,
        -2.8019591213423077494444700357168707775769028e281),
      C(2.820947917809305132678577516325951485807107151e-6,
        2.820947917668257736791638444590253942253354058e-6),
      C(2.82094791773878143474039725787438662716372268e-15,
        2.82094791773878143474039725773333923127678361e-15),
      C(-0.0000563851289696244350147899376081488003110150498,
        -0.000169211755126812174631861529808288295454992688),
      C(-5.586035480670854326218608431294778077663867e-162,
        5.586035480670854326218608431294778077663867e-161),
      C(0.00016318325137140451888255634399123461580248456,
        -0.095232456573009287370728788146686162555021209999),
      C(0.69504753678406939989115375989939096800793577783885,
        -1.8916411171103639136680830887017670616339912024317),
      C(0.0001242418269653279656612334210746733213167234822,
        7.145975826320186888508563111992099992116786763e-7),
      C(2.318587329648353318615800865959225429377529825e-8,
        6.182899545728857485721417893323317843200933380e-8),
      C(-0.0133426877243506022053521927604277115767311800303,
        -0.0148087097143220769493341484176979826888871576145),
      C(1.00000000000000012412170838050638522857747934,
        1.12837916709551279389615890312156495593616433e-16),
      C(0.9999999853310704677583504063775310832036830015,
        2.595272024519678881897196435157270184030360773e-8),
      C(-1.4731421795638279504242963027196663601154624e-15,
        0.090727659684127365236479098488823462473074709),
      C(5.79246077884410284575834156425396800754409308e-18,
        0.0907276596841273652364790985059772809093822374),
      C(0.0884658993528521953466533278764830881245144368,
        1.37088352495749125283269718778582613192166760e-22),
      C(0.0345480845419190424370085249304184266813447878,
        2.11161102895179044968099038990446187626075258e-23),
      C(6.63967719958073440070225527042829242391918213e-36,
        0.0630820900592582863713653132559743161572639353),
      C(0.00179435233208702644891092397579091030658500743634,
        0.0951983814805270647939647438459699953990788064762),
      C(9.09760377102097999924241322094863528771095448e-13,
        0.0709979210725138550986782242355007611074966717),
      C(7.2049510279742166460047102593255688682910274423e-304,
        0.0201552956479526953866611812593266285000876784321),
      C(3.04543604652250734193622967873276113872279682e-44,
        0.0566481651760675042930042117726713294607499165),
      C(3.04543604652250734193622967873276113872279682e-44,
        0.0566481651760675042930042117726713294607499165),
      C(0.5659928732065273429286988428080855057102069081e-12,
        0.056648165176067504292998527162143030538756683302),
      C(-0.56599287320652734292869884280802459698927645e-12,
        0.0566481651760675042929985271621430305387566833029),
      C(0.0796884251721652215687859778119964009569455462,
        1.11474461817561675017794941973556302717225126e-22),
      C(0.07817195821247357458545539935996687005781943386550,
        -0.01093913670103576690766705513142246633056714279654),
      C(0.04670032980990449912809326141164730850466208439937,
        0.03944038961933534137558064191650437353429669886545),
      C(0.36787944117144232159552377016146086744581113103176,
        0.60715770584139372911503823580074492116122092866515),
      C(0,
        0.010259688805536830986089913987516716056946786526145),
      C(0.99004983374916805357390597718003655777207908125383,
        -0.11208866436449538036721343053869621153527769495574),
      C(0.99999999999999999999999999999999999999990000,
        1.12837916709551257389615890312154517168802603e-20),
      C(0.999999999999943581041645226871305192054749891144158,
        0),
      C(0.0110604154853277201542582159216317923453996211744250,
        0),
      C(0,0),
      C(0,0),
      C(0,0),
      C(Inf,0),
      C(0,0),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,0),
      C(NaN,NaN),
      C(NaN,NaN)
    };
    double errmax = 0;
    for (int i = 0; i < NTST; ++i) {
      cmplx fw = FADDEEVA(w)(z[i],0.);
      double re_err = relerr(creal(w[i]), creal(fw));
      double im_err = relerr(cimag(w[i]), cimag(fw));
      printf("w(%g%+gi) = %g%+gi (vs. %g%+gi), re/im rel. err. = %0.2g/%0.2g)\n",
             creal(z[i]),cimag(z[i]), creal(fw),cimag(fw), creal(w[i]),cimag(w[i]),
             re_err, im_err);
      if (re_err > errmax) errmax = re_err;
      if (im_err > errmax) errmax = im_err;
    }
    if (errmax > 1e-13) {
      printf("FAILURE -- relative error %g too large!\n", errmax);
      return 1;
    }
    printf("SUCCESS (max relative error = %g)\n", errmax);
    if (errmax > errmax_all) errmax_all = errmax;
  }
  {
#undef NTST
#define NTST 41 // define instead of const for C compatibility
    cmplx z[NTST] = {
      C(1,2),
      C(-1,2),
      C(1,-2),
      C(-1,-2),
      C(9,-28),
      C(21,-33),
      C(1e3,1e3),
      C(-3001,-1000),
      C(1e160,-1e159),
      C(5.1e-3, 1e-8),
      C(-4.9e-3, 4.95e-3),
      C(4.9e-3, 0.5),
      C(4.9e-4, -0.5e1),
      C(-4.9e-5, -0.5e2),
      C(5.1e-3, 0.5),
      C(5.1e-4, -0.5e1),
      C(-5.1e-5, -0.5e2),
      C(1e-6,2e-6),
      C(0,2e-6),
      C(0,2),
      C(0,20),
      C(0,200),
      C(Inf,0),
      C(-Inf,0),
      C(0,Inf),
      C(0,-Inf),
      C(Inf,Inf),
      C(Inf,-Inf),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,Inf),
      C(Inf,NaN),
      C(1e-3,NaN),
      C(7e-2,7e-2),
      C(7e-2,-7e-4),
      C(-9e-2,7e-4),
      C(-9e-2,9e-2),
      C(-7e-4,9e-2),
      C(7e-2,0.9e-2),
      C(7e-2,1.1e-2)
    };
    cmplx w[NTST] = { // erf(z[i]), evaluated with Maple
      C(-0.5366435657785650339917955593141927494421,
        -5.049143703447034669543036958614140565553),
      C(0.5366435657785650339917955593141927494421,
        -5.049143703447034669543036958614140565553),
      C(-0.5366435657785650339917955593141927494421,
        5.049143703447034669543036958614140565553),
      C(0.5366435657785650339917955593141927494421,
        5.049143703447034669543036958614140565553),
      C(0.3359473673830576996788000505817956637777e304,
        -0.1999896139679880888755589794455069208455e304),
      C(0.3584459971462946066523939204836760283645e278,
        0.3818954885257184373734213077678011282505e280),
      C(0.9996020422657148639102150147542224526887,
        0.00002801044116908227889681753993542916894856),
      C(-1, 0),
      C(1, 0),
      C(0.005754683859034800134412990541076554934877,
        0.1128349818335058741511924929801267822634e-7),
      C(-0.005529149142341821193633460286828381876955,
        0.005585388387864706679609092447916333443570),
      C(0.007099365669981359632319829148438283865814,
        0.6149347012854211635026981277569074001219),
      C(0.3981176338702323417718189922039863062440e8,
        -0.8298176341665249121085423917575122140650e10),
      C(-Inf,
        -Inf),
      C(0.007389128308257135427153919483147229573895,
        0.6149332524601658796226417164791221815139),
      C(0.4143671923267934479245651547534414976991e8,
        -0.8298168216818314211557046346850921446950e10),
      C(-Inf,
        -Inf),
      C(0.1128379167099649964175513742247082845155e-5,
        0.2256758334191777400570377193451519478895e-5),
      C(0,
        0.2256758334194034158904576117253481476197e-5),
      C(0,
        18.56480241457555259870429191324101719886),
      C(0,
        0.1474797539628786202447733153131835124599e173),
      C(0,
        Inf),
      C(1,0),
      C(-1,0),
      C(0,Inf),
      C(0,-Inf),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,NaN),
      C(0.07924380404615782687930591956705225541145,
        0.07872776218046681145537914954027729115247),
      C(0.07885775828512276968931773651224684454495,
        -0.0007860046704118224342390725280161272277506),
      C(-0.1012806432747198859687963080684978759881,
        0.0007834934747022035607566216654982820299469),
      C(-0.1020998418798097910247132140051062512527,
        0.1010030778892310851309082083238896270340),
      C(-0.0007962891763147907785684591823889484764272,
        0.1018289385936278171741809237435404896152),
      C(0.07886408666470478681566329888615410479530,
        0.01010604288780868961492224347707949372245),
      C(0.07886723099940260286824654364807981336591,
        0.01235199327873258197931147306290916629654)
    };
#define TST(f,isc)                                                      \
    printf("############# " #f "(z) tests #############\n");            \
    double errmax = 0;                                                  \
    for (int i = 0; i < NTST; ++i) {                                    \
      cmplx fw = FADDEEVA(f)(z[i],0.);                  \
      double re_err = relerr(creal(w[i]), creal(fw));                   \
      double im_err = relerr(cimag(w[i]), cimag(fw));                   \
      printf(#f "(%g%+gi) = %g%+gi (vs. %g%+gi), re/im rel. err. = %0.2g/%0.2g)\n", \
             creal(z[i]),cimag(z[i]), creal(fw),cimag(fw), creal(w[i]),cimag(w[i]), \
             re_err, im_err);                                           \
      if (re_err > errmax) errmax = re_err;                             \
      if (im_err > errmax) errmax = im_err;                             \
    }                                                                   \
    if (errmax > 1e-13) {                                               \
      printf("FAILURE -- relative error %g too large!\n", errmax);      \
      return 1;                                                         \
    }                                                                   \
    printf("Checking " #f "(x) special case...\n");                     \
    for (int i = 0; i < 10000; ++i) {                                   \
      double x = pow(10., -300. + i * 600. / (10000 - 1));              \
      double re_err = relerr(FADDEEVA_RE(f)(x),                         \
                             creal(FADDEEVA(f)(C(x,x*isc),0.)));        \
      if (re_err > errmax) errmax = re_err;                             \
      re_err = relerr(FADDEEVA_RE(f)(-x),                               \
                      creal(FADDEEVA(f)(C(-x,x*isc),0.)));              \
      if (re_err > errmax) errmax = re_err;                             \
    }                                                                   \
    {                                                                   \
      double re_err = relerr(FADDEEVA_RE(f)(Inf),                       \
                             creal(FADDEEVA(f)(C(Inf,0.),0.))); \
      if (re_err > errmax) errmax = re_err;                             \
      re_err = relerr(FADDEEVA_RE(f)(-Inf),                             \
                      creal(FADDEEVA(f)(C(-Inf,0.),0.)));               \
      if (re_err > errmax) errmax = re_err;                             \
      re_err = relerr(FADDEEVA_RE(f)(NaN),                              \
                      creal(FADDEEVA(f)(C(NaN,0.),0.)));                \
      if (re_err > errmax) errmax = re_err;                             \
    }                                                                   \
    if (errmax > 1e-13) {                                               \
      printf("FAILURE -- relative error %g too large!\n", errmax);      \
      return 1;                                                         \
    }                                                                   \
    printf("SUCCESS (max relative error = %g)\n", errmax);              \
    if (errmax > errmax_all) errmax_all = errmax

    TST(erf, 1e-20);
  }
  {
    // since erfi just calls through to erf, just one test should
    // be sufficient to make sure I didn't screw up the signs or something
#undef NTST
#define NTST 1 // define instead of const for C compatibility
    cmplx z[NTST] = { C(1.234,0.5678) };
    cmplx w[NTST] = { // erfi(z[i]), computed with Maple
      C(1.081032284405373149432716643834106923212,
        1.926775520840916645838949402886591180834)
    };
    TST(erfi, 0);
  }
  {
    // since erfcx just calls through to w, just one test should
    // be sufficient to make sure I didn't screw up the signs or something
#undef NTST
#define NTST 1 // define instead of const for C compatibility
    cmplx z[NTST] = { C(1.234,0.5678) };
    cmplx w[NTST] = { // erfcx(z[i]), computed with Maple
      C(0.3382187479799972294747793561190487832579,
        -0.1116077470811648467464927471872945833154)
    };
    TST(erfcx, 0);
  }
  {
#undef NTST
#define NTST 30 // define instead of const for C compatibility
    cmplx z[NTST] = {
      C(1,2),
      C(-1,2),
      C(1,-2),
      C(-1,-2),
      C(9,-28),
      C(21,-33),
      C(1e3,1e3),
      C(-3001,-1000),
      C(1e160,-1e159),
      C(5.1e-3, 1e-8),
      C(0,2e-6),
      C(0,2),
      C(0,20),
      C(0,200),
      C(2e-6,0),
      C(2,0),
      C(20,0),
      C(200,0),
      C(Inf,0),
      C(-Inf,0),
      C(0,Inf),
      C(0,-Inf),
      C(Inf,Inf),
      C(Inf,-Inf),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,Inf),
      C(Inf,NaN),
      C(88,0)
    };
    cmplx w[NTST] = { // erfc(z[i]), evaluated with Maple
      C(1.536643565778565033991795559314192749442,
        5.049143703447034669543036958614140565553),
      C(0.4633564342214349660082044406858072505579,
        5.049143703447034669543036958614140565553),
      C(1.536643565778565033991795559314192749442,
        -5.049143703447034669543036958614140565553),
      C(0.4633564342214349660082044406858072505579,
        -5.049143703447034669543036958614140565553),
      C(-0.3359473673830576996788000505817956637777e304,
        0.1999896139679880888755589794455069208455e304),
      C(-0.3584459971462946066523939204836760283645e278,
        -0.3818954885257184373734213077678011282505e280),
      C(0.0003979577342851360897849852457775473112748,
        -0.00002801044116908227889681753993542916894856),
      C(2, 0),
      C(0, 0),
      C(0.9942453161409651998655870094589234450651,
        -0.1128349818335058741511924929801267822634e-7),
      C(1,
        -0.2256758334194034158904576117253481476197e-5),
      C(1,
        -18.56480241457555259870429191324101719886),
      C(1,
        -0.1474797539628786202447733153131835124599e173),
      C(1, -Inf),
      C(0.9999977432416658119838633199332831406314,
        0),
      C(0.004677734981047265837930743632747071389108,
        0),
      C(0.5395865611607900928934999167905345604088e-175,
        0),
      C(0, 0),
      C(0, 0),
      C(2, 0),
      C(1, -Inf),
      C(1, Inf),
      C(NaN, NaN),
      C(NaN, NaN),
      C(NaN, NaN),
      C(NaN, 0),
      C(1, NaN),
      C(NaN, NaN),
      C(NaN, NaN),
      C(0,0)
    };
    TST(erfc, 1e-20);
  }
  {
#undef NTST
#define NTST 48 // define instead of const for C compatibility
    cmplx z[NTST] = {
      C(2,1),
      C(-2,1),
      C(2,-1),
      C(-2,-1),
      C(-28,9),
      C(33,-21),
      C(1e3,1e3),
      C(-1000,-3001),
      C(1e-8, 5.1e-3),
      C(4.95e-3, -4.9e-3),
      C(5.1e-3, 5.1e-3),
      C(0.5, 4.9e-3),
      C(-0.5e1, 4.9e-4),
      C(-0.5e2, -4.9e-5),
      C(0.5e3, 4.9e-6),
      C(0.5, 5.1e-3),
      C(-0.5e1, 5.1e-4),
      C(-0.5e2, -5.1e-5),
      C(1e-6,2e-6),
      C(2e-6,0),
      C(2,0),
      C(20,0),
      C(200,0),
      C(0,4.9e-3),
      C(0,-5.1e-3),
      C(0,2e-6),
      C(0,-2),
      C(0,20),
      C(0,-200),
      C(Inf,0),
      C(-Inf,0),
      C(0,Inf),
      C(0,-Inf),
      C(Inf,Inf),
      C(Inf,-Inf),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,Inf),
      C(Inf,NaN),
      C(39, 6.4e-5),
      C(41, 6.09e-5),
      C(4.9e7, 5e-11),
      C(5.1e7, 4.8e-11),
      C(1e9, 2.4e-12),
      C(1e11, 2.4e-14),
      C(1e13, 2.4e-16),
      C(1e300, 2.4e-303)
    };
    cmplx w[NTST] = { // dawson(z[i]), evaluated with Maple
      C(0.1635394094345355614904345232875688576839,
        -0.1531245755371229803585918112683241066853),
      C(-0.1635394094345355614904345232875688576839,
        -0.1531245755371229803585918112683241066853),
      C(0.1635394094345355614904345232875688576839,
        0.1531245755371229803585918112683241066853),
      C(-0.1635394094345355614904345232875688576839,
        0.1531245755371229803585918112683241066853),
      C(-0.01619082256681596362895875232699626384420,
        -0.005210224203359059109181555401330902819419),
      C(0.01078377080978103125464543240346760257008,
        0.006866888783433775382193630944275682670599),
      C(-0.5808616819196736225612296471081337245459,
        0.6688593905505562263387760667171706325749),
      C(Inf,
        -Inf),
      C(0.1000052020902036118082966385855563526705e-7,
        0.005100088434920073153418834680320146441685),
      C(0.004950156837581592745389973960217444687524,
        -0.004899838305155226382584756154100963570500),
      C(0.005100176864319675957314822982399286703798,
        0.005099823128319785355949825238269336481254),
      C(0.4244534840871830045021143490355372016428,
        0.002820278933186814021399602648373095266538),
      C(-0.1021340733271046543881236523269967674156,
        -0.00001045696456072005761498961861088944159916),
      C(-0.01000200120119206748855061636187197886859,
        0.9805885888237419500266621041508714123763e-8),
      C(0.001000002000012000023960527532953151819595,
        -0.9800058800588007290937355024646722133204e-11),
      C(0.4244549085628511778373438768121222815752,
        0.002935393851311701428647152230552122898291),
      C(-0.1021340732357117208743299813648493928105,
        -0.00001088377943049851799938998805451564893540),
      C(-0.01000200120119126652710792390331206563616,
        0.1020612612857282306892368985525393707486e-7),
      C(0.1000000000007333333333344266666666664457e-5,
        0.2000000000001333333333323199999999978819e-5),
      C(0.1999999999994666666666675199999999990248e-5,
        0),
      C(0.3013403889237919660346644392864226952119,
        0),
      C(0.02503136792640367194699495234782353186858,
        0),
      C(0.002500031251171948248596912483183760683918,
        0),
      C(0,0.004900078433419939164774792850907128053308),
      C(0,-0.005100088434920074173454208832365950009419),
      C(0,0.2000000000005333333333341866666666676419e-5),
      C(0,-48.16001211429122974789822893525016528191),
      C(0,0.4627407029504443513654142715903005954668e174),
      C(0,-Inf),
      C(0,0),
      C(-0,0),
      C(0, Inf),
      C(0, -Inf),
      C(NaN, NaN),
      C(NaN, NaN),
      C(NaN, NaN),
      C(NaN, 0),
      C(0, NaN),
      C(NaN, NaN),
      C(NaN, NaN),
      C(0.01282473148489433743567240624939698290584,
        -0.2105957276516618621447832572909153498104e-7),
      C(0.01219875253423634378984109995893708152885,
        -0.1813040560401824664088425926165834355953e-7),
      C(0.1020408163265306334945473399689037886997e-7,
        -0.1041232819658476285651490827866174985330e-25),
      C(0.9803921568627452865036825956835185367356e-8,
        -0.9227220299884665067601095648451913375754e-26),
      C(0.5000000000000000002500000000000000003750e-9,
        -0.1200000000000000001800000188712838420241e-29),
      C(5.00000000000000000000025000000000000000000003e-12,
        -1.20000000000000000000018000000000000000000004e-36),
      C(5.00000000000000000000000002500000000000000000e-14,
        -1.20000000000000000000000001800000000000000000e-42),
      C(5e-301, 0)
    };
    TST(Dawson, 1e-20);
  }
  printf("#####################################\n");
  printf("SUCCESS (max relative error = %g)\n", errmax_all);
}

#endif

#endif

//end file: faddeeva_mit.h


#endif /* XFIELDS_FADDEEVA_H */


// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2023.                   //
// ########################################### //

#ifndef XFIELDS_BIGAUSSIAN_H
#define XFIELDS_BIGAUSSIAN_H


// for quick test with gcc
//#include "constants.h" //only_for_context none
//#include "faddeeva.h" //only_for_context none
//#include "complex_error_function.h" //only_for_context none
//#include "compute_gx_gy.h" //only_for_context none

//from file: compute_gx_gy.h

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_COMPUTE_GX_GY
#define XFIELDS_COMPUTE_GX_GY

 static inline void compute_Gx_Gy(
        const double x,
        const double y,
        const double sigma_x,
        const double sigma_y,
        const double min_sigma_diff,
        const double Ex,
        const double Ey,
        double* Gx_ptr,
        double* Gy_ptr) {

    double Gx, Gy;

    if (fabs(sigma_x-sigma_y) < min_sigma_diff) {
        const double sigma = 0.5 * (sigma_x+sigma_y);
        if ((x*x + y*y) < 1e-14) {
            Gx = 1./(8 * PI * EPSILON_0 * sigma * sigma);
            Gy = Gx;
        }
	    else {
            Gx = 1/(2.*(x*x+y*y))*(y*Ey-x*Ex+1./(2*PI*EPSILON_0*sigma*sigma)
                    *x*x*exp(-(x*x+y*y)/(2.*sigma*sigma)));
            Gy = 1./(2*(x*x+y*y))*(x*Ex-y*Ey+1./(2*PI*EPSILON_0*sigma*sigma)
                    *y*y*exp(-(x*x+y*y)/(2.*sigma*sigma)));
	    }
    }
    else {
        const double Sig_11 = sigma_x*sigma_x;
        const double Sig_33 = sigma_y*sigma_y;

        Gx = -1./(2*(Sig_11-Sig_33))*(x*Ex+y*Ey+1./(2*PI*EPSILON_0)
                *(sigma_y/sigma_x*exp(-x*x/(2*Sig_11)-y*y/(2*Sig_33))-1.));
        Gy = 1./(2*(Sig_11-Sig_33))*(x*Ex+y*Ey+1./(2*PI*EPSILON_0)*
                (sigma_x/sigma_y*exp(-x*x/(2*Sig_11)-y*y/(2*Sig_33))-1.));

    }

    *Gx_ptr = Gx;
    *Gy_ptr = Gy;
}

#endif //XFIELDS_COMPUTE_GX_GY

//end file: compute_gx_gy.h


 static inline
void get_charge_density(const double x,
                      const double y,
                      const double sigma_x,
                      const double sigma_y,
                      double* rho)
{

  // this is a PDF
  double factor = 1 / (2*PI*sigma_x*sigma_y);
  double exp_x = exp(-x*x/(2*sigma_x*sigma_x));
  double exp_y = exp(-y*y/(2*sigma_y*sigma_y));
  *rho = factor * exp_x * exp_y;  // [m^-2]
}

 static inline
void get_transv_field_gauss_round(
    double sigma, double Delta_x, double Delta_y,
    double x, double y,
    double* Ex,
    double* Ey)
{
  double r2, temp;

  r2 = (x-Delta_x)*(x-Delta_x)+(y-Delta_y)*(y-Delta_y);
  double const inv_sig2 = 1./(sigma*sigma);
  double const r2_sig2 = r2 * inv_sig2;
  if (r2_sig2<1e-10) temp = inv_sig2/(4.*PI*EPSILON_0); //linearised
  else temp = inv_sig2 * (1-exp(-0.5*r2_sig2))/(2.*PI*EPSILON_0*r2_sig2);

  (*Ex) = temp * (x-Delta_x);
  (*Ey) = temp * (y-Delta_y);
}

 static inline
void get_transv_field_gauss_ellip(
        double sigma_x,  double sigma_y,
        double Delta_x,  double Delta_y,
        const double x,
	const double y,
        double* Ex_out,
        double* Ey_out)
{
  double sigmax = sigma_x;
  double sigmay = sigma_y;

  // I always go to the first quadrant and then apply the signs a posteriori
  // numerically more stable (see http://inspirehep.net/record/316705/files/slac-pub-5582.pdf)

  double abx = fabs(x - Delta_x);
  double aby = fabs(y - Delta_y);

  double S, factBE, Ex, Ey;
  double etaBE_re, etaBE_im, zetaBE_re, zetaBE_im;
  double w_etaBE_re, w_etaBE_im, w_zetaBE_re, w_zetaBE_im;
  double expBE;


  if (sigmax>sigmay){
    S = sqrt(2.*(sigmax*sigmax-sigmay*sigmay));
    factBE = 1./(2.*EPSILON_0*SQRT_PI*S);

    etaBE_re = sigmay/sigmax*abx;
    etaBE_im = sigmax/sigmay*aby;

    zetaBE_re = abx;
    zetaBE_im = aby;

    //w_zetaBE_re, w_zetaBE_im = wfun(zetaBE_re/S, zetaBE_im/S)
    faddeeva_w(zetaBE_re/S, zetaBE_im/S , &(w_zetaBE_re), &(w_zetaBE_im));

    //w_etaBE_re, w_etaBE_im = wfun(etaBE_re/S, etaBE_im/S)
    faddeeva_w(etaBE_re/S, etaBE_im/S , &(w_etaBE_re), &(w_etaBE_im));

    expBE = exp(-abx*abx/(2*sigmax*sigmax)-aby*aby/(2*sigmay*sigmay));

    Ex = factBE*(w_zetaBE_im - w_etaBE_im*expBE);
    Ey = factBE*(w_zetaBE_re - w_etaBE_re*expBE);

  }
  else if (sigmax<sigmay){
    S = sqrt(2.*(sigmay*sigmay-sigmax*sigmax));
    factBE = 1./(2.*EPSILON_0*SQRT_PI*S);

    etaBE_re = sigmax/sigmay*aby;
    etaBE_im = sigmay/sigmax*abx;

    zetaBE_re = aby;
    zetaBE_im = abx;

    //w_zetaBE_re, w_zetaBE_im = wfun(zetaBE_re/S, zetaBE_im/S)
    faddeeva_w(zetaBE_re/S, zetaBE_im/S , &(w_zetaBE_re), &(w_zetaBE_im));

    //w_etaBE_re, w_etaBE_im = wfun(etaBE_re/S, etaBE_im/S)
    faddeeva_w(etaBE_re/S, etaBE_im/S , &(w_etaBE_re), &(w_etaBE_im));

    expBE = exp(-aby*aby/(2*sigmay*sigmay)-abx*abx/(2*sigmax*sigmax));

    Ey = factBE*(w_zetaBE_im - w_etaBE_im*expBE);
    Ex = factBE*(w_zetaBE_re - w_etaBE_re*expBE);

  }
  else{
    Ex = Ey = 0.;
  }

  if((x - Delta_x)<0) Ex=-Ex;
  if((y - Delta_y)<0) Ey=-Ey;

  (*Ex_out) = Ex;
  (*Ey_out) = Ey;
}

 static inline
void get_Ex_Ey_gauss(
             const double  x,
             const double  y,
             const double  sigma_x,
             const double  sigma_y,
             const double  min_sigma_diff,
             double* Ex_ptr,
             double* Ey_ptr){

        // round beam
	if (fabs(sigma_x-sigma_y)< min_sigma_diff){
	    double sigma = 0.5*(sigma_x+sigma_y);
	    	get_transv_field_gauss_round(sigma, 0., 0., x, y, Ex_ptr, Ey_ptr);
	}

        // elliptical beam
	else{
	    get_transv_field_gauss_ellip(
	            sigma_x, sigma_y, 0., 0., x, y, Ex_ptr, Ey_ptr);

	}
}

#endif // XFIELDS_BIGAUSSIAN_H

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2023.                   //
// ########################################### //

#ifndef XFIELDS_BIGAUSSIAN_H_FIELDMAP
#define XFIELDS_BIGAUSSIAN_H_FIELDMAP

 static inline
void BiGaussianFieldMap_get_dphi_dx_dphi_dy(
           BiGaussianFieldMapData fmap,
                    const double  x,
                    const double  y,
                          double* dphi_dx,
                          double* dphi_dy){

    const double sigma_x = BiGaussianFieldMapData_get_sigma_x(fmap);
    const double sigma_y = BiGaussianFieldMapData_get_sigma_y(fmap);
    const double mean_x = BiGaussianFieldMapData_get_mean_x(fmap);
    const double mean_y = BiGaussianFieldMapData_get_mean_y(fmap);
    const double min_sigma_diff = BiGaussianFieldMapData_get_min_sigma_diff(fmap);

    double Ex, Ey;
    get_Ex_Ey_gauss(
             x-mean_x,
             y-mean_y,
             sigma_x,
             sigma_y,
             min_sigma_diff,
             &Ex,
             &Ey);

    *dphi_dx = -Ex;
    *dphi_dy = -Ey;
}

#endif // XFIELDS_BIGAUSSIAN_H_FIELDMAP
// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_QGAUSSIAN 
#define XFIELDS_QGAUSSIAN 

 static inline
double LongitudinalProfileQGaussian_line_density_scalar(
		LongitudinalProfileQGaussianData prof, double z){

    const double number_of_particles = 
	    LongitudinalProfileQGaussianData_get_number_of_particles(prof);
    const double q = LongitudinalProfileQGaussianData_get__q_param(prof);
    const double cq = LongitudinalProfileQGaussianData_get__cq_param(prof);
    const double q_tol = LongitudinalProfileQGaussianData_get__q_tol(prof);
    const double z0 = LongitudinalProfileQGaussianData_get__z0(prof);
    const double beta_param = LongitudinalProfileQGaussianData_get__beta_param(prof);
    const double sqrt_beta_param = 
	    LongitudinalProfileQGaussianData_get__sqrt_beta_param(prof);
    const double z_min = LongitudinalProfileQGaussianData_get__support_min(prof);
    const double z_max = LongitudinalProfileQGaussianData_get__support_max(prof);

    const double factor = number_of_particles*sqrt_beta_param/cq; 


    if (fabs(q-1.) < q_tol){
	if (z<z_max && z>z_min){
	    double z_m_z0 = z - z0;
		return factor*exp(-beta_param*z_m_z0*z_m_z0 );
	}
	else{
		return 0; 
	}
    }
    else{
    	double exponent = 1./(1.-q);
	if (z<z_max && z>z_min){
	    double z_m_z0 = z - z0;
    		double q_exp_arg =  -(beta_param*z_m_z0*z_m_z0 );
    		double q_exp_res = pow(
	    	 (1.+(1.-q)*q_exp_arg), exponent );
    		return factor*q_exp_res;
	}
	else{
		return 0; 
	}
    }
}

 static inline
double LongitudinalProfileQGaussian_line_density_derivative_scalar(
		LongitudinalProfileQGaussianData prof, double z){

    const double number_of_particles = 
	    LongitudinalProfileQGaussianData_get_number_of_particles(prof);
    const double q = LongitudinalProfileQGaussianData_get__q_param(prof);
    const double cq = LongitudinalProfileQGaussianData_get__cq_param(prof);
    const double q_tol = LongitudinalProfileQGaussianData_get__q_tol(prof);
    const double z0 = LongitudinalProfileQGaussianData_get__z0(prof);
    const double beta_param = LongitudinalProfileQGaussianData_get__beta_param(prof);
    const double sqrt_beta_param = 
	    LongitudinalProfileQGaussianData_get__sqrt_beta_param(prof);
    const double z_min = LongitudinalProfileQGaussianData_get__support_min(prof);
    const double z_max = LongitudinalProfileQGaussianData_get__support_max(prof);

    const double factor = number_of_particles*sqrt_beta_param/cq;


    if (fabs(q-1.) < q_tol){
	if (z<z_max && z>z_min){
	    double z_m_z0 = z - z0;
		return -2*factor*beta_param*z_m_z0*exp(-beta_param*z_m_z0*z_m_z0 );
	}
	else{
		return 0;
	}
    }
    else{
    	double exponent = 1./(1.-q);
	if (z<z_max && z>z_min){
	    double z_m_z0 = z - z0;
    		double q_exp_arg =  -(beta_param*z_m_z0*z_m_z0 );
    		double q_exp_res = pow((1.+(1.-q)*q_exp_arg), exponent-1.);
    		return -2*factor*beta_param*z_m_z0*q_exp_res;
	}
	else{
		return 0;
	}
    }
}



 
void line_density_qgauss(LongitudinalProfileQGaussianData prof,
		               const int64_t n,
		    const double* z, 
		          double* res){

//   #pragma omp parallel for //only_for_context cpu_openmp 
for (int ii=0; ii<n; ii++){ //autovectorized


       res[ii] = LongitudinalProfileQGaussian_line_density_scalar(prof, z[ii]);
  
}//end autovectorized

}


 
void line_derivative_qgauss(LongitudinalProfileQGaussianData prof,
		               const int64_t n,
		    const double* z, 
		          double* res){

//   #pragma omp parallel for //only_for_context cpu_openmp 
for (int ii=0; ii<n; ii++){ //autovectorized


       res[ii] = LongitudinalProfileQGaussian_line_density_derivative_scalar(prof, z[ii]);
  
}//end autovectorized

}

#endif

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_SPACECHARGEBIGAUSSIAN_H
#define XFIELDS_SPACECHARGEBIGAUSSIAN_H

 static inline
void SpaceChargeBiGaussian_track_local_particle(
		 SpaceChargeBiGaussianData el, LocalParticle* part0){

    const double length = SpaceChargeBiGaussianData_get_length(el);
    BiGaussianFieldMapData fmap = SpaceChargeBiGaussianData_getp_fieldmap(el);
    LongitudinalProfileQGaussianData prof =
	    SpaceChargeBiGaussianData_getp_longitudinal_profile(el);

	const int64_t z_kick_num_integ_per_sigma =
		SpaceChargeBiGaussianData_get_z_kick_num_integ_per_sigma(el);


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

		double const x = LocalParticle_get_x(part);
		double const y = LocalParticle_get_y(part);
		double const z = LocalParticle_get_zeta(part);

		double const q0 = LocalParticle_get_q0(part);
		double const mass0 = LocalParticle_get_mass0(part);
		double const chi = LocalParticle_get_chi(part);
		double const beta0 = LocalParticle_get_beta0(part);
		double const gamma0 = LocalParticle_get_gamma0(part);

		double dphi_dx, dphi_dy;
		BiGaussianFieldMap_get_dphi_dx_dphi_dy(fmap, x, y,
							&dphi_dx, &dphi_dy);

		const double lambda_z =
			LongitudinalProfileQGaussian_line_density_scalar(prof, z);

		const double charge_mass_ratio =
						chi*QELEM*q0/(mass0*QELEM/(C_LIGHT*C_LIGHT));
		const double factor = -(charge_mass_ratio*q0*QELEM
								*length*(1.-beta0*beta0)
								/(gamma0*beta0*beta0*C_LIGHT*C_LIGHT));

		LocalParticle_add_to_px(part, factor*lambda_z*dphi_dx);
		LocalParticle_add_to_py(part, factor*lambda_z*dphi_dy);

		if (z_kick_num_integ_per_sigma > 0){

			const int64_t x_sigma = (int64_t)(x / BiGaussianFieldMapData_get_sigma_x(fmap));
			const int64_t y_sigma = (int64_t)(y / BiGaussianFieldMapData_get_sigma_y(fmap));

			int64_t n_sigma;
			if (x_sigma > y_sigma){
				n_sigma = x_sigma;
			}
			else{
				n_sigma = y_sigma;
			}

			if (n_sigma < 1){
				n_sigma = 1;
			}
			const int64_t n_integ = n_sigma * z_kick_num_integ_per_sigma;

			const double dx = fabs(x / (n_integ - 1));
			const double dy = fabs(y / (n_integ - 1));

			double phi = 0.0;
			double dphi_integ = 0.0;
			for (int ii=0; ii<n_integ; ii++){
				double const x_integ = ii*dx;
				double const y_integ = ii*dy;
				double dphi_dx_integ, dphi_dy_integ;
				BiGaussianFieldMap_get_dphi_dx_dphi_dy(fmap, x_integ, y_integ,
									            &dphi_dx_integ, &dphi_dy_integ);

				dphi_integ = dphi_dx_integ*dx + dphi_dy_integ*dy;

				phi += dphi_integ;
			}
			phi -= 0.5 * dphi_integ;

			double const lam_prime =
				LongitudinalProfileQGaussian_line_density_derivative_scalar(prof, z);

			LocalParticle_update_delta(part,
				LocalParticle_get_delta(part) + factor*lam_prime*phi);

		}


//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

}


#endif


             static inline
            void SpaceChargeBiGaussian_track_local_particle_with_transformations(SpaceChargeBiGaussianData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = SpaceChargeBiGaussianData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = SpaceChargeBiGaussianData_get__cos_rot_s(el);
    double const shift_x = SpaceChargeBiGaussianData_get__shift_x(el);
    double const shift_y = SpaceChargeBiGaussianData_get__shift_y(el);
    double const shift_s = SpaceChargeBiGaussianData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    SpaceChargeBiGaussian_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = SpaceChargeBiGaussianData_get__cos_rot_s(el);
    double const shift_x = SpaceChargeBiGaussianData_get__shift_x(el);
    double const shift_y = SpaceChargeBiGaussianData_get__shift_y(el);
    double const shift_s = SpaceChargeBiGaussianData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void SpaceChargeBiGaussian_track_particles(
               SpaceChargeBiGaussianData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              SpaceChargeBiGaussian_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_MarkerData
#define XOBJ_TYPEDEF_MarkerData
typedef   struct MarkerData_s * MarkerData;
 static inline MarkerData MarkerData_getp(MarkerData restrict  obj){
  int64_t offset=0;
  return (MarkerData)(( char*) obj+offset);
}
 static inline int64_t MarkerData_get__dummy(const MarkerData restrict  obj){
  int64_t offset=0;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MarkerData_set__dummy(MarkerData restrict  obj, int64_t value){
  int64_t offset=0;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MarkerData_getp__dummy(MarkerData restrict  obj){
  int64_t offset=0;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/marker.h>

             static inline
            void Marker_track_local_particle_with_transformations(MarkerData el, LocalParticle* part0){
    Marker_track_local_particle(el, part0);
}


             
            void Marker_track_particles(
               MarkerData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Marker_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_CavityData
#define XOBJ_TYPEDEF_CavityData
typedef   struct CavityData_s * CavityData;
 static inline CavityData CavityData_getp(CavityData restrict  obj){
  int64_t offset=0;
  return (CavityData)(( char*) obj+offset);
}
 static inline double CavityData_get_voltage(const CavityData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set_voltage(CavityData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp_voltage(CavityData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double CavityData_get_frequency(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set_frequency(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp_frequency(CavityData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double CavityData_get_lag(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set_lag(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp_lag(CavityData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double CavityData_get_lag_taper(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set_lag_taper(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp_lag_taper(CavityData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t CavityData_get_absolute_time(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void CavityData_set_absolute_time(CavityData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* CavityData_getp_absolute_time(CavityData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double CavityData_get__sin_rot_s(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set__sin_rot_s(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp__sin_rot_s(CavityData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double CavityData_get__cos_rot_s(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set__cos_rot_s(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp__cos_rot_s(CavityData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double CavityData_get__shift_x(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set__shift_x(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp__shift_x(CavityData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double CavityData_get__shift_y(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set__shift_y(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp__shift_y(CavityData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double CavityData_get__shift_s(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set__shift_s(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp__shift_s(CavityData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/cavity.h>

             static inline
            void Cavity_track_local_particle_with_transformations(CavityData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = CavityData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = CavityData_get__cos_rot_s(el);
    double const shift_x = CavityData_get__shift_x(el);
    double const shift_y = CavityData_get__shift_y(el);
    double const shift_s = CavityData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Cavity_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = CavityData_get__cos_rot_s(el);
    double const shift_x = CavityData_get__shift_x(el);
    double const shift_y = CavityData_get__shift_y(el);
    double const shift_s = CavityData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Cavity_track_particles(
               CavityData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Cavity_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_LimitEllipseData
#define XOBJ_TYPEDEF_LimitEllipseData
typedef   struct LimitEllipseData_s * LimitEllipseData;
 static inline LimitEllipseData LimitEllipseData_getp(LimitEllipseData restrict  obj){
  int64_t offset=0;
  return (LimitEllipseData)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get_a_squ(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set_a_squ(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp_a_squ(LimitEllipseData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get_b_squ(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set_b_squ(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp_b_squ(LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get_a_b_squ(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set_a_b_squ(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp_a_b_squ(LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get__sin_rot_s(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set__sin_rot_s(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp__sin_rot_s(LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get__cos_rot_s(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set__cos_rot_s(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp__cos_rot_s(LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get__shift_x(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set__shift_x(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp__shift_x(LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get__shift_y(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set__shift_y(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp__shift_y(LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get__shift_s(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set__shift_s(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp__shift_s(LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/apertures_src/limitellipse.h>

             static inline
            void LimitEllipse_track_local_particle_with_transformations(LimitEllipseData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LimitEllipseData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitEllipseData_get__cos_rot_s(el);
    double const shift_x = LimitEllipseData_get__shift_x(el);
    double const shift_y = LimitEllipseData_get__shift_y(el);
    double const shift_s = LimitEllipseData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LimitEllipse_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitEllipseData_get__cos_rot_s(el);
    double const shift_x = LimitEllipseData_get__shift_x(el);
    double const shift_y = LimitEllipseData_get__shift_y(el);
    double const shift_s = LimitEllipseData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LimitEllipse_track_particles(
               LimitEllipseData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LimitEllipse_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_NonLinearLensData
#define XOBJ_TYPEDEF_NonLinearLensData
typedef   struct NonLinearLensData_s * NonLinearLensData;
 static inline NonLinearLensData NonLinearLensData_getp(NonLinearLensData restrict  obj){
  int64_t offset=0;
  return (NonLinearLensData)(( char*) obj+offset);
}
 static inline double NonLinearLensData_get_knll(const NonLinearLensData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void NonLinearLensData_set_knll(NonLinearLensData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* NonLinearLensData_getp_knll(NonLinearLensData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double NonLinearLensData_get_cnll(const NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void NonLinearLensData_set_cnll(NonLinearLensData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* NonLinearLensData_getp_cnll(NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double NonLinearLensData_get__sin_rot_s(const NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void NonLinearLensData_set__sin_rot_s(NonLinearLensData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* NonLinearLensData_getp__sin_rot_s(NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double NonLinearLensData_get__cos_rot_s(const NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void NonLinearLensData_set__cos_rot_s(NonLinearLensData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* NonLinearLensData_getp__cos_rot_s(NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double NonLinearLensData_get__shift_x(const NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void NonLinearLensData_set__shift_x(NonLinearLensData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* NonLinearLensData_getp__shift_x(NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double NonLinearLensData_get__shift_y(const NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void NonLinearLensData_set__shift_y(NonLinearLensData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* NonLinearLensData_getp__shift_y(NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double NonLinearLensData_get__shift_s(const NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void NonLinearLensData_set__shift_s(NonLinearLensData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* NonLinearLensData_getp__shift_s(NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/nonlinearlens.h>

             static inline
            void NonLinearLens_track_local_particle_with_transformations(NonLinearLensData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = NonLinearLensData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = NonLinearLensData_get__cos_rot_s(el);
    double const shift_x = NonLinearLensData_get__shift_x(el);
    double const shift_y = NonLinearLensData_get__shift_y(el);
    double const shift_s = NonLinearLensData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    NonLinearLens_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = NonLinearLensData_get__cos_rot_s(el);
    double const shift_x = NonLinearLensData_get__shift_x(el);
    double const shift_y = NonLinearLensData_get__shift_y(el);
    double const shift_s = NonLinearLensData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void NonLinearLens_track_particles(
               NonLinearLensData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              NonLinearLens_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_LimitRectEllipseData
#define XOBJ_TYPEDEF_LimitRectEllipseData
typedef   struct LimitRectEllipseData_s * LimitRectEllipseData;
 static inline LimitRectEllipseData LimitRectEllipseData_getp(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  return (LimitRectEllipseData)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get_max_x(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set_max_x(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp_max_x(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get_max_y(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set_max_y(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp_max_y(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get_a_squ(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set_a_squ(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp_a_squ(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get_b_squ(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set_b_squ(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp_b_squ(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get_a_b_squ(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set_a_b_squ(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp_a_b_squ(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get__sin_rot_s(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set__sin_rot_s(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp__sin_rot_s(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get__cos_rot_s(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set__cos_rot_s(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp__cos_rot_s(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get__shift_x(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set__shift_x(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp__shift_x(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get__shift_y(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set__shift_y(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp__shift_y(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get__shift_s(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set__shift_s(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp__shift_s(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/apertures_src/limitrectellipse.h>

             static inline
            void LimitRectEllipse_track_local_particle_with_transformations(LimitRectEllipseData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LimitRectEllipseData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitRectEllipseData_get__cos_rot_s(el);
    double const shift_x = LimitRectEllipseData_get__shift_x(el);
    double const shift_y = LimitRectEllipseData_get__shift_y(el);
    double const shift_s = LimitRectEllipseData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LimitRectEllipse_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitRectEllipseData_get__cos_rot_s(el);
    double const shift_x = LimitRectEllipseData_get__shift_x(el);
    double const shift_y = LimitRectEllipseData_get__shift_y(el);
    double const shift_s = LimitRectEllipseData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LimitRectEllipse_track_particles(
               LimitRectEllipseData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LimitRectEllipse_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_EmittanceMonitorData
#define XOBJ_TYPEDEF_EmittanceMonitorData
typedef   struct EmittanceMonitorData_s * EmittanceMonitorData;
 static inline EmittanceMonitorData EmittanceMonitorData_getp(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  return (EmittanceMonitorData)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_get_part_id_start(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_part_id_start(EmittanceMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* EmittanceMonitorData_getp_part_id_start(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_get_part_id_end(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_part_id_end(EmittanceMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* EmittanceMonitorData_getp_part_id_end(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_get_start_at_turn(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_start_at_turn(EmittanceMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* EmittanceMonitorData_getp_start_at_turn(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_get_stop_at_turn(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_stop_at_turn(EmittanceMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* EmittanceMonitorData_getp_stop_at_turn(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double EmittanceMonitorData_get_frev(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_frev(EmittanceMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp_frev(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double EmittanceMonitorData_get_sampling_frequency(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_sampling_frequency(EmittanceMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp_sampling_frequency(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIndex EmittanceMonitorData_getp__index(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_get__index_capacity(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set__index_capacity(EmittanceMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* EmittanceMonitorData_getp__index_capacity(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t EmittanceMonitorData_get__index_num_recorded(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set__index_num_recorded(EmittanceMonitorData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=64;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* EmittanceMonitorData_getp__index_num_recorded(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t EmittanceMonitorData_get__index__dummy(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set__index__dummy(EmittanceMonitorData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=72;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* EmittanceMonitorData_getp__index__dummy(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_get__index_buffer_id(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set__index_buffer_id(EmittanceMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* EmittanceMonitorData_getp__index_buffer_id(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline EmittanceMonitorRecord EmittanceMonitorData_getp_data(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return (EmittanceMonitorRecord)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_count(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=368;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_count(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=368;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_count(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=368;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_count(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=368;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_count(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=368;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_x_sum1(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_x_sum1(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_x_sum1(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_x_sum1(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_x_sum1(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_px_sum1(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_px_sum1(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+16);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_px_sum1(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_px_sum1(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_px_sum1(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_y_sum1(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_y_sum1(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+24);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_y_sum1(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_y_sum1(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_y_sum1(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_py_sum1(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_py_sum1(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+32);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_py_sum1(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_py_sum1(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_py_sum1(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_zeta_sum1(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_zeta_sum1(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+40);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_zeta_sum1(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_zeta_sum1(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_zeta_sum1(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_pzeta_sum1(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_pzeta_sum1(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+48);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_pzeta_sum1(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_pzeta_sum1(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_pzeta_sum1(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_x_x_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_x_x_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+56);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_x_x_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_x_x_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_x_x_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_x_px_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_x_px_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_x_px_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_x_px_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_x_px_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_x_y_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_x_y_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+72);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_x_y_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_x_y_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_x_y_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_x_py_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_x_py_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+80);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_x_py_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_x_py_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_x_py_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_x_zeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_x_zeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+88);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_x_zeta_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_x_zeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_x_zeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_x_pzeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_x_pzeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+96);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_x_pzeta_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_x_pzeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_x_pzeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_px_px_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_px_px_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+104);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_px_px_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_px_px_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_px_px_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_px_y_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_px_y_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+112);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_px_y_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_px_y_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_px_y_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_px_py_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_px_py_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+120);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_px_py_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_px_py_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_px_py_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_px_zeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_px_zeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+128);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_px_zeta_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_px_zeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_px_zeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_px_pzeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_px_pzeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+136);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_px_pzeta_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_px_pzeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_px_pzeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_y_y_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_y_y_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+144);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_y_y_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_y_y_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_y_y_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_y_py_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_y_py_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+152);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_y_py_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_y_py_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_y_py_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_y_zeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_y_zeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_y_zeta_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_y_zeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_y_zeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_y_pzeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_y_pzeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+168);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_y_pzeta_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_y_pzeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_y_pzeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_py_py_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_py_py_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+176);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_py_py_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_py_py_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_py_py_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_py_zeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_py_zeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+184);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_py_zeta_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_py_zeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_py_zeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_py_pzeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_py_pzeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+192);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_py_pzeta_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_py_pzeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_py_pzeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_zeta_zeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_zeta_zeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+200);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_zeta_zeta_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_zeta_zeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_zeta_zeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_zeta_pzeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_zeta_pzeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+208);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_zeta_pzeta_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_zeta_pzeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_zeta_pzeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 EmittanceMonitorData_getp_data_pzeta_pzeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t EmittanceMonitorData_len_data_pzeta_pzeta_sum2(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+216);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double EmittanceMonitorData_get_data_pzeta_pzeta_sum2(const EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set_data_pzeta_pzeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp1_data_pzeta_pzeta_sum2(EmittanceMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t EmittanceMonitorData_get__cached(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *(( int8_t*) obj+offset);
}
 static inline void EmittanceMonitorData_set__cached(EmittanceMonitorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=88;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EmittanceMonitorData_getp__cached(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline int8_t EmittanceMonitorData_get__plane_selector(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *(( int8_t*) obj+offset);
}
 static inline void EmittanceMonitorData_set__plane_selector(EmittanceMonitorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=96;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EmittanceMonitorData_getp__plane_selector(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double EmittanceMonitorData_get__sin_rot_s(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set__sin_rot_s(EmittanceMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp__sin_rot_s(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double EmittanceMonitorData_get__cos_rot_s(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set__cos_rot_s(EmittanceMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp__cos_rot_s(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double EmittanceMonitorData_get__shift_x(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set__shift_x(EmittanceMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp__shift_x(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double EmittanceMonitorData_get__shift_y(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set__shift_y(EmittanceMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp__shift_y(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double EmittanceMonitorData_get__shift_s(const EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void EmittanceMonitorData_set__shift_s(EmittanceMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EmittanceMonitorData_getp__shift_s(EmittanceMonitorData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef _ATOMICADD_H_
#define _ATOMICADD_H_

#define ATOMICADD_CPU  //only_for_context cpu_serial cpu_openmp
//#define ATOMICADD_OPENCL //only_for_context opencl
// CUDA provides atomicAdd() natively

#ifdef ATOMICADD_CPU
inline void atomicAdd(double *addr, double val)
{
//   #pragma omp atomic //only_for_context cpu_openmp
   *addr = *addr + val;
}
#endif // ATOMICADD_CPU

#ifdef ATOMICADD_OPENCL
#pragma OPENCL EXTENSION cl_khr_int64_base_atomics : enable
inline void atomicAdd(volatile __global double *addr, double val)
{
	union {
		long u64;
		double f64;
	} next, expected, current;
	current.f64 = *addr;
	do {
		expected.f64 = current.f64;
		next.f64 = expected.f64 + val;
		current.u64 = atom_cmpxchg(
			(volatile __global long *)addr,
		        (long) expected.u64,
			(long) next.u64);
	} while( current.u64 != expected.u64 );
}
#endif // ATOMICADD_OPENCL

#endif

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_EMITTANCE_MONITOR_H
#define XCOLL_EMITTANCE_MONITOR_H

#ifndef C_LIGHT
#define C_LIGHT 299792458.0
#endif

 static inline
void EmittanceMonitor_track_local_particle(EmittanceMonitorData el, LocalParticle* part0){
    EmittanceMonitorData_set__cached(el, 0);
    int64_t const start_at_turn = EmittanceMonitorData_get_start_at_turn(el);
    int64_t const part_id_start = EmittanceMonitorData_get_part_id_start(el);
    int64_t const part_id_end   = EmittanceMonitorData_get_part_id_end(el);
    double const frev = EmittanceMonitorData_get_frev(el);
    double const sampling_frequency = EmittanceMonitorData_get_sampling_frequency(el);

    EmittanceMonitorRecord record = EmittanceMonitorData_getp_data(el);

    int64_t max_slot = EmittanceMonitorRecord_len_count(record);

    int const plane_selector = EmittanceMonitorData_get__plane_selector(el);
    int const monitor_horizontal   =  plane_selector % 2;
    int const monitor_vertical     = (plane_selector >> 1) % 2;
    int const monitor_longitudinal = (plane_selector >> 2) % 2;


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

        int64_t particle_id = LocalParticle_get_particle_id(part);
        if (part_id_end < 0 || (part_id_start <= particle_id && particle_id < part_id_end)){

            // zeta is the absolute path length deviation from the reference particle: zeta = (s - beta0*c*t)
            // but without limits, i.e. it can exceed the circumference (for coasting beams)
            // as the particle falls behind or overtakes the reference particle
            double const zeta = LocalParticle_get_zeta(part);
            double const beta0 = LocalParticle_get_beta0(part);
            double const at_turn = LocalParticle_get_at_turn(part);

            double x =0;
            double px = 0;
            double y = 0;
            double py = 0;
            double pzeta = 0;

            // compute sample index
            int64_t slot = round(sampling_frequency * ( (at_turn-start_at_turn)/frev - zeta/beta0/C_LIGHT ));

            if (slot >= 0 && slot < max_slot){
                  double *count = EmittanceMonitorRecord_getp1_count(record, slot); atomicAdd(count, 1);

                if (monitor_horizontal){
                    x  = LocalParticle_get_x(part);
                    px = LocalParticle_get_px(part);
                      double *x_sum1     = EmittanceMonitorRecord_getp1_x_sum1(record, slot);     atomicAdd(x_sum1, x);
                      double *px_sum1    = EmittanceMonitorRecord_getp1_px_sum1(record, slot);    atomicAdd(px_sum1, px);
                      double *x_x_sum2   = EmittanceMonitorRecord_getp1_x_x_sum2(record, slot);   atomicAdd(x_x_sum2, x*x);
                      double *x_px_sum2  = EmittanceMonitorRecord_getp1_x_px_sum2(record, slot);  atomicAdd(x_px_sum2, x*px);
                      double *px_px_sum2 = EmittanceMonitorRecord_getp1_px_px_sum2(record, slot); atomicAdd(px_px_sum2, px*px);
                }

                if (monitor_vertical){
                    y  = LocalParticle_get_y(part);
                    py = LocalParticle_get_py(part);
                      double *y_sum1     = EmittanceMonitorRecord_getp1_y_sum1(record, slot);     atomicAdd(y_sum1, y);
                      double *py_sum1    = EmittanceMonitorRecord_getp1_py_sum1(record, slot);    atomicAdd(py_sum1, py);
                      double *y_y_sum2   = EmittanceMonitorRecord_getp1_y_y_sum2(record, slot);   atomicAdd(y_y_sum2, y*y);
                      double *y_py_sum2  = EmittanceMonitorRecord_getp1_y_py_sum2(record, slot);  atomicAdd(y_py_sum2, y*py);
                      double *py_py_sum2 = EmittanceMonitorRecord_getp1_py_py_sum2(record, slot); atomicAdd(py_py_sum2, py*py);
                }

                if (monitor_longitudinal){
                    double const ptau = LocalParticle_get_ptau(part);
                    pzeta = ptau/beta0;
                      double *zeta_sum1        = EmittanceMonitorRecord_getp1_zeta_sum1(record, slot);        atomicAdd(zeta_sum1, zeta);
                      double *pzeta_sum1       = EmittanceMonitorRecord_getp1_pzeta_sum1(record, slot);       atomicAdd(pzeta_sum1, pzeta);
                      double *zeta_zeta_sum2   = EmittanceMonitorRecord_getp1_zeta_zeta_sum2(record, slot);   atomicAdd(zeta_zeta_sum2, zeta*zeta);
                      double *zeta_pzeta_sum2  = EmittanceMonitorRecord_getp1_zeta_pzeta_sum2(record, slot);  atomicAdd(zeta_pzeta_sum2, zeta*pzeta);
                      double *pzeta_pzeta_sum2 = EmittanceMonitorRecord_getp1_pzeta_pzeta_sum2(record, slot); atomicAdd(pzeta_pzeta_sum2, pzeta*pzeta);
                }

                if (monitor_horizontal && monitor_vertical){
                      double *x_y_sum2   = EmittanceMonitorRecord_getp1_x_y_sum2(record, slot);   atomicAdd(x_y_sum2, x*y);
                      double *x_py_sum2  = EmittanceMonitorRecord_getp1_x_py_sum2(record, slot);  atomicAdd(x_py_sum2, x*py);
                      double *px_y_sum2  = EmittanceMonitorRecord_getp1_px_y_sum2(record, slot);  atomicAdd(px_y_sum2, px*y);
                      double *px_py_sum2 = EmittanceMonitorRecord_getp1_px_py_sum2(record, slot); atomicAdd(px_py_sum2, px*py);
                }

                if (monitor_horizontal && monitor_longitudinal){
                      double *x_zeta_sum2   = EmittanceMonitorRecord_getp1_x_zeta_sum2(record, slot);   atomicAdd(x_zeta_sum2, x*zeta);
                      double *x_pzeta_sum2  = EmittanceMonitorRecord_getp1_x_pzeta_sum2(record, slot);  atomicAdd(x_pzeta_sum2, x*pzeta);
                      double *px_zeta_sum2  = EmittanceMonitorRecord_getp1_px_zeta_sum2(record, slot);  atomicAdd(px_zeta_sum2, px*zeta);
                      double *px_pzeta_sum2 = EmittanceMonitorRecord_getp1_px_pzeta_sum2(record, slot); atomicAdd(px_pzeta_sum2, px*pzeta);
                }

                if (monitor_vertical && monitor_longitudinal){
                      double *y_zeta_sum2   = EmittanceMonitorRecord_getp1_y_zeta_sum2(record, slot);   atomicAdd(y_zeta_sum2, y*zeta);
                      double *y_pzeta_sum2  = EmittanceMonitorRecord_getp1_y_pzeta_sum2(record, slot);  atomicAdd(y_pzeta_sum2, y*pzeta);
                      double *py_zeta_sum2  = EmittanceMonitorRecord_getp1_py_zeta_sum2(record, slot);  atomicAdd(py_zeta_sum2, py*zeta);
                      double *py_pzeta_sum2 = EmittanceMonitorRecord_getp1_py_pzeta_sum2(record, slot); atomicAdd(py_pzeta_sum2, py*pzeta);
                }
            }
        }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

}

#endif /* XCOLL_EMITTANCE_MONITOR_H */

             static inline
            void EmittanceMonitor_track_local_particle_with_transformations(EmittanceMonitorData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = EmittanceMonitorData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = EmittanceMonitorData_get__cos_rot_s(el);
    double const shift_x = EmittanceMonitorData_get__shift_x(el);
    double const shift_y = EmittanceMonitorData_get__shift_y(el);
    double const shift_s = EmittanceMonitorData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    EmittanceMonitor_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = EmittanceMonitorData_get__cos_rot_s(el);
    double const shift_x = EmittanceMonitorData_get__shift_x(el);
    double const shift_y = EmittanceMonitorData_get__shift_y(el);
    double const shift_s = EmittanceMonitorData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void EmittanceMonitor_track_particles(
               EmittanceMonitorData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              EmittanceMonitor_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_SimpleThinBendData
#define XOBJ_TYPEDEF_SimpleThinBendData
typedef   struct SimpleThinBendData_s * SimpleThinBendData;
 static inline SimpleThinBendData SimpleThinBendData_getp(SimpleThinBendData restrict  obj){
  int64_t offset=0;
  return (SimpleThinBendData)(( char*) obj+offset);
}
 static inline Arr1Float64 SimpleThinBendData_getp_knl(SimpleThinBendData restrict  obj){
  int64_t offset=0;
  return (Arr1Float64)(( char*) obj+offset);
}
 static inline int64_t SimpleThinBendData_len_knl(SimpleThinBendData restrict  obj){
  return 1;
}
 static inline double SimpleThinBendData_get_knl(const SimpleThinBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SimpleThinBendData_set_knl(SimpleThinBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SimpleThinBendData_getp1_knl(SimpleThinBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double SimpleThinBendData_get_hxl(const SimpleThinBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SimpleThinBendData_set_hxl(SimpleThinBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SimpleThinBendData_getp_hxl(SimpleThinBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double SimpleThinBendData_get_length(const SimpleThinBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void SimpleThinBendData_set_length(SimpleThinBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SimpleThinBendData_getp_length(SimpleThinBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/simplethinbend.h>

             static inline
            void SimpleThinBend_track_local_particle_with_transformations(SimpleThinBendData el, LocalParticle* part0){
    SimpleThinBend_track_local_particle(el, part0);
}


             
            void SimpleThinBend_track_particles(
               SimpleThinBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              SimpleThinBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_YRotationData
#define XOBJ_TYPEDEF_YRotationData
typedef   struct YRotationData_s * YRotationData;
 static inline YRotationData YRotationData_getp(YRotationData restrict  obj){
  int64_t offset=0;
  return (YRotationData)(( char*) obj+offset);
}
 static inline double YRotationData_get_sin_angle(const YRotationData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void YRotationData_set_sin_angle(YRotationData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* YRotationData_getp_sin_angle(YRotationData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double YRotationData_get_cos_angle(const YRotationData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void YRotationData_set_cos_angle(YRotationData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* YRotationData_getp_cos_angle(YRotationData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double YRotationData_get_tan_angle(const YRotationData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void YRotationData_set_tan_angle(YRotationData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* YRotationData_getp_tan_angle(YRotationData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/yrotation.h>

             static inline
            void YRotation_track_local_particle_with_transformations(YRotationData el, LocalParticle* part0){
    YRotation_track_local_particle(el, part0);
}


             
            void YRotation_track_particles(
               YRotationData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              YRotation_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_BeamProfileMonitorData
#define XOBJ_TYPEDEF_BeamProfileMonitorData
typedef   struct BeamProfileMonitorData_s * BeamProfileMonitorData;
 static inline BeamProfileMonitorData BeamProfileMonitorData_getp(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  return (BeamProfileMonitorData)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get_particle_id_start(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_particle_id_start(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp_particle_id_start(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get_num_particles(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_num_particles(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp_num_particles(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get_start_at_turn(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_start_at_turn(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp_start_at_turn(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get_stop_at_turn(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_stop_at_turn(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp_stop_at_turn(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get_frev(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_frev(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp_frev(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get_sampling_frequency(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_sampling_frequency(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp_sampling_frequency(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get_nx(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_nx(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp_nx(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get_x_min(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_x_min(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp_x_min(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get_dx(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_dx(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp_dx(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get_ny(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_ny(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp_ny(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get_y_min(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_y_min(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp_y_min(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get_dy(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_dy(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp_dy(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get_sample_size(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_sample_size(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp_sample_size(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline RecordIndex BeamProfileMonitorData_getp__index(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get__index_capacity(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__index_capacity(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=112;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp__index_capacity(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamProfileMonitorData_get__index_num_recorded(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__index_num_recorded(BeamProfileMonitorData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=120;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamProfileMonitorData_getp__index_num_recorded(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamProfileMonitorData_get__index__dummy(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__index__dummy(BeamProfileMonitorData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=128;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamProfileMonitorData_getp__index__dummy(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get__index_buffer_id(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__index_buffer_id(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=136;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp__index_buffer_id(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline BeamProfileMonitorRecord BeamProfileMonitorData_getp_data(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return (BeamProfileMonitorRecord)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamProfileMonitorData_getp_data_counts_x(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_len_data_counts_x(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=200;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamProfileMonitorData_get_data_counts_x(const BeamProfileMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=200;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_data_counts_x(BeamProfileMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=200;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp1_data_counts_x(BeamProfileMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=200;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamProfileMonitorData_getp_data_counts_y(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=184;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_len_data_counts_y(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=184;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamProfileMonitorData_get_data_counts_y(const BeamProfileMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=184;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_data_counts_y(BeamProfileMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=184;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp1_data_counts_y(BeamProfileMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=184;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get__sin_rot_s(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__sin_rot_s(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp__sin_rot_s(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get__cos_rot_s(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__cos_rot_s(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp__cos_rot_s(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get__shift_x(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__shift_x(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp__shift_x(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get__shift_y(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__shift_y(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp__shift_y(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get__shift_s(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__shift_s(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=176;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp__shift_s(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef _ATOMICADD_H_
#define _ATOMICADD_H_

#define ATOMICADD_CPU  //only_for_context cpu_serial cpu_openmp
//#define ATOMICADD_OPENCL //only_for_context opencl
// CUDA provides atomicAdd() natively

#ifdef ATOMICADD_CPU
inline void atomicAdd(double *addr, double val)
{
//   #pragma omp atomic //only_for_context cpu_openmp
   *addr = *addr + val;
}
#endif // ATOMICADD_CPU

#ifdef ATOMICADD_OPENCL
#pragma OPENCL EXTENSION cl_khr_int64_base_atomics : enable
inline void atomicAdd(volatile __global double *addr, double val)
{
	union {
		long u64;
		double f64;
	} next, expected, current;
	current.f64 = *addr;
	do {
		expected.f64 = current.f64;
		next.f64 = expected.f64 + val;
		current.u64 = atom_cmpxchg(
			(volatile __global long *)addr,
		        (long) expected.u64,
			(long) next.u64);
	} while( current.u64 != expected.u64 );
}
#endif // ATOMICADD_OPENCL

#endif

// ##################################
// Beam Profile Monitor
//
// Author: Philipp Niedermayer
// Date: 2023-08-15
// ##################################


#ifndef XTRACK_BEAM_PROFILE_MONITOR_H
#define XTRACK_BEAM_PROFILE_MONITOR_H

#include <headers/track.h>


GPUFUN
void BeamProfileMonitor_track_local_particle(BeamProfileMonitorData el, LocalParticle* part0){

    // get parameters
    int64_t const start_at_turn = BeamProfileMonitorData_get_start_at_turn(el);
    int64_t particle_id_start = BeamProfileMonitorData_get_particle_id_start(el);
    int64_t particle_id_stop = particle_id_start + BeamProfileMonitorData_get_num_particles(el);
    double const frev = BeamProfileMonitorData_get_frev(el);
    double const sampling_frequency = BeamProfileMonitorData_get_sampling_frequency(el);

    BeamProfileMonitorRecord record = BeamProfileMonitorData_getp_data(el);

    int64_t max_sample = BeamProfileMonitorData_get_sample_size(el);
    int64_t max_slot_x = BeamProfileMonitorRecord_len_counts_x(record);
    int64_t max_slot_y = BeamProfileMonitorRecord_len_counts_y(record);
    int64_t nx = BeamProfileMonitorData_get_nx(el);
    int64_t ny = BeamProfileMonitorData_get_ny(el);
    double x_min = BeamProfileMonitorData_get_x_min(el);
    double dx = BeamProfileMonitorData_get_dx(el);
    double y_min = BeamProfileMonitorData_get_y_min(el);
    double dy = BeamProfileMonitorData_get_dy(el);


    START_PER_PARTICLE_BLOCK(part0, part);
        int64_t particle_id = LocalParticle_get_particle_id(part);
        if (particle_id_stop < 0 || (particle_id_start <= particle_id && particle_id < particle_id_stop))
        {
            // zeta is the absolute path length deviation from the reference particle: zeta = (s - beta0*c*t)
            // but without limits, i.e. it can exceed the circumference (for coasting beams)
            // as the particle falls behind or overtakes the reference particle
            double const zeta = LocalParticle_get_zeta(part);
            double const at_turn = LocalParticle_get_at_turn(part);
            double const beta0 = LocalParticle_get_beta0(part);

            // compute sample index
            int64_t sample = round(sampling_frequency * ( (at_turn-start_at_turn)/frev - zeta/beta0/C_LIGHT ));

            if (sample >= 0 && sample < max_sample){
                double x = LocalParticle_get_x(part);
                double y = LocalParticle_get_y(part);

                // compute bin index in raster
                int64_t bin_x = floor((x - x_min) / dx);
                int64_t bin_y = floor((y - y_min) / dy);

                if (bin_x >= 0 && bin_x < nx){
                    int64_t slot_x = sample * nx + bin_x;

                    if (slot_x >= 0 && slot_x < max_slot_x){
                        GPUGLMEM double* counts_x = BeamProfileMonitorRecord_getp1_counts_x(record, slot_x);
                        atomicAdd(counts_x, 1.);
                    }
                }

                if (bin_y >= 0 && bin_y < ny){
                    int64_t slot_y = sample * ny + bin_y;

                    if (slot_y >= 0 && slot_y < max_slot_y){
                        GPUGLMEM double* counts_y = BeamProfileMonitorRecord_getp1_counts_y(record, slot_y);
                        atomicAdd(counts_y, 1);
                    }
                }
            }
        }
    END_PER_PARTICLE_BLOCK;
}

#endif



             static inline
            void BeamProfileMonitor_track_local_particle_with_transformations(BeamProfileMonitorData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = BeamProfileMonitorData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamProfileMonitorData_get__cos_rot_s(el);
    double const shift_x = BeamProfileMonitorData_get__shift_x(el);
    double const shift_y = BeamProfileMonitorData_get__shift_y(el);
    double const shift_s = BeamProfileMonitorData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    BeamProfileMonitor_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamProfileMonitorData_get__cos_rot_s(el);
    double const shift_x = BeamProfileMonitorData_get__shift_x(el);
    double const shift_y = BeamProfileMonitorData_get__shift_y(el);
    double const shift_s = BeamProfileMonitorData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void BeamProfileMonitor_track_particles(
               BeamProfileMonitorData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              BeamProfileMonitor_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_SRotationData
#define XOBJ_TYPEDEF_SRotationData
typedef   struct SRotationData_s * SRotationData;
 static inline SRotationData SRotationData_getp(SRotationData restrict  obj){
  int64_t offset=0;
  return (SRotationData)(( char*) obj+offset);
}
 static inline double SRotationData_get_cos_z(const SRotationData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void SRotationData_set_cos_z(SRotationData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SRotationData_getp_cos_z(SRotationData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double SRotationData_get_sin_z(const SRotationData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SRotationData_set_sin_z(SRotationData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SRotationData_getp_sin_z(SRotationData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/srotation.h>

             static inline
            void SRotation_track_local_particle_with_transformations(SRotationData el, LocalParticle* part0){
    SRotation_track_local_particle(el, part0);
}


             
            void SRotation_track_particles(
               SRotationData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              SRotation_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_SecondOrderTaylorMapData
#define XOBJ_TYPEDEF_SecondOrderTaylorMapData
typedef   struct SecondOrderTaylorMapData_s * SecondOrderTaylorMapData;
 static inline SecondOrderTaylorMapData SecondOrderTaylorMapData_getp(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  return (SecondOrderTaylorMapData)(( char*) obj+offset);
}
 static inline Arr6Float64 SecondOrderTaylorMapData_getp_k(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  return (Arr6Float64)(( char*) obj+offset);
}
 static inline int64_t SecondOrderTaylorMapData_len_k(SecondOrderTaylorMapData restrict  obj){
  return 6;
}
 static inline double SecondOrderTaylorMapData_get_k(const SecondOrderTaylorMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set_k(SecondOrderTaylorMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp1_k(SecondOrderTaylorMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr6x6Float64 SecondOrderTaylorMapData_getp_R(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return (Arr6x6Float64)(( char*) obj+offset);
}
 static inline int64_t SecondOrderTaylorMapData_len_R(SecondOrderTaylorMapData restrict  obj){
  return 36;
}
 static inline double SecondOrderTaylorMapData_get_R(const SecondOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=48;
  offset+=i0*48+i1*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set_R(SecondOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1, double value){
  int64_t offset=0;
  offset+=48;
  offset+=i0*48+i1*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp2_R(SecondOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=48;
  offset+=i0*48+i1*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr6x6x6Float64 SecondOrderTaylorMapData_getp_T(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=336;
  return (Arr6x6x6Float64)(( char*) obj+offset);
}
 static inline int64_t SecondOrderTaylorMapData_len_T(SecondOrderTaylorMapData restrict  obj){
  return 216;
}
 static inline double SecondOrderTaylorMapData_get_T(const SecondOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1, int64_t i2){
  int64_t offset=0;
  offset+=336;
  offset+=i0*288+i1*48+i2*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set_T(SecondOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1, int64_t i2, double value){
  int64_t offset=0;
  offset+=336;
  offset+=i0*288+i1*48+i2*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp3_T(SecondOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1, int64_t i2){
  int64_t offset=0;
  offset+=336;
  offset+=i0*288+i1*48+i2*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double SecondOrderTaylorMapData_get_length(const SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2064;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set_length(SecondOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=2064;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp_length(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2064;
  return ( double*)(( char*) obj+offset);
}
 static inline double SecondOrderTaylorMapData_get__sin_rot_s(const SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2072;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set__sin_rot_s(SecondOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=2072;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp__sin_rot_s(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2072;
  return ( double*)(( char*) obj+offset);
}
 static inline double SecondOrderTaylorMapData_get__cos_rot_s(const SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2080;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set__cos_rot_s(SecondOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=2080;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp__cos_rot_s(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2080;
  return ( double*)(( char*) obj+offset);
}
 static inline double SecondOrderTaylorMapData_get__shift_x(const SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2088;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set__shift_x(SecondOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=2088;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp__shift_x(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2088;
  return ( double*)(( char*) obj+offset);
}
 static inline double SecondOrderTaylorMapData_get__shift_y(const SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2096;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set__shift_y(SecondOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=2096;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp__shift_y(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2096;
  return ( double*)(( char*) obj+offset);
}
 static inline double SecondOrderTaylorMapData_get__shift_s(const SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2104;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set__shift_s(SecondOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=2104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp__shift_s(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2104;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/second_order_taylor_map.h>

             static inline
            void SecondOrderTaylorMap_track_local_particle_with_transformations(SecondOrderTaylorMapData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = SecondOrderTaylorMapData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = SecondOrderTaylorMapData_get__cos_rot_s(el);
    double const shift_x = SecondOrderTaylorMapData_get__shift_x(el);
    double const shift_y = SecondOrderTaylorMapData_get__shift_y(el);
    double const shift_s = SecondOrderTaylorMapData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    SecondOrderTaylorMap_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = SecondOrderTaylorMapData_get__cos_rot_s(el);
    double const shift_x = SecondOrderTaylorMapData_get__shift_x(el);
    double const shift_y = SecondOrderTaylorMapData_get__shift_y(el);
    double const shift_s = SecondOrderTaylorMapData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void SecondOrderTaylorMap_track_particles(
               SecondOrderTaylorMapData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              SecondOrderTaylorMap_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_SimpleThinQuadrupoleData
#define XOBJ_TYPEDEF_SimpleThinQuadrupoleData
typedef   struct SimpleThinQuadrupoleData_s * SimpleThinQuadrupoleData;
 static inline SimpleThinQuadrupoleData SimpleThinQuadrupoleData_getp(SimpleThinQuadrupoleData restrict  obj){
  int64_t offset=0;
  return (SimpleThinQuadrupoleData)(( char*) obj+offset);
}
 static inline Arr2Float64 SimpleThinQuadrupoleData_getp_knl(SimpleThinQuadrupoleData restrict  obj){
  int64_t offset=0;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t SimpleThinQuadrupoleData_len_knl(SimpleThinQuadrupoleData restrict  obj){
  return 2;
}
 static inline double SimpleThinQuadrupoleData_get_knl(const SimpleThinQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SimpleThinQuadrupoleData_set_knl(SimpleThinQuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SimpleThinQuadrupoleData_getp1_knl(SimpleThinQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/simplethinquadrupole.h>

             static inline
            void SimpleThinQuadrupole_track_local_particle_with_transformations(SimpleThinQuadrupoleData el, LocalParticle* part0){
    SimpleThinQuadrupole_track_local_particle(el, part0);
}


             
            void SimpleThinQuadrupole_track_particles(
               SimpleThinQuadrupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              SimpleThinQuadrupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_LimitPolygonData
#define XOBJ_TYPEDEF_LimitPolygonData
typedef   struct LimitPolygonData_s * LimitPolygonData;
 static inline LimitPolygonData LimitPolygonData_getp(LimitPolygonData restrict  obj){
  int64_t offset=0;
  return (LimitPolygonData)(( char*) obj+offset);
}
 static inline ArrNFloat64 LimitPolygonData_getp_x_vertices(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LimitPolygonData_len_x_vertices(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=80;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LimitPolygonData_get_x_vertices(const LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set_x_vertices(LimitPolygonData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=80;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp1_x_vertices(LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LimitPolygonData_getp_y_vertices(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LimitPolygonData_len_y_vertices(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LimitPolygonData_get_y_vertices(const LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set_y_vertices(LimitPolygonData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp1_y_vertices(LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LimitPolygonData_getp_x_normal(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LimitPolygonData_len_x_normal(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LimitPolygonData_get_x_normal(const LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set_x_normal(LimitPolygonData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp1_x_normal(LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LimitPolygonData_getp_y_normal(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LimitPolygonData_len_y_normal(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LimitPolygonData_get_y_normal(const LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set_y_normal(LimitPolygonData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp1_y_normal(LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitPolygonData_get_resc_fac(const LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set_resc_fac(LimitPolygonData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp_resc_fac(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitPolygonData_get__sin_rot_s(const LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set__sin_rot_s(LimitPolygonData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp__sin_rot_s(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitPolygonData_get__cos_rot_s(const LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set__cos_rot_s(LimitPolygonData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp__cos_rot_s(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitPolygonData_get__shift_x(const LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set__shift_x(LimitPolygonData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp__shift_x(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitPolygonData_get__shift_y(const LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set__shift_y(LimitPolygonData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp__shift_y(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitPolygonData_get__shift_s(const LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set__shift_s(LimitPolygonData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp__shift_s(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/apertures_src/limitpolygon.h>

             static inline
            void LimitPolygon_track_local_particle_with_transformations(LimitPolygonData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LimitPolygonData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitPolygonData_get__cos_rot_s(el);
    double const shift_x = LimitPolygonData_get__shift_x(el);
    double const shift_y = LimitPolygonData_get__shift_y(el);
    double const shift_s = LimitPolygonData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LimitPolygon_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitPolygonData_get__cos_rot_s(el);
    double const shift_x = LimitPolygonData_get__shift_x(el);
    double const shift_y = LimitPolygonData_get__shift_y(el);
    double const shift_s = LimitPolygonData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LimitPolygon_track_particles(
               LimitPolygonData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LimitPolygon_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ElensData
#define XOBJ_TYPEDEF_ElensData
typedef   struct ElensData_s * ElensData;
 static inline ElensData ElensData_getp(ElensData restrict  obj){
  int64_t offset=0;
  return (ElensData)(( char*) obj+offset);
}
 static inline double ElensData_get_current(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_current(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_current(ElensData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get_inner_radius(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_inner_radius(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_inner_radius(ElensData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get_outer_radius(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_outer_radius(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_outer_radius(ElensData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get_elens_length(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_elens_length(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_elens_length(ElensData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get_voltage(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_voltage(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_voltage(ElensData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get_residual_kick_x(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_residual_kick_x(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_residual_kick_x(ElensData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get_residual_kick_y(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_residual_kick_y(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_residual_kick_y(ElensData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ElensData_getp_coefficients_polynomial(ElensData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ElensData_len_coefficients_polynomial(ElensData restrict  obj){
  int64_t offset=0;
  offset+=112;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ElensData_get_coefficients_polynomial(const ElensData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=112;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_coefficients_polynomial(ElensData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=112;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp1_coefficients_polynomial(ElensData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=112;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get_polynomial_order(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_polynomial_order(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_polynomial_order(ElensData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get__sin_rot_s(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set__sin_rot_s(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp__sin_rot_s(ElensData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get__cos_rot_s(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set__cos_rot_s(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp__cos_rot_s(ElensData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get__shift_x(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set__shift_x(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp__shift_x(ElensData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get__shift_y(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set__shift_y(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp__shift_y(ElensData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get__shift_s(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set__shift_s(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp__shift_s(ElensData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/elens.h>

             static inline
            void Elens_track_local_particle_with_transformations(ElensData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ElensData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ElensData_get__cos_rot_s(el);
    double const shift_x = ElensData_get__shift_x(el);
    double const shift_y = ElensData_get__shift_y(el);
    double const shift_s = ElensData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Elens_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ElensData_get__cos_rot_s(el);
    double const shift_x = ElensData_get__shift_x(el);
    double const shift_y = ElensData_get__shift_y(el);
    double const shift_s = ElensData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Elens_track_particles(
               ElensData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Elens_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_DriftData
#define XOBJ_TYPEDEF_DriftData
typedef   struct DriftData_s * DriftData;
 static inline DriftData DriftData_getp(DriftData restrict  obj){
  int64_t offset=0;
  return (DriftData)(( char*) obj+offset);
}
 static inline double DriftData_get_length(const DriftData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftData_set_length(DriftData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftData_getp_length(DriftData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/drift.h>

             static inline
            void Drift_track_local_particle_with_transformations(DriftData el, LocalParticle* part0){
    Drift_track_local_particle(el, part0);
}


             
            void Drift_track_particles(
               DriftData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Drift_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_MultipoleEdgeData
#define XOBJ_TYPEDEF_MultipoleEdgeData
typedef   struct MultipoleEdgeData_s * MultipoleEdgeData;
 static inline MultipoleEdgeData MultipoleEdgeData_getp(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  return (MultipoleEdgeData)(( char*) obj+offset);
}
 static inline ArrNFloat64 MultipoleEdgeData_getp_kn(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t MultipoleEdgeData_len_kn(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=72;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double MultipoleEdgeData_get_kn(const MultipoleEdgeData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set_kn(MultipoleEdgeData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleEdgeData_getp1_kn(MultipoleEdgeData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 MultipoleEdgeData_getp_ks(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t MultipoleEdgeData_len_ks(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double MultipoleEdgeData_get_ks(const MultipoleEdgeData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set_ks(MultipoleEdgeData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleEdgeData_getp1_ks(MultipoleEdgeData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t MultipoleEdgeData_get_is_exit(const MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set_is_exit(MultipoleEdgeData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MultipoleEdgeData_getp_is_exit(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MultipoleEdgeData_get_order(const MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set_order(MultipoleEdgeData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MultipoleEdgeData_getp_order(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double MultipoleEdgeData_get__sin_rot_s(const MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set__sin_rot_s(MultipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleEdgeData_getp__sin_rot_s(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleEdgeData_get__cos_rot_s(const MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set__cos_rot_s(MultipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleEdgeData_getp__cos_rot_s(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleEdgeData_get__shift_x(const MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set__shift_x(MultipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleEdgeData_getp__shift_x(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleEdgeData_get__shift_y(const MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set__shift_y(MultipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleEdgeData_getp__shift_y(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleEdgeData_get__shift_s(const MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set__shift_s(MultipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleEdgeData_getp__shift_s(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/multipoleedge.h>

             static inline
            void MultipoleEdge_track_local_particle_with_transformations(MultipoleEdgeData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = MultipoleEdgeData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = MultipoleEdgeData_get__cos_rot_s(el);
    double const shift_x = MultipoleEdgeData_get__shift_x(el);
    double const shift_y = MultipoleEdgeData_get__shift_y(el);
    double const shift_s = MultipoleEdgeData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    MultipoleEdge_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = MultipoleEdgeData_get__cos_rot_s(el);
    double const shift_x = MultipoleEdgeData_get__shift_x(el);
    double const shift_y = MultipoleEdgeData_get__shift_y(el);
    double const shift_s = MultipoleEdgeData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void MultipoleEdge_track_particles(
               MultipoleEdgeData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              MultipoleEdge_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_LimitRacetrackData
#define XOBJ_TYPEDEF_LimitRacetrackData
typedef   struct LimitRacetrackData_s * LimitRacetrackData;
 static inline LimitRacetrackData LimitRacetrackData_getp(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  return (LimitRacetrackData)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get_min_x(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set_min_x(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp_min_x(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get_max_x(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set_max_x(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp_max_x(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get_min_y(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set_min_y(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp_min_y(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get_max_y(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set_max_y(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp_max_y(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get_a(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set_a(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp_a(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get_b(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set_b(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp_b(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get__sin_rot_s(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set__sin_rot_s(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp__sin_rot_s(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get__cos_rot_s(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set__cos_rot_s(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp__cos_rot_s(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get__shift_x(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set__shift_x(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp__shift_x(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get__shift_y(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set__shift_y(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp__shift_y(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get__shift_s(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set__shift_s(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp__shift_s(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/apertures_src/limitracetrack.h>

             static inline
            void LimitRacetrack_track_local_particle_with_transformations(LimitRacetrackData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LimitRacetrackData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitRacetrackData_get__cos_rot_s(el);
    double const shift_x = LimitRacetrackData_get__shift_x(el);
    double const shift_y = LimitRacetrackData_get__shift_y(el);
    double const shift_s = LimitRacetrackData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LimitRacetrack_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitRacetrackData_get__cos_rot_s(el);
    double const shift_x = LimitRacetrackData_get__shift_x(el);
    double const shift_y = LimitRacetrackData_get__shift_y(el);
    double const shift_s = LimitRacetrackData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LimitRacetrack_track_particles(
               LimitRacetrackData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LimitRacetrack_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ReferenceEnergyIncreaseData
#define XOBJ_TYPEDEF_ReferenceEnergyIncreaseData
typedef   struct ReferenceEnergyIncreaseData_s * ReferenceEnergyIncreaseData;
 static inline ReferenceEnergyIncreaseData ReferenceEnergyIncreaseData_getp(ReferenceEnergyIncreaseData restrict  obj){
  int64_t offset=0;
  return (ReferenceEnergyIncreaseData)(( char*) obj+offset);
}
 static inline double ReferenceEnergyIncreaseData_get_Delta_p0c(const ReferenceEnergyIncreaseData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void ReferenceEnergyIncreaseData_set_Delta_p0c(ReferenceEnergyIncreaseData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ReferenceEnergyIncreaseData_getp_Delta_p0c(ReferenceEnergyIncreaseData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/referenceenergyincrease.h>

             static inline
            void ReferenceEnergyIncrease_track_local_particle_with_transformations(ReferenceEnergyIncreaseData el, LocalParticle* part0){
    ReferenceEnergyIncrease_track_local_particle(el, part0);
}


             
            void ReferenceEnergyIncrease_track_particles(
               ReferenceEnergyIncreaseData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ReferenceEnergyIncrease_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RecordIdentifier
#define XOBJ_TYPEDEF_RecordIdentifier
typedef   struct RecordIdentifier_s * RecordIdentifier;
 static inline RecordIdentifier RecordIdentifier_getp(RecordIdentifier restrict  obj){
  int64_t offset=0;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t RecordIdentifier_get_buffer_id(const RecordIdentifier restrict  obj){
  int64_t offset=0;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RecordIdentifier_set_buffer_id(RecordIdentifier restrict  obj, int64_t value){
  int64_t offset=0;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RecordIdentifier_getp_buffer_id(RecordIdentifier restrict  obj){
  int64_t offset=0;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RecordIdentifier_get_offset(const RecordIdentifier restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RecordIdentifier_set_offset(RecordIdentifier restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RecordIdentifier_getp_offset(RecordIdentifier restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
#endif

 static inline
  int8_t* RecordIdentifier_getp_record(RecordIdentifier record_id, LocalParticle* part){
      int8_t* io_buffer = LocalParticle_get_io_buffer(part);
    if (io_buffer == NULL){
        return NULL;
    }

    int64_t buffer_id = RecordIdentifier_get_buffer_id(record_id);
      int64_t* found_id = (  int64_t*)io_buffer;
    if (buffer_id != (*found_id)){
        printf("Error: buffer_id mismatch!\n");
        return NULL;
    }

    int64_t offset = RecordIdentifier_get_offset(record_id);

    return io_buffer + offset;
    }


#ifndef XOBJ_TYPEDEF_InteractionRecordData
#define XOBJ_TYPEDEF_InteractionRecordData
typedef   struct InteractionRecordData_s * InteractionRecordData;
 static inline InteractionRecordData InteractionRecordData_getp(InteractionRecordData restrict  obj){
  int64_t offset=0;
  return (InteractionRecordData)(( char*) obj+offset);
}
 static inline RecordIndex InteractionRecordData_getp__index(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_get__index_capacity(const InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set__index_capacity(InteractionRecordData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp__index_capacity(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t InteractionRecordData_get__index_num_recorded(const InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set__index_num_recorded(InteractionRecordData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=16;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* InteractionRecordData_getp__index_num_recorded(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t InteractionRecordData_get__index__dummy(const InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set__index__dummy(InteractionRecordData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=24;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* InteractionRecordData_getp__index__dummy(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_get__index_buffer_id(const InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set__index_buffer_id(InteractionRecordData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp__index_buffer_id(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 InteractionRecordData_getp_at_element(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=320;
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_at_element(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=320;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t InteractionRecordData_get_at_element(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=320;
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_at_element(InteractionRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=320;
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp1_at_element(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=320;
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 InteractionRecordData_getp_at_turn(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_at_turn(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t InteractionRecordData_get_at_turn(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_at_turn(InteractionRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp1_at_turn(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 InteractionRecordData_getp__inter(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len__inter(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t InteractionRecordData_get__inter(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set__inter(InteractionRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp1__inter(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 InteractionRecordData_getp_id_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_id_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t InteractionRecordData_get_id_before(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_id_before(InteractionRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp1_id_before(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_s_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_s_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_s_before(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_s_before(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_s_before(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_x_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_x_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_x_before(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_x_before(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_x_before(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_px_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_px_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_px_before(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_px_before(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_px_before(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_y_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_y_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_y_before(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_y_before(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_y_before(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_py_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_py_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_py_before(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_py_before(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_py_before(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_zeta_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_zeta_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_zeta_before(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_zeta_before(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_zeta_before(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_delta_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_delta_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_delta_before(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_delta_before(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_delta_before(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_energy_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_energy_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_energy_before(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_energy_before(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_energy_before(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_mass_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_mass_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_mass_before(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_mass_before(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_mass_before(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNInt64 InteractionRecordData_getp_charge_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_charge_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t InteractionRecordData_get_charge_before(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_charge_before(InteractionRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp1_charge_before(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 InteractionRecordData_getp_z_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_z_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t InteractionRecordData_get_z_before(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_z_before(InteractionRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp1_z_before(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 InteractionRecordData_getp_a_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_a_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t InteractionRecordData_get_a_before(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_a_before(InteractionRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp1_a_before(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 InteractionRecordData_getp_pdgid_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_pdgid_before(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t InteractionRecordData_get_pdgid_before(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_pdgid_before(InteractionRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp1_pdgid_before(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 InteractionRecordData_getp_id_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_id_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t InteractionRecordData_get_id_after(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_id_after(InteractionRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp1_id_after(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_s_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_s_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_s_after(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_s_after(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_s_after(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_x_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_x_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_x_after(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_x_after(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_x_after(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_px_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_px_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_px_after(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_px_after(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_px_after(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_y_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_y_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_y_after(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_y_after(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_y_after(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_py_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_py_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_py_after(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_py_after(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_py_after(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_zeta_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_zeta_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_zeta_after(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_zeta_after(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_zeta_after(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_delta_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_delta_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_delta_after(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_delta_after(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_delta_after(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_energy_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_energy_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_energy_after(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_energy_after(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_energy_after(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 InteractionRecordData_getp_mass_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_mass_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double InteractionRecordData_get_mass_after(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_mass_after(InteractionRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp1_mass_after(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNInt64 InteractionRecordData_getp_charge_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_charge_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t InteractionRecordData_get_charge_after(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_charge_after(InteractionRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp1_charge_after(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 InteractionRecordData_getp_z_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_z_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t InteractionRecordData_get_z_after(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_z_after(InteractionRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp1_z_after(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 InteractionRecordData_getp_a_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_a_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t InteractionRecordData_get_a_after(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_a_after(InteractionRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp1_a_after(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 InteractionRecordData_getp_pdgid_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t InteractionRecordData_len_pdgid_after(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t InteractionRecordData_get_pdgid_after(const InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set_pdgid_after(InteractionRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* InteractionRecordData_getp1_pdgid_after(InteractionRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double InteractionRecordData_get__sin_rot_s(const InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set__sin_rot_s(InteractionRecordData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp__sin_rot_s(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double InteractionRecordData_get__cos_rot_s(const InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set__cos_rot_s(InteractionRecordData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp__cos_rot_s(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double InteractionRecordData_get__shift_x(const InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set__shift_x(InteractionRecordData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp__shift_x(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double InteractionRecordData_get__shift_y(const InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set__shift_y(InteractionRecordData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp__shift_y(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double InteractionRecordData_get__shift_s(const InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void InteractionRecordData_set__shift_s(InteractionRecordData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InteractionRecordData_getp__shift_s(InteractionRecordData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


#ifndef XCOLL_INTERACTIONS_H
#define XCOLL_INTERACTIONS_H

#define  XC_UNITIALISED                     0        // NAN  // Do not use

#define  XC_ENTER_JAW_L                    -1        // JI   // point (no children)    Set ds > 0 if entering later
#define  XC_ENTER_JAW_R                    -2        // JI   // point (no children)    Set ds > 0 if entering later
#define  XC_EXIT_JAW                       -3        // JO   // point (no children)
#define  XC_ENTER_JAW                      -4        // JI   // point (no children)    Set ds > 0 if entering later    still here for compatibility
#define  XC_ABSORBED                        1        // A    // point (no children)    Don't use 0 (is default for unitialised)
#define  XC_MULTIPLE_COULOMB_SCATTERING    13        // MCS  // continuous
#define  XC_PN_ELASTIC                     14        // PN   // point (no children)
#define  XC_PP_ELASTIC                     15        // PP   // point (no children)
#define  XC_SINGLE_DIFFRACTIVE             16        // SD   // point (no children)
#define  XC_COULOMB                        17        // C    // point (no children)
#define  XC_CHANNELING                    100        // CH   // continuous
#define  XC_DECHANNELING                  101        // DCH  // point (no children)
#define  XC_VOLUME_REFLECTION_TRANS_CH    102        // VRCH // point (no children)    Transition region around +-xpcrit
#define  XC_VOLUME_REFLECTION             103        // VR   // point (no children)
#define  XC_VOLUME_REFLECTION_TRANS_MCS   104        // VRAM // point (no children)    Transition region around t_P
#define  XC_MULTIPLE_COULOMB_TRANS_VR     105        // AMVR // continuous             Transition region around t_P + 2 xpcrit
#define  XC_VOLUME_CAPTURE                106        // VC   // point (no children)

#endif /* XCOLL_INTERACTIONS_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_STATES_H
#define XCOLL_STATES_H

#define  XC_LOST_ON_EVEREST_BLOCK   -330
#define  XC_LOST_ON_EVEREST_COLL    -331
#define  XC_LOST_ON_EVEREST_CRYSTAL -332
#define  XC_LOST_ON_FLUKA_BLOCK     -333
#define  XC_LOST_ON_FLUKA_COLL      -334
#define  XC_LOST_ON_FLUKA_CRYSTAL   -335
#define  XC_LOST_ON_GEANT4_BLOCK    -336
#define  XC_LOST_ON_GEANT4_COLL     -337
#define  XC_LOST_ON_GEANT4_CRYSTAL  -338
#define  XC_LOST_ON_ABSORBER        -340

#define  XC_ERR_INVALID_TRACK       -390
#define  XC_ERR_NOT_IMPLEMENTED     -391
#define  XC_ERR_INVALID_XOFIELD     -392
#define  XC_ERR                     -399

#endif /* XCOLL_STATES_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #


#ifndef XCOLL_IMPACTS_H
#define XCOLL_IMPACTS_H

// TODO: do we need to pass RecordIndex?
// probably can do RecordIndex record_index = InteractionRecordData_getp__index(record);  ?
 static inline
int64_t InteractionRecordData_log(InteractionRecordData record, RecordIndex record_index, LocalParticle* parent,
                                  int64_t interaction){
    // This can be used for a point-like interaction where there is no child (or because it's equal to the parent)
    // or to log the parent first, to be followed up with InteractionRecordData_log_child on the same slot

    int64_t i_slot = -1;
    if (record){
        // Get a slot in the record (this is thread safe)
        i_slot = RecordIndex_get_slot(record_index);
        // The returned slot id is negative if record is NULL or if record is full

        if (i_slot>=0){
            InteractionRecordData_set_at_element(record, i_slot, LocalParticle_get_at_element(parent));
            InteractionRecordData_set_at_turn(record, i_slot, LocalParticle_get_at_turn(parent));
            InteractionRecordData_set__inter(record, i_slot, interaction);

            double charge_ratio = LocalParticle_get_charge_ratio(parent);
            double mass_ratio = charge_ratio / LocalParticle_get_chi(parent);
            double energy = ( LocalParticle_get_ptau(parent) + 1 / LocalParticle_get_beta0(parent)
                             ) * mass_ratio * LocalParticle_get_p0c(parent);
            // All fields have to be written, or the arrays will not have the same length
            // TODO: maybe this is not true, as we are setting by slot index? Don't the arrays come pre-initialised?
            InteractionRecordData_set_id_before(record, i_slot, LocalParticle_get_particle_id(parent));
            InteractionRecordData_set_s_before(record,  i_slot, LocalParticle_get_s(parent));
            InteractionRecordData_set_x_before(record,  i_slot, LocalParticle_get_x(parent));
            InteractionRecordData_set_px_before(record, i_slot, LocalParticle_get_px(parent));
            InteractionRecordData_set_y_before(record,  i_slot, LocalParticle_get_y(parent));
            InteractionRecordData_set_py_before(record, i_slot, LocalParticle_get_py(parent));
            InteractionRecordData_set_zeta_before(record,   i_slot, LocalParticle_get_zeta(parent));
            InteractionRecordData_set_delta_before(record,  i_slot, LocalParticle_get_delta(parent));
            InteractionRecordData_set_energy_before(record, i_slot, energy);
            InteractionRecordData_set_mass_before(record,   i_slot, mass_ratio*LocalParticle_get_mass0(parent));
            InteractionRecordData_set_charge_before(record, i_slot, charge_ratio*LocalParticle_get_q0(parent));
            // TODO: particle info
            InteractionRecordData_set_z_before(record, i_slot, -1);
            InteractionRecordData_set_a_before(record, i_slot, -1);
            InteractionRecordData_set_pdgid_before(record, i_slot, -1);

            // TODO: maybe this is not needed
            InteractionRecordData_set_id_after(record, i_slot, -1);
            InteractionRecordData_set_s_after(record, i_slot, -1);
            InteractionRecordData_set_x_after(record, i_slot, -1);
            InteractionRecordData_set_px_after(record, i_slot, -1);
            InteractionRecordData_set_y_after(record, i_slot, -1);
            InteractionRecordData_set_py_after(record, i_slot, -1);
            InteractionRecordData_set_zeta_after(record, i_slot, -1);
            InteractionRecordData_set_delta_after(record, i_slot, -1);
            InteractionRecordData_set_energy_after(record, i_slot, -1);
            InteractionRecordData_set_mass_after(record, i_slot, -1);
            InteractionRecordData_set_charge_after(record, i_slot, -1);
            InteractionRecordData_set_z_after(record, i_slot, -1);
            InteractionRecordData_set_a_after(record, i_slot, -1);
            InteractionRecordData_set_pdgid_after(record, i_slot, -1);
        }
    }
//     printf("Logging %i in slot %i\n", interaction, i_slot);
    return i_slot;
}

 static inline
void InteractionRecordData_log_child(InteractionRecordData record, int64_t i_slot, LocalParticle* child){
    if (record && i_slot>=0){
        double charge_ratio = LocalParticle_get_charge_ratio(child);
        double mass_ratio = charge_ratio / LocalParticle_get_chi(child);
        double energy = ( LocalParticle_get_ptau(child) + 1 / LocalParticle_get_beta0(child)
                         ) * mass_ratio * LocalParticle_get_p0c(child);
        InteractionRecordData_set_id_after(record, i_slot, LocalParticle_get_particle_id(child));
        InteractionRecordData_set_s_after(record,  i_slot, LocalParticle_get_s(child));
        InteractionRecordData_set_x_after(record,  i_slot, LocalParticle_get_x(child));
        InteractionRecordData_set_px_after(record, i_slot, LocalParticle_get_px(child));
        InteractionRecordData_set_y_after(record,  i_slot, LocalParticle_get_y(child));
        InteractionRecordData_set_py_after(record, i_slot, LocalParticle_get_py(child));
        InteractionRecordData_set_zeta_after(record,  i_slot, LocalParticle_get_zeta(child));
        InteractionRecordData_set_delta_after(record, i_slot, LocalParticle_get_delta(child));
        InteractionRecordData_set_energy_after(record, i_slot, energy);
        InteractionRecordData_set_mass_after(record,   i_slot, mass_ratio*LocalParticle_get_mass0(child));
        InteractionRecordData_set_charge_after(record, i_slot, charge_ratio*LocalParticle_get_q0(child));
        // TODO: particle info
        InteractionRecordData_set_z_after(record, i_slot, -1);
        InteractionRecordData_set_a_after(record, i_slot, -1);
        InteractionRecordData_set_pdgid_after(record, i_slot, -1);
//     printf("Slot %i: length %f\n", i_slot, ds);
    }
}

#endif /* XCOLL_IMPACTS_H */

#ifndef XOBJ_TYPEDEF_RandomUniformData
#define XOBJ_TYPEDEF_RandomUniformData
typedef   struct RandomUniformData_s * RandomUniformData;
 static inline RandomUniformData RandomUniformData_getp(RandomUniformData restrict  obj){
  int64_t offset=0;
  return (RandomUniformData)(( char*) obj+offset);
}
 static inline uint8_t RandomUniformData_get__dummy(const RandomUniformData restrict  obj){
  int64_t offset=0;
  return *(( uint8_t*) obj+offset);
}
 static inline void RandomUniformData_set__dummy(RandomUniformData restrict  obj, uint8_t value){
  int64_t offset=0;
  *(( uint8_t*) obj+offset)=value;
}
 static inline  uint8_t* RandomUniformData_getp__dummy(RandomUniformData restrict  obj){
  int64_t offset=0;
  return ( uint8_t*)(( char*) obj+offset);
}
 static inline double RandomUniformData_get__sin_rot_s(const RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformData_set__sin_rot_s(RandomUniformData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformData_getp__sin_rot_s(RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformData_get__cos_rot_s(const RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformData_set__cos_rot_s(RandomUniformData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformData_getp__cos_rot_s(RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformData_get__shift_x(const RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformData_set__shift_x(RandomUniformData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformData_getp__shift_x(RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformData_get__shift_y(const RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformData_set__shift_y(RandomUniformData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformData_getp__shift_y(RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformData_get__shift_s(const RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformData_set__shift_s(RandomUniformData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformData_getp__shift_s(RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <random/random_src/uniform.h>

             
            void sample_uniform(
               RandomUniformData el,

                             ParticlesData particles,
    double* samples,  int64_t n_samples_per_seed, 
                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              RandomUniform_sample(el, &lpart, samples, n_samples_per_seed);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_LastTurnsMonitorData
#define XOBJ_TYPEDEF_LastTurnsMonitorData
typedef   struct LastTurnsMonitorData_s * LastTurnsMonitorData;
 static inline LastTurnsMonitorData LastTurnsMonitorData_getp(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  return (LastTurnsMonitorData)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_get_particle_id_start(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_particle_id_start(LastTurnsMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LastTurnsMonitorData_getp_particle_id_start(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_get_num_particles(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_num_particles(LastTurnsMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LastTurnsMonitorData_getp_num_particles(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_get_n_last_turns(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_n_last_turns(LastTurnsMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LastTurnsMonitorData_getp_n_last_turns(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_get_every_n_turns(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_every_n_turns(LastTurnsMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LastTurnsMonitorData_getp_every_n_turns(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline LastTurnsData LastTurnsMonitorData_getp_data(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return (LastTurnsData)(( char*) obj+offset);
}
 static inline ArrNUint32 LastTurnsMonitorData_getp_data_lost_at_offset(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_lost_at_offset(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t LastTurnsMonitorData_get_data_lost_at_offset(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=152;
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_lost_at_offset(LastTurnsMonitorData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=152;
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* LastTurnsMonitorData_getp1_data_lost_at_offset(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=152;
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 LastTurnsMonitorData_getp_data_particle_id(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_particle_id(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t LastTurnsMonitorData_get_data_particle_id(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_particle_id(LastTurnsMonitorData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* LastTurnsMonitorData_getp1_data_particle_id(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 LastTurnsMonitorData_getp_data_at_turn(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_at_turn(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+16);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t LastTurnsMonitorData_get_data_at_turn(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_at_turn(LastTurnsMonitorData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* LastTurnsMonitorData_getp1_data_at_turn(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsMonitorData_getp_data_x(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_x(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+24);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsMonitorData_get_data_x(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_x(LastTurnsMonitorData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsMonitorData_getp1_data_x(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsMonitorData_getp_data_px(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_px(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+32);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsMonitorData_get_data_px(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_px(LastTurnsMonitorData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsMonitorData_getp1_data_px(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsMonitorData_getp_data_y(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_y(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+40);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsMonitorData_get_data_y(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_y(LastTurnsMonitorData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsMonitorData_getp1_data_y(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsMonitorData_getp_data_py(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_py(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+48);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsMonitorData_get_data_py(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_py(LastTurnsMonitorData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsMonitorData_getp1_data_py(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsMonitorData_getp_data_delta(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_delta(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+56);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsMonitorData_get_data_delta(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_delta(LastTurnsMonitorData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsMonitorData_getp1_data_delta(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsMonitorData_getp_data_zeta(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_zeta(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsMonitorData_get_data_zeta(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_zeta(LastTurnsMonitorData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsMonitorData_getp1_data_zeta(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline double LastTurnsMonitorData_get__sin_rot_s(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set__sin_rot_s(LastTurnsMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LastTurnsMonitorData_getp__sin_rot_s(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LastTurnsMonitorData_get__cos_rot_s(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set__cos_rot_s(LastTurnsMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LastTurnsMonitorData_getp__cos_rot_s(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LastTurnsMonitorData_get__shift_x(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set__shift_x(LastTurnsMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LastTurnsMonitorData_getp__shift_x(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double LastTurnsMonitorData_get__shift_y(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set__shift_y(LastTurnsMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LastTurnsMonitorData_getp__shift_y(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double LastTurnsMonitorData_get__shift_s(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set__shift_s(LastTurnsMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LastTurnsMonitorData_getp__shift_s(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// ##################################
// Monitor to save particle state
// for last N turns before loss
// 
// Author: Philipp Niedermayer
// Date: 2023-01-19
// ##################################

#ifndef XTRACK_LAST_TURNS_MONITOR_H
#define XTRACK_LAST_TURNS_MONITOR_H

#include <headers/track.h>


GPUFUN
void LastTurnsMonitor_track_local_particle(LastTurnsMonitorData el, LocalParticle* part0){
    int64_t n_last_turns = LastTurnsMonitorData_get_n_last_turns(el);
    int64_t particle_id_start = LastTurnsMonitorData_get_particle_id_start(el);
    int64_t particle_id_stop = particle_id_start + LastTurnsMonitorData_get_num_particles(el);
    int64_t every_n_turns = LastTurnsMonitorData_get_every_n_turns(el);
    LastTurnsData data = LastTurnsMonitorData_getp_data(el);

    START_PER_PARTICLE_BLOCK(part0, part);
        int64_t particle_id = LocalParticle_get_particle_id(part);
        int64_t at_turn = LocalParticle_get_at_turn(part);

        // When the particle is lost, tracking is stopped automatically for it.
        // Therefore we don't need to check for particle state here.
        // But this also means, that he have to save the buffer offset each time
        // as long as the particle is still alive, since it could be the last
        // time we see it.
    
        if (at_turn >= 0 && at_turn%every_n_turns == 0 && particle_id_start <= particle_id && particle_id < particle_id_stop)
        {
            // determine slot in rolling buffer
            int64_t offset = (at_turn / every_n_turns) % n_last_turns;
            int64_t ip = particle_id - particle_id_start;
            int64_t slot = n_last_turns * ip + offset;

            // store buffer offset
            LastTurnsData_set_lost_at_offset(data, ip, offset);

            // store data
            LastTurnsData_set_particle_id(data, slot, particle_id);
            LastTurnsData_set_at_turn(data, slot, at_turn);
            LastTurnsData_set_x(data, slot, LocalParticle_get_x(part));
            LastTurnsData_set_px(data, slot, LocalParticle_get_px(part));
            LastTurnsData_set_y(data, slot, LocalParticle_get_y(part));
            LastTurnsData_set_py(data, slot, LocalParticle_get_py(part));
            LastTurnsData_set_delta(data, slot, LocalParticle_get_delta(part));
            LastTurnsData_set_zeta(data, slot, LocalParticle_get_zeta(part));
        }
    END_PER_PARTICLE_BLOCK;

}

#endif


             static inline
            void LastTurnsMonitor_track_local_particle_with_transformations(LastTurnsMonitorData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LastTurnsMonitorData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LastTurnsMonitorData_get__cos_rot_s(el);
    double const shift_x = LastTurnsMonitorData_get__shift_x(el);
    double const shift_y = LastTurnsMonitorData_get__shift_y(el);
    double const shift_s = LastTurnsMonitorData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LastTurnsMonitor_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LastTurnsMonitorData_get__cos_rot_s(el);
    double const shift_x = LastTurnsMonitorData_get__shift_x(el);
    double const shift_y = LastTurnsMonitorData_get__shift_y(el);
    double const shift_s = LastTurnsMonitorData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LastTurnsMonitor_track_particles(
               LastTurnsMonitorData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LastTurnsMonitor_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RefDriftData
#define XOBJ_TYPEDEF_RefDriftData
typedef   struct RefDriftData_s * RefDriftData;
#endif
#ifndef XOBJ_TYPEDEF_XcollGeometryData
#define XOBJ_TYPEDEF_XcollGeometryData
typedef   struct XcollGeometryData_s * XcollGeometryData;
 static inline XcollGeometryData XcollGeometryData_getp(XcollGeometryData restrict  obj){
  int64_t offset=0;
  return (XcollGeometryData)(( char*) obj+offset);
}
 static inline double XcollGeometryData_get__sin_rot_s(const XcollGeometryData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void XcollGeometryData_set__sin_rot_s(XcollGeometryData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XcollGeometryData_getp__sin_rot_s(XcollGeometryData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double XcollGeometryData_get__cos_rot_s(const XcollGeometryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void XcollGeometryData_set__cos_rot_s(XcollGeometryData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XcollGeometryData_getp__cos_rot_s(XcollGeometryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double XcollGeometryData_get__shift_x(const XcollGeometryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void XcollGeometryData_set__shift_x(XcollGeometryData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XcollGeometryData_getp__shift_x(XcollGeometryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double XcollGeometryData_get__shift_y(const XcollGeometryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void XcollGeometryData_set__shift_y(XcollGeometryData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XcollGeometryData_getp__shift_y(XcollGeometryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double XcollGeometryData_get__shift_s(const XcollGeometryData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void XcollGeometryData_set__shift_s(XcollGeometryData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XcollGeometryData_getp__shift_s(XcollGeometryData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_GEOM_SORT_H
#define XCOLL_GEOM_SORT_H
#include <math.h>
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Warray-bounds"

#ifdef MAX
#undef MAX
#pragma message ("Xcoll geometry: Compiler macro MAX redefined")
#endif
#define MAX(x, y) ({const __typeof__ (x) _x = (x); \
                    const __typeof__ (y) _y = (y); \
                    _x > _y ? _x : _y; })
#ifdef MIN
#undef MIN
#pragma message ("Xcoll geometry: Compiler macro MIN redefined")
#endif
#define MIN(x, y) ({const __typeof__ (x) _x = (x); \
                    const __typeof__ (y) _y = (y); \
                    _x < _y ? _x : _y; })
#ifdef SWAP
#error "Xcoll geometry: Compiler macro SWAP already defined!"
#endif
#define SWAP(d,x,y) ({const __typeof__(*d) _x = MIN(d[x], d[y]); \
                      const __typeof__(*d) _y = MAX(d[x], d[y]); \
                      d[x] = _x; d[y] = _y; })


// Fast methods
// ------------

static inline void sort_array_of_2_double(double* d){
    SWAP(d, 0, 1);
}

static inline void sort_array_of_3_double(double* d){
    SWAP(d, 0, 1); SWAP(d, 1, 2); SWAP(d, 0, 1);
}

static inline void sort_array_of_4_double(double* d){
    SWAP(d, 0, 1); SWAP(d, 2, 3); SWAP(d, 0, 2); SWAP(d, 1, 3); SWAP(d, 1, 2);
}

static inline void sort_array_of_5_double(double* d){
    SWAP(d, 0, 1); SWAP(d, 3, 4); SWAP(d, 2, 4); SWAP(d, 2, 3); SWAP(d, 1, 4);
    SWAP(d, 0, 3); SWAP(d, 0, 2); SWAP(d, 1, 3); SWAP(d, 1, 2);
}

static inline void sort_array_of_6_double(double* d){
    SWAP(d, 1, 2); SWAP(d, 4, 5); SWAP(d, 0, 2); SWAP(d, 3, 5); SWAP(d, 0, 1);
    SWAP(d, 3, 4); SWAP(d, 1, 4); SWAP(d, 0, 3); SWAP(d, 2, 5); SWAP(d, 1, 3);
    SWAP(d, 2, 4); SWAP(d, 2, 3);
}

static inline void sort_array_of_7_double(double* d){
    SWAP(d, 1, 2); SWAP(d, 3, 4); SWAP(d, 5, 6); SWAP(d, 0, 2); SWAP(d, 3, 5);
    SWAP(d, 4, 6); SWAP(d, 0, 1); SWAP(d, 4, 5); SWAP(d, 2, 6); SWAP(d, 0, 4);
    SWAP(d, 1, 5); SWAP(d, 0, 3); SWAP(d, 2, 5); SWAP(d, 1, 3); SWAP(d, 2, 4);
    SWAP(d, 2, 3);
}

static inline void sort_array_of_8_double(double* d){
    SWAP(d, 0, 1); SWAP(d, 2, 3); SWAP(d, 4, 5); SWAP(d, 6, 7); SWAP(d, 0, 2);
    SWAP(d, 1, 3); SWAP(d, 4, 6); SWAP(d, 5, 7); SWAP(d, 1, 2); SWAP(d, 5, 6);
    SWAP(d, 0, 4); SWAP(d, 3, 7); SWAP(d, 1, 5); SWAP(d, 2, 6); SWAP(d, 1, 4);
    SWAP(d, 3, 6); SWAP(d, 2, 4); SWAP(d, 3, 5); SWAP(d, 3, 4);
}

static inline void sort_array_of_2_int64(int64_t* d){
    SWAP(d, 0, 1);
}

static inline void sort_array_of_3_int64(int64_t* d){
    SWAP(d, 0, 1); SWAP(d, 1, 2); SWAP(d, 0, 1);
}

static inline void sort_array_of_4_int64(int64_t* d){
    SWAP(d, 0, 1); SWAP(d, 2, 3); SWAP(d, 0, 2); SWAP(d, 1, 3); SWAP(d, 1, 2);
}

static inline void sort_array_of_5_int64(int64_t* d){
    SWAP(d, 0, 1); SWAP(d, 3, 4); SWAP(d, 2, 4); SWAP(d, 2, 3); SWAP(d, 1, 4);
    SWAP(d, 0, 3); SWAP(d, 0, 2); SWAP(d, 1, 3); SWAP(d, 1, 2);
}

static inline void sort_array_of_6_int64(int64_t* d){
    SWAP(d, 1, 2); SWAP(d, 4, 5); SWAP(d, 0, 2); SWAP(d, 3, 5); SWAP(d, 0, 1);
    SWAP(d, 3, 4); SWAP(d, 1, 4); SWAP(d, 0, 3); SWAP(d, 2, 5); SWAP(d, 1, 3);
    SWAP(d, 2, 4); SWAP(d, 2, 3);
}

static inline void sort_array_of_7_int64(int64_t* d){
    SWAP(d, 1, 2); SWAP(d, 3, 4); SWAP(d, 5, 6); SWAP(d, 0, 2); SWAP(d, 3, 5);
    SWAP(d, 4, 6); SWAP(d, 0, 1); SWAP(d, 4, 5); SWAP(d, 2, 6); SWAP(d, 0, 4);
    SWAP(d, 1, 5); SWAP(d, 0, 3); SWAP(d, 2, 5); SWAP(d, 1, 3); SWAP(d, 2, 4);
    SWAP(d, 2, 3);
}

static inline void sort_array_of_8_int64(int64_t* d){
    SWAP(d, 0, 1); SWAP(d, 2, 3); SWAP(d, 4, 5); SWAP(d, 6, 7); SWAP(d, 0, 2);
    SWAP(d, 1, 3); SWAP(d, 4, 6); SWAP(d, 5, 7); SWAP(d, 1, 2); SWAP(d, 5, 6);
    SWAP(d, 0, 4); SWAP(d, 3, 7); SWAP(d, 1, 5); SWAP(d, 2, 6); SWAP(d, 1, 4);
    SWAP(d, 3, 6); SWAP(d, 2, 4); SWAP(d, 3, 5); SWAP(d, 3, 4);
}


// Generic methods
// ---------------

int cmpfunc_double(const void * a, const void * b) {
   return ( *(double*)a - *(double*)b );
}

static inline void sort_array_of_double(double* arr, int64_t length){
    switch(length){
        case 2:
            sort_array_of_2_double(arr);
            break;
        case 3:
            sort_array_of_3_double(arr);
            break;
        case 4:
            sort_array_of_4_double(arr);
            break;
        case 5:
            sort_array_of_5_double(arr);
            break;
        case 6:
            sort_array_of_6_double(arr);
            break;
        case 7:
            sort_array_of_7_double(arr);
            break;
        case 8:
            sort_array_of_8_double(arr);
            break;
        default:
            qsort(arr, length, sizeof(double), cmpfunc_double);
    }
}

int cmpfunc_int64(const void * a, const void * b) {
   return ( *(int64_t*)a - *(int64_t*)b );
}

static inline void sort_array_of_int64(int64_t* arr, int64_t length){
    switch(length){
        case 2:
            sort_array_of_2_int64(arr);
            break;
        case 3:
            sort_array_of_3_int64(arr);
            break;
        case 4:
            sort_array_of_4_int64(arr);
            break;
        case 5:
            sort_array_of_5_int64(arr);
            break;
        case 6:
            sort_array_of_6_int64(arr);
            break;
        case 7:
            sort_array_of_7_int64(arr);
            break;
        case 8:
            sort_array_of_8_int64(arr);
            break;
        default:
            qsort(arr, length, sizeof(int64_t), cmpfunc_int64);
    }
}

#pragma GCC diagnostic pop
#endif /* XCOLL_GEOM_SORT_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_GEOM_SEGMENTS_H
#define XCOLL_GEOM_SEGMENTS_H
#include <math.h>
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>


// These functions compare a particle trajectory (straight line with slope part_tan going
// through the point [0, part_x]) with a given segment of specific type.
// The results are always stored in an array s, and n_hit keeps track of the number of hits.


#define XC_MAX_CROSS_PER_SEGMENT 2  // Update if new segment type allows more crossings


// Function that calculates the crossing with a given segment
typedef void (*CrossingFunc)(int8_t*, double*, double, double, void*);


// Parent type for all segments
// ----------------------------
typedef struct Segment_{
    CrossingFunc crossing;
} Segment_;
typedef Segment_* Segment;


// Line segment
// ------------

// Line segment defined by two points (s1, x1), (s2, x2). The function will fill in the segment
// points in the trajectory equation; if the results have opposite sign, the two points lie on
// different sides of the trajectory and hence the segment is crossed.

typedef struct LineSegment_ {
    CrossingFunc crossing;
    double point1_s;
    double point1_x;
    double point2_s;
    double point2_x;
} LineSegment_;
typedef LineSegment_* LineSegment;

 static inline
void get_s_of_crossing_with_line_segment(int8_t* n_hit, double* s, double part_x, double part_tan, void* self){
    // Get segment data
    LineSegment seg = (LineSegment) self;
    double s_p1 = seg->point1_s;
    double s_p2 = seg->point2_s;
    double x_p1 = seg->point1_x;
    double x_p2 = seg->point2_x;
    // Calculate crossings
    double trajectory_p1 = x_p1 - part_x - s_p1*part_tan;
    double trajectory_p2 = x_p2 - part_x - s_p2*part_tan;
    if (trajectory_p1*trajectory_p2 <= 0){
        // It's a crossing
        if (fabs(s_p2 - s_p1) < 1.e-12){
            s[*n_hit] = s_p1;
            (*n_hit)++;
        } else {
            double poly_tan = (x_p2 - x_p1)/(s_p2 - s_p1);
            if (fabs(poly_tan - part_tan) < 1.e-12){
                s[*n_hit] = s_p1;
                (*n_hit)++;
            } else {
                s[*n_hit] = (part_x - x_p1 + s_p1*poly_tan)/(poly_tan - part_tan);
                (*n_hit)++;
            }
        }
    }
}

 static inline
LineSegment create_line_segment(double point1_s, double point1_x, double point2_s, double point2_x){
    LineSegment seg = (LineSegment) malloc(sizeof(LineSegment_));
    seg->crossing = &get_s_of_crossing_with_line_segment;
    seg->point1_s = point1_s;
    seg->point2_s = point2_s;
    seg->point1_x = point1_x;
    seg->point2_x = point2_x;
    return seg;
}


// Half-open line segment
// ----------------------

// This function works as above, but considers a half-open segment. For this reason,
// the function needs to know whether this is a positive or negative jaw (representing
// to which infinite it points), and the overall tilt of the jaw.
typedef struct HalfOpenLineSegment_ {
    CrossingFunc crossing;
    double point_s;
    double point_x;
    int8_t side;
    // Important: this is the perpendicular angle (hence we will use -1/point_tan)
    // This is done because the case "point_tan == 0" cannot take place in our setup,
    // but "point_tan == inf" can (when the jaws have no tilt).
    double point_tan;
} HalfOpenLineSegment_;
typedef HalfOpenLineSegment_* HalfOpenLineSegment;

// A half-open segment implies one of its points lies at +-inf.
// In practice we just add a polygon point at the wall overflow (at 1km for the x-coordinate).
 static inline
void get_s_of_crossing_with_halfopen_line_segment(int8_t* n_hit, double* s, double part_x, double part_tan, void* self){
    // Get segment data
    HalfOpenLineSegment seg = (HalfOpenLineSegment) self;
    double s_p1 = seg->point_s;
    double x_p1 = seg->point_x;
    double x_p2 = 1.e3*seg->side;
    double s_p2;
    if (fabs(seg->point_tan) < 1.e-12){
        s_p2 = s_p1;
    } else {
        s_p2 = -(x_p2 - x_p1 - s_p1/seg->point_tan)*seg->point_tan;
    }
    // Calculate crossings
    double trajectory_p1 = x_p1 - part_x - s_p1*part_tan;
    double trajectory_p2 = x_p2 - part_x - s_p2*part_tan;
    if (trajectory_p1*trajectory_p2 <= 0){
        // It's a crossing
        if (fabs(s_p2 - s_p1) < 1.e-12){
            s[*n_hit] = s_p1;
            (*n_hit)++;
        } else {
            double poly_tan = (x_p2 - x_p1)/(s_p2 - s_p1);
            if (fabs(poly_tan - part_tan) < 1.e-12){
                s[*n_hit] = s_p1;
                (*n_hit)++;
            } else {
                s[*n_hit] = (part_x - x_p1 + s_p1*poly_tan)/(poly_tan - part_tan);
                (*n_hit)++;
            }
        }
    }
}

 static inline
HalfOpenLineSegment create_halfopen_line_segment(double point_s, double point_x, double point_tan, int8_t side){
    HalfOpenLineSegment seg = (HalfOpenLineSegment) malloc(sizeof(HalfOpenLineSegment_));
    seg->crossing = &get_s_of_crossing_with_halfopen_line_segment;
    seg->point_s = point_s;
    seg->point_x = point_x;
    seg->side = side;
    seg->point_tan = point_tan;
    return seg;
}


// Circular arc segment
// --------------------

// This function finds the crossing points between a line defined by a point (s=0, x) and a tangent,
// and a circular arc segment defined by a radius R, a centre (Rs, Rx), and angles t1 and t2.
// The results are stored in an array s, and n_hit keeps track of the number of hits.
typedef struct CircularSegment_ {
    CrossingFunc crossing;
    double R;
    double centre_s;
    double centre_x;
    double point1_angle;
    double point2_angle;
} CircularSegment_;
typedef CircularSegment_* CircularSegment;

 static inline
void get_s_of_crossing_with_circular_segment(int8_t* n_hit, double* s, double part_x, double part_tan, void* self){
    // Get segment data
    CircularSegment seg = (CircularSegment) self;
    double R   = seg->R;
    double R_s = seg->centre_s;
    double R_x = seg->centre_x;
    double t1  = seg->point1_angle;
    double t2  = seg->point2_angle;
    // Calculate crossings
    int8_t reversed = 0;
    if (t2 < t1){
        reversed = 1;
    }
    double a = 1 + part_tan*part_tan;
    double bb = R_s - part_tan*(part_x - R_x);
    double c = R_s*R_s + (part_x - R_x)*(part_x - R_x) - R*R;
    double disc = bb*bb - a*c;
    if (disc >= 0){
        for (int8_t i = 0; i < 2; i++) {
            double sgnD = i*2-1; // negative and positive solutions
            double new_s = 1/a*(bb + sgnD*sqrt(bb*bb - a*c));
            double x = part_x + new_s*part_tan;
            double t = atan2(x - R_x, new_s - R_s);
            if (reversed){
                // t2 < t1, so we are looking at the inverted region of angles
                if (t1 >= t || t >= t2){
                    s[*n_hit] = new_s;
                    (*n_hit)++;
                }
            } else {
                if (t1 <= t && t <= t2){
                    s[*n_hit] = new_s;
                    (*n_hit)++;
                }
            }
        }
    }
}

 static inline
CircularSegment create_circular_segment(double R, double centre_s, double centre_x, double point1_angle, double point2_angle){
    CircularSegment seg = (CircularSegment) malloc(sizeof(CircularSegment_));
    seg->crossing = &get_s_of_crossing_with_circular_segment;
    seg->R = R;
    seg->centre_s = centre_s;
    seg->centre_x = centre_x;
    seg->point1_angle = point1_angle;
    seg->point2_angle = point2_angle;
    return seg;
}


#endif /* XCOLL_GEOM_SEGMENTS_H */
// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_GEOM_OBJECTS_H
#define XCOLL_GEOM_OBJECTS_H
#include <math.h>
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>


// Assumption for all objects: the particle at -inf is outside the object (otherwise some comparisons might give wrong results)


// Collimator jaw
// --------------

 static inline
Segment* create_jaw(double s_U, double x_U, double s_D, double x_D, double tilt_tan, int8_t side){
    Segment* segments= (Segment*) malloc(3*sizeof(Segment));
    segments[0] = (Segment) create_halfopen_line_segment(s_U, x_U, tilt_tan, side);
    segments[1] = (Segment) create_line_segment(s_U, x_U, s_D, x_D);
    segments[2] = (Segment) create_halfopen_line_segment(s_D, x_D, tilt_tan, side);
    return segments;
}

 static inline
void destroy_jaw(Segment* segments){
    free((HalfOpenLineSegment) segments[0]);
    free((LineSegment)         segments[1]);
    free((HalfOpenLineSegment) segments[2]);
    free(segments);
}


// Polygon
// -------

 static inline
Segment* create_polygon(double* s_poly, double* x_poly, int8_t num_polys){
    Segment* segments= (Segment*) malloc((unsigned int) num_polys*sizeof(Segment));
    for (int8_t i=0; i<num_polys-1; i++){
        segments[i] = (Segment) create_line_segment(s_poly[i], x_poly[i], s_poly[i+1], x_poly[i+1]);
    }
    segments[num_polys-1] = (Segment) create_line_segment(s_poly[num_polys-1], x_poly[num_polys-1], \
                                                          s_poly[0], x_poly[0]);
    return segments;
}

 static inline
void destroy_polygon(Segment* segments, int8_t num_polys){
    for (int8_t i=0; i<num_polys; i++) {
        free((LineSegment) segments[i]);
    }
    free(segments);
}


// Open polygon
// ------------

 static inline
Segment* create_open_polygon(double* s_poly, double* x_poly, int8_t num_polys, double tilt_tan, int8_t side){
    Segment* segments= (Segment*) malloc((num_polys+1)*sizeof(Segment));
    segments[0] = (Segment) create_halfopen_line_segment(s_poly[0], x_poly[0], tilt_tan, side);
    for (int8_t i=1; i<num_polys; i++){
        segments[i] = (Segment) create_line_segment(s_poly[i-1], x_poly[i-1], s_poly[i], x_poly[i]);
    }
    segments[num_polys] = (Segment) create_halfopen_line_segment(s_poly[num_polys-1], x_poly[num_polys-1], \
                                                                 tilt_tan, side);
    return segments;
}

 static inline
void destroy_open_polygon(Segment* segments, int8_t num_polys){
    free((HalfOpenLineSegment) segments[0]);
    for (int8_t i=1; i<num_polys; i++) {
        free((LineSegment)     segments[i]);
    }
    free((HalfOpenLineSegment) segments[num_polys]);
    free(segments);
}


// Crystal
// -------

// The four corners A, B, C, D are such that AB is the front face, BC the curve furthest from the beam,
// CD the back face, and DA the curve closest to the beam.
 static inline
Segment* create_crystal(double R, double width, double length, double jaw_U, double tilt_sin, double tilt_cos){
    Segment* segments= (Segment*) malloc(4*sizeof(Segment));

    // First corner is what defines the crystal position
    double A_s = 0;
    double A_x = jaw_U;

    // Manipulate R in function of sign
    double sgnR = (R > 0) - (R < 0);
    double R_short  = sgnR*(fabs(R) - width);
    double sin_a = length/fabs(R);
    double cos_a = sqrt(1 - length*length/R/R);
    if (fabs(R) < 1.e-12){
        // straight crystal - not yet implemented 
        printf("Straight crystal not yet implemented!"); //only_for_context cpu_serial
        fflush(stdout);                 //only_for_context cpu_serial
        return NULL;

    } else if (R < 0){
        // This distinction is needed to keep the crystal at the same location when changing the bend direction
        double R_temp = R_short;
        R_short = R;
        R = R_temp;
    }

    // Bending centre is defined w.r.t. A
    double R_s = A_s - R*tilt_sin;
    double R_x = A_x + R*tilt_cos;

    // Three remaining corner points of crystal
    double B_s = R_s + R_short*tilt_sin;
    double C_s = R_s + fabs(R_short)*sin_a*tilt_cos + R_short*cos_a*tilt_sin;
    double D_s = R_s + fabs(R)*sin_a*tilt_cos + R*cos_a*tilt_sin;
    double B_x = R_x - R_short*tilt_cos;
    double C_x = R_x - cos_a*tilt_cos*R_short + sin_a*tilt_sin*fabs(R_short);
    double D_x = R_x - cos_a*tilt_cos*R + sin_a*tilt_sin*fabs(R);
    double A_t = atan2(A_x - R_x, A_s - R_s);
    double D_t = atan2(D_x - R_x, D_s - R_s);
    double t1 = MIN(A_t, D_t);
    double t2 = MAX(A_t, D_t);

    // Fill segments
    segments[0] = (Segment) create_line_segment(A_s, A_x, B_s, B_x);
    segments[1] = (Segment) create_circular_segment(R, R_s, R_x, t1, t2);
    segments[2] = (Segment) create_line_segment(C_s, C_x, D_s, D_x);
    segments[3] = (Segment) create_circular_segment(R_short, R_s, R_x, t1, t2);

    // printf("R: (%f, %f)   A: (%f, %f)   B: (%f, %f)   C: (%f, %f)   D: (%f, %f)   t1: %f   t2: %f\n", R_s,R_x,A_s,A_x,B_s,B_x,C_s,C_x,D_s,D_x,t1*180/3.141592653589793,t2*180/3.141592653589793); fflush(stdout);
    return segments;
}

 static inline
void destroy_crystal(Segment* segments){
    free((LineSegment)     segments[0]);
    free((CircularSegment) segments[1]);
    free((LineSegment)     segments[2]);
    free((CircularSegment) segments[3]);
    free(segments);
}


#endif /* XCOLL_GEOM_OBJECTS_H */
// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_GEOM_METHODS_H
#define XCOLL_GEOM_METHODS_H
#include <math.h>
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>

#define S_MAX 1.e21


 static inline
void find_crossing(int8_t* n_hit, double* s, double part_x, double part_tan, \
                       Segment* segments, int8_t n_segments){
    for (int8_t i=0; i<n_segments;i++) {
        segments[i]->crossing(n_hit, s, part_x, part_tan, segments[i]);
    }
    sort_array_of_double(s, (int64_t) *n_hit);
}


// IMPORTANT:
// The array and interval are assumed to be sorted!
// Furthermore, the array should have one extra slot allocated at the end, in case it needs to be expanded..
// This is always true for the arrays created by get_s, as we create them with 2*n_segments slots.
 static inline
void calculate_overlap_array_interval(double* arr, int8_t* length, double* interval){
    if (arr[0] > interval[1]){
        // No overlap
        *length = 0;
    }
    if ((*length)%2 == 1){
        // Special case: last interval of array is open until infinity,
        // so we add an extra point at the end to represent infinity.
        arr[*length] = S_MAX*0.1;
        (*length)++;
    } else if (arr[*length-1] < interval[0]){
        // No overlap
        *length = 0;
    }
    int8_t i_start = 0;
    // Find the start of overlap
    for (int8_t i=0; i<*length; i++){
        if (arr[i] >= interval[0]){
            if (i%2 == 0){
                // This is the first point of overlap
                i_start = i;
            } else {
                // The vertical restriction is the first point of overlap
                i_start = i-1;
                arr[i_start] = interval[0];
            }
            break;
        }
    }
    // Find the end of overlap
    int8_t i_stop = *length - 1;
    for (int8_t i=0; i<*length; i++){
        if (arr[i] >= interval[1]){
            if (i%2 == 0){
                // The previous point is the last point of overlap
                i_stop = i-1;
            } else {
                // The vertical restriction is the first point of overlap
                i_stop = i;
                arr[i_stop] = interval[1];
            }
            break;
        }
    }
    *length = i_stop - i_start + 1;
    if (i_start > 0){
        for (int8_t i=0; i<*length; i++){
            arr[i] = arr[i+i_start];
        }
    }
}


 static inline
void find_crossing_with_vlimit(int8_t* n_hit, double* s, double part_x, double part_tan_x, \
                               double part_y, double part_tan_y, Segment* segments, \
                               int8_t n_segments, double y_min, double y_max){
    if (fabs(part_tan_y) < 1.e-12){
        // Trajectory parallel to s axis
        if (part_y < y_min || part_y > y_max){
            // No crossing
            return;
        } else {
            // The particle is completely inside the vertical limits, so only check horizontal
            find_crossing(n_hit, s, part_x, part_tan_x, segments, n_segments);
            return;
        }
    } else {
        find_crossing(n_hit, s, part_x, part_tan_x, segments, n_segments);
        // restrict_s is the region [s0, s1] where the particle is inside the vertical limits
        double* restrict_s = (double*) malloc(2*sizeof(double));
        restrict_s[0] = (y_min - part_y)/part_tan_y;
        restrict_s[1] = (y_max - part_y)/part_tan_y;
        SWAP(restrict_s, 0, 1);   // To make sure these are sorted
        calculate_overlap_array_interval(s, n_hit, restrict_s);
        free(restrict_s);
    }
}


#endif /* XCOLL_GEOM_METHODS_H */
// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_GEOM_GET_S_H
#define XCOLL_GEOM_GET_S_H
#include <math.h>
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>


// IMPORTANT:
// These functions assume that the particle moves towards positive s!
// (hence no backscattering/backtracking is allowed)


 static inline
double get_s_of_first_crossing(double part_x, double part_tan, Segment* segments, \
                               int8_t n_segments){
    int8_t n_hit = 0;
    double* s = (double*) malloc(XC_MAX_CROSS_PER_SEGMENT*n_segments*sizeof(double));
    find_crossing(&n_hit, s, part_x, part_tan, segments, n_segments);
    if (n_hit==0){
        // No crossing
        free(s);
        return S_MAX;
    }
    double result = s[0];
    free(s);
    return result;
}

 static inline
double get_s_of_crossing_after_s(double part_x, double part_tan, Segment* segments, \
                                 int8_t n_segments, double current_s){
    int8_t n_hit = 0;
    double* s = (double*) malloc(XC_MAX_CROSS_PER_SEGMENT*n_segments*sizeof(double));
    find_crossing(&n_hit, s, part_x, part_tan, segments, n_segments);
    for (int8_t i=0; i<n_hit; i++){
        if (s[i] >= current_s){
            double result = s[i];
            free(s);
            return result;
        }
    }
    // No crossing
    free(s);
    return S_MAX;
}

 static inline
double get_s_of_first_crossing_with_vlimit(double part_x, double part_tan_x, \
                                double part_y, double part_tan_y, Segment* segments, \
                                int8_t n_segments, double y_min, double y_max){
    int8_t n_hit = 0;
    double* s = (double*) malloc(XC_MAX_CROSS_PER_SEGMENT*n_segments*sizeof(double));
    find_crossing_with_vlimit(&n_hit, s, part_x, part_tan_x, part_y, part_tan_y, \
                              segments, n_segments, y_min, y_max);
    if (n_hit==0){
        // No crossing
        free(s);
        return S_MAX;
    }
    double result = s[0];
    free(s);
    return result;
}

 static inline
double get_s_of_crossing_after_s_with_vlimit(double part_x, double part_tan_x, \
                                double part_y, double part_tan_y, Segment* segments, \
                                int8_t n_segments, double y_min, double y_max, double current_s){
    int8_t n_hit = 0;
    double* s = (double*) malloc(XC_MAX_CROSS_PER_SEGMENT*n_segments*sizeof(double));
    find_crossing_with_vlimit(&n_hit, s, part_x, part_tan_x, part_y, part_tan_y, \
                              segments, n_segments, y_min, y_max);
    for (int8_t i=0; i<n_hit; i++){
        if (s[i] >= current_s){
            double result = s[i];
            free(s);
            return result;
        }
    }
    // No crossing
    free(s);
    return S_MAX;
}


#endif /* XCOLL_GEOM_GET_S_H */
// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_GEOM_ROT_H
#define XCOLL_GEOM_ROT_H
#include <math.h>
#include <stdio.h>


 static inline
double YRotation_single_particle_rotate_only(LocalParticle* part, double s, double angle){
    double x   = LocalParticle_get_x(part);
    double rpp = LocalParticle_get_rpp(part);
    double sin_y = sin(angle);
    double cos_y = cos(angle);
    LocalParticle_set_x(part, x*cos_y - s*sin_y);
    LocalParticle_add_to_px(part,-angle/rpp);
    return x*sin_y + s*cos_y;  // new s
}

#endif /* XCOLL_GEOM_ROT_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_COLL_GEOM_H
#define XCOLL_COLL_GEOM_H
#include <math.h>
#include <stdio.h>

typedef struct CollimatorGeometry_ {
    // Collimator jaws (with tilts)
    double jaw_LU;
    double jaw_RU;
    double length;
    int8_t side;
    // Jaw angles
    double sin_zL;
    double cos_zL;
    double sin_zR;
    double cos_zR;
    double sin_zDiff;
    double cos_zDiff;
    int8_t jaws_parallel;
    // Tilts
    double sin_yL;
    double cos_yL;
    double sin_yR;
    double cos_yR;
    // Segments
    Segment* segments_L;
    Segment* segments_R;
    // Impact table
    InteractionRecordData record;
    RecordIndex record_index;
    int8_t record_impacts;
    int8_t record_exits;
} CollimatorGeometry_;
typedef CollimatorGeometry_* CollimatorGeometry;


// This function checks if a particle hits a jaw (and which).
// Return value: 0 (no hit), 1 (hit on left jaw), -1 (hit on right jaw).
// Furthermore, the particle is moved to the location where it hits the jaw (drifted to the end if no hit),
//              and transformed to the reference frame of that jaw.
 static inline
int8_t hit_jaws_check_and_transform(LocalParticle* part, CollimatorGeometry restrict cg){
    double part_x, part_tan;
    int8_t is_hit = 0;
    double s_L = 1.e21;
    double s_R = 1.e21;

    // Find the first hit on the left jaw (if not a right-sided collimator)
    if (cg->side != -1){
        SRotation_single_particle(part, cg->sin_zL, cg->cos_zL);
        part_x = LocalParticle_get_x(part);
#ifdef XCOLL_USE_EXACT
        part_tan = LocalParticle_get_exact_xp(part);
#else
        part_tan = LocalParticle_get_xp(part);
#endif
        s_L = get_s_of_first_crossing(part_x, part_tan, cg->segments_L, 3);
        if (s_L < S_MAX){
            is_hit = 1;
        } else if (cg->side == 1){
            // If left-sided and no hit, rotate back to lab frame
            SRotation_single_particle(part, -cg->sin_zL, cg->cos_zL);
        }
    }

    // if rightsided:            lab  frame
    // if leftsided  and no hit: lab  frame
    // if leftsided  and hit:    left frame
    // if bothsided  and no hit: left frame
    // if bothsided  and hit:    left frame

    // Find the first hit on the right jaw (if not a left-sided collimator)
    if (cg->side != 1){
        if (cg->side == -1){
            // We didn't rotate to the left frame earlier, so full rotation to the right frame now
            SRotation_single_particle(part, cg->sin_zR, cg->cos_zR);
        } else if (!cg->jaws_parallel){
            // We rotated to the left frame before, so now rotate the difference
            SRotation_single_particle(part, cg->sin_zDiff, cg->cos_zDiff);
        }
        part_x = LocalParticle_get_x(part);
#ifdef XCOLL_USE_EXACT
        part_tan = LocalParticle_get_exact_xp(part);
#else
        part_tan = LocalParticle_get_xp(part);
#endif
        s_R = get_s_of_first_crossing(part_x, part_tan, cg->segments_R, 3);
        if (s_R < S_MAX && s_R < s_L){
            is_hit = -1;
        } else if (is_hit == 1){
            if (!cg->jaws_parallel){
                // Rotate back to left frame
                SRotation_single_particle(part, -cg->sin_zDiff, cg->cos_zDiff);
            }
        } else {
            // No hit, rotate back to lab frame
            SRotation_single_particle(part, -cg->sin_zR, cg->cos_zR);
        }
    }

    // if rightsided and no hit: lab   frame
    // if rightsided and hit:    right frame
    // if leftsided  and no hit: lab   frame
    // if leftsided  and hit:    left  frame
    // if bothsided  and no hit: lab  frame
    // if bothsided  and hit:    hit   frame

    // Drift to the impact position or end, and move to jaw frame if relevant
    if (is_hit == 1){
        // Move to the impact position
#ifdef XCOLL_USE_EXACT
        Drift_single_particle_exact(part, s_L);
#else
        Drift_single_particle_expanded(part, s_L);
#endif
        // Shift the reference frame to the jaw corner LU
        XYShift_single_particle(part, cg->jaw_LU, 0);
        LocalParticle_add_to_s(part, -cg->length/2*(1 - cg->cos_yL));
        // Rotate the reference frame to tilt
        double new_s = YRotation_single_particle_rotate_only(part, LocalParticle_get_s(part), asin(cg->sin_yL));
        LocalParticle_set_s(part, new_s);
        if (cg->record_impacts){
            InteractionRecordData_log(cg->record, cg->record_index, part, XC_ENTER_JAW_L);
        }

    } else if (is_hit == -1){
        // Move to the impact position
#ifdef XCOLL_USE_EXACT
        Drift_single_particle_exact(part, s_R);
#else
        Drift_single_particle_expanded(part, s_R);
#endif
        // Shift the reference frame to the jaw corner RU
        XYShift_single_particle(part, cg->jaw_RU, 0);
        LocalParticle_add_to_s(part, -cg->length/2*(1 - cg->cos_yR));
        // Rotate the reference frame to tilt
        double new_s = YRotation_single_particle_rotate_only(part, LocalParticle_get_s(part), asin(cg->sin_yR));
        LocalParticle_set_s(part, new_s);
        // Mirror x
        LocalParticle_scale_x(part, -1);
#ifdef XCOLL_USE_EXACT
        LocalParticle_scale_exact_xp(part, -1);
#else
        LocalParticle_scale_xp(part, -1);
#endif
        if (cg->record_impacts){
            InteractionRecordData_log(cg->record, cg->record_index, part, XC_ENTER_JAW_R);
        }

    } else {
#ifdef XCOLL_USE_EXACT
        Drift_single_particle_exact(part, cg->length);
#else
        Drift_single_particle_expanded(part, cg->length);
#endif
    }

    return is_hit;
}


 static inline
void hit_jaws_transform_back(int8_t is_hit, LocalParticle* part, CollimatorGeometry restrict cg){
    if (is_hit != 0 && LocalParticle_get_state(part) > 0){
        if (cg->record_exits){
            InteractionRecordData_log(cg->record, cg->record_index, part, XC_EXIT_JAW);
        }
    }
    if (is_hit == 1){
        // Rotate back from tilt
        double new_s = YRotation_single_particle_rotate_only(part, LocalParticle_get_s(part), -asin(cg->sin_yL));
        LocalParticle_set_s(part, new_s);
        // Shift the reference frame back from jaw corner LU
        XYShift_single_particle(part, -cg->jaw_LU, 0);
        LocalParticle_add_to_s(part, cg->length/2*(1 - cg->cos_yL));
        // If particle survived, drift to end of element
        if (LocalParticle_get_state(part) > 0){
#ifdef XCOLL_USE_EXACT
            Drift_single_particle_exact(part, cg->length - LocalParticle_get_s(part));
#else
            Drift_single_particle_expanded(part, cg->length - LocalParticle_get_s(part));
#endif
        }
        SRotation_single_particle(part, -cg->sin_zL, cg->cos_zL);

    } else if (is_hit == -1){
        // Mirror back
        LocalParticle_scale_x(part, -1);
#ifdef XCOLL_USE_EXACT
        LocalParticle_scale_exact_xp(part, -1);
#else
        LocalParticle_scale_xp(part, -1);
#endif
        // Rotate back from tilt
        double new_s = YRotation_single_particle_rotate_only(part, LocalParticle_get_s(part), -asin(cg->sin_yR));
        LocalParticle_set_s(part, new_s);
        // Shift the reference frame back from jaw corner RU
        XYShift_single_particle(part, -cg->jaw_RU, 0);
        LocalParticle_add_to_s(part, cg->length/2*(1 - cg->cos_yR));
        // If particle survived, drift to end of element
        if (LocalParticle_get_state(part) > 0){
#ifdef XCOLL_USE_EXACT
            Drift_single_particle_exact(part, cg->length - LocalParticle_get_s(part));
#else
            Drift_single_particle_expanded(part, cg->length - LocalParticle_get_s(part));
#endif
        }
        SRotation_single_particle(part, -cg->sin_zR, cg->cos_zR);
    }
}


#endif /* XCOLL_COLL_GEOM_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_CRY_GEOM_H
#define XCOLL_CRY_GEOM_H
#include <math.h>
#include <stdio.h>

typedef struct CrystalGeometry_ {
    // Crystal inner upstream corner (with tilt)
    double jaw_U;
    double length;
    int8_t side;
    // Jaw angle
    double sin_z;
    double cos_z;
    // Tilt
    double sin_y;
    double cos_y;
    // Crystal geometry
    double bending_radius;
    double bending_angle;
    double width;
    double height;
    double miscut_angle;
    double s_B;    // Bend centre
    double x_B;
    double s_P;    // Miscut centre
    double x_P;
    double t_VImax;
    // Segments
    Segment* segments;
    // Impact table
    InteractionRecordData record;
    RecordIndex record_index;
    int8_t record_impacts;
    int8_t record_exits;
} CrystalGeometry_;
typedef CrystalGeometry_* CrystalGeometry;


// This function checks if a particle hits a jaw (and which).
// Return value: 0 (no hit), 1 (hit on left jaw), -1 (hit on right jaw).
// Furthermore, the particle is moved to the location where it hits the jaw (drifted to the end if no hit),
//              and transformed to the reference frame of that jaw.
 static inline
int8_t hit_crystal_check_and_transform(LocalParticle* part, CrystalGeometry restrict cg){
    double part_x, part_tan_x, part_y, part_tan_y;
    double s = 1.e21;

    // Crystal should be single-sided
    if (cg->side == 0){
        LocalParticle_kill_particle(part, XC_ERR_NOT_IMPLEMENTED);
    }

    SRotation_single_particle(part, cg->sin_z, cg->cos_z);
    part_x = LocalParticle_get_x(part);
#ifdef XCOLL_USE_EXACT
    part_tan_x = LocalParticle_get_exact_xp(part);
#else
    part_tan_x = LocalParticle_get_xp(part);
#endif
    part_y = LocalParticle_get_y(part);
#ifdef XCOLL_USE_EXACT
    part_tan_y = LocalParticle_get_exact_yp(part);
#else
    part_tan_y = LocalParticle_get_yp(part);
#endif
    s = get_s_of_first_crossing_with_vlimit(part_x, part_tan_x, part_y, part_tan_y, cg->segments, 4, -cg->height/2, cg->height/2);

    if (s < S_MAX){
        // Hit: Drift to the impact position, and move to jaw frame if relevant
#ifdef XCOLL_USE_EXACT
        Drift_single_particle_exact(part, s);
#else
        Drift_single_particle_expanded(part, s);
#endif
        // Shift the reference frame to the upstream jaw corner (for a crystal, this is always at s=0)
        XYShift_single_particle(part, cg->jaw_U, 0);
        // Rotate the reference frame to tilt
        double new_s = YRotation_single_particle_rotate_only(part, LocalParticle_get_s(part), asin(cg->sin_y));
        LocalParticle_set_s(part, new_s);
        if (cg->side == 1){
            if (cg->record_impacts){
                InteractionRecordData_log(cg->record, cg->record_index, part, XC_ENTER_JAW_L);
            }

        } else {
            // Mirror x
            LocalParticle_scale_x(part, -1);
#ifdef XCOLL_USE_EXACT
            LocalParticle_scale_exact_xp(part, -1);
#else
            LocalParticle_scale_xp(part, -1);
#endif
            if (cg->record_impacts){
                InteractionRecordData_log(cg->record, cg->record_index, part, XC_ENTER_JAW_R);
            }
        }
        return cg->side;

    } else {
        // No hit, rotate back to lab frame
        SRotation_single_particle(part, -cg->sin_z, cg->cos_z);
        // Drift to end
#ifdef XCOLL_USE_EXACT
        Drift_single_particle_exact(part, cg->length);
#else
        Drift_single_particle_expanded(part, cg->length);
#endif
        return 0;
    }
}


 static inline
void hit_crystal_transform_back(int8_t is_hit, LocalParticle* part, CrystalGeometry restrict cg){
    if (is_hit != 0){
        if (LocalParticle_get_state(part) > 0){
            if (cg->record_exits){
                InteractionRecordData_log(cg->record, cg->record_index, part, XC_EXIT_JAW);
            }
        }
        if (cg->side == -1){
            // Mirror back
            LocalParticle_scale_x(part, -1);
#ifdef XCOLL_USE_EXACT
            LocalParticle_scale_exact_xp(part, -1);
#else
            LocalParticle_scale_xp(part, -1);
#endif
        }
        // Rotate back from tilt
        double new_s = YRotation_single_particle_rotate_only(part, LocalParticle_get_s(part), -asin(cg->sin_y));
        LocalParticle_set_s(part, new_s);
        // Shift the reference frame back from jaw corner U
        XYShift_single_particle(part, -cg->jaw_U, 0);
        // If particle survived, drift to end of element
        if (LocalParticle_get_state(part) > 0){
#ifdef XCOLL_USE_EXACT
            Drift_single_particle_exact(part, cg->length - LocalParticle_get_s(part));
#else
            Drift_single_particle_expanded(part, cg->length - LocalParticle_get_s(part));
#endif
        }
        SRotation_single_particle(part, -cg->sin_z, cg->cos_z);
    }
}


#endif /* XCOLL_CRY_GEOM_H */

#ifndef XOBJ_TYPEDEF_BeamBeamBiGaussian3DData
#define XOBJ_TYPEDEF_BeamBeamBiGaussian3DData
typedef   struct BeamBeamBiGaussian3DData_s * BeamBeamBiGaussian3DData;
 static inline BeamBeamBiGaussian3DData BeamBeamBiGaussian3DData_getp(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  return (BeamBeamBiGaussian3DData)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_scale_strength(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_scale_strength(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_scale_strength(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get__sin_phi(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set__sin_phi(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp__sin_phi(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get__cos_phi(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set__cos_phi(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp__cos_phi(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get__tan_phi(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set__tan_phi(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp__tan_phi(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get__sin_alpha(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set__sin_alpha(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp__sin_alpha(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get__cos_alpha(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set__cos_alpha(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp__cos_alpha(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_ref_shift_x(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_ref_shift_x(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_ref_shift_x(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_ref_shift_px(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_ref_shift_px(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_ref_shift_px(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_ref_shift_y(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_ref_shift_y(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_ref_shift_y(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_ref_shift_py(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_ref_shift_py(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_ref_shift_py(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_ref_shift_zeta(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_ref_shift_zeta(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_ref_shift_zeta(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_ref_shift_pzeta(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_ref_shift_pzeta(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_ref_shift_pzeta(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_other_beam_shift_x(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_other_beam_shift_x(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_other_beam_shift_x(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_other_beam_shift_px(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_other_beam_shift_px(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_other_beam_shift_px(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_other_beam_shift_y(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_other_beam_shift_y(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_other_beam_shift_y(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_other_beam_shift_py(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_other_beam_shift_py(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_other_beam_shift_py(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_other_beam_shift_zeta(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_other_beam_shift_zeta(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_other_beam_shift_zeta(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_other_beam_shift_pzeta(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_other_beam_shift_pzeta(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_other_beam_shift_pzeta(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_post_subtract_x(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_post_subtract_x(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_post_subtract_x(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_post_subtract_px(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_post_subtract_px(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_post_subtract_px(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_post_subtract_y(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_post_subtract_y(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_post_subtract_y(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_post_subtract_py(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_post_subtract_py(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=176;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_post_subtract_py(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_post_subtract_zeta(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_post_subtract_zeta(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=184;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_post_subtract_zeta(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_post_subtract_pzeta(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_post_subtract_pzeta(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_post_subtract_pzeta(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_other_beam_q0(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_other_beam_q0(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=200;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_other_beam_q0(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_get_num_slices_other_beam(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_num_slices_other_beam(BeamBeamBiGaussian3DData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=208;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DData_getp_num_slices_other_beam(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_num_particles(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=496;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_num_particles(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=496;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_num_particles(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=496;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_num_particles(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=496;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_num_particles(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=496;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_x_center_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+328);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_x_center_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+328);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_x_center_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+328);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_x_center_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+328);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_x_center_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+328);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_px_center_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+336);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_px_center_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+336);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_px_center_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+336);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_px_center_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+336);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_px_center_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+336);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_y_center_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+344);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_y_center_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+344);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_y_center_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+344);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_y_center_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+344);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_y_center_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+344);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_py_center_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+352);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_py_center_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+352);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_py_center_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+352);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_py_center_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+352);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_py_center_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+352);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_zeta_center_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+360);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_zeta_center_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+360);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_zeta_center_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+360);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_zeta_center_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+360);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_zeta_center_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+360);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_pzeta_center_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+368);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_pzeta_center_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+368);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_pzeta_center_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+368);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_pzeta_center_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+368);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_pzeta_center_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+368);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_Sigma_11_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+376);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_Sigma_11_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+376);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_11_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+376);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_Sigma_11_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+376);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_Sigma_11_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+376);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_Sigma_12_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+384);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_Sigma_12_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+384);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_12_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+384);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_Sigma_12_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+384);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_Sigma_12_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+384);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_Sigma_13_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+392);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_Sigma_13_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+392);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_13_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+392);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_Sigma_13_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+392);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_Sigma_13_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+392);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_Sigma_14_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+400);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_Sigma_14_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+400);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_14_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+400);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_Sigma_14_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+400);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_Sigma_14_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+400);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_Sigma_22_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+408);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_Sigma_22_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+408);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_22_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+408);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_Sigma_22_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+408);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_Sigma_22_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+408);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_Sigma_23_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+416);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_Sigma_23_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+416);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_23_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+416);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_Sigma_23_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+416);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_Sigma_23_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+416);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_Sigma_24_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+424);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_Sigma_24_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+424);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_24_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+424);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_Sigma_24_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+424);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_Sigma_24_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+424);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_Sigma_33_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+432);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_Sigma_33_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+432);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_33_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+432);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_Sigma_33_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+432);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_Sigma_33_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+432);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_Sigma_34_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+440);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_Sigma_34_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+440);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_34_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+440);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_Sigma_34_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+440);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_Sigma_34_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+440);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_Sigma_44_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+448);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_Sigma_44_star(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+448);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_44_star(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+448);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_Sigma_44_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+448);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_Sigma_44_star(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+448);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_min_sigma_diff(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_min_sigma_diff(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_min_sigma_diff(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_threshold_singular(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_threshold_singular(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_threshold_singular(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_get_flag_beamstrahlung(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_flag_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=232;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DData_getp_flag_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_zeta_bin_width_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+456);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_zeta_bin_width_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+456);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_zeta_bin_width_beamstrahlung(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+456);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_zeta_bin_width_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+456);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_zeta_bin_width_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+456);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_zeta_bin_width_star_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+464);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_zeta_bin_width_star_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+464);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_zeta_bin_width_star_beamstrahlung(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+464);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_zeta_bin_width_star_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+464);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_zeta_bin_width_star_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+464);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_sqrtSigma_11_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+472);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_sqrtSigma_11_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+472);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_sqrtSigma_11_beamstrahlung(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+472);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_sqrtSigma_11_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+472);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_sqrtSigma_11_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+472);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_sqrtSigma_33_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+480);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_sqrtSigma_33_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+480);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_sqrtSigma_33_beamstrahlung(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+480);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_sqrtSigma_33_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+480);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_sqrtSigma_33_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+480);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamBeamBiGaussian3DData_getp_slices_other_beam_sqrtSigma_55_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+488);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_len_slices_other_beam_sqrtSigma_55_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+488);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamBeamBiGaussian3DData_get_slices_other_beam_sqrtSigma_55_beamstrahlung(const BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+488);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_slices_other_beam_sqrtSigma_55_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+488);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp1_slices_other_beam_sqrtSigma_55_beamstrahlung(BeamBeamBiGaussian3DData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+488);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_get_flag_bhabha(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_flag_bhabha(BeamBeamBiGaussian3DData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=240;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DData_getp_flag_bhabha(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get_compt_x_min(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_compt_x_min(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp_compt_x_min(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_get_flag_beamsize_effect(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_flag_beamsize_effect(BeamBeamBiGaussian3DData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DData_getp_flag_beamsize_effect(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_get_flag_luminosity(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set_flag_luminosity(BeamBeamBiGaussian3DData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=264;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DData_getp_flag_luminosity(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get__sin_rot_s(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set__sin_rot_s(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=272;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp__sin_rot_s(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get__cos_rot_s(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set__cos_rot_s(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=280;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp__cos_rot_s(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get__shift_x(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=288;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set__shift_x(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=288;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp__shift_x(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=288;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get__shift_y(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=296;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set__shift_y(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=296;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp__shift_y(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=296;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamBeamBiGaussian3DData_get__shift_s(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=304;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set__shift_s(BeamBeamBiGaussian3DData restrict  obj, double value){
  int64_t offset=0;
  offset+=304;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamBeamBiGaussian3DData_getp__shift_s(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=304;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier BeamBeamBiGaussian3DData_getp__internal_record_id(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=312;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_get__internal_record_id_buffer_id(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=312;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set__internal_record_id_buffer_id(BeamBeamBiGaussian3DData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=312;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DData_getp__internal_record_id_buffer_id(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=312;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamBeamBiGaussian3DData_get__internal_record_id_offset(const BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=320;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamBeamBiGaussian3DData_set__internal_record_id_offset(BeamBeamBiGaussian3DData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=320;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamBeamBiGaussian3DData_getp__internal_record_id_offset(BeamBeamBiGaussian3DData restrict  obj){
  int64_t offset=0;
  offset+=320;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
BeamBeamBiGaussian3DRecordData BeamBeamBiGaussian3DData_getp_internal_record(BeamBeamBiGaussian3DData el, LocalParticle* part){
    RecordIdentifier record_id = BeamBeamBiGaussian3DData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (BeamBeamBiGaussian3DRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    

#ifndef XFIELDS_CONSTANTS_H
#define XFIELDS_CONSTANTS_H

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //


// classical electron radius [m]
#if !defined( RE )
    #define   RE ( 2.81794092e-15 )
#endif

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif

// from python scipy version 1.9.0: cst.elementary_charge
#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.8541878128e-12)
#endif

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif

// from python scipy version 1.9.0: cst.epsilon_0
#if !defined( QELEM )
    #define QELEM (1.602176634e-19)
#endif

#if !defined( MPROTON_GEV )
    #define MPROTON_GEV (0.93827208816)
#endif

#if !defined( MELECTRON_GEV )
    #define MELECTRON_GEV (0.00051099895000)
#endif

#if !defined( MELECTRON_KG )
    #define MELECTRON_KG (9.1093837015e-31)
#endif

#if !defined( ALPHA )
    #define ALPHA (7.29735257e-3)
#endif

#if !defined( HBAR_GEVS )
    #define HBAR_GEVS (6.582119569e-25)
#endif

#if !defined( TWO_OVER_SQRT_PI )
    #define TWO_OVER_SQRT_PI (1.128379167095512573896158903121545171688101258657997713688171443418)
#endif

#if !defined( SQRT_TWO )
    #define SQRT_TWO (1.414213562373095048801688724209698078569671875376948073176679738)
#endif

#if !defined( REDUCED_COMPTON_WAVELENGTH_ELECTRON )
    #define REDUCED_COMPTON_WAVELENGTH_ELECTRON (3.8615926796089057e-13)
#endif

#if !defined( REAL_EPSILON )
    #define REAL_EPSILON 2.22044604925031e-16
#endif /* !defined( REAL_EPSILON ) */

#endif /* XFIELDS_CONSTANTS_H */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef _ATOMICADD_H_
#define _ATOMICADD_H_

#define ATOMICADD_CPU  //only_for_context cpu_serial cpu_openmp
//#define ATOMICADD_OPENCL //only_for_context opencl
// CUDA provides atomicAdd() natively

#ifdef ATOMICADD_CPU
inline void atomicAdd(double *addr, double val)
{
//   #pragma omp atomic //only_for_context cpu_openmp
   *addr = *addr + val;
}
#endif // ATOMICADD_CPU

#ifdef ATOMICADD_OPENCL
#pragma OPENCL EXTENSION cl_khr_int64_base_atomics : enable
inline void atomicAdd(volatile __global double *addr, double val)
{
	union {
		long u64;
		double f64;
	} next, expected, current;
	current.f64 = *addr;
	do {
		expected.f64 = current.f64;
		next.f64 = expected.f64 + val;
		current.u64 = atom_cmpxchg(
			(volatile __global long *)addr,
		        (long) expected.u64,
			(long) next.u64);
	} while( current.u64 != expected.u64 );
}
#endif // ATOMICADD_OPENCL

#endif

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_SINCOS_H__
#define XFIELDS_SINCOS_H__

#include <math.h> //only_for_context cpu_serial cpu_openmp

/* Define XSUITE_NO_SINCOS as a compiler parameter to never use the inline
 * wrapper function below (the compiler may still decide to use sincos - like
 * intrinsic, but usually enforcing that math functions have to update
 * errno should put an end to this.
 *
 * If XSUITE_NO_SINCOS is not set, then a best-effort attempt is made to
 * use it on platforms that support it (i.e. gnu compiler, no ANSI standards,
 * relaxed errno handling for math functions.
 */

#if ( !defined( XSUITE_NO_SINCOS ) ) && ( defined( __OPENCL_C_VERSION__ ) )
 static inline void xsuite_sincos( double const arg,
    double*  restrict  sin_result, double*  restrict  cos_result ) {
    *sin_result = sincos( arg, cos_result ); }

#elif ( !defined( XSUITE_NO_SINCOS ) ) && \
      ( ( defined( __CUDA_ARCH__ ) ) || \
        ( defined( __GNUC__ ) && !defined( __clang__ ) && \
         !defined( __STRICT_ANSI__ ) && !defined( __INTEL_COMPILER ) && \
         defined( __NO_MATH_ERRNO__ ) ) )
 static inline void xsuite_sincos( double const arg,
    double*  restrict  sin_result, double*  restrict  cos_result ) {
    sincos( arg, sin_result, cos_result ); }

#else
 static inline void xsuite_sincos( double const arg,
    double*  restrict  sin_result, double*  restrict  cos_result ) {
    *sin_result = sin( arg );
    *cos_result = cos( arg ); }

#endif /* XSUITE_NO_SINCOS */
#endif /* XFIELDS_SINCOS_H__ */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_HEADERS_POWER_H_H__
#define XFIELDS_HEADERS_POWER_H_H__

/** \file power_n.h
 *  \note always include constants first!!! */

 static inline double power_n( double x, unsigned int n )
{
    #if defined( __OPENCL_VERSION__ )
    return pown( x, n );
    #else

    double x_n = x;

    unsigned int const n_div_16 = n >> 4u;
    unsigned int const n_mod_16 = n - ( n_div_16 << 4u );

    switch( n_mod_16 )
    {
        case  0u: { x_n = ( double )1.0; break; }
        case  1u: { break; }
        case  2u: { x_n *= x;                                       break; }
        case  3u: { x_n *= x * x;                                   break; }
        case  4u: { x_n *= x;     x_n *= x_n;                       break; }
        case  5u: { x_n *= x;     x_n *= x_n * x;                   break; }
        case  6u: { x_n *= x * x; x_n *= x_n;                       break; }
        case  7u: { x_n *= x * x; x_n *= x_n * x;                   break; }
        case  8u: { x_n *= x;     x_n *= x_n;     x_n *= x_n;       break; }
        case  9u: { x_n *= x * x; x_n *= x_n * x_n;                 break; }
        case 10u: { x_n *= x * x; x_n *= x_n * x_n * x;             break; }
        case 11u: { x_n *= x;     x_n *= x_n * x; x_n *= x_n * x;   break; }
        case 12u: { x_n *= x * x; x_n *= x_n;     x_n *= x_n;       break; }
        case 13u: { x_n *= x * x; x_n *= x_n;     x_n *= x_n * x;   break; }
        case 14u: { x_n *= x * x; x_n *= x_n * x; x_n *= x_n;       break; }
        case 15u: { x_n *= x;     x_n *= x_n * x; x_n *= x_n * x_n; break; }
        default:  { x_n = ( double )0.0; }
    };

    if( n_div_16 > 0u ){ x *= x; x *= x; x *= x; x *= x; }

    switch( n_div_16 )
    {
        case  0u: { x_n  = ( n_mod_16 != 0u ) ? x_n : ( double )1.0; break; }
        case  1u: { x_n *= x;                                           break; }
        case  2u: { x   *= x; x_n *= x;                                 break; }
        case  3u: { x_n *= x * x * x;                                   break; }
        case  4u: { x   *= x; x *= x; x_n *= x;                         break; }
        case  5u: { x_n *= x; x *= x; x *= x; x_n *= x;                 break; }
        case  6u: { x   *= x * x; x *= x; x_n *= x;                     break; }
        case  7u: { x_n *= x; x *= x * x; x *= x; x_n *= x;             break; }
        case  8u: { x *= x; x *= x; x*= x; x_n *= x;                    break; }
        case  9u: { x *= x * x; x *= x * x; x_n *= x;                   break; }
        case 10u: { x_n *= x; x *= x * x; x *= x * x; x_n *= x;         break; }
        case 11u: { x_n *= x * x; x *= x * x; x *= x * x; x_n *= x;     break; }
        case 12u: { x *= x; x *= x; x_n *= x; x *= x; x_n *= x;         break; }
        case 13u: { x_n *= x; x *= x; x *= x; x_n *= x; x *= x;
                    x_n *= x; break; }

        case 14u: { x_n *= x * x; x *= x; x *= x; x_n *= x; x *= x;
                    x_n *= x; break; }

        case 15u: { x *= x * x; x_n *= x * x; x *= x * x; x_n *= x;    break; }

        default:
        {
            unsigned int ii = 0u;
            unsigned int nn = n_div_16 % 16u;

            for( ; ii < nn ; ++ii ) x_n *= x;

            x *= x; x *= x; x *= x; x *= x;
            nn = ( n_div_16 - nn ) >> 4u;

            for( ii = 0u ; ii < nn ; ++ii ) x_n *= x;
        }
    };

    return x_n;
    #endif /* defined( __OPENCL_VERSION__ ) */
}

#endif /* XFIELDS_HEADERS_POWER_H_H__ */

// copyright ############################### //
// This file is part of the Xfields Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XFIELDS_PARTICLE_STATES_H
#define XFIELDS_PARTICLE_STATES_H

#define XF_OUTSIDE_INTERPOL -11
#define XF_TOO_MANY_PHOTONS -12

#endif /* XFIELDS_PARTICLE_STATES_H */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_FADDEEVA_H
#define XFIELDS_FADDEEVA_H


//from file: faddeeva_mit.h

//  -*- mode:c++; tab-width:2; indent-tabs-mode:nil;  -*-

/* Copyright (c) 2012 Massachusetts Institute of Technology
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/* (Note that this file can be compiled with either C++, in which
    case it uses C++ std::complex<double>, or C, in which case it
    uses C99 double complex.) */

/* Available at: http://ab-initio.mit.edu/Faddeeva

   Computes various error functions (erf, erfc, erfi, erfcx),
   including the Dawson integral, in the complex plane, based
   on algorithms for the computation of the Faddeeva function
              w(z) = exp(-z^2) * erfc(-i*z).
   Given w(z), the error functions are mostly straightforward
   to compute, except for certain regions where we have to
   switch to Taylor expansions to avoid cancellation errors
   [e.g. near the origin for erf(z)].

   To compute the Faddeeva function, we use a combination of two
   algorithms:

   For sufficiently large |z|, we use a continued-fraction expansion
   for w(z) similar to those described in:

      Walter Gautschi, "Efficient computation of the complex error
      function," SIAM J. Numer. Anal. 7(1), pp. 187-198 (1970)

      G. P. M. Poppe and C. M. J. Wijers, "More efficient computation
      of the complex error function," ACM Trans. Math. Soft. 16(1),
      pp. 38-46 (1990).

   Unlike those papers, however, we switch to a completely different
   algorithm for smaller |z|:

      Mofreh R. Zaghloul and Ahmed N. Ali, "Algorithm 916: Computing the
      Faddeyeva and Voigt Functions," ACM Trans. Math. Soft. 38(2), 15
      (2011).

   (I initially used this algorithm for all z, but it turned out to be
    significantly slower than the continued-fraction expansion for
    larger |z|.  On the other hand, it is competitive for smaller |z|,
    and is significantly more accurate than the Poppe & Wijers code
    in some regions, e.g. in the vicinity of z=1+1i.)

   Note that this is an INDEPENDENT RE-IMPLEMENTATION of these algorithms,
   based on the description in the papers ONLY.  In particular, I did
   not refer to the authors' Fortran or Matlab implementations, respectively,
   (which are under restrictive ACM copyright terms and therefore unusable
    in free/open-source software).

   Steven G. Johnson, Massachusetts Institute of Technology
   http://math.mit.edu/~stevenj
   October 2012.

    -- Note that Algorithm 916 assumes that the erfc(x) function,
       or rather the scaled function erfcx(x) = exp(x*x)*erfc(x),
       is supplied for REAL arguments x.   I originally used an
       erfcx routine derived from DERFC in SLATEC, but I have
       since replaced it with a much faster routine written by
       me which uses a combination of continued-fraction expansions
       and a lookup table of Chebyshev polynomials.  For speed,
       I implemented a similar algorithm for Im[w(x)] of real x,
       since this comes up frequently in the other error functions.

   A small test program is included the end, which checks
   the w(z) etc. results against several known values.  To compile
   the test function, compile with -DTEST_FADDEEVA (that is,
   #define TEST_FADDEEVA).

   If HAVE_CONFIG_H is #defined (e.g. by compiling with -DHAVE_CONFIG_H),
   then we #include "config.h", which is assumed to be a GNU autoconf-style
   header defining HAVE_* macros to indicate the presence of features. In
   particular, if HAVE_ISNAN and HAVE_ISINF are #defined, we use those
   functions in math.h instead of defining our own, and if HAVE_ERF and/or
   HAVE_ERFC are defined we use those functions from <cmath> for erf and
   erfc of real arguments, respectively, instead of defining our own.

   REVISION HISTORY:
       4 October 2012: Initial public release (SGJ)
       5 October 2012: Revised (SGJ) to fix spelling error,
                       start summation for large x at round(x/a) (> 1)
                       rather than ceil(x/a) as in the original
                       paper, which should slightly improve performance
                       (and, apparently, slightly improves accuracy)
      19 October 2012: Revised (SGJ) to fix bugs for large x, large -y,
                       and 15<x<26. Performance improvements. Prototype
                       now supplies default value for relerr.
      24 October 2012: Switch to continued-fraction expansion for
                       sufficiently large z, for performance reasons.
                       Also, avoid spurious overflow for |z| > 1e154.
                       Set relerr argument to min(relerr,0.1).
      27 October 2012: Enhance accuracy in Re[w(z)] taken by itself,
                       by switching to Alg. 916 in a region near
                       the real-z axis where continued fractions
                       have poor relative accuracy in Re[w(z)].  Thanks
                       to M. Zaghloul for the tip.
      29 October 2012: Replace SLATEC-derived erfcx routine with
                       completely rewritten code by me, using a very
                       different algorithm which is much faster.
      30 October 2012: Implemented special-case code for real z
                       (where real part is exp(-x^2) and imag part is
                        Dawson integral), using algorithm similar to erfx.
                       Export ImFaddeeva_w function to make Dawson's
                       integral directly accessible.
      3 November 2012: Provide implementations of erf, erfc, erfcx,
                       and Dawson functions in Faddeeva:: namespace,
                       in addition to Faddeeva::w.  Provide header
                       file Faddeeva.hh.
      4 November 2012: Slightly faster erf for real arguments.
                       Updated MATLAB and Octave plugins.
     27 November 2012: Support compilation with either C++ or
                       plain C (using C99 complex numbers).
                       For real x, use standard-library erf(x)
                       and erfc(x) if available (for C99 or C++11).
                       #include "config.h" if HAVE_CONFIG_H is #defined.
     15 December 2012: Portability fixes (copysign, Inf/NaN creation),
                       use CMPLX/__builtin_complex if available in C,
                       slight accuracy improvements to erf and dawson
                       functions near the origin.  Use gnulib functions
                       if GNULIB_NAMESPACE is defined.
     18 December 2012: Slight tweaks (remove recomputation of x*x in Dawson)
          12 May 2015: Bugfix for systems lacking copysign function.
*/

/////////////////////////////////////////////////////////////////////////
/* If this file is compiled as a part of a larger project,
   support using an autoconf-style config.h header file
   (with various "HAVE_*" #defines to indicate features)
   if HAVE_CONFIG_H is #defined (in GNU autotools style). */

#ifndef XFIELDS_FADDEEVA_MIT_H
#define XFIELDS_FADDEEVA_MIT_H

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

/////////////////////////////////////////////////////////////////////////
// macros to allow us to use either C++ or C (with C99 features)


// #  include "Faddeeva.h" # I include the full header here
/* Copyright (c) 2012 Massachusetts Institute of Technology
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/* Available at: http://ab-initio.mit.edu/Faddeeva

   Header file for Faddeeva.c; see Faddeeva.cc for more information. */


// Require C99 complex-number support
#include <complex.h>


// compute w(z) = exp(-z^2) erfc(-iz) [ Faddeeva / scaled complex error func ]
static inline double complex Faddeeva_MIT_w(double complex z, double relerr);
double Faddeeva_MIT_w_im(double x); // special-case code for Im[w(x)] of real x

// Various functions that we can compute with the help of w(z)

// compute erfcx(z) = exp(z^2) erfc(z)
double complex Faddeeva_MIT_erfcx(double complex z, double relerr);
double Faddeeva_MIT_erfcx_re(double x); // special case for real x

// compute erf(z), the error function of complex arguments
double complex Faddeeva_MIT_erf(double complex z, double relerr);
double Faddeeva_MIT_erf_re(double x); // special case for real x

// compte erfi(z) = -i erf(iz), the imaginary error function
double complex Faddeeva_MIT_erfi(double complex z, double relerr);
double Faddeeva_MIT_erfi_re(double x); // special case for real x

// compute erfc(z) = 1 - erf(z), the complementary error function
double complex Faddeeva_MIT_erfc(double complex z, double relerr);
double Faddeeva_MIT_erfc_re(double x); // special case for real x

// compute Dawson(z) = sqrt(pi)/2  *  exp(-z^2) * erfi(z)
double complex Faddeeva_MIT_Dawson(double complex z, double relerr);
double Faddeeva_MIT_Dawson_re(double x); // special case for real x


 static inline void faddeeva_w( double x, double y,
    double*  restrict  out_x, double*  restrict  out_y )
{
    double complex z, W;
    z = x + I * y;
    W = Faddeeva_MIT_w(z, 0);
    *out_x = creal(W);
    *out_y = cimag(W);
}

 static inline void faddeeva_w_q1( double x, double y,
    double*  restrict  out_x, double*  restrict  out_y )
{
    faddeeva_w(x, y, out_x, out_y);
}


#  define _GNU_SOURCE // enable GNU libc NAN extension if possible

#  include <float.h>
#  include <math.h>

typedef double complex cmplx;

#  define FADDEEVA(name) Faddeeva_MIT_ ## name
#  define FADDEEVA_RE(name) Faddeeva_MIT_ ## name ## _re

/* Constructing complex numbers like 0+i*NaN is problematic in C99
   without the C11 CMPLX macro, because 0.+I*NAN may give NaN+i*NAN if
   I is a complex (rather than imaginary) constant.  For some reason,
   however, it works fine in (pre-4.7) gcc if I define Inf and NaN as
   1/0 and 0/0 (and only if I compile with optimization -O1 or more),
   but not if I use the INFINITY or NAN macros. */

/* __builtin_complex was introduced in gcc 4.7, but the C11 CMPLX macro
   may not be defined unless we are using a recent (2012) version of
   glibc and compile with -std=c11... note that icc lies about being
   gcc and probably doesn't have this builtin(?), so exclude icc explicitly */
#  if !defined(CMPLX) && (__GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 7)) && !(defined(__ICC) || defined(__INTEL_COMPILER))
#    define CMPLX(a,b) __builtin_complex((double) (a), (double) (b))
#  endif

#  ifdef CMPLX // C11
#    define C(a,b) CMPLX(a,b)
#    define Inf INFINITY // C99 infinity
#    ifdef NAN // GNU libc extension
#      define NaN NAN
#    else
#      define NaN (0./0.) // NaN
#    endif
#  else
#    define C(a,b) ((a) + I*(b))
#    define Inf (1./0.)
#    define NaN (0./0.)
#  endif

static inline cmplx cpolar(double r, double t)
{
  if (r == 0.0 && !isnan(t))
    return 0.0;
  else
    return C(r * cos(t), r * sin(t));
}


/////////////////////////////////////////////////////////////////////////
// Auxiliary routines to compute other special functions based on w(z)

// compute erfcx(z) = exp(z^2) erfz(z)
cmplx FADDEEVA(erfcx)(cmplx z, double relerr)
{
  return FADDEEVA(w)(C(-cimag(z), creal(z)), relerr);
}

// compute the error function erf(x)
double FADDEEVA_RE(erf)(double x)
{
#if !defined(__cplusplus)
  return erf(x); // C99 supplies erf in math.h
#elif (__cplusplus >= 201103L) || defined(HAVE_ERF)
  return ::erf(x); // C++11 supplies std::erf in cmath
#else
  double mx2 = -x*x;
  if (mx2 < -750) // underflow
    return (x >= 0 ? 1.0 : -1.0);

  if (x >= 0) {
    if (x < 8e-2) goto taylor;
    return 1.0 - exp(mx2) * FADDEEVA_RE(erfcx)(x);
  }
  else { // x < 0
    if (x > -8e-2) goto taylor;
    return exp(mx2) * FADDEEVA_RE(erfcx)(-x) - 1.0;
  }

  // Use Taylor series for small |x|, to avoid cancellation inaccuracy
  //   erf(x) = 2/sqrt(pi) * x * (1 - x^2/3 + x^4/10 - x^6/42 + x^8/216 + ...)
 taylor:
  return x * (1.1283791670955125739
              + mx2 * (0.37612638903183752464
                       + mx2 * (0.11283791670955125739
                                + mx2 * (0.026866170645131251760
                                         + mx2 * 0.0052239776254421878422))));
#endif
}

// compute the error function erf(z)
cmplx FADDEEVA(erf)(cmplx z, double relerr)
{
  double x = creal(z), y = cimag(z);

  if (y == 0)
    return C(FADDEEVA_RE(erf)(x),
             y); // preserve sign of 0
  if (x == 0) // handle separately for speed & handling of y = Inf or NaN
    return C(x, // preserve sign of 0
             /* handle y -> Inf limit manually, since
                exp(y^2) -> Inf but Im[w(y)] -> 0, so
                IEEE will give us a NaN when it should be Inf */
             y*y > 720 ? (y > 0 ? Inf : -Inf)
             : exp(y*y) * FADDEEVA(w_im)(y));

  double mRe_z2 = (y - x) * (x + y); // Re(-z^2), being careful of overflow
  double mIm_z2 = -2*x*y; // Im(-z^2)
  if (mRe_z2 < -750) // underflow
    return (x >= 0 ? 1.0 : -1.0);

  /* Handle positive and negative x via different formulas,
     using the mirror symmetries of w, to avoid overflow/underflow
     problems from multiplying exponentially large and small quantities. */
  if (x >= 0) {
    if (x < 8e-2) {
      if (fabs(y) < 1e-2)
        goto taylor;
      else if (fabs(mIm_z2) < 5e-3 && x < 5e-3)
        goto taylor_erfi;
    }
    /* don't use complex exp function, since that will produce spurious NaN
       values when multiplying w in an overflow situation. */
    return 1.0 - exp(mRe_z2) *
      (C(cos(mIm_z2), sin(mIm_z2))
       * FADDEEVA(w)(C(-y,x), relerr));
  }
  else { // x < 0
    if (x > -8e-2) { // duplicate from above to avoid fabs(x) call
      if (fabs(y) < 1e-2)
        goto taylor;
      else if (fabs(mIm_z2) < 5e-3 && x > -5e-3)
        goto taylor_erfi;
    }
    else if (isnan(x))
      return C(NaN, y == 0 ? 0 : NaN);
    /* don't use complex exp function, since that will produce spurious NaN
       values when multiplying w in an overflow situation. */
    return exp(mRe_z2) *
      (C(cos(mIm_z2), sin(mIm_z2))
       * FADDEEVA(w)(C(y,-x), relerr)) - 1.0;
  }

  // Use Taylor series for small |z|, to avoid cancellation inaccuracy
  //   erf(z) = 2/sqrt(pi) * z * (1 - z^2/3 + z^4/10 - z^6/42 + z^8/216 + ...)
 taylor:
  {
    cmplx mz2 = C(mRe_z2, mIm_z2); // -z^2
    return z * (1.1283791670955125739
                + mz2 * (0.37612638903183752464
                         + mz2 * (0.11283791670955125739
                                  + mz2 * (0.026866170645131251760
                                          + mz2 * 0.0052239776254421878422))));
  }

  /* for small |x| and small |xy|,
     use Taylor series to avoid cancellation inaccuracy:
       erf(x+iy) = erf(iy)
          + 2*exp(y^2)/sqrt(pi) *
            [ x * (1 - x^2 * (1+2y^2)/3 + x^4 * (3+12y^2+4y^4)/30 + ...
              - i * x^2 * y * (1 - x^2 * (3+2y^2)/6 + ...) ]
     where:
        erf(iy) = exp(y^2) * Im[w(y)]
  */
 taylor_erfi:
  {
    double x2 = x*x, y2 = y*y;
    double expy2 = exp(y2);
    return C
      (expy2 * x * (1.1283791670955125739
                    - x2 * (0.37612638903183752464
                            + 0.75225277806367504925*y2)
                    + x2*x2 * (0.11283791670955125739
                               + y2 * (0.45135166683820502956
                                       + 0.15045055561273500986*y2))),
       expy2 * (FADDEEVA(w_im)(y)
                - x2*y * (1.1283791670955125739
                          - x2 * (0.56418958354775628695
                                  + 0.37612638903183752464*y2))));
  }
}

// erfi(z) = -i erf(iz)
cmplx FADDEEVA(erfi)(cmplx z, double relerr)
{
  cmplx e = FADDEEVA(erf)(C(-cimag(z),creal(z)), relerr);
  return C(cimag(e), -creal(e));
}

// erfi(x) = -i erf(ix)
double FADDEEVA_RE(erfi)(double x)
{
  return x*x > 720 ? (x > 0 ? Inf : -Inf)
    : exp(x*x) * FADDEEVA(w_im)(x);
}

// erfc(x) = 1 - erf(x)
double FADDEEVA_RE(erfc)(double x)
{
#if !defined(__cplusplus)
  return erfc(x); // C99 supplies erfc in math.h
#elif (__cplusplus >= 201103L) || defined(HAVE_ERFC)
  return ::erfc(x); // C++11 supplies std::erfc in cmath
#else
  if (x*x > 750) // underflow
    return (x >= 0 ? 0.0 : 2.0);
  return x >= 0 ? exp(-x*x) * FADDEEVA_RE(erfcx)(x)
    : 2. - exp(-x*x) * FADDEEVA_RE(erfcx)(-x);
#endif
}

// erfc(z) = 1 - erf(z)
cmplx FADDEEVA(erfc)(cmplx z, double relerr)
{
  double x = creal(z), y = cimag(z);

  if (x == 0.)
    return C(1,
             /* handle y -> Inf limit manually, since
                exp(y^2) -> Inf but Im[w(y)] -> 0, so
                IEEE will give us a NaN when it should be Inf */
             y*y > 720 ? (y > 0 ? -Inf : Inf)
             : -exp(y*y) * FADDEEVA(w_im)(y));
  if (y == 0.) {
    if (x*x > 750) // underflow
      return C(x >= 0 ? 0.0 : 2.0,
               -y); // preserve sign of 0
    return C(x >= 0 ? exp(-x*x) * FADDEEVA_RE(erfcx)(x)
             : 2. - exp(-x*x) * FADDEEVA_RE(erfcx)(-x),
             -y); // preserve sign of zero
  }

  double mRe_z2 = (y - x) * (x + y); // Re(-z^2), being careful of overflow
  double mIm_z2 = -2*x*y; // Im(-z^2)
  if (mRe_z2 < -750) // underflow
    return (x >= 0 ? 0.0 : 2.0);

  if (x >= 0)
    return cexp(C(mRe_z2, mIm_z2))
      * FADDEEVA(w)(C(-y,x), relerr);
  else
    return 2.0 - cexp(C(mRe_z2, mIm_z2))
      * FADDEEVA(w)(C(y,-x), relerr);
}

// compute Dawson(x) = sqrt(pi)/2  *  exp(-x^2) * erfi(x)
double FADDEEVA_RE(Dawson)(double x)
{
  const double spi2 = 0.8862269254527580136490837416705725913990; // sqrt(pi)/2
  return spi2 * FADDEEVA(w_im)(x);
}

// compute Dawson(z) = sqrt(pi)/2  *  exp(-z^2) * erfi(z)
cmplx FADDEEVA(Dawson)(cmplx z, double relerr)
{
  const double spi2 = 0.8862269254527580136490837416705725913990; // sqrt(pi)/2
  double x = creal(z), y = cimag(z);

  // handle axes separately for speed & proper handling of x or y = Inf or NaN
  if (y == 0)
    return C(spi2 * FADDEEVA(w_im)(x),
             -y); // preserve sign of 0
  if (x == 0) {
    double y2 = y*y;
    if (y2 < 2.5e-5) { // Taylor expansion
      return C(x, // preserve sign of 0
               y * (1.
                    + y2 * (0.6666666666666666666666666666666666666667
                            + y2 * 0.26666666666666666666666666666666666667)));
    }
    return C(x, // preserve sign of 0
             spi2 * (y >= 0
                     ? exp(y2) - FADDEEVA_RE(erfcx)(y)
                     : FADDEEVA_RE(erfcx)(-y) - exp(y2)));
  }

  double mRe_z2 = (y - x) * (x + y); // Re(-z^2), being careful of overflow
  double mIm_z2 = -2*x*y; // Im(-z^2)
  cmplx mz2 = C(mRe_z2, mIm_z2); // -z^2

  /* Handle positive and negative x via different formulas,
     using the mirror symmetries of w, to avoid overflow/underflow
     problems from multiplying exponentially large and small quantities. */
  if (y >= 0) {
    if (y < 5e-3) {
      if (fabs(x) < 5e-3)
        goto taylor;
      else if (fabs(mIm_z2) < 5e-3)
        goto taylor_realaxis;
    }
    cmplx res = cexp(mz2) - FADDEEVA(w)(z, relerr);
    return spi2 * C(-cimag(res), creal(res));
  }
  else { // y < 0
    if (y > -5e-3) { // duplicate from above to avoid fabs(x) call
      if (fabs(x) < 5e-3)
        goto taylor;
      else if (fabs(mIm_z2) < 5e-3)
        goto taylor_realaxis;
    }
    else if (isnan(y))
      return C(x == 0 ? 0 : NaN, NaN);
    cmplx res = FADDEEVA(w)(-z, relerr) - cexp(mz2);
    return spi2 * C(-cimag(res), creal(res));
  }

  // Use Taylor series for small |z|, to avoid cancellation inaccuracy
  //     dawson(z) = z - 2/3 z^3 + 4/15 z^5 + ...
 taylor:
  return z * (1.
              + mz2 * (0.6666666666666666666666666666666666666667
                       + mz2 * 0.2666666666666666666666666666666666666667));

  /* for small |y| and small |xy|,
     use Taylor series to avoid cancellation inaccuracy:
       dawson(x + iy)
        = D + y^2 (D + x - 2Dx^2)
            + y^4 (D/2 + 5x/6 - 2Dx^2 - x^3/3 + 2Dx^4/3)
        + iy [ (1-2Dx) + 2/3 y^2 (1 - 3Dx - x^2 + 2Dx^3)
              + y^4/15 (4 - 15Dx - 9x^2 + 20Dx^3 + 2x^4 - 4Dx^5) ] + ...
     where D = dawson(x)

     However, for large |x|, 2Dx -> 1 which gives cancellation problems in
     this series (many of the leading terms cancel).  So, for large |x|,
     we need to substitute a continued-fraction expansion for D.

        dawson(x) = 0.5 / (x-0.5/(x-1/(x-1.5/(x-2/(x-2.5/(x...))))))

     The 6 terms shown here seems to be the minimum needed to be
     accurate as soon as the simpler Taylor expansion above starts
     breaking down.  Using this 6-term expansion, factoring out the
     denominator, and simplifying with Maple, we obtain:

      Re dawson(x + iy) * (-15 + 90x^2 - 60x^4 + 8x^6) / x
        = 33 - 28x^2 + 4x^4 + y^2 (18 - 4x^2) + 4 y^4
      Im dawson(x + iy) * (-15 + 90x^2 - 60x^4 + 8x^6) / y
        = -15 + 24x^2 - 4x^4 + 2/3 y^2 (6x^2 - 15) - 4 y^4

     Finally, for |x| > 5e7, we can use a simpler 1-term continued-fraction
     expansion for the real part, and a 2-term expansion for the imaginary
     part.  (This avoids overflow problems for huge |x|.)  This yields:

     Re dawson(x + iy) = [1 + y^2 (1 + y^2/2 - (xy)^2/3)] / (2x)
     Im dawson(x + iy) = y [ -1 - 2/3 y^2 + y^4/15 (2x^2 - 4) ] / (2x^2 - 1)

 */
 taylor_realaxis:
  {
    double x2 = x*x;
    if (x2 > 1600) { // |x| > 40
      double y2 = y*y;
      if (x2 > 25e14) {// |x| > 5e7
        double xy2 = (x*y)*(x*y);
        return C((0.5 + y2 * (0.5 + 0.25*y2
                              - 0.16666666666666666667*xy2)) / x,
                 y * (-1 + y2 * (-0.66666666666666666667
                                 + 0.13333333333333333333*xy2
                                 - 0.26666666666666666667*y2))
                 / (2*x2 - 1));
      }
      return (1. / (-15 + x2*(90 + x2*(-60 + 8*x2)))) *
        C(x * (33 + x2 * (-28 + 4*x2)
               + y2 * (18 - 4*x2 + 4*y2)),
          y * (-15 + x2 * (24 - 4*x2)
               + y2 * (4*x2 - 10 - 4*y2)));
    }
    else {
      double D = spi2 * FADDEEVA(w_im)(x);
      double y2 = y*y;
      return C
        (D + y2 * (D + x - 2*D*x2)
         + y2*y2 * (D * (0.5 - x2 * (2 - 0.66666666666666666667*x2))
                    + x * (0.83333333333333333333
                           - 0.33333333333333333333 * x2)),
         y * (1 - 2*D*x
              + y2 * 0.66666666666666666667 * (1 - x2 - D*x * (3 - 2*x2))
              + y2*y2 * (0.26666666666666666667 -
                         x2 * (0.6 - 0.13333333333333333333 * x2)
                         - D*x * (1 - x2 * (1.3333333333333333333
                                            - 0.26666666666666666667 * x2)))));
    }
  }
}

/////////////////////////////////////////////////////////////////////////

// return sinc(x) = sin(x)/x, given both x and sin(x)
// [since we only use this in cases where sin(x) has already been computed]
static inline double sinc(double x, double sinx) {
  return fabs(x) < 1e-4 ? 1 - (0.1666666666666666666667)*x*x : sinx / x;
}

// sinh(x) via Taylor series, accurate to machine precision for |x| < 1e-2
static inline double sinh_taylor(double x) {
  return x * (1 + (x*x) * (0.1666666666666666666667
                           + 0.00833333333333333333333 * (x*x)));
}

static inline double sqr(double x) { return x*x; }

// precomputed table of expa2n2[n-1] = exp(-a2*n*n)
// for double-precision a2 = 0.26865... in FADDEEVA(w), below.
static const double expa2n2[] = {
  7.64405281671221563e-01,
  3.41424527166548425e-01,
  8.91072646929412548e-02,
  1.35887299055460086e-02,
  1.21085455253437481e-03,
  6.30452613933449404e-05,
  1.91805156577114683e-06,
  3.40969447714832381e-08,
  3.54175089099469393e-10,
  2.14965079583260682e-12,
  7.62368911833724354e-15,
  1.57982797110681093e-17,
  1.91294189103582677e-20,
  1.35344656764205340e-23,
  5.59535712428588720e-27,
  1.35164257972401769e-30,
  1.90784582843501167e-34,
  1.57351920291442930e-38,
  7.58312432328032845e-43,
  2.13536275438697082e-47,
  3.51352063787195769e-52,
  3.37800830266396920e-57,
  1.89769439468301000e-62,
  6.22929926072668851e-68,
  1.19481172006938722e-73,
  1.33908181133005953e-79,
  8.76924303483223939e-86,
  3.35555576166254986e-92,
  7.50264110688173024e-99,
  9.80192200745410268e-106,
  7.48265412822268959e-113,
  3.33770122566809425e-120,
  8.69934598159861140e-128,
  1.32486951484088852e-135,
  1.17898144201315253e-143,
  6.13039120236180012e-152,
  1.86258785950822098e-160,
  3.30668408201432783e-169,
  3.43017280887946235e-178,
  2.07915397775808219e-187,
  7.36384545323984966e-197,
  1.52394760394085741e-206,
  1.84281935046532100e-216,
  1.30209553802992923e-226,
  5.37588903521080531e-237,
  1.29689584599763145e-247,
  1.82813078022866562e-258,
  1.50576355348684241e-269,
  7.24692320799294194e-281,
  2.03797051314726829e-292,
  3.34880215927873807e-304,
  0.0 // underflow (also prevents reads past array end, below)
};

/////////////////////////////////////////////////////////////////////////

static inline cmplx FADDEEVA(w)(cmplx z, double relerr)
{
  if (creal(z) == 0.0)
    return C(FADDEEVA_RE(erfcx)(cimag(z)),
             creal(z)); // give correct sign of 0 in cimag(w)
  else if (cimag(z) == 0)
    return C(exp(-sqr(creal(z))),
             FADDEEVA(w_im)(creal(z)));

  double a, a2, c;
  if (relerr <= DBL_EPSILON) {
    relerr = DBL_EPSILON;
    a = 0.518321480430085929872; // pi / sqrt(-log(eps*0.5))
    c = 0.329973702884629072537; // (2/pi) * a;
    a2 = 0.268657157075235951582; // a^2
  }
  else {
    const double pi = 3.14159265358979323846264338327950288419716939937510582;
    if (relerr > 0.1) relerr = 0.1; // not sensible to compute < 1 digit
    a = pi / sqrt(-log(relerr*0.5));
    c = (2/pi)*a;
    a2 = a*a;
  }
  const double x = fabs(creal(z));
  const double y = cimag(z), ya = fabs(y);

  cmplx ret = 0.; // return value

  double sum1 = 0, sum2 = 0, sum3 = 0, sum4 = 0, sum5 = 0;

#define USE_CONTINUED_FRACTION 1 // 1 to use continued fraction for large |z|

#if USE_CONTINUED_FRACTION
  if (ya > 7 || (x > 6  // continued fraction is faster
                 /* As pointed out by M. Zaghloul, the continued
                    fraction seems to give a large relative error in
                    Re w(z) for |x| ~ 6 and small |y|, so use
                    algorithm 816 in this region: */
                 && (ya > 0.1 || (x > 8 && ya > 1e-10) || x > 28))) {

    /* Poppe & Wijers suggest using a number of terms
           nu = 3 + 1442 / (26*rho + 77)
       where rho = sqrt((x/x0)^2 + (y/y0)^2) where x0=6.3, y0=4.4.
       (They only use this expansion for rho >= 1, but rho a little less
        than 1 seems okay too.)
       Instead, I did my own fit to a slightly different function
       that avoids the hypotenuse calculation, using NLopt to minimize
       the sum of the squares of the errors in nu with the constraint
       that the estimated nu be >= minimum nu to attain machine precision.
       I also separate the regions where nu == 2 and nu == 1. */
    const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
    double xs = y < 0 ? -creal(z) : creal(z); // compute for -z if y < 0
    if (x + ya > 4000) { // nu <= 2
      if (x + ya > 1e7) { // nu == 1, w(z) = i/sqrt(pi) / z
        // scale to avoid overflow
        if (x > ya) {
          double yax = ya / xs;
          double denom = ispi / (xs + yax*ya);
          ret = C(denom*yax, denom);
        }
        else if (isinf(ya))
          return ((isnan(x) || y < 0)
                  ? C(NaN,NaN) : C(0,0));
        else {
          double xya = xs / ya;
          double denom = ispi / (xya*xs + ya);
          ret = C(denom, denom*xya);
        }
      }
      else { // nu == 2, w(z) = i/sqrt(pi) * z / (z*z - 0.5)
        double dr = xs*xs - ya*ya - 0.5, di = 2*xs*ya;
        double denom = ispi / (dr*dr + di*di);
        ret = C(denom * (xs*di-ya*dr), denom * (xs*dr+ya*di));
      }
    }
    else { // compute nu(z) estimate and do general continued fraction
      const double c0=3.9, c1=11.398, c2=0.08254, c3=0.1421, c4=0.2023; // fit
      double nu = floor(c0 + c1 / (c2*x + c3*ya + c4));
      double wr = xs, wi = ya;
      for (nu = 0.5 * (nu - 1); nu > 0.4; nu -= 0.5) {
        // w <- z - nu/w:
        double denom = nu / (wr*wr + wi*wi);
        wr = xs - wr * denom;
        wi = ya + wi * denom;
      }
      { // w(z) = i/sqrt(pi) / w:
        double denom = ispi / (wr*wr + wi*wi);
        ret = C(denom*wi, denom*wr);
      }
    }
    if (y < 0) {
      // use w(z) = 2.0*exp(-z*z) - w(-z),
      // but be careful of overflow in exp(-z*z)
      //                                = exp(-(xs*xs-ya*ya) -2*i*xs*ya)
      return 2.0*cexp(C((ya-xs)*(xs+ya), 2*xs*y)) - ret;
    }
    else
      return ret;
  }
#else // !USE_CONTINUED_FRACTION
  if (x + ya > 1e7) { // w(z) = i/sqrt(pi) / z, to machine precision
    const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
    double xs = y < 0 ? -creal(z) : creal(z); // compute for -z if y < 0
    // scale to avoid overflow
    if (x > ya) {
      double yax = ya / xs;
      double denom = ispi / (xs + yax*ya);
      ret = C(denom*yax, denom);
    }
    else {
      double xya = xs / ya;
      double denom = ispi / (xya*xs + ya);
      ret = C(denom, denom*xya);
    }
    if (y < 0) {
      // use w(z) = 2.0*exp(-z*z) - w(-z),
      // but be careful of overflow in exp(-z*z)
      //                                = exp(-(xs*xs-ya*ya) -2*i*xs*ya)
      return 2.0*cexp(C((ya-xs)*(xs+ya), 2*xs*y)) - ret;
    }
    else
      return ret;
  }
#endif // !USE_CONTINUED_FRACTION

  /* Note: The test that seems to be suggested in the paper is x <
     sqrt(-log(DBL_MIN)), about 26.6, since otherwise exp(-x^2)
     underflows to zero and sum1,sum2,sum4 are zero.  However, long
     before this occurs, the sum1,sum2,sum4 contributions are
     negligible in double precision; I find that this happens for x >
     about 6, for all y.  On the other hand, I find that the case
     where we compute all of the sums is faster (at least with the
     precomputed expa2n2 table) until about x=10.  Furthermore, if we
     try to compute all of the sums for x > 20, I find that we
     sometimes run into numerical problems because underflow/overflow
     problems start to appear in the various coefficients of the sums,
     below.  Therefore, we use x < 10 here. */
  else if (x < 10) {
    double prod2ax = 1, prodm2ax = 1;
    double expx2;

    if (isnan(y))
      return C(y,y);

    /* Somewhat ugly copy-and-paste duplication here, but I see significant
       speedups from using the special-case code with the precomputed
       exponential, and the x < 5e-4 special case is needed for accuracy. */

    if (relerr == DBL_EPSILON) { // use precomputed exp(-a2*(n*n)) table
      if (x < 5e-4) { // compute sum4 and sum5 together as sum5-sum4
        const double x2 = x*x;
        expx2 = 1 - x2 * (1 - 0.5*x2); // exp(-x*x) via Taylor
        // compute exp(2*a*x) and exp(-2*a*x) via Taylor, to double precision
        const double ax2 = 1.036642960860171859744*x; // 2*a*x
        const double exp2ax =
          1 + ax2 * (1 + ax2 * (0.5 + 0.166666666666666666667*ax2));
        const double expm2ax =
          1 - ax2 * (1 - ax2 * (0.5 - 0.166666666666666666667*ax2));
        for (int n = 1; 1; ++n) {
          const double coef = expa2n2[n-1] * expx2 / (a2*(n*n) + y*y);
          prod2ax *= exp2ax;
          prodm2ax *= expm2ax;
          sum1 += coef;
          sum2 += coef * prodm2ax;
          sum3 += coef * prod2ax;

          // really = sum5 - sum4
          sum5 += coef * (2*a) * n * sinh_taylor((2*a)*n*x);

          // test convergence via sum3
          if (coef * prod2ax < relerr * sum3) break;
        }
      }
      else { // x > 5e-4, compute sum4 and sum5 separately
        expx2 = exp(-x*x);
        const double exp2ax = exp((2*a)*x), expm2ax = 1 / exp2ax;
        for (int n = 1; 1; ++n) {
          const double coef = expa2n2[n-1] * expx2 / (a2*(n*n) + y*y);
          prod2ax *= exp2ax;
          prodm2ax *= expm2ax;
          sum1 += coef;
          sum2 += coef * prodm2ax;
          sum4 += (coef * prodm2ax) * (a*n);
          sum3 += coef * prod2ax;
          sum5 += (coef * prod2ax) * (a*n);
          // test convergence via sum5, since this sum has the slowest decay
          if ((coef * prod2ax) * (a*n) < relerr * sum5) break;
        }
      }
    }
    else { // relerr != DBL_EPSILON, compute exp(-a2*(n*n)) on the fly
      const double exp2ax = exp((2*a)*x), expm2ax = 1 / exp2ax;
      if (x < 5e-4) { // compute sum4 and sum5 together as sum5-sum4
        const double x2 = x*x;
        expx2 = 1 - x2 * (1 - 0.5*x2); // exp(-x*x) via Taylor
        for (int n = 1; 1; ++n) {
          const double coef = exp(-a2*(n*n)) * expx2 / (a2*(n*n) + y*y);
          prod2ax *= exp2ax;
          prodm2ax *= expm2ax;
          sum1 += coef;
          sum2 += coef * prodm2ax;
          sum3 += coef * prod2ax;

          // really = sum5 - sum4
          sum5 += coef * (2*a) * n * sinh_taylor((2*a)*n*x);

          // test convergence via sum3
          if (coef * prod2ax < relerr * sum3) break;
        }
      }
      else { // x > 5e-4, compute sum4 and sum5 separately
        expx2 = exp(-x*x);
        for (int n = 1; 1; ++n) {
          const double coef = exp(-a2*(n*n)) * expx2 / (a2*(n*n) + y*y);
          prod2ax *= exp2ax;
          prodm2ax *= expm2ax;
          sum1 += coef;
          sum2 += coef * prodm2ax;
          sum4 += (coef * prodm2ax) * (a*n);
          sum3 += coef * prod2ax;
          sum5 += (coef * prod2ax) * (a*n);
          // test convergence via sum5, since this sum has the slowest decay
          if ((coef * prod2ax) * (a*n) < relerr * sum5) break;
        }
      }
    }
    const double expx2erfcxy = // avoid spurious overflow for large negative y
      y > -6 // for y < -6, erfcx(y) = 2*exp(y*y) to double precision
      ? expx2*FADDEEVA_RE(erfcx)(y) : 2*exp(y*y-x*x);
    if (y > 5) { // imaginary terms cancel
      const double sinxy = sin(x*y);
      ret = (expx2erfcxy - c*y*sum1) * cos(2*x*y)
        + (c*x*expx2) * sinxy * sinc(x*y, sinxy);
    }
    else {
      double xs = creal(z);
      const double sinxy = sin(xs*y);
      const double sin2xy = sin(2*xs*y), cos2xy = cos(2*xs*y);
      const double coef1 = expx2erfcxy - c*y*sum1;
      const double coef2 = c*xs*expx2;
      ret = C(coef1 * cos2xy + coef2 * sinxy * sinc(xs*y, sinxy),
              coef2 * sinc(2*xs*y, sin2xy) - coef1 * sin2xy);
    }
  }
  else { // x large: only sum3 & sum5 contribute (see above note)
    if (isnan(x))
      return C(x,x);
    if (isnan(y))
      return C(y,y);

#if USE_CONTINUED_FRACTION
    ret = exp(-x*x); // |y| < 1e-10, so we only need exp(-x*x) term
#else
    if (y < 0) {
      /* erfcx(y) ~ 2*exp(y*y) + (< 1) if y < 0, so
         erfcx(y)*exp(-x*x) ~ 2*exp(y*y-x*x) term may not be negligible
         if y*y - x*x > -36 or so.  So, compute this term just in case.
         We also need the -exp(-x*x) term to compute Re[w] accurately
         in the case where y is very small. */
      ret = cpolar(2*exp(y*y-x*x) - exp(-x*x), -2*creal(z)*y);
    }
    else
      ret = exp(-x*x); // not negligible in real part if y very small
#endif
    // (round instead of ceil as in original paper; note that x/a > 1 here)
    double n0 = floor(x/a + 0.5); // sum in both directions, starting at n0
    double dx = a*n0 - x;
    sum3 = exp(-dx*dx) / (a2*(n0*n0) + y*y);
    sum5 = a*n0 * sum3;
    double exp1 = exp(4*a*dx), exp1dn = 1;
    int dn;
    for (dn = 1; n0 - dn > 0; ++dn) { // loop over n0-dn and n0+dn terms
      double np = n0 + dn, nm = n0 - dn;
      double tp = exp(-sqr(a*dn+dx));
      double tm = tp * (exp1dn *= exp1); // trick to get tm from tp
      tp /= (a2*(np*np) + y*y);
      tm /= (a2*(nm*nm) + y*y);
      sum3 += tp + tm;
      sum5 += a * (np * tp + nm * tm);
      if (a * (np * tp + nm * tm) < relerr * sum5) goto finish;
    }
    while (1) { // loop over n0+dn terms only (since n0-dn <= 0)
      double np = n0 + dn++;
      double tp = exp(-sqr(a*dn+dx)) / (a2*(np*np) + y*y);
      sum3 += tp;
      sum5 += a * np * tp;
      if (a * np * tp < relerr * sum5) goto finish;
    }
  }
 finish:
  return ret + C((0.5*c)*y*(sum2+sum3),
                 (0.5*c)*copysign(sum5-sum4, creal(z)));
}

/////////////////////////////////////////////////////////////////////////

/* erfcx(x) = exp(x^2) erfc(x) function, for real x, written by
   Steven G. Johnson, October 2012.

   This function combines a few different ideas.

   First, for x > 50, it uses a continued-fraction expansion (same as
   for the Faddeeva function, but with algebraic simplifications for z=i*x).

   Second, for 0 <= x <= 50, it uses Chebyshev polynomial approximations,
   but with two twists:

      a) It maps x to y = 4 / (4+x) in [0,1].  This simple transformation,
         inspired by a similar transformation in the octave-forge/specfun
         erfcx by Soren Hauberg, results in much faster Chebyshev convergence
         than other simple transformations I have examined.

      b) Instead of using a single Chebyshev polynomial for the entire
         [0,1] y interval, we break the interval up into 100 equal
         subintervals, with a switch/lookup table, and use much lower
         degree Chebyshev polynomials in each subinterval. This greatly
         improves performance in my tests.

   For x < 0, we use the relationship erfcx(-x) = 2 exp(x^2) - erfc(x),
   with the usual checks for overflow etcetera.

   Performance-wise, it seems to be substantially faster than either
   the SLATEC DERFC function [or an erfcx function derived therefrom]
   or Cody's CALERF function (from netlib.org/specfun), while
   retaining near machine precision in accuracy.  */

/* Given y100=100*y, where y = 4/(4+x) for x >= 0, compute erfc(x).

   Uses a look-up table of 100 different Chebyshev polynomials
   for y intervals [0,0.01], [0.01,0.02], ...., [0.99,1], generated
   with the help of Maple and a little shell script.   This allows
   the Chebyshev polynomials to be of significantly lower degree (about 1/4)
   compared to fitting the whole [0,1] interval with a single polynomial. */
static double erfcx_y100(double y100)
{
  switch ((int) y100) {
case 0: {
double t = 2*y100 - 1;
return 0.70878032454106438663e-3 + (0.71234091047026302958e-3 + (0.35779077297597742384e-5 + (0.17403143962587937815e-7 + (0.81710660047307788845e-10 + (0.36885022360434957634e-12 + 0.15917038551111111111e-14 * t) * t) * t) * t) * t) * t;
}
case 1: {
double t = 2*y100 - 3;
return 0.21479143208285144230e-2 + (0.72686402367379996033e-3 + (0.36843175430938995552e-5 + (0.18071841272149201685e-7 + (0.85496449296040325555e-10 + (0.38852037518534291510e-12 + 0.16868473576888888889e-14 * t) * t) * t) * t) * t) * t;
}
case 2: {
double t = 2*y100 - 5;
return 0.36165255935630175090e-2 + (0.74182092323555510862e-3 + (0.37948319957528242260e-5 + (0.18771627021793087350e-7 + (0.89484715122415089123e-10 + (0.40935858517772440862e-12 + 0.17872061464888888889e-14 * t) * t) * t) * t) * t) * t;
}
case 3: {
double t = 2*y100 - 7;
return 0.51154983860031979264e-2 + (0.75722840734791660540e-3 + (0.39096425726735703941e-5 + (0.19504168704300468210e-7 + (0.93687503063178993915e-10 + (0.43143925959079664747e-12 + 0.18939926435555555556e-14 * t) * t) * t) * t) * t) * t;
}
case 4: {
double t = 2*y100 - 9;
return 0.66457513172673049824e-2 + (0.77310406054447454920e-3 + (0.40289510589399439385e-5 + (0.20271233238288381092e-7 + (0.98117631321709100264e-10 + (0.45484207406017752971e-12 + 0.20076352213333333333e-14 * t) * t) * t) * t) * t) * t;
}
case 5: {
double t = 2*y100 - 11;
return 0.82082389970241207883e-2 + (0.78946629611881710721e-3 + (0.41529701552622656574e-5 + (0.21074693344544655714e-7 + (0.10278874108587317989e-9 + (0.47965201390613339638e-12 + 0.21285907413333333333e-14 * t) * t) * t) * t) * t) * t;
}
case 6: {
double t = 2*y100 - 13;
return 0.98039537275352193165e-2 + (0.80633440108342840956e-3 + (0.42819241329736982942e-5 + (0.21916534346907168612e-7 + (0.10771535136565470914e-9 + (0.50595972623692822410e-12 + 0.22573462684444444444e-14 * t) * t) * t) * t) * t) * t;
}
case 7: {
double t = 2*y100 - 15;
return 0.11433927298290302370e-1 + (0.82372858383196561209e-3 + (0.44160495311765438816e-5 + (0.22798861426211986056e-7 + (0.11291291745879239736e-9 + (0.53386189365816880454e-12 + 0.23944209546666666667e-14 * t) * t) * t) * t) * t) * t;
}
case 8: {
double t = 2*y100 - 17;
return 0.13099232878814653979e-1 + (0.84167002467906968214e-3 + (0.45555958988457506002e-5 + (0.23723907357214175198e-7 + (0.11839789326602695603e-9 + (0.56346163067550237877e-12 + 0.25403679644444444444e-14 * t) * t) * t) * t) * t) * t;
}
case 9: {
double t = 2*y100 - 19;
return 0.14800987015587535621e-1 + (0.86018092946345943214e-3 + (0.47008265848816866105e-5 + (0.24694040760197315333e-7 + (0.12418779768752299093e-9 + (0.59486890370320261949e-12 + 0.26957764568888888889e-14 * t) * t) * t) * t) * t) * t;
}
case 10: {
double t = 2*y100 - 21;
return 0.16540351739394069380e-1 + (0.87928458641241463952e-3 + (0.48520195793001753903e-5 + (0.25711774900881709176e-7 + (0.13030128534230822419e-9 + (0.62820097586874779402e-12 + 0.28612737351111111111e-14 * t) * t) * t) * t) * t) * t;
}
case 11: {
double t = 2*y100 - 23;
return 0.18318536789842392647e-1 + (0.89900542647891721692e-3 + (0.50094684089553365810e-5 + (0.26779777074218070482e-7 + (0.13675822186304615566e-9 + (0.66358287745352705725e-12 + 0.30375273884444444444e-14 * t) * t) * t) * t) * t) * t;
}
case 12: {
double t = 2*y100 - 25;
return 0.20136801964214276775e-1 + (0.91936908737673676012e-3 + (0.51734830914104276820e-5 + (0.27900878609710432673e-7 + (0.14357976402809042257e-9 + (0.70114790311043728387e-12 + 0.32252476000000000000e-14 * t) * t) * t) * t) * t) * t;
}
case 13: {
double t = 2*y100 - 27;
return 0.21996459598282740954e-1 + (0.94040248155366777784e-3 + (0.53443911508041164739e-5 + (0.29078085538049374673e-7 + (0.15078844500329731137e-9 + (0.74103813647499204269e-12 + 0.34251892320000000000e-14 * t) * t) * t) * t) * t) * t;
}
case 14: {
double t = 2*y100 - 29;
return 0.23898877187226319502e-1 + (0.96213386835900177540e-3 + (0.55225386998049012752e-5 + (0.30314589961047687059e-7 + (0.15840826497296335264e-9 + (0.78340500472414454395e-12 + 0.36381553564444444445e-14 * t) * t) * t) * t) * t) * t;
}
case 15: {
double t = 2*y100 - 31;
return 0.25845480155298518485e-1 + (0.98459293067820123389e-3 + (0.57082915920051843672e-5 + (0.31613782169164830118e-7 + (0.16646478745529630813e-9 + (0.82840985928785407942e-12 + 0.38649975768888888890e-14 * t) * t) * t) * t) * t) * t;
}
case 16: {
double t = 2*y100 - 33;
return 0.27837754783474696598e-1 + (0.10078108563256892757e-2 + (0.59020366493792212221e-5 + (0.32979263553246520417e-7 + (0.17498524159268458073e-9 + (0.87622459124842525110e-12 + 0.41066206488888888890e-14 * t) * t) * t) * t) * t) * t;
}
case 17: {
double t = 2*y100 - 35;
return 0.29877251304899307550e-1 + (0.10318204245057349310e-2 + (0.61041829697162055093e-5 + (0.34414860359542720579e-7 + (0.18399863072934089607e-9 + (0.92703227366365046533e-12 + 0.43639844053333333334e-14 * t) * t) * t) * t) * t) * t;
}
case 18: {
double t = 2*y100 - 37;
return 0.31965587178596443475e-1 + (0.10566560976716574401e-2 + (0.63151633192414586770e-5 + (0.35924638339521924242e-7 + (0.19353584758781174038e-9 + (0.98102783859889264382e-12 + 0.46381060817777777779e-14 * t) * t) * t) * t) * t) * t;
}
case 19: {
double t = 2*y100 - 39;
return 0.34104450552588334840e-1 + (0.10823541191350532574e-2 + (0.65354356159553934436e-5 + (0.37512918348533521149e-7 + (0.20362979635817883229e-9 + (0.10384187833037282363e-11 + 0.49300625262222222221e-14 * t) * t) * t) * t) * t) * t;
}
case 20: {
double t = 2*y100 - 41;
return 0.36295603928292425716e-1 + (0.11089526167995268200e-2 + (0.67654845095518363577e-5 + (0.39184292949913591646e-7 + (0.21431552202133775150e-9 + (0.10994259106646731797e-11 + 0.52409949102222222221e-14 * t) * t) * t) * t) * t) * t;
}
case 21: {
double t = 2*y100 - 43;
return 0.38540888038840509795e-1 + (0.11364917134175420009e-2 + (0.70058230641246312003e-5 + (0.40943644083718586939e-7 + (0.22563034723692881631e-9 + (0.11642841011361992885e-11 + 0.55721092871111111110e-14 * t) * t) * t) * t) * t) * t;
}
case 22: {
double t = 2*y100 - 45;
return 0.40842225954785960651e-1 + (0.11650136437945673891e-2 + (0.72569945502343006619e-5 + (0.42796161861855042273e-7 + (0.23761401711005024162e-9 + (0.12332431172381557035e-11 + 0.59246802364444444445e-14 * t) * t) * t) * t) * t) * t;
}
case 23: {
double t = 2*y100 - 47;
return 0.43201627431540222422e-1 + (0.11945628793917272199e-2 + (0.75195743532849206263e-5 + (0.44747364553960993492e-7 + (0.25030885216472953674e-9 + (0.13065684400300476484e-11 + 0.63000532853333333334e-14 * t) * t) * t) * t) * t) * t;
}
case 24: {
double t = 2*y100 - 49;
return 0.45621193513810471438e-1 + (0.12251862608067529503e-2 + (0.77941720055551920319e-5 + (0.46803119830954460212e-7 + (0.26375990983978426273e-9 + (0.13845421370977119765e-11 + 0.66996477404444444445e-14 * t) * t) * t) * t) * t) * t;
}
case 25: {
double t = 2*y100 - 51;
return 0.48103121413299865517e-1 + (0.12569331386432195113e-2 + (0.80814333496367673980e-5 + (0.48969667335682018324e-7 + (0.27801515481905748484e-9 + (0.14674637611609884208e-11 + 0.71249589351111111110e-14 * t) * t) * t) * t) * t) * t;
}
case 26: {
double t = 2*y100 - 53;
return 0.50649709676983338501e-1 + (0.12898555233099055810e-2 + (0.83820428414568799654e-5 + (0.51253642652551838659e-7 + (0.29312563849675507232e-9 + (0.15556512782814827846e-11 + 0.75775607822222222221e-14 * t) * t) * t) * t) * t) * t;
}
case 27: {
double t = 2*y100 - 55;
return 0.53263363664388864181e-1 + (0.13240082443256975769e-2 + (0.86967260015007658418e-5 + (0.53662102750396795566e-7 + (0.30914568786634796807e-9 + (0.16494420240828493176e-11 + 0.80591079644444444445e-14 * t) * t) * t) * t) * t) * t;
}
case 28: {
double t = 2*y100 - 57;
return 0.55946601353500013794e-1 + (0.13594491197408190706e-2 + (0.90262520233016380987e-5 + (0.56202552975056695376e-7 + (0.32613310410503135996e-9 + (0.17491936862246367398e-11 + 0.85713381688888888890e-14 * t) * t) * t) * t) * t) * t;
}
case 29: {
double t = 2*y100 - 59;
return 0.58702059496154081813e-1 + (0.13962391363223647892e-2 + (0.93714365487312784270e-5 + (0.58882975670265286526e-7 + (0.34414937110591753387e-9 + (0.18552853109751857859e-11 + 0.91160736711111111110e-14 * t) * t) * t) * t) * t) * t;
}
case 30: {
double t = 2*y100 - 61;
return 0.61532500145144778048e-1 + (0.14344426411912015247e-2 + (0.97331446201016809696e-5 + (0.61711860507347175097e-7 + (0.36325987418295300221e-9 + (0.19681183310134518232e-11 + 0.96952238400000000000e-14 * t) * t) * t) * t) * t) * t;
}
case 31: {
double t = 2*y100 - 63;
return 0.64440817576653297993e-1 + (0.14741275456383131151e-2 + (0.10112293819576437838e-4 + (0.64698236605933246196e-7 + (0.38353412915303665586e-9 + (0.20881176114385120186e-11 + 0.10310784480000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 32: {
double t = 2*y100 - 65;
return 0.67430045633130393282e-1 + (0.15153655418916540370e-2 + (0.10509857606888328667e-4 + (0.67851706529363332855e-7 + (0.40504602194811140006e-9 + (0.22157325110542534469e-11 + 0.10964842115555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 33: {
double t = 2*y100 - 67;
return 0.70503365513338850709e-1 + (0.15582323336495709827e-2 + (0.10926868866865231089e-4 + (0.71182482239613507542e-7 + (0.42787405890153386710e-9 + (0.23514379522274416437e-11 + 0.11659571751111111111e-13 * t) * t) * t) * t) * t) * t;
}
case 34: {
double t = 2*y100 - 69;
return 0.73664114037944596353e-1 + (0.16028078812438820413e-2 + (0.11364423678778207991e-4 + (0.74701423097423182009e-7 + (0.45210162777476488324e-9 + (0.24957355004088569134e-11 + 0.12397238257777777778e-13 * t) * t) * t) * t) * t) * t;
}
case 35: {
double t = 2*y100 - 71;
return 0.76915792420819562379e-1 + (0.16491766623447889354e-2 + (0.11823685320041302169e-4 + (0.78420075993781544386e-7 + (0.47781726956916478925e-9 + (0.26491544403815724749e-11 + 0.13180196462222222222e-13 * t) * t) * t) * t) * t) * t;
}
case 36: {
double t = 2*y100 - 73;
return 0.80262075578094612819e-1 + (0.16974279491709504117e-2 + (0.12305888517309891674e-4 + (0.82350717698979042290e-7 + (0.50511496109857113929e-9 + (0.28122528497626897696e-11 + 0.14010889635555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 37: {
double t = 2*y100 - 75;
return 0.83706822008980357446e-1 + (0.17476561032212656962e-2 + (0.12812343958540763368e-4 + (0.86506399515036435592e-7 + (0.53409440823869467453e-9 + (0.29856186620887555043e-11 + 0.14891851591111111111e-13 * t) * t) * t) * t) * t) * t;
}
case 38: {
double t = 2*y100 - 77;
return 0.87254084284461718231e-1 + (0.17999608886001962327e-2 + (0.13344443080089492218e-4 + (0.90900994316429008631e-7 + (0.56486134972616465316e-9 + (0.31698707080033956934e-11 + 0.15825697795555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 39: {
double t = 2*y100 - 79;
return 0.90908120182172748487e-1 + (0.18544478050657699758e-2 + (0.13903663143426120077e-4 + (0.95549246062549906177e-7 + (0.59752787125242054315e-9 + (0.33656597366099099413e-11 + 0.16815130613333333333e-13 * t) * t) * t) * t) * t) * t;
}
case 40: {
double t = 2*y100 - 81;
return 0.94673404508075481121e-1 + (0.19112284419887303347e-2 + (0.14491572616545004930e-4 + (0.10046682186333613697e-6 + (0.63221272959791000515e-9 + (0.35736693975589130818e-11 + 0.17862931591111111111e-13 * t) * t) * t) * t) * t) * t;
}
case 41: {
double t = 2*y100 - 83;
return 0.98554641648004456555e-1 + (0.19704208544725622126e-2 + (0.15109836875625443935e-4 + (0.10567036667675984067e-6 + (0.66904168640019354565e-9 + (0.37946171850824333014e-11 + 0.18971959040000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 42: {
double t = 2*y100 - 85;
return 0.10255677889470089531e0 + (0.20321499629472857418e-2 + (0.15760224242962179564e-4 + (0.11117756071353507391e-6 + (0.70814785110097658502e-9 + (0.40292553276632563925e-11 + 0.20145143075555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 43: {
double t = 2*y100 - 87;
return 0.10668502059865093318e0 + (0.20965479776148731610e-2 + (0.16444612377624983565e-4 + (0.11700717962026152749e-6 + (0.74967203250938418991e-9 + (0.42783716186085922176e-11 + 0.21385479360000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 44: {
double t = 2*y100 - 89;
return 0.11094484319386444474e0 + (0.21637548491908170841e-2 + (0.17164995035719657111e-4 + (0.12317915750735938089e-6 + (0.79376309831499633734e-9 + (0.45427901763106353914e-11 + 0.22696025653333333333e-13 * t) * t) * t) * t) * t) * t;
}
case 45: {
double t = 2*y100 - 91;
return 0.11534201115268804714e0 + (0.22339187474546420375e-2 + (0.17923489217504226813e-4 + (0.12971465288245997681e-6 + (0.84057834180389073587e-9 + (0.48233721206418027227e-11 + 0.24079890062222222222e-13 * t) * t) * t) * t) * t) * t;
}
case 46: {
double t = 2*y100 - 93;
return 0.11988259392684094740e0 + (0.23071965691918689601e-2 + (0.18722342718958935446e-4 + (0.13663611754337957520e-6 + (0.89028385488493287005e-9 + (0.51210161569225846701e-11 + 0.25540227111111111111e-13 * t) * t) * t) * t) * t) * t;
}
case 47: {
double t = 2*y100 - 95;
return 0.12457298393509812907e0 + (0.23837544771809575380e-2 + (0.19563942105711612475e-4 + (0.14396736847739470782e-6 + (0.94305490646459247016e-9 + (0.54366590583134218096e-11 + 0.27080225920000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 48: {
double t = 2*y100 - 97;
return 0.12941991566142438816e0 + (0.24637684719508859484e-2 + (0.20450821127475879816e-4 + (0.15173366280523906622e-6 + (0.99907632506389027739e-9 + (0.57712760311351625221e-11 + 0.28703099555555555556e-13 * t) * t) * t) * t) * t) * t;
}
case 49: {
double t = 2*y100 - 99;
return 0.13443048593088696613e0 + (0.25474249981080823877e-2 + (0.21385669591362915223e-4 + (0.15996177579900443030e-6 + (0.10585428844575134013e-8 + (0.61258809536787882989e-11 + 0.30412080142222222222e-13 * t) * t) * t) * t) * t) * t;
}
case 50: {
double t = 2*y100 - 101;
return 0.13961217543434561353e0 + (0.26349215871051761416e-2 + (0.22371342712572567744e-4 + (0.16868008199296822247e-6 + (0.11216596910444996246e-8 + (0.65015264753090890662e-11 + 0.32210394506666666666e-13 * t) * t) * t) * t) * t) * t;
}
case 51: {
double t = 2*y100 - 103;
return 0.14497287157673800690e0 + (0.27264675383982439814e-2 + (0.23410870961050950197e-4 + (0.17791863939526376477e-6 + (0.11886425714330958106e-8 + (0.68993039665054288034e-11 + 0.34101266222222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 52: {
double t = 2*y100 - 105;
return 0.15052089272774618151e0 + (0.28222846410136238008e-2 + (0.24507470422713397006e-4 + (0.18770927679626136909e-6 + (0.12597184587583370712e-8 + (0.73203433049229821618e-11 + 0.36087889048888888890e-13 * t) * t) * t) * t) * t) * t;
}
case 53: {
double t = 2*y100 - 107;
return 0.15626501395774612325e0 + (0.29226079376196624949e-2 + (0.25664553693768450545e-4 + (0.19808568415654461964e-6 + (0.13351257759815557897e-8 + (0.77658124891046760667e-11 + 0.38173420035555555555e-13 * t) * t) * t) * t) * t) * t;
}
case 54: {
double t = 2*y100 - 109;
return 0.16221449434620737567e0 + (0.30276865332726475672e-2 + (0.26885741326534564336e-4 + (0.20908350604346384143e-6 + (0.14151148144240728728e-8 + (0.82369170665974313027e-11 + 0.40360957457777777779e-13 * t) * t) * t) * t) * t) * t;
}
case 55: {
double t = 2*y100 - 111;
return 0.16837910595412130659e0 + (0.31377844510793082301e-2 + (0.28174873844911175026e-4 + (0.22074043807045782387e-6 + (0.14999481055996090039e-8 + (0.87348993661930809254e-11 + 0.42653528977777777779e-13 * t) * t) * t) * t) * t) * t;
}
case 56: {
double t = 2*y100 - 113;
return 0.17476916455659369953e0 + (0.32531815370903068316e-2 + (0.29536024347344364074e-4 + (0.23309632627767074202e-6 + (0.15899007843582444846e-8 + (0.92610375235427359475e-11 + 0.45054073102222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 57: {
double t = 2*y100 - 115;
return 0.18139556223643701364e0 + (0.33741744168096996041e-2 + (0.30973511714709500836e-4 + (0.24619326937592290996e-6 + (0.16852609412267750744e-8 + (0.98166442942854895573e-11 + 0.47565418097777777779e-13 * t) * t) * t) * t) * t) * t;
}
case 58: {
double t = 2*y100 - 117;
return 0.18826980194443664549e0 + (0.35010775057740317997e-2 + (0.32491914440014267480e-4 + (0.26007572375886319028e-6 + (0.17863299617388376116e-8 + (0.10403065638343878679e-10 + 0.50190265831111111110e-13 * t) * t) * t) * t) * t) * t;
}
case 59: {
double t = 2*y100 - 119;
return 0.19540403413693967350e0 + (0.36342240767211326315e-2 + (0.34096085096200907289e-4 + (0.27479061117017637474e-6 + (0.18934228504790032826e-8 + (0.11021679075323598664e-10 + 0.52931171733333333334e-13 * t) * t) * t) * t) * t) * t;
}
case 60: {
double t = 2*y100 - 121;
return 0.20281109560651886959e0 + (0.37739673859323597060e-2 + (0.35791165457592409054e-4 + (0.29038742889416172404e-6 + (0.20068685374849001770e-8 + (0.11673891799578381999e-10 + 0.55790523093333333334e-13 * t) * t) * t) * t) * t) * t;
}
case 61: {
double t = 2*y100 - 123;
return 0.21050455062669334978e0 + (0.39206818613925652425e-2 + (0.37582602289680101704e-4 + (0.30691836231886877385e-6 + (0.21270101645763677824e-8 + (0.12361138551062899455e-10 + 0.58770520160000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 62: {
double t = 2*y100 - 125;
return 0.21849873453703332479e0 + (0.40747643554689586041e-2 + (0.39476163820986711501e-4 + (0.32443839970139918836e-6 + (0.22542053491518680200e-8 + (0.13084879235290858490e-10 + 0.61873153262222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 63: {
double t = 2*y100 - 127;
return 0.22680879990043229327e0 + (0.42366354648628516935e-2 + (0.41477956909656896779e-4 + (0.34300544894502810002e-6 + (0.23888264229264067658e-8 + (0.13846596292818514601e-10 + 0.65100183751111111110e-13 * t) * t) * t) * t) * t) * t;
}
case 64: {
double t = 2*y100 - 129;
return 0.23545076536988703937e0 + (0.44067409206365170888e-2 + (0.43594444916224700881e-4 + (0.36268045617760415178e-6 + (0.25312606430853202748e-8 + (0.14647791812837903061e-10 + 0.68453122631111111110e-13 * t) * t) * t) * t) * t) * t;
}
case 65: {
double t = 2*y100 - 131;
return 0.24444156740777432838e0 + (0.45855530511605787178e-2 + (0.45832466292683085475e-4 + (0.38352752590033030472e-6 + (0.26819103733055603460e-8 + (0.15489984390884756993e-10 + 0.71933206364444444445e-13 * t) * t) * t) * t) * t) * t;
}
case 66: {
double t = 2*y100 - 133;
return 0.25379911500634264643e0 + (0.47735723208650032167e-2 + (0.48199253896534185372e-4 + (0.40561404245564732314e-6 + (0.28411932320871165585e-8 + (0.16374705736458320149e-10 + 0.75541379822222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 67: {
double t = 2*y100 - 135;
return 0.26354234756393613032e0 + (0.49713289477083781266e-2 + (0.50702455036930367504e-4 + (0.42901079254268185722e-6 + (0.30095422058900481753e-8 + (0.17303497025347342498e-10 + 0.79278273368888888890e-13 * t) * t) * t) * t) * t) * t;
}
case 68: {
double t = 2*y100 - 137;
return 0.27369129607732343398e0 + (0.51793846023052643767e-2 + (0.53350152258326602629e-4 + (0.45379208848865015485e-6 + (0.31874057245814381257e-8 + (0.18277905010245111046e-10 + 0.83144182364444444445e-13 * t) * t) * t) * t) * t) * t;
}
case 69: {
double t = 2*y100 - 139;
return 0.28426714781640316172e0 + (0.53983341916695141966e-2 + (0.56150884865255810638e-4 + (0.48003589196494734238e-6 + (0.33752476967570796349e-8 + (0.19299477888083469086e-10 + 0.87139049137777777779e-13 * t) * t) * t) * t) * t) * t;
}
case 70: {
double t = 2*y100 - 141;
return 0.29529231465348519920e0 + (0.56288077305420795663e-2 + (0.59113671189913307427e-4 + (0.50782393781744840482e-6 + (0.35735475025851713168e-8 + (0.20369760937017070382e-10 + 0.91262442613333333334e-13 * t) * t) * t) * t) * t) * t;
}
case 71: {
double t = 2*y100 - 143;
return 0.30679050522528838613e0 + (0.58714723032745403331e-2 + (0.62248031602197686791e-4 + (0.53724185766200945789e-6 + (0.37827999418960232678e-8 + (0.21490291930444538307e-10 + 0.95513539182222222221e-13 * t) * t) * t) * t) * t) * t;
}
case 72: {
double t = 2*y100 - 145;
return 0.31878680111173319425e0 + (0.61270341192339103514e-2 + (0.65564012259707640976e-4 + (0.56837930287837738996e-6 + (0.40035151353392378882e-8 + (0.22662596341239294792e-10 + 0.99891109760000000000e-13 * t) * t) * t) * t) * t) * t;
}
case 73: {
double t = 2*y100 - 147;
return 0.33130773722152622027e0 + (0.63962406646798080903e-2 + (0.69072209592942396666e-4 + (0.60133006661885941812e-6 + (0.42362183765883466691e-8 + (0.23888182347073698382e-10 + 0.10439349811555555556e-12 * t) * t) * t) * t) * t) * t;
}
case 74: {
double t = 2*y100 - 149;
return 0.34438138658041336523e0 + (0.66798829540414007258e-2 + (0.72783795518603561144e-4 + (0.63619220443228800680e-6 + (0.44814499336514453364e-8 + (0.25168535651285475274e-10 + 0.10901861383111111111e-12 * t) * t) * t) * t) * t) * t;
}
case 75: {
double t = 2*y100 - 151;
return 0.35803744972380175583e0 + (0.69787978834882685031e-2 + (0.76710543371454822497e-4 + (0.67306815308917386747e-6 + (0.47397647975845228205e-8 + (0.26505114141143050509e-10 + 0.11376390933333333333e-12 * t) * t) * t) * t) * t) * t;
}
case 76: {
double t = 2*y100 - 153;
return 0.37230734890119724188e0 + (0.72938706896461381003e-2 + (0.80864854542670714092e-4 + (0.71206484718062688779e-6 + (0.50117323769745883805e-8 + (0.27899342394100074165e-10 + 0.11862637614222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 77: {
double t = 2*y100 - 155;
return 0.38722432730555448223e0 + (0.76260375162549802745e-2 + (0.85259785810004603848e-4 + (0.75329383305171327677e-6 + (0.52979361368388119355e-8 + (0.29352606054164086709e-10 + 0.12360253370666666667e-12 * t) * t) * t) * t) * t) * t;
}
case 78: {
double t = 2*y100 - 157;
return 0.40282355354616940667e0 + (0.79762880915029728079e-2 + (0.89909077342438246452e-4 + (0.79687137961956194579e-6 + (0.55989731807360403195e-8 + (0.30866246101464869050e-10 + 0.12868841946666666667e-12 * t) * t) * t) * t) * t) * t;
}
case 79: {
double t = 2*y100 - 159;
return 0.41914223158913787649e0 + (0.83456685186950463538e-2 + (0.94827181359250161335e-4 + (0.84291858561783141014e-6 + (0.59154537751083485684e-8 + (0.32441553034347469291e-10 + 0.13387957943111111111e-12 * t) * t) * t) * t) * t) * t;
}
case 80: {
double t = 2*y100 - 161;
return 0.43621971639463786896e0 + (0.87352841828289495773e-2 + (0.10002929142066799966e-3 + (0.89156148280219880024e-6 + (0.62480008150788597147e-8 + (0.34079760983458878910e-10 + 0.13917107176888888889e-12 * t) * t) * t) * t) * t) * t;
}
case 81: {
double t = 2*y100 - 163;
return 0.45409763548534330981e0 + (0.91463027755548240654e-2 + (0.10553137232446167258e-3 + (0.94293113464638623798e-6 + (0.65972492312219959885e-8 + (0.35782041795476563662e-10 + 0.14455745872000000000e-12 * t) * t) * t) * t) * t) * t;
}
case 82: {
double t = 2*y100 - 165;
return 0.47282001668512331468e0 + (0.95799574408860463394e-2 + (0.11135019058000067469e-3 + (0.99716373005509038080e-6 + (0.69638453369956970347e-8 + (0.37549499088161345850e-10 + 0.15003280712888888889e-12 * t) * t) * t) * t) * t) * t;
}
case 83: {
double t = 2*y100 - 167;
return 0.49243342227179841649e0 + (0.10037550043909497071e-1 + (0.11750334542845234952e-3 + (0.10544006716188967172e-5 + (0.73484461168242224872e-8 + (0.39383162326435752965e-10 + 0.15559069118222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 84: {
double t = 2*y100 - 169;
return 0.51298708979209258326e0 + (0.10520454564612427224e-1 + (0.12400930037494996655e-3 + (0.11147886579371265246e-5 + (0.77517184550568711454e-8 + (0.41283980931872622611e-10 + 0.16122419680000000000e-12 * t) * t) * t) * t) * t) * t;
}
case 85: {
double t = 2*y100 - 171;
return 0.53453307979101369843e0 + (0.11030120618800726938e-1 + (0.13088741519572269581e-3 + (0.11784797595374515432e-5 + (0.81743383063044825400e-8 + (0.43252818449517081051e-10 + 0.16692592640000000000e-12 * t) * t) * t) * t) * t) * t;
}
case 86: {
double t = 2*y100 - 173;
return 0.55712643071169299478e0 + (0.11568077107929735233e-1 + (0.13815797838036651289e-3 + (0.12456314879260904558e-5 + (0.86169898078969313597e-8 + (0.45290446811539652525e-10 + 0.17268801084444444444e-12 * t) * t) * t) * t) * t) * t;
}
case 87: {
double t = 2*y100 - 175;
return 0.58082532122519320968e0 + (0.12135935999503877077e-1 + (0.14584223996665838559e-3 + (0.13164068573095710742e-5 + (0.90803643355106020163e-8 + (0.47397540713124619155e-10 + 0.17850211608888888889e-12 * t) * t) * t) * t) * t) * t;
}
case 88: {
double t = 2*y100 - 177;
return 0.60569124025293375554e0 + (0.12735396239525550361e-1 + (0.15396244472258863344e-3 + (0.13909744385382818253e-5 + (0.95651595032306228245e-8 + (0.49574672127669041550e-10 + 0.18435945564444444444e-12 * t) * t) * t) * t) * t) * t;
}
case 89: {
double t = 2*y100 - 179;
return 0.63178916494715716894e0 + (0.13368247798287030927e-1 + (0.16254186562762076141e-3 + (0.14695084048334056083e-5 + (0.10072078109604152350e-7 + (0.51822304995680707483e-10 + 0.19025081422222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 90: {
double t = 2*y100 - 181;
return 0.65918774689725319200e0 + (0.14036375850601992063e-1 + (0.17160483760259706354e-3 + (0.15521885688723188371e-5 + (0.10601827031535280590e-7 + (0.54140790105837520499e-10 + 0.19616655146666666667e-12 * t) * t) * t) * t) * t) * t;
}
case 91: {
double t = 2*y100 - 183;
return 0.68795950683174433822e0 + (0.14741765091365869084e-1 + (0.18117679143520433835e-3 + (0.16392004108230585213e-5 + (0.11155116068018043001e-7 + (0.56530360194925690374e-10 + 0.20209663662222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 92: {
double t = 2*y100 - 185;
return 0.71818103808729967036e0 + (0.15486504187117112279e-1 + (0.19128428784550923217e-3 + (0.17307350969359975848e-5 + (0.11732656736113607751e-7 + (0.58991125287563833603e-10 + 0.20803065333333333333e-12 * t) * t) * t) * t) * t) * t;
}
case 93: {
double t = 2*y100 - 187;
return 0.74993321911726254661e0 + (0.16272790364044783382e-1 + (0.20195505163377912645e-3 + (0.18269894883203346953e-5 + (0.12335161021630225535e-7 + (0.61523068312169087227e-10 + 0.21395783431111111111e-12 * t) * t) * t) * t) * t) * t;
}
case 94: {
double t = 2*y100 - 189;
return 0.78330143531283492729e0 + (0.17102934132652429240e-1 + (0.21321800585063327041e-3 + (0.19281661395543913713e-5 + (0.12963340087354341574e-7 + (0.64126040998066348872e-10 + 0.21986708942222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 95: {
double t = 2*y100 - 191;
return 0.81837581041023811832e0 + (0.17979364149044223802e-1 + (0.22510330592753129006e-3 + (0.20344732868018175389e-5 + (0.13617902941839949718e-7 + (0.66799760083972474642e-10 + 0.22574701262222222222e-12 * t) * t) * t) * t) * t) * t;
}
case 96: {
double t = 2*y100 - 193;
return 0.85525144775685126237e0 + (0.18904632212547561026e-1 + (0.23764237370371255638e-3 + (0.21461248251306387979e-5 + (0.14299555071870523786e-7 + (0.69543803864694171934e-10 + 0.23158593688888888889e-12 * t) * t) * t) * t) * t) * t;
}
case 97: {
double t = 2*y100 - 195;
return 0.89402868170849933734e0 + (0.19881418399127202569e-1 + (0.25086793128395995798e-3 + (0.22633402747585233180e-5 + (0.15008997042116532283e-7 + (0.72357609075043941261e-10 + 0.23737194737777777778e-12 * t) * t) * t) * t) * t) * t;
}
case 98: {
double t = 2*y100 - 197;
return 0.93481333942870796363e0 + (0.20912536329780368893e-1 + (0.26481403465998477969e-3 + (0.23863447359754921676e-5 + (0.15746923065472184451e-7 + (0.75240468141720143653e-10 + 0.24309291271111111111e-12 * t) * t) * t) * t) * t) * t;
}
case 99: {
double t = 2*y100 - 199;
return 0.97771701335885035464e0 + (0.22000938572830479551e-1 + (0.27951610702682383001e-3 + (0.25153688325245314530e-5 + (0.16514019547822821453e-7 + (0.78191526829368231251e-10 + 0.24873652355555555556e-12 * t) * t) * t) * t) * t) * t;
}
  }
  // we only get here if y = 1, i.e. |x| < 4*eps, in which case
  // erfcx is within 1e-15 of 1..
  return 1.0;
}

double FADDEEVA_RE(erfcx)(double x)
{
  if (x >= 0) {
    if (x > 50) { // continued-fraction expansion is faster
      const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
      if (x > 5e7) // 1-term expansion, important to avoid overflow
        return ispi / x;
      /* 5-term expansion (rely on compiler for CSE), simplified from:
                ispi / (x+0.5/(x+1/(x+1.5/(x+2/x))))  */
      return ispi*((x*x) * (x*x+4.5) + 2) / (x * ((x*x) * (x*x+5) + 3.75));
    }
    return erfcx_y100(400/(4+x));
  }
  else
    return x < -26.7 ? HUGE_VAL : (x < -6.1 ? 2*exp(x*x)
                                   : 2*exp(x*x) - erfcx_y100(400/(4-x)));
}

/////////////////////////////////////////////////////////////////////////
/* Compute a scaled Dawson integral
            FADDEEVA(w_im)(x) = 2*Dawson(x)/sqrt(pi)
   equivalent to the imaginary part w(x) for real x.

   Uses methods similar to the erfcx calculation above: continued fractions
   for large |x|, a lookup table of Chebyshev polynomials for smaller |x|,
   and finally a Taylor expansion for |x|<0.01.

   Steven G. Johnson, October 2012. */

/* Given y100=100*y, where y = 1/(1+x) for x >= 0, compute w_im(x).

   Uses a look-up table of 100 different Chebyshev polynomials
   for y intervals [0,0.01], [0.01,0.02], ...., [0.99,1], generated
   with the help of Maple and a little shell script.   This allows
   the Chebyshev polynomials to be of significantly lower degree (about 1/30)
   compared to fitting the whole [0,1] interval with a single polynomial. */
static double w_im_y100(double y100, double x) {
  switch ((int) y100) {
    case 0: {
      double t = 2*y100 - 1;
      return 0.28351593328822191546e-2 + (0.28494783221378400759e-2 + (0.14427470563276734183e-4 + (0.10939723080231588129e-6 + (0.92474307943275042045e-9 + (0.89128907666450075245e-11 + 0.92974121935111111110e-13 * t) * t) * t) * t) * t) * t;
    }
    case 1: {
      double t = 2*y100 - 3;
      return 0.85927161243940350562e-2 + (0.29085312941641339862e-2 + (0.15106783707725582090e-4 + (0.11716709978531327367e-6 + (0.10197387816021040024e-8 + (0.10122678863073360769e-10 + 0.10917479678400000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 2: {
      double t = 2*y100 - 5;
      return 0.14471159831187703054e-1 + (0.29703978970263836210e-2 + (0.15835096760173030976e-4 + (0.12574803383199211596e-6 + (0.11278672159518415848e-8 + (0.11547462300333495797e-10 + 0.12894535335111111111e-12 * t) * t) * t) * t) * t) * t;
    }
    case 3: {
      double t = 2*y100 - 7;
      return 0.20476320420324610618e-1 + (0.30352843012898665856e-2 + (0.16617609387003727409e-4 + (0.13525429711163116103e-6 + (0.12515095552507169013e-8 + (0.13235687543603382345e-10 + 0.15326595042666666667e-12 * t) * t) * t) * t) * t) * t;
    }
    case 4: {
      double t = 2*y100 - 9;
      return 0.26614461952489004566e-1 + (0.31034189276234947088e-2 + (0.17460268109986214274e-4 + (0.14582130824485709573e-6 + (0.13935959083809746345e-8 + (0.15249438072998932900e-10 + 0.18344741882133333333e-12 * t) * t) * t) * t) * t) * t;
    }
    case 5: {
      double t = 2*y100 - 11;
      return 0.32892330248093586215e-1 + (0.31750557067975068584e-2 + (0.18369907582308672632e-4 + (0.15761063702089457882e-6 + (0.15577638230480894382e-8 + (0.17663868462699097951e-10 + (0.22126732680711111111e-12 + 0.30273474177737853668e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 6: {
      double t = 2*y100 - 13;
      return 0.39317207681134336024e-1 + (0.32504779701937539333e-2 + (0.19354426046513400534e-4 + (0.17081646971321290539e-6 + (0.17485733959327106250e-8 + (0.20593687304921961410e-10 + (0.26917401949155555556e-12 + 0.38562123837725712270e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 7: {
      double t = 2*y100 - 15;
      return 0.45896976511367738235e-1 + (0.33300031273110976165e-2 + (0.20423005398039037313e-4 + (0.18567412470376467303e-6 + (0.19718038363586588213e-8 + (0.24175006536781219807e-10 + (0.33059982791466666666e-12 + 0.49756574284439426165e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 8: {
      double t = 2*y100 - 17;
      return 0.52640192524848962855e-1 + (0.34139883358846720806e-2 + (0.21586390240603337337e-4 + (0.20247136501568904646e-6 + (0.22348696948197102935e-8 + (0.28597516301950162548e-10 + (0.41045502119111111110e-12 + 0.65151614515238361946e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 9: {
      double t = 2*y100 - 19;
      return 0.59556171228656770456e-1 + (0.35028374386648914444e-2 + (0.22857246150998562824e-4 + (0.22156372146525190679e-6 + (0.25474171590893813583e-8 + (0.34122390890697400584e-10 + (0.51593189879111111110e-12 + 0.86775076853908006938e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 10: {
      double t = 2*y100 - 21;
      return 0.66655089485108212551e-1 + (0.35970095381271285568e-2 + (0.24250626164318672928e-4 + (0.24339561521785040536e-6 + (0.29221990406518411415e-8 + (0.41117013527967776467e-10 + (0.65786450716444444445e-12 + 0.11791885745450623331e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 11: {
      double t = 2*y100 - 23;
      return 0.73948106345519174661e-1 + (0.36970297216569341748e-2 + (0.25784588137312868792e-4 + (0.26853012002366752770e-6 + (0.33763958861206729592e-8 + (0.50111549981376976397e-10 + (0.85313857496888888890e-12 + 0.16417079927706899860e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 12: {
      double t = 2*y100 - 25;
      return 0.81447508065002963203e-1 + (0.38035026606492705117e-2 + (0.27481027572231851896e-4 + (0.29769200731832331364e-6 + (0.39336816287457655076e-8 + (0.61895471132038157624e-10 + (0.11292303213511111111e-11 + 0.23558532213703884304e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 13: {
      double t = 2*y100 - 27;
      return 0.89166884027582716628e-1 + (0.39171301322438946014e-2 + (0.29366827260422311668e-4 + (0.33183204390350724895e-6 + (0.46276006281647330524e-8 + (0.77692631378169813324e-10 + (0.15335153258844444444e-11 + 0.35183103415916026911e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 14: {
      double t = 2*y100 - 29;
      return 0.97121342888032322019e-1 + (0.40387340353207909514e-2 + (0.31475490395950776930e-4 + (0.37222714227125135042e-6 + (0.55074373178613809996e-8 + (0.99509175283990337944e-10 + (0.21552645758222222222e-11 + 0.55728651431872687605e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 15: {
      double t = 2*y100 - 31;
      return 0.10532778218603311137e0 + (0.41692873614065380607e-2 + (0.33849549774889456984e-4 + (0.42064596193692630143e-6 + (0.66494579697622432987e-8 + (0.13094103581931802337e-9 + (0.31896187409777777778e-11 + 0.97271974184476560742e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 16: {
      double t = 2*y100 - 33;
      return 0.11380523107427108222e0 + (0.43099572287871821013e-2 + (0.36544324341565929930e-4 + (0.47965044028581857764e-6 + (0.81819034238463698796e-8 + (0.17934133239549647357e-9 + (0.50956666166186293627e-11 + (0.18850487318190638010e-12 + 0.79697813173519853340e-14 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 17: {
      double t = 2*y100 - 35;
      return 0.12257529703447467345e0 + (0.44621675710026986366e-2 + (0.39634304721292440285e-4 + (0.55321553769873381819e-6 + (0.10343619428848520870e-7 + (0.26033830170470368088e-9 + (0.87743837749108025357e-11 + (0.34427092430230063401e-12 + 0.10205506615709843189e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 18: {
      double t = 2*y100 - 37;
      return 0.13166276955656699478e0 + (0.46276970481783001803e-2 + (0.43225026380496399310e-4 + (0.64799164020016902656e-6 + (0.13580082794704641782e-7 + (0.39839800853954313927e-9 + (0.14431142411840000000e-10 + 0.42193457308830027541e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 19: {
      double t = 2*y100 - 39;
      return 0.14109647869803356475e0 + (0.48088424418545347758e-2 + (0.47474504753352150205e-4 + (0.77509866468724360352e-6 + (0.18536851570794291724e-7 + (0.60146623257887570439e-9 + (0.18533978397305276318e-10 + (0.41033845938901048380e-13 - 0.46160680279304825485e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 20: {
      double t = 2*y100 - 41;
      return 0.15091057940548936603e0 + (0.50086864672004685703e-2 + (0.52622482832192230762e-4 + (0.95034664722040355212e-6 + (0.25614261331144718769e-7 + (0.80183196716888606252e-9 + (0.12282524750534352272e-10 + (-0.10531774117332273617e-11 - 0.86157181395039646412e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 21: {
      double t = 2*y100 - 43;
      return 0.16114648116017010770e0 + (0.52314661581655369795e-2 + (0.59005534545908331315e-4 + (0.11885518333915387760e-5 + (0.33975801443239949256e-7 + (0.82111547144080388610e-9 + (-0.12357674017312854138e-10 + (-0.24355112256914479176e-11 - 0.75155506863572930844e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 22: {
      double t = 2*y100 - 45;
      return 0.17185551279680451144e0 + (0.54829002967599420860e-2 + (0.67013226658738082118e-4 + (0.14897400671425088807e-5 + (0.40690283917126153701e-7 + (0.44060872913473778318e-9 + (-0.52641873433280000000e-10 - 0.30940587864543343124e-11 * t) * t) * t) * t) * t) * t) * t;
    }
    case 23: {
      double t = 2*y100 - 47;
      return 0.18310194559815257381e0 + (0.57701559375966953174e-2 + (0.76948789401735193483e-4 + (0.18227569842290822512e-5 + (0.41092208344387212276e-7 + (-0.44009499965694442143e-9 + (-0.92195414685628803451e-10 + (-0.22657389705721753299e-11 + 0.10004784908106839254e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 24: {
      double t = 2*y100 - 49;
      return 0.19496527191546630345e0 + (0.61010853144364724856e-2 + (0.88812881056342004864e-4 + (0.21180686746360261031e-5 + (0.30652145555130049203e-7 + (-0.16841328574105890409e-8 + (-0.11008129460612823934e-9 + (-0.12180794204544515779e-12 + 0.15703325634590334097e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 25: {
      double t = 2*y100 - 51;
      return 0.20754006813966575720e0 + (0.64825787724922073908e-2 + (0.10209599627522311893e-3 + (0.22785233392557600468e-5 + (0.73495224449907568402e-8 + (-0.29442705974150112783e-8 + (-0.94082603434315016546e-10 + (0.23609990400179321267e-11 + 0.14141908654269023788e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 26: {
      double t = 2*y100 - 53;
      return 0.22093185554845172146e0 + (0.69182878150187964499e-2 + (0.11568723331156335712e-3 + (0.22060577946323627739e-5 + (-0.26929730679360840096e-7 + (-0.38176506152362058013e-8 + (-0.47399503861054459243e-10 + (0.40953700187172127264e-11 + 0.69157730376118511127e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 27: {
      double t = 2*y100 - 55;
      return 0.23524827304057813918e0 + (0.74063350762008734520e-2 + (0.12796333874615790348e-3 + (0.18327267316171054273e-5 + (-0.66742910737957100098e-7 + (-0.40204740975496797870e-8 + (0.14515984139495745330e-10 + (0.44921608954536047975e-11 - 0.18583341338983776219e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 28: {
      double t = 2*y100 - 57;
      return 0.25058626331812744775e0 + (0.79377285151602061328e-2 + (0.13704268650417478346e-3 + (0.11427511739544695861e-5 + (-0.10485442447768377485e-6 + (-0.34850364756499369763e-8 + (0.72656453829502179208e-10 + (0.36195460197779299406e-11 - 0.84882136022200714710e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 29: {
      double t = 2*y100 - 59;
      return 0.26701724900280689785e0 + (0.84959936119625864274e-2 + (0.14112359443938883232e-3 + (0.17800427288596909634e-6 + (-0.13443492107643109071e-6 + (-0.23512456315677680293e-8 + (0.11245846264695936769e-9 + (0.19850501334649565404e-11 - 0.11284666134635050832e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 30: {
      double t = 2*y100 - 61;
      return 0.28457293586253654144e0 + (0.90581563892650431899e-2 + (0.13880520331140646738e-3 + (-0.97262302362522896157e-6 + (-0.15077100040254187366e-6 + (-0.88574317464577116689e-9 + (0.12760311125637474581e-9 + (0.20155151018282695055e-12 - 0.10514169375181734921e-12 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 31: {
      double t = 2*y100 - 63;
      return 0.30323425595617385705e0 + (0.95968346790597422934e-2 + (0.12931067776725883939e-3 + (-0.21938741702795543986e-5 + (-0.15202888584907373963e-6 + (0.61788350541116331411e-9 + (0.11957835742791248256e-9 + (-0.12598179834007710908e-11 - 0.75151817129574614194e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 32: {
      double t = 2*y100 - 65;
      return 0.32292521181517384379e0 + (0.10082957727001199408e-1 + (0.11257589426154962226e-3 + (-0.33670890319327881129e-5 + (-0.13910529040004008158e-6 + (0.19170714373047512945e-8 + (0.94840222377720494290e-10 + (-0.21650018351795353201e-11 - 0.37875211678024922689e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 33: {
      double t = 2*y100 - 67;
      return 0.34351233557911753862e0 + (0.10488575435572745309e-1 + (0.89209444197248726614e-4 + (-0.43893459576483345364e-5 + (-0.11488595830450424419e-6 + (0.28599494117122464806e-8 + (0.61537542799857777779e-10 - 0.24935749227658002212e-11 * t) * t) * t) * t) * t) * t) * t;
    }
    case 34: {
      double t = 2*y100 - 69;
      return 0.36480946642143669093e0 + (0.10789304203431861366e-1 + (0.60357993745283076834e-4 + (-0.51855862174130669389e-5 + (-0.83291664087289801313e-7 + (0.33898011178582671546e-8 + (0.27082948188277716482e-10 + (-0.23603379397408694974e-11 + 0.19328087692252869842e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 35: {
      double t = 2*y100 - 71;
      return 0.38658679935694939199e0 + (0.10966119158288804999e-1 + (0.27521612041849561426e-4 + (-0.57132774537670953638e-5 + (-0.48404772799207914899e-7 + (0.35268354132474570493e-8 + (-0.32383477652514618094e-11 + (-0.19334202915190442501e-11 + 0.32333189861286460270e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 36: {
      double t = 2*y100 - 73;
      return 0.40858275583808707870e0 + (0.11006378016848466550e-1 + (-0.76396376685213286033e-5 + (-0.59609835484245791439e-5 + (-0.13834610033859313213e-7 + (0.33406952974861448790e-8 + (-0.26474915974296612559e-10 + (-0.13750229270354351983e-11 + 0.36169366979417390637e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 37: {
      double t = 2*y100 - 75;
      return 0.43051714914006682977e0 + (0.10904106549500816155e-1 + (-0.43477527256787216909e-4 + (-0.59429739547798343948e-5 + (0.17639200194091885949e-7 + (0.29235991689639918688e-8 + (-0.41718791216277812879e-10 + (-0.81023337739508049606e-12 + 0.33618915934461994428e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 38: {
      double t = 2*y100 - 77;
      return 0.45210428135559607406e0 + (0.10659670756384400554e-1 + (-0.78488639913256978087e-4 + (-0.56919860886214735936e-5 + (0.44181850467477733407e-7 + (0.23694306174312688151e-8 + (-0.49492621596685443247e-10 + (-0.31827275712126287222e-12 + 0.27494438742721623654e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 39: {
      double t = 2*y100 - 79;
      return 0.47306491195005224077e0 + (0.10279006119745977570e-1 + (-0.11140268171830478306e-3 + (-0.52518035247451432069e-5 + (0.64846898158889479518e-7 + (0.17603624837787337662e-8 + (-0.51129481592926104316e-10 + (0.62674584974141049511e-13 + 0.20055478560829935356e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 40: {
      double t = 2*y100 - 81;
      return 0.49313638965719857647e0 + (0.97725799114772017662e-2 + (-0.14122854267291533334e-3 + (-0.46707252568834951907e-5 + (0.79421347979319449524e-7 + (0.11603027184324708643e-8 + (-0.48269605844397175946e-10 + (0.32477251431748571219e-12 + 0.12831052634143527985e-13 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 41: {
      double t = 2*y100 - 83;
      return 0.51208057433416004042e0 + (0.91542422354009224951e-2 + (-0.16726530230228647275e-3 + (-0.39964621752527649409e-5 + (0.88232252903213171454e-7 + (0.61343113364949928501e-9 + (-0.42516755603130443051e-10 + (0.47910437172240209262e-12 + 0.66784341874437478953e-14 * t) * t) * t) * t) * t) * t) * t) * t;
    }
    case 42: {
      double t = 2*y100 - 85;
      return 0.52968945458607484524e0 + (0.84400880445116786088e-2 + (-0.18908729783854258774e-3 + (-0.32725905467782951931e-5 + (0.91956190588652090659e-7 + (0.14593989152420122909e-9 + (-0.35239490687644444445e-10 + 0.54613829888448694898e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 43: {
      double t = 2*y100 - 87;
      return 0.54578857454330070965e0 + (0.76474155195880295311e-2 + (-0.20651230590808213884e-3 + (-0.25364339140543131706e-5 + (0.91455367999510681979e-7 + (-0.23061359005297528898e-9 + (-0.27512928625244444444e-10 + 0.54895806008493285579e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 44: {
      double t = 2*y100 - 89;
      return 0.56023851910298493910e0 + (0.67938321739997196804e-2 + (-0.21956066613331411760e-3 + (-0.18181127670443266395e-5 + (0.87650335075416845987e-7 + (-0.51548062050366615977e-9 + (-0.20068462174044444444e-10 + 0.50912654909758187264e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 45: {
      double t = 2*y100 - 91;
      return 0.57293478057455721150e0 + (0.58965321010394044087e-2 + (-0.22841145229276575597e-3 + (-0.11404605562013443659e-5 + (0.81430290992322326296e-7 + (-0.71512447242755357629e-9 + (-0.13372664928000000000e-10 + 0.44461498336689298148e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 46: {
      double t = 2*y100 - 93;
      return 0.58380635448407827360e0 + (0.49717469530842831182e-2 + (-0.23336001540009645365e-3 + (-0.51952064448608850822e-6 + (0.73596577815411080511e-7 + (-0.84020916763091566035e-9 + (-0.76700972702222222221e-11 + 0.36914462807972467044e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 47: {
      double t = 2*y100 - 95;
      return 0.59281340237769489597e0 + (0.40343592069379730568e-2 + (-0.23477963738658326185e-3 + (0.34615944987790224234e-7 + (0.64832803248395814574e-7 + (-0.90329163587627007971e-9 + (-0.30421940400000000000e-11 + 0.29237386653743536669e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 48: {
      double t = 2*y100 - 97;
      return 0.59994428743114271918e0 + (0.30976579788271744329e-2 + (-0.23308875765700082835e-3 + (0.51681681023846925160e-6 + (0.55694594264948268169e-7 + (-0.91719117313243464652e-9 + (0.53982743680000000000e-12 + 0.22050829296187771142e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 49: {
      double t = 2*y100 - 99;
      return 0.60521224471819875444e0 + (0.21732138012345456060e-2 + (-0.22872428969625997456e-3 + (0.92588959922653404233e-6 + (0.46612665806531930684e-7 + (-0.89393722514414153351e-9 + (0.31718550353777777778e-11 + 0.15705458816080549117e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 50: {
      double t = 2*y100 - 101;
      return 0.60865189969791123620e0 + (0.12708480848877451719e-2 + (-0.22212090111534847166e-3 + (0.12636236031532793467e-5 + (0.37904037100232937574e-7 + (-0.84417089968101223519e-9 + (0.49843180828444444445e-11 + 0.10355439441049048273e-12 * t) * t) * t) * t) * t) * t) * t;
    }
    case 51: {
      double t = 2*y100 - 103;
      return 0.61031580103499200191e0 + (0.39867436055861038223e-3 + (-0.21369573439579869291e-3 + (0.15339402129026183670e-5 + (0.29787479206646594442e-7 + (-0.77687792914228632974e-9 + (0.61192452741333333334e-11 + 0.60216691829459295780e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 52: {
      double t = 2*y100 - 105;
      return 0.61027109047879835868e0 + (-0.43680904508059878254e-3 + (-0.20383783788303894442e-3 + (0.17421743090883439959e-5 + (0.22400425572175715576e-7 + (-0.69934719320045128997e-9 + (0.67152759655111111110e-11 + 0.26419960042578359995e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 53: {
      double t = 2*y100 - 107;
      return 0.60859639489217430521e0 + (-0.12305921390962936873e-2 + (-0.19290150253894682629e-3 + (0.18944904654478310128e-5 + (0.15815530398618149110e-7 + (-0.61726850580964876070e-9 + 0.68987888999111111110e-11 * t) * t) * t) * t) * t) * t;
    }
    case 54: {
      double t = 2*y100 - 109;
      return 0.60537899426486075181e0 + (-0.19790062241395705751e-2 + (-0.18120271393047062253e-3 + (0.19974264162313241405e-5 + (0.10055795094298172492e-7 + (-0.53491997919318263593e-9 + (0.67794550295111111110e-11 - 0.17059208095741511603e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 55: {
      double t = 2*y100 - 111;
      return 0.60071229457904110537e0 + (-0.26795676776166354354e-2 + (-0.16901799553627508781e-3 + (0.20575498324332621581e-5 + (0.51077165074461745053e-8 + (-0.45536079828057221858e-9 + (0.64488005516444444445e-11 - 0.29311677573152766338e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 56: {
      double t = 2*y100 - 113;
      return 0.59469361520112714738e0 + (-0.33308208190600993470e-2 + (-0.15658501295912405679e-3 + (0.20812116912895417272e-5 + (0.93227468760614182021e-9 + (-0.38066673740116080415e-9 + (0.59806790359111111110e-11 - 0.36887077278950440597e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 57: {
      double t = 2*y100 - 115;
      return 0.58742228631775388268e0 + (-0.39321858196059227251e-2 + (-0.14410441141450122535e-3 + (0.20743790018404020716e-5 + (-0.25261903811221913762e-8 + (-0.31212416519526924318e-9 + (0.54328422462222222221e-11 - 0.40864152484979815972e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 58: {
      double t = 2*y100 - 117;
      return 0.57899804200033018447e0 + (-0.44838157005618913447e-2 + (-0.13174245966501437965e-3 + (0.20425306888294362674e-5 + (-0.53330296023875447782e-8 + (-0.25041289435539821014e-9 + (0.48490437205333333334e-11 - 0.42162206939169045177e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 59: {
      double t = 2*y100 - 119;
      return 0.56951968796931245974e0 + (-0.49864649488074868952e-2 + (-0.11963416583477567125e-3 + (0.19906021780991036425e-5 + (-0.75580140299436494248e-8 + (-0.19576060961919820491e-9 + (0.42613011928888888890e-11 - 0.41539443304115604377e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 60: {
      double t = 2*y100 - 121;
      return 0.55908401930063918964e0 + (-0.54413711036826877753e-2 + (-0.10788661102511914628e-3 + (0.19229663322982839331e-5 + (-0.92714731195118129616e-8 + (-0.14807038677197394186e-9 + (0.36920870298666666666e-11 - 0.39603726688419162617e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 61: {
      double t = 2*y100 - 123;
      return 0.54778496152925675315e0 + (-0.58501497933213396670e-2 + (-0.96582314317855227421e-4 + (0.18434405235069270228e-5 + (-0.10541580254317078711e-7 + (-0.10702303407788943498e-9 + (0.31563175582222222222e-11 - 0.36829748079110481422e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 62: {
      double t = 2*y100 - 125;
      return 0.53571290831682823999e0 + (-0.62147030670760791791e-2 + (-0.85782497917111760790e-4 + (0.17553116363443470478e-5 + (-0.11432547349815541084e-7 + (-0.72157091369041330520e-10 + (0.26630811607111111111e-11 - 0.33578660425893164084e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 63: {
      double t = 2*y100 - 127;
      return 0.52295422962048434978e0 + (-0.65371404367776320720e-2 + (-0.75530164941473343780e-4 + (0.16613725797181276790e-5 + (-0.12003521296598910761e-7 + (-0.42929753689181106171e-10 + (0.22170894940444444444e-11 - 0.30117697501065110505e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 64: {
      double t = 2*y100 - 129;
      return 0.50959092577577886140e0 + (-0.68197117603118591766e-2 + (-0.65852936198953623307e-4 + (0.15639654113906716939e-5 + (-0.12308007991056524902e-7 + (-0.18761997536910939570e-10 + (0.18198628922666666667e-11 - 0.26638355362285200932e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 65: {
      double t = 2*y100 - 131;
      return 0.49570040481823167970e0 + (-0.70647509397614398066e-2 + (-0.56765617728962588218e-4 + (0.14650274449141448497e-5 + (-0.12393681471984051132e-7 + (0.92904351801168955424e-12 + (0.14706755960177777778e-11 - 0.23272455351266325318e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 66: {
      double t = 2*y100 - 133;
      return 0.48135536250935238066e0 + (-0.72746293327402359783e-2 + (-0.48272489495730030780e-4 + (0.13661377309113939689e-5 + (-0.12302464447599382189e-7 + (0.16707760028737074907e-10 + (0.11672928324444444444e-11 - 0.20105801424709924499e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 67: {
      double t = 2*y100 - 135;
      return 0.46662374675511439448e0 + (-0.74517177649528487002e-2 + (-0.40369318744279128718e-4 + (0.12685621118898535407e-5 + (-0.12070791463315156250e-7 + (0.29105507892605823871e-10 + (0.90653314645333333334e-12 - 0.17189503312102982646e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 68: {
      double t = 2*y100 - 137;
      return 0.45156879030168268778e0 + (-0.75983560650033817497e-2 + (-0.33045110380705139759e-4 + (0.11732956732035040896e-5 + (-0.11729986947158201869e-7 + (0.38611905704166441308e-10 + (0.68468768305777777779e-12 - 0.14549134330396754575e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 69: {
      double t = 2*y100 - 139;
      return 0.43624909769330896904e0 + (-0.77168291040309554679e-2 + (-0.26283612321339907756e-4 + (0.10811018836893550820e-5 + (-0.11306707563739851552e-7 + (0.45670446788529607380e-10 + (0.49782492549333333334e-12 - 0.12191983967561779442e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 70: {
      double t = 2*y100 - 141;
      return 0.42071877443548481181e0 + (-0.78093484015052730097e-2 + (-0.20064596897224934705e-4 + (0.99254806680671890766e-6 + (-0.10823412088884741451e-7 + (0.50677203326904716247e-10 + (0.34200547594666666666e-12 - 0.10112698698356194618e-13 * t) * t) * t) * t) * t) * t) * t;
    }
    case 71: {
      double t = 2*y100 - 143;
      return 0.40502758809710844280e0 + (-0.78780384460872937555e-2 + (-0.14364940764532853112e-4 + (0.90803709228265217384e-6 + (-0.10298832847014466907e-7 + (0.53981671221969478551e-10 + (0.21342751381333333333e-12 - 0.82975901848387729274e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 72: {
      double t = 2*y100 - 145;
      return 0.38922115269731446690e0 + (-0.79249269708242064120e-2 + (-0.91595258799106970453e-5 + (0.82783535102217576495e-6 + (-0.97484311059617744437e-8 + (0.55889029041660225629e-10 + (0.10851981336888888889e-12 - 0.67278553237853459757e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 73: {
      double t = 2*y100 - 147;
      return 0.37334112915460307335e0 + (-0.79519385109223148791e-2 + (-0.44219833548840469752e-5 + (0.75209719038240314732e-6 + (-0.91848251458553190451e-8 + (0.56663266668051433844e-10 + (0.23995894257777777778e-13 - 0.53819475285389344313e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 74: {
      double t = 2*y100 - 149;
      return 0.35742543583374223085e0 + (-0.79608906571527956177e-2 + (-0.12530071050975781198e-6 + (0.68088605744900552505e-6 + (-0.86181844090844164075e-8 + (0.56530784203816176153e-10 + (-0.43120012248888888890e-13 - 0.42372603392496813810e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 75: {
      double t = 2*y100 - 151;
      return 0.34150846431979618536e0 + (-0.79534924968773806029e-2 + (0.37576885610891515813e-5 + (0.61419263633090524326e-6 + (-0.80565865409945960125e-8 + (0.55684175248749269411e-10 + (-0.95486860764444444445e-13 - 0.32712946432984510595e-14 * t) * t) * t) * t) * t) * t) * t;
    }
    case 76: {
      double t = 2*y100 - 153;
      return 0.32562129649136346824e0 + (-0.79313448067948884309e-2 + (0.72539159933545300034e-5 + (0.55195028297415503083e-6 + (-0.75063365335570475258e-8 + (0.54281686749699595941e-10 - 0.13545424295111111111e-12 * t) * t) * t) * t) * t) * t;
    }
    case 77: {
      double t = 2*y100 - 155;
      return 0.30979191977078391864e0 + (-0.78959416264207333695e-2 + (0.10389774377677210794e-4 + (0.49404804463196316464e-6 + (-0.69722488229411164685e-8 + (0.52469254655951393842e-10 - 0.16507860650666666667e-12 * t) * t) * t) * t) * t) * t;
    }
    case 78: {
      double t = 2*y100 - 157;
      return 0.29404543811214459904e0 + (-0.78486728990364155356e-2 + (0.13190885683106990459e-4 + (0.44034158861387909694e-6 + (-0.64578942561562616481e-8 + (0.50354306498006928984e-10 - 0.18614473550222222222e-12 * t) * t) * t) * t) * t) * t;
    }
    case 79: {
      double t = 2*y100 - 159;
      return 0.27840427686253660515e0 + (-0.77908279176252742013e-2 + (0.15681928798708548349e-4 + (0.39066226205099807573e-6 + (-0.59658144820660420814e-8 + (0.48030086420373141763e-10 - 0.20018995173333333333e-12 * t) * t) * t) * t) * t) * t;
    }
    case 80: {
      double t = 2*y100 - 161;
      return 0.26288838011163800908e0 + (-0.77235993576119469018e-2 + (0.17886516796198660969e-4 + (0.34482457073472497720e-6 + (-0.54977066551955420066e-8 + (0.45572749379147269213e-10 - 0.20852924954666666667e-12 * t) * t) * t) * t) * t) * t;
    }
    case 81: {
      double t = 2*y100 - 163;
      return 0.24751539954181029717e0 + (-0.76480877165290370975e-2 + (0.19827114835033977049e-4 + (0.30263228619976332110e-6 + (-0.50545814570120129947e-8 + (0.43043879374212005966e-10 - 0.21228012028444444444e-12 * t) * t) * t) * t) * t) * t;
    }
    case 82: {
      double t = 2*y100 - 165;
      return 0.23230087411688914593e0 + (-0.75653060136384041587e-2 + (0.21524991113020016415e-4 + (0.26388338542539382413e-6 + (-0.46368974069671446622e-8 + (0.40492715758206515307e-10 - 0.21238627815111111111e-12 * t) * t) * t) * t) * t) * t;
    }
    case 83: {
      double t = 2*y100 - 167;
      return 0.21725840021297341931e0 + (-0.74761846305979730439e-2 + (0.23000194404129495243e-4 + (0.22837400135642906796e-6 + (-0.42446743058417541277e-8 + (0.37958104071765923728e-10 - 0.20963978568888888889e-12 * t) * t) * t) * t) * t) * t;
    }
    case 84: {
      double t = 2*y100 - 169;
      return 0.20239979200788191491e0 + (-0.73815761980493466516e-2 + (0.24271552727631854013e-4 + (0.19590154043390012843e-6 + (-0.38775884642456551753e-8 + (0.35470192372162901168e-10 - 0.20470131678222222222e-12 * t) * t) * t) * t) * t) * t;
    }
    case 85: {
      double t = 2*y100 - 171;
      return 0.18773523211558098962e0 + (-0.72822604530339834448e-2 + (0.25356688567841293697e-4 + (0.16626710297744290016e-6 + (-0.35350521468015310830e-8 + (0.33051896213898864306e-10 - 0.19811844544000000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 86: {
      double t = 2*y100 - 173;
      return 0.17327341258479649442e0 + (-0.71789490089142761950e-2 + (0.26272046822383820476e-4 + (0.13927732375657362345e-6 + (-0.32162794266956859603e-8 + (0.30720156036105652035e-10 - 0.19034196304000000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 87: {
      double t = 2*y100 - 175;
      return 0.15902166648328672043e0 + (-0.70722899934245504034e-2 + (0.27032932310132226025e-4 + (0.11474573347816568279e-6 + (-0.29203404091754665063e-8 + (0.28487010262547971859e-10 - 0.18174029063111111111e-12 * t) * t) * t) * t) * t) * t;
    }
    case 88: {
      double t = 2*y100 - 177;
      return 0.14498609036610283865e0 + (-0.69628725220045029273e-2 + (0.27653554229160596221e-4 + (0.92493727167393036470e-7 + (-0.26462055548683583849e-8 + (0.26360506250989943739e-10 - 0.17261211260444444444e-12 * t) * t) * t) * t) * t) * t;
    }
    case 89: {
      double t = 2*y100 - 179;
      return 0.13117165798208050667e0 + (-0.68512309830281084723e-2 + (0.28147075431133863774e-4 + (0.72351212437979583441e-7 + (-0.23927816200314358570e-8 + (0.24345469651209833155e-10 - 0.16319736960000000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 90: {
      double t = 2*y100 - 181;
      return 0.11758232561160626306e0 + (-0.67378491192463392927e-2 + (0.28525664781722907847e-4 + (0.54156999310046790024e-7 + (-0.21589405340123827823e-8 + (0.22444150951727334619e-10 - 0.15368675584000000000e-12 * t) * t) * t) * t) * t) * t;
    }
    case 91: {
      double t = 2*y100 - 183;
      return 0.10422112945361673560e0 + (-0.66231638959845581564e-2 + (0.28800551216363918088e-4 + (0.37758983397952149613e-7 + (-0.19435423557038933431e-8 + (0.20656766125421362458e-10 - 0.14422990012444444444e-12 * t) * t) * t) * t) * t) * t;
    }
    case 92: {
      double t = 2*y100 - 185;
      return 0.91090275493541084785e-1 + (-0.65075691516115160062e-2 + (0.28982078385527224867e-4 + (0.23014165807643012781e-7 + (-0.17454532910249875958e-8 + (0.18981946442680092373e-10 - 0.13494234691555555556e-12 * t) * t) * t) * t) * t) * t;
    }
    case 93: {
      double t = 2*y100 - 187;
      return 0.78191222288771379358e-1 + (-0.63914190297303976434e-2 + (0.29079759021299682675e-4 + (0.97885458059415717014e-8 + (-0.15635596116134296819e-8 + (0.17417110744051331974e-10 - 0.12591151763555555556e-12 * t) * t) * t) * t) * t) * t;
    }
    case 94: {
      double t = 2*y100 - 189;
      return 0.65524757106147402224e-1 + (-0.62750311956082444159e-2 + (0.29102328354323449795e-4 + (-0.20430838882727954582e-8 + (-0.13967781903855367270e-8 + (0.15958771833747057569e-10 - 0.11720175765333333333e-12 * t) * t) * t) * t) * t) * t;
    }
    case 95: {
      double t = 2*y100 - 191;
      return 0.53091065838453612773e-1 + (-0.61586898417077043662e-2 + (0.29057796072960100710e-4 + (-0.12597414620517987536e-7 + (-0.12440642607426861943e-8 + (0.14602787128447932137e-10 - 0.10885859114666666667e-12 * t) * t) * t) * t) * t) * t;
    }
    case 96: {
      double t = 2*y100 - 193;
      return 0.40889797115352738582e-1 + (-0.60426484889413678200e-2 + (0.28953496450191694606e-4 + (-0.21982952021823718400e-7 + (-0.11044169117553026211e-8 + (0.13344562332430552171e-10 - 0.10091231402844444444e-12 * t) * t) * t) * t) * t) * t;
    }
  case 97: case 98:
  case 99: case 100: { // use Taylor expansion for small x (|x| <= 0.0309...)
      //  (2/sqrt(pi)) * (x - 2/3 x^3  + 4/15 x^5  - 8/105 x^7 + 16/945 x^9)
      double x2 = x*x;
      return x * (1.1283791670955125739
                  - x2 * (0.75225277806367504925
                          - x2 * (0.30090111122547001970
                                  - x2 * (0.085971746064420005629
                                          - x2 * 0.016931216931216931217))));
    }
  }
  /* Since 0 <= y100 < 101, this is only reached if x is NaN,
     in which case we should return NaN. */
  return NaN;
}

double FADDEEVA(w_im)(double x)
{
  if (x >= 0) {
    if (x > 45) { // continued-fraction expansion is faster
      const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
      if (x > 5e7) // 1-term expansion, important to avoid overflow
        return ispi / x;
      /* 5-term expansion (rely on compiler for CSE), simplified from:
                ispi / (x-0.5/(x-1/(x-1.5/(x-2/x))))  */
      return ispi*((x*x) * (x*x-4.5) + 2) / (x * ((x*x) * (x*x-5) + 3.75));
    }
    return w_im_y100(100/(1+x), x);
  }
  else { // = -FADDEEVA(w_im)(-x)
    if (x < -45) { // continued-fraction expansion is faster
      const double ispi = 0.56418958354775628694807945156; // 1 / sqrt(pi)
      if (x < -5e7) // 1-term expansion, important to avoid overflow
        return ispi / x;
      /* 5-term expansion (rely on compiler for CSE), simplified from:
                ispi / (x-0.5/(x-1/(x-1.5/(x-2/x))))  */
      return ispi*((x*x) * (x*x-4.5) + 2) / (x * ((x*x) * (x*x-5) + 3.75));
    }
    return -w_im_y100(100/(1-x), -x);
  }
}

/////////////////////////////////////////////////////////////////////////

// Compile with -DTEST_FADDEEVA to compile a little test program
#ifdef TEST_FADDEEVA

#ifdef __cplusplus
#  include <cstdio>
#else
#  include <stdio.h>
#endif

// compute relative error |b-a|/|a|, handling case of NaN and Inf,
static double relerr(double a, double b) {
  if (isnan(a) || isnan(b) || isinf(a) || isinf(b)) {
    if ((isnan(a) && !isnan(b)) || (!isnan(a) && isnan(b)) ||
        (isinf(a) && !isinf(b)) || (!isinf(a) && isinf(b)) ||
        (isinf(a) && isinf(b) && a*b < 0))
      return Inf; // "infinite" error
    return 0; // matching infinity/nan results counted as zero error
  }
  if (a == 0)
    return b == 0 ? 0 : Inf;
  else
    return fabs((b-a) / a);
}

int main(void) {
  double errmax_all = 0;
  {
    printf("############# w(z) tests #############\n");
#define NTST 57 // define instead of const for C compatibility
    cmplx z[NTST] = {
      C(624.2,-0.26123),
      C(-0.4,3.),
      C(0.6,2.),
      C(-1.,1.),
      C(-1.,-9.),
      C(-1.,9.),
      C(-0.0000000234545,1.1234),
      C(-3.,5.1),
      C(-53,30.1),
      C(0.0,0.12345),
      C(11,1),
      C(-22,-2),
      C(9,-28),
      C(21,-33),
      C(1e5,1e5),
      C(1e14,1e14),
      C(-3001,-1000),
      C(1e160,-1e159),
      C(-6.01,0.01),
      C(-0.7,-0.7),
      C(2.611780000000000e+01, 4.540909610972489e+03),
      C(0.8e7,0.3e7),
      C(-20,-19.8081),
      C(1e-16,-1.1e-16),
      C(2.3e-8,1.3e-8),
      C(6.3,-1e-13),
      C(6.3,1e-20),
      C(1e-20,6.3),
      C(1e-20,16.3),
      C(9,1e-300),
      C(6.01,0.11),
      C(8.01,1.01e-10),
      C(28.01,1e-300),
      C(10.01,1e-200),
      C(10.01,-1e-200),
      C(10.01,0.99e-10),
      C(10.01,-0.99e-10),
      C(1e-20,7.01),
      C(-1,7.01),
      C(5.99,7.01),
      C(1,0),
      C(55,0),
      C(-0.1,0),
      C(1e-20,0),
      C(0,5e-14),
      C(0,51),
      C(Inf,0),
      C(-Inf,0),
      C(0,Inf),
      C(0,-Inf),
      C(Inf,Inf),
      C(Inf,-Inf),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,Inf),
      C(Inf,NaN)
    };
    cmplx w[NTST] = { /* w(z), computed with WolframAlpha
                                   ... note that WolframAlpha is problematic
                                   some of the above inputs, so I had to
                                   use the continued-fraction expansion
                                   in WolframAlpha in some cases, or switch
                                   to Maple */
      C(-3.78270245518980507452677445620103199303131110e-7,
        0.000903861276433172057331093754199933411710053155),
      C(0.1764906227004816847297495349730234591778719532788,
        -0.02146550539468457616788719893991501311573031095617),
      C(0.2410250715772692146133539023007113781272362309451,
        0.06087579663428089745895459735240964093522265589350),
      C(0.30474420525691259245713884106959496013413834051768,
        -0.20821893820283162728743734725471561394145872072738),
      C(7.317131068972378096865595229600561710140617977e34,
        8.321873499714402777186848353320412813066170427e34),
      C(0.0615698507236323685519612934241429530190806818395,
        -0.00676005783716575013073036218018565206070072304635),
      C(0.3960793007699874918961319170187598400134746631,
        -5.593152259116644920546186222529802777409274656e-9),
      C(0.08217199226739447943295069917990417630675021771804,
        -0.04701291087643609891018366143118110965272615832184),
      C(0.00457246000350281640952328010227885008541748668738,
        -0.00804900791411691821818731763401840373998654987934),
      C(0.8746342859608052666092782112565360755791467973338452,
        0.),
      C(0.00468190164965444174367477874864366058339647648741,
        0.0510735563901306197993676329845149741675029197050),
      C(-0.0023193175200187620902125853834909543869428763219,
        -0.025460054739731556004902057663500272721780776336),
      C(9.11463368405637174660562096516414499772662584e304,
        3.97101807145263333769664875189354358563218932e305),
      C(-4.4927207857715598976165541011143706155432296e281,
        -2.8019591213423077494444700357168707775769028e281),
      C(2.820947917809305132678577516325951485807107151e-6,
        2.820947917668257736791638444590253942253354058e-6),
      C(2.82094791773878143474039725787438662716372268e-15,
        2.82094791773878143474039725773333923127678361e-15),
      C(-0.0000563851289696244350147899376081488003110150498,
        -0.000169211755126812174631861529808288295454992688),
      C(-5.586035480670854326218608431294778077663867e-162,
        5.586035480670854326218608431294778077663867e-161),
      C(0.00016318325137140451888255634399123461580248456,
        -0.095232456573009287370728788146686162555021209999),
      C(0.69504753678406939989115375989939096800793577783885,
        -1.8916411171103639136680830887017670616339912024317),
      C(0.0001242418269653279656612334210746733213167234822,
        7.145975826320186888508563111992099992116786763e-7),
      C(2.318587329648353318615800865959225429377529825e-8,
        6.182899545728857485721417893323317843200933380e-8),
      C(-0.0133426877243506022053521927604277115767311800303,
        -0.0148087097143220769493341484176979826888871576145),
      C(1.00000000000000012412170838050638522857747934,
        1.12837916709551279389615890312156495593616433e-16),
      C(0.9999999853310704677583504063775310832036830015,
        2.595272024519678881897196435157270184030360773e-8),
      C(-1.4731421795638279504242963027196663601154624e-15,
        0.090727659684127365236479098488823462473074709),
      C(5.79246077884410284575834156425396800754409308e-18,
        0.0907276596841273652364790985059772809093822374),
      C(0.0884658993528521953466533278764830881245144368,
        1.37088352495749125283269718778582613192166760e-22),
      C(0.0345480845419190424370085249304184266813447878,
        2.11161102895179044968099038990446187626075258e-23),
      C(6.63967719958073440070225527042829242391918213e-36,
        0.0630820900592582863713653132559743161572639353),
      C(0.00179435233208702644891092397579091030658500743634,
        0.0951983814805270647939647438459699953990788064762),
      C(9.09760377102097999924241322094863528771095448e-13,
        0.0709979210725138550986782242355007611074966717),
      C(7.2049510279742166460047102593255688682910274423e-304,
        0.0201552956479526953866611812593266285000876784321),
      C(3.04543604652250734193622967873276113872279682e-44,
        0.0566481651760675042930042117726713294607499165),
      C(3.04543604652250734193622967873276113872279682e-44,
        0.0566481651760675042930042117726713294607499165),
      C(0.5659928732065273429286988428080855057102069081e-12,
        0.056648165176067504292998527162143030538756683302),
      C(-0.56599287320652734292869884280802459698927645e-12,
        0.0566481651760675042929985271621430305387566833029),
      C(0.0796884251721652215687859778119964009569455462,
        1.11474461817561675017794941973556302717225126e-22),
      C(0.07817195821247357458545539935996687005781943386550,
        -0.01093913670103576690766705513142246633056714279654),
      C(0.04670032980990449912809326141164730850466208439937,
        0.03944038961933534137558064191650437353429669886545),
      C(0.36787944117144232159552377016146086744581113103176,
        0.60715770584139372911503823580074492116122092866515),
      C(0,
        0.010259688805536830986089913987516716056946786526145),
      C(0.99004983374916805357390597718003655777207908125383,
        -0.11208866436449538036721343053869621153527769495574),
      C(0.99999999999999999999999999999999999999990000,
        1.12837916709551257389615890312154517168802603e-20),
      C(0.999999999999943581041645226871305192054749891144158,
        0),
      C(0.0110604154853277201542582159216317923453996211744250,
        0),
      C(0,0),
      C(0,0),
      C(0,0),
      C(Inf,0),
      C(0,0),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,0),
      C(NaN,NaN),
      C(NaN,NaN)
    };
    double errmax = 0;
    for (int i = 0; i < NTST; ++i) {
      cmplx fw = FADDEEVA(w)(z[i],0.);
      double re_err = relerr(creal(w[i]), creal(fw));
      double im_err = relerr(cimag(w[i]), cimag(fw));
      printf("w(%g%+gi) = %g%+gi (vs. %g%+gi), re/im rel. err. = %0.2g/%0.2g)\n",
             creal(z[i]),cimag(z[i]), creal(fw),cimag(fw), creal(w[i]),cimag(w[i]),
             re_err, im_err);
      if (re_err > errmax) errmax = re_err;
      if (im_err > errmax) errmax = im_err;
    }
    if (errmax > 1e-13) {
      printf("FAILURE -- relative error %g too large!\n", errmax);
      return 1;
    }
    printf("SUCCESS (max relative error = %g)\n", errmax);
    if (errmax > errmax_all) errmax_all = errmax;
  }
  {
#undef NTST
#define NTST 41 // define instead of const for C compatibility
    cmplx z[NTST] = {
      C(1,2),
      C(-1,2),
      C(1,-2),
      C(-1,-2),
      C(9,-28),
      C(21,-33),
      C(1e3,1e3),
      C(-3001,-1000),
      C(1e160,-1e159),
      C(5.1e-3, 1e-8),
      C(-4.9e-3, 4.95e-3),
      C(4.9e-3, 0.5),
      C(4.9e-4, -0.5e1),
      C(-4.9e-5, -0.5e2),
      C(5.1e-3, 0.5),
      C(5.1e-4, -0.5e1),
      C(-5.1e-5, -0.5e2),
      C(1e-6,2e-6),
      C(0,2e-6),
      C(0,2),
      C(0,20),
      C(0,200),
      C(Inf,0),
      C(-Inf,0),
      C(0,Inf),
      C(0,-Inf),
      C(Inf,Inf),
      C(Inf,-Inf),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,Inf),
      C(Inf,NaN),
      C(1e-3,NaN),
      C(7e-2,7e-2),
      C(7e-2,-7e-4),
      C(-9e-2,7e-4),
      C(-9e-2,9e-2),
      C(-7e-4,9e-2),
      C(7e-2,0.9e-2),
      C(7e-2,1.1e-2)
    };
    cmplx w[NTST] = { // erf(z[i]), evaluated with Maple
      C(-0.5366435657785650339917955593141927494421,
        -5.049143703447034669543036958614140565553),
      C(0.5366435657785650339917955593141927494421,
        -5.049143703447034669543036958614140565553),
      C(-0.5366435657785650339917955593141927494421,
        5.049143703447034669543036958614140565553),
      C(0.5366435657785650339917955593141927494421,
        5.049143703447034669543036958614140565553),
      C(0.3359473673830576996788000505817956637777e304,
        -0.1999896139679880888755589794455069208455e304),
      C(0.3584459971462946066523939204836760283645e278,
        0.3818954885257184373734213077678011282505e280),
      C(0.9996020422657148639102150147542224526887,
        0.00002801044116908227889681753993542916894856),
      C(-1, 0),
      C(1, 0),
      C(0.005754683859034800134412990541076554934877,
        0.1128349818335058741511924929801267822634e-7),
      C(-0.005529149142341821193633460286828381876955,
        0.005585388387864706679609092447916333443570),
      C(0.007099365669981359632319829148438283865814,
        0.6149347012854211635026981277569074001219),
      C(0.3981176338702323417718189922039863062440e8,
        -0.8298176341665249121085423917575122140650e10),
      C(-Inf,
        -Inf),
      C(0.007389128308257135427153919483147229573895,
        0.6149332524601658796226417164791221815139),
      C(0.4143671923267934479245651547534414976991e8,
        -0.8298168216818314211557046346850921446950e10),
      C(-Inf,
        -Inf),
      C(0.1128379167099649964175513742247082845155e-5,
        0.2256758334191777400570377193451519478895e-5),
      C(0,
        0.2256758334194034158904576117253481476197e-5),
      C(0,
        18.56480241457555259870429191324101719886),
      C(0,
        0.1474797539628786202447733153131835124599e173),
      C(0,
        Inf),
      C(1,0),
      C(-1,0),
      C(0,Inf),
      C(0,-Inf),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,NaN),
      C(NaN,NaN),
      C(NaN,NaN),
      C(0.07924380404615782687930591956705225541145,
        0.07872776218046681145537914954027729115247),
      C(0.07885775828512276968931773651224684454495,
        -0.0007860046704118224342390725280161272277506),
      C(-0.1012806432747198859687963080684978759881,
        0.0007834934747022035607566216654982820299469),
      C(-0.1020998418798097910247132140051062512527,
        0.1010030778892310851309082083238896270340),
      C(-0.0007962891763147907785684591823889484764272,
        0.1018289385936278171741809237435404896152),
      C(0.07886408666470478681566329888615410479530,
        0.01010604288780868961492224347707949372245),
      C(0.07886723099940260286824654364807981336591,
        0.01235199327873258197931147306290916629654)
    };
#define TST(f,isc)                                                      \
    printf("############# " #f "(z) tests #############\n");            \
    double errmax = 0;                                                  \
    for (int i = 0; i < NTST; ++i) {                                    \
      cmplx fw = FADDEEVA(f)(z[i],0.);                  \
      double re_err = relerr(creal(w[i]), creal(fw));                   \
      double im_err = relerr(cimag(w[i]), cimag(fw));                   \
      printf(#f "(%g%+gi) = %g%+gi (vs. %g%+gi), re/im rel. err. = %0.2g/%0.2g)\n", \
             creal(z[i]),cimag(z[i]), creal(fw),cimag(fw), creal(w[i]),cimag(w[i]), \
             re_err, im_err);                                           \
      if (re_err > errmax) errmax = re_err;                             \
      if (im_err > errmax) errmax = im_err;                             \
    }                                                                   \
    if (errmax > 1e-13) {                                               \
      printf("FAILURE -- relative error %g too large!\n", errmax);      \
      return 1;                                                         \
    }                                                                   \
    printf("Checking " #f "(x) special case...\n");                     \
    for (int i = 0; i < 10000; ++i) {                                   \
      double x = pow(10., -300. + i * 600. / (10000 - 1));              \
      double re_err = relerr(FADDEEVA_RE(f)(x),                         \
                             creal(FADDEEVA(f)(C(x,x*isc),0.)));        \
      if (re_err > errmax) errmax = re_err;                             \
      re_err = relerr(FADDEEVA_RE(f)(-x),                               \
                      creal(FADDEEVA(f)(C(-x,x*isc),0.)));              \
      if (re_err > errmax) errmax = re_err;                             \
    }                                                                   \
    {                                                                   \
      double re_err = relerr(FADDEEVA_RE(f)(Inf),                       \
                             creal(FADDEEVA(f)(C(Inf,0.),0.))); \
      if (re_err > errmax) errmax = re_err;                             \
      re_err = relerr(FADDEEVA_RE(f)(-Inf),                             \
                      creal(FADDEEVA(f)(C(-Inf,0.),0.)));               \
      if (re_err > errmax) errmax = re_err;                             \
      re_err = relerr(FADDEEVA_RE(f)(NaN),                              \
                      creal(FADDEEVA(f)(C(NaN,0.),0.)));                \
      if (re_err > errmax) errmax = re_err;                             \
    }                                                                   \
    if (errmax > 1e-13) {                                               \
      printf("FAILURE -- relative error %g too large!\n", errmax);      \
      return 1;                                                         \
    }                                                                   \
    printf("SUCCESS (max relative error = %g)\n", errmax);              \
    if (errmax > errmax_all) errmax_all = errmax

    TST(erf, 1e-20);
  }
  {
    // since erfi just calls through to erf, just one test should
    // be sufficient to make sure I didn't screw up the signs or something
#undef NTST
#define NTST 1 // define instead of const for C compatibility
    cmplx z[NTST] = { C(1.234,0.5678) };
    cmplx w[NTST] = { // erfi(z[i]), computed with Maple
      C(1.081032284405373149432716643834106923212,
        1.926775520840916645838949402886591180834)
    };
    TST(erfi, 0);
  }
  {
    // since erfcx just calls through to w, just one test should
    // be sufficient to make sure I didn't screw up the signs or something
#undef NTST
#define NTST 1 // define instead of const for C compatibility
    cmplx z[NTST] = { C(1.234,0.5678) };
    cmplx w[NTST] = { // erfcx(z[i]), computed with Maple
      C(0.3382187479799972294747793561190487832579,
        -0.1116077470811648467464927471872945833154)
    };
    TST(erfcx, 0);
  }
  {
#undef NTST
#define NTST 30 // define instead of const for C compatibility
    cmplx z[NTST] = {
      C(1,2),
      C(-1,2),
      C(1,-2),
      C(-1,-2),
      C(9,-28),
      C(21,-33),
      C(1e3,1e3),
      C(-3001,-1000),
      C(1e160,-1e159),
      C(5.1e-3, 1e-8),
      C(0,2e-6),
      C(0,2),
      C(0,20),
      C(0,200),
      C(2e-6,0),
      C(2,0),
      C(20,0),
      C(200,0),
      C(Inf,0),
      C(-Inf,0),
      C(0,Inf),
      C(0,-Inf),
      C(Inf,Inf),
      C(Inf,-Inf),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,Inf),
      C(Inf,NaN),
      C(88,0)
    };
    cmplx w[NTST] = { // erfc(z[i]), evaluated with Maple
      C(1.536643565778565033991795559314192749442,
        5.049143703447034669543036958614140565553),
      C(0.4633564342214349660082044406858072505579,
        5.049143703447034669543036958614140565553),
      C(1.536643565778565033991795559314192749442,
        -5.049143703447034669543036958614140565553),
      C(0.4633564342214349660082044406858072505579,
        -5.049143703447034669543036958614140565553),
      C(-0.3359473673830576996788000505817956637777e304,
        0.1999896139679880888755589794455069208455e304),
      C(-0.3584459971462946066523939204836760283645e278,
        -0.3818954885257184373734213077678011282505e280),
      C(0.0003979577342851360897849852457775473112748,
        -0.00002801044116908227889681753993542916894856),
      C(2, 0),
      C(0, 0),
      C(0.9942453161409651998655870094589234450651,
        -0.1128349818335058741511924929801267822634e-7),
      C(1,
        -0.2256758334194034158904576117253481476197e-5),
      C(1,
        -18.56480241457555259870429191324101719886),
      C(1,
        -0.1474797539628786202447733153131835124599e173),
      C(1, -Inf),
      C(0.9999977432416658119838633199332831406314,
        0),
      C(0.004677734981047265837930743632747071389108,
        0),
      C(0.5395865611607900928934999167905345604088e-175,
        0),
      C(0, 0),
      C(0, 0),
      C(2, 0),
      C(1, -Inf),
      C(1, Inf),
      C(NaN, NaN),
      C(NaN, NaN),
      C(NaN, NaN),
      C(NaN, 0),
      C(1, NaN),
      C(NaN, NaN),
      C(NaN, NaN),
      C(0,0)
    };
    TST(erfc, 1e-20);
  }
  {
#undef NTST
#define NTST 48 // define instead of const for C compatibility
    cmplx z[NTST] = {
      C(2,1),
      C(-2,1),
      C(2,-1),
      C(-2,-1),
      C(-28,9),
      C(33,-21),
      C(1e3,1e3),
      C(-1000,-3001),
      C(1e-8, 5.1e-3),
      C(4.95e-3, -4.9e-3),
      C(5.1e-3, 5.1e-3),
      C(0.5, 4.9e-3),
      C(-0.5e1, 4.9e-4),
      C(-0.5e2, -4.9e-5),
      C(0.5e3, 4.9e-6),
      C(0.5, 5.1e-3),
      C(-0.5e1, 5.1e-4),
      C(-0.5e2, -5.1e-5),
      C(1e-6,2e-6),
      C(2e-6,0),
      C(2,0),
      C(20,0),
      C(200,0),
      C(0,4.9e-3),
      C(0,-5.1e-3),
      C(0,2e-6),
      C(0,-2),
      C(0,20),
      C(0,-200),
      C(Inf,0),
      C(-Inf,0),
      C(0,Inf),
      C(0,-Inf),
      C(Inf,Inf),
      C(Inf,-Inf),
      C(NaN,NaN),
      C(NaN,0),
      C(0,NaN),
      C(NaN,Inf),
      C(Inf,NaN),
      C(39, 6.4e-5),
      C(41, 6.09e-5),
      C(4.9e7, 5e-11),
      C(5.1e7, 4.8e-11),
      C(1e9, 2.4e-12),
      C(1e11, 2.4e-14),
      C(1e13, 2.4e-16),
      C(1e300, 2.4e-303)
    };
    cmplx w[NTST] = { // dawson(z[i]), evaluated with Maple
      C(0.1635394094345355614904345232875688576839,
        -0.1531245755371229803585918112683241066853),
      C(-0.1635394094345355614904345232875688576839,
        -0.1531245755371229803585918112683241066853),
      C(0.1635394094345355614904345232875688576839,
        0.1531245755371229803585918112683241066853),
      C(-0.1635394094345355614904345232875688576839,
        0.1531245755371229803585918112683241066853),
      C(-0.01619082256681596362895875232699626384420,
        -0.005210224203359059109181555401330902819419),
      C(0.01078377080978103125464543240346760257008,
        0.006866888783433775382193630944275682670599),
      C(-0.5808616819196736225612296471081337245459,
        0.6688593905505562263387760667171706325749),
      C(Inf,
        -Inf),
      C(0.1000052020902036118082966385855563526705e-7,
        0.005100088434920073153418834680320146441685),
      C(0.004950156837581592745389973960217444687524,
        -0.004899838305155226382584756154100963570500),
      C(0.005100176864319675957314822982399286703798,
        0.005099823128319785355949825238269336481254),
      C(0.4244534840871830045021143490355372016428,
        0.002820278933186814021399602648373095266538),
      C(-0.1021340733271046543881236523269967674156,
        -0.00001045696456072005761498961861088944159916),
      C(-0.01000200120119206748855061636187197886859,
        0.9805885888237419500266621041508714123763e-8),
      C(0.001000002000012000023960527532953151819595,
        -0.9800058800588007290937355024646722133204e-11),
      C(0.4244549085628511778373438768121222815752,
        0.002935393851311701428647152230552122898291),
      C(-0.1021340732357117208743299813648493928105,
        -0.00001088377943049851799938998805451564893540),
      C(-0.01000200120119126652710792390331206563616,
        0.1020612612857282306892368985525393707486e-7),
      C(0.1000000000007333333333344266666666664457e-5,
        0.2000000000001333333333323199999999978819e-5),
      C(0.1999999999994666666666675199999999990248e-5,
        0),
      C(0.3013403889237919660346644392864226952119,
        0),
      C(0.02503136792640367194699495234782353186858,
        0),
      C(0.002500031251171948248596912483183760683918,
        0),
      C(0,0.004900078433419939164774792850907128053308),
      C(0,-0.005100088434920074173454208832365950009419),
      C(0,0.2000000000005333333333341866666666676419e-5),
      C(0,-48.16001211429122974789822893525016528191),
      C(0,0.4627407029504443513654142715903005954668e174),
      C(0,-Inf),
      C(0,0),
      C(-0,0),
      C(0, Inf),
      C(0, -Inf),
      C(NaN, NaN),
      C(NaN, NaN),
      C(NaN, NaN),
      C(NaN, 0),
      C(0, NaN),
      C(NaN, NaN),
      C(NaN, NaN),
      C(0.01282473148489433743567240624939698290584,
        -0.2105957276516618621447832572909153498104e-7),
      C(0.01219875253423634378984109995893708152885,
        -0.1813040560401824664088425926165834355953e-7),
      C(0.1020408163265306334945473399689037886997e-7,
        -0.1041232819658476285651490827866174985330e-25),
      C(0.9803921568627452865036825956835185367356e-8,
        -0.9227220299884665067601095648451913375754e-26),
      C(0.5000000000000000002500000000000000003750e-9,
        -0.1200000000000000001800000188712838420241e-29),
      C(5.00000000000000000000025000000000000000000003e-12,
        -1.20000000000000000000018000000000000000000004e-36),
      C(5.00000000000000000000000002500000000000000000e-14,
        -1.20000000000000000000000001800000000000000000e-42),
      C(5e-301, 0)
    };
    TST(Dawson, 1e-20);
  }
  printf("#####################################\n");
  printf("SUCCESS (max relative error = %g)\n", errmax_all);
}

#endif

#endif

//end file: faddeeva_mit.h


#endif /* XFIELDS_FADDEEVA_H */


// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2023.                   //
// ########################################### //

#ifndef XFIELDS_BIGAUSSIAN_H
#define XFIELDS_BIGAUSSIAN_H


// for quick test with gcc
//#include "constants.h" //only_for_context none
//#include "faddeeva.h" //only_for_context none
//#include "complex_error_function.h" //only_for_context none
//#include "compute_gx_gy.h" //only_for_context none

//from file: compute_gx_gy.h

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_COMPUTE_GX_GY
#define XFIELDS_COMPUTE_GX_GY

 static inline void compute_Gx_Gy(
        const double x,
        const double y,
        const double sigma_x,
        const double sigma_y,
        const double min_sigma_diff,
        const double Ex,
        const double Ey,
        double* Gx_ptr,
        double* Gy_ptr) {

    double Gx, Gy;

    if (fabs(sigma_x-sigma_y) < min_sigma_diff) {
        const double sigma = 0.5 * (sigma_x+sigma_y);
        if ((x*x + y*y) < 1e-14) {
            Gx = 1./(8 * PI * EPSILON_0 * sigma * sigma);
            Gy = Gx;
        }
	    else {
            Gx = 1/(2.*(x*x+y*y))*(y*Ey-x*Ex+1./(2*PI*EPSILON_0*sigma*sigma)
                    *x*x*exp(-(x*x+y*y)/(2.*sigma*sigma)));
            Gy = 1./(2*(x*x+y*y))*(x*Ex-y*Ey+1./(2*PI*EPSILON_0*sigma*sigma)
                    *y*y*exp(-(x*x+y*y)/(2.*sigma*sigma)));
	    }
    }
    else {
        const double Sig_11 = sigma_x*sigma_x;
        const double Sig_33 = sigma_y*sigma_y;

        Gx = -1./(2*(Sig_11-Sig_33))*(x*Ex+y*Ey+1./(2*PI*EPSILON_0)
                *(sigma_y/sigma_x*exp(-x*x/(2*Sig_11)-y*y/(2*Sig_33))-1.));
        Gy = 1./(2*(Sig_11-Sig_33))*(x*Ex+y*Ey+1./(2*PI*EPSILON_0)*
                (sigma_x/sigma_y*exp(-x*x/(2*Sig_11)-y*y/(2*Sig_33))-1.));

    }

    *Gx_ptr = Gx;
    *Gy_ptr = Gy;
}

#endif //XFIELDS_COMPUTE_GX_GY

//end file: compute_gx_gy.h


 static inline
void get_charge_density(const double x,
                      const double y,
                      const double sigma_x,
                      const double sigma_y,
                      double* rho)
{

  // this is a PDF
  double factor = 1 / (2*PI*sigma_x*sigma_y);
  double exp_x = exp(-x*x/(2*sigma_x*sigma_x));
  double exp_y = exp(-y*y/(2*sigma_y*sigma_y));
  *rho = factor * exp_x * exp_y;  // [m^-2]
}

 static inline
void get_transv_field_gauss_round(
    double sigma, double Delta_x, double Delta_y,
    double x, double y,
    double* Ex,
    double* Ey)
{
  double r2, temp;

  r2 = (x-Delta_x)*(x-Delta_x)+(y-Delta_y)*(y-Delta_y);
  double const inv_sig2 = 1./(sigma*sigma);
  double const r2_sig2 = r2 * inv_sig2;
  if (r2_sig2<1e-10) temp = inv_sig2/(4.*PI*EPSILON_0); //linearised
  else temp = inv_sig2 * (1-exp(-0.5*r2_sig2))/(2.*PI*EPSILON_0*r2_sig2);

  (*Ex) = temp * (x-Delta_x);
  (*Ey) = temp * (y-Delta_y);
}

 static inline
void get_transv_field_gauss_ellip(
        double sigma_x,  double sigma_y,
        double Delta_x,  double Delta_y,
        const double x,
	const double y,
        double* Ex_out,
        double* Ey_out)
{
  double sigmax = sigma_x;
  double sigmay = sigma_y;

  // I always go to the first quadrant and then apply the signs a posteriori
  // numerically more stable (see http://inspirehep.net/record/316705/files/slac-pub-5582.pdf)

  double abx = fabs(x - Delta_x);
  double aby = fabs(y - Delta_y);

  double S, factBE, Ex, Ey;
  double etaBE_re, etaBE_im, zetaBE_re, zetaBE_im;
  double w_etaBE_re, w_etaBE_im, w_zetaBE_re, w_zetaBE_im;
  double expBE;


  if (sigmax>sigmay){
    S = sqrt(2.*(sigmax*sigmax-sigmay*sigmay));
    factBE = 1./(2.*EPSILON_0*SQRT_PI*S);

    etaBE_re = sigmay/sigmax*abx;
    etaBE_im = sigmax/sigmay*aby;

    zetaBE_re = abx;
    zetaBE_im = aby;

    //w_zetaBE_re, w_zetaBE_im = wfun(zetaBE_re/S, zetaBE_im/S)
    faddeeva_w(zetaBE_re/S, zetaBE_im/S , &(w_zetaBE_re), &(w_zetaBE_im));

    //w_etaBE_re, w_etaBE_im = wfun(etaBE_re/S, etaBE_im/S)
    faddeeva_w(etaBE_re/S, etaBE_im/S , &(w_etaBE_re), &(w_etaBE_im));

    expBE = exp(-abx*abx/(2*sigmax*sigmax)-aby*aby/(2*sigmay*sigmay));

    Ex = factBE*(w_zetaBE_im - w_etaBE_im*expBE);
    Ey = factBE*(w_zetaBE_re - w_etaBE_re*expBE);

  }
  else if (sigmax<sigmay){
    S = sqrt(2.*(sigmay*sigmay-sigmax*sigmax));
    factBE = 1./(2.*EPSILON_0*SQRT_PI*S);

    etaBE_re = sigmax/sigmay*aby;
    etaBE_im = sigmay/sigmax*abx;

    zetaBE_re = aby;
    zetaBE_im = abx;

    //w_zetaBE_re, w_zetaBE_im = wfun(zetaBE_re/S, zetaBE_im/S)
    faddeeva_w(zetaBE_re/S, zetaBE_im/S , &(w_zetaBE_re), &(w_zetaBE_im));

    //w_etaBE_re, w_etaBE_im = wfun(etaBE_re/S, etaBE_im/S)
    faddeeva_w(etaBE_re/S, etaBE_im/S , &(w_etaBE_re), &(w_etaBE_im));

    expBE = exp(-aby*aby/(2*sigmay*sigmay)-abx*abx/(2*sigmax*sigmax));

    Ey = factBE*(w_zetaBE_im - w_etaBE_im*expBE);
    Ex = factBE*(w_zetaBE_re - w_etaBE_re*expBE);

  }
  else{
    Ex = Ey = 0.;
  }

  if((x - Delta_x)<0) Ex=-Ex;
  if((y - Delta_y)<0) Ey=-Ey;

  (*Ex_out) = Ex;
  (*Ey_out) = Ey;
}

 static inline
void get_Ex_Ey_gauss(
             const double  x,
             const double  y,
             const double  sigma_x,
             const double  sigma_y,
             const double  min_sigma_diff,
             double* Ex_ptr,
             double* Ey_ptr){

        // round beam
	if (fabs(sigma_x-sigma_y)< min_sigma_diff){
	    double sigma = 0.5*(sigma_x+sigma_y);
	    	get_transv_field_gauss_round(sigma, 0., 0., x, y, Ex_ptr, Ey_ptr);
	}

        // elliptical beam
	else{
	    get_transv_field_gauss_ellip(
	            sigma_x, sigma_y, 0., 0., x, y, Ex_ptr, Ey_ptr);

	}
}

#endif // XFIELDS_BIGAUSSIAN_H

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_BEAMBEAM3D_TRASPORT_SIGMAS_H
#define XFIELDS_BEAMBEAM3D_TRASPORT_SIGMAS_H

#if !defined(mysign)
    #define mysign(a) (((a) >= 0) - ((a) < 0))
#endif

 static inline
void Sigmas_propagate(
        double const Sig_11_0,
        double const Sig_12_0,
        double const Sig_13_0,
        double const Sig_14_0,
        double const Sig_22_0,
        double const Sig_23_0,
        double const Sig_24_0,
        double const Sig_33_0,
        double const Sig_34_0,
        double const Sig_44_0,
        double const S,
        double const threshold_singular,
        int64_t const handle_singularities,
        double* Sig_11_hat_ptr,
        double* Sig_33_hat_ptr,
        double* costheta_ptr,
        double* sintheta_ptr,
        double* dS_Sig_11_hat_ptr,
        double* dS_Sig_33_hat_ptr,
        double* dS_costheta_ptr,
        double* dS_sintheta_ptr)
{

    // Propagate sigma matrix
    double const Sig_11 = Sig_11_0 + 2.*Sig_12_0*S+Sig_22_0*S*S;
    double const Sig_33 = Sig_33_0 + 2.*Sig_34_0*S+Sig_44_0*S*S;
    double const Sig_13 = Sig_13_0 + (Sig_14_0+Sig_23_0)*S+Sig_24_0*S*S;

    double const Sig_12 = Sig_12_0 + Sig_22_0*S;
    double const Sig_14 = Sig_14_0 + Sig_24_0*S;
    double const Sig_22 = Sig_22_0 + 0.*S;
    double const Sig_23 = Sig_23_0 + Sig_24_0*S;
    double const Sig_24 = Sig_24_0 + 0.*S;
    double const Sig_34 = Sig_34_0 + Sig_44_0*S;
    double const Sig_44 = Sig_44_0 + 0.*S;

    double const R = Sig_11-Sig_33;
    double const W = Sig_11+Sig_33;
    double const T = R*R+4*Sig_13*Sig_13;

    //evaluate derivatives
    double const dS_R = 2.*(Sig_12_0-Sig_34_0)+2*S*(Sig_22_0-Sig_44_0);
    double const dS_W = 2.*(Sig_12_0+Sig_34_0)+2*S*(Sig_22_0+Sig_44_0);
    double const dS_Sig_13 = Sig_14_0 + Sig_23_0 + 2*Sig_24_0*S;
    double const dS_T = 2*R*dS_R+8.*Sig_13*dS_Sig_13;

    double Sig_11_hat, Sig_33_hat, costheta, sintheta, dS_Sig_11_hat,
           dS_Sig_33_hat, dS_costheta, dS_sintheta, cos2theta, dS_cos2theta;

    double const signR = mysign(R);


    if (T<threshold_singular && handle_singularities){
        double const a = Sig_12-Sig_34;
        double const b = Sig_22-Sig_44;
        double const c = Sig_14+Sig_23;
        double const d = Sig_24;

        double sqrt_a2_c2 = sqrt(a*a+c*c);

        if (sqrt_a2_c2*sqrt_a2_c2*sqrt_a2_c2 < threshold_singular){
        //equivalent to: if np.abs(c)<threshold_singular and np.abs(a)<threshold_singular:

            if (fabs(d)> threshold_singular){
                cos2theta = fabs(b)/sqrt(b*b+4*d*d);
                }
            else{
                cos2theta = 1.;
                } // Decoupled beam

            costheta = sqrt(0.5*(1.+cos2theta));
            sintheta = mysign(b)*mysign(d)*sqrt(0.5*(1.-cos2theta));

            dS_costheta = 0.;
            dS_sintheta = 0.;

            Sig_11_hat = 0.5*W;
            Sig_33_hat = 0.5*W;

            dS_Sig_11_hat = 0.5*dS_W;
            dS_Sig_33_hat = 0.5*dS_W;
        }
        else{
            sqrt_a2_c2 = sqrt(a*a+c*c); //repeated?
            cos2theta = fabs(2.*a)/(2*sqrt_a2_c2);
            costheta = sqrt(0.5*(1.+cos2theta));
            sintheta = mysign(a)*mysign(c)*sqrt(0.5*(1.-cos2theta));

            dS_cos2theta = mysign(a)*(0.5*b/sqrt_a2_c2-a*(a*b+2.*c*d)/(2.*sqrt_a2_c2*sqrt_a2_c2*sqrt_a2_c2));

            dS_costheta = 1./(4.*costheta)*dS_cos2theta;
            if (fabs(sintheta)>threshold_singular){
            //equivalent to: if np.abs(c)>threshold_singular:
                dS_sintheta = -1./(4.*sintheta)*dS_cos2theta;
            }
            else{
                dS_sintheta = d/(2.*a);
            }

            Sig_11_hat = 0.5*W;
            Sig_33_hat = 0.5*W;

            dS_Sig_11_hat = 0.5*dS_W + mysign(a)*sqrt_a2_c2;
            dS_Sig_33_hat = 0.5*dS_W - mysign(a)*sqrt_a2_c2;
        }
    }
    else{
        double const sqrtT = sqrt(T);
        cos2theta = signR*R/sqrtT;
        costheta = sqrt(0.5*(1.+cos2theta));
        sintheta = signR*mysign(Sig_13)*sqrt(0.5*(1.-cos2theta));

        //in sixtrack this line seems to be different
        // sintheta = -mysign((Sig_11-Sig_33))*np.sqrt(0.5*(1.-cos2theta))
       Sig_11_hat = 0.5*(W+signR*sqrtT);
       Sig_33_hat = 0.5*(W-signR*sqrtT);

        dS_cos2theta = signR*(dS_R/sqrtT - R/(2*sqrtT*sqrtT*sqrtT)*dS_T);
        dS_costheta = 1./(4.*costheta)*dS_cos2theta;

        if (fabs(sintheta)<threshold_singular && handle_singularities){
        //equivalent to to np.abs(Sig_13)<threshold_singular
            dS_sintheta = (Sig_14+Sig_23)/R;
        }
        else{
            dS_sintheta = -1./(4.*sintheta)*dS_cos2theta;
        }

        dS_Sig_11_hat = 0.5*(dS_W + signR*0.5/sqrtT*dS_T);
        dS_Sig_33_hat = 0.5*(dS_W - signR*0.5/sqrtT*dS_T);
    }

    *Sig_11_hat_ptr = Sig_11_hat;
    *Sig_33_hat_ptr = Sig_33_hat;
    *costheta_ptr = costheta;
    *sintheta_ptr = sintheta;
    *dS_Sig_11_hat_ptr = dS_Sig_11_hat;
    *dS_Sig_33_hat_ptr = dS_Sig_33_hat;
    *dS_costheta_ptr = dS_costheta;
    *dS_sintheta_ptr = dS_sintheta;

}

#endif

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_BEAMBEAM3D_REF_FRAME_CHANGES_H
#define XFIELDS_BEAMBEAM3D_REF_FRAME_CHANGES_H


 static inline
void boost_coordinates(
        double const sphi,
        double const cphi,
        double const tphi,
        double const salpha,
        double const calpha,
        double* x_star,
        double* px_star,
        double* y_star,
        double* py_star,
        double* sigma_star,
        double* delta_star){


    double const x = *x_star;
    double const px = *px_star;
    double const y = *y_star;
    double const py = *py_star ;
    double const sigma = *sigma_star;
    double const delta = *delta_star ;

    double const h = delta + 1. - sqrt((1.+delta)*(1.+delta)-px*px-py*py);


    double const px_st = px/cphi-h*calpha*tphi/cphi;
    double const py_st = py/cphi-h*salpha*tphi/cphi;
    double const delta_st = delta -px*calpha*tphi-py*salpha*tphi+h*tphi*tphi;

    double const pz_st =
        sqrt((1.+delta_st)*(1.+delta_st)-px_st*px_st-py_st*py_st);

    double const hx_st = px_st/pz_st;
    double const hy_st = py_st/pz_st;
    double const hsigma_st = 1.-(delta_st+1)/pz_st;

    double const L11 = 1.+hx_st*calpha*sphi;
    double const L12 = hx_st*salpha*sphi;
    double const L13 = calpha*tphi;

    double const L21 = hy_st*calpha*sphi;
    double const L22 = 1.+hy_st*salpha*sphi;
    double const L23 = salpha*tphi;

    double const L31 = hsigma_st*calpha*sphi;
    double const L32 = hsigma_st*salpha*sphi;
    double const L33 = 1./cphi;

    double const x_st = L11*x + L12*y + L13*sigma;
    double const y_st = L21*x + L22*y + L23*sigma;
    double const sigma_st = L31*x + L32*y + L33*sigma;

    *x_star = x_st;
    *px_star = px_st;
    *y_star = y_st;
    *py_star = py_st;
    *sigma_star = sigma_st;
    *delta_star = delta_st;

}

 static inline
void boost_coordinates_inv(
        double const sphi,
        double const cphi,
        double const tphi,
        double const salpha,
        double const calpha,
        double* x,
        double* px,
        double* y,
        double* py,
        double* sigma,
        double* delta){

    double const x_st = *x;
    double const px_st = *px;
    double const y_st = *y;
    double const py_st = *py ;
    double const sigma_st = *sigma;
    double const delta_st = *delta ;

    double const pz_st = sqrt((1.+delta_st)*(1.+delta_st)-px_st*px_st-py_st*py_st);
    double const hx_st = px_st/pz_st;
    double const hy_st = py_st/pz_st;
    double const hsigma_st = 1.-(delta_st+1)/pz_st;

    double const Det_L =
        1./cphi + (hx_st*calpha + hy_st*salpha-hsigma_st*sphi)*tphi;

    double const Linv_11 =
        (1./cphi + salpha*tphi*(hy_st-hsigma_st*salpha*sphi))/Det_L;

    double const Linv_12 =
        (salpha*tphi*(hsigma_st*calpha*sphi-hx_st))/Det_L;

    double const Linv_13 =
        -tphi*(calpha - hx_st*salpha*salpha*sphi + hy_st*calpha*salpha*sphi)/Det_L;

    double const Linv_21 =
        (calpha*tphi*(-hy_st + hsigma_st*salpha*sphi))/Det_L;

    double const Linv_22 =
        (1./cphi + calpha*tphi*(hx_st-hsigma_st*calpha*sphi))/Det_L;

    double const Linv_23 =
        -tphi*(salpha - hy_st*calpha*calpha*sphi + hx_st*calpha*salpha*sphi)/Det_L;

    double const Linv_31 = -hsigma_st*calpha*sphi/Det_L;
    double const Linv_32 = -hsigma_st*salpha*sphi/Det_L;
    double const Linv_33 = (1. + hx_st*calpha*sphi + hy_st*salpha*sphi)/Det_L;

    double const x_i = Linv_11*x_st + Linv_12*y_st + Linv_13*sigma_st;
    double const y_i = Linv_21*x_st + Linv_22*y_st + Linv_23*sigma_st;
    double const sigma_i = Linv_31*x_st + Linv_32*y_st + Linv_33*sigma_st;

    double const h = (delta_st+1.-pz_st)*cphi*cphi;

    double const px_i = px_st*cphi+h*calpha*tphi;
    double const py_i = py_st*cphi+h*salpha*tphi;

    double const delta_i = delta_st + px_i*calpha*tphi + py_i*salpha*tphi - h*tphi*tphi;


    *x = x_i;
    *px = px_i;
    *y = y_i;
    *py = py_i;
    *sigma = sigma_i;
    *delta = delta_i;

}

 static inline
void change_ref_frame_coordinates(
        double* x, double* px, double* y, double* py, double* zeta, double* pzeta,
        double const shift_x, double const shift_px,
        double const shift_y, double const shift_py,
        double const shift_zeta, double const shift_pzeta,
        double const sin_phi, double const cos_phi, double const tan_phi,
        double const sin_alpha, double const cos_alpha){

    // Change reference frame
    double x_star =     *x     - shift_x;
    double px_star =    *px    - shift_px;
    double y_star =     *y     - shift_y;
    double py_star =    *py    - shift_py;
    double zeta_star =  *zeta  - shift_zeta;
    double pzeta_star = *pzeta - shift_pzeta;

    // Boost coordinates of the weak beam
    boost_coordinates(
        sin_phi, cos_phi, tan_phi, sin_alpha, cos_alpha,
        &x_star, &px_star, &y_star, &py_star,
        &zeta_star, &pzeta_star);

    *x = x_star;
    *px = px_star;
    *y = y_star;
    *py = py_star;
    *zeta = zeta_star;
    *pzeta = pzeta_star;
    }

 static inline
void change_back_ref_frame_and_subtract_dipolar_coordinates(
        double* x, double* px,
        double* y, double* py,
        double* zeta, double* pzeta,
        double const shift_x, double const shift_px,
        double const shift_y, double const shift_py,
        double const shift_zeta, double const shift_pzeta,
        double const post_subtract_x, double const post_subtract_px,
        double const post_subtract_y, double const post_subtract_py,
        double const post_subtract_zeta, double const post_subtract_pzeta,
        double const sin_phi, double const cos_phi, double const tan_phi,
        double const sin_alpha, double const cos_alpha){

    // Inverse boost on the coordinates of the weak beam
    boost_coordinates_inv(
        sin_phi, cos_phi, tan_phi, sin_alpha, cos_alpha,
        x, px, y, py, zeta, pzeta);

    // Go back to original reference frame and remove dipolar effect
    *x =     *x     + shift_x     - post_subtract_x;
    *px =    *px    + shift_px    - post_subtract_px;
    *y =     *y     + shift_y     - post_subtract_y;
    *py =    *py    + shift_py    - post_subtract_py;
    *zeta =  *zeta  + shift_zeta  - post_subtract_zeta;
    *pzeta = *pzeta + shift_pzeta - post_subtract_pzeta;

    }

#endif

#ifndef XFIELDS_BEAMSTRAHLUNG_SPECTRUM_H
#define XFIELDS_BEAMSTRAHLUNG_SPECTRUM_H

#define SQRT3 1.732050807568877
#define ALPHA_EM 0.0072973525693


 static inline
int beamstrahlung_0(LocalParticle *part,
             double energy,     // [eV] primary electron energy
             double dz,         // [m] z slice half width
             double rho_inv,    // [1/m] inverse local bending radius, changes after each photon emission
             double* e_photon,  // [GeV] emitted BS photon energy
             double* ecrit      // [GeV] critical energy of emitted BS photon
){
    /*
    Based on:
    GUINEA-PIG
    https://gitlab.cern.ch/clic-software/guinea-pig-legacy/-/blob/master/guinea_pig.c#L1894
    and
    K. Yokoya: A COMPUTER SIMULATION CODE FOR THE BEAM-BEAM INTERACTION IN LINEAR COLLIDERS
    https://inis.iaea.org/collection/NCLCollectionStore/_Public/18/033/18033162.pdf?r=1
    ----
    return 0: no photon
    return 1: emit 1 photon, energy stored in e_photon
    */

    // constants for approximating beamstrahlung spectrum
    const double g1_a[5] = {1.0, -0.8432885317, 0.1835132767, -0.0527949659, 0.0156489316};
    const double g2_a[5] = {0.4999456517, -0.5853467515, 0.3657833336, -0.0695055284, 0.019180386};
    const double g1_b[7] = {2.066603927, -0.5718025331, 0.04243170587, -0.9691386396, 5.651947051, -0.6903991322, 1.0};
    const double g2_b[7] = {1.8852203645, -0.5176616313, 0.03812218492, -0.49158806, 6.1800441958, -0.6524469236, 1.0};
    const double g1_c[4] = {1.0174394594, 0.5831679349, 0.9949036186, 1.0};
    const double g2_c[4] = {0.2847316689, 0.58306846, 0.3915531539, 1.0};

    double c1 = 1.5*HBAR_GEVS / pow(MELECTRON_GEV, 3.0) * C_LIGHT;  // [c^4/Gev^2] 2.22e-6 = 1.5*hbar*cst.c/e0**3

    double xcrit = c1 * pow(energy*1e-9, 2.0) * rho_inv; // [1] ecrit/E magnitude of quantum correction, in guineapig: xcrit (C) = xi (doc) = upsbar (C++)
    (*ecrit) = xcrit * energy*1e-9; // [GeV]
    //double omega_crit = (*ecrit)/HBAR_GEVS;  // [1/s] = 1.5 * gamma**3 * cst.c / rho
    //double upsilon = 2.0/3.0 * (*ecrit) / (energy*1e-9);  // [1] beamstrahlung parameter for single macropart
    double p0 = 25.4 * energy*1e-9 * dz * rho_inv;  // [1]  Fr * dz, specific for 1 macropart
 
    // eliminate region A in p0*g-v plane (=normalize with p0 = reject 1-p0 (p0<1) fraction of cases = y axis of p0*g-v plane is now spanning 0--p0=1
    if (RandomUniform_generate(part) > p0){return 0;}

    // 2 random numbers to calculate g(v, xcrit)
    double p = RandomUniform_generate(part);  // if this is 1, then it corresponds to p0 on original p0*g-v plane
    double v;
    while((v=RandomUniform_generate(part))==0); // draw a nonzero random number, variable of the beamstrahlung spectrum
    double v2 = v*v;
    double v3 = v2*v;
    double y = v3 / (1.0 - v3);
    double denom = 1.0 - ( 1.0 - xcrit ) * v3;

    // calculate beamstrahlung spectrum coefficients, depending the value of y
    double g1, g2;
    if (y <= 1.54){
        g1 = pow(y, -2.0/3.0) * (g1_a[0] + g1_a[1]*pow(y, 2.0/3.0) + g1_a[2]*pow(y, 2.0) + g1_a[3]*pow(y, 10.0/3.0) + g1_a[4]*pow(y, 4.0));
        g2 = pow(y, -2.0/3.0) * (g2_a[0] + g2_a[1]*pow(y, 4.0/3.0) + g2_a[2]*pow(y, 2.0) + g2_a[3]*pow(y, 10.0/3.0) + g2_a[4]*pow(y, 4.0));
    }else if (y <= 4.48){
        g1 = ( g1_b[0] + g1_b[1]*y + g1_b[2]*pow(y, 2.0) ) / ( g1_b[3] + g1_b[4]*y + g1_b[5]*pow(y, 2.0) + g1_b[6]*pow(y, 3.0) );
        g2 = ( g2_b[0] + g2_b[1]*y + g2_b[2]*pow(y, 2.0) ) / ( g2_b[3] + g2_b[4]*y + g2_b[5]*pow(y, 2.0) + g2_b[6]*pow(y, 3.0) );
    }else if (y <= 165.0){
        g1 = exp(-y)/sqrt(y) * ( g1_c[0] + g1_c[1]*y ) / ( g1_c[2] + g1_c[3]*y );
        g2 = exp(-y)/sqrt(y) * ( g2_c[0] + g2_c[1]*y ) / ( g2_c[2] + g2_c[3]*y );
    }else{
        // no radiation, y too high
        return 0;
    }
        
    // g normalized (g(v=0, xcrit)=1), g(v, xcrit) gives the no. of emitted photons in a given delta v interval
    double g = v2 / pow(denom, 2.0) * ( g1 + ( pow(xcrit, 2.0) * pow(y, 2.0) ) / ( 1.0 + xcrit * y ) * g2 );  // g (w.o. normalization above) splits the unit rectangle p0*g-v to A,B,C regions
   
    // region C (emit photon) if p<p0*g, region B (no photon) if p>=p0*g, p0=1 bc. of normalization above
    if (p<g){
        (*e_photon) = (*ecrit) * v3 / denom;
        return 1;
    }else{
        (*e_photon) = 0.0;
        return 0;
    }
}


 static inline
double beamstrahlung_avg(LocalParticle *part, BeamBeamBiGaussian3DRecordData beamstrahlung_record, RecordIndex beamstrahlung_table_index, BeamstrahlungTableData beamstrahlung_table,
        const double n_bb, // [1] strong slice bunch intensity
        const double sigma_x, const double sigma_y, const double sigma_z  // [m] unboosted strong slice RMS
){
    /*
    Based on:
    K. Yokoya: Beam-Beam Phenomena In Linear Colliders
    https://doi.org/10.1007/3-540-55250-2_37
    ----
    n_bb and sigma_z are scaled with the (same) slice weights
    n_avg ~ n_bb -> 1/num_slices less photons per mp in 1 slice
    delta_avg ~ n_bb^2/sigma_z -> 1/num_slices less rel. E loss per mp in 1 slice
    e_photon_avg = delta_avg / n_avg -> avg. photon energy is the same in 1 slice
    */

    // beam properties
    const double m0             = LocalParticle_get_mass0(part); // [eV/c] beam particle mass
    const double initial_energy = LocalParticle_get_energy0(part) + LocalParticle_get_ptau(part)*LocalParticle_get_p0c(part); // [eV]
    const double gamma          = initial_energy / m0; // [1] 

    // constants
    const double r  = pow(QELEM, 2.0)/(4.0* PI * EPSILON_0 * MELECTRON_KG * pow(C_LIGHT, 2.0));      // [m] electron radius
    const double c1 = 2.59 * ( 5.0/ 6.0) * (    r*r) / REDUCED_COMPTON_WAVELENGTH_ELECTRON;          // [m]
    const double c2 =  1.2 * (25.0/36.0) * (r*r*r*r) / REDUCED_COMPTON_WAVELENGTH_ELECTRON * 137.0;  // [m^3]

    // compute averaged quantities
    double n_avg        = c1 * n_bb/(sigma_x + sigma_y);  // [1] avg. number of emitted photons from 1 macroparticle in one slice collision
    double delta_avg    = c2 * gamma/sigma_z * (n_bb/(sigma_x + sigma_y))*(n_bb/(sigma_x + sigma_y));  // [1] avg. rel. E loss for 1 macroparticle in one slice collision
    double U_BS         = delta_avg*initial_energy;  // [eV] avg. energy loss per macropart in one slice collision
    double u_avg        = delta_avg/n_avg;           // [1] avg. rel. photon energy normalized to initial electron energy
    double e_photon_avg = u_avg*initial_energy;      // [eV] avg. photon energy
    LocalParticle_add_to_energy(part, -U_BS, 0);
    double energy_loss = -U_BS;  // <0

    if (beamstrahlung_record){

        // Get a slot in the record (this is thread safe)
        int64_t i_slot = RecordIndex_get_slot(beamstrahlung_table_index);

        // The returned slot id is negative if record is NULL or if record is full
        if (i_slot>=0){
            BeamstrahlungTableData_set_at_element(    beamstrahlung_table, i_slot, LocalParticle_get_at_element(part));
    	    BeamstrahlungTableData_set_at_turn(       beamstrahlung_table, i_slot, LocalParticle_get_at_turn(part)); 
            BeamstrahlungTableData_set_particle_id(   beamstrahlung_table, i_slot, LocalParticle_get_particle_id(part));
            BeamstrahlungTableData_set_primary_energy(beamstrahlung_table, i_slot, initial_energy);
	    BeamstrahlungTableData_set_photon_energy( beamstrahlung_table, i_slot, e_photon_avg);
            BeamstrahlungTableData_set_n_avg(         beamstrahlung_table, i_slot, n_avg);
            BeamstrahlungTableData_set_delta_avg(     beamstrahlung_table, i_slot, delta_avg);
	}
    }

    return energy_loss;
}


 static inline
double beamstrahlung(LocalParticle *part, BeamBeamBiGaussian3DRecordData beamstrahlung_record, RecordIndex beamstrahlung_table_index, BeamstrahlungTableData beamstrahlung_table,
     	double Fr,  // [1] radial force sqrt[(px' - px)^2 + (py' - py)^2]/Dt, Dt=1
	double dz   // [m] z slice half width: step between 2 slices ((z_max - z_min) / 2)
){
    /*
    Based on:
    GUINEA-PIG
    https://gitlab.cern.ch/clic-software/guinea-pig-legacy/-/blob/master/guinea_pig.c#L1962
    */

    // beam properties
    double initial_energy = LocalParticle_get_energy0(part) + LocalParticle_get_ptau(part)*LocalParticle_get_p0c(part); // [eV]
    double energy         = initial_energy;  // [eV]

    // single macroparticle trajectory 
    double rho_inv  = Fr / dz;  // [1/m] macropart inverse bending radius
    double tmp      = 25.4 * energy*1e-9 * dz * rho_inv;  // [1] p0, specific for 1 macropart, 1e-9 to convert [eV] to [GeV]
    int max_photons = (int)(tmp*10.0)+1;  // [1]
    dz /= (double)max_photons;  // photons are emitted uniformly in space along dz (between 2 slice interactions)

    // BS photon counter and BS photon energy buffer
    int j = 0;
    double e_photon_array[1000];
    for (int i=0; i<max_photons; i++){
   
        double e_photon, ecrit;  // [GeV] BS photon energy and critical energy
        if (beamstrahlung_0(part, energy, dz, rho_inv, &e_photon, &ecrit)){  // see if quantum photon can be emitted
            e_photon_array[j] = e_photon;  // [GeV]
           
            if (beamstrahlung_record){

                // Get a slot in the record (this is thread safe)
                int64_t i_slot = RecordIndex_get_slot(beamstrahlung_table_index);

                // The returned slot id is negative if record is NULL or if record is full
                if (i_slot>=0){
                    BeamstrahlungTableData_set_at_element(            beamstrahlung_table, i_slot, LocalParticle_get_at_element(part));
                    BeamstrahlungTableData_set_at_turn(               beamstrahlung_table, i_slot, LocalParticle_get_at_turn(part));
		    BeamstrahlungTableData_set_particle_id(           beamstrahlung_table, i_slot, LocalParticle_get_particle_id(part));
                    BeamstrahlungTableData_set_primary_energy(        beamstrahlung_table, i_slot, energy);
		    BeamstrahlungTableData_set_photon_id(             beamstrahlung_table, i_slot, j);
		    BeamstrahlungTableData_set_photon_energy(         beamstrahlung_table, i_slot, e_photon*1e9);
                    BeamstrahlungTableData_set_photon_critical_energy(beamstrahlung_table, i_slot, ecrit*1e9);
                    BeamstrahlungTableData_set_rho_inv(               beamstrahlung_table, i_slot, rho_inv);
                }
            }

            // update bending radius, primary macropart energy
            rho_inv *= energy/(energy - e_photon*1e9);
            energy  -= e_photon*1e9;

            // some error handling
            if (e_photon_array[j]<=0.0){
                printf("photon emitted with negative energy: E_photon=%g [eV], E_macropart=%g [eV], photon ID: %d, max_photons: %d\n", e_photon*1e9, energy, j, max_photons);
            }

            // increment photon counter
            j++;

            // break loop and flag macroparticle as dead
            if (j>=1000){
                printf("[%d] too many photons produced by one particle (photon ID: %d), Fr: %.12e, dz: %.12e\n", (int)part->ipart, j, Fr, dz);
                //exit(-1);  // doesnt work on GPU
                LocalParticle_set_state(part, XF_TOO_MANY_PHOTONS); // used to flag this kind of loss
                break;
            }

        }
    }

    // update primary macroparticle energy
    if (energy == 0.0){
        LocalParticle_set_state(part, XT_LOST_ALL_E_IN_SYNRAD); // used to flag this kind of loss
    }else{
       LocalParticle_add_to_energy(part, energy-initial_energy, 0);
    }
    double energy_loss = energy - initial_energy;  // <0

    return energy_loss;
}

#endif /* XFIELDS_BEAMSTRAHLUNG_SPECTRUM_H */

#ifndef XFIELDS_BHABHA_SPECTRUM_H
#define XFIELDS_BHABHA_SPECTRUM_H

/************************************************************************************/
/* Subroutines for the generation of the equivalent virtual photons for one primary */
/* Adapted from GUINEA-PIG                                                          */
/************************************************************************************/

 static inline
double rndm_sincos(LocalParticle *part, double *theta)
{
    const double twopi=2.0*PI;
    double r1;
    r1 = RandomUniform_generate(part);
    *theta = cos(twopi*r1);
    if (r1 > 0.5)
        return sqrt(1.0- *theta * *theta);
    else
        return -sqrt(1.0- *theta * *theta);
}


 static inline
float requiv(LocalParticle *part, const double e_primary, const double compt_x_min){
    /*
    Based on:
    GUINEA-PIG
    https://gitlab.cern.ch/clic-software/guinea-pig-legacy/-/blob/master/guinea_pig.c#L1205
    ----
    Returns the number of equivalent virtual (macro)photons for a single primary macroparticle of the beam.
    */
    const double emass2=MELECTRON_GEV*MELECTRON_GEV;
    double lnxmin, s4, xmin, lns4, r_photons, n_photons;

    s4 = e_primary*e_primary;  // [GeV^2] mandelstam s divided by 4: s/4
    xmin = compt_x_min * emass2 / s4;  // [1] virtual photon's energy fraction compared to primary energy

    if (xmin>=1.0) return 0.0;

    lnxmin=-log(xmin);
    lns4 = log(s4 / (MELECTRON_GEV*MELECTRON_GEV));

    r_photons = .00232461*lnxmin*(lnxmin + lns4);  // alpha/pi = 0.00232461

    // account for noninteger photon by randomly emitting n+1 sometimes
    n_photons = (int)floor(r_photons);
    r_photons -= n_photons;
    if(RandomUniform_generate(part) < r_photons) n_photons += 1.0;

    return n_photons;
}


 static inline
void mequiv (LocalParticle *part,
             const double e_primary,    // [GeV] other beam slice energy
             const double compt_x_min,  // [1] scaling factor in the minimum energy cutoff
             double *xmin,              // [1] cutoff x from where to integrate number density
             double *e_photon,          // [GeV] single equivalent virtual photon energy
             double *q2,                // [GeV^2] single equivalent virtual photon virtuality
             double *one_m_x            // [1] 1 - x
){
    /*
    Based on:
    GUINEA-PIG
    https://gitlab.cern.ch/clic-software/guinea-pig-legacy/-/blob/master/guinea_pig.c#L1248
    ----
    Sets the energy and virtuality of a single virtual photon.
    */
    const double emass2=MELECTRON_GEV*MELECTRON_GEV;
    double s4, q2max, q2min, lnx, x, lnxmin, lns4;
  
    s4 = e_primary*e_primary;  // [GeV^2] mandelstam s divided by 4: s/4
    *xmin = compt_x_min * emass2 / s4;  // [1] virtual photon's energy fraction compared to primary energy
  
    lnxmin = -log(*xmin);
    lns4 = log(s4 / (MELECTRON_GEV*MELECTRON_GEV));
  
    // set energy fraction and virtuality boundaires
    if(RandomUniform_generate(part) < lnxmin / (lnxmin + lns4)){
        lnx   = -sqrt(RandomUniform_generate(part)) * lnxmin;
        x     = exp(lnx);
        q2min = x*x*emass2;
        q2max = emass2;
    }
    else{
        lnx   = -RandomUniform_generate(part) * lnxmin;
        x     = exp(lnx);
        q2min = emass2;
        q2max = s4;
    }
  
    // set virtual photon energy and virtuality
    if((1.0 + (1.0 - x) * (1.0 - x)) * 0.5 < RandomUniform_generate(part)){
        *e_photon = 0.0;
        *q2  = 0.0;
    }
    else{
        *e_photon = e_primary * x;
        *q2 = q2min * pow(q2max / q2min, RandomUniform_generate(part));
    }
  
    if (*q2 * (1.0 - x) < x*x*emass2) *e_photon = 0.0;
    *one_m_x = 1.0 - x;
  
    return;
  
}

 static inline
double compt_tot(double s  // [GeV^2] center of mass energy of the macroparticle - virtual photon Compton scattering
){
    /*
    Based on:
    GUINEA-PIG
    https://gitlab.cern.ch/clic-software/guinea-pig-legacy/-/blob/master/background.c#L350
    and
    https://doi.org/10.1016/0167-5087(84)90128-5
    ----
    Total Compton cross section.
    */
    const double sig0 = PI*RE*RE;
    double xi, xp, xip, ln, sigc, x_compt;

    x_compt = s/(MELECTRON_GEV*MELECTRON_GEV);
    xi  = 1.0 / x_compt; 
    xp  = 1.0 + x_compt;
    xip = 1.0 / xp;
    ln  = log(xp);

    sigc = 2.0*sig0*xi*((1.0 - xi*(4.0 + 8.0*xi))*ln + 0.5 + 8.0*xi - 0.5*xip*xip);

    return sigc;  // [m^2]
}


 static inline
double compt_diff(double y,              // [1] virtual photon energy fraction compared to primary energy
                  const double x_compt   // [1] normalized cm energy of virtual photon - electron compton scattering
){
    /*
    Based on:
    GUINEA-PIG
    https://gitlab.cern.ch/clic-software/guinea-pig-legacy/-/blob/master/background.c#L364
    ----
    Differential Compton energy spectrum.
    */
    double r, yp;
    yp = 1.0 - y;
    r = y / (x_compt*yp);
    return 1.0/yp + yp - 4.0*r*(1.0 - r);  // [m^2]
}


 static inline
double compt_int(double y,             // [1] virtual photon energy fraction compared to primary energy
                 const double x_compt  // [1] normalized cm energy of virtual photon - electron compton scattering
){
    /*
    Based on:
    GUINEA-PIG
    https://gitlab.cern.ch/clic-software/guinea-pig-legacy/-/blob/master/background.c#L373
    ----
    Integrated Compton energy spectrum.
    */
    double yp, lny, xi;

    yp = 1.0 - y;
    xi = 1.0 / x_compt;
    lny = -log(yp);

    return lny*(1.0-4.0*xi-8.0*xi*xi) + y - y*y*0.5 + 4.0*y*xi + 4.0*y*xi*xi + 4.0/(x_compt*x_compt*yp);  // [m^2]
}


/***********************************************************************************/
/* Subroutines for Compton scattering of the virtual photon and the opposite slice */
/* Adapted from GUINEA-PIG                                                         */
/***********************************************************************************/

 static inline
void equal_newton(
                  double xmin,              // left boundary of domain
                  double xmax,              // right boundary of domain
                  double y,                 // random sample on y axis
                  double *x,                // initial guess for root (inverse CDF sampling)
                  const double x_compt      // [1] normalized cm energy of virtual photon - electron compton scattering

){
    /*
    Based on:
    GUINEA-PIG
    https://gitlab.cern.ch/clic-software/guinea-pig-legacy/-/blob/master/background.c#L23
    ----
    Uses the Newton-Raphson root finding method for inverse CDF sampling of the given spectrum.
    */
    double eps=1e-6;
    double ytry,xtry;
    xtry=*x;
    ytry=compt_int(xtry, x_compt);
    while (fabs(ytry-y)>(fabs(ytry)+fabs(y))*eps
           && (xmax-xmin)>eps) {
        xtry-=(ytry-y)/compt_diff(xtry, x_compt);
        if ((xtry>=xmax)||(xtry<=xmin)) {
            xtry=0.5*(xmax+xmin);
        }
        ytry=compt_int(xtry, x_compt);
        if(ytry<y) {
            xmin=xtry;
        }
        else {
            xmax=xtry;
        }
    }
    *x=xtry;
}



 static inline
double compt_select(LocalParticle *part,
                    double s  // [GeV^2] center of mass energy of the macroparticle - virtual photon Compton scattering
){
    /*
    Based on:
    GUINEA-PIG
    https://gitlab.cern.ch/clic-software/guinea-pig-legacy/-/blob/master/background.c#L397
    ----
    Given an input CM energy, returns a generated scattered Compton photon energy (y = hbar*omega/E0)
    s: center of mass energy of electron-virtual photon system, s=(x+1)*(m_e*c**2)**2
    returns a randomly sampled scattered photon energy fraction drawn from the Compton energy ditribution
    */
    double cmin, cmax, c, y, ym;
    const double x_compt = s / (MELECTRON_GEV*MELECTRON_GEV);

    //x_compt = x;
    ym = x_compt / (x_compt + 1.0);  // [1] y_max, maximum energy fraction (right edge of domain on x axis of the spectrum)
    cmin = compt_int(0.0, x_compt);  // [m^2] min of range of CDF 
    cmax = compt_int(ym, x_compt);   // [m^2] max of range of CDF

    y = RandomUniform_generate(part);
    c = cmin + (cmax - cmin)*y;  // [m^2] this is the random sample in the inverse CDF
    y *= ym;                     // [1] this is the initial guess on the domain axis 
    equal_newton(0.0, ym, c, &y, x_compt);  // find root: y=sigma^-1(c) i.e. do the inverse CDF sampling
  
    return y;  // [1]
}

 static inline
void compt_do(LocalParticle *part, BeamBeamBiGaussian3DRecordData bhabha_record, RecordIndex bhabha_table_index, BhabhaTableData bhabha_table,
              double e_photon,           // [GeV] single equivalent virtual photon energy before Compton scattering
              const double compt_x_min,  // [1] scaling factor in the minimum energy cutoff
              double q2,                 // [GeV^2] single equivalent virtual photon virtuality
              double x_photon, double y_photon, double z_photon,  // [m] (boosted) coords of the virtual photon
              double vx_photon,          // [1] transverse x momentum component of virtual photon (vx = dx/ds/p0)
              double vy_photon,          // [1] transverse y momentum component of virtual photon (vy = dy/ds/p0)
              double vzeta_photon,       // [1] zeta momentum component of virtual photon
              double wgt,                // [m^-2] luminosity per opposing slice crossing by single macroparticle
              double *vx, double *vy, double *vzeta, // [1] normalized momenta of the primary macroparticle 
              double q0                  // [e] charge of primary macroparticle
){

    /*
    Based on:
    GUINEA-PIG
    https://gitlab.cern.ch/clic-software/guinea-pig-legacy/-/blob/master/background.c#L420
    and
    https://doi.org/10.1016/0167-5087(84)90128-5
    and
    https://doi.org/10.1016/0031-9163(63)90351-2
    ----
    Compton scatter one vitrual macrophoton on one macroparticle. Potentially emit a real Bhabha photon. 
    */

    //double e_ref = LocalParticle_get_energy0(part)*1e-9;  // [GeV] nominal beam energy
    //double beta_ref = LocalParticle_get_beta0(part);         // [1] nominal beta
    double e_primary = (LocalParticle_get_energy0(part) + LocalParticle_get_ptau(part)*LocalParticle_get_p0c(part))*1e-9;  // [GeV] total energy of primary macroparticle before scattering
    double part_per_mpart = LocalParticle_get_weight(part);  // [e] num real charges represented by 1 macropart

    int n, i;                        // [1]
    double tmp, scal, s, x, y;       // [m^2, m^2, GeV^2, 1, 1]
    double theta_g, theta_e, phi_e;  // [rad] photon scattering angle, electron scattering angle, electron azimuthal scattering angle
    double e_e_prime, px_e_prime, py_e_prime, pt_e_prime;  // , pz_e_prime, pzeta_e_prime; [GeV, GeV/c, GeV/c, GeV/c] scattered primary momenta
    double e_photon_prime, px_photon_prime, py_photon_prime;      // [GeV, GeV/c] scattered (real) Compton photon momenta
    double e_loss_primary;            // [GeV] energy lost from one photon emission
    double eps = 0.0;                 // 1e-5 in guinea, used due to limited resolution of RNG in the past
    const double compt_scale = 1;     // [1] can be used to scale up photon generation for tests
    const double compt_emax = 200;    // [GeV] upper cutoff on e_e_prime from guineapig
    const double pair_ecut = 0.005;   // [GeV] lower cutoff on e_e_prime from guineapig
    double r1, r2;  // [1] uniform random numbers

    if (q2 > MELECTRON_GEV*MELECTRON_GEV) return;  // global upper cut on virtuality; eliminates "constant" part of q2 spectrum i.e. the hadronic virtual photons
    s = 4.0*e_photon*e_primary;  // [GeV^2] approximated center of mass energy of electron-photon Compton scattering
    if (q2 > s) return;          // event specific upper cut on virtuality; check against max allowed virtuality to be absorbed in the event
    if (s < compt_x_min * MELECTRON_GEV*MELECTRON_GEV*4.0) return;  // event specific lower cut on x; check against user defined compt_x_min

    tmp = compt_tot(s)*wgt*compt_scale;   // [1] this determines the number of real Compton scattering events
    n = (int)floor(tmp)+1;                // [1] round up e.g. tmp=5.4 will mean n=6 events
    scal = tmp/n;                         // [1] fractional part of event count
    x = s/(MELECTRON_GEV*MELECTRON_GEV);  // [1] normalized center of mass energy

    // simulate n Compton events
    for (i=0; i<n; i++) {
      y = compt_select(part, s);  // [1] draw Compton scattered photon energy normalized to total energy of primary before scattering

      if (scal > eps){
        double one_m_y = 1 - y;  // + e_photon / e_primary; neglected
        e_e_prime      = e_primary * one_m_y;  // + e_photon; neglected. [GeV] scattered electron energy: E_e' = E_e + E_p - E_p' but E_p is negligible compared to other terms
        e_photon_prime = e_primary * y;  // [GeV] scattered photon energy

        // get scattering angle for photon and beam primary
        theta_g = MELECTRON_GEV / e_primary * sqrt((x - (x + 1.0) * y) / y);
        theta_e = theta_g * e_photon_prime / (e_primary - e_photon_prime);  // + e_photon; neglected

        // save computations for tracking: energies below pair_ecut are lost anyways, energies above compt_emax result in negligible energy loss from bhabha
        if ((e_e_prime < compt_emax) && (e_e_prime > pair_ecut)) {

          // compute scattered primary momenta
          // adjust magnitude due to energy change (vx is in units of [1], corresponds to px in beambeam3d.h)
          px_e_prime = *vx * e_e_prime;  // [GeV/c]
          py_e_prime = *vy * e_e_prime;  // [GeV/c]

          // adjust direction
          pt_e_prime = theta_e * e_e_prime;  // [GeV/c] transverse azimuthal momentum
          phi_e = 2.0 * PI * RandomUniform_generate(part);  // [rad]
          px_e_prime  += pt_e_prime * sin(phi_e);  // [GeV/c]
          py_e_prime  += pt_e_prime * cos(phi_e);  // [GeV/c]
          //pz_e_prime   = sqrt(e_e_prime*e_e_prime - px_e_prime*px_e_prime - py_e_prime*py_e_prime - MELECTRON_GEV*MELECTRON_GEV);  // [GeV/c] longitudinal momentum

          // energy variable
          //pzeta_e_prime = (e_e_prime - e_ref) / (beta_ref * beta_ref * e_ref);

          // compute scattered photon momenta from momentum conservation
          px_photon_prime = (*vx + vx_photon) * e_primary - px_e_prime;
          py_photon_prime = (*vy + vy_photon) * e_primary - py_e_prime;

          // account for the event weight
          r1 = RandomUniform_generate(part);
          if (r1 < scal) {

            if (bhabha_record){

              // Get a slot in the record (this is thread safe)
              int64_t i_slot = RecordIndex_get_slot(bhabha_table_index);

              // The returned slot id is negative if record is NULL or if record is full
              if (i_slot>=0){
                  BhabhaTableData_set_at_element(    bhabha_table, i_slot, LocalParticle_get_at_element(part));
                  BhabhaTableData_set_at_turn(       bhabha_table, i_slot, LocalParticle_get_at_turn(part));
                  BhabhaTableData_set_particle_id(   bhabha_table, i_slot, LocalParticle_get_particle_id(part));
		  BhabhaTableData_set_primary_energy(bhabha_table, i_slot, e_primary*1e9);
                  BhabhaTableData_set_photon_id(     bhabha_table, i_slot, n);
                  BhabhaTableData_set_photon_x(      bhabha_table, i_slot, x_photon);
                  BhabhaTableData_set_photon_y(      bhabha_table, i_slot, y_photon);
                  BhabhaTableData_set_photon_z(      bhabha_table, i_slot, z_photon);
                  BhabhaTableData_set_photon_px(     bhabha_table, i_slot, px_photon_prime);
                  BhabhaTableData_set_photon_py(     bhabha_table, i_slot, py_photon_prime);
                  BhabhaTableData_set_photon_energy( bhabha_table, i_slot, e_photon_prime*1e9);
                  BhabhaTableData_set_primary_scattering_angle(bhabha_table, i_slot, theta_e);
                  BhabhaTableData_set_photon_scattering_angle( bhabha_table, i_slot, theta_g);
              }
            }

            // scattered photons are real so affect a macropart with a probability
            r2 = RandomUniform_generate(part);
            if (r2 < 1.0 / part_per_mpart){
              e_loss_primary = e_e_prime - e_primary;  // [GeV], <0, loss from a single photon emission

              if (e_loss_primary == 0.0){
                printf("0 energy loss: %g", e_loss_primary);
              }else{
                if (-1.0 * e_loss_primary >= e_primary){  // macropart dies
                  LocalParticle_set_state(part, XT_LOST_ALL_E_IN_SYNRAD); // used to flag this kind of loss
                  return;
                }else{  // macropart doesnt die
                  *vx    = px_e_prime / e_e_prime;
                  *vy    = py_e_prime / e_e_prime;
                  e_primary += e_loss_primary;
                  LocalParticle_add_to_energy(part, e_loss_primary*1e9, 0);  // this changes pzeta
                }
              }
            }
          }
        }
      }
    }
}
#endif /* XFIELDS_BHABHA_SPECTRUM_H */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_BEAMBEAM3D_H
#define XFIELDS_BEAMBEAM3D_H

#ifndef min
#define min(a,b) ((a) <= (b) ? (a) : (b))
#endif

 static inline
void do_luminosity(BeamBeamBiGaussian3DData el, LocalParticle *part,
               double* rho, double* wgt,
               double const x_bar_hat_star, double const y_bar_hat_star,
               double const Sig_11_hat_star, double const Sig_33_hat_star,
               double const num_part_slice){

    // gaussian charge density: at x, y density given by the 2D gaussian, local lumi depending on x y, total lumi sum of all
    get_charge_density(x_bar_hat_star, y_bar_hat_star, sqrt(Sig_11_hat_star), sqrt(Sig_33_hat_star), rho);
    *wgt =  LocalParticle_get_weight(part) * num_part_slice * (*rho);  // [m^-2] integrated lumi of a single electron colliding with the opposing slice

    // init record table
    BeamBeamBiGaussian3DRecordData lumi_record = NULL;
    LumiTableData lumi_table                   = NULL;
    lumi_record = BeamBeamBiGaussian3DData_getp_internal_record(el, part);
    if (lumi_record){
        lumi_table       = BeamBeamBiGaussian3DRecordData_getp_lumitable(lumi_record);

    const int at_turn = LocalParticle_get_at_turn(part);
      double* lumi_address = LumiTableData_getp1_luminosity(lumi_table, at_turn);  // double pointer
    atomicAdd(lumi_address, *wgt);
    }
}

 static inline
void do_bhabha(BeamBeamBiGaussian3DData el, LocalParticle *part,
               double* rho, double* wgt,
               const int64_t flag_luminosity, double const q0,
               double const x_bar_hat_star, double const y_bar_hat_star,
               double const Sig_11_hat_star, double const Sig_33_hat_star,
               double const num_part_slice, double const S,
               double* px_star, double* py_star, double* pzeta_star,
               double px_slice_star, double py_slice_star, double pzeta_slice_star){

    // init record table
    BeamBeamBiGaussian3DRecordData bhabha_record = NULL;
    BhabhaTableData bhabha_table                 = NULL;
    RecordIndex bhabha_table_index               = NULL;
    bhabha_record = BeamBeamBiGaussian3DData_getp_internal_record(el, part);
    if (bhabha_record){
        bhabha_table       = BeamBeamBiGaussian3DRecordData_getp_bhabhatable(bhabha_record);
        bhabha_table_index =                      BhabhaTableData_getp__index(bhabha_table);
    }

    // switch for beam size effect
    const int64_t flag_beamsize_effect = BeamBeamBiGaussian3DData_get_flag_beamsize_effect(el);

    // gaussian charge density, we are centered at the strong slice centroid
    if (flag_luminosity != 1 && flag_beamsize_effect == 0){
      get_charge_density(x_bar_hat_star, y_bar_hat_star, sqrt(Sig_11_hat_star), sqrt(Sig_33_hat_star), rho);
      *wgt =  LocalParticle_get_weight(part) * num_part_slice * (*rho);  // [m^-2] integrated lumi of a single electron colliding with the opposing slice
    }

    LocalParticle_update_pzeta(part, *pzeta_star);  // update energy vars with boost and/or last kick

    const double other_beam_slice_energy =  LocalParticle_get_energy0(part)*(1 + pzeta_slice_star) * 1e-9;  // [GeV] for now betastar is 1; later change to other beam E0

    const double compt_x_min = BeamBeamBiGaussian3DData_get_compt_x_min(el); // [1] low energy cutoff on scattered photons
    int n_photons = requiv(part, other_beam_slice_energy, compt_x_min);  // generate virtual photons equivalent to the opposite slice using the average energy of the opposite slice

    // generate virtual photons of the opposite slice
    double xmin, e_photon, q2, one_m_x, x_photon, y_photon, px_photon, py_photon, pzeta_photon, radius, theta;
    for (int i_phot=0; i_phot<n_photons; i_phot++){

      // draw total energy [GeV] and squared virtuality [GeV^2] of 1 photon
      mequiv(part, other_beam_slice_energy, compt_x_min, &xmin, &e_photon, &q2, &one_m_x);  // here again use opposite slice energy average

      // apply beam size effect here (affects x and y of virtual photon only)
      if (flag_beamsize_effect == 0){
          
	  // this is w.r.t of the strong slice centroid
          radius = 0.0;
          x_photon = x_bar_hat_star;
          y_photon = y_bar_hat_star;

      }else{ // if flag_beamsize_effect==1

	  // photons distributed on a disc around strong slice centroid
          radius = HBAR_GEVS*C_LIGHT / sqrt(q2*one_m_x);  // [m]
          radius = min(radius, 1e5);
          x_photon = x_bar_hat_star + rndm_sincos(part, &theta) * radius;
          y_photon = y_bar_hat_star + theta * radius;

          // resample charge density at randomized photon location
          get_charge_density(x_photon, y_photon, sqrt(Sig_11_hat_star), sqrt(Sig_33_hat_star), rho);
          *wgt =  LocalParticle_get_weight(part) * num_part_slice * (*rho);  // [m^-2] integrated lumi of a single electron colliding with the opposing slice
      }

      // virtual photons are located at the opposite slice centroid, inherit mom. vars
      px_photon = px_slice_star;
      py_photon = py_slice_star;
      pzeta_photon = pzeta_slice_star;

      // for each virtual photon get compton scatterings; updates pzeta and energy vars inside
      compt_do(part, bhabha_record, bhabha_table_index, bhabha_table,
               e_photon, compt_x_min, q2,
               x_photon, y_photon, S, px_photon, py_photon, pzeta_photon,
               *wgt, px_star, py_star, pzeta_star, q0);

      // reload pzeta since they changed from compton; px and py are changed only locally
      *pzeta_star = LocalParticle_get_pzeta(part);  // bhabha rescales energy vars, so load again before kick
    }
}


 static inline
void do_beamstrahlung(BeamBeamBiGaussian3DData el, LocalParticle *part,
                      double Fx_star, double Fy_star,
                      double* pzeta_star, const int i_slice, double const num_part_slice,
                      const int64_t flag_beamstrahlung){

        // init record table
        BeamBeamBiGaussian3DRecordData beamstrahlung_record = NULL;
        BeamstrahlungTableData beamstrahlung_table          = NULL;
        RecordIndex beamstrahlung_table_index               = NULL;
        beamstrahlung_record = BeamBeamBiGaussian3DData_getp_internal_record(el, part);
        if (beamstrahlung_record){
            beamstrahlung_table       = BeamBeamBiGaussian3DRecordData_getp_beamstrahlungtable(beamstrahlung_record);
            beamstrahlung_table_index =                      BeamstrahlungTableData_getp__index(beamstrahlung_table);
        }

        LocalParticle_update_pzeta(part, *pzeta_star);  // update energy vars with boost and/or last kick

	if(flag_beamstrahlung==1){

            // get unboosted strong slice RMS [m]
            double sqrtSigma_11 = BeamBeamBiGaussian3DData_get_slices_other_beam_sqrtSigma_11_beamstrahlung(el, i_slice);
            double sqrtSigma_33 = BeamBeamBiGaussian3DData_get_slices_other_beam_sqrtSigma_33_beamstrahlung(el, i_slice);
            double sqrtSigma_55 = BeamBeamBiGaussian3DData_get_slices_other_beam_sqrtSigma_55_beamstrahlung(el, i_slice);
            beamstrahlung_avg(part, beamstrahlung_record, beamstrahlung_table_index, beamstrahlung_table,
                num_part_slice, sqrtSigma_11, sqrtSigma_33, sqrtSigma_55);

	} else if (flag_beamstrahlung==2){
            double const Fr = hypot(Fx_star, Fy_star) * LocalParticle_get_rpp(part); // radial kick [1]
            double const dz = .5*BeamBeamBiGaussian3DData_get_slices_other_beam_zeta_bin_width_star_beamstrahlung(el, i_slice);  // half slice width [m]
            beamstrahlung(part, beamstrahlung_record, beamstrahlung_table_index, beamstrahlung_table, Fr, dz);
        }

        *pzeta_star = LocalParticle_get_pzeta(part);  // BS rescales energy vars, so load again before kick
}


 static inline
void synchrobeam_kick(
        BeamBeamBiGaussian3DData el, LocalParticle *part,
        const int i_slice,
        double const q0, double const p0c,
        double* x_star,
        double* px_star,
        double* y_star,
        double* py_star,
        double* zeta_star,
        double* pzeta_star){

    // Get data from memory
    double const scale_strength = BeamBeamBiGaussian3DData_get_scale_strength(el);
    const double q0_bb  = scale_strength*BeamBeamBiGaussian3DData_get_other_beam_q0(el);
    const double min_sigma_diff = BeamBeamBiGaussian3DData_get_min_sigma_diff(el);
    const double threshold_singular = BeamBeamBiGaussian3DData_get_threshold_singular(el);

    double const Sig_11_0 = BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_11_star(el, i_slice);
    double const Sig_12_0 = BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_12_star(el, i_slice);
    double const Sig_13_0 = BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_13_star(el, i_slice);
    double const Sig_14_0 = BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_14_star(el, i_slice);
    double const Sig_22_0 = BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_22_star(el, i_slice);
    double const Sig_23_0 = BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_23_star(el, i_slice);
    double const Sig_24_0 = BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_24_star(el, i_slice);
    double const Sig_33_0 = BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_33_star(el, i_slice);
    double const Sig_34_0 = BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_34_star(el, i_slice);
    double const Sig_44_0 = BeamBeamBiGaussian3DData_get_slices_other_beam_Sigma_44_star(el, i_slice);

    double const num_part_slice = BeamBeamBiGaussian3DData_get_slices_other_beam_num_particles(el, i_slice);

    // no kick if not sufficient macroparticles; should be taken care of when slicing
    if (num_part_slice == 0){
        return;
    }

    const double x_slice_star = BeamBeamBiGaussian3DData_get_slices_other_beam_x_center_star(el, i_slice);
    const double y_slice_star = BeamBeamBiGaussian3DData_get_slices_other_beam_y_center_star(el, i_slice);
    const double px_slice_star = BeamBeamBiGaussian3DData_get_slices_other_beam_px_center_star(el, i_slice);
    const double py_slice_star = BeamBeamBiGaussian3DData_get_slices_other_beam_py_center_star(el, i_slice);
    const double zeta_slice_star = BeamBeamBiGaussian3DData_get_slices_other_beam_zeta_center_star(el, i_slice);

    const double P0 = p0c/C_LIGHT*QELEM;

    //Compute force scaling factor
    const double Ksl = num_part_slice*QELEM*q0_bb*QELEM*q0/(P0 * C_LIGHT);

    //Identify the Collision Point (CP)
    #ifdef XFIELDS_BEAMBEAM3D_FORCE_CP0
    const double S = 0.0;
    #else
    const double S = 0.5*(*zeta_star - zeta_slice_star);
    #endif
    //fflush(stdout);

    // Propagate sigma matrix
    double Sig_11_hat_star, Sig_33_hat_star, costheta, sintheta;
    double dS_Sig_11_hat_star, dS_Sig_33_hat_star, dS_costheta, dS_sintheta;

    // Get strong beam shape at the CP
    Sigmas_propagate(
            Sig_11_0,
            Sig_12_0,
            Sig_13_0,
            Sig_14_0,
            Sig_22_0,
            Sig_23_0,
            Sig_24_0,
            Sig_33_0,
            Sig_34_0,
            Sig_44_0,
            S, threshold_singular, 1,
            &Sig_11_hat_star, &Sig_33_hat_star,
            &costheta, &sintheta,
            &dS_Sig_11_hat_star, &dS_Sig_33_hat_star,
            &dS_costheta, &dS_sintheta);

    // Evaluate transverse coordinates of the weak baem w.r.t. the strong beam centroid
    const double x_bar_star = *x_star + *px_star * S - x_slice_star - px_slice_star * S;
    const double y_bar_star = *y_star + *py_star * S - y_slice_star - py_slice_star * S;

    // Move to the uncoupled reference frame
    const double x_bar_hat_star = x_bar_star*costheta + y_bar_star * sintheta;
    const double y_bar_hat_star = -x_bar_star*sintheta + y_bar_star * costheta;

    // Compute derivatives of the transformation
    const double dS_x_bar_hat_star = x_bar_star * dS_costheta + y_bar_star * dS_sintheta;
    const double dS_y_bar_hat_star = -x_bar_star * dS_sintheta + y_bar_star * dS_costheta;

    // Get transverse fields
    double Ex, Ey;
    get_Ex_Ey_gauss(x_bar_hat_star, y_bar_hat_star,
        sqrt(Sig_11_hat_star), sqrt(Sig_33_hat_star),
        min_sigma_diff,
        &Ex, &Ey);

    //compute Gs
    double Gx, Gy;
    compute_Gx_Gy(x_bar_hat_star, y_bar_hat_star,
          sqrt(Sig_11_hat_star), sqrt(Sig_33_hat_star),
                      min_sigma_diff, Ex, Ey, &Gx, &Gy);

    // Compute kicks [1]
    double Fx_hat_star = Ksl*Ex;
    double Fy_hat_star = Ksl*Ey;
    double Gx_hat_star = Ksl*Gx;
    double Gy_hat_star = Ksl*Gy;

    // Move kicks to coupled reference frame
    double Fx_star = Fx_hat_star*costheta - Fy_hat_star*sintheta;
    double Fy_star = Fx_hat_star*sintheta + Fy_hat_star*costheta;

    // Compute longitudinal kick [1]
    double Fz_star = 0.5*(Fx_hat_star*dS_x_bar_hat_star  + Fy_hat_star*dS_y_bar_hat_star+
                   Gx_hat_star*dS_Sig_11_hat_star + Gy_hat_star*dS_Sig_33_hat_star);

    double rho = 0.0, wgt = 0.0;

    // calculate luminosity
    const int64_t flag_luminosity = BeamBeamBiGaussian3DData_get_flag_luminosity(el);
    if (flag_luminosity == 1){
        do_luminosity(el, part, &rho, &wgt,
            x_bar_hat_star, y_bar_hat_star, Sig_11_hat_star, Sig_33_hat_star,
            num_part_slice);
    }

    // emit bhabha photons from single macropart
    #ifndef XFIELDS_BB3D_NO_BHABHA
    const int64_t flag_bhabha = BeamBeamBiGaussian3DData_get_flag_bhabha(el);
    if (flag_bhabha == 1) {
        const double pzeta_slice_star = BeamBeamBiGaussian3DData_get_slices_other_beam_pzeta_center_star(el, i_slice);
        do_bhabha(el, part, &rho, &wgt, flag_luminosity, q0,
            x_bar_hat_star, y_bar_hat_star, Sig_11_hat_star, Sig_33_hat_star,
            num_part_slice, S, px_star, py_star, pzeta_star,
            px_slice_star, py_slice_star, pzeta_slice_star);
    }
    #endif

    // emit beamstrahlung photons from single macropart
    #ifndef XFIELDS_BB3D_NO_BEAMSTR
    const int64_t flag_beamstrahlung = BeamBeamBiGaussian3DData_get_flag_beamstrahlung(el);
    if(flag_beamstrahlung!=0){
        do_beamstrahlung(el, part, Fx_star, Fy_star, pzeta_star,
           i_slice, num_part_slice, flag_beamstrahlung);
    }
    #endif

    // compute longitudinal kick on pzeta
    double const dpzeta_star = Fz_star + 0.5 * (
                Fx_star*(*px_star+0.5*Fx_star - px_slice_star)+
                Fy_star*(*py_star+0.5*Fy_star - py_slice_star));

    // Apply the kicks (Hirata's synchro-beam)
    *pzeta_star = *pzeta_star + dpzeta_star;
    *x_star = *x_star - S*Fx_star;
    *px_star = *px_star + Fx_star;
    *y_star = *y_star - S*Fy_star;
    *py_star = *py_star + Fy_star;
}


 static inline
void BeamBeamBiGaussian3D_track_local_particle(BeamBeamBiGaussian3DData el, LocalParticle* part0){

    // Get data from memory
    double const sin_phi = BeamBeamBiGaussian3DData_get__sin_phi(el);
    double const cos_phi = BeamBeamBiGaussian3DData_get__cos_phi(el);
    double const tan_phi = BeamBeamBiGaussian3DData_get__tan_phi(el);
    double const sin_alpha = BeamBeamBiGaussian3DData_get__sin_alpha(el);
    double const cos_alpha = BeamBeamBiGaussian3DData_get__cos_alpha(el);

    const int N_slices = BeamBeamBiGaussian3DData_get_num_slices_other_beam(el);

    const double shift_x = BeamBeamBiGaussian3DData_get_ref_shift_x(el)
                           + BeamBeamBiGaussian3DData_get_other_beam_shift_x(el);
    const double shift_px = BeamBeamBiGaussian3DData_get_ref_shift_px(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_px(el);
    const double shift_y = BeamBeamBiGaussian3DData_get_ref_shift_y(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_y(el);
    const double shift_py = BeamBeamBiGaussian3DData_get_ref_shift_py(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_py(el);
    const double shift_zeta = BeamBeamBiGaussian3DData_get_ref_shift_zeta(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_zeta(el);
    const double shift_pzeta = BeamBeamBiGaussian3DData_get_ref_shift_pzeta(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_pzeta(el);

    double const scale_strength = BeamBeamBiGaussian3DData_get_scale_strength(el);
    const double post_subtract_x = scale_strength*BeamBeamBiGaussian3DData_get_post_subtract_x(el);
    const double post_subtract_px = scale_strength*BeamBeamBiGaussian3DData_get_post_subtract_px(el);
    const double post_subtract_y = scale_strength*BeamBeamBiGaussian3DData_get_post_subtract_y(el);
    const double post_subtract_py = scale_strength*BeamBeamBiGaussian3DData_get_post_subtract_py(el);
    const double post_subtract_zeta = scale_strength*BeamBeamBiGaussian3DData_get_post_subtract_zeta(el);
    const double post_subtract_pzeta = scale_strength*BeamBeamBiGaussian3DData_get_post_subtract_pzeta(el);


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

        double x = LocalParticle_get_x(part);
        double px = LocalParticle_get_px(part);
        double y = LocalParticle_get_y(part);
        double py = LocalParticle_get_py(part);
        double zeta = LocalParticle_get_zeta(part);
        double pzeta = LocalParticle_get_pzeta(part);

        const double q0 = LocalParticle_get_q0(part);
        const double p0c = LocalParticle_get_p0c(part); // eV

        // Change reference frame
        change_ref_frame_coordinates(
            &x, &px, &y, &py, &zeta, &pzeta,
            shift_x, shift_px, shift_y, shift_py, shift_zeta, shift_pzeta,
            sin_phi, cos_phi, tan_phi, sin_alpha, cos_alpha);

        // Synchro beam
        for (int i_slice=0; i_slice<N_slices; i_slice++)
        {
            synchrobeam_kick(
                            el, part,
                            i_slice, q0, p0c,
                            &x,
                            &px,
                            &y,
                            &py,
                            &zeta,
                            &pzeta);
        }

        // Go back to original reference frame and remove dipolar effect
        change_back_ref_frame_and_subtract_dipolar_coordinates(
            &x, &px, &y, &py, &zeta, &pzeta,
            shift_x, shift_px, shift_y, shift_py, shift_zeta, shift_pzeta,
            post_subtract_x, post_subtract_px,
            post_subtract_y, post_subtract_py,
            post_subtract_zeta, post_subtract_pzeta,
            sin_phi, cos_phi, tan_phi, sin_alpha, cos_alpha);

        // Store
        LocalParticle_set_x(part, x);
        LocalParticle_set_px(part, px);
        LocalParticle_set_y(part, y);
        LocalParticle_set_py(part, py);
        LocalParticle_set_zeta(part, zeta);
        LocalParticle_update_pzeta(part, pzeta);


//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

}



#endif

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef XFIELDS_BEAMBEAM3D_METHODS_FOR_STRONGSTRONG_H
#define XFIELDS_BEAMBEAM3D_METHODS_FOR_STRONGSTRONG_H


 static inline
void BeamBeamBiGaussian3D_change_ref_frame_local_particle(
        BeamBeamBiGaussian3DData el, LocalParticle* part0){

    // Get data from memory
    double const sin_phi = BeamBeamBiGaussian3DData_get__sin_phi(el);
    double const cos_phi = BeamBeamBiGaussian3DData_get__cos_phi(el);
    double const tan_phi = BeamBeamBiGaussian3DData_get__tan_phi(el);
    double const sin_alpha = BeamBeamBiGaussian3DData_get__sin_alpha(el);
    double const cos_alpha = BeamBeamBiGaussian3DData_get__cos_alpha(el);

    const double shift_x = BeamBeamBiGaussian3DData_get_ref_shift_x(el)
                           + BeamBeamBiGaussian3DData_get_other_beam_shift_x(el);
    const double shift_px = BeamBeamBiGaussian3DData_get_ref_shift_px(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_px(el);
    const double shift_y = BeamBeamBiGaussian3DData_get_ref_shift_y(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_y(el);
    const double shift_py = BeamBeamBiGaussian3DData_get_ref_shift_py(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_py(el);
    const double shift_zeta = BeamBeamBiGaussian3DData_get_ref_shift_zeta(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_zeta(el);
    const double shift_pzeta = BeamBeamBiGaussian3DData_get_ref_shift_pzeta(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_pzeta(el);



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

        double x = LocalParticle_get_x(part);
        double px = LocalParticle_get_px(part);
        double y = LocalParticle_get_y(part);
        double py = LocalParticle_get_py(part);
        double zeta = LocalParticle_get_zeta(part);
        double pzeta = LocalParticle_get_pzeta(part);

        // Change reference frame
        change_ref_frame_coordinates(
            &x, &px, &y, &py, &zeta, &pzeta,
            shift_x, shift_px, shift_y, shift_py, shift_zeta, shift_pzeta,
            sin_phi, cos_phi, tan_phi, sin_alpha, cos_alpha);

        // Store
        LocalParticle_set_x(part, x);
        LocalParticle_set_px(part, px);
        LocalParticle_set_y(part, y);
        LocalParticle_set_py(part, py);
        LocalParticle_set_zeta(part, zeta);
        LocalParticle_update_pzeta(part, pzeta);


//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

}

 static inline
void BeamBeamBiGaussian3D_change_back_ref_frame_and_subtract_dipolar_local_particle(
        BeamBeamBiGaussian3DData el, LocalParticle* part0){

    // Get data from memory
    double const sin_phi = BeamBeamBiGaussian3DData_get__sin_phi(el);
    double const cos_phi = BeamBeamBiGaussian3DData_get__cos_phi(el);
    double const tan_phi = BeamBeamBiGaussian3DData_get__tan_phi(el);
    double const sin_alpha = BeamBeamBiGaussian3DData_get__sin_alpha(el);
    double const cos_alpha = BeamBeamBiGaussian3DData_get__cos_alpha(el);

    const double shift_x = BeamBeamBiGaussian3DData_get_ref_shift_x(el)
                           + BeamBeamBiGaussian3DData_get_other_beam_shift_x(el);
    const double shift_px = BeamBeamBiGaussian3DData_get_ref_shift_px(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_px(el);
    const double shift_y = BeamBeamBiGaussian3DData_get_ref_shift_y(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_y(el);
    const double shift_py = BeamBeamBiGaussian3DData_get_ref_shift_py(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_py(el);
    const double shift_zeta = BeamBeamBiGaussian3DData_get_ref_shift_zeta(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_zeta(el);
    const double shift_pzeta = BeamBeamBiGaussian3DData_get_ref_shift_pzeta(el)
                            + BeamBeamBiGaussian3DData_get_other_beam_shift_pzeta(el);

    const double post_subtract_x = BeamBeamBiGaussian3DData_get_post_subtract_x(el);
    const double post_subtract_px = BeamBeamBiGaussian3DData_get_post_subtract_px(el);
    const double post_subtract_y = BeamBeamBiGaussian3DData_get_post_subtract_y(el);
    const double post_subtract_py = BeamBeamBiGaussian3DData_get_post_subtract_py(el);
    const double post_subtract_zeta = BeamBeamBiGaussian3DData_get_post_subtract_zeta(el);
    const double post_subtract_pzeta = BeamBeamBiGaussian3DData_get_post_subtract_pzeta(el);


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

        double x = LocalParticle_get_x(part);
        double px = LocalParticle_get_px(part);
        double y = LocalParticle_get_y(part);
        double py = LocalParticle_get_py(part);
        double zeta = LocalParticle_get_zeta(part);
        double pzeta = LocalParticle_get_pzeta(part);


        // Go back to original reference frame and remove dipolar effect
        change_back_ref_frame_and_subtract_dipolar_coordinates(
            &x, &px, &y, &py, &zeta, &pzeta,
            shift_x, shift_px, shift_y, shift_py, shift_zeta, shift_pzeta,
            post_subtract_x, post_subtract_px,
            post_subtract_y, post_subtract_py,
            post_subtract_zeta, post_subtract_pzeta,
            sin_phi, cos_phi, tan_phi, sin_alpha, cos_alpha);

        // Store
        LocalParticle_set_x(part, x);
        LocalParticle_set_px(part, px);
        LocalParticle_set_y(part, y);
        LocalParticle_set_py(part, py);
        LocalParticle_set_zeta(part, zeta);
        LocalParticle_update_pzeta(part, pzeta);


//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


}


 static inline
void BeamBeam3D_selective_apply_synchrobeam_kick_local_particle(BeamBeamBiGaussian3DData el,
                LocalParticle* part0,
                  int64_t* i_slice_for_particles){



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp


        const int64_t i_slice = i_slice_for_particles[part->ipart];
        const int64_t N_slices = BeamBeamBiGaussian3DData_get_num_slices_other_beam(el);

        if (i_slice >= 0 && i_slice < N_slices){

            double x_star = LocalParticle_get_x(part);
            double px_star = LocalParticle_get_px(part);
            double y_star = LocalParticle_get_y(part);
            double py_star = LocalParticle_get_py(part);
            double zeta_star = LocalParticle_get_zeta(part);
            double pzeta_star = LocalParticle_get_pzeta(part);

            const double q0 = LocalParticle_get_q0(part);
            const double p0c = LocalParticle_get_p0c(part); // eV

            synchrobeam_kick(
                el, part,
                i_slice, q0, p0c,
                &x_star,
                &px_star,
                &y_star,
                &py_star,
                &zeta_star,
                &pzeta_star);

            LocalParticle_set_x(part, x_star);
            LocalParticle_set_px(part, px_star);
            LocalParticle_set_y(part, y_star);
            LocalParticle_set_py(part, py_star);
            LocalParticle_set_zeta(part, zeta_star);
            LocalParticle_update_pzeta(part, pzeta_star);

        }


//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



}

#endif


             static inline
            void BeamBeamBiGaussian3D_track_local_particle_with_transformations(BeamBeamBiGaussian3DData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = BeamBeamBiGaussian3DData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamBeamBiGaussian3DData_get__cos_rot_s(el);
    double const shift_x = BeamBeamBiGaussian3DData_get__shift_x(el);
    double const shift_y = BeamBeamBiGaussian3DData_get__shift_y(el);
    double const shift_s = BeamBeamBiGaussian3DData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    BeamBeamBiGaussian3D_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamBeamBiGaussian3DData_get__cos_rot_s(el);
    double const shift_x = BeamBeamBiGaussian3DData_get__shift_x(el);
    double const shift_y = BeamBeamBiGaussian3DData_get__shift_y(el);
    double const shift_s = BeamBeamBiGaussian3DData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void BeamBeamBiGaussian3D_track_particles(
               BeamBeamBiGaussian3DData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              BeamBeamBiGaussian3D_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }


             
            void synchro_beam_kick(
               BeamBeamBiGaussian3DData el,

                             ParticlesData particles,
    int64_t* i_slice_for_particles, 
                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              BeamBeam3D_selective_apply_synchrobeam_kick_local_particle(el, &lpart, i_slice_for_particles);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }


             
            void change_ref_frame(
               BeamBeamBiGaussian3DData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              BeamBeamBiGaussian3D_change_ref_frame_local_particle(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }


             
            void change_back_ref_frame_and_subtract_dipolar(
               BeamBeamBiGaussian3DData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              BeamBeamBiGaussian3D_change_back_ref_frame_and_subtract_dipolar_local_particle(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RandomUniformAccurateData
#define XOBJ_TYPEDEF_RandomUniformAccurateData
typedef   struct RandomUniformAccurateData_s * RandomUniformAccurateData;
 static inline RandomUniformAccurateData RandomUniformAccurateData_getp(RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  return (RandomUniformAccurateData)(( char*) obj+offset);
}
 static inline uint8_t RandomUniformAccurateData_get__dummy(const RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  return *(( uint8_t*) obj+offset);
}
 static inline void RandomUniformAccurateData_set__dummy(RandomUniformAccurateData restrict  obj, uint8_t value){
  int64_t offset=0;
  *(( uint8_t*) obj+offset)=value;
}
 static inline  uint8_t* RandomUniformAccurateData_getp__dummy(RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  return ( uint8_t*)(( char*) obj+offset);
}
 static inline double RandomUniformAccurateData_get__sin_rot_s(const RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformAccurateData_set__sin_rot_s(RandomUniformAccurateData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformAccurateData_getp__sin_rot_s(RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformAccurateData_get__cos_rot_s(const RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformAccurateData_set__cos_rot_s(RandomUniformAccurateData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformAccurateData_getp__cos_rot_s(RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformAccurateData_get__shift_x(const RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformAccurateData_set__shift_x(RandomUniformAccurateData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformAccurateData_getp__shift_x(RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformAccurateData_get__shift_y(const RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformAccurateData_set__shift_y(RandomUniformAccurateData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformAccurateData_getp__shift_y(RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformAccurateData_get__shift_s(const RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformAccurateData_set__shift_s(RandomUniformAccurateData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformAccurateData_getp__shift_s(RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <random/random_src/uniform_accurate.h>

             
            void sample_unif_accuurate(
               RandomUniformAccurateData el,

                             ParticlesData particles,
    double* samples,  int64_t n_samples_per_seed, 
                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              RandomUniformAccurate_sample(el, &lpart, samples, n_samples_per_seed);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RandomExponentialData
#define XOBJ_TYPEDEF_RandomExponentialData
typedef   struct RandomExponentialData_s * RandomExponentialData;
 static inline RandomExponentialData RandomExponentialData_getp(RandomExponentialData restrict  obj){
  int64_t offset=0;
  return (RandomExponentialData)(( char*) obj+offset);
}
 static inline uint8_t RandomExponentialData_get__dummy(const RandomExponentialData restrict  obj){
  int64_t offset=0;
  return *(( uint8_t*) obj+offset);
}
 static inline void RandomExponentialData_set__dummy(RandomExponentialData restrict  obj, uint8_t value){
  int64_t offset=0;
  *(( uint8_t*) obj+offset)=value;
}
 static inline  uint8_t* RandomExponentialData_getp__dummy(RandomExponentialData restrict  obj){
  int64_t offset=0;
  return ( uint8_t*)(( char*) obj+offset);
}
 static inline double RandomExponentialData_get__sin_rot_s(const RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomExponentialData_set__sin_rot_s(RandomExponentialData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomExponentialData_getp__sin_rot_s(RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomExponentialData_get__cos_rot_s(const RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomExponentialData_set__cos_rot_s(RandomExponentialData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomExponentialData_getp__cos_rot_s(RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomExponentialData_get__shift_x(const RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomExponentialData_set__shift_x(RandomExponentialData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomExponentialData_getp__shift_x(RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomExponentialData_get__shift_y(const RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomExponentialData_set__shift_y(RandomExponentialData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomExponentialData_getp__shift_y(RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomExponentialData_get__shift_s(const RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomExponentialData_set__shift_s(RandomExponentialData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomExponentialData_getp__shift_s(RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <random/random_src/exponential.h>

             
            void sample_exp(
               RandomExponentialData el,

                             ParticlesData particles,
    double* samples,  int64_t n_samples_per_seed, 
                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              RandomExponential_sample(el, &lpart, samples, n_samples_per_seed);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RandomRutherfordData
#define XOBJ_TYPEDEF_RandomRutherfordData
typedef   struct RandomRutherfordData_s * RandomRutherfordData;
 static inline RandomRutherfordData RandomRutherfordData_getp(RandomRutherfordData restrict  obj){
  int64_t offset=0;
  return (RandomRutherfordData)(( char*) obj+offset);
}
 static inline double RandomRutherfordData_get_lower_val(const RandomRutherfordData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomRutherfordData_set_lower_val(RandomRutherfordData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomRutherfordData_getp_lower_val(RandomRutherfordData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomRutherfordData_get_upper_val(const RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomRutherfordData_set_upper_val(RandomRutherfordData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomRutherfordData_getp_upper_val(RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomRutherfordData_get_A(const RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomRutherfordData_set_A(RandomRutherfordData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomRutherfordData_getp_A(RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomRutherfordData_get_B(const RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomRutherfordData_set_B(RandomRutherfordData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomRutherfordData_getp_B(RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t RandomRutherfordData_get_Newton_iterations(const RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *(( int8_t*) obj+offset);
}
 static inline void RandomRutherfordData_set_Newton_iterations(RandomRutherfordData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=32;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* RandomRutherfordData_getp_Newton_iterations(RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double RandomRutherfordData_get__sin_rot_s(const RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomRutherfordData_set__sin_rot_s(RandomRutherfordData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomRutherfordData_getp__sin_rot_s(RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomRutherfordData_get__cos_rot_s(const RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomRutherfordData_set__cos_rot_s(RandomRutherfordData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomRutherfordData_getp__cos_rot_s(RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomRutherfordData_get__shift_x(const RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomRutherfordData_set__shift_x(RandomRutherfordData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomRutherfordData_getp__shift_x(RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomRutherfordData_get__shift_y(const RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomRutherfordData_set__shift_y(RandomRutherfordData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomRutherfordData_getp__shift_y(RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomRutherfordData_get__shift_s(const RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomRutherfordData_set__shift_s(RandomRutherfordData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomRutherfordData_getp__shift_s(RandomRutherfordData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <random/random_src/rutherford.h>

             
            void sample_ruth(
               RandomRutherfordData el,

                             ParticlesData particles,
    double* samples,  int64_t n_samples_per_seed, 
                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              RandomRutherford_sample(el, &lpart, samples, n_samples_per_seed);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RandomNormalData
#define XOBJ_TYPEDEF_RandomNormalData
typedef   struct RandomNormalData_s * RandomNormalData;
 static inline RandomNormalData RandomNormalData_getp(RandomNormalData restrict  obj){
  int64_t offset=0;
  return (RandomNormalData)(( char*) obj+offset);
}
 static inline uint8_t RandomNormalData_get__dummy(const RandomNormalData restrict  obj){
  int64_t offset=0;
  return *(( uint8_t*) obj+offset);
}
 static inline void RandomNormalData_set__dummy(RandomNormalData restrict  obj, uint8_t value){
  int64_t offset=0;
  *(( uint8_t*) obj+offset)=value;
}
 static inline  uint8_t* RandomNormalData_getp__dummy(RandomNormalData restrict  obj){
  int64_t offset=0;
  return ( uint8_t*)(( char*) obj+offset);
}
 static inline double RandomNormalData_get__sin_rot_s(const RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomNormalData_set__sin_rot_s(RandomNormalData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomNormalData_getp__sin_rot_s(RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomNormalData_get__cos_rot_s(const RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomNormalData_set__cos_rot_s(RandomNormalData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomNormalData_getp__cos_rot_s(RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomNormalData_get__shift_x(const RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomNormalData_set__shift_x(RandomNormalData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomNormalData_getp__shift_x(RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomNormalData_get__shift_y(const RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomNormalData_set__shift_y(RandomNormalData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomNormalData_getp__shift_y(RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomNormalData_get__shift_s(const RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomNormalData_set__shift_s(RandomNormalData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomNormalData_getp__shift_s(RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <random/random_src/normal.h>

             
            void sample_gauss(
               RandomNormalData el,

                             ParticlesData particles,
    double* samples,  int64_t n_samples_per_seed, 
                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              RandomNormal_sample(el, &lpart, samples, n_samples_per_seed);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_DriftSliceData
#define XOBJ_TYPEDEF_DriftSliceData
typedef   struct DriftSliceData_s * DriftSliceData;
 static inline DriftSliceData DriftSliceData_getp(DriftSliceData restrict  obj){
  int64_t offset=0;
  return (DriftSliceData)(( char*) obj+offset);
}
 static inline DriftData DriftSliceData_getp__parent(DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (DriftData)(( char*) obj+offset);
}
 static inline double DriftSliceData_get__parent_length(const DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceData_set__parent_length(DriftSliceData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceData_getp__parent_length(DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceData_get_radiation_flag(const DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceData_set_radiation_flag(DriftSliceData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceData_getp_radiation_flag(DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceData_get_delta_taper(const DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceData_set_delta_taper(DriftSliceData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceData_getp_delta_taper(DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceData_get_weight(const DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceData_set_weight(DriftSliceData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceData_getp_weight(DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/drift_slice.h>

             static inline
            void DriftSlice_track_local_particle_with_transformations(DriftSliceData el, LocalParticle* part0){
    DriftSlice_track_local_particle(el, part0);
}


             
            void DriftSlice_track_particles(
               DriftSliceData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              DriftSlice_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_OctupoleData
#define XOBJ_TYPEDEF_OctupoleData
typedef   struct OctupoleData_s * OctupoleData;
 static inline OctupoleData OctupoleData_getp(OctupoleData restrict  obj){
  int64_t offset=0;
  return (OctupoleData)(( char*) obj+offset);
}
 static inline double OctupoleData_get_k3(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_k3(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp_k3(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double OctupoleData_get_k3s(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_k3s(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp_k3s(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double OctupoleData_get_length(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_length(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp_length(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_get_order(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_order(OctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* OctupoleData_getp_order(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double OctupoleData_get_inv_factorial_order(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_inv_factorial_order(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp_inv_factorial_order(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 OctupoleData_getp_knl(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_len_knl(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double OctupoleData_get_knl(const OctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_knl(OctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp1_knl(OctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 OctupoleData_getp_ksl(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_len_ksl(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double OctupoleData_get_ksl(const OctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_ksl(OctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp1_ksl(OctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t OctupoleData_get_edge_entry_active(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_edge_entry_active(OctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* OctupoleData_getp_edge_entry_active(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t OctupoleData_get_edge_exit_active(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_edge_exit_active(OctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* OctupoleData_getp_edge_exit_active(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_get_num_multipole_kicks(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_num_multipole_kicks(OctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* OctupoleData_getp_num_multipole_kicks(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_get_model(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_model(OctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* OctupoleData_getp_model(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_get_integrator(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_integrator(OctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* OctupoleData_getp_integrator(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_get_radiation_flag(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_radiation_flag(OctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* OctupoleData_getp_radiation_flag(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double OctupoleData_get_delta_taper(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_delta_taper(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp_delta_taper(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double OctupoleData_get__sin_rot_s(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set__sin_rot_s(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp__sin_rot_s(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double OctupoleData_get__cos_rot_s(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set__cos_rot_s(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp__cos_rot_s(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double OctupoleData_get__shift_x(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set__shift_x(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp__shift_x(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double OctupoleData_get__shift_y(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set__shift_y(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp__shift_y(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double OctupoleData_get__shift_s(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set__shift_s(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp__shift_s(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier OctupoleData_getp__internal_record_id(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_get__internal_record_id_buffer_id(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set__internal_record_id_buffer_id(OctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* OctupoleData_getp__internal_record_id_buffer_id(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_get__internal_record_id_offset(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set__internal_record_id_offset(OctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* OctupoleData_getp__internal_record_id_offset(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData OctupoleData_getp_internal_record(OctupoleData el, LocalParticle* part){
    RecordIdentifier record_id = OctupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/octupole.h>

             static inline
            void Octupole_track_local_particle_with_transformations(OctupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = OctupoleData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = OctupoleData_get__cos_rot_s(el);
    double const shift_x = OctupoleData_get__shift_x(el);
    double const shift_y = OctupoleData_get__shift_y(el);
    double const shift_s = OctupoleData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Octupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = OctupoleData_get__cos_rot_s(el);
    double const shift_x = OctupoleData_get__shift_x(el);
    double const shift_y = OctupoleData_get__shift_y(el);
    double const shift_s = OctupoleData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Octupole_track_particles(
               OctupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Octupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_SextupoleData
#define XOBJ_TYPEDEF_SextupoleData
typedef   struct SextupoleData_s * SextupoleData;
 static inline SextupoleData SextupoleData_getp(SextupoleData restrict  obj){
  int64_t offset=0;
  return (SextupoleData)(( char*) obj+offset);
}
 static inline double SextupoleData_get_k2(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_k2(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp_k2(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double SextupoleData_get_k2s(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_k2s(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp_k2s(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double SextupoleData_get_length(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_length(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp_length(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_get_order(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_order(SextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SextupoleData_getp_order(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double SextupoleData_get_inv_factorial_order(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_inv_factorial_order(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp_inv_factorial_order(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 SextupoleData_getp_knl(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_len_knl(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double SextupoleData_get_knl(const SextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_knl(SextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp1_knl(SextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 SextupoleData_getp_ksl(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_len_ksl(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double SextupoleData_get_ksl(const SextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_ksl(SextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp1_ksl(SextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t SextupoleData_get_edge_entry_active(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_edge_entry_active(SextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* SextupoleData_getp_edge_entry_active(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t SextupoleData_get_edge_exit_active(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_edge_exit_active(SextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* SextupoleData_getp_edge_exit_active(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_get_num_multipole_kicks(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_num_multipole_kicks(SextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SextupoleData_getp_num_multipole_kicks(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_get_model(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_model(SextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SextupoleData_getp_model(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_get_integrator(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_integrator(SextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SextupoleData_getp_integrator(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_get_radiation_flag(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_radiation_flag(SextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SextupoleData_getp_radiation_flag(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double SextupoleData_get_delta_taper(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_delta_taper(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp_delta_taper(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double SextupoleData_get__sin_rot_s(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set__sin_rot_s(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp__sin_rot_s(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double SextupoleData_get__cos_rot_s(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set__cos_rot_s(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp__cos_rot_s(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double SextupoleData_get__shift_x(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set__shift_x(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp__shift_x(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double SextupoleData_get__shift_y(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set__shift_y(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp__shift_y(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double SextupoleData_get__shift_s(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set__shift_s(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp__shift_s(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier SextupoleData_getp__internal_record_id(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_get__internal_record_id_buffer_id(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set__internal_record_id_buffer_id(SextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SextupoleData_getp__internal_record_id_buffer_id(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_get__internal_record_id_offset(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set__internal_record_id_offset(SextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SextupoleData_getp__internal_record_id_offset(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData SextupoleData_getp_internal_record(SextupoleData el, LocalParticle* part){
    RecordIdentifier record_id = SextupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/sextupole.h>

             static inline
            void Sextupole_track_local_particle_with_transformations(SextupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = SextupoleData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = SextupoleData_get__cos_rot_s(el);
    double const shift_x = SextupoleData_get__shift_x(el);
    double const shift_y = SextupoleData_get__shift_y(el);
    double const shift_s = SextupoleData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Sextupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = SextupoleData_get__cos_rot_s(el);
    double const shift_x = SextupoleData_get__shift_x(el);
    double const shift_y = SextupoleData_get__shift_y(el);
    double const shift_s = SextupoleData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Sextupole_track_particles(
               SextupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Sextupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RBendData
#define XOBJ_TYPEDEF_RBendData
typedef   struct RBendData_s * RBendData;
 static inline RBendData RBendData_getp(RBendData restrict  obj){
  int64_t offset=0;
  return (RBendData)(( char*) obj+offset);
}
 static inline double RBendData_get_k0(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_k0(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_k0(RBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_k1(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_k1(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_k1(RBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_h(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_h(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_h(RBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_angle(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_angle(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_angle(RBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_length(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_length(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_length(RBendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_model(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_model(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_model(RBendData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_integrator(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_integrator(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_integrator(RBendData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_radiation_flag(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_radiation_flag(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_radiation_flag(RBendData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double RBendData_get_delta_taper(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_delta_taper(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_delta_taper(RBendData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_edge_entry_active(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_entry_active(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_edge_entry_active(RBendData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_edge_exit_active(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_exit_active(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_edge_exit_active(RBendData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_edge_entry_model(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_entry_model(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_edge_entry_model(RBendData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_edge_exit_model(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_exit_model(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_edge_exit_model(RBendData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_entry_angle(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_entry_angle(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_entry_angle(RBendData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_exit_angle(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_exit_angle(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_exit_angle(RBendData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_entry_angle_fdown(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_entry_angle_fdown(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_entry_angle_fdown(RBendData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_exit_angle_fdown(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_exit_angle_fdown(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_exit_angle_fdown(RBendData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_entry_fint(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_entry_fint(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_entry_fint(RBendData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_exit_fint(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_exit_fint(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_exit_fint(RBendData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_entry_hgap(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_entry_hgap(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_entry_hgap(RBendData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_exit_hgap(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_exit_hgap(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_exit_hgap(RBendData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_num_multipole_kicks(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_num_multipole_kicks(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_num_multipole_kicks(RBendData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_order(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_order(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_order(RBendData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double RBendData_get_inv_factorial_order(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_inv_factorial_order(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_inv_factorial_order(RBendData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 RBendData_getp_knl(RBendData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t RBendData_len_knl(RBendData restrict  obj){
  int64_t offset=0;
  offset+=280;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double RBendData_get_knl(const RBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=280;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_knl(RBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=280;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp1_knl(RBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=280;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 RBendData_getp_ksl(RBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t RBendData_len_ksl(RBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double RBendData_get_ksl(const RBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_ksl(RBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp1_ksl(RBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t RBendData_get_k0_from_h(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_k0_from_h(RBendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* RBendData_getp_k0_from_h(RBendData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double RBendData_get_length_straight(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_length_straight(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_length_straight(RBendData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get__sin_rot_s(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set__sin_rot_s(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp__sin_rot_s(RBendData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get__cos_rot_s(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set__cos_rot_s(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp__cos_rot_s(RBendData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get__shift_x(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set__shift_x(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp__shift_x(RBendData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get__shift_y(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set__shift_y(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp__shift_y(RBendData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get__shift_s(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set__shift_s(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp__shift_s(RBendData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier RBendData_getp__internal_record_id(RBendData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t RBendData_get__internal_record_id_buffer_id(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set__internal_record_id_buffer_id(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp__internal_record_id_buffer_id(RBendData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get__internal_record_id_offset(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set__internal_record_id_offset(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=264;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp__internal_record_id_offset(RBendData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData RBendData_getp_internal_record(RBendData el, LocalParticle* part){
    RecordIdentifier record_id = RBendData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/rbend.h>

             static inline
            void RBend_track_local_particle_with_transformations(RBendData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = RBendData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = RBendData_get__cos_rot_s(el);
    double const shift_x = RBendData_get__shift_x(el);
    double const shift_y = RBendData_get__shift_y(el);
    double const shift_s = RBendData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    RBend_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = RBendData_get__cos_rot_s(el);
    double const shift_x = RBendData_get__shift_x(el);
    double const shift_y = RBendData_get__shift_y(el);
    double const shift_s = RBendData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void RBend_track_particles(
               RBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              RBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_MultipoleData
#define XOBJ_TYPEDEF_MultipoleData
typedef   struct MultipoleData_s * MultipoleData;
 static inline MultipoleData MultipoleData_getp(MultipoleData restrict  obj){
  int64_t offset=0;
  return (MultipoleData)(( char*) obj+offset);
}
 static inline int64_t MultipoleData_get_order(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_order(MultipoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MultipoleData_getp_order(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double MultipoleData_get_inv_factorial_order(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_inv_factorial_order(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp_inv_factorial_order(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleData_get_length(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_length(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp_length(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleData_get_hxl(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_hxl(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp_hxl(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t MultipoleData_get_radiation_flag(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_radiation_flag(MultipoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MultipoleData_getp_radiation_flag(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double MultipoleData_get_delta_taper(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_delta_taper(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp_delta_taper(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 MultipoleData_getp_knl(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t MultipoleData_len_knl(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double MultipoleData_get_knl(const MultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_knl(MultipoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp1_knl(MultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 MultipoleData_getp_ksl(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t MultipoleData_len_ksl(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double MultipoleData_get_ksl(const MultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_ksl(MultipoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp1_ksl(MultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleData_get__sin_rot_s(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set__sin_rot_s(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp__sin_rot_s(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleData_get__cos_rot_s(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set__cos_rot_s(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp__cos_rot_s(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleData_get__shift_x(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set__shift_x(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp__shift_x(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleData_get__shift_y(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set__shift_y(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp__shift_y(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleData_get__shift_s(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set__shift_s(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp__shift_s(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier MultipoleData_getp__internal_record_id(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t MultipoleData_get__internal_record_id_buffer_id(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MultipoleData_set__internal_record_id_buffer_id(MultipoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MultipoleData_getp__internal_record_id_buffer_id(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MultipoleData_get__internal_record_id_offset(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MultipoleData_set__internal_record_id_offset(MultipoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MultipoleData_getp__internal_record_id_offset(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData MultipoleData_getp_internal_record(MultipoleData el, LocalParticle* part){
    RecordIdentifier record_id = MultipoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/multipole.h>

             static inline
            void Multipole_track_local_particle_with_transformations(MultipoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = MultipoleData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = MultipoleData_get__cos_rot_s(el);
    double const shift_x = MultipoleData_get__shift_x(el);
    double const shift_y = MultipoleData_get__shift_y(el);
    double const shift_s = MultipoleData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Multipole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = MultipoleData_get__cos_rot_s(el);
    double const shift_x = MultipoleData_get__shift_x(el);
    double const shift_y = MultipoleData_get__shift_y(el);
    double const shift_s = MultipoleData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Multipole_track_particles(
               MultipoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Multipole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_MagnetData
#define XOBJ_TYPEDEF_MagnetData
typedef   struct MagnetData_s * MagnetData;
 static inline MagnetData MagnetData_getp(MagnetData restrict  obj){
  int64_t offset=0;
  return (MagnetData)(( char*) obj+offset);
}
 static inline double MagnetData_get_length(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_length(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_length(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_order(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_order(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_order(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double MagnetData_get_inv_factorial_order(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_inv_factorial_order(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_inv_factorial_order(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_num_multipole_kicks(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_num_multipole_kicks(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_num_multipole_kicks(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 MagnetData_getp_knl(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=320;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t MagnetData_len_knl(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=320;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double MagnetData_get_knl(const MagnetData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=320;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_knl(MagnetData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=320;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp1_knl(MagnetData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=320;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 MagnetData_getp_ksl(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t MagnetData_len_ksl(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double MagnetData_get_ksl(const MagnetData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_ksl(MagnetData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp1_ksl(MagnetData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k0(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k0(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k0(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k1(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k1(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k1(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k2(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k2(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k2(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k3(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k3(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k3(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k0s(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k0s(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k0s(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k1s(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k1s(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k1s(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k2s(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k2s(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k2s(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k3s(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k3s(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k3s(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_angle(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_angle(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_angle(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_h(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_h(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_h(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t MagnetData_get_k0_from_h(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k0_from_h(MagnetData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=120;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* MagnetData_getp_k0_from_h(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_edge_entry_active(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_entry_active(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=128;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_edge_entry_active(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_edge_exit_active(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_exit_active(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=136;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_edge_exit_active(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_edge_entry_model(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_entry_model(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_edge_entry_model(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_edge_exit_model(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_exit_model(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_edge_exit_model(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_entry_angle(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_entry_angle(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_entry_angle(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_exit_angle(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_exit_angle(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_exit_angle(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_entry_angle_fdown(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_entry_angle_fdown(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=176;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_entry_angle_fdown(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_exit_angle_fdown(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_exit_angle_fdown(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=184;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_exit_angle_fdown(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_entry_fint(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_entry_fint(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_entry_fint(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_exit_fint(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_exit_fint(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=200;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_exit_fint(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_entry_hgap(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_entry_hgap(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_entry_hgap(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_exit_hgap(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_exit_hgap(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_exit_hgap(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_model(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_model(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=224;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_model(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_integrator(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_integrator(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=232;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_integrator(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_radiation_flag(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_radiation_flag(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=240;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_radiation_flag(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double MagnetData_get_delta_taper(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_delta_taper(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_delta_taper(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get__sin_rot_s(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set__sin_rot_s(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=256;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp__sin_rot_s(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get__cos_rot_s(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set__cos_rot_s(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=264;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp__cos_rot_s(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get__shift_x(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set__shift_x(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=272;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp__shift_x(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get__shift_y(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set__shift_y(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=280;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp__shift_y(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get__shift_s(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=288;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set__shift_s(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=288;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp__shift_s(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=288;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier MagnetData_getp__internal_record_id(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=296;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get__internal_record_id_buffer_id(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=296;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set__internal_record_id_buffer_id(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=296;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp__internal_record_id_buffer_id(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=296;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get__internal_record_id_offset(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=304;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set__internal_record_id_offset(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=304;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp__internal_record_id_offset(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=304;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData MagnetData_getp_internal_record(MagnetData el, LocalParticle* part){
    RecordIdentifier record_id = MagnetData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/magnet.h>

             static inline
            void Magnet_track_local_particle_with_transformations(MagnetData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = MagnetData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = MagnetData_get__cos_rot_s(el);
    double const shift_x = MagnetData_get__shift_x(el);
    double const shift_y = MagnetData_get__shift_y(el);
    double const shift_s = MagnetData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Magnet_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = MagnetData_get__cos_rot_s(el);
    double const shift_x = MagnetData_get__shift_x(el);
    double const shift_y = MagnetData_get__shift_y(el);
    double const shift_s = MagnetData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Magnet_track_particles(
               MagnetData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Magnet_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_FirstOrderTaylorMapData
#define XOBJ_TYPEDEF_FirstOrderTaylorMapData
typedef   struct FirstOrderTaylorMapData_s * FirstOrderTaylorMapData;
 static inline FirstOrderTaylorMapData FirstOrderTaylorMapData_getp(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  return (FirstOrderTaylorMapData)(( char*) obj+offset);
}
 static inline double FirstOrderTaylorMapData_get_length(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set_length(FirstOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp_length(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr6Float64 FirstOrderTaylorMapData_getp_m0(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return (Arr6Float64)(( char*) obj+offset);
}
 static inline int64_t FirstOrderTaylorMapData_len_m0(FirstOrderTaylorMapData restrict  obj){
  return 6;
}
 static inline double FirstOrderTaylorMapData_get_m0(const FirstOrderTaylorMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=8;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set_m0(FirstOrderTaylorMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=8;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp1_m0(FirstOrderTaylorMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=8;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr6x6Float64 FirstOrderTaylorMapData_getp_m1(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return (Arr6x6Float64)(( char*) obj+offset);
}
 static inline int64_t FirstOrderTaylorMapData_len_m1(FirstOrderTaylorMapData restrict  obj){
  return 36;
}
 static inline double FirstOrderTaylorMapData_get_m1(const FirstOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=56;
  offset+=i0*48+i1*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set_m1(FirstOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1, double value){
  int64_t offset=0;
  offset+=56;
  offset+=i0*48+i1*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp2_m1(FirstOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=56;
  offset+=i0*48+i1*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double FirstOrderTaylorMapData_get__sin_rot_s(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=344;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set__sin_rot_s(FirstOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=344;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp__sin_rot_s(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=344;
  return ( double*)(( char*) obj+offset);
}
 static inline double FirstOrderTaylorMapData_get__cos_rot_s(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=352;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set__cos_rot_s(FirstOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=352;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp__cos_rot_s(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=352;
  return ( double*)(( char*) obj+offset);
}
 static inline double FirstOrderTaylorMapData_get__shift_x(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=360;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set__shift_x(FirstOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=360;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp__shift_x(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=360;
  return ( double*)(( char*) obj+offset);
}
 static inline double FirstOrderTaylorMapData_get__shift_y(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=368;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set__shift_y(FirstOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=368;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp__shift_y(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=368;
  return ( double*)(( char*) obj+offset);
}
 static inline double FirstOrderTaylorMapData_get__shift_s(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=376;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set__shift_s(FirstOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=376;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp__shift_s(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=376;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier FirstOrderTaylorMapData_getp__internal_record_id(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=384;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t FirstOrderTaylorMapData_get__internal_record_id_buffer_id(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=384;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set__internal_record_id_buffer_id(FirstOrderTaylorMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=384;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* FirstOrderTaylorMapData_getp__internal_record_id_buffer_id(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=384;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t FirstOrderTaylorMapData_get__internal_record_id_offset(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=392;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set__internal_record_id_offset(FirstOrderTaylorMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=392;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* FirstOrderTaylorMapData_getp__internal_record_id_offset(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=392;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData FirstOrderTaylorMapData_getp_internal_record(FirstOrderTaylorMapData el, LocalParticle* part){
    RecordIdentifier record_id = FirstOrderTaylorMapData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/firstordertaylormap.h>

             static inline
            void FirstOrderTaylorMap_track_local_particle_with_transformations(FirstOrderTaylorMapData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = FirstOrderTaylorMapData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = FirstOrderTaylorMapData_get__cos_rot_s(el);
    double const shift_x = FirstOrderTaylorMapData_get__shift_x(el);
    double const shift_y = FirstOrderTaylorMapData_get__shift_y(el);
    double const shift_s = FirstOrderTaylorMapData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    FirstOrderTaylorMap_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = FirstOrderTaylorMapData_get__cos_rot_s(el);
    double const shift_x = FirstOrderTaylorMapData_get__shift_x(el);
    double const shift_y = FirstOrderTaylorMapData_get__shift_y(el);
    double const shift_s = FirstOrderTaylorMapData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void FirstOrderTaylorMap_track_particles(
               FirstOrderTaylorMapData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              FirstOrderTaylorMap_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_BendData
#define XOBJ_TYPEDEF_BendData
typedef   struct BendData_s * BendData;
 static inline BendData BendData_getp(BendData restrict  obj){
  int64_t offset=0;
  return (BendData)(( char*) obj+offset);
}
 static inline double BendData_get_k0(const BendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_k0(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_k0(BendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_k1(const BendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_k1(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_k1(BendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_h(const BendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_h(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_h(BendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_angle(const BendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_angle(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_angle(BendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_length(const BendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_length(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_length(BendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_model(const BendData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_model(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_model(BendData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_integrator(const BendData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_integrator(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_integrator(BendData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_radiation_flag(const BendData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_radiation_flag(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_radiation_flag(BendData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BendData_get_delta_taper(const BendData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_delta_taper(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_delta_taper(BendData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_edge_entry_active(const BendData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_entry_active(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_edge_entry_active(BendData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_edge_exit_active(const BendData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_exit_active(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_edge_exit_active(BendData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_edge_entry_model(const BendData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_entry_model(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_edge_entry_model(BendData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_edge_exit_model(const BendData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_exit_model(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_edge_exit_model(BendData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_entry_angle(const BendData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_entry_angle(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_entry_angle(BendData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_exit_angle(const BendData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_exit_angle(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_exit_angle(BendData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_entry_angle_fdown(const BendData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_entry_angle_fdown(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_entry_angle_fdown(BendData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_exit_angle_fdown(const BendData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_exit_angle_fdown(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_exit_angle_fdown(BendData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_entry_fint(const BendData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_entry_fint(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_entry_fint(BendData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_exit_fint(const BendData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_exit_fint(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_exit_fint(BendData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_entry_hgap(const BendData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_entry_hgap(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_entry_hgap(BendData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_exit_hgap(const BendData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_exit_hgap(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_exit_hgap(BendData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_num_multipole_kicks(const BendData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_num_multipole_kicks(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_num_multipole_kicks(BendData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_order(const BendData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_order(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_order(BendData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BendData_get_inv_factorial_order(const BendData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_inv_factorial_order(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_inv_factorial_order(BendData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BendData_getp_knl(BendData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BendData_len_knl(BendData restrict  obj){
  int64_t offset=0;
  offset+=272;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BendData_get_knl(const BendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=272;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_knl(BendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=272;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp1_knl(BendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=272;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BendData_getp_ksl(BendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BendData_len_ksl(BendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BendData_get_ksl(const BendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_ksl(BendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp1_ksl(BendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t BendData_get_k0_from_h(const BendData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_k0_from_h(BendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* BendData_getp_k0_from_h(BendData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double BendData_get__sin_rot_s(const BendData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set__sin_rot_s(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp__sin_rot_s(BendData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get__cos_rot_s(const BendData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set__cos_rot_s(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp__cos_rot_s(BendData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get__shift_x(const BendData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set__shift_x(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp__shift_x(BendData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get__shift_y(const BendData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set__shift_y(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp__shift_y(BendData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get__shift_s(const BendData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set__shift_s(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp__shift_s(BendData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier BendData_getp__internal_record_id(BendData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t BendData_get__internal_record_id_buffer_id(const BendData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set__internal_record_id_buffer_id(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=248;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp__internal_record_id_buffer_id(BendData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BendData_get__internal_record_id_offset(const BendData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set__internal_record_id_offset(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp__internal_record_id_offset(BendData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData BendData_getp_internal_record(BendData el, LocalParticle* part){
    RecordIdentifier record_id = BendData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/bend.h>

             static inline
            void Bend_track_local_particle_with_transformations(BendData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = BendData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BendData_get__cos_rot_s(el);
    double const shift_x = BendData_get__shift_x(el);
    double const shift_y = BendData_get__shift_y(el);
    double const shift_s = BendData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Bend_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BendData_get__cos_rot_s(el);
    double const shift_x = BendData_get__shift_x(el);
    double const shift_y = BendData_get__shift_y(el);
    double const shift_s = BendData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Bend_track_particles(
               BendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Bend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_SolenoidData
#define XOBJ_TYPEDEF_SolenoidData
typedef   struct SolenoidData_s * SolenoidData;
 static inline SolenoidData SolenoidData_getp(SolenoidData restrict  obj){
  int64_t offset=0;
  return (SolenoidData)(( char*) obj+offset);
}
 static inline double SolenoidData_get_length(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_length(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_length(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_ks(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_ks(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_ks(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_ksi(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_ksi(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_ksi(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t SolenoidData_get_radiation_flag(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_radiation_flag(SolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SolenoidData_getp_radiation_flag(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t SolenoidData_get_num_multipole_kicks(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_num_multipole_kicks(SolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SolenoidData_getp_num_multipole_kicks(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t SolenoidData_get_order(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_order(SolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SolenoidData_getp_order(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_inv_factorial_order(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_inv_factorial_order(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_inv_factorial_order(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 SolenoidData_getp_knl(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t SolenoidData_len_knl(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double SolenoidData_get_knl(const SolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_knl(SolenoidData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp1_knl(SolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 SolenoidData_getp_ksl(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t SolenoidData_len_ksl(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double SolenoidData_get_ksl(const SolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_ksl(SolenoidData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp1_ksl(SolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_mult_rot_x_rad(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_mult_rot_x_rad(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_mult_rot_x_rad(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_mult_rot_y_rad(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_mult_rot_y_rad(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_mult_rot_y_rad(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_mult_shift_x(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_mult_shift_x(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_mult_shift_x(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_mult_shift_y(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_mult_shift_y(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_mult_shift_y(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_mult_shift_s(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_mult_shift_s(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_mult_shift_s(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get__sin_rot_s(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set__sin_rot_s(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp__sin_rot_s(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get__cos_rot_s(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set__cos_rot_s(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp__cos_rot_s(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get__shift_x(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set__shift_x(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp__shift_x(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get__shift_y(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set__shift_y(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp__shift_y(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get__shift_s(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set__shift_s(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp__shift_s(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier SolenoidData_getp__internal_record_id(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t SolenoidData_get__internal_record_id_buffer_id(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SolenoidData_set__internal_record_id_buffer_id(SolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SolenoidData_getp__internal_record_id_buffer_id(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t SolenoidData_get__internal_record_id_offset(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SolenoidData_set__internal_record_id_offset(SolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SolenoidData_getp__internal_record_id_offset(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData SolenoidData_getp_internal_record(SolenoidData el, LocalParticle* part){
    RecordIdentifier record_id = SolenoidData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/solenoid.h>

             static inline
            void Solenoid_track_local_particle_with_transformations(SolenoidData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = SolenoidData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = SolenoidData_get__cos_rot_s(el);
    double const shift_x = SolenoidData_get__shift_x(el);
    double const shift_y = SolenoidData_get__shift_y(el);
    double const shift_s = SolenoidData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Solenoid_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = SolenoidData_get__cos_rot_s(el);
    double const shift_x = SolenoidData_get__shift_x(el);
    double const shift_y = SolenoidData_get__shift_y(el);
    double const shift_s = SolenoidData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Solenoid_track_particles(
               SolenoidData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Solenoid_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_QuadrupoleData
#define XOBJ_TYPEDEF_QuadrupoleData
typedef   struct QuadrupoleData_s * QuadrupoleData;
 static inline QuadrupoleData QuadrupoleData_getp(QuadrupoleData restrict  obj){
  int64_t offset=0;
  return (QuadrupoleData)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get_k1(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_k1(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp_k1(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get_k1s(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_k1s(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp_k1s(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get_length(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_length(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp_length(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_get_num_multipole_kicks(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_num_multipole_kicks(QuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* QuadrupoleData_getp_num_multipole_kicks(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_get_order(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_order(QuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* QuadrupoleData_getp_order(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get_inv_factorial_order(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_inv_factorial_order(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp_inv_factorial_order(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 QuadrupoleData_getp_knl(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_len_knl(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double QuadrupoleData_get_knl(const QuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_knl(QuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp1_knl(QuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 QuadrupoleData_getp_ksl(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_len_ksl(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double QuadrupoleData_get_ksl(const QuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_ksl(QuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp1_ksl(QuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t QuadrupoleData_get_edge_entry_active(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_edge_entry_active(QuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* QuadrupoleData_getp_edge_entry_active(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t QuadrupoleData_get_edge_exit_active(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_edge_exit_active(QuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=64;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* QuadrupoleData_getp_edge_exit_active(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_get_model(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_model(QuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* QuadrupoleData_getp_model(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_get_integrator(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_integrator(QuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* QuadrupoleData_getp_integrator(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_get_radiation_flag(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_radiation_flag(QuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* QuadrupoleData_getp_radiation_flag(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get_delta_taper(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_delta_taper(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp_delta_taper(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get__sin_rot_s(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set__sin_rot_s(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp__sin_rot_s(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get__cos_rot_s(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set__cos_rot_s(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp__cos_rot_s(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get__shift_x(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set__shift_x(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp__shift_x(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get__shift_y(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set__shift_y(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp__shift_y(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get__shift_s(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set__shift_s(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp__shift_s(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier QuadrupoleData_getp__internal_record_id(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_get__internal_record_id_buffer_id(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set__internal_record_id_buffer_id(QuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* QuadrupoleData_getp__internal_record_id_buffer_id(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_get__internal_record_id_offset(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set__internal_record_id_offset(QuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* QuadrupoleData_getp__internal_record_id_offset(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData QuadrupoleData_getp_internal_record(QuadrupoleData el, LocalParticle* part){
    RecordIdentifier record_id = QuadrupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/quadrupole.h>

             static inline
            void Quadrupole_track_local_particle_with_transformations(QuadrupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = QuadrupoleData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = QuadrupoleData_get__cos_rot_s(el);
    double const shift_x = QuadrupoleData_get__shift_x(el);
    double const shift_y = QuadrupoleData_get__shift_y(el);
    double const shift_s = QuadrupoleData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Quadrupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = QuadrupoleData_get__cos_rot_s(el);
    double const shift_x = QuadrupoleData_get__shift_x(el);
    double const shift_y = QuadrupoleData_get__shift_y(el);
    double const shift_s = QuadrupoleData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Quadrupole_track_particles(
               QuadrupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Quadrupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_InvalidXcollData
#define XOBJ_TYPEDEF_InvalidXcollData
typedef   struct InvalidXcollData_s * InvalidXcollData;
 static inline InvalidXcollData InvalidXcollData_getp(InvalidXcollData restrict  obj){
  int64_t offset=0;
  return (InvalidXcollData)(( char*) obj+offset);
}
 static inline double InvalidXcollData_get_length(const InvalidXcollData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void InvalidXcollData_set_length(InvalidXcollData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InvalidXcollData_getp_length(InvalidXcollData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double InvalidXcollData_get__sin_rot_s(const InvalidXcollData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void InvalidXcollData_set__sin_rot_s(InvalidXcollData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InvalidXcollData_getp__sin_rot_s(InvalidXcollData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double InvalidXcollData_get__cos_rot_s(const InvalidXcollData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void InvalidXcollData_set__cos_rot_s(InvalidXcollData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InvalidXcollData_getp__cos_rot_s(InvalidXcollData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double InvalidXcollData_get__shift_x(const InvalidXcollData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void InvalidXcollData_set__shift_x(InvalidXcollData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InvalidXcollData_getp__shift_x(InvalidXcollData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double InvalidXcollData_get__shift_y(const InvalidXcollData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void InvalidXcollData_set__shift_y(InvalidXcollData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InvalidXcollData_getp__shift_y(InvalidXcollData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double InvalidXcollData_get__shift_s(const InvalidXcollData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void InvalidXcollData_set__shift_s(InvalidXcollData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* InvalidXcollData_getp__shift_s(InvalidXcollData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_STATES_H
#define XCOLL_STATES_H

#define  XC_LOST_ON_EVEREST_BLOCK   -330
#define  XC_LOST_ON_EVEREST_COLL    -331
#define  XC_LOST_ON_EVEREST_CRYSTAL -332
#define  XC_LOST_ON_FLUKA_BLOCK     -333
#define  XC_LOST_ON_FLUKA_COLL      -334
#define  XC_LOST_ON_FLUKA_CRYSTAL   -335
#define  XC_LOST_ON_GEANT4_BLOCK    -336
#define  XC_LOST_ON_GEANT4_COLL     -337
#define  XC_LOST_ON_GEANT4_CRYSTAL  -338
#define  XC_LOST_ON_ABSORBER        -340

#define  XC_ERR_INVALID_TRACK       -390
#define  XC_ERR_NOT_IMPLEMENTED     -391
#define  XC_ERR_INVALID_XOFIELD     -392
#define  XC_ERR                     -399

#endif /* XCOLL_STATES_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2023.                 #
// ######################################### #

#ifndef XCOLL_CHECKS_H
#define XCOLL_CHECKS_H

// This is a quick macro to use inside a function body on a parameter that is not
// used inside the function (this avoids throwing warnings at compilation time).
#ifndef UNUSED
#define UNUSED(expr) (void)(expr)
#endif

 static inline
int8_t xcoll_check_particle_init(RandomRutherfordData rng, LocalParticle* part) {
    int8_t is_tracking = assert_tracking(part, XC_ERR_INVALID_TRACK);
    if (!is_tracking){
        printf("Collimator tracking code is called, but we are not supposed to be tracking!"); //only_for_context cpu_serial
        fflush(stdout);                                                                        //only_for_context cpu_serial
    }
    int8_t rng_is_set  = assert_rng_set(part, RNG_ERR_SEEDS_NOT_SET);
    if (!rng_is_set){
        printf("Random generator seeds in particles object are not set!"); //only_for_context cpu_serial
        fflush(stdout);                                                    //only_for_context cpu_serial
    }
    int8_t ruth_is_set = assert_rutherford_set(rng, part, RNG_ERR_RUTH_NOT_SET);
    if (!ruth_is_set){
        printf("Rutherford random generator not initialised!"); //only_for_context cpu_serial
        fflush(stdout);                                         //only_for_context cpu_serial
    }
    return is_tracking*rng_is_set*ruth_is_set;
}

#endif /* XCOLL_CHECKS_H */

#ifndef XOBJ_TYPEDEF_LineSegmentMapData
#define XOBJ_TYPEDEF_LineSegmentMapData
typedef   struct LineSegmentMapData_s * LineSegmentMapData;
 static inline LineSegmentMapData LineSegmentMapData_getp(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  return (LineSegmentMapData)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_length(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_length(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_length(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_qx(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_qx(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_qx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_qy(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_qy(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_qy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LineSegmentMapData_getp_coeffs_dqx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=1000;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_coeffs_dqx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=1000;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LineSegmentMapData_get_coeffs_dqx(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=1000;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_coeffs_dqx(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=1000;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_coeffs_dqx(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=1000;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LineSegmentMapData_getp_coeffs_dqy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+968);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_coeffs_dqy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+968);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LineSegmentMapData_get_coeffs_dqy(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+968);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_coeffs_dqy(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+968);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_coeffs_dqy(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+968);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_det_xx(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_det_xx(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_det_xx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_det_xy(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_det_xy(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_det_xy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_det_yy(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_det_yy(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_det_yy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_det_yx(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_det_yx(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_det_yx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_betx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_betx(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_betx(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=64;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_betx(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=64;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_betx(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=64;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_bety(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_bety(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_bety(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_bety(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=80;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_bety(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_alfx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_alfx(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_alfx(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=96;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_alfx(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=96;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_alfx(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=96;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_alfy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_alfy(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_alfy(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=112;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_alfy(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=112;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_alfy(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=112;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_dx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_dx(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_dx(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_dx(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=128;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_dx(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_dpx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_dpx(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_dpx(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_dpx(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_dpx(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_dy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_dy(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_dy(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=160;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_dy(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=160;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_dy(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=160;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_dpy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_dpy(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_dpy(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=176;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_dpy(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=176;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_dpy(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=176;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_x_ref(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_x_ref(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_x_ref(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=192;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_x_ref(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=192;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_x_ref(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=192;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_px_ref(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_px_ref(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_px_ref(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=208;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_px_ref(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=208;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_px_ref(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=208;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_y_ref(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_y_ref(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_y_ref(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=224;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_y_ref(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=224;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_y_ref(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=224;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_py_ref(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_py_ref(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_py_ref(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=240;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_py_ref(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=240;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_py_ref(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=240;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_energy_ref_increment(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_energy_ref_increment(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=256;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_energy_ref_increment(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_energy_increment(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_energy_increment(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=264;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_energy_increment(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_get_uncorrelated_rad_damping(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_uncorrelated_rad_damping(LineSegmentMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=272;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LineSegmentMapData_getp_uncorrelated_rad_damping(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_get_correlated_rad_damping(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_correlated_rad_damping(LineSegmentMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=280;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LineSegmentMapData_getp_correlated_rad_damping(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline Arr6x6Float64 LineSegmentMapData_getp_damping_factors(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=288;
  return (Arr6x6Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_damping_factors(LineSegmentMapData restrict  obj){
  return 36;
}
 static inline double LineSegmentMapData_get_damping_factors(const LineSegmentMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=288;
  offset+=i0*48+i1*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_damping_factors(LineSegmentMapData restrict  obj, int64_t i0, int64_t i1, double value){
  int64_t offset=0;
  offset+=288;
  offset+=i0*48+i1*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp2_damping_factors(LineSegmentMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=288;
  offset+=i0*48+i1*8;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_get_uncorrelated_gauss_noise(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=576;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_uncorrelated_gauss_noise(LineSegmentMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=576;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LineSegmentMapData_getp_uncorrelated_gauss_noise(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=576;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_get_correlated_gauss_noise(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=584;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_correlated_gauss_noise(LineSegmentMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=584;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LineSegmentMapData_getp_correlated_gauss_noise(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=584;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline Arr6x6Float64 LineSegmentMapData_getp_gauss_noise_matrix(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=592;
  return (Arr6x6Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_gauss_noise_matrix(LineSegmentMapData restrict  obj){
  return 36;
}
 static inline double LineSegmentMapData_get_gauss_noise_matrix(const LineSegmentMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=592;
  offset+=i0*48+i1*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_gauss_noise_matrix(LineSegmentMapData restrict  obj, int64_t i0, int64_t i1, double value){
  int64_t offset=0;
  offset+=592;
  offset+=i0*48+i1*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp2_gauss_noise_matrix(LineSegmentMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=592;
  offset+=i0*48+i1*8;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_get_longitudinal_mode_flag(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=880;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_longitudinal_mode_flag(LineSegmentMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=880;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LineSegmentMapData_getp_longitudinal_mode_flag(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=880;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_qs(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=888;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_qs(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=888;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_qs(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=888;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_bets(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=896;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_bets(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=896;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_bets(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=896;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_bucket_length(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=904;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_bucket_length(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=904;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_bucket_length(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=904;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_momentum_compaction_factor(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=912;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_momentum_compaction_factor(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=912;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_momentum_compaction_factor(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=912;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_slippage_length(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=920;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_slippage_length(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=920;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_slippage_length(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=920;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LineSegmentMapData_getp_voltage_rf(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+976);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_voltage_rf(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+976);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LineSegmentMapData_get_voltage_rf(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+976);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_voltage_rf(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+976);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_voltage_rf(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+976);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LineSegmentMapData_getp_frequency_rf(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+984);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_frequency_rf(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+984);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LineSegmentMapData_get_frequency_rf(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+984);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_frequency_rf(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+984);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_frequency_rf(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+984);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LineSegmentMapData_getp_lag_rf(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+992);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_lag_rf(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+992);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LineSegmentMapData_get_lag_rf(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+992);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_lag_rf(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+992);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_lag_rf(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+992);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get__sin_rot_s(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=928;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set__sin_rot_s(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=928;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp__sin_rot_s(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=928;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get__cos_rot_s(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=936;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set__cos_rot_s(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=936;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp__cos_rot_s(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=936;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get__shift_x(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=944;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set__shift_x(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=944;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp__shift_x(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=944;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get__shift_y(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=952;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set__shift_y(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=952;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp__shift_y(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=952;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get__shift_s(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=960;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set__shift_s(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=960;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp__shift_s(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=960;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/linesegmentmap.h>

             static inline
            void LineSegmentMap_track_local_particle_with_transformations(LineSegmentMapData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LineSegmentMapData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LineSegmentMapData_get__cos_rot_s(el);
    double const shift_x = LineSegmentMapData_get__shift_x(el);
    double const shift_y = LineSegmentMapData_get__shift_y(el);
    double const shift_s = LineSegmentMapData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LineSegmentMap_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LineSegmentMapData_get__cos_rot_s(el);
    double const shift_x = LineSegmentMapData_get__shift_x(el);
    double const shift_y = LineSegmentMapData_get__shift_y(el);
    double const shift_s = LineSegmentMapData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LineSegmentMap_track_particles(
               LineSegmentMapData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LineSegmentMap_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_EverestEngineData
#define XOBJ_TYPEDEF_EverestEngineData
typedef   struct EverestEngineData_s * EverestEngineData;
 static inline EverestEngineData EverestEngineData_getp(EverestEngineData restrict  obj){
  int64_t offset=0;
  return (EverestEngineData)(( char*) obj+offset);
}
 static inline double EverestEngineData_get__sin_rot_s(const EverestEngineData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestEngineData_set__sin_rot_s(EverestEngineData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestEngineData_getp__sin_rot_s(EverestEngineData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestEngineData_get__cos_rot_s(const EverestEngineData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestEngineData_set__cos_rot_s(EverestEngineData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestEngineData_getp__cos_rot_s(EverestEngineData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestEngineData_get__shift_x(const EverestEngineData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestEngineData_set__shift_x(EverestEngineData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestEngineData_getp__shift_x(EverestEngineData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestEngineData_get__shift_y(const EverestEngineData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestEngineData_set__shift_y(EverestEngineData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestEngineData_getp__shift_y(EverestEngineData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestEngineData_get__shift_s(const EverestEngineData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestEngineData_set__shift_s(EverestEngineData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestEngineData_getp__shift_s(EverestEngineData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_GEOM_ROT_H
#define XCOLL_GEOM_ROT_H
#include <math.h>
#include <stdio.h>


 static inline
double YRotation_single_particle_rotate_only(LocalParticle* part, double s, double angle){
    double x   = LocalParticle_get_x(part);
    double rpp = LocalParticle_get_rpp(part);
    double sin_y = sin(angle);
    double cos_y = cos(angle);
    LocalParticle_set_x(part, x*cos_y - s*sin_y);
    LocalParticle_add_to_px(part,-angle/rpp);
    return x*sin_y + s*cos_y;  // new s
}

#endif /* XCOLL_GEOM_ROT_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2023.                 #
// ######################################### #

#ifndef XCOLL_EVEREST_CONSTANTS_H
#define XCOLL_EVEREST_CONSTANTS_H

#if !defined( XC_PROTON_MASS )
    #define   XC_PROTON_MASS ( 938.271998 )
#endif

#if !defined( XC_ELECTRON_MASS )
    #define   XC_ELECTRON_MASS ( 0.51099890 )
#endif

// Constant in front bethe-bloch [mev g^-1 cm^2]
#if !defined( XC_BETHE_BLOCH )
    #define   XC_BETHE_BLOCH ( 0.307075 )
#endif

#if !defined( XC_PP_CS_REF )
    #define   XC_PP_CS_REF ( 0.04 )
#endif

#if !defined( XC_FREE_CO )
    #define   XC_FREE_CO ( 1.618 )
#endif

#if !defined( XC_AVOGADRO )
    #define   XC_AVOGADRO ( 6.02214076e23 )
#endif

// -------------------------
// #### Crystal-specific ###
// -------------------------

// Screening function [m]
#if !defined( XC_SCREENING )
    #define   XC_SCREENING ( 0.194e-10 )
#endif

// Distance between planes (110) [m]
#if !defined( XC_PLANE_DISTANCE )
    #define   XC_PLANE_DISTANCE ( 1.920e-10 )
#endif

// Thermal vibrations amplitude
#if !defined( XC_THERMAL_VIBRATIONS )
    #define   XC_THERMAL_VIBRATIONS ( 0.075e-10 )
#endif 

// No idea what this represents physically...
#if !defined( XC_CRADE )
    #define   XC_CRADE ( 2.817940285e-15 )
#endif 


#endif /* XCOLL_EVEREST_CONSTANTS_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_EVEREST_ENGINE_H
#define XCOLL_EVEREST_ENGINE_H

#define XCOLL_TRANSITION

typedef struct EverestCollData_ {
    // Collimator properties
    RandomRutherfordData restrict rng;
    InteractionRecordData record;
    RecordIndex record_index;
    int8_t record_scatterings;
    // Material properties
    // TODO: can we use pointers for the MaterialData? It then gets a bit difficult to read them, ie *coll->exenergy
    double exenergy;
    double rho;
    double anuc;
    double zatom;
    double bnref;
    double csref[6];
    double radl;  // TODO: is this the same physically as collnt or dlri ?
    double dlri;
    double dlyi;
    double ai;
    double eum;
    double collnt;
    double eta;
    int8_t orient;
    int8_t only_mcs;
} EverestCollData_;
typedef EverestCollData_ *EverestCollData;

typedef struct EverestData_ {
    EverestCollData coll;
    // Dynamic parameters
    double cprob[6];
    double xintl;
    double bn;
    double ecmsq;
    double xln15s;
    double bpp;
    double prob_tail_c1;
    double prob_tail_c2;
    double prob_tail_c3;
    double prob_tail_c4;
    double energy_loss;
    double energy_loss_tail;
    // Crystal data
    double rescale_scattering;
    double t_c;
    double t_c0;
    double Rc_over_R;
    double Ang_rms;
    double Ang_avr;
    double Vcapt;
    double t_I;
    double t_P;
    double r;
} EverestData_;
typedef EverestData_ *EverestData;


 static inline
double LocalParticle_get_energy(LocalParticle* part){
    double mass_ratio = LocalParticle_get_charge_ratio(part) / LocalParticle_get_chi(part);
    return (LocalParticle_get_ptau(part)*LocalParticle_get_p0c(part) \
            + LocalParticle_get_energy0(part)) * mass_ratio;
}


 static inline
double drift_zeta_single(double rvv, double xp, double yp, double length){
    double const rv0v = 1./rvv;
    double const dzeta = 1 - rv0v * (1. + (pow(xp,2.) + pow(yp,2.))/2.);
    return length * dzeta;
}

 static inline
void Drift_single_particle_4d(LocalParticle* part, double length){
    double zeta = LocalParticle_get_zeta(part);
    Drift_single_particle(part, length);
    LocalParticle_set_zeta(part, zeta);
}

 
void RandomRutherford_set_by_xcoll_material(RandomRutherfordData ran, GeneralMaterialData material){
    if (GeneralMaterialData_get__only_mcs(material)){
        RandomRutherford_set(ran, 1, 1, 0.0001, 0.01);
        return;
    }
    double const zatom    = GeneralMaterialData_get_Z(material);
    double const emr      = GeneralMaterialData_get_nuclear_radius(material);
    double const hcut     = GeneralMaterialData_get_hcut(material);
    double const lcut     = 0.0009982;
    double const c = 0.8561e3; // TODO: Where tha fuck does this come from??
    double A = pow(zatom,2);
    double B = c*pow(emr,2);
    RandomRutherford_set(ran, A, B, lcut, hcut);
}

#endif /* XCOLL_EVEREST_ENGINE_H */
// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2023.                 #
// ######################################### #

#ifndef XCOLL_EVEREST_PROP_H
#define XCOLL_EVEREST_PROP_H
#include <stdlib.h>
#include <math.h>
#include <stdio.h>


 static inline
void calculate_scattering(EverestData restrict everest, double p) {
    if (everest->coll->only_mcs){   // TODO: this should be done smarter
        return;
    }
    // Material properties
    double const anuc  = everest->coll->anuc;
    double const rho   = everest->coll->rho;
    double const bnref = everest->coll->bnref;
    double csref[6];
    csref[0] = everest->coll->csref[0];
    csref[1] = everest->coll->csref[1];
    csref[5] = everest->coll->csref[5];

    double csect[6];

    everest->ecmsq = 2*XC_PROTON_MASS*1.0e-3*p;
    double ecmsq = everest->ecmsq;
    everest->xln15s = log(0.15*ecmsq);

    // Claudia Fit from COMPETE collaboration points "arXiv:hep-ph/0206172v1 19Jun2002"
    double pptot = 0.041084 - 0.0023302*log(ecmsq) + 0.00031514*pow(log(ecmsq), 2.);

    // Claudia used the fit from TOTEM for ppel (in barn)
    double ppel = (11.7 - 1.59*log(ecmsq) + 0.134*pow(log(ecmsq), 2.))/1e3;   // TODO /1.e3

    // Claudia updated SD cross that cointains renormalized pomeron flux (in barn)
    double ppsd = (4.3 + 0.3*log(ecmsq))/1e3;

    // Claudia new fit for the slope parameter with new data at sqrt(s)=7 TeV from TOTEM
    everest->bpp = 7.156 + 1.439*log(sqrt(ecmsq));

    // freep: number of nucleons involved in single scattering
    double freep = XC_FREE_CO * pow(anuc,(1./3.));

    // Rescale reference cross sections (only used for crystals)
    csref[0] = csref[0]*everest->rescale_scattering;
    csref[1] = csref[1]*everest->rescale_scattering;

    // compute pp and pn el+single diff contributions to cross-section
    // (both added : quasi-elastic or qel later)
    csect[3] = freep * ppel;
    csect[4] = freep * ppsd;

    // correct TOT-CSec for energy dependence of qel
    // TOT CS is here without a Coulomb contribution
    csect[0] = csref[0] + freep * (pptot - XC_PP_CS_REF);
    //Also correct inel-CS
    if(csref[0] == 0) {   // TODO: is this needed?
        csect[1] = 0;   // TODO: Is this correct? It seems as if it should be huge instead
        everest->bn = 1.e10;
    } else {
        csect[1] = csref[1] * csect[0] / csref[0];
        everest->bn = bnref * csect[0] / csref[0];
    }

    // Nuclear Elastic is TOT-inel-qel ( see definition in RPP)
    csect[2] = csect[0] - csect[1] - csect[3] - csect[4];
    csect[5] = csref[5];

    // Now add Coulomb
    csect[0] += csect[5];

    // Interaction length in meter
    everest->xintl = 1.0e-2*anuc/(XC_AVOGADRO*rho*csect[0]*1e-24);

    // Filling CProb with cumulated normalised Cross-sections
    int i;
    everest->cprob[0] = 0;
    if(csect[0] == 0) {   // TODO: is this needed?
        for (i=1; i<5; ++i){
            everest->cprob[i] = everest->cprob[i-1];  // TODO: seems wrong
        }
    } else {
        for (i=1; i<5; ++i){
            everest->cprob[i] = everest->cprob[i-1] + csect[i]/csect[0];
        }
    }
    everest->cprob[5] = 1;
}


 static inline
void calculate_ionisation_properties(EverestData restrict everest, double pc) {
    if (everest->coll->only_mcs){   // TODO: this should be done smarter
        return;
    }

    // Material properties
    double const exenergy = everest->coll->exenergy;
    double const rho      = everest->coll->rho;
    double const anuc     = everest->coll->anuc;
    double const zatom    = everest->coll->zatom;

    // Energy variables
    double momentum = pc*1.0e3;   // [MeV]
    double energy   = sqrt(pow(momentum, 2.) + pow(XC_PROTON_MASS, 2.)); // [MeV]
    double gammar   = energy/XC_PROTON_MASS;
    double betar    = momentum/energy;
    double bgr      = betar*gammar;
    double mep      = XC_ELECTRON_MASS/XC_PROTON_MASS;  // Electron/proton

    // tmax is max energy loss from kinematics
    double tmax = 2.*XC_ELECTRON_MASS*pow(bgr, 2.)/ (1. + 2.*gammar*mep + pow(mep, 2.));  // [MeV]
    double plen = sqrt(rho*zatom/anuc)*28.816e-6; // [MeV]

    everest->energy_loss = 0.5*log(2.*XC_ELECTRON_MASS*bgr*bgr*tmax/pow(exenergy, 2.)) + 0.5;
    everest->energy_loss -= pow(betar, 2.);
    everest->energy_loss -= log(plen/exenergy);
    everest->energy_loss -= log(bgr);
    everest->energy_loss *= XC_BETHE_BLOCH*zatom/(anuc* pow(betar, 2.))*rho*1.0e-1; // [GeV/m]

    everest->energy_loss_tail = 0.5*log(2*XC_ELECTRON_MASS*bgr*bgr*tmax/pow(exenergy, 2.)) + 0.5;
    everest->energy_loss_tail -= pow(betar, 2.);
    everest->energy_loss_tail -= log(plen/exenergy);
    everest->energy_loss_tail -= log(bgr);
    everest->energy_loss_tail += pow(tmax, 2.)/(8.*pow(energy, 2.));
    everest->energy_loss_tail *= XC_BETHE_BLOCH*zatom/(anuc*pow(betar, 2.))*rho*1.0e-1; // [GeV/m]

    double Tt = everest->energy_loss*1.0e3 + XC_BETHE_BLOCH*zatom*4.0e2*rho/(anuc*pow(betar, 2.)); // [MeV/m]

    // Calculate different coefficients for terms in dz (length) to get the tail probability
    double const prob_factor = rho*1.e2*XC_BETHE_BLOCH*zatom/(anuc*pow(betar, 2.));
    everest->prob_tail_c1 = prob_factor * 0.5 / Tt;
    everest->prob_tail_c2 = prob_factor * (
                        tmax/(4.*pow(energy, 2.)) - 0.5/tmax
                        - log(tmax/Tt)*pow(betar,2.)/(2.*tmax)
                   );  // * dz
    everest->prob_tail_c3 = prob_factor * pow(betar,2.)/(2.*tmax);  // * dz * log(dz)
    everest->prob_tail_c4 = -prob_factor * Tt/(4.*pow(energy, 2.));  // * dz * dz
}


 static inline
double calcionloss(EverestData restrict everest, LocalParticle* part, double length) {

#ifdef XCOLL_REFINE_ENERGY
    calculate_ionisation_properties(everest, pc);
#endif

    double prob_tail = everest->prob_tail_c1 + everest->prob_tail_c2 * length
                     + everest->prob_tail_c3 * length * log(length) + everest->prob_tail_c4 * length * length;

    if (RandomUniform_generate(part) < prob_tail) {
        return everest->energy_loss_tail;
    } else {
        return everest->energy_loss;
    }
}


 static inline
double calculate_dechanneling_length(EverestData restrict everest, double pc) {
    // Material properties
    double const exenergy = everest->coll->exenergy;

    // Energy variables
    double momentum = pc*1.0e3;   // [MeV]
    double energy   = sqrt(pow(momentum, 2.) + pow(XC_PROTON_MASS, 2.)); // [MeV]
    double gammar   = energy/XC_PROTON_MASS;

    double const_dech = 256.0/(9.*pow(M_PI, 2.)) / (log(2.*XC_ELECTRON_MASS*gammar/exenergy/1000) - 1.);
    const_dech       *= (XC_SCREENING*XC_PLANE_DISTANCE)/(XC_CRADE*XC_ELECTRON_MASS)*1.0e3; // [m/GeV]
    return const_dech;
}


#endif /* XCOLL_EVEREST_PROP_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_EVEREST_MCS_H
#define XCOLL_EVEREST_MCS_H
#include <math.h>
#include <stdio.h>


 static inline
double iterat(double a, double b, double dh, double s) {
    double ds = s;
    while (1) {
        ds = ds*0.5;
        if (pow(s,3) < pow((a+b*s),2)) {
            s = s+ds;
        } else {
            s = s-ds;
        }
        if (ds < dh) {
            break;
        } else {
            continue;
        }
    }
    return s;
}


 static inline
double soln3(double a, double b, double dh, double smax) {
    double s;
    if (b == 0) {
        s = pow(a,0.6666666666666667);
        if (s > smax) {
            s = smax;
        }
        return s;
    }
    if (a == 0) {
        if (b > 0) {
            s = pow(b,2);
        } else {
            s = 0;
        }
        if (s > smax) {
            s = smax;
        }
        return s;
    }
    if (b > 0) {
        if (pow(smax,3) <= pow((a + b*smax),2)) {
            s = smax;
            return s;
        } else {
            s = smax*0.5;
            s = iterat(a,b,dh,s);
        }
    } else {
        double c = (-1*a)/b;
        if (smax < c) {
            if ((pow(smax,3)) <= pow((a + b*smax),2)) {
                s = smax;
                return s;
            } else {
                s = smax*0.5;
                s = iterat(a,b,dh,s);
            }
        } else {
            s = c*0.5;
            s = iterat(a,b,dh,s);
        }
    }
    return s;
}


 static inline
double* scamcs(LocalParticle* part, double x0, double xp0, double s) {
    double* result = (double*)malloc(2 * sizeof(double));

    // Generate two Gaussian random numbers z1 and z2
    double r2 = 0;
    double v1 = 0;
    double v2 = 0;
    while (1) {
        v1 = 2*RandomUniform_generate(part) - 1;
        v2 = 2*RandomUniform_generate(part) - 1;
        r2 = pow(v1,2) + pow(v2,2);
        if(r2 < 1) {
            break;
        }
    }
    double a   = sqrt((-2*log(r2))/r2);
    double z1  = v1*a;
    double z2  = v2*a;

    // MCS scaling by length in units of radiation length
    double ss  = sqrt(s) * (1 + 0.038*log(s));

    result[0] = x0  + s*(xp0 + 0.5*ss*(z2 + z1*0.577350269));
    result[1] = xp0 + ss*z2;
    return result;
}


 static inline
void mcs(EverestData restrict everest, LocalParticle* part, double length, double p, int edge_check){
    InteractionRecordData record = everest->coll->record;
    RecordIndex record_index     = everest->coll->record_index;
    int8_t sc = everest->coll->record_scatterings;

    // First log particle at start of multiple coulomb scattering
    int64_t i_slot = -1;
    if (sc) i_slot = InteractionRecordData_log(record, record_index, part, XC_MULTIPLE_COULOMB_SCATTERING);

    double const radl = everest->coll->radl;
    double s;
    double theta = 13.6e-3/p;
    double h   = 0.001;
    double dh  = 0.0001;
    double bn0 = 0.4330127019;
    double rlen0 = length/radl;
    double rlen  = rlen0;

    double x  = LocalParticle_get_x(part);
    double z  = LocalParticle_get_y(part);
#ifdef XCOLL_USE_EXACT
    double xp = LocalParticle_get_exact_xp(part);  // This is tangent
    double zp = LocalParticle_get_exact_yp(part);  // This is tangent
#else
    double xp = LocalParticle_get_xp(part);
    double zp = LocalParticle_get_yp(part);
#endif

    x  = (x/theta)/radl;
    xp = xp/theta;
    z  = (z/theta)/radl;
    zp = zp/theta;

    if (edge_check){
        while (1) {
            double ae = bn0 * x;
            double be = bn0 * xp;
            // #######################################
            // ae = np.array(ae, dtype=np.double64)
            // be = np.array(be, dtype=np.double64)
            // dh = np.array(dh, dtype=np.double64)
            // rlen = np.array(rlen, dtype=np.double64)
            // s = np.array(s, dtype=np.double64)
            // #######################################
            s = soln3(ae,be,dh,rlen);
            if (s < h) {
                s = h;
            }
            // TODO: should cap s whenever we are out (the two if cases below), because now the scamcs is applied over an s that might be (slightly) too long
            double* res = scamcs(part, x, xp, s);
            x  = res[0];
            xp = res[1];
            free(res);
            if (x < 0) {
                // extrapolation back to where x = 0
                s = rlen0 - rlen + (s - x/xp);
                x = 0.0;
                break;
            }
            if (s + dh >= rlen) {
                s = rlen0;
                break;
            }
            rlen = rlen - s;
        }

    } else {
        double* res = scamcs(part, x, xp, rlen0);
        x  = res[0];
        xp = res[1];
        free(res);
        s = rlen0;
    }

    double* res = scamcs(part, z, zp, s);
    z  = res[0];
    zp = res[1];
    free(res);

    LocalParticle_set_x(part, x*theta*radl);
    LocalParticle_set_y(part, z*theta*radl);
#ifdef XCOLL_USE_EXACT
    LocalParticle_set_exact_xp_yp(part, xp*theta, zp*theta);
#else
    LocalParticle_set_xp_yp(part, xp*theta, zp*theta);
#endif
    LocalParticle_add_to_s(part, s*radl);

    // Finally log particle at end of multiple coulomb scattering
    if (sc) InteractionRecordData_log_child(record, i_slot, part);
}

#endif /* XCOLL_EVEREST_MCS_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_EVEREST_NUCL_H
#define XCOLL_EVEREST_NUCL_H
#include <math.h>
#include <stdio.h>


 static inline
double nuclear_interaction(EverestData restrict everest, LocalParticle* part, double pc) {
    InteractionRecordData record = everest->coll->record;
    RecordIndex record_index     = everest->coll->record_index;
    int8_t sc = everest->coll->record_scatterings;

#ifdef XCOLL_REFINE_ENERGY
    calculate_scattering(everest, pc);
#endif

    //Choose nuclear interaction
    double aran = RandomUniform_generate(part);
    int ichoix = 1;

    while (aran > everest->cprob[ichoix]) {
        ichoix += 1;
    }

    //Do the interaction
    int64_t i_slot = -1;
    if (ichoix==1) {
        if (sc) i_slot = InteractionRecordData_log(record, record_index, part, XC_ABSORBED);
        LocalParticle_set_state(part, XC_LOST_ON_EVEREST_COLL);

    } else {
        double teta;
        if (ichoix==2) { // p-n elastic
            if (sc) i_slot = InteractionRecordData_log(record, record_index, part, XC_PN_ELASTIC);
            teta  = sqrt(RandomExponential_generate(part)/everest->bn)/pc;

        } else if (ichoix==3) { // p-p elastic
            if (sc) i_slot = InteractionRecordData_log(record, record_index, part, XC_PP_ELASTIC);
            teta  = sqrt(RandomExponential_generate(part)/everest->bpp)/pc;

        } else if (ichoix==4) { // Single diffractive
            if (sc) i_slot = InteractionRecordData_log(record, record_index, part, XC_SINGLE_DIFFRACTIVE);
            double xm2 = exp(RandomUniform_generate(part)*everest->xln15s);
            double bsd;
            if (xm2 < 2.) {
                bsd = 2*everest->bpp;
            } else if (xm2 >= 2. && xm2 <= 5.) {
                bsd = ((106.0 - 17.0*xm2)*everest->bpp)/36.0;
            } else {
                bsd = (7*everest->bpp)/12.0;
            }
            double pc_in = pc;
            pc = pc*(1 - xm2/everest->ecmsq);
            // Corrected 1/p into 1/sqrt(pp')
            teta = sqrt(RandomExponential_generate(part)/bsd)/sqrt(pc_in*pc);

        } else { // Coulomb
            if (sc) i_slot = InteractionRecordData_log(record, record_index, part, XC_COULOMB);
            teta = sqrt(RandomRutherford_generate(everest->coll->rng, part))/pc;
        }

        // TODO: I am not convinced that we can just sample two independent random numbers
        // I believe it should be tan(tx) = cos(phi) * tan(teta)    and    tan(ty) = sin(phi) * tan(teta)
        // with phi uniformly sampled between 0 and 2 pi
        double tx = teta*RandomNormal_generate(part);
        double tz = teta*RandomNormal_generate(part);

        //Change the angles
#ifdef XCOLL_USE_EXACT
        LocalParticle_add_to_exact_xp_yp(part, tx, tz);
#else
        LocalParticle_add_to_xp_yp(part, tx, tz);
#endif

        if (sc) InteractionRecordData_log_child(record, i_slot, part);
    }

    return pc;
}

#endif /* XCOLL_EVEREST_NUCL_H */
// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2023.                 #
// ######################################### #

#ifndef XCOLL_EVEREST_CRYSTAL_PARAMETERS_H
#define XCOLL_EVEREST_CRYSTAL_PARAMETERS_H
#include <math.h>
#include <stdio.h>
#include <stdlib.h>


 static inline
void calculate_initial_angle(EverestData restrict everest, LocalParticle* part, CrystalGeometry restrict cg){
    double R = cg->bending_radius;
    double s = LocalParticle_get_s(part);
    double x = LocalParticle_get_x(part);
    double s_P = cg->s_P;
    double x_P = cg->x_P;
    double r   = sqrt((s-s_P)*(s-s_P) + (x-x_P)*(x-x_P));
    everest->r = r;
    everest->t_I = R/fabs(R)*asin( (s-s_P)/r); // Tangent angle of the channeling planes (not neccecarly the same as xp)
}


 static inline
void calculate_opening_angle(EverestData restrict everest, LocalParticle* part, CrystalGeometry restrict cg){
    double t    = cg->bending_angle;
    double xd   = cg->width;
    double R    = cg->bending_radius;
    double sinp = sin(cg->miscut_angle);
    double cosp = cos(cg->miscut_angle);

    // Radius from starting point to miscut centre
    double r = everest->r;
    // Intersection with exit face
    double bb = R/2. * sin(2.*t) * (1 - cosp - tan(t)*sinp);
    double s_F = bb + sqrt(bb*bb - tan(t)*sin(2.*t)*(R*R*(1-cosp) - r*r/2.));
    double x_F = R - s_F/tan(t);

    // We could intersect with the upper (positive miscut) or lower bend (negative miscut) before the exit face
    // Distance between bending centre and miscut centre:
    double d = R*sqrt(2*(1-cosp));
    if (cg->miscut_angle > 0){
        // Check if intersection with upper bend R-xd is possible
        double Rb = R-xd;
        if (d > fabs(r - Rb)){
            double st_UB = (r*r - Rb*Rb)/(2*d);
            double xt_UB = -sqrt(r*r/2. + Rb*Rb/2. - st_UB*st_UB - d*d/4.);
            double s_UB  = (st_UB/d - 0.5)*R*sinp - xt_UB/d*R*(1-cosp);
            if (s_F > s_UB){
                // Upper bend encountered before exit face
                s_F = s_UB;
                x_F = (st_UB/d + 0.5)*R*(1-cosp) + xt_UB/d*R*sinp + R*cosp;
            }
        }
    } else {
        // Check if intersection with lower bend R is possible
        if (d > fabs(R - r)){
            double st_LB = (R*R - r*r)/(2*d);
            double xt_LB = -sqrt(r*r/2. + R*R/2. - st_LB*st_LB - d*d/4.);
            double s_LB  = -(st_LB/d + 0.5)*R*sinp + xt_LB/d*R*(1-cosp);
            if (s_F > s_LB){
                // Lower bend encountered before exit face
                s_F = s_LB;
                x_F = -(st_LB/d - 0.5)*R*(1-cosp) - xt_LB/d*R*sinp + R*cosp;
            }
        }
    }

    // Opening angle of channeling trajectory
    double s = LocalParticle_get_s(part);
    double x = LocalParticle_get_x(part);
    everest->t_P = acos(1 - ( (s_F-s)*(s_F-s) - (x_F-x)*(x_F-x) ) / (2*r*r) );
}


 static inline
double _critical_angle0(EverestCollData restrict coll, double pc){
    // Define typical angles/probabilities for orientation 110
    double eum   = coll->eum;
    double eta   = coll->eta;
    return sqrt(2.e-9*eta*eum/pc); // Critical angle (rad) for straight crystals    // pc is actually beta pc
}

 static inline
double _critical_radius(EverestCollData restrict coll, double pc){
    // Define typical angles/probabilities for orientation 110
    double eum   = coll->eum;
    double ai    = coll->ai;
    double eta   = coll->eta;
    return pc/(2.e-6*sqrt(eta)*eum)*ai;  // Critical curvature radius [m]   // pc is actually beta pc
}

 static inline
double _critical_angle(EverestCollData restrict coll, double t_c0, double Rc_over_R){
    double t_c = 0;
    if (Rc_over_R <= 1.) {
        // Otherwise no channeling possible
        t_c = t_c0*(1 - Rc_over_R); // Critical angle for curved crystal
        if (coll->orient == 2) {
            t_c *= 0.98;
        }
    }
    return t_c;
}

 static inline
void calculate_critical_angle(EverestData restrict everest, LocalParticle* part, CrystalGeometry restrict cg, double pc){
    // Define typical angles/probabilities for orientation 110
    everest->t_c0  = _critical_angle0(everest->coll, pc);
    double Rcrit = _critical_radius(everest->coll, pc);
    everest->Rc_over_R = Rcrit / fabs(cg->bending_radius);
    everest->t_c = _critical_angle(everest->coll, everest->t_c0, everest->Rc_over_R);
}


 static inline
void calculate_VI_parameters(EverestData restrict everest, LocalParticle* part, double pc){

    double ratio = everest->Rc_over_R;
    double t_c0  = everest->t_c0;

    // Correction by sasha drozdin/armen    // TODO: pc = energy
    // K=0.0007 is taken based on simulations using CATCH.f (V.Biryukov)
    // TODO: From the paper (arXiv:0808.1486, eq (18), (34)) it seems the power of E should be 0.25
    // Typo in Daniele's thesis in 3.25 (E^0.2 instead of 1/E^0.2)
    everest->Vcapt = 7.e-4*(1./ratio - 0.7)/pow(pc, 0.2);

    double Ang_rms, Ang_avr;
    double c1 = -3./2.;   // Fitting coefficient
    double c2 = 5./3.;  // Fitting coefficient
    double c3 =  1.7;   // Fitting coefficient
    if (ratio > 1.) {
        // no channeling possibile
        Ang_avr = c1*t_c0*5.e-2/ratio;         // Average angle reflection
        Ang_rms = c3*0.42*t_c0*sin(1.4/ratio); // RMS scattering
        everest->Vcapt = 0.;                   // Probability of VC is zero
    } else if (ratio > 1./3.) {
        // Strongly bent crystal
        Ang_avr = c1*t_c0*(0.1972/ratio - 0.1472);        // Average angle reflection
        Ang_rms = c3*0.42*t_c0*sin(0.4713/ratio + 0.85);  // RMS scattering
    } else {
        // Rcrit << R
        Ang_avr = c1*t_c0*(1. - c2*ratio);     // Average angle for VR
        Ang_rms = c3*t_c0*ratio;               // RMS scattering
    }
    if (everest->coll->orient == 2) {
        Ang_avr = Ang_avr*0.93;
        Ang_rms = Ang_rms*1.05;
    }

    everest->Ang_rms = Ang_rms;
    everest->Ang_avr = Ang_avr;
}

#endif /* XCOLL_EVEREST_CRYSTAL_PARAMETERS_H */
// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2023.                 #
// ######################################### #

#ifndef XCOLL_EVEREST_AMORPHOUS_H
#define XCOLL_EVEREST_AMORPHOUS_H
#include <math.h>
#include <stdio.h>
#include <stdlib.h>


 static inline
void volume_reflection(EverestData restrict everest, LocalParticle* part, int8_t transition) {

    InteractionRecordData record = everest->coll->record;
    RecordIndex record_index     = everest->coll->record_index;
    int8_t sc = everest->coll->record_scatterings;
    int64_t i_slot = -1;


    double Ang_avr = everest->Ang_avr;
    double Ang_rms = everest->Ang_rms;

    if (transition == XC_VOLUME_REFLECTION_TRANS_CH){
        // We are in transition from CH to VR
        double xp = LocalParticle_get_xp(part);
        // TODO: we believe the original 0.45 comes from the 0.9 saturation factor, so we changed it to 0.5
        Ang_avr *= 0.5*((xp - everest->t_I)/everest->t_c + 1);
        Ang_rms  = 0;   // TODO: why does transition to CH not use any spread?
        if (sc) i_slot = InteractionRecordData_log(record, record_index, part, XC_VOLUME_REFLECTION_TRANS_CH);

    } else if (transition == XC_VOLUME_REFLECTION_TRANS_MCS){
        // We are in transition from VR to MCS
//         double t_c = everest->t_c;
//         double t_P = everest->t_P;
//         double xp_rel = LocalParticle_get_xp(part) - everest->t_I;
//         // TODO: where does 3 come from
//         Ang_rms *= -3.*(xp_rel-t_P)/(2.*t_c); // TODO: why no random number?
        Ang_rms *= RandomNormal_generate(part);
        if (sc) i_slot = InteractionRecordData_log(record, record_index, part, XC_VOLUME_REFLECTION_TRANS_MCS);

    } else {
        Ang_rms *= RandomNormal_generate(part);
        if (sc) i_slot = InteractionRecordData_log(record, record_index, part, XC_VOLUME_REFLECTION);
    }

    double t_VR = Ang_avr + Ang_rms;
    LocalParticle_add_to_xp(part, t_VR);
    if (sc) InteractionRecordData_log_child(record, i_slot, part);
}


// Amorphous transport is just Multiple Coulomb scattering
 static inline
double amorphous_transport(EverestData restrict everest, LocalParticle* part, double pc, double length, int8_t transition) {

    InteractionRecordData record = everest->coll->record;
    RecordIndex record_index     = everest->coll->record_index;
    int8_t sc = everest->coll->record_scatterings;
    int64_t i_slot = -1;

    // Accumulated effect of mcs on the angles (with initial energy)
    // TODO: pc is energy
    // TODO: missing factor (1 + 0.038*log( L / dlri) )  ( *Z if not protons)
    double dya = (13.6/pc)*sqrt(length/everest->coll->dlri)*1.0e-3; // RMS of coloumb scattering MCS (rad)
    double kxmcs, kymcs;

    if (transition == XC_MULTIPLE_COULOMB_TRANS_VR){
        // Transition MCS
        if (sc) i_slot = InteractionRecordData_log(record, record_index, part, XC_MULTIPLE_COULOMB_TRANS_VR);
//         double xp_rel = LocalParticle_get_xp(part) - everest->t_I;
//         double t_P = everest->t_P;
//         double t_c = everest->t_c;
//         dya *= 1 - (xp_rel-t_P)/(2.*t_c);
    } else {
        // Normal MCS
        if (sc) i_slot = InteractionRecordData_log(record, record_index, part, XC_MULTIPLE_COULOMB_SCATTERING);
    }
    kxmcs = dya*RandomNormal_generate(part);
    kymcs = dya*RandomNormal_generate(part);

    // Transport of Multiple Coulomb Scattering
    Drift_single_particle_4d(part, length);

    // Energy lost because of ionisation process[GeV]
    double energy_loss = calcionloss(everest, part, length);
    pc  = pc - energy_loss*length;

    // Store new angles
    LocalParticle_add_to_xp_yp(part, kxmcs, kymcs);

    // Finally log particle at end of mcs
    if (sc) InteractionRecordData_log_child(record, i_slot, part);

    return pc;
}

double Channel(EverestData restrict everest, LocalParticle* part, CrystalGeometry restrict cg, double pc, double length);

 static inline
double Amorphous(EverestData restrict everest, LocalParticle* part, CrystalGeometry restrict cg, double pc, double length, int8_t allow_VI) {

    if (LocalParticle_get_state(part) < 1){
        // Do nothing if already absorbed
        return pc;
    }

    InteractionRecordData record = everest->coll->record;
    RecordIndex record_index     = everest->coll->record_index;
    int8_t sc = everest->coll->record_scatterings;

    calculate_initial_angle(everest, part, cg);

    // -----------------------------------------------
    // Calculate longitudinal position where we go out
    // -----------------------------------------------
    // Assumption: crystal bends away from beam (this does not work when crystal bends towards beam)
    // All s are absolute in the collimator frame
    double R = cg->bending_radius;
    double t = cg->bending_angle;
    double d = cg->width;
    double s  = LocalParticle_get_s(part);
    double x  = LocalParticle_get_x(part);
    double xp = LocalParticle_get_xp(part);
    // We either exit the crystal at the exit face
    double s1 = (R - x + s*xp) / (xp + cos(t)/sin(t) );
    if (s1 < s) {s1 = 1e10;}
    // or the larger bend
    double dd = (R - x + s*xp) / (1 + xp*xp);
    double s2 = dd*xp + sqrt(R*R / (1 + xp*xp) * dd*dd);
    if (s2 < s) {s2 = 1e10;}
    // or the smaller bend (which potentially has two solutions, in case the particle enters again before the exit face)
    double s3 = dd*xp - sqrt( (R-d)*(R-d) / (1 + xp*xp) * dd*dd);
    if (s3 < s) {s3 = 1e10;}
    // whichever comes first after the current position.
    // This gives us an "exit length" \with respect to the current position
    double exit_point  = fmin(fmin(s1, s2), s3);
    double length_exit = fmin(exit_point - s, length);

    // ----------------------------------------------------
    // Calculate longitudinal length of nuclear interaction
    // ----------------------------------------------------
    double length_nucl = everest->coll->collnt*RandomExponential_generate(part);

    // --------------------------------------------------------------
    // Calculate longitudinal length of volume interaction (VR or VC)
    // --------------------------------------------------------------
    // This happens when the particle is tangential to the crystal planes.
    // The (straight) trajectory until the point of reflection is r sin(xp - t_I),
    // hence the longitudinal length is r sin(xp - miscut) cos xp
    double length_VI = everest->r * sin(xp - everest->t_I) * cos(xp);
    // If length_VI is negative, VI is not possible, so set to a big value
    if (length_VI < 0) {length_VI = 1e10;}
    // Calculate extra length to transition region between VR and AM
    double length_VR_trans = everest->r * sin(xp - everest->t_I - 2.*everest->t_c) * cos(xp - 2.*everest->t_c);
    if (length_VR_trans < 0) {length_VR_trans = 1e10;}

    // ------------------------------------------------------------------------
    // Compare the 3 lengths: the first one encountered is what will be applied
    // ------------------------------------------------------------------------
    if (length_VI <= fmin(length_nucl, length_exit) && allow_VI == 1){
        // MCS to volume interaction
        pc = amorphous_transport(everest, part, pc, length_VI, 0);
#ifdef XCOLL_REFINE_ENERGY
        calculate_VI_parameters(everest, part, pc);
#endif
        // Are we reflecting or captured?
        if (RandomUniform_generate(part) > everest->Vcapt) {
            // Volume Reflection
            volume_reflection(everest, part, 0);
            // We call the main Amorphous function for the leftover
            pc = Amorphous(everest, part, cg, pc, length - length_VI, 0);

        } else {
            // Volume Capture
            if (sc) InteractionRecordData_log(record, record_index, part, XC_VOLUME_CAPTURE);
            // We call the main Channel function for the leftover
            pc = Channel(everest, part, cg, pc, length - length_VI);
        }

#ifdef XCOLL_TRANSITION
    } else if (length_VR_trans <= fmin(length_nucl, length_exit) && allow_VI == 1){
        // Transition region between VR and AM for t_P < xp - tI < t_P + 2t_c
#ifdef XCOLL_REFINE_ENERGY
        calculate_critical_angle(everest, part, cg, pc);
#endif
        double xp_rel = xp - everest->t_I;
        double t_P = everest->t_P;
        double t_c = everest->t_c;
        double prob_MCS = (xp_rel - t_P) / (2*t_c);
        if (RandomUniform_generate(part) > prob_MCS){
            // We are on the VR side
            pc = amorphous_transport(everest, part, pc, length_VR_trans, 0);
            volume_reflection(everest, part, XC_VOLUME_REFLECTION_TRANS_MCS);
            pc = Amorphous(everest, part, cg,  pc, length - length_VR_trans, 0);
        } else {
            // We are on the AM side
            // if (sc) InteractionRecordData_log(record, record_index, part, XC_MULTIPLE_COULOMB_TRANS_VR);
            pc = amorphous_transport(everest, part, pc, length_VR_trans, XC_MULTIPLE_COULOMB_TRANS_VR);
            pc = Amorphous(everest, part, cg, pc, length - length_VR_trans, 0);
        }
#endif

    } else if (length_nucl < length_exit) {
        // MCS to nuclear interaction
        pc = amorphous_transport(everest, part, pc, length_nucl, 0);
        // interact
        pc = nuclear_interaction(everest, part, pc);
        if (LocalParticle_get_state(part) == XC_LOST_ON_EVEREST_COLL){
            LocalParticle_set_state(part, XC_LOST_ON_EVEREST_CRYSTAL);
        } else {
            // We call the main Amorphous function for the leftover
            pc = Amorphous(everest, part, cg, pc, length - length_nucl, 1);
        }

    } else {
        // Exit crystal
        // MCS to exit point
        pc = amorphous_transport(everest, part, pc, length_exit, 0);
        // However, if we have exited at s3, and we encounter s4 before s2, we reenter:
        double s4 = dd*xp + sqrt( (R-d)*(R-d) / (1 + xp*xp) * dd*dd);  // second solution for smaller bend
        if (s3 < fmin(s1, s2) && s4 < s2){
            // We drift until re-entry
            Drift_single_particle_4d(part, s4 - exit_point);
            // We call the main Amorphous function for the leftover
            pc = Amorphous(everest, part, cg, pc, length - length_exit - s4 + exit_point, 1);
        }
    }

    return pc;
}

#endif /* XCOLL_EVEREST_AMORPHOUS_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_EVEREST_JAW_H
#define XCOLL_EVEREST_JAW_H
#include <math.h>
#include <stdio.h>


 static inline
double jaw(EverestData restrict everest, LocalParticle* part, double p, double length, int edge_check) {
    if (LocalParticle_get_state(part) < 1){
        // Do nothing if already absorbed
        return p;
    }

    double rlen = length;
    double s0 = LocalParticle_get_s(part);
    p /= 1e9;   // Energy (not momentum) in GeV

    if (everest->coll->only_mcs) {
        mcs(everest, part, rlen, p, edge_check);

    } else {
        // Do a step for a point-like interaction.
        // Get monte-carlo interaction length.
        while (1) {
            calculate_ionisation_properties(everest, p);
            double length_step = everest->xintl*RandomExponential_generate(part);

            // If the monte-carlo interaction length is longer than the remaining
            // length, then put it to the remaining length, do mcs and return.
            if (length_step > rlen) {
                mcs(everest, part, rlen, p, edge_check);
                break;
            }

            // Otherwise do multi-coulomb scattering.
            mcs(everest, part, length_step, p, edge_check);

            if(LocalParticle_get_x(part) <= 0) {
                // PARTICLE LEFT COLLIMATOR BEFORE ITS END.
                break;
            }

            p = nuclear_interaction(everest, part, p);
            if (LocalParticle_get_state(part) < 1){
                // PARTICLE WAS ABSORBED INSIDE COLLIMATOR DURING MCS.
                break;
            }

            // Calculate the remaining interaction length and close the iteration loop.
            rlen = rlen - length_step;
        }
        // TODO: ionisation loss should also be calculated when only_mcs
        double m_dpodx = calcionloss(everest, part, rlen);  // DM routine to include tail // TODO: should not be rlen but s after updating
        double s = LocalParticle_get_s(part) - s0;
        p = p-m_dpodx*s; // TODO: This is correct: ionisation loss is only calculated and applied at end of while (break)
    }
    return p*1e9;  // Back to eV
}

#endif /* XCOLL_EVEREST_JAW_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2023.                 #
// ######################################### #

#ifndef XCOLL_EVEREST_CHANNELING_H
#define XCOLL_EVEREST_CHANNELING_H
#include <math.h>
#include <stdio.h>
#include <stdlib.h>


// Convention:
//       L: length of curved trajectory
//       s: longitudinal coordinate (in collimator frame)  -  projection of curved trajectory
//       t: opening angle of curve ('t' for theta)
//       r: radius from position to bending centre (including t_I):  L = t*r


 static inline
double channeling_average_density(EverestData restrict everest, CrystalGeometry restrict cg, LocalParticle* part, double pc) {

    // Material properties
    double const anuc = everest->coll->anuc;
    double const rho  = everest->coll->rho;
    double const eum  = everest->coll->eum;

    double bend_r = cg->bending_radius;
    double ratio  = everest->Rc_over_R;

    //Rescale the total and inelastic cross-section accordigly to the average density seen
    double x_i = LocalParticle_get_x(part);
    double xp  = LocalParticle_get_xp(part);
    int np     = x_i/XC_PLANE_DISTANCE;          //Calculate in which crystalline plane the particle enters
    x_i       -= (np + 0.5)*XC_PLANE_DISTANCE;   //Rescale the incoming x to the middle of the crystalline plane

    double pv   = pow(pc, 2.)/sqrt(pow(pc, 2.) + pow(XC_PROTON_MASS*1.0e-3, 2.))*1.0e9; //Calculate pv=P/E   TODO: this is beta?
    double Ueff = eum*4.*pow(x_i/XC_PLANE_DISTANCE, 2.) + pv*x_i/bend_r; //Calculate effective potential
    double Et   = pv*pow(xp, 2.)/2. + Ueff;       //Calculate transverse energy
    double Ec   = eum*pow(1. - ratio, 2.);         //Calculate critical energy in bent crystals

    //To avoid negative Et
    double xminU = -pow(XC_PLANE_DISTANCE, 2.)*pc*1.0e9/(8.*eum*bend_r);
    double Umin  = fabs(eum*4.*pow(xminU/XC_PLANE_DISTANCE, 2.) + pv*xminU/bend_r);
    Et    = Et + Umin;
    Ec    = Ec + Umin;

    //Calculate min e max of the trajectory between crystalline planes
    double x_min = -0.5*XC_PLANE_DISTANCE*ratio - 0.5*XC_PLANE_DISTANCE*sqrt(Et/Ec);
    double x_max = -0.5*XC_PLANE_DISTANCE*ratio + 0.5*XC_PLANE_DISTANCE*sqrt(Et/Ec);

    //Change ref. frame and go back with 0 on the crystalline plane on the left
    x_min = x_min - XC_PLANE_DISTANCE/2.;
    x_max = x_max - XC_PLANE_DISTANCE/2.;

    //Calculate the "normal density" in m^-3
    double N_am  = rho*XC_AVOGADRO*1.0e6/anuc;

    //Calculate atomic density at min and max of the trajectory oscillation
    // erf returns the error function of complex argument
    double rho_max = erf(x_max/sqrt(2*pow(XC_THERMAL_VIBRATIONS, 2.)));
    rho_max       -= erf((XC_PLANE_DISTANCE-x_max)/sqrt(2*pow(XC_THERMAL_VIBRATIONS, 2.)));
    rho_max       *= N_am*XC_PLANE_DISTANCE/2.;
    double rho_min = erf(x_min/sqrt(2*pow(XC_THERMAL_VIBRATIONS, 2.)));
    rho_min       -= erf((XC_PLANE_DISTANCE-x_min)/sqrt(2*pow(XC_THERMAL_VIBRATIONS, 2.)));
    rho_min       *= N_am*XC_PLANE_DISTANCE/2.;

    //"zero-approximation" of average nuclear density seen along the trajectory
    double avrrho  = (rho_max - rho_min)/(x_max - x_min);
    avrrho  = 2.*avrrho/N_am;

    return avrrho;
}


 static inline
double* channel_transport(EverestData restrict everest, LocalParticle* part, double pc, double L_chan, double t_I, double t_P) {
    // Channeling: happens over an arc length L_chan (potentially less if dechanneling)
    //             This equates to an opening angle t_P wrt. to the point P (center of miscut if at start of crystal)
    //             The chord angle xp at the start of channeling (I) is t_P/2 + t_I
    //             The angle xp at the end of channeling (F) is t_P + t_I
    //             In practice: we drift from start to end, but overwrite the angle afterwards
    // TODO: why does channeling only have 50% energy loss?

    double* result = (double*)malloc(2 * sizeof(double));

    InteractionRecordData record = everest->coll->record;
    RecordIndex record_index     = everest->coll->record_index;
    int8_t sc = everest->coll->record_scatterings;

    // First log particle at start of channeling
    int64_t i_slot = -1;
    if (sc) i_slot = InteractionRecordData_log(record, record_index, part, XC_CHANNELING);

    // Do channeling.
    // The distance from I to F is the chord length of the angle t_P: d = 2 r sin(t_P/2)
    // Hence the longitudinal distance (the length to be drifted) is the projection of this using the
    // xp at the start of channeling: s = 2 r sin(t_P/2)cos(t_P/2 + t_I)
    double t_chord= t_I + t_P/2.;
    double drift_length = 2.*L_chan/t_P * sin(t_P/2.) * cos(t_chord);
    LocalParticle_set_xp(part, t_chord);          // Angle at start of channeling
    Drift_single_particle_4d(part, drift_length);
    // In reality,the particle oscillates horizontally between the planes while channeling.
    // This effect is mimicked by giving a random angle spread at the exit
    double sigma_ran = 0.5*everest->t_c;
    double ran_angle = RandomNormal_generate(part)*sigma_ran;
    LocalParticle_set_xp(part, t_I + t_P + ran_angle); // Angle at end of channeling

    // Apply energy loss along trajectory
    double energy_loss = 0.5*calcionloss(everest, part, L_chan);
    // TODO: LocalParticle_add_to_energy(part, - energy_loss*L_chan*1.e9, change_angle);
    // if change_angle = 0  => LocalParticle_scale_px(part, old_rpp / new_rpp) such that xp remains the same
    // It is done in K2, so we should do it. Though, it seems that with the current implementation in xtrack
    // this is no longer correct with exact drifts...?
    pc = pc - energy_loss*L_chan; //energy loss to ionization [GeV]

    // Finally log particle at end of channeling
    if (sc) InteractionRecordData_log_child(record, i_slot, part);

    result[0] = drift_length;
    result[1] = pc;
    return result;
}


double Channel(EverestData restrict everest, LocalParticle* part, CrystalGeometry restrict cg, double pc, double length) {

    if (LocalParticle_get_state(part) < 1){
        // Do nothing if already absorbed
        return pc;
    }

    InteractionRecordData record = everest->coll->record;
    RecordIndex record_index     = everest->coll->record_index;
    int8_t sc = everest->coll->record_scatterings;

    calculate_initial_angle(everest, part, cg);
#ifdef XCOLL_REFINE_ENERGY
    calculate_critical_angle(everest, part, cg, pc);
#endif

    // Do we channel, or are we in the transition between channeling and VR?
    double xp = LocalParticle_get_xp(part);
    double alpha = fabs(xp - everest->t_I) / everest->t_c;
    double ratio = everest->Rc_over_R;
    double xi = RandomUniform_generate(part)/(1 - ratio)/sqrt(everest->coll->eta);

    if (xi > 1 || alpha > 2*sqrt(xi)*sqrt(1-xi)) {
#ifdef XCOLL_TRANSITION
        // TRANSITION
        // We feel that this transition is not needed, as it interpolates between two regions
        // (adding a slant below the channeling region) which does not seem to be present in
        // experimental data.
#ifdef XCOLL_REFINE_ENERGY
        calculate_VI_parameters(everest, part, pc);
#endif
        volume_reflection(everest, part, XC_VOLUME_REFLECTION_TRANS_CH);
#endif
        pc = Amorphous(everest, part, cg, pc, length, 1);

    } else {
        // CHANNEL
        calculate_opening_angle(everest, part, cg);
        double t_I = everest->t_I;
        double t_P = everest->t_P;
        double L_chan = everest->r*t_P;

        // ------------------------------------------------
        // Calculate curved length L_dechan of dechanneling
        // ------------------------------------------------
        double const_dech = calculate_dechanneling_length(everest, pc);
        double TLdech1 = const_dech*pc*pow(1. - ratio, 2.); //Updated calculate typical dech. length(m)
        double N_atom = 1.0e-1;
        if(RandomUniform_generate(part) <= N_atom) {
            TLdech1 /= 200.;   // Updated dechanneling length (m)      
        }
        double L_dechan = TLdech1*RandomExponential_generate(part);   // Actual dechan. length

        // -----------------------------------------------------
        // Calculate curved length L_nucl of nuclear interaction
        // -----------------------------------------------------
        // Nuclear interaction length is rescaled in this case, because channeling
        double collnt = everest->coll->collnt;
        double avrrho = channeling_average_density(everest, cg, part, pc);
        if (avrrho == 0) {
            collnt = 1.e10;  // very large because essentially 1/0
        } else {
            collnt = collnt/avrrho;
        }
        double L_nucl = collnt*RandomExponential_generate(part);

// printf("Channeling (%f -> %f):   L_c: %f,  L_d: %f,  L_n: %f\n", t_I, t_P, L_chan, L_dechan, L_nucl);
        // ------------------------------------------------------------------------
        // Compare the 3 lengths: the first one encountered is what will be applied
        // ------------------------------------------------------------------------
        if (L_chan <= fmin(L_dechan, L_nucl)){
            // Channel full length
            double* result_chan = channel_transport(everest, part, pc, L_chan, t_I, t_P);
            // double channeled_length = result_chan[0];
            pc               = result_chan[1];
            free(result_chan);

        } else if (L_dechan < L_nucl) {
            // Channel up to L_dechan, then amorphous
            double* result_chan = channel_transport(everest, part, pc, L_dechan, t_I, t_P*L_dechan/L_chan);
            double channeled_length = result_chan[0];
            pc               = result_chan[1];
            free(result_chan);
            if (sc) InteractionRecordData_log(record, record_index, part, XC_DECHANNELING);
            pc = Amorphous(everest, part, cg, pc, length - channeled_length, 1);

        } else {
            // Channel up to L_nucl, then scatter, then amorphous
            double* result_chan = channel_transport(everest, part, pc, L_nucl, t_I, t_P*L_nucl/L_chan);
            double channeled_length = result_chan[0];
            pc               = result_chan[1];
            free(result_chan);
            // Rescale nuclear interaction parameters
            everest->rescale_scattering = avrrho;
#ifndef XCOLL_REFINE_ENERGY
            calculate_scattering(everest, pc);
#endif
            pc = nuclear_interaction(everest, part, pc);
            if (LocalParticle_get_state(part) == XC_LOST_ON_EVEREST_COLL){
                LocalParticle_set_state(part, XC_LOST_ON_EVEREST_CRYSTAL);
            } else {
                // We call the main Amorphous function for the leftover
                everest->rescale_scattering = 1;
#ifndef XCOLL_REFINE_ENERGY
                calculate_scattering(everest, pc);
#endif
                pc = Amorphous(everest, part, cg, pc, length - channeled_length, 1);
            }
        }
    }

    return pc;
}

#endif /* XCOLL_EVEREST_CHANNELING_H */

#ifndef XOBJ_TYPEDEF_RefOctupoleData
#define XOBJ_TYPEDEF_RefOctupoleData
typedef   struct RefOctupoleData_s * RefOctupoleData;
#endif
#ifndef XOBJ_TYPEDEF_RefSextupoleData
#define XOBJ_TYPEDEF_RefSextupoleData
typedef   struct RefSextupoleData_s * RefSextupoleData;
#endif
#ifndef XOBJ_TYPEDEF_RefRBendData
#define XOBJ_TYPEDEF_RefRBendData
typedef   struct RefRBendData_s * RefRBendData;
#endif
#ifndef XOBJ_TYPEDEF_RefBendData
#define XOBJ_TYPEDEF_RefBendData
typedef   struct RefBendData_s * RefBendData;
#endif
#ifndef XOBJ_TYPEDEF_RefSolenoidData
#define XOBJ_TYPEDEF_RefSolenoidData
typedef   struct RefSolenoidData_s * RefSolenoidData;
#endif
#ifndef XOBJ_TYPEDEF_RefQuadrupoleData
#define XOBJ_TYPEDEF_RefQuadrupoleData
typedef   struct RefQuadrupoleData_s * RefQuadrupoleData;
#endif
#ifndef XOBJ_TYPEDEF_BlowUpData
#define XOBJ_TYPEDEF_BlowUpData
typedef   struct BlowUpData_s * BlowUpData;
 static inline BlowUpData BlowUpData_getp(BlowUpData restrict  obj){
  int64_t offset=0;
  return (BlowUpData)(( char*) obj+offset);
}
 static inline int8_t BlowUpData_get__plane(const BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *(( int8_t*) obj+offset);
}
 static inline void BlowUpData_set__plane(BlowUpData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=8;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BlowUpData_getp__plane(BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline int64_t BlowUpData_get_start_at_turn(const BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BlowUpData_set_start_at_turn(BlowUpData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BlowUpData_getp_start_at_turn(BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BlowUpData_get_stop_at_turn(const BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BlowUpData_set_stop_at_turn(BlowUpData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BlowUpData_getp_stop_at_turn(BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int8_t BlowUpData_get_use_individual_kicks(const BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *(( int8_t*) obj+offset);
}
 static inline void BlowUpData_set_use_individual_kicks(BlowUpData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=32;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BlowUpData_getp_use_individual_kicks(BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double BlowUpData_get__max_kick(const BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlowUpData_set__max_kick(BlowUpData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlowUpData_getp__max_kick(BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BlowUpData_getp__rans(BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BlowUpData_len__rans(BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=104;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BlowUpData_get__rans(const BlowUpData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=104;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlowUpData_set__rans(BlowUpData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=104;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlowUpData_getp1__rans(BlowUpData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=104;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlowUpData_get__calibration(const BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlowUpData_set__calibration(BlowUpData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlowUpData_getp__calibration(BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t BlowUpData_get__active(const BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *(( int8_t*) obj+offset);
}
 static inline void BlowUpData_set__active(BlowUpData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=56;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BlowUpData_getp__active(BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double BlowUpData_get__sin_rot_s(const BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlowUpData_set__sin_rot_s(BlowUpData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlowUpData_getp__sin_rot_s(BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlowUpData_get__cos_rot_s(const BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlowUpData_set__cos_rot_s(BlowUpData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlowUpData_getp__cos_rot_s(BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlowUpData_get__shift_x(const BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlowUpData_set__shift_x(BlowUpData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlowUpData_getp__shift_x(BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlowUpData_get__shift_y(const BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlowUpData_set__shift_y(BlowUpData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlowUpData_getp__shift_y(BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlowUpData_get__shift_s(const BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlowUpData_set__shift_s(BlowUpData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlowUpData_getp__shift_s(BlowUpData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_BLOWUP_H
#define XCOLL_BLOWUP_H

 static inline
void BlowUp_track_local_particle(BlowUpData el, LocalParticle* part0){

    int8_t plane          = BlowUpData_get__plane(el);
    double max_kick       = BlowUpData_get__max_kick(el);
    int8_t active         = BlowUpData_get__active(el);
    int8_t individual     = BlowUpData_get_use_individual_kicks(el);
    int64_t start_at_turn = BlowUpData_get_start_at_turn(el);
    int64_t stop_at_turn  = BlowUpData_get_stop_at_turn(el);


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

        if (active){
            int64_t at_turn = LocalParticle_get_at_turn(part);
            if (at_turn >= start_at_turn && at_turn < stop_at_turn){
                double ran;
                if (individual){
                    ran = (2*RandomUniform_generate(part) - 1);
                } else {
                    ran = BlowUpData_get__rans(el, at_turn - start_at_turn);
                }
                double kick = max_kick * ran;
                if (plane == 1){
                    LocalParticle_add_to_px(part, kick);
                } else if (plane == -1){
                    LocalParticle_add_to_py(part, kick);
                } else {
                    LocalParticle_kill_particle(part, XC_ERR_INVALID_XOFIELD);
                }
            }
        }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

}

#endif /* XCOLL_BLOWUP_H */


             static inline
            void BlowUp_track_local_particle_with_transformations(BlowUpData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = BlowUpData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BlowUpData_get__cos_rot_s(el);
    double const shift_x = BlowUpData_get__shift_x(el);
    double const shift_y = BlowUpData_get__shift_y(el);
    double const shift_s = BlowUpData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    BlowUp_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BlowUpData_get__cos_rot_s(el);
    double const shift_x = BlowUpData_get__shift_x(el);
    double const shift_y = BlowUpData_get__shift_y(el);
    double const shift_s = BlowUpData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void BlowUp_track_particles(
               BlowUpData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              BlowUp_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_BaseBlockData
#define XOBJ_TYPEDEF_BaseBlockData
typedef   struct BaseBlockData_s * BaseBlockData;
 static inline BaseBlockData BaseBlockData_getp(BaseBlockData restrict  obj){
  int64_t offset=0;
  return (BaseBlockData)(( char*) obj+offset);
}
 static inline double BaseBlockData_get_length(const BaseBlockData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseBlockData_set_length(BaseBlockData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseBlockData_getp_length(BaseBlockData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t BaseBlockData_get_active(const BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *(( int8_t*) obj+offset);
}
 static inline void BaseBlockData_set_active(BaseBlockData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=8;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BaseBlockData_getp_active(BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline int8_t BaseBlockData_get__record_interactions(const BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *(( int8_t*) obj+offset);
}
 static inline void BaseBlockData_set__record_interactions(BaseBlockData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=16;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BaseBlockData_getp__record_interactions(BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double BaseBlockData_get__sin_rot_s(const BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseBlockData_set__sin_rot_s(BaseBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseBlockData_getp__sin_rot_s(BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseBlockData_get__cos_rot_s(const BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseBlockData_set__cos_rot_s(BaseBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseBlockData_getp__cos_rot_s(BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseBlockData_get__shift_x(const BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseBlockData_set__shift_x(BaseBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseBlockData_getp__shift_x(BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseBlockData_get__shift_y(const BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseBlockData_set__shift_y(BaseBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseBlockData_getp__shift_y(BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseBlockData_get__shift_s(const BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseBlockData_set__shift_s(BaseBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseBlockData_getp__shift_s(BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier BaseBlockData_getp__internal_record_id(BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t BaseBlockData_get__internal_record_id_buffer_id(const BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BaseBlockData_set__internal_record_id_buffer_id(BaseBlockData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BaseBlockData_getp__internal_record_id_buffer_id(BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BaseBlockData_get__internal_record_id_offset(const BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BaseBlockData_set__internal_record_id_offset(BaseBlockData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BaseBlockData_getp__internal_record_id_offset(BaseBlockData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
InteractionRecordData BaseBlockData_getp_internal_record(BaseBlockData el, LocalParticle* part){
    RecordIdentifier record_id = BaseBlockData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (InteractionRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#ifndef XOBJ_TYPEDEF_ThinSliceOctupoleExitData
#define XOBJ_TYPEDEF_ThinSliceOctupoleExitData
typedef   struct ThinSliceOctupoleExitData_s * ThinSliceOctupoleExitData;
 static inline ThinSliceOctupoleExitData ThinSliceOctupoleExitData_getp(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  return (ThinSliceOctupoleExitData)(( char*) obj+offset);
}
 static inline OctupoleData ThinSliceOctupoleExitData_getp__parent(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (OctupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent_k3(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_k3(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent_k3(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent_k3s(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_k3s(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent_k3s(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent_length(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_length(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent_length(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get__parent_order(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_order(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp__parent_order(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent_inv_factorial_order(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_inv_factorial_order(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent_inv_factorial_order(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceOctupoleExitData_getp__parent_knl(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_len__parent_knl(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceOctupoleExitData_get__parent_knl(const ThinSliceOctupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_knl(ThinSliceOctupoleExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp1__parent_knl(ThinSliceOctupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceOctupoleExitData_getp__parent_ksl(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_len__parent_ksl(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceOctupoleExitData_get__parent_ksl(const ThinSliceOctupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_ksl(ThinSliceOctupoleExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp1__parent_ksl(ThinSliceOctupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceOctupoleExitData_get__parent_edge_entry_active(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_edge_entry_active(ThinSliceOctupoleExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceOctupoleExitData_getp__parent_edge_entry_active(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceOctupoleExitData_get__parent_edge_exit_active(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_edge_exit_active(ThinSliceOctupoleExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceOctupoleExitData_getp__parent_edge_exit_active(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get__parent_num_multipole_kicks(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_num_multipole_kicks(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp__parent_num_multipole_kicks(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get__parent_model(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_model(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp__parent_model(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get__parent_integrator(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_integrator(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp__parent_integrator(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get__parent_radiation_flag(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_radiation_flag(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp__parent_radiation_flag(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent_delta_taper(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_delta_taper(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent_delta_taper(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent__sin_rot_s(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent__sin_rot_s(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent__sin_rot_s(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent__cos_rot_s(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent__cos_rot_s(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent__cos_rot_s(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent__shift_x(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent__shift_x(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent__shift_x(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent__shift_y(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent__shift_y(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent__shift_y(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent__shift_s(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent__shift_s(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent__shift_s(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceOctupoleExitData_getp__parent__internal_record_id(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get__parent__internal_record_id_buffer_id(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent__internal_record_id_buffer_id(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp__parent__internal_record_id_buffer_id(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get__parent__internal_record_id_offset(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent__internal_record_id_offset(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp__parent__internal_record_id_offset(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get_radiation_flag(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set_radiation_flag(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp_radiation_flag(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get_delta_taper(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set_delta_taper(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp_delta_taper(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get_weight(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set_weight(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp_weight(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_octupole_exit.h>

             static inline
            void ThinSliceOctupoleExit_track_local_particle_with_transformations(ThinSliceOctupoleExitData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceOctupoleExitData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceOctupoleExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceOctupoleExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceOctupoleExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceOctupoleExitData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceOctupoleExit_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceOctupoleExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceOctupoleExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceOctupoleExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceOctupoleExitData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceOctupoleExit_track_particles(
               ThinSliceOctupoleExitData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceOctupoleExit_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThickSliceOctupoleData
#define XOBJ_TYPEDEF_ThickSliceOctupoleData
typedef   struct ThickSliceOctupoleData_s * ThickSliceOctupoleData;
 static inline ThickSliceOctupoleData ThickSliceOctupoleData_getp(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  return (ThickSliceOctupoleData)(( char*) obj+offset);
}
 static inline OctupoleData ThickSliceOctupoleData_getp__parent(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (OctupoleData)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent_k3(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_k3(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent_k3(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent_k3s(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_k3s(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent_k3s(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent_length(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_length(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent_length(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__parent_order(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_order(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__parent_order(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent_inv_factorial_order(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_inv_factorial_order(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent_inv_factorial_order(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceOctupoleData_getp__parent_knl(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_len__parent_knl(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceOctupoleData_get__parent_knl(const ThickSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_knl(ThickSliceOctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp1__parent_knl(ThickSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceOctupoleData_getp__parent_ksl(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_len__parent_ksl(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceOctupoleData_get__parent_ksl(const ThickSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_ksl(ThickSliceOctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp1__parent_ksl(ThickSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceOctupoleData_get__parent_edge_entry_active(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_edge_entry_active(ThickSliceOctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceOctupoleData_getp__parent_edge_entry_active(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceOctupoleData_get__parent_edge_exit_active(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_edge_exit_active(ThickSliceOctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceOctupoleData_getp__parent_edge_exit_active(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__parent_num_multipole_kicks(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_num_multipole_kicks(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__parent_num_multipole_kicks(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__parent_model(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_model(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__parent_model(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__parent_integrator(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_integrator(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__parent_integrator(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__parent_radiation_flag(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_radiation_flag(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__parent_radiation_flag(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent_delta_taper(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_delta_taper(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent_delta_taper(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent__sin_rot_s(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent__sin_rot_s(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent__sin_rot_s(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent__cos_rot_s(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent__cos_rot_s(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent__cos_rot_s(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent__shift_x(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent__shift_x(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent__shift_x(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent__shift_y(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent__shift_y(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent__shift_y(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent__shift_s(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent__shift_s(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent__shift_s(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceOctupoleData_getp__parent__internal_record_id(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__parent__internal_record_id_buffer_id(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent__internal_record_id_buffer_id(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__parent__internal_record_id_buffer_id(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__parent__internal_record_id_offset(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent__internal_record_id_offset(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__parent__internal_record_id_offset(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get_radiation_flag(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set_radiation_flag(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp_radiation_flag(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get_delta_taper(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set_delta_taper(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp_delta_taper(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get_weight(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set_weight(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp_weight(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceOctupoleData_getp__internal_record_id(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__internal_record_id_buffer_id(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__internal_record_id_buffer_id(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__internal_record_id_buffer_id(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__internal_record_id_offset(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__internal_record_id_offset(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__internal_record_id_offset(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThickSliceOctupoleData_getp_internal_record(ThickSliceOctupoleData el, LocalParticle* part){
    RecordIdentifier record_id = ThickSliceOctupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/thick_slice_octupole.h>

             static inline
            void ThickSliceOctupole_track_local_particle_with_transformations(ThickSliceOctupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThickSliceOctupoleData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceOctupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceOctupoleData_get__parent__shift_x(el);
    double const shift_y = ThickSliceOctupoleData_get__parent__shift_y(el);
    double const shift_s = ThickSliceOctupoleData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThickSliceOctupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceOctupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceOctupoleData_get__parent__shift_x(el);
    double const shift_y = ThickSliceOctupoleData_get__parent__shift_y(el);
    double const shift_s = ThickSliceOctupoleData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThickSliceOctupole_track_particles(
               ThickSliceOctupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThickSliceOctupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceOctupoleEntryData
#define XOBJ_TYPEDEF_ThinSliceOctupoleEntryData
typedef   struct ThinSliceOctupoleEntryData_s * ThinSliceOctupoleEntryData;
 static inline ThinSliceOctupoleEntryData ThinSliceOctupoleEntryData_getp(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  return (ThinSliceOctupoleEntryData)(( char*) obj+offset);
}
 static inline OctupoleData ThinSliceOctupoleEntryData_getp__parent(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (OctupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent_k3(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_k3(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent_k3(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent_k3s(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_k3s(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent_k3s(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent_length(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_length(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent_length(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get__parent_order(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_order(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp__parent_order(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent_inv_factorial_order(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_inv_factorial_order(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent_inv_factorial_order(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceOctupoleEntryData_getp__parent_knl(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_len__parent_knl(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceOctupoleEntryData_get__parent_knl(const ThinSliceOctupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_knl(ThinSliceOctupoleEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp1__parent_knl(ThinSliceOctupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceOctupoleEntryData_getp__parent_ksl(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_len__parent_ksl(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceOctupoleEntryData_get__parent_ksl(const ThinSliceOctupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_ksl(ThinSliceOctupoleEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp1__parent_ksl(ThinSliceOctupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceOctupoleEntryData_get__parent_edge_entry_active(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_edge_entry_active(ThinSliceOctupoleEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceOctupoleEntryData_getp__parent_edge_entry_active(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceOctupoleEntryData_get__parent_edge_exit_active(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_edge_exit_active(ThinSliceOctupoleEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceOctupoleEntryData_getp__parent_edge_exit_active(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get__parent_num_multipole_kicks(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_num_multipole_kicks(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp__parent_num_multipole_kicks(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get__parent_model(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_model(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp__parent_model(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get__parent_integrator(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_integrator(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp__parent_integrator(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get__parent_radiation_flag(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_radiation_flag(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp__parent_radiation_flag(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent_delta_taper(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_delta_taper(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent_delta_taper(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent__sin_rot_s(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent__sin_rot_s(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent__sin_rot_s(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent__cos_rot_s(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent__cos_rot_s(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent__cos_rot_s(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent__shift_x(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent__shift_x(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent__shift_x(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent__shift_y(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent__shift_y(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent__shift_y(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent__shift_s(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent__shift_s(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent__shift_s(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceOctupoleEntryData_getp__parent__internal_record_id(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get__parent__internal_record_id_buffer_id(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent__internal_record_id_buffer_id(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp__parent__internal_record_id_buffer_id(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get__parent__internal_record_id_offset(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent__internal_record_id_offset(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp__parent__internal_record_id_offset(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get_radiation_flag(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set_radiation_flag(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp_radiation_flag(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get_delta_taper(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set_delta_taper(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp_delta_taper(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get_weight(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set_weight(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp_weight(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_octupole_entry.h>

             static inline
            void ThinSliceOctupoleEntry_track_local_particle_with_transformations(ThinSliceOctupoleEntryData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceOctupoleEntryData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceOctupoleEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceOctupoleEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceOctupoleEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceOctupoleEntryData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceOctupoleEntry_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceOctupoleEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceOctupoleEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceOctupoleEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceOctupoleEntryData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceOctupoleEntry_track_particles(
               ThinSliceOctupoleEntryData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceOctupoleEntry_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceOctupoleData
#define XOBJ_TYPEDEF_ThinSliceOctupoleData
typedef   struct ThinSliceOctupoleData_s * ThinSliceOctupoleData;
 static inline ThinSliceOctupoleData ThinSliceOctupoleData_getp(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  return (ThinSliceOctupoleData)(( char*) obj+offset);
}
 static inline OctupoleData ThinSliceOctupoleData_getp__parent(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (OctupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent_k3(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_k3(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent_k3(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent_k3s(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_k3s(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent_k3s(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent_length(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_length(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent_length(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__parent_order(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_order(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__parent_order(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent_inv_factorial_order(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_inv_factorial_order(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent_inv_factorial_order(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceOctupoleData_getp__parent_knl(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_len__parent_knl(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceOctupoleData_get__parent_knl(const ThinSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_knl(ThinSliceOctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp1__parent_knl(ThinSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceOctupoleData_getp__parent_ksl(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_len__parent_ksl(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceOctupoleData_get__parent_ksl(const ThinSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_ksl(ThinSliceOctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp1__parent_ksl(ThinSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceOctupoleData_get__parent_edge_entry_active(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_edge_entry_active(ThinSliceOctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceOctupoleData_getp__parent_edge_entry_active(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceOctupoleData_get__parent_edge_exit_active(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_edge_exit_active(ThinSliceOctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceOctupoleData_getp__parent_edge_exit_active(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__parent_num_multipole_kicks(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_num_multipole_kicks(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__parent_num_multipole_kicks(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__parent_model(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_model(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__parent_model(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__parent_integrator(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_integrator(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__parent_integrator(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__parent_radiation_flag(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_radiation_flag(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__parent_radiation_flag(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent_delta_taper(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_delta_taper(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent_delta_taper(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent__sin_rot_s(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent__sin_rot_s(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent__sin_rot_s(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent__cos_rot_s(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent__cos_rot_s(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent__cos_rot_s(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent__shift_x(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent__shift_x(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent__shift_x(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent__shift_y(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent__shift_y(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent__shift_y(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent__shift_s(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent__shift_s(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent__shift_s(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceOctupoleData_getp__parent__internal_record_id(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__parent__internal_record_id_buffer_id(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent__internal_record_id_buffer_id(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__parent__internal_record_id_buffer_id(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__parent__internal_record_id_offset(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent__internal_record_id_offset(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__parent__internal_record_id_offset(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get_radiation_flag(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set_radiation_flag(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp_radiation_flag(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get_delta_taper(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set_delta_taper(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp_delta_taper(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get_weight(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set_weight(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp_weight(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceOctupoleData_getp__internal_record_id(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__internal_record_id_buffer_id(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__internal_record_id_buffer_id(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__internal_record_id_buffer_id(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__internal_record_id_offset(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__internal_record_id_offset(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__internal_record_id_offset(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThinSliceOctupoleData_getp_internal_record(ThinSliceOctupoleData el, LocalParticle* part){
    RecordIdentifier record_id = ThinSliceOctupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/thin_slice_octupole.h>

             static inline
            void ThinSliceOctupole_track_local_particle_with_transformations(ThinSliceOctupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceOctupoleData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceOctupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceOctupoleData_get__parent__shift_x(el);
    double const shift_y = ThinSliceOctupoleData_get__parent__shift_y(el);
    double const shift_s = ThinSliceOctupoleData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceOctupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceOctupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceOctupoleData_get__parent__shift_x(el);
    double const shift_y = ThinSliceOctupoleData_get__parent__shift_y(el);
    double const shift_s = ThinSliceOctupoleData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceOctupole_track_particles(
               ThinSliceOctupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceOctupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_DriftSliceOctupoleData
#define XOBJ_TYPEDEF_DriftSliceOctupoleData
typedef   struct DriftSliceOctupoleData_s * DriftSliceOctupoleData;
 static inline DriftSliceOctupoleData DriftSliceOctupoleData_getp(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  return (DriftSliceOctupoleData)(( char*) obj+offset);
}
 static inline OctupoleData DriftSliceOctupoleData_getp__parent(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (OctupoleData)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent_k3(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_k3(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent_k3(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent_k3s(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_k3s(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent_k3s(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent_length(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_length(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent_length(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get__parent_order(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_order(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp__parent_order(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent_inv_factorial_order(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_inv_factorial_order(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent_inv_factorial_order(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceOctupoleData_getp__parent_knl(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_len__parent_knl(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceOctupoleData_get__parent_knl(const DriftSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_knl(DriftSliceOctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp1__parent_knl(DriftSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceOctupoleData_getp__parent_ksl(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_len__parent_ksl(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceOctupoleData_get__parent_ksl(const DriftSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_ksl(DriftSliceOctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp1__parent_ksl(DriftSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceOctupoleData_get__parent_edge_entry_active(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_edge_entry_active(DriftSliceOctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceOctupoleData_getp__parent_edge_entry_active(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceOctupoleData_get__parent_edge_exit_active(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_edge_exit_active(DriftSliceOctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceOctupoleData_getp__parent_edge_exit_active(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get__parent_num_multipole_kicks(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_num_multipole_kicks(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp__parent_num_multipole_kicks(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get__parent_model(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_model(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp__parent_model(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get__parent_integrator(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_integrator(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp__parent_integrator(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get__parent_radiation_flag(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_radiation_flag(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp__parent_radiation_flag(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent_delta_taper(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_delta_taper(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent_delta_taper(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent__sin_rot_s(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent__sin_rot_s(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent__sin_rot_s(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent__cos_rot_s(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent__cos_rot_s(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent__cos_rot_s(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent__shift_x(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent__shift_x(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent__shift_x(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent__shift_y(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent__shift_y(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent__shift_y(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent__shift_s(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent__shift_s(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent__shift_s(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier DriftSliceOctupoleData_getp__parent__internal_record_id(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get__parent__internal_record_id_buffer_id(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent__internal_record_id_buffer_id(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp__parent__internal_record_id_buffer_id(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get__parent__internal_record_id_offset(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent__internal_record_id_offset(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp__parent__internal_record_id_offset(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get_radiation_flag(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set_radiation_flag(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp_radiation_flag(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get_delta_taper(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set_delta_taper(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp_delta_taper(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get_weight(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set_weight(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp_weight(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/drift_slice_octupole.h>

             static inline
            void DriftSliceOctupole_track_local_particle_with_transformations(DriftSliceOctupoleData el, LocalParticle* part0){
    DriftSliceOctupole_track_local_particle(el, part0);
}


             
            void DriftSliceOctupole_track_particles(
               DriftSliceOctupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              DriftSliceOctupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceSextupoleExitData
#define XOBJ_TYPEDEF_ThinSliceSextupoleExitData
typedef   struct ThinSliceSextupoleExitData_s * ThinSliceSextupoleExitData;
 static inline ThinSliceSextupoleExitData ThinSliceSextupoleExitData_getp(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  return (ThinSliceSextupoleExitData)(( char*) obj+offset);
}
 static inline SextupoleData ThinSliceSextupoleExitData_getp__parent(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (SextupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent_k2(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_k2(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent_k2(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent_k2s(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_k2s(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent_k2s(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent_length(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_length(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent_length(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get__parent_order(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_order(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp__parent_order(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent_inv_factorial_order(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_inv_factorial_order(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent_inv_factorial_order(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceSextupoleExitData_getp__parent_knl(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_len__parent_knl(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceSextupoleExitData_get__parent_knl(const ThinSliceSextupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_knl(ThinSliceSextupoleExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp1__parent_knl(ThinSliceSextupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceSextupoleExitData_getp__parent_ksl(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_len__parent_ksl(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceSextupoleExitData_get__parent_ksl(const ThinSliceSextupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_ksl(ThinSliceSextupoleExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp1__parent_ksl(ThinSliceSextupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceSextupoleExitData_get__parent_edge_entry_active(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_edge_entry_active(ThinSliceSextupoleExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceSextupoleExitData_getp__parent_edge_entry_active(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceSextupoleExitData_get__parent_edge_exit_active(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_edge_exit_active(ThinSliceSextupoleExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceSextupoleExitData_getp__parent_edge_exit_active(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get__parent_num_multipole_kicks(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_num_multipole_kicks(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp__parent_num_multipole_kicks(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get__parent_model(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_model(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp__parent_model(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get__parent_integrator(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_integrator(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp__parent_integrator(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get__parent_radiation_flag(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_radiation_flag(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp__parent_radiation_flag(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent_delta_taper(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_delta_taper(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent_delta_taper(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent__sin_rot_s(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent__sin_rot_s(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent__sin_rot_s(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent__cos_rot_s(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent__cos_rot_s(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent__cos_rot_s(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent__shift_x(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent__shift_x(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent__shift_x(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent__shift_y(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent__shift_y(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent__shift_y(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent__shift_s(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent__shift_s(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent__shift_s(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceSextupoleExitData_getp__parent__internal_record_id(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get__parent__internal_record_id_buffer_id(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent__internal_record_id_buffer_id(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp__parent__internal_record_id_buffer_id(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get__parent__internal_record_id_offset(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent__internal_record_id_offset(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp__parent__internal_record_id_offset(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get_radiation_flag(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set_radiation_flag(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp_radiation_flag(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get_delta_taper(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set_delta_taper(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp_delta_taper(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get_weight(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set_weight(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp_weight(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_sextupole_exit.h>

             static inline
            void ThinSliceSextupoleExit_track_local_particle_with_transformations(ThinSliceSextupoleExitData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceSextupoleExitData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceSextupoleExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceSextupoleExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceSextupoleExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceSextupoleExitData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceSextupoleExit_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceSextupoleExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceSextupoleExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceSextupoleExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceSextupoleExitData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceSextupoleExit_track_particles(
               ThinSliceSextupoleExitData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceSextupoleExit_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceSextupoleData
#define XOBJ_TYPEDEF_ThinSliceSextupoleData
typedef   struct ThinSliceSextupoleData_s * ThinSliceSextupoleData;
 static inline ThinSliceSextupoleData ThinSliceSextupoleData_getp(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  return (ThinSliceSextupoleData)(( char*) obj+offset);
}
 static inline SextupoleData ThinSliceSextupoleData_getp__parent(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (SextupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent_k2(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_k2(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent_k2(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent_k2s(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_k2s(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent_k2s(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent_length(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_length(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent_length(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__parent_order(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_order(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__parent_order(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent_inv_factorial_order(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_inv_factorial_order(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent_inv_factorial_order(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceSextupoleData_getp__parent_knl(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_len__parent_knl(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceSextupoleData_get__parent_knl(const ThinSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_knl(ThinSliceSextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp1__parent_knl(ThinSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceSextupoleData_getp__parent_ksl(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_len__parent_ksl(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceSextupoleData_get__parent_ksl(const ThinSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_ksl(ThinSliceSextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp1__parent_ksl(ThinSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceSextupoleData_get__parent_edge_entry_active(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_edge_entry_active(ThinSliceSextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceSextupoleData_getp__parent_edge_entry_active(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceSextupoleData_get__parent_edge_exit_active(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_edge_exit_active(ThinSliceSextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceSextupoleData_getp__parent_edge_exit_active(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__parent_num_multipole_kicks(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_num_multipole_kicks(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__parent_num_multipole_kicks(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__parent_model(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_model(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__parent_model(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__parent_integrator(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_integrator(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__parent_integrator(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__parent_radiation_flag(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_radiation_flag(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__parent_radiation_flag(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent_delta_taper(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_delta_taper(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent_delta_taper(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent__sin_rot_s(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent__sin_rot_s(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent__sin_rot_s(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent__cos_rot_s(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent__cos_rot_s(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent__cos_rot_s(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent__shift_x(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent__shift_x(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent__shift_x(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent__shift_y(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent__shift_y(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent__shift_y(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent__shift_s(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent__shift_s(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent__shift_s(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceSextupoleData_getp__parent__internal_record_id(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__parent__internal_record_id_buffer_id(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent__internal_record_id_buffer_id(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__parent__internal_record_id_buffer_id(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__parent__internal_record_id_offset(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent__internal_record_id_offset(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__parent__internal_record_id_offset(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get_radiation_flag(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set_radiation_flag(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp_radiation_flag(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get_delta_taper(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set_delta_taper(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp_delta_taper(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get_weight(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set_weight(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp_weight(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceSextupoleData_getp__internal_record_id(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__internal_record_id_buffer_id(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__internal_record_id_buffer_id(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__internal_record_id_buffer_id(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__internal_record_id_offset(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__internal_record_id_offset(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__internal_record_id_offset(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThinSliceSextupoleData_getp_internal_record(ThinSliceSextupoleData el, LocalParticle* part){
    RecordIdentifier record_id = ThinSliceSextupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/thin_slice_sextupole.h>

             static inline
            void ThinSliceSextupole_track_local_particle_with_transformations(ThinSliceSextupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceSextupoleData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceSextupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceSextupoleData_get__parent__shift_x(el);
    double const shift_y = ThinSliceSextupoleData_get__parent__shift_y(el);
    double const shift_s = ThinSliceSextupoleData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceSextupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceSextupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceSextupoleData_get__parent__shift_x(el);
    double const shift_y = ThinSliceSextupoleData_get__parent__shift_y(el);
    double const shift_s = ThinSliceSextupoleData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceSextupole_track_particles(
               ThinSliceSextupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceSextupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_DriftSliceSextupoleData
#define XOBJ_TYPEDEF_DriftSliceSextupoleData
typedef   struct DriftSliceSextupoleData_s * DriftSliceSextupoleData;
 static inline DriftSliceSextupoleData DriftSliceSextupoleData_getp(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  return (DriftSliceSextupoleData)(( char*) obj+offset);
}
 static inline SextupoleData DriftSliceSextupoleData_getp__parent(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (SextupoleData)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent_k2(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_k2(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent_k2(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent_k2s(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_k2s(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent_k2s(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent_length(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_length(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent_length(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get__parent_order(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_order(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp__parent_order(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent_inv_factorial_order(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_inv_factorial_order(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent_inv_factorial_order(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceSextupoleData_getp__parent_knl(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_len__parent_knl(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceSextupoleData_get__parent_knl(const DriftSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_knl(DriftSliceSextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp1__parent_knl(DriftSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceSextupoleData_getp__parent_ksl(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_len__parent_ksl(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceSextupoleData_get__parent_ksl(const DriftSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_ksl(DriftSliceSextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp1__parent_ksl(DriftSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceSextupoleData_get__parent_edge_entry_active(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_edge_entry_active(DriftSliceSextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceSextupoleData_getp__parent_edge_entry_active(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceSextupoleData_get__parent_edge_exit_active(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_edge_exit_active(DriftSliceSextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceSextupoleData_getp__parent_edge_exit_active(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get__parent_num_multipole_kicks(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_num_multipole_kicks(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp__parent_num_multipole_kicks(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get__parent_model(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_model(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp__parent_model(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get__parent_integrator(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_integrator(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp__parent_integrator(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get__parent_radiation_flag(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_radiation_flag(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp__parent_radiation_flag(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent_delta_taper(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_delta_taper(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent_delta_taper(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent__sin_rot_s(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent__sin_rot_s(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent__sin_rot_s(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent__cos_rot_s(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent__cos_rot_s(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent__cos_rot_s(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent__shift_x(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent__shift_x(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent__shift_x(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent__shift_y(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent__shift_y(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent__shift_y(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent__shift_s(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent__shift_s(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent__shift_s(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier DriftSliceSextupoleData_getp__parent__internal_record_id(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get__parent__internal_record_id_buffer_id(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent__internal_record_id_buffer_id(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp__parent__internal_record_id_buffer_id(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get__parent__internal_record_id_offset(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent__internal_record_id_offset(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp__parent__internal_record_id_offset(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get_radiation_flag(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set_radiation_flag(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp_radiation_flag(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get_delta_taper(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set_delta_taper(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp_delta_taper(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get_weight(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set_weight(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp_weight(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/drift_slice_sextupole.h>

             static inline
            void DriftSliceSextupole_track_local_particle_with_transformations(DriftSliceSextupoleData el, LocalParticle* part0){
    DriftSliceSextupole_track_local_particle(el, part0);
}


             
            void DriftSliceSextupole_track_particles(
               DriftSliceSextupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              DriftSliceSextupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceSextupoleEntryData
#define XOBJ_TYPEDEF_ThinSliceSextupoleEntryData
typedef   struct ThinSliceSextupoleEntryData_s * ThinSliceSextupoleEntryData;
 static inline ThinSliceSextupoleEntryData ThinSliceSextupoleEntryData_getp(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  return (ThinSliceSextupoleEntryData)(( char*) obj+offset);
}
 static inline SextupoleData ThinSliceSextupoleEntryData_getp__parent(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (SextupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent_k2(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_k2(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent_k2(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent_k2s(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_k2s(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent_k2s(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent_length(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_length(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent_length(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get__parent_order(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_order(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp__parent_order(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent_inv_factorial_order(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_inv_factorial_order(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent_inv_factorial_order(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceSextupoleEntryData_getp__parent_knl(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_len__parent_knl(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceSextupoleEntryData_get__parent_knl(const ThinSliceSextupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_knl(ThinSliceSextupoleEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp1__parent_knl(ThinSliceSextupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceSextupoleEntryData_getp__parent_ksl(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_len__parent_ksl(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceSextupoleEntryData_get__parent_ksl(const ThinSliceSextupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_ksl(ThinSliceSextupoleEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp1__parent_ksl(ThinSliceSextupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceSextupoleEntryData_get__parent_edge_entry_active(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_edge_entry_active(ThinSliceSextupoleEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceSextupoleEntryData_getp__parent_edge_entry_active(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceSextupoleEntryData_get__parent_edge_exit_active(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_edge_exit_active(ThinSliceSextupoleEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceSextupoleEntryData_getp__parent_edge_exit_active(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get__parent_num_multipole_kicks(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_num_multipole_kicks(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp__parent_num_multipole_kicks(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get__parent_model(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_model(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp__parent_model(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get__parent_integrator(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_integrator(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp__parent_integrator(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get__parent_radiation_flag(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_radiation_flag(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp__parent_radiation_flag(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent_delta_taper(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_delta_taper(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent_delta_taper(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent__sin_rot_s(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent__sin_rot_s(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent__sin_rot_s(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent__cos_rot_s(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent__cos_rot_s(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent__cos_rot_s(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent__shift_x(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent__shift_x(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent__shift_x(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent__shift_y(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent__shift_y(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent__shift_y(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent__shift_s(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent__shift_s(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent__shift_s(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceSextupoleEntryData_getp__parent__internal_record_id(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get__parent__internal_record_id_buffer_id(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent__internal_record_id_buffer_id(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp__parent__internal_record_id_buffer_id(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get__parent__internal_record_id_offset(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent__internal_record_id_offset(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp__parent__internal_record_id_offset(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get_radiation_flag(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set_radiation_flag(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp_radiation_flag(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get_delta_taper(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set_delta_taper(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp_delta_taper(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get_weight(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set_weight(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp_weight(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_sextupole_entry.h>

             static inline
            void ThinSliceSextupoleEntry_track_local_particle_with_transformations(ThinSliceSextupoleEntryData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceSextupoleEntryData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceSextupoleEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceSextupoleEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceSextupoleEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceSextupoleEntryData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceSextupoleEntry_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceSextupoleEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceSextupoleEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceSextupoleEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceSextupoleEntryData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceSextupoleEntry_track_particles(
               ThinSliceSextupoleEntryData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceSextupoleEntry_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThickSliceSextupoleData
#define XOBJ_TYPEDEF_ThickSliceSextupoleData
typedef   struct ThickSliceSextupoleData_s * ThickSliceSextupoleData;
 static inline ThickSliceSextupoleData ThickSliceSextupoleData_getp(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  return (ThickSliceSextupoleData)(( char*) obj+offset);
}
 static inline SextupoleData ThickSliceSextupoleData_getp__parent(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (SextupoleData)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent_k2(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_k2(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent_k2(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent_k2s(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_k2s(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent_k2s(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent_length(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_length(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent_length(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__parent_order(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_order(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__parent_order(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent_inv_factorial_order(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_inv_factorial_order(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent_inv_factorial_order(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceSextupoleData_getp__parent_knl(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_len__parent_knl(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceSextupoleData_get__parent_knl(const ThickSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_knl(ThickSliceSextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp1__parent_knl(ThickSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceSextupoleData_getp__parent_ksl(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_len__parent_ksl(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceSextupoleData_get__parent_ksl(const ThickSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_ksl(ThickSliceSextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp1__parent_ksl(ThickSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceSextupoleData_get__parent_edge_entry_active(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_edge_entry_active(ThickSliceSextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceSextupoleData_getp__parent_edge_entry_active(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceSextupoleData_get__parent_edge_exit_active(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_edge_exit_active(ThickSliceSextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceSextupoleData_getp__parent_edge_exit_active(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__parent_num_multipole_kicks(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_num_multipole_kicks(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__parent_num_multipole_kicks(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__parent_model(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_model(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__parent_model(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__parent_integrator(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_integrator(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__parent_integrator(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__parent_radiation_flag(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_radiation_flag(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__parent_radiation_flag(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent_delta_taper(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_delta_taper(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent_delta_taper(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent__sin_rot_s(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent__sin_rot_s(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent__sin_rot_s(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent__cos_rot_s(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent__cos_rot_s(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent__cos_rot_s(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent__shift_x(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent__shift_x(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent__shift_x(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent__shift_y(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent__shift_y(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent__shift_y(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent__shift_s(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent__shift_s(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent__shift_s(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceSextupoleData_getp__parent__internal_record_id(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__parent__internal_record_id_buffer_id(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent__internal_record_id_buffer_id(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__parent__internal_record_id_buffer_id(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__parent__internal_record_id_offset(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent__internal_record_id_offset(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__parent__internal_record_id_offset(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get_radiation_flag(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set_radiation_flag(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp_radiation_flag(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get_delta_taper(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set_delta_taper(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp_delta_taper(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get_weight(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set_weight(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp_weight(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceSextupoleData_getp__internal_record_id(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__internal_record_id_buffer_id(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__internal_record_id_buffer_id(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__internal_record_id_buffer_id(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__internal_record_id_offset(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__internal_record_id_offset(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__internal_record_id_offset(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThickSliceSextupoleData_getp_internal_record(ThickSliceSextupoleData el, LocalParticle* part){
    RecordIdentifier record_id = ThickSliceSextupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/thick_slice_sextupole.h>

             static inline
            void ThickSliceSextupole_track_local_particle_with_transformations(ThickSliceSextupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThickSliceSextupoleData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceSextupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceSextupoleData_get__parent__shift_x(el);
    double const shift_y = ThickSliceSextupoleData_get__parent__shift_y(el);
    double const shift_s = ThickSliceSextupoleData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThickSliceSextupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceSextupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceSextupoleData_get__parent__shift_x(el);
    double const shift_y = ThickSliceSextupoleData_get__parent__shift_y(el);
    double const shift_s = ThickSliceSextupoleData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThickSliceSextupole_track_particles(
               ThickSliceSextupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThickSliceSextupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceRBendEntryData
#define XOBJ_TYPEDEF_ThinSliceRBendEntryData
typedef   struct ThinSliceRBendEntryData_s * ThinSliceRBendEntryData;
 static inline ThinSliceRBendEntryData ThinSliceRBendEntryData_getp(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  return (ThinSliceRBendEntryData)(( char*) obj+offset);
}
 static inline RBendData ThinSliceRBendEntryData_getp__parent(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (RBendData)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_k0(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_k0(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_k0(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_k1(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_k1(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_k1(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_h(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_h(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_h(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_angle(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_angle(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_angle(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_length(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_length(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_length(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_model(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_model(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_model(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_integrator(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_integrator(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_integrator(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_radiation_flag(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_radiation_flag(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_radiation_flag(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_delta_taper(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_delta_taper(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_delta_taper(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_edge_entry_active(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_entry_active(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_edge_entry_active(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_edge_exit_active(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_exit_active(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_edge_exit_active(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_edge_entry_model(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_entry_model(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_edge_entry_model(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_edge_exit_model(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_exit_model(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_edge_exit_model(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_entry_angle(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_entry_angle(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_entry_angle(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_exit_angle(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_exit_angle(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_exit_angle(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_entry_angle_fdown(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_entry_angle_fdown(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_entry_angle_fdown(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_exit_angle_fdown(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_exit_angle_fdown(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_exit_angle_fdown(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_entry_fint(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_entry_fint(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_entry_fint(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_exit_fint(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_exit_fint(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_exit_fint(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_entry_hgap(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_entry_hgap(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_entry_hgap(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_exit_hgap(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_exit_hgap(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_exit_hgap(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_num_multipole_kicks(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_num_multipole_kicks(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_num_multipole_kicks(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_order(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_order(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_order(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_inv_factorial_order(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_inv_factorial_order(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_inv_factorial_order(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceRBendEntryData_getp__parent_knl(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_len__parent_knl(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceRBendEntryData_get__parent_knl(const ThinSliceRBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_knl(ThinSliceRBendEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp1__parent_knl(ThinSliceRBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceRBendEntryData_getp__parent_ksl(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_len__parent_ksl(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceRBendEntryData_get__parent_ksl(const ThinSliceRBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_ksl(ThinSliceRBendEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp1__parent_ksl(ThinSliceRBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceRBendEntryData_get__parent_k0_from_h(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_k0_from_h(ThinSliceRBendEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceRBendEntryData_getp__parent_k0_from_h(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_length_straight(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_length_straight(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_length_straight(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent__sin_rot_s(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent__sin_rot_s(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent__sin_rot_s(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent__cos_rot_s(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent__cos_rot_s(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent__cos_rot_s(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent__shift_x(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent__shift_x(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent__shift_x(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent__shift_y(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent__shift_y(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent__shift_y(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent__shift_s(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent__shift_s(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent__shift_s(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceRBendEntryData_getp__parent__internal_record_id(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent__internal_record_id_buffer_id(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent__internal_record_id_buffer_id(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent__internal_record_id_buffer_id(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent__internal_record_id_offset(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent__internal_record_id_offset(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent__internal_record_id_offset(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get_radiation_flag(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set_radiation_flag(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp_radiation_flag(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get_delta_taper(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set_delta_taper(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp_delta_taper(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get_weight(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set_weight(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp_weight(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_rbend_entry.h>

             static inline
            void ThinSliceRBendEntry_track_local_particle_with_transformations(ThinSliceRBendEntryData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceRBendEntryData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceRBendEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceRBendEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceRBendEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceRBendEntryData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceRBendEntry_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceRBendEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceRBendEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceRBendEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceRBendEntryData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceRBendEntry_track_particles(
               ThinSliceRBendEntryData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceRBendEntry_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_DriftSliceRBendData
#define XOBJ_TYPEDEF_DriftSliceRBendData
typedef   struct DriftSliceRBendData_s * DriftSliceRBendData;
 static inline DriftSliceRBendData DriftSliceRBendData_getp(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  return (DriftSliceRBendData)(( char*) obj+offset);
}
 static inline RBendData DriftSliceRBendData_getp__parent(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (RBendData)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_k0(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_k0(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_k0(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_k1(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_k1(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_k1(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_h(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_h(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_h(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_angle(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_angle(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_angle(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_length(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_length(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_length(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_model(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_model(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_model(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_integrator(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_integrator(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_integrator(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_radiation_flag(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_radiation_flag(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_radiation_flag(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_delta_taper(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_delta_taper(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_delta_taper(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_edge_entry_active(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_entry_active(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_edge_entry_active(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_edge_exit_active(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_exit_active(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_edge_exit_active(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_edge_entry_model(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_entry_model(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_edge_entry_model(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_edge_exit_model(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_exit_model(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_edge_exit_model(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_entry_angle(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_entry_angle(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_entry_angle(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_exit_angle(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_exit_angle(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_exit_angle(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_entry_angle_fdown(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_entry_angle_fdown(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_entry_angle_fdown(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_exit_angle_fdown(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_exit_angle_fdown(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_exit_angle_fdown(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_entry_fint(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_entry_fint(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_entry_fint(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_exit_fint(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_exit_fint(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_exit_fint(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_entry_hgap(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_entry_hgap(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_entry_hgap(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_exit_hgap(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_exit_hgap(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_exit_hgap(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_num_multipole_kicks(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_num_multipole_kicks(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_num_multipole_kicks(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_order(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_order(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_order(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_inv_factorial_order(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_inv_factorial_order(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_inv_factorial_order(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceRBendData_getp__parent_knl(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_len__parent_knl(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceRBendData_get__parent_knl(const DriftSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_knl(DriftSliceRBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp1__parent_knl(DriftSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceRBendData_getp__parent_ksl(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_len__parent_ksl(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceRBendData_get__parent_ksl(const DriftSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_ksl(DriftSliceRBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp1__parent_ksl(DriftSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceRBendData_get__parent_k0_from_h(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_k0_from_h(DriftSliceRBendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceRBendData_getp__parent_k0_from_h(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_length_straight(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_length_straight(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_length_straight(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent__sin_rot_s(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent__sin_rot_s(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent__sin_rot_s(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent__cos_rot_s(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent__cos_rot_s(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent__cos_rot_s(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent__shift_x(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent__shift_x(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent__shift_x(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent__shift_y(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent__shift_y(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent__shift_y(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent__shift_s(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent__shift_s(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent__shift_s(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier DriftSliceRBendData_getp__parent__internal_record_id(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent__internal_record_id_buffer_id(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent__internal_record_id_buffer_id(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent__internal_record_id_buffer_id(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent__internal_record_id_offset(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent__internal_record_id_offset(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent__internal_record_id_offset(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get_radiation_flag(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set_radiation_flag(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp_radiation_flag(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get_delta_taper(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set_delta_taper(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp_delta_taper(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get_weight(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set_weight(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp_weight(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/drift_slice_rbend.h>

             static inline
            void DriftSliceRBend_track_local_particle_with_transformations(DriftSliceRBendData el, LocalParticle* part0){
    DriftSliceRBend_track_local_particle(el, part0);
}


             
            void DriftSliceRBend_track_particles(
               DriftSliceRBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              DriftSliceRBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceRBendData
#define XOBJ_TYPEDEF_ThinSliceRBendData
typedef   struct ThinSliceRBendData_s * ThinSliceRBendData;
 static inline ThinSliceRBendData ThinSliceRBendData_getp(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  return (ThinSliceRBendData)(( char*) obj+offset);
}
 static inline RBendData ThinSliceRBendData_getp__parent(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (RBendData)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_k0(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_k0(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_k0(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_k1(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_k1(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_k1(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_h(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_h(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_h(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_angle(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_angle(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_angle(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_length(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_length(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_length(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_model(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_model(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_model(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_integrator(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_integrator(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_integrator(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_radiation_flag(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_radiation_flag(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_radiation_flag(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_delta_taper(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_delta_taper(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_delta_taper(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_edge_entry_active(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_entry_active(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_edge_entry_active(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_edge_exit_active(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_exit_active(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_edge_exit_active(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_edge_entry_model(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_entry_model(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_edge_entry_model(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_edge_exit_model(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_exit_model(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_edge_exit_model(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_entry_angle(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_entry_angle(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_entry_angle(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_exit_angle(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_exit_angle(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_exit_angle(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_entry_angle_fdown(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_entry_angle_fdown(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_entry_angle_fdown(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_exit_angle_fdown(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_exit_angle_fdown(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_exit_angle_fdown(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_entry_fint(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_entry_fint(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_entry_fint(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_exit_fint(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_exit_fint(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_exit_fint(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_entry_hgap(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_entry_hgap(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_entry_hgap(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_exit_hgap(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_exit_hgap(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_exit_hgap(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_num_multipole_kicks(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_num_multipole_kicks(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_num_multipole_kicks(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_order(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_order(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_order(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_inv_factorial_order(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_inv_factorial_order(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_inv_factorial_order(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceRBendData_getp__parent_knl(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_len__parent_knl(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceRBendData_get__parent_knl(const ThinSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_knl(ThinSliceRBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp1__parent_knl(ThinSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceRBendData_getp__parent_ksl(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_len__parent_ksl(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceRBendData_get__parent_ksl(const ThinSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_ksl(ThinSliceRBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp1__parent_ksl(ThinSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceRBendData_get__parent_k0_from_h(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_k0_from_h(ThinSliceRBendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceRBendData_getp__parent_k0_from_h(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_length_straight(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_length_straight(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_length_straight(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent__sin_rot_s(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent__sin_rot_s(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent__sin_rot_s(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent__cos_rot_s(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent__cos_rot_s(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent__cos_rot_s(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent__shift_x(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent__shift_x(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent__shift_x(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent__shift_y(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent__shift_y(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent__shift_y(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent__shift_s(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent__shift_s(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent__shift_s(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceRBendData_getp__parent__internal_record_id(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent__internal_record_id_buffer_id(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent__internal_record_id_buffer_id(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent__internal_record_id_buffer_id(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent__internal_record_id_offset(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent__internal_record_id_offset(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent__internal_record_id_offset(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get_radiation_flag(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set_radiation_flag(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp_radiation_flag(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get_delta_taper(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set_delta_taper(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp_delta_taper(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get_weight(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set_weight(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp_weight(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceRBendData_getp__internal_record_id(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__internal_record_id_buffer_id(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__internal_record_id_buffer_id(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__internal_record_id_buffer_id(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__internal_record_id_offset(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__internal_record_id_offset(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__internal_record_id_offset(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThinSliceRBendData_getp_internal_record(ThinSliceRBendData el, LocalParticle* part){
    RecordIdentifier record_id = ThinSliceRBendData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/thin_slice_rbend.h>

             static inline
            void ThinSliceRBend_track_local_particle_with_transformations(ThinSliceRBendData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceRBendData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceRBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceRBendData_get__parent__shift_x(el);
    double const shift_y = ThinSliceRBendData_get__parent__shift_y(el);
    double const shift_s = ThinSliceRBendData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceRBend_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceRBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceRBendData_get__parent__shift_x(el);
    double const shift_y = ThinSliceRBendData_get__parent__shift_y(el);
    double const shift_s = ThinSliceRBendData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceRBend_track_particles(
               ThinSliceRBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceRBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceRBendExitData
#define XOBJ_TYPEDEF_ThinSliceRBendExitData
typedef   struct ThinSliceRBendExitData_s * ThinSliceRBendExitData;
 static inline ThinSliceRBendExitData ThinSliceRBendExitData_getp(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  return (ThinSliceRBendExitData)(( char*) obj+offset);
}
 static inline RBendData ThinSliceRBendExitData_getp__parent(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (RBendData)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_k0(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_k0(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_k0(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_k1(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_k1(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_k1(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_h(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_h(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_h(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_angle(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_angle(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_angle(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_length(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_length(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_length(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_model(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_model(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_model(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_integrator(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_integrator(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_integrator(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_radiation_flag(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_radiation_flag(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_radiation_flag(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_delta_taper(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_delta_taper(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_delta_taper(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_edge_entry_active(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_entry_active(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_edge_entry_active(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_edge_exit_active(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_exit_active(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_edge_exit_active(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_edge_entry_model(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_entry_model(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_edge_entry_model(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_edge_exit_model(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_exit_model(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_edge_exit_model(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_entry_angle(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_entry_angle(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_entry_angle(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_exit_angle(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_exit_angle(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_exit_angle(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_entry_angle_fdown(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_entry_angle_fdown(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_entry_angle_fdown(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_exit_angle_fdown(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_exit_angle_fdown(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_exit_angle_fdown(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_entry_fint(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_entry_fint(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_entry_fint(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_exit_fint(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_exit_fint(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_exit_fint(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_entry_hgap(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_entry_hgap(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_entry_hgap(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_exit_hgap(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_exit_hgap(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_exit_hgap(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_num_multipole_kicks(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_num_multipole_kicks(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_num_multipole_kicks(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_order(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_order(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_order(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_inv_factorial_order(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_inv_factorial_order(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_inv_factorial_order(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceRBendExitData_getp__parent_knl(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_len__parent_knl(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceRBendExitData_get__parent_knl(const ThinSliceRBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_knl(ThinSliceRBendExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp1__parent_knl(ThinSliceRBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceRBendExitData_getp__parent_ksl(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_len__parent_ksl(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceRBendExitData_get__parent_ksl(const ThinSliceRBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_ksl(ThinSliceRBendExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp1__parent_ksl(ThinSliceRBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceRBendExitData_get__parent_k0_from_h(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_k0_from_h(ThinSliceRBendExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceRBendExitData_getp__parent_k0_from_h(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_length_straight(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_length_straight(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_length_straight(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent__sin_rot_s(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent__sin_rot_s(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent__sin_rot_s(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent__cos_rot_s(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent__cos_rot_s(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent__cos_rot_s(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent__shift_x(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent__shift_x(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent__shift_x(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent__shift_y(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent__shift_y(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent__shift_y(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent__shift_s(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent__shift_s(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent__shift_s(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceRBendExitData_getp__parent__internal_record_id(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent__internal_record_id_buffer_id(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent__internal_record_id_buffer_id(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent__internal_record_id_buffer_id(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent__internal_record_id_offset(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent__internal_record_id_offset(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent__internal_record_id_offset(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get_radiation_flag(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set_radiation_flag(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp_radiation_flag(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get_delta_taper(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set_delta_taper(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp_delta_taper(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get_weight(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set_weight(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp_weight(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_rbend_exit.h>

             static inline
            void ThinSliceRBendExit_track_local_particle_with_transformations(ThinSliceRBendExitData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceRBendExitData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceRBendExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceRBendExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceRBendExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceRBendExitData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceRBendExit_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceRBendExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceRBendExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceRBendExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceRBendExitData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceRBendExit_track_particles(
               ThinSliceRBendExitData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceRBendExit_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThickSliceRBendData
#define XOBJ_TYPEDEF_ThickSliceRBendData
typedef   struct ThickSliceRBendData_s * ThickSliceRBendData;
 static inline ThickSliceRBendData ThickSliceRBendData_getp(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  return (ThickSliceRBendData)(( char*) obj+offset);
}
 static inline RBendData ThickSliceRBendData_getp__parent(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (RBendData)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_k0(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_k0(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_k0(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_k1(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_k1(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_k1(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_h(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_h(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_h(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_angle(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_angle(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_angle(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_length(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_length(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_length(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_model(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_model(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_model(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_integrator(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_integrator(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_integrator(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_radiation_flag(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_radiation_flag(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_radiation_flag(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_delta_taper(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_delta_taper(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_delta_taper(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_edge_entry_active(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_entry_active(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_edge_entry_active(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_edge_exit_active(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_exit_active(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_edge_exit_active(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_edge_entry_model(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_entry_model(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_edge_entry_model(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_edge_exit_model(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_exit_model(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_edge_exit_model(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_entry_angle(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_entry_angle(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_entry_angle(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_exit_angle(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_exit_angle(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_exit_angle(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_entry_angle_fdown(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_entry_angle_fdown(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_entry_angle_fdown(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_exit_angle_fdown(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_exit_angle_fdown(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_exit_angle_fdown(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_entry_fint(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_entry_fint(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_entry_fint(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_exit_fint(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_exit_fint(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_exit_fint(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_entry_hgap(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_entry_hgap(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_entry_hgap(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_exit_hgap(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_exit_hgap(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_exit_hgap(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_num_multipole_kicks(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_num_multipole_kicks(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_num_multipole_kicks(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_order(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_order(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_order(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_inv_factorial_order(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_inv_factorial_order(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_inv_factorial_order(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceRBendData_getp__parent_knl(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_len__parent_knl(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceRBendData_get__parent_knl(const ThickSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_knl(ThickSliceRBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp1__parent_knl(ThickSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceRBendData_getp__parent_ksl(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_len__parent_ksl(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceRBendData_get__parent_ksl(const ThickSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_ksl(ThickSliceRBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp1__parent_ksl(ThickSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceRBendData_get__parent_k0_from_h(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_k0_from_h(ThickSliceRBendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceRBendData_getp__parent_k0_from_h(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_length_straight(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_length_straight(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_length_straight(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent__sin_rot_s(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent__sin_rot_s(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent__sin_rot_s(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent__cos_rot_s(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent__cos_rot_s(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent__cos_rot_s(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent__shift_x(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent__shift_x(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent__shift_x(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent__shift_y(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent__shift_y(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent__shift_y(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent__shift_s(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent__shift_s(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent__shift_s(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceRBendData_getp__parent__internal_record_id(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent__internal_record_id_buffer_id(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent__internal_record_id_buffer_id(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent__internal_record_id_buffer_id(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent__internal_record_id_offset(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent__internal_record_id_offset(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent__internal_record_id_offset(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get_radiation_flag(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set_radiation_flag(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp_radiation_flag(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get_delta_taper(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set_delta_taper(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp_delta_taper(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get_weight(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set_weight(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp_weight(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thick_slice_rbend.h>

             static inline
            void ThickSliceRBend_track_local_particle_with_transformations(ThickSliceRBendData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThickSliceRBendData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceRBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceRBendData_get__parent__shift_x(el);
    double const shift_y = ThickSliceRBendData_get__parent__shift_y(el);
    double const shift_s = ThickSliceRBendData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThickSliceRBend_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceRBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceRBendData_get__parent__shift_x(el);
    double const shift_y = ThickSliceRBendData_get__parent__shift_y(el);
    double const shift_s = ThickSliceRBendData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThickSliceRBend_track_particles(
               ThickSliceRBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThickSliceRBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceBendData
#define XOBJ_TYPEDEF_ThinSliceBendData
typedef   struct ThinSliceBendData_s * ThinSliceBendData;
 static inline ThinSliceBendData ThinSliceBendData_getp(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  return (ThinSliceBendData)(( char*) obj+offset);
}
 static inline BendData ThinSliceBendData_getp__parent(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (BendData)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_k0(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_k0(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_k0(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_k1(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_k1(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_k1(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_h(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_h(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_h(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_angle(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_angle(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_angle(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_length(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_length(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_length(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_model(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_model(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_model(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_integrator(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_integrator(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_integrator(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_radiation_flag(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_radiation_flag(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_radiation_flag(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_delta_taper(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_delta_taper(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_delta_taper(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_edge_entry_active(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_entry_active(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_edge_entry_active(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_edge_exit_active(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_exit_active(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_edge_exit_active(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_edge_entry_model(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_entry_model(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_edge_entry_model(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_edge_exit_model(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_exit_model(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_edge_exit_model(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_entry_angle(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_entry_angle(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_entry_angle(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_exit_angle(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_exit_angle(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_exit_angle(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_entry_angle_fdown(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_entry_angle_fdown(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_entry_angle_fdown(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_exit_angle_fdown(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_exit_angle_fdown(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_exit_angle_fdown(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_entry_fint(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_entry_fint(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_entry_fint(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_exit_fint(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_exit_fint(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_exit_fint(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_entry_hgap(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_entry_hgap(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_entry_hgap(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_exit_hgap(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_exit_hgap(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_exit_hgap(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_num_multipole_kicks(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_num_multipole_kicks(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_num_multipole_kicks(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_order(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_order(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_order(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_inv_factorial_order(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_inv_factorial_order(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_inv_factorial_order(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceBendData_getp__parent_knl(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_len__parent_knl(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceBendData_get__parent_knl(const ThinSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_knl(ThinSliceBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp1__parent_knl(ThinSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceBendData_getp__parent_ksl(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_len__parent_ksl(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceBendData_get__parent_ksl(const ThinSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_ksl(ThinSliceBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp1__parent_ksl(ThinSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceBendData_get__parent_k0_from_h(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_k0_from_h(ThinSliceBendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceBendData_getp__parent_k0_from_h(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent__sin_rot_s(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent__sin_rot_s(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent__sin_rot_s(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent__cos_rot_s(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent__cos_rot_s(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent__cos_rot_s(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent__shift_x(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent__shift_x(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent__shift_x(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent__shift_y(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent__shift_y(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent__shift_y(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent__shift_s(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent__shift_s(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent__shift_s(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceBendData_getp__parent__internal_record_id(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent__internal_record_id_buffer_id(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent__internal_record_id_buffer_id(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent__internal_record_id_buffer_id(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent__internal_record_id_offset(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent__internal_record_id_offset(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent__internal_record_id_offset(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get_radiation_flag(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set_radiation_flag(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp_radiation_flag(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get_delta_taper(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set_delta_taper(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp_delta_taper(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get_weight(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set_weight(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp_weight(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceBendData_getp__internal_record_id(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__internal_record_id_buffer_id(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__internal_record_id_buffer_id(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__internal_record_id_buffer_id(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__internal_record_id_offset(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__internal_record_id_offset(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__internal_record_id_offset(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThinSliceBendData_getp_internal_record(ThinSliceBendData el, LocalParticle* part){
    RecordIdentifier record_id = ThinSliceBendData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/thin_slice_bend.h>

             static inline
            void ThinSliceBend_track_local_particle_with_transformations(ThinSliceBendData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceBendData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceBendData_get__parent__shift_x(el);
    double const shift_y = ThinSliceBendData_get__parent__shift_y(el);
    double const shift_s = ThinSliceBendData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceBend_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceBendData_get__parent__shift_x(el);
    double const shift_y = ThinSliceBendData_get__parent__shift_y(el);
    double const shift_s = ThinSliceBendData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceBend_track_particles(
               ThinSliceBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThickSliceBendData
#define XOBJ_TYPEDEF_ThickSliceBendData
typedef   struct ThickSliceBendData_s * ThickSliceBendData;
 static inline ThickSliceBendData ThickSliceBendData_getp(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  return (ThickSliceBendData)(( char*) obj+offset);
}
 static inline BendData ThickSliceBendData_getp__parent(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (BendData)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_k0(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_k0(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_k0(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_k1(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_k1(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_k1(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_h(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_h(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_h(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_angle(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_angle(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_angle(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_length(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_length(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_length(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_model(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_model(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_model(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_integrator(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_integrator(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_integrator(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_radiation_flag(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_radiation_flag(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_radiation_flag(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_delta_taper(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_delta_taper(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_delta_taper(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_edge_entry_active(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_entry_active(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_edge_entry_active(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_edge_exit_active(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_exit_active(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_edge_exit_active(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_edge_entry_model(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_entry_model(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_edge_entry_model(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_edge_exit_model(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_exit_model(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_edge_exit_model(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_entry_angle(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_entry_angle(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_entry_angle(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_exit_angle(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_exit_angle(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_exit_angle(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_entry_angle_fdown(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_entry_angle_fdown(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_entry_angle_fdown(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_exit_angle_fdown(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_exit_angle_fdown(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_exit_angle_fdown(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_entry_fint(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_entry_fint(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_entry_fint(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_exit_fint(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_exit_fint(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_exit_fint(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_entry_hgap(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_entry_hgap(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_entry_hgap(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_exit_hgap(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_exit_hgap(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_exit_hgap(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_num_multipole_kicks(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_num_multipole_kicks(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_num_multipole_kicks(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_order(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_order(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_order(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_inv_factorial_order(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_inv_factorial_order(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_inv_factorial_order(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceBendData_getp__parent_knl(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_len__parent_knl(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceBendData_get__parent_knl(const ThickSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_knl(ThickSliceBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp1__parent_knl(ThickSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceBendData_getp__parent_ksl(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_len__parent_ksl(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceBendData_get__parent_ksl(const ThickSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_ksl(ThickSliceBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp1__parent_ksl(ThickSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceBendData_get__parent_k0_from_h(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_k0_from_h(ThickSliceBendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceBendData_getp__parent_k0_from_h(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent__sin_rot_s(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent__sin_rot_s(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent__sin_rot_s(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent__cos_rot_s(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent__cos_rot_s(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent__cos_rot_s(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent__shift_x(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent__shift_x(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent__shift_x(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent__shift_y(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent__shift_y(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent__shift_y(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent__shift_s(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent__shift_s(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent__shift_s(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceBendData_getp__parent__internal_record_id(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent__internal_record_id_buffer_id(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent__internal_record_id_buffer_id(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent__internal_record_id_buffer_id(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent__internal_record_id_offset(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent__internal_record_id_offset(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent__internal_record_id_offset(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get_radiation_flag(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set_radiation_flag(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp_radiation_flag(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get_delta_taper(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set_delta_taper(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp_delta_taper(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get_weight(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set_weight(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp_weight(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thick_slice_bend.h>

             static inline
            void ThickSliceBend_track_local_particle_with_transformations(ThickSliceBendData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThickSliceBendData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceBendData_get__parent__shift_x(el);
    double const shift_y = ThickSliceBendData_get__parent__shift_y(el);
    double const shift_s = ThickSliceBendData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThickSliceBend_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceBendData_get__parent__shift_x(el);
    double const shift_y = ThickSliceBendData_get__parent__shift_y(el);
    double const shift_s = ThickSliceBendData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThickSliceBend_track_particles(
               ThickSliceBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThickSliceBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_DriftSliceBendData
#define XOBJ_TYPEDEF_DriftSliceBendData
typedef   struct DriftSliceBendData_s * DriftSliceBendData;
 static inline DriftSliceBendData DriftSliceBendData_getp(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  return (DriftSliceBendData)(( char*) obj+offset);
}
 static inline BendData DriftSliceBendData_getp__parent(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (BendData)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_k0(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_k0(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_k0(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_k1(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_k1(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_k1(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_h(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_h(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_h(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_angle(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_angle(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_angle(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_length(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_length(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_length(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_model(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_model(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_model(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_integrator(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_integrator(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_integrator(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_radiation_flag(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_radiation_flag(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_radiation_flag(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_delta_taper(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_delta_taper(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_delta_taper(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_edge_entry_active(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_entry_active(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_edge_entry_active(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_edge_exit_active(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_exit_active(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_edge_exit_active(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_edge_entry_model(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_entry_model(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_edge_entry_model(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_edge_exit_model(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_exit_model(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_edge_exit_model(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_entry_angle(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_entry_angle(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_entry_angle(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_exit_angle(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_exit_angle(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_exit_angle(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_entry_angle_fdown(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_entry_angle_fdown(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_entry_angle_fdown(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_exit_angle_fdown(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_exit_angle_fdown(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_exit_angle_fdown(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_entry_fint(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_entry_fint(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_entry_fint(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_exit_fint(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_exit_fint(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_exit_fint(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_entry_hgap(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_entry_hgap(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_entry_hgap(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_exit_hgap(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_exit_hgap(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_exit_hgap(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_num_multipole_kicks(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_num_multipole_kicks(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_num_multipole_kicks(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_order(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_order(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_order(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_inv_factorial_order(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_inv_factorial_order(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_inv_factorial_order(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceBendData_getp__parent_knl(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_len__parent_knl(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceBendData_get__parent_knl(const DriftSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_knl(DriftSliceBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp1__parent_knl(DriftSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceBendData_getp__parent_ksl(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_len__parent_ksl(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceBendData_get__parent_ksl(const DriftSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_ksl(DriftSliceBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp1__parent_ksl(DriftSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceBendData_get__parent_k0_from_h(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_k0_from_h(DriftSliceBendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceBendData_getp__parent_k0_from_h(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent__sin_rot_s(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent__sin_rot_s(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent__sin_rot_s(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent__cos_rot_s(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent__cos_rot_s(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent__cos_rot_s(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent__shift_x(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent__shift_x(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent__shift_x(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent__shift_y(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent__shift_y(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent__shift_y(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent__shift_s(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent__shift_s(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent__shift_s(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier DriftSliceBendData_getp__parent__internal_record_id(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent__internal_record_id_buffer_id(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent__internal_record_id_buffer_id(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent__internal_record_id_buffer_id(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent__internal_record_id_offset(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent__internal_record_id_offset(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent__internal_record_id_offset(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get_radiation_flag(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set_radiation_flag(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp_radiation_flag(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get_delta_taper(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set_delta_taper(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp_delta_taper(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get_weight(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set_weight(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp_weight(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/drift_slice_bend.h>

             static inline
            void DriftSliceBend_track_local_particle_with_transformations(DriftSliceBendData el, LocalParticle* part0){
    DriftSliceBend_track_local_particle(el, part0);
}


             
            void DriftSliceBend_track_particles(
               DriftSliceBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              DriftSliceBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceBendEntryData
#define XOBJ_TYPEDEF_ThinSliceBendEntryData
typedef   struct ThinSliceBendEntryData_s * ThinSliceBendEntryData;
 static inline ThinSliceBendEntryData ThinSliceBendEntryData_getp(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  return (ThinSliceBendEntryData)(( char*) obj+offset);
}
 static inline BendData ThinSliceBendEntryData_getp__parent(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (BendData)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_k0(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_k0(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_k0(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_k1(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_k1(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_k1(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_h(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_h(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_h(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_angle(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_angle(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_angle(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_length(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_length(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_length(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_model(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_model(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_model(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_integrator(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_integrator(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_integrator(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_radiation_flag(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_radiation_flag(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_radiation_flag(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_delta_taper(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_delta_taper(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_delta_taper(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_edge_entry_active(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_entry_active(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_edge_entry_active(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_edge_exit_active(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_exit_active(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_edge_exit_active(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_edge_entry_model(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_entry_model(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_edge_entry_model(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_edge_exit_model(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_exit_model(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_edge_exit_model(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_entry_angle(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_entry_angle(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_entry_angle(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_exit_angle(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_exit_angle(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_exit_angle(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_entry_angle_fdown(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_entry_angle_fdown(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_entry_angle_fdown(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_exit_angle_fdown(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_exit_angle_fdown(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_exit_angle_fdown(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_entry_fint(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_entry_fint(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_entry_fint(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_exit_fint(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_exit_fint(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_exit_fint(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_entry_hgap(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_entry_hgap(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_entry_hgap(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_exit_hgap(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_exit_hgap(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_exit_hgap(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_num_multipole_kicks(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_num_multipole_kicks(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_num_multipole_kicks(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_order(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_order(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_order(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_inv_factorial_order(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_inv_factorial_order(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_inv_factorial_order(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceBendEntryData_getp__parent_knl(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_len__parent_knl(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceBendEntryData_get__parent_knl(const ThinSliceBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_knl(ThinSliceBendEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp1__parent_knl(ThinSliceBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceBendEntryData_getp__parent_ksl(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_len__parent_ksl(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceBendEntryData_get__parent_ksl(const ThinSliceBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_ksl(ThinSliceBendEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp1__parent_ksl(ThinSliceBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceBendEntryData_get__parent_k0_from_h(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_k0_from_h(ThinSliceBendEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceBendEntryData_getp__parent_k0_from_h(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent__sin_rot_s(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent__sin_rot_s(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent__sin_rot_s(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent__cos_rot_s(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent__cos_rot_s(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent__cos_rot_s(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent__shift_x(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent__shift_x(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent__shift_x(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent__shift_y(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent__shift_y(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent__shift_y(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent__shift_s(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent__shift_s(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent__shift_s(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceBendEntryData_getp__parent__internal_record_id(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent__internal_record_id_buffer_id(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent__internal_record_id_buffer_id(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent__internal_record_id_buffer_id(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent__internal_record_id_offset(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent__internal_record_id_offset(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent__internal_record_id_offset(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get_radiation_flag(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set_radiation_flag(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp_radiation_flag(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get_delta_taper(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set_delta_taper(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp_delta_taper(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get_weight(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set_weight(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp_weight(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_DIPOLEEDGE_NONLINEAR_H
#define XTRACK_TRACK_DIPOLEEDGE_NONLINEAR_H

#include <headers/track.h>


GPUFUN
void DipoleEdgeNonLinear_single_particle(LocalParticle* part,
            double const k, double const e1, double const fint, double const hgap,
            int64_t const side
){

    double sin_, cos_, tan_;
    if (fabs(e1) < 10e-10) {
        sin_ = -999.0; cos_ = -999.0; tan_ = -999.0;
    }
    else{
        sin_ = sin(e1); cos_ = cos(e1); tan_ = tan(e1);
    }

    if (side == 0){ // entry
        if (sin_ > -99.){
            YRotation_single_particle(part, sin_, cos_, tan_);
        }
        DipoleFringe_single_particle(part, fint, hgap, k);
        if (sin_ > -99.){
            Wedge_single_particle(part, -e1, k);
        }
    }
    else if (side == 1){ // exit
        if (sin_ > -99.){
            Wedge_single_particle(part, -e1, k);
        }
        DipoleFringe_single_particle(part, fint, hgap, -k);
        if (sin_ > -99.){
            YRotation_single_particle(part, sin_, cos_, tan_);
        }

    }
}

#endif
#include <beam_elements/elements_src/thin_slice_bend_entry.h>

             static inline
            void ThinSliceBendEntry_track_local_particle_with_transformations(ThinSliceBendEntryData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceBendEntryData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceBendEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceBendEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceBendEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceBendEntryData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceBendEntry_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceBendEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceBendEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceBendEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceBendEntryData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceBendEntry_track_particles(
               ThinSliceBendEntryData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceBendEntry_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceBendExitData
#define XOBJ_TYPEDEF_ThinSliceBendExitData
typedef   struct ThinSliceBendExitData_s * ThinSliceBendExitData;
 static inline ThinSliceBendExitData ThinSliceBendExitData_getp(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  return (ThinSliceBendExitData)(( char*) obj+offset);
}
 static inline BendData ThinSliceBendExitData_getp__parent(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (BendData)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_k0(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_k0(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_k0(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_k1(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_k1(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_k1(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_h(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_h(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_h(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_angle(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_angle(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_angle(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_length(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_length(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_length(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_model(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_model(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_model(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_integrator(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_integrator(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_integrator(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_radiation_flag(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_radiation_flag(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_radiation_flag(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_delta_taper(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_delta_taper(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_delta_taper(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_edge_entry_active(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_entry_active(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_edge_entry_active(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_edge_exit_active(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_exit_active(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_edge_exit_active(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_edge_entry_model(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_entry_model(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_edge_entry_model(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_edge_exit_model(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_exit_model(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_edge_exit_model(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_entry_angle(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_entry_angle(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_entry_angle(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_exit_angle(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_exit_angle(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_exit_angle(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_entry_angle_fdown(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_entry_angle_fdown(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_entry_angle_fdown(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_exit_angle_fdown(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_exit_angle_fdown(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_exit_angle_fdown(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_entry_fint(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_entry_fint(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_entry_fint(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_exit_fint(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_exit_fint(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_exit_fint(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_entry_hgap(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_entry_hgap(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_entry_hgap(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_exit_hgap(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_exit_hgap(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_exit_hgap(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_num_multipole_kicks(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_num_multipole_kicks(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_num_multipole_kicks(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_order(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_order(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_order(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_inv_factorial_order(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_inv_factorial_order(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_inv_factorial_order(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceBendExitData_getp__parent_knl(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_len__parent_knl(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceBendExitData_get__parent_knl(const ThinSliceBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_knl(ThinSliceBendExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp1__parent_knl(ThinSliceBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceBendExitData_getp__parent_ksl(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_len__parent_ksl(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceBendExitData_get__parent_ksl(const ThinSliceBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_ksl(ThinSliceBendExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp1__parent_ksl(ThinSliceBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceBendExitData_get__parent_k0_from_h(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_k0_from_h(ThinSliceBendExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceBendExitData_getp__parent_k0_from_h(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent__sin_rot_s(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent__sin_rot_s(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent__sin_rot_s(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent__cos_rot_s(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent__cos_rot_s(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent__cos_rot_s(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent__shift_x(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent__shift_x(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent__shift_x(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent__shift_y(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent__shift_y(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent__shift_y(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent__shift_s(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent__shift_s(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent__shift_s(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceBendExitData_getp__parent__internal_record_id(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent__internal_record_id_buffer_id(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent__internal_record_id_buffer_id(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent__internal_record_id_buffer_id(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent__internal_record_id_offset(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent__internal_record_id_offset(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent__internal_record_id_offset(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get_radiation_flag(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set_radiation_flag(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp_radiation_flag(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get_delta_taper(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set_delta_taper(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp_delta_taper(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get_weight(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set_weight(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp_weight(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_bend_exit.h>

             static inline
            void ThinSliceBendExit_track_local_particle_with_transformations(ThinSliceBendExitData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceBendExitData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceBendExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceBendExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceBendExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceBendExitData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceBendExit_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceBendExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceBendExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceBendExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceBendExitData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceBendExit_track_particles(
               ThinSliceBendExitData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceBendExit_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThickSliceSolenoidData
#define XOBJ_TYPEDEF_ThickSliceSolenoidData
typedef   struct ThickSliceSolenoidData_s * ThickSliceSolenoidData;
 static inline ThickSliceSolenoidData ThickSliceSolenoidData_getp(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  return (ThickSliceSolenoidData)(( char*) obj+offset);
}
 static inline SolenoidData ThickSliceSolenoidData_getp__parent(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (SolenoidData)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_length(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_length(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_length(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_ks(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_ks(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_ks(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_ksi(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_ksi(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_ksi(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get__parent_radiation_flag(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_radiation_flag(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp__parent_radiation_flag(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get__parent_num_multipole_kicks(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_num_multipole_kicks(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp__parent_num_multipole_kicks(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get__parent_order(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_order(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp__parent_order(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_inv_factorial_order(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_inv_factorial_order(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_inv_factorial_order(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceSolenoidData_getp__parent_knl(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_len__parent_knl(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceSolenoidData_get__parent_knl(const ThickSliceSolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_knl(ThickSliceSolenoidData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp1__parent_knl(ThickSliceSolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceSolenoidData_getp__parent_ksl(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_len__parent_ksl(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceSolenoidData_get__parent_ksl(const ThickSliceSolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_ksl(ThickSliceSolenoidData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp1__parent_ksl(ThickSliceSolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_mult_rot_x_rad(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_mult_rot_x_rad(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_mult_rot_x_rad(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_mult_rot_y_rad(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_mult_rot_y_rad(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_mult_rot_y_rad(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_mult_shift_x(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_mult_shift_x(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_mult_shift_x(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_mult_shift_y(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_mult_shift_y(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_mult_shift_y(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_mult_shift_s(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_mult_shift_s(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_mult_shift_s(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent__sin_rot_s(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent__sin_rot_s(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent__sin_rot_s(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent__cos_rot_s(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent__cos_rot_s(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent__cos_rot_s(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent__shift_x(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent__shift_x(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent__shift_x(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent__shift_y(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent__shift_y(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent__shift_y(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent__shift_s(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent__shift_s(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent__shift_s(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceSolenoidData_getp__parent__internal_record_id(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get__parent__internal_record_id_buffer_id(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent__internal_record_id_buffer_id(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp__parent__internal_record_id_buffer_id(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get__parent__internal_record_id_offset(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent__internal_record_id_offset(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp__parent__internal_record_id_offset(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get_radiation_flag(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set_radiation_flag(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp_radiation_flag(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get_delta_taper(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set_delta_taper(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp_delta_taper(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get_weight(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set_weight(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp_weight(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceSolenoidData_getp__internal_record_id(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get__internal_record_id_buffer_id(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__internal_record_id_buffer_id(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp__internal_record_id_buffer_id(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get__internal_record_id_offset(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__internal_record_id_offset(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp__internal_record_id_offset(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThickSliceSolenoidData_getp_internal_record(ThickSliceSolenoidData el, LocalParticle* part){
    RecordIdentifier record_id = ThickSliceSolenoidData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/thick_slice_solenoid.h>

             static inline
            void ThickSliceSolenoid_track_local_particle_with_transformations(ThickSliceSolenoidData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThickSliceSolenoidData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceSolenoidData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceSolenoidData_get__parent__shift_x(el);
    double const shift_y = ThickSliceSolenoidData_get__parent__shift_y(el);
    double const shift_s = ThickSliceSolenoidData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThickSliceSolenoid_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceSolenoidData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceSolenoidData_get__parent__shift_x(el);
    double const shift_y = ThickSliceSolenoidData_get__parent__shift_y(el);
    double const shift_s = ThickSliceSolenoidData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThickSliceSolenoid_track_particles(
               ThickSliceSolenoidData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThickSliceSolenoid_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceQuadrupoleExitData
#define XOBJ_TYPEDEF_ThinSliceQuadrupoleExitData
typedef   struct ThinSliceQuadrupoleExitData_s * ThinSliceQuadrupoleExitData;
 static inline ThinSliceQuadrupoleExitData ThinSliceQuadrupoleExitData_getp(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  return (ThinSliceQuadrupoleExitData)(( char*) obj+offset);
}
 static inline QuadrupoleData ThinSliceQuadrupoleExitData_getp__parent(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (QuadrupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent_k1(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_k1(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent_k1(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent_k1s(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_k1s(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent_k1s(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent_length(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_length(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent_length(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get__parent_num_multipole_kicks(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_num_multipole_kicks(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp__parent_num_multipole_kicks(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get__parent_order(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_order(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp__parent_order(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent_inv_factorial_order(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_inv_factorial_order(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent_inv_factorial_order(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceQuadrupoleExitData_getp__parent_knl(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_len__parent_knl(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceQuadrupoleExitData_get__parent_knl(const ThinSliceQuadrupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_knl(ThinSliceQuadrupoleExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp1__parent_knl(ThinSliceQuadrupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceQuadrupoleExitData_getp__parent_ksl(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_len__parent_ksl(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceQuadrupoleExitData_get__parent_ksl(const ThinSliceQuadrupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_ksl(ThinSliceQuadrupoleExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp1__parent_ksl(ThinSliceQuadrupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceQuadrupoleExitData_get__parent_edge_entry_active(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_edge_entry_active(ThinSliceQuadrupoleExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceQuadrupoleExitData_getp__parent_edge_entry_active(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceQuadrupoleExitData_get__parent_edge_exit_active(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_edge_exit_active(ThinSliceQuadrupoleExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceQuadrupoleExitData_getp__parent_edge_exit_active(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get__parent_model(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_model(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp__parent_model(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get__parent_integrator(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_integrator(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp__parent_integrator(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get__parent_radiation_flag(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_radiation_flag(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp__parent_radiation_flag(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent_delta_taper(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_delta_taper(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent_delta_taper(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent__sin_rot_s(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent__sin_rot_s(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent__sin_rot_s(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent__cos_rot_s(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent__cos_rot_s(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent__cos_rot_s(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent__shift_x(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent__shift_x(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent__shift_x(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent__shift_y(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent__shift_y(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent__shift_y(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent__shift_s(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent__shift_s(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent__shift_s(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceQuadrupoleExitData_getp__parent__internal_record_id(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get__parent__internal_record_id_buffer_id(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent__internal_record_id_buffer_id(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp__parent__internal_record_id_buffer_id(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get__parent__internal_record_id_offset(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent__internal_record_id_offset(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp__parent__internal_record_id_offset(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get_radiation_flag(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set_radiation_flag(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp_radiation_flag(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get_delta_taper(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set_delta_taper(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp_delta_taper(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get_weight(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set_weight(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp_weight(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_quadrupole_exit.h>

             static inline
            void ThinSliceQuadrupoleExit_track_local_particle_with_transformations(ThinSliceQuadrupoleExitData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceQuadrupoleExitData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceQuadrupoleExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceQuadrupoleExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceQuadrupoleExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceQuadrupoleExitData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceQuadrupoleExit_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceQuadrupoleExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceQuadrupoleExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceQuadrupoleExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceQuadrupoleExitData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceQuadrupoleExit_track_particles(
               ThinSliceQuadrupoleExitData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceQuadrupoleExit_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThickSliceQuadrupoleData
#define XOBJ_TYPEDEF_ThickSliceQuadrupoleData
typedef   struct ThickSliceQuadrupoleData_s * ThickSliceQuadrupoleData;
 static inline ThickSliceQuadrupoleData ThickSliceQuadrupoleData_getp(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  return (ThickSliceQuadrupoleData)(( char*) obj+offset);
}
 static inline QuadrupoleData ThickSliceQuadrupoleData_getp__parent(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (QuadrupoleData)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent_k1(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_k1(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent_k1(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent_k1s(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_k1s(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent_k1s(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent_length(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_length(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent_length(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get__parent_num_multipole_kicks(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_num_multipole_kicks(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp__parent_num_multipole_kicks(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get__parent_order(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_order(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp__parent_order(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent_inv_factorial_order(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_inv_factorial_order(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent_inv_factorial_order(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceQuadrupoleData_getp__parent_knl(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_len__parent_knl(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceQuadrupoleData_get__parent_knl(const ThickSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_knl(ThickSliceQuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp1__parent_knl(ThickSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceQuadrupoleData_getp__parent_ksl(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_len__parent_ksl(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceQuadrupoleData_get__parent_ksl(const ThickSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_ksl(ThickSliceQuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp1__parent_ksl(ThickSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceQuadrupoleData_get__parent_edge_entry_active(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_edge_entry_active(ThickSliceQuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceQuadrupoleData_getp__parent_edge_entry_active(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceQuadrupoleData_get__parent_edge_exit_active(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_edge_exit_active(ThickSliceQuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceQuadrupoleData_getp__parent_edge_exit_active(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get__parent_model(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_model(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp__parent_model(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get__parent_integrator(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_integrator(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp__parent_integrator(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get__parent_radiation_flag(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_radiation_flag(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp__parent_radiation_flag(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent_delta_taper(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_delta_taper(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent_delta_taper(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent__sin_rot_s(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent__sin_rot_s(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent__sin_rot_s(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent__cos_rot_s(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent__cos_rot_s(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent__cos_rot_s(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent__shift_x(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent__shift_x(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent__shift_x(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent__shift_y(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent__shift_y(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent__shift_y(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent__shift_s(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent__shift_s(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent__shift_s(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceQuadrupoleData_getp__parent__internal_record_id(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get__parent__internal_record_id_buffer_id(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent__internal_record_id_buffer_id(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp__parent__internal_record_id_buffer_id(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get__parent__internal_record_id_offset(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent__internal_record_id_offset(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp__parent__internal_record_id_offset(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get_radiation_flag(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set_radiation_flag(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp_radiation_flag(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get_delta_taper(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set_delta_taper(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp_delta_taper(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get_weight(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set_weight(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp_weight(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thick_slice_quadrupole.h>

             static inline
            void ThickSliceQuadrupole_track_local_particle_with_transformations(ThickSliceQuadrupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThickSliceQuadrupoleData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceQuadrupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceQuadrupoleData_get__parent__shift_x(el);
    double const shift_y = ThickSliceQuadrupoleData_get__parent__shift_y(el);
    double const shift_s = ThickSliceQuadrupoleData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThickSliceQuadrupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceQuadrupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceQuadrupoleData_get__parent__shift_x(el);
    double const shift_y = ThickSliceQuadrupoleData_get__parent__shift_y(el);
    double const shift_s = ThickSliceQuadrupoleData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThickSliceQuadrupole_track_particles(
               ThickSliceQuadrupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThickSliceQuadrupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceQuadrupoleData
#define XOBJ_TYPEDEF_ThinSliceQuadrupoleData
typedef   struct ThinSliceQuadrupoleData_s * ThinSliceQuadrupoleData;
 static inline ThinSliceQuadrupoleData ThinSliceQuadrupoleData_getp(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  return (ThinSliceQuadrupoleData)(( char*) obj+offset);
}
 static inline QuadrupoleData ThinSliceQuadrupoleData_getp__parent(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (QuadrupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent_k1(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_k1(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent_k1(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent_k1s(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_k1s(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent_k1s(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent_length(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_length(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent_length(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__parent_num_multipole_kicks(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_num_multipole_kicks(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__parent_num_multipole_kicks(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__parent_order(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_order(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__parent_order(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent_inv_factorial_order(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_inv_factorial_order(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent_inv_factorial_order(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceQuadrupoleData_getp__parent_knl(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_len__parent_knl(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceQuadrupoleData_get__parent_knl(const ThinSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_knl(ThinSliceQuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp1__parent_knl(ThinSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceQuadrupoleData_getp__parent_ksl(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_len__parent_ksl(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceQuadrupoleData_get__parent_ksl(const ThinSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_ksl(ThinSliceQuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp1__parent_ksl(ThinSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceQuadrupoleData_get__parent_edge_entry_active(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_edge_entry_active(ThinSliceQuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceQuadrupoleData_getp__parent_edge_entry_active(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceQuadrupoleData_get__parent_edge_exit_active(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_edge_exit_active(ThinSliceQuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceQuadrupoleData_getp__parent_edge_exit_active(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__parent_model(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_model(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__parent_model(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__parent_integrator(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_integrator(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__parent_integrator(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__parent_radiation_flag(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_radiation_flag(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__parent_radiation_flag(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent_delta_taper(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_delta_taper(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent_delta_taper(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent__sin_rot_s(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent__sin_rot_s(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent__sin_rot_s(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent__cos_rot_s(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent__cos_rot_s(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent__cos_rot_s(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent__shift_x(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent__shift_x(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent__shift_x(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent__shift_y(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent__shift_y(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent__shift_y(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent__shift_s(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent__shift_s(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent__shift_s(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceQuadrupoleData_getp__parent__internal_record_id(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__parent__internal_record_id_buffer_id(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent__internal_record_id_buffer_id(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__parent__internal_record_id_buffer_id(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__parent__internal_record_id_offset(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent__internal_record_id_offset(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__parent__internal_record_id_offset(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get_radiation_flag(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set_radiation_flag(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp_radiation_flag(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get_delta_taper(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set_delta_taper(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp_delta_taper(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get_weight(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set_weight(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp_weight(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceQuadrupoleData_getp__internal_record_id(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__internal_record_id_buffer_id(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__internal_record_id_buffer_id(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__internal_record_id_buffer_id(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__internal_record_id_offset(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__internal_record_id_offset(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__internal_record_id_offset(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThinSliceQuadrupoleData_getp_internal_record(ThinSliceQuadrupoleData el, LocalParticle* part){
    RecordIdentifier record_id = ThinSliceQuadrupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //
#ifndef XTRACK_THIN_SLICE_QUADRUPOLE_H
#define XTRACK_THIN_SLICE_QUADRUPOLE_H

#include <headers/track.h>
#include <beam_elements/elements_src/track_magnet.h>


GPUFUN
void ThinSliceQuadrupole_track_local_particle(
        ThinSliceQuadrupoleData el,
        LocalParticle* part0
) {
    double weight = ThinSliceQuadrupoleData_get_weight(el);

    int64_t radiation_flag = 0;
    double delta_taper = 0.0;
    SynchrotronRadiationRecordData record = NULL;
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
        radiation_flag = ThinSliceQuadrupoleData_get_radiation_flag(el);
        if (radiation_flag == 10){ // from parent
            radiation_flag = ThinSliceQuadrupoleData_get__parent_radiation_flag(el);
        }
        delta_taper = ThinSliceQuadrupoleData_get_delta_taper(el);
        if (radiation_flag==2){
            record = (SynchrotronRadiationRecordData) ThinSliceQuadrupoleData_getp_internal_record(el, part0);
        }
    #endif

    track_magnet_particles(
        /*part0*/                 part0,
        /*length*/                ThinSliceQuadrupoleData_get__parent_length(el) * weight,
        /*order*/                 ThinSliceQuadrupoleData_get__parent_order(el),
        /*inv_factorial_order*/   ThinSliceQuadrupoleData_get__parent_inv_factorial_order(el),
        /*knl*/                   ThinSliceQuadrupoleData_getp1__parent_knl(el, 0),
        /*ksl*/                   ThinSliceQuadrupoleData_getp1__parent_ksl(el, 0),
        /*factor_knl_ksl*/        weight,
        /*num_multipole_kicks*/   1,
        /*model*/                 -1, // kick only
        /*integrator*/            3, // uniform
        /*radiation_flag*/        radiation_flag,
        /*radiation_record*/      record,
        /*delta_taper*/           delta_taper,
        /*h*/                     0.,
        /*hxl*/                   0.,
        /*k0*/                    0.,
        /*k1*/                    ThinSliceQuadrupoleData_get__parent_k1(el),
        /*k2*/                    0.,
        /*k3*/                    0.,
        /*k0s*/                   0.,
        /*k1s*/                   ThinSliceQuadrupoleData_get__parent_k1s(el),
        /*k2s*/                   0.,
        /*k3s*/                   0.,
        /*edge_entry_active*/     0,
        /*edge_exit_active*/      0,
        /*edge_entry_model*/      0,
        /*edge_exit_model*/       0,
        /*edge_entry_angle*/      0.,
        /*edge_exit_angle*/       0.,
        /*edge_entry_angle_fdown*/0.,
        /*edge_exit_angle_fdown*/ 0.,
        /*edge_entry_fint*/       0.,
        /*edge_exit_fint*/        0.,
        /*edge_entry_hgap*/       0.,
        /*edge_exit_hgap*/        0.
    );
}

#endif


             static inline
            void ThinSliceQuadrupole_track_local_particle_with_transformations(ThinSliceQuadrupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceQuadrupoleData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceQuadrupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceQuadrupoleData_get__parent__shift_x(el);
    double const shift_y = ThinSliceQuadrupoleData_get__parent__shift_y(el);
    double const shift_s = ThinSliceQuadrupoleData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceQuadrupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceQuadrupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceQuadrupoleData_get__parent__shift_x(el);
    double const shift_y = ThinSliceQuadrupoleData_get__parent__shift_y(el);
    double const shift_s = ThinSliceQuadrupoleData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceQuadrupole_track_particles(
               ThinSliceQuadrupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceQuadrupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceQuadrupoleEntryData
#define XOBJ_TYPEDEF_ThinSliceQuadrupoleEntryData
typedef   struct ThinSliceQuadrupoleEntryData_s * ThinSliceQuadrupoleEntryData;
 static inline ThinSliceQuadrupoleEntryData ThinSliceQuadrupoleEntryData_getp(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  return (ThinSliceQuadrupoleEntryData)(( char*) obj+offset);
}
 static inline QuadrupoleData ThinSliceQuadrupoleEntryData_getp__parent(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (QuadrupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent_k1(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_k1(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent_k1(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent_k1s(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_k1s(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent_k1s(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent_length(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_length(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent_length(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get__parent_num_multipole_kicks(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_num_multipole_kicks(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp__parent_num_multipole_kicks(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get__parent_order(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_order(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp__parent_order(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent_inv_factorial_order(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_inv_factorial_order(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent_inv_factorial_order(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceQuadrupoleEntryData_getp__parent_knl(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_len__parent_knl(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent_knl(const ThinSliceQuadrupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_knl(ThinSliceQuadrupoleEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp1__parent_knl(ThinSliceQuadrupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceQuadrupoleEntryData_getp__parent_ksl(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_len__parent_ksl(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent_ksl(const ThinSliceQuadrupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_ksl(ThinSliceQuadrupoleEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp1__parent_ksl(ThinSliceQuadrupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceQuadrupoleEntryData_get__parent_edge_entry_active(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_edge_entry_active(ThinSliceQuadrupoleEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceQuadrupoleEntryData_getp__parent_edge_entry_active(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceQuadrupoleEntryData_get__parent_edge_exit_active(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_edge_exit_active(ThinSliceQuadrupoleEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceQuadrupoleEntryData_getp__parent_edge_exit_active(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get__parent_model(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_model(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp__parent_model(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get__parent_integrator(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_integrator(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp__parent_integrator(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get__parent_radiation_flag(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_radiation_flag(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp__parent_radiation_flag(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent_delta_taper(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_delta_taper(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent_delta_taper(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent__sin_rot_s(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent__sin_rot_s(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent__sin_rot_s(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent__cos_rot_s(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent__cos_rot_s(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent__cos_rot_s(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent__shift_x(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent__shift_x(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent__shift_x(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent__shift_y(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent__shift_y(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent__shift_y(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent__shift_s(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent__shift_s(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent__shift_s(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceQuadrupoleEntryData_getp__parent__internal_record_id(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get__parent__internal_record_id_buffer_id(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent__internal_record_id_buffer_id(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp__parent__internal_record_id_buffer_id(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get__parent__internal_record_id_offset(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent__internal_record_id_offset(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp__parent__internal_record_id_offset(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get_radiation_flag(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set_radiation_flag(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp_radiation_flag(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get_delta_taper(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set_delta_taper(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp_delta_taper(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get_weight(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set_weight(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp_weight(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_quadrupole_entry.h>

             static inline
            void ThinSliceQuadrupoleEntry_track_local_particle_with_transformations(ThinSliceQuadrupoleEntryData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceQuadrupoleEntryData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceQuadrupoleEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceQuadrupoleEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceQuadrupoleEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceQuadrupoleEntryData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceQuadrupoleEntry_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceQuadrupoleEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceQuadrupoleEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceQuadrupoleEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceQuadrupoleEntryData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceQuadrupoleEntry_track_particles(
               ThinSliceQuadrupoleEntryData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceQuadrupoleEntry_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_DriftSliceQuadrupoleData
#define XOBJ_TYPEDEF_DriftSliceQuadrupoleData
typedef   struct DriftSliceQuadrupoleData_s * DriftSliceQuadrupoleData;
 static inline DriftSliceQuadrupoleData DriftSliceQuadrupoleData_getp(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  return (DriftSliceQuadrupoleData)(( char*) obj+offset);
}
 static inline QuadrupoleData DriftSliceQuadrupoleData_getp__parent(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (QuadrupoleData)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent_k1(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_k1(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent_k1(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent_k1s(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_k1s(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent_k1s(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent_length(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_length(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent_length(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get__parent_num_multipole_kicks(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_num_multipole_kicks(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp__parent_num_multipole_kicks(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get__parent_order(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_order(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp__parent_order(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent_inv_factorial_order(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_inv_factorial_order(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent_inv_factorial_order(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceQuadrupoleData_getp__parent_knl(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_len__parent_knl(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceQuadrupoleData_get__parent_knl(const DriftSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_knl(DriftSliceQuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp1__parent_knl(DriftSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceQuadrupoleData_getp__parent_ksl(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_len__parent_ksl(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceQuadrupoleData_get__parent_ksl(const DriftSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_ksl(DriftSliceQuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp1__parent_ksl(DriftSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceQuadrupoleData_get__parent_edge_entry_active(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_edge_entry_active(DriftSliceQuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceQuadrupoleData_getp__parent_edge_entry_active(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceQuadrupoleData_get__parent_edge_exit_active(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_edge_exit_active(DriftSliceQuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceQuadrupoleData_getp__parent_edge_exit_active(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get__parent_model(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_model(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp__parent_model(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get__parent_integrator(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_integrator(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp__parent_integrator(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get__parent_radiation_flag(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_radiation_flag(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp__parent_radiation_flag(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent_delta_taper(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_delta_taper(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent_delta_taper(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent__sin_rot_s(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent__sin_rot_s(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent__sin_rot_s(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent__cos_rot_s(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent__cos_rot_s(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent__cos_rot_s(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent__shift_x(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent__shift_x(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent__shift_x(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent__shift_y(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent__shift_y(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent__shift_y(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent__shift_s(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent__shift_s(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent__shift_s(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier DriftSliceQuadrupoleData_getp__parent__internal_record_id(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get__parent__internal_record_id_buffer_id(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent__internal_record_id_buffer_id(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp__parent__internal_record_id_buffer_id(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get__parent__internal_record_id_offset(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent__internal_record_id_offset(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp__parent__internal_record_id_offset(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get_radiation_flag(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set_radiation_flag(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp_radiation_flag(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get_delta_taper(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set_delta_taper(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp_delta_taper(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get_weight(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set_weight(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp_weight(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/drift_slice_quadrupole.h>

             static inline
            void DriftSliceQuadrupole_track_local_particle_with_transformations(DriftSliceQuadrupoleData el, LocalParticle* part0){
    DriftSliceQuadrupole_track_local_particle(el, part0);
}


             
            void DriftSliceQuadrupole_track_particles(
               DriftSliceQuadrupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              DriftSliceQuadrupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_EverestBlockData
#define XOBJ_TYPEDEF_EverestBlockData
typedef   struct EverestBlockData_s * EverestBlockData;
 static inline EverestBlockData EverestBlockData_getp(EverestBlockData restrict  obj){
  int64_t offset=0;
  return (EverestBlockData)(( char*) obj+offset);
}
 static inline double EverestBlockData_get_length(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set_length(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp_length(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t EverestBlockData_get_active(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestBlockData_set_active(EverestBlockData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=16;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestBlockData_getp_active(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline int8_t EverestBlockData_get__record_interactions(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestBlockData_set__record_interactions(EverestBlockData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=24;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestBlockData_getp__record_interactions(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get__sin_rot_s(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__sin_rot_s(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp__sin_rot_s(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get__cos_rot_s(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__cos_rot_s(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp__cos_rot_s(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get__shift_x(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__shift_x(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp__shift_x(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get__shift_y(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__shift_y(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp__shift_y(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get__shift_s(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__shift_s(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp__shift_s(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier EverestBlockData_getp__internal_record_id(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t EverestBlockData_get__internal_record_id_buffer_id(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__internal_record_id_buffer_id(EverestBlockData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* EverestBlockData_getp__internal_record_id_buffer_id(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t EverestBlockData_get__internal_record_id_offset(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__internal_record_id_offset(EverestBlockData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* EverestBlockData_getp__internal_record_id_offset(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline MaterialData EverestBlockData_getp__material(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return (MaterialData)(( char*) obj+offset);
}
 static inline double EverestBlockData_get__material_Z(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__material_Z(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=184;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp__material_Z(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get__material_A(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__material_A(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp__material_A(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get__material_density(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__material_density(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=200;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp__material_density(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get__material_excitation_energy(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__material_excitation_energy(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp__material_excitation_energy(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get__material_nuclear_radius(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__material_nuclear_radius(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp__material_nuclear_radius(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get__material_nuclear_elastic_slope(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__material_nuclear_elastic_slope(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp__material_nuclear_elastic_slope(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr6Float64 EverestBlockData_getp__material_cross_section(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return (Arr6Float64)(( char*) obj+offset);
}
 static inline int64_t EverestBlockData_len__material_cross_section(EverestBlockData restrict  obj){
  return 6;
}
 static inline double EverestBlockData_get__material_cross_section(const EverestBlockData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=232;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__material_cross_section(EverestBlockData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=232;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp1__material_cross_section(EverestBlockData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=232;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get__material_hcut(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__material_hcut(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=280;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp__material_hcut(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return ( double*)(( char*) obj+offset);
}
 static inline  char* EverestBlockData_getp__material_name(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=304;
  return ( char*)(( char*) obj+offset);
}
 static inline int8_t EverestBlockData_get__material__only_mcs(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=288;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestBlockData_set__material__only_mcs(EverestBlockData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=288;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestBlockData_getp__material__only_mcs(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=288;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get__material_radiation_length(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=296;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set__material_radiation_length(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=296;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp__material_radiation_length(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=296;
  return ( double*)(( char*) obj+offset);
}
 static inline RandomRutherfordData EverestBlockData_getp_rutherford_rng(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return (RandomRutherfordData)(( char*) obj+offset);
}
 static inline double EverestBlockData_get_rutherford_rng_lower_val(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set_rutherford_rng_lower_val(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp_rutherford_rng_lower_val(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get_rutherford_rng_upper_val(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set_rutherford_rng_upper_val(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp_rutherford_rng_upper_val(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get_rutherford_rng_A(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set_rutherford_rng_A(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp_rutherford_rng_A(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get_rutherford_rng_B(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set_rutherford_rng_B(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp_rutherford_rng_B(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t EverestBlockData_get_rutherford_rng_Newton_iterations(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestBlockData_set_rutherford_rng_Newton_iterations(EverestBlockData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=120;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestBlockData_getp_rutherford_rng_Newton_iterations(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get_rutherford_rng__sin_rot_s(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set_rutherford_rng__sin_rot_s(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp_rutherford_rng__sin_rot_s(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get_rutherford_rng__cos_rot_s(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set_rutherford_rng__cos_rot_s(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp_rutherford_rng__cos_rot_s(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get_rutherford_rng__shift_x(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set_rutherford_rng__shift_x(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp_rutherford_rng__shift_x(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get_rutherford_rng__shift_y(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set_rutherford_rng__shift_y(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp_rutherford_rng__shift_y(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestBlockData_get_rutherford_rng__shift_s(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestBlockData_set_rutherford_rng__shift_s(EverestBlockData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestBlockData_getp_rutherford_rng__shift_s(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t EverestBlockData_get__tracking(const EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestBlockData_set__tracking(EverestBlockData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=168;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestBlockData_getp__tracking(EverestBlockData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( int8_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
InteractionRecordData EverestBlockData_getp_internal_record(EverestBlockData el, LocalParticle* part){
    RecordIdentifier record_id = EverestBlockData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (InteractionRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_EVEREST_BLOCK_H
#define XCOLL_EVEREST_BLOCK_H
#include <math.h>
#include <stdio.h>


 static inline
int8_t EverestBlockData_get_record_impacts(EverestBlockData el){
    return EverestBlockData_get__record_interactions(el) % 2;
}

 static inline
int8_t EverestBlockData_get_record_exits(EverestBlockData el){
    return (EverestBlockData_get__record_interactions(el) >> 1) % 2;
}

 static inline
int8_t EverestBlockData_get_record_scatterings(EverestBlockData el){
    return (EverestBlockData_get__record_interactions(el) >> 2) % 2;
}

 static inline
void EverestBlock_set_material(EverestBlockData el){
    MaterialData material = EverestBlockData_getp__material(el);
    RandomRutherfordData rng = EverestBlockData_getp_rutherford_rng(el);
    RandomRutherford_set_by_xcoll_material(rng, (GeneralMaterialData) material);
}


 static inline
EverestCollData EverestBlock_init(EverestBlockData el, LocalParticle* part0, int8_t active){
    EverestCollData coll = (EverestCollData) malloc(sizeof(EverestCollData_));
    if (active){ // This is needed in order to avoid that the initialisation is called during a twiss!
        // Random generator and material
        coll->rng = EverestBlockData_getp_rutherford_rng(el);
        MaterialData material = EverestBlockData_getp__material(el);
        coll->exenergy = MaterialData_get_excitation_energy(material)*1.0e3; // MeV
        coll->rho      = MaterialData_get_density(material);
        coll->anuc     = MaterialData_get_A(material);
        coll->zatom    = MaterialData_get_Z(material);
        coll->bnref    = MaterialData_get_nuclear_elastic_slope(material);
        coll->radl     = MaterialData_get_radiation_length(material);
        coll->csref[0] = MaterialData_get_cross_section(material, 0);
        coll->csref[1] = MaterialData_get_cross_section(material, 1);
        coll->csref[5] = MaterialData_get_cross_section(material, 5);
        coll->only_mcs = MaterialData_get__only_mcs(material);

        // Impact table
        coll->record = EverestBlockData_getp_internal_record(el, part0);
        coll->record_index = NULL;
        coll->record_scatterings = 0;
        if (coll->record){
            coll->record_index = InteractionRecordData_getp__index(coll->record);
            coll->record_scatterings = EverestBlockData_get_record_scatterings(el);
        }
    }
    return coll;
}


 static inline
EverestData EverestBlock_init_data(LocalParticle* part, EverestCollData coll){
    EverestData everest = (EverestData) malloc(sizeof(EverestData_));
    everest->coll = coll;
    everest->rescale_scattering = 1;
    // Preinitialise scattering parameters
    double energy = LocalParticle_get_energy(part) / 1e9; // energy in GeV
    calculate_scattering(everest, energy);
    calculate_ionisation_properties(everest, energy);
    return everest;
}


 static inline
void EverestBlock_track_local_particle(EverestBlockData el, LocalParticle* part0) {
    int8_t active = EverestBlockData_get__tracking(el);
    active       *= EverestBlockData_get_active(el);
    double const length = EverestBlockData_get_length(el);

    // Initialise collimator data
    // TODO: we want this to happen before tracking (instead of every turn), as a separate kernel
    EverestCollData coll = EverestBlock_init(el, part0, active);


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

        if (!active){
            // Drift full length
            Drift_single_particle(part, length);

        } else {
            // Check collimator initialisation
            int8_t is_valid = xcoll_check_particle_init(coll->rng, part);

            if (is_valid) {
                // Store s-location of start of block
                double s_block = LocalParticle_get_s(part);
                LocalParticle_set_s(part, 0);

                // Store initial coordinates for updating later
                double const rvv_in     = LocalParticle_get_rvv(part);
#ifdef XCOLL_USE_EXACT
                double const xp_in      = LocalParticle_get_exact_xp(part);
                double const yp_in      = LocalParticle_get_exact_yp(part);
#else
                double const xp_in      = LocalParticle_get_xp(part);
                double const yp_in      = LocalParticle_get_yp(part);
#endif
                double const zeta_in    = LocalParticle_get_zeta(part);
                double const energy_in  = LocalParticle_get_energy(part);
                double energy_out;

                EverestData everest = EverestBlock_init_data(part, coll);
                energy_out = jaw(everest, part, energy_in, length, 0);
                free(everest);
                LocalParticle_add_to_s(part, s_block);

                LocalParticle_set_zeta(part, zeta_in);
                // Survived particles need correcting:
                if (LocalParticle_get_state(part)>0){
                    // Update energy; the last flag keeps angles constant (even valid for exact angles!)
                    LocalParticle_add_to_energy(part, energy_out - energy_in, 0);
                    // Update zeta
#ifdef XCOLL_USE_EXACT
                    double xp  = LocalParticle_get_exact_xp(part);
                    double yp  = LocalParticle_get_exact_yp(part);
#else
                    double xp  = LocalParticle_get_xp(part);
                    double yp  = LocalParticle_get_yp(part);
#endif
                    double rvv = LocalParticle_get_rvv(part);
                    // First we drift half the length with the old angles:
                    LocalParticle_add_to_zeta(part, drift_zeta_single(rvv_in, xp_in, yp_in, length/2) );
                    // then half the length with the new angles:
                    LocalParticle_add_to_zeta(part, drift_zeta_single(rvv, xp, yp, length/2) );
                }
            }
        }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    free(coll);
}



#endif /* XCOLL_EVEREST_BLOCK_H */

             static inline
            void EverestBlock_track_local_particle_with_transformations(EverestBlockData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = EverestBlockData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = EverestBlockData_get__cos_rot_s(el);
    double const shift_x = EverestBlockData_get__shift_x(el);
    double const shift_y = EverestBlockData_get__shift_y(el);
    double const shift_s = EverestBlockData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    EverestBlock_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = EverestBlockData_get__cos_rot_s(el);
    double const shift_x = EverestBlockData_get__shift_x(el);
    double const shift_y = EverestBlockData_get__shift_y(el);
    double const shift_s = EverestBlockData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void EverestBlock_track_particles(
               EverestBlockData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              EverestBlock_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_BaseCollimatorData
#define XOBJ_TYPEDEF_BaseCollimatorData
typedef   struct BaseCollimatorData_s * BaseCollimatorData;
 static inline BaseCollimatorData BaseCollimatorData_getp(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  return (BaseCollimatorData)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get_length(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set_length(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp_length(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t BaseCollimatorData_get_active(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *(( int8_t*) obj+offset);
}
 static inline void BaseCollimatorData_set_active(BaseCollimatorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=8;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BaseCollimatorData_getp_active(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline int8_t BaseCollimatorData_get__record_interactions(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *(( int8_t*) obj+offset);
}
 static inline void BaseCollimatorData_set__record_interactions(BaseCollimatorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=16;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BaseCollimatorData_getp__record_interactions(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__sin_rot_s(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__sin_rot_s(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__sin_rot_s(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__cos_rot_s(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__cos_rot_s(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__cos_rot_s(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__shift_x(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__shift_x(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__shift_x(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__shift_y(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__shift_y(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__shift_y(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__shift_s(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__shift_s(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__shift_s(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier BaseCollimatorData_getp__internal_record_id(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t BaseCollimatorData_get__internal_record_id_buffer_id(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__internal_record_id_buffer_id(BaseCollimatorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BaseCollimatorData_getp__internal_record_id_buffer_id(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BaseCollimatorData_get__internal_record_id_offset(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__internal_record_id_offset(BaseCollimatorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BaseCollimatorData_getp__internal_record_id_offset(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__sin_zL(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__sin_zL(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__sin_zL(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__cos_zL(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__cos_zL(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__cos_zL(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__sin_zR(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__sin_zR(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__sin_zR(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__cos_zR(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__cos_zR(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__cos_zR(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__sin_zDiff(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__sin_zDiff(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__sin_zDiff(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__cos_zDiff(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__cos_zDiff(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__cos_zDiff(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t BaseCollimatorData_get__jaws_parallel(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *(( int8_t*) obj+offset);
}
 static inline void BaseCollimatorData_set__jaws_parallel(BaseCollimatorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=128;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BaseCollimatorData_getp__jaws_parallel(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__jaw_LU(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__jaw_LU(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__jaw_LU(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__jaw_RU(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__jaw_RU(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__jaw_RU(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__jaw_LD(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__jaw_LD(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__jaw_LD(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__jaw_RD(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__jaw_RD(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__jaw_RD(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__sin_yL(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__sin_yL(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__sin_yL(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__cos_yL(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__cos_yL(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=176;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__cos_yL(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__tan_yL(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__tan_yL(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=184;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__tan_yL(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__sin_yR(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__sin_yR(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__sin_yR(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__cos_yR(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__cos_yR(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=200;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__cos_yR(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__tan_yR(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__tan_yR(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__tan_yR(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t BaseCollimatorData_get__side(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return *(( int8_t*) obj+offset);
}
 static inline void BaseCollimatorData_set__side(BaseCollimatorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=216;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BaseCollimatorData_getp__side(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline int8_t BaseCollimatorData_get__align(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return *(( int8_t*) obj+offset);
}
 static inline void BaseCollimatorData_set__align(BaseCollimatorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=224;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BaseCollimatorData_getp__align(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__gap_L(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__gap_L(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__gap_L(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__gap_R(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__gap_R(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__gap_R(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__nemitt_x(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__nemitt_x(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__nemitt_x(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCollimatorData_get__nemitt_y(const BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCollimatorData_set__nemitt_y(BaseCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=256;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCollimatorData_getp__nemitt_y(BaseCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
InteractionRecordData BaseCollimatorData_getp_internal_record(BaseCollimatorData el, LocalParticle* part){
    RecordIdentifier record_id = BaseCollimatorData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (InteractionRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#ifndef XOBJ_TYPEDEF_BlackAbsorberData
#define XOBJ_TYPEDEF_BlackAbsorberData
typedef   struct BlackAbsorberData_s * BlackAbsorberData;
 static inline BlackAbsorberData BlackAbsorberData_getp(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  return (BlackAbsorberData)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get_length(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set_length(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp_length(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t BlackAbsorberData_get_active(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *(( int8_t*) obj+offset);
}
 static inline void BlackAbsorberData_set_active(BlackAbsorberData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=8;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BlackAbsorberData_getp_active(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline int8_t BlackAbsorberData_get__record_interactions(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *(( int8_t*) obj+offset);
}
 static inline void BlackAbsorberData_set__record_interactions(BlackAbsorberData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=16;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BlackAbsorberData_getp__record_interactions(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__sin_rot_s(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__sin_rot_s(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__sin_rot_s(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__cos_rot_s(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__cos_rot_s(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__cos_rot_s(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__shift_x(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__shift_x(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__shift_x(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__shift_y(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__shift_y(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__shift_y(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__shift_s(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__shift_s(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__shift_s(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier BlackAbsorberData_getp__internal_record_id(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t BlackAbsorberData_get__internal_record_id_buffer_id(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__internal_record_id_buffer_id(BlackAbsorberData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BlackAbsorberData_getp__internal_record_id_buffer_id(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BlackAbsorberData_get__internal_record_id_offset(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__internal_record_id_offset(BlackAbsorberData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BlackAbsorberData_getp__internal_record_id_offset(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__sin_zL(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__sin_zL(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__sin_zL(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__cos_zL(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__cos_zL(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__cos_zL(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__sin_zR(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__sin_zR(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__sin_zR(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__cos_zR(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__cos_zR(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__cos_zR(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__sin_zDiff(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__sin_zDiff(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__sin_zDiff(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__cos_zDiff(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__cos_zDiff(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__cos_zDiff(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t BlackAbsorberData_get__jaws_parallel(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *(( int8_t*) obj+offset);
}
 static inline void BlackAbsorberData_set__jaws_parallel(BlackAbsorberData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=128;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BlackAbsorberData_getp__jaws_parallel(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__jaw_LU(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__jaw_LU(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__jaw_LU(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__jaw_RU(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__jaw_RU(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__jaw_RU(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__jaw_LD(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__jaw_LD(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__jaw_LD(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__jaw_RD(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__jaw_RD(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__jaw_RD(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__sin_yL(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__sin_yL(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__sin_yL(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__cos_yL(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__cos_yL(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=176;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__cos_yL(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__tan_yL(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__tan_yL(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=184;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__tan_yL(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__sin_yR(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__sin_yR(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__sin_yR(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__cos_yR(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__cos_yR(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=200;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__cos_yR(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__tan_yR(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__tan_yR(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__tan_yR(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t BlackAbsorberData_get__side(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return *(( int8_t*) obj+offset);
}
 static inline void BlackAbsorberData_set__side(BlackAbsorberData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=216;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BlackAbsorberData_getp__side(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline int8_t BlackAbsorberData_get__align(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return *(( int8_t*) obj+offset);
}
 static inline void BlackAbsorberData_set__align(BlackAbsorberData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=224;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BlackAbsorberData_getp__align(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__gap_L(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__gap_L(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__gap_L(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__gap_R(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__gap_R(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__gap_R(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__nemitt_x(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__nemitt_x(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__nemitt_x(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline double BlackAbsorberData_get__nemitt_y(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return *( double*)(( char*) obj+offset);
}
 static inline void BlackAbsorberData_set__nemitt_y(BlackAbsorberData restrict  obj, double value){
  int64_t offset=0;
  offset+=256;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BlackAbsorberData_getp__nemitt_y(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t BlackAbsorberData_get__tracking(const BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return *(( int8_t*) obj+offset);
}
 static inline void BlackAbsorberData_set__tracking(BlackAbsorberData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=264;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BlackAbsorberData_getp__tracking(BlackAbsorberData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return ( int8_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
InteractionRecordData BlackAbsorberData_getp_internal_record(BlackAbsorberData el, LocalParticle* part){
    RecordIdentifier record_id = BlackAbsorberData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (InteractionRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_ABSORBER_H
#define XCOLL_ABSORBER_H


 static inline
int8_t BlackAbsorberData_get_record_impacts(BlackAbsorberData el){
    return BlackAbsorberData_get__record_interactions(el) % 2;
}

 static inline
int8_t BlackAbsorberData_get_record_exits(BlackAbsorberData el){
    return (BlackAbsorberData_get__record_interactions(el) >> 1) % 2;
}

 static inline
int8_t BlackAbsorberData_get_record_scatterings(BlackAbsorberData el){
    return (BlackAbsorberData_get__record_interactions(el) >> 2) % 2;
}


 static inline
CollimatorGeometry BlackAbsorber_init_geometry(BlackAbsorberData el, LocalParticle* part0, int8_t active){
    CollimatorGeometry cg = (CollimatorGeometry) malloc(sizeof(CollimatorGeometry_));
    if (active){ // This is needed in order to avoid that the initialisation is called during a twiss!
        // Jaw corners (with tilts)
        cg->jaw_LU = BlackAbsorberData_get__jaw_LU(el);
        cg->jaw_RU = BlackAbsorberData_get__jaw_RU(el);
        // Get angles of jaws
        cg->sin_zL = BlackAbsorberData_get__sin_zL(el);
        cg->cos_zL = BlackAbsorberData_get__cos_zL(el);
        cg->sin_zR = BlackAbsorberData_get__sin_zR(el);
        cg->cos_zR = BlackAbsorberData_get__cos_zR(el);
        cg->sin_zDiff = BlackAbsorberData_get__sin_zDiff(el);
        cg->cos_zDiff = BlackAbsorberData_get__cos_zDiff(el);
        cg->jaws_parallel = BlackAbsorberData_get__jaws_parallel(el);
        // Tilts
        cg->sin_yL = BlackAbsorberData_get__sin_yL(el);
        cg->cos_yL = BlackAbsorberData_get__cos_yL(el);
        cg->sin_yR = BlackAbsorberData_get__sin_yR(el);
        cg->cos_yR = BlackAbsorberData_get__cos_yR(el);
        // Length and segments
        cg->length = BlackAbsorberData_get_length(el);
        cg->side   = BlackAbsorberData_get__side(el);
        double s_U, s_D, x_D;
        if (cg->side != -1){
            s_U = cg->length/2 * (1-cg->cos_yL);
            s_D = cg->length/2 * (1+cg->cos_yL);
            x_D = BlackAbsorberData_get__jaw_LD(el);
            cg->segments_L = create_jaw(s_U, cg->jaw_LU, s_D, x_D, cg->sin_yL/cg->cos_yL, 1);
        }
        if (cg->side != 1){
            s_U = cg->length/2 * (1-cg->cos_yR);
            s_D = cg->length/2 * (1+cg->cos_yR);
            x_D = BlackAbsorberData_get__jaw_RD(el);
            cg->segments_R = create_jaw(s_U, cg->jaw_RU, s_D, x_D, cg->sin_yR/cg->cos_yR, -1);
        }
        // Impact table
        cg->record = BlackAbsorberData_getp_internal_record(el, part0);
        cg->record_index = NULL;
        cg->record_impacts = 0;
        cg->record_exits = 0;
        if (cg->record){
            cg->record_index = InteractionRecordData_getp__index(cg->record);
            cg->record_impacts = BlackAbsorberData_get_record_impacts(el);
            cg->record_exits = BlackAbsorberData_get_record_exits(el);
        }
    }

    return cg;
}

 static inline
void BlackAbsorber_free(CollimatorGeometry restrict cg, int8_t active){
    if (active){
        if (cg->side != -1){
            destroy_jaw(cg->segments_L);
        }
        if (cg->side != 1){
            destroy_jaw(cg->segments_R);
        }
    }
    free(cg);
}


 static inline
void BlackAbsorber_track_local_particle(BlackAbsorberData el, LocalParticle* part0){

    // Collimator active and length
    int8_t active = BlackAbsorberData_get_active(el);
    active       *= BlackAbsorberData_get__tracking(el);
    double const length = BlackAbsorberData_get_length(el);

    // Get geometry
    CollimatorGeometry cg     = BlackAbsorber_init_geometry(el, part0, active);
    int8_t record_scatterings = BlackAbsorberData_get_record_scatterings(el);


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

        if (!active){
            // Drift full length
            Drift_single_particle(part, length);

        } else {
            // Check collimator initialisation
            int8_t is_tracking = assert_tracking(part, XC_ERR_INVALID_TRACK);

            if (is_tracking) {
                // Store s-location of start of collimator
                double s_coll = LocalParticle_get_s(part);
                LocalParticle_set_s(part, 0);

                // Check if hit on jaws
                int8_t is_hit = hit_jaws_check_and_transform(part, cg);

                if (is_hit != 0){
                    LocalParticle_set_state(part, XC_LOST_ON_ABSORBER);
                    if (record_scatterings) {
                        InteractionRecordData_log(cg->record, cg->record_index, part, XC_ABSORBED);  // In coll jaw reference frame
                    }
                }

                // Transform back to the lab frame
                hit_jaws_transform_back(is_hit, part, cg);
                LocalParticle_add_to_s(part, s_coll);
            }
        }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    BlackAbsorber_free(cg, active);
}

#endif /* XCOLL_ABSORBER_H */


             static inline
            void BlackAbsorber_track_local_particle_with_transformations(BlackAbsorberData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = BlackAbsorberData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BlackAbsorberData_get__cos_rot_s(el);
    double const shift_x = BlackAbsorberData_get__shift_x(el);
    double const shift_y = BlackAbsorberData_get__shift_y(el);
    double const shift_s = BlackAbsorberData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    BlackAbsorber_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BlackAbsorberData_get__cos_rot_s(el);
    double const shift_x = BlackAbsorberData_get__shift_x(el);
    double const shift_y = BlackAbsorberData_get__shift_y(el);
    double const shift_s = BlackAbsorberData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void BlackAbsorber_track_particles(
               BlackAbsorberData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              BlackAbsorber_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_EverestCollimatorData
#define XOBJ_TYPEDEF_EverestCollimatorData
typedef   struct EverestCollimatorData_s * EverestCollimatorData;
 static inline EverestCollimatorData EverestCollimatorData_getp(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  return (EverestCollimatorData)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get_length(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set_length(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp_length(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t EverestCollimatorData_get_active(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCollimatorData_set_active(EverestCollimatorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=16;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCollimatorData_getp_active(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline int8_t EverestCollimatorData_get__record_interactions(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCollimatorData_set__record_interactions(EverestCollimatorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=24;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCollimatorData_getp__record_interactions(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__sin_rot_s(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__sin_rot_s(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__sin_rot_s(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__cos_rot_s(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__cos_rot_s(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__cos_rot_s(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__shift_x(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__shift_x(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__shift_x(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__shift_y(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__shift_y(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__shift_y(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__shift_s(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__shift_s(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__shift_s(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier EverestCollimatorData_getp__internal_record_id(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t EverestCollimatorData_get__internal_record_id_buffer_id(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__internal_record_id_buffer_id(EverestCollimatorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* EverestCollimatorData_getp__internal_record_id_buffer_id(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t EverestCollimatorData_get__internal_record_id_offset(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__internal_record_id_offset(EverestCollimatorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* EverestCollimatorData_getp__internal_record_id_offset(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__sin_zL(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__sin_zL(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__sin_zL(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__cos_zL(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__cos_zL(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__cos_zL(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__sin_zR(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__sin_zR(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__sin_zR(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__cos_zR(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__cos_zR(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__cos_zR(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__sin_zDiff(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__sin_zDiff(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__sin_zDiff(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__cos_zDiff(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__cos_zDiff(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__cos_zDiff(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t EverestCollimatorData_get__jaws_parallel(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCollimatorData_set__jaws_parallel(EverestCollimatorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=136;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCollimatorData_getp__jaws_parallel(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__jaw_LU(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__jaw_LU(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__jaw_LU(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__jaw_RU(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__jaw_RU(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__jaw_RU(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__jaw_LD(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__jaw_LD(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__jaw_LD(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__jaw_RD(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__jaw_RD(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__jaw_RD(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__sin_yL(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__sin_yL(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=176;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__sin_yL(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__cos_yL(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__cos_yL(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=184;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__cos_yL(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__tan_yL(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__tan_yL(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__tan_yL(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__sin_yR(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__sin_yR(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=200;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__sin_yR(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__cos_yR(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__cos_yR(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__cos_yR(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__tan_yR(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__tan_yR(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__tan_yR(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t EverestCollimatorData_get__side(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCollimatorData_set__side(EverestCollimatorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=224;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCollimatorData_getp__side(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline int8_t EverestCollimatorData_get__align(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCollimatorData_set__align(EverestCollimatorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=232;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCollimatorData_getp__align(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__gap_L(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__gap_L(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__gap_L(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__gap_R(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__gap_R(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__gap_R(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__nemitt_x(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__nemitt_x(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=256;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__nemitt_x(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__nemitt_y(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__nemitt_y(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=264;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__nemitt_y(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return ( double*)(( char*) obj+offset);
}
 static inline MaterialData EverestCollimatorData_getp__material(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=360;
  return (MaterialData)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__material_Z(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=368;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__material_Z(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=368;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__material_Z(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=368;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__material_A(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=376;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__material_A(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=376;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__material_A(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=376;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__material_density(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=384;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__material_density(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=384;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__material_density(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=384;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__material_excitation_energy(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=392;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__material_excitation_energy(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=392;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__material_excitation_energy(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=392;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__material_nuclear_radius(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=400;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__material_nuclear_radius(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=400;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__material_nuclear_radius(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=400;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__material_nuclear_elastic_slope(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=408;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__material_nuclear_elastic_slope(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=408;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__material_nuclear_elastic_slope(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=408;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr6Float64 EverestCollimatorData_getp__material_cross_section(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=416;
  return (Arr6Float64)(( char*) obj+offset);
}
 static inline int64_t EverestCollimatorData_len__material_cross_section(EverestCollimatorData restrict  obj){
  return 6;
}
 static inline double EverestCollimatorData_get__material_cross_section(const EverestCollimatorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=416;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__material_cross_section(EverestCollimatorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=416;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp1__material_cross_section(EverestCollimatorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=416;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__material_hcut(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=464;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__material_hcut(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=464;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__material_hcut(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=464;
  return ( double*)(( char*) obj+offset);
}
 static inline  char* EverestCollimatorData_getp__material_name(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=488;
  return ( char*)(( char*) obj+offset);
}
 static inline int8_t EverestCollimatorData_get__material__only_mcs(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=472;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCollimatorData_set__material__only_mcs(EverestCollimatorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=472;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCollimatorData_getp__material__only_mcs(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=472;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get__material_radiation_length(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=480;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set__material_radiation_length(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=480;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp__material_radiation_length(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=480;
  return ( double*)(( char*) obj+offset);
}
 static inline RandomRutherfordData EverestCollimatorData_getp_rutherford_rng(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return (RandomRutherfordData)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get_rutherford_rng_lower_val(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set_rutherford_rng_lower_val(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=272;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp_rutherford_rng_lower_val(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get_rutherford_rng_upper_val(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set_rutherford_rng_upper_val(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=280;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp_rutherford_rng_upper_val(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get_rutherford_rng_A(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=288;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set_rutherford_rng_A(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=288;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp_rutherford_rng_A(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=288;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get_rutherford_rng_B(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=296;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set_rutherford_rng_B(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=296;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp_rutherford_rng_B(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=296;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t EverestCollimatorData_get_rutherford_rng_Newton_iterations(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=304;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCollimatorData_set_rutherford_rng_Newton_iterations(EverestCollimatorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=304;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCollimatorData_getp_rutherford_rng_Newton_iterations(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=304;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get_rutherford_rng__sin_rot_s(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=312;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set_rutherford_rng__sin_rot_s(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=312;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp_rutherford_rng__sin_rot_s(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=312;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get_rutherford_rng__cos_rot_s(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=320;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set_rutherford_rng__cos_rot_s(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=320;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp_rutherford_rng__cos_rot_s(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=320;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get_rutherford_rng__shift_x(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=328;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set_rutherford_rng__shift_x(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=328;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp_rutherford_rng__shift_x(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=328;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get_rutherford_rng__shift_y(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=336;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set_rutherford_rng__shift_y(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=336;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp_rutherford_rng__shift_y(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=336;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCollimatorData_get_rutherford_rng__shift_s(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=344;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCollimatorData_set_rutherford_rng__shift_s(EverestCollimatorData restrict  obj, double value){
  int64_t offset=0;
  offset+=344;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCollimatorData_getp_rutherford_rng__shift_s(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=344;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t EverestCollimatorData_get__tracking(const EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=352;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCollimatorData_set__tracking(EverestCollimatorData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=352;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCollimatorData_getp__tracking(EverestCollimatorData restrict  obj){
  int64_t offset=0;
  offset+=352;
  return ( int8_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
InteractionRecordData EverestCollimatorData_getp_internal_record(EverestCollimatorData el, LocalParticle* part){
    RecordIdentifier record_id = EverestCollimatorData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (InteractionRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_EVEREST_COLL_H
#define XCOLL_EVEREST_COLL_H
#include <math.h>
#include <stdio.h>


 static inline
int8_t EverestCollimatorData_get_record_impacts(EverestCollimatorData el){
    return EverestCollimatorData_get__record_interactions(el) % 2;
}

 static inline
int8_t EverestCollimatorData_get_record_exits(EverestCollimatorData el){
    return (EverestCollimatorData_get__record_interactions(el) >> 1) % 2;
}

 static inline
int8_t EverestCollimatorData_get_record_scatterings(EverestCollimatorData el){
    return (EverestCollimatorData_get__record_interactions(el) >> 2) % 2;
}

void EverestCollimator_set_material(EverestCollimatorData el){
    MaterialData material = EverestCollimatorData_getp__material(el);
    RandomRutherfordData rng = EverestCollimatorData_getp_rutherford_rng(el);
    RandomRutherford_set_by_xcoll_material(rng, (GeneralMaterialData) material);
}


 static inline
CollimatorGeometry EverestCollimator_init_geometry(EverestCollimatorData el, LocalParticle* part0, int8_t active){
    CollimatorGeometry cg = (CollimatorGeometry) malloc(sizeof(CollimatorGeometry_));
    if (active){ // This is needed in order to avoid that the initialisation is called during a twiss!
        // Jaw corners (with tilts)
        cg->jaw_LU = EverestCollimatorData_get__jaw_LU(el);
        cg->jaw_RU = EverestCollimatorData_get__jaw_RU(el);
        // Get angles of jaws
        cg->sin_zL = EverestCollimatorData_get__sin_zL(el);
        cg->cos_zL = EverestCollimatorData_get__cos_zL(el);
        cg->sin_zR = EverestCollimatorData_get__sin_zR(el);
        cg->cos_zR = EverestCollimatorData_get__cos_zR(el);
        cg->sin_zDiff = EverestCollimatorData_get__sin_zDiff(el);
        cg->cos_zDiff = EverestCollimatorData_get__cos_zDiff(el);
        cg->jaws_parallel = EverestCollimatorData_get__jaws_parallel(el);
        // Tilts
        cg->sin_yL = EverestCollimatorData_get__sin_yL(el);
        cg->cos_yL = EverestCollimatorData_get__cos_yL(el);
        cg->sin_yR = EverestCollimatorData_get__sin_yR(el);
        cg->cos_yR = EverestCollimatorData_get__cos_yR(el);
        // Length and segments
        cg->length = EverestCollimatorData_get_length(el);
        cg->side   = EverestCollimatorData_get__side(el);
        double s_U, s_D, x_D;
        if (cg->side != -1){
            s_U = cg->length/2 * (1-cg->cos_yL);
            s_D = cg->length/2 * (1+cg->cos_yL);
            x_D = EverestCollimatorData_get__jaw_LD(el);
            cg->segments_L = create_jaw(s_U, cg->jaw_LU, s_D, x_D, cg->sin_yL/cg->cos_yL, 1);
        }
        if (cg->side != 1){
            s_U = cg->length/2 * (1-cg->cos_yR);
            s_D = cg->length/2 * (1+cg->cos_yR);
            x_D = EverestCollimatorData_get__jaw_RD(el);
            cg->segments_R = create_jaw(s_U, cg->jaw_RU, s_D, x_D, cg->sin_yR/cg->cos_yR, -1);
        }
        // Impact table
        cg->record = EverestCollimatorData_getp_internal_record(el, part0);
        cg->record_index = NULL;
        cg->record_impacts = 0;
        cg->record_exits = 0;
        if (cg->record){
            cg->record_index = InteractionRecordData_getp__index(cg->record);
            cg->record_impacts = EverestCollimatorData_get_record_impacts(el);
            cg->record_exits = EverestCollimatorData_get_record_exits(el);
        }
    }

    return cg;
}

 static inline
void EverestCollimator_free(CollimatorGeometry restrict cg, int8_t active){
    if (active){
        if (cg->side != -1){
            destroy_jaw(cg->segments_L);
        }
        if (cg->side != 1){
            destroy_jaw(cg->segments_R);
        }
    }
    free(cg);
}


// TODO: it would be great if we could set EverestData as an xofield, because then we could
// run this function at creation of the collimator instead of every turn
// Hmmmm this should be called whenever we change an xofield
 static inline
EverestCollData EverestCollimator_init(EverestCollimatorData el, LocalParticle* part0, int8_t active){
    EverestCollData coll = (EverestCollData) malloc(sizeof(EverestCollData_));
    if (active){ // This is needed in order to avoid that the initialisation is called during a twiss!
        // Random generator and material
        coll->rng = EverestCollimatorData_getp_rutherford_rng(el);
        MaterialData material = EverestCollimatorData_getp__material(el);
        coll->exenergy = MaterialData_get_excitation_energy(material)*1.0e3; // MeV
        coll->rho      = MaterialData_get_density(material);
        coll->anuc     = MaterialData_get_A(material);
        coll->zatom    = MaterialData_get_Z(material);
        coll->bnref    = MaterialData_get_nuclear_elastic_slope(material);
        coll->radl     = MaterialData_get_radiation_length(material);
        coll->csref[0] = MaterialData_get_cross_section(material, 0);
        coll->csref[1] = MaterialData_get_cross_section(material, 1);
        coll->csref[5] = MaterialData_get_cross_section(material, 5);
        coll->only_mcs = MaterialData_get__only_mcs(material);
        // Impact table:  need it here to record interactions
        coll->record = EverestCollimatorData_getp_internal_record(el, part0);
        coll->record_index = NULL;
        coll->record_scatterings = 0;
        if (coll->record){
            coll->record_index = InteractionRecordData_getp__index(coll->record);
            coll->record_scatterings = EverestCollimatorData_get_record_scatterings(el);
        }
    }
    return coll;
}


 static inline
EverestData EverestCollimator_init_data(LocalParticle* part, EverestCollData coll){
    EverestData everest = (EverestData) malloc(sizeof(EverestData_));
    everest->coll = coll;
    everest->rescale_scattering = 1;
    // Preinitialise scattering parameters
    double energy = LocalParticle_get_energy(part) / 1e9; // energy in GeV
    calculate_scattering(everest, energy);
    calculate_ionisation_properties(everest, energy);
    return everest;
}


 static inline
void EverestCollimator_track_local_particle(EverestCollimatorData el, LocalParticle* part0) {
    int8_t active = EverestCollimatorData_get_active(el);
    active       *= EverestCollimatorData_get__tracking(el);
    double const length = EverestCollimatorData_get_length(el);

    // Initialise collimator data
    // TODO: we want this to happen before tracking (instead of every turn), as a separate kernel
    EverestCollData coll  = EverestCollimator_init(el, part0, active);
    CollimatorGeometry cg = EverestCollimator_init_geometry(el, part0, active);


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

        if (!active){
            // Drift full length
            Drift_single_particle(part, length);

        } else {
            // Check collimator initialisation
            int8_t is_valid = xcoll_check_particle_init(coll->rng, part);

            if (is_valid) {
                // Store s-location of start of collimator
                double const s_coll = LocalParticle_get_s(part);
                LocalParticle_set_s(part, 0);

                // Store initial coordinates for updating later
                double const rvv_in     = LocalParticle_get_rvv(part);
#ifdef XCOLL_USE_EXACT
                double const xp_in      = LocalParticle_get_exact_xp(part);
                double const yp_in      = LocalParticle_get_exact_yp(part);
#else
                double const xp_in      = LocalParticle_get_xp(part);
                double const yp_in      = LocalParticle_get_yp(part);
#endif
                double const zeta_in    = LocalParticle_get_zeta(part);
                double const energy_in  = LocalParticle_get_energy(part);
                double energy_out;

                // Check if hit on jaws
                int8_t is_hit = hit_jaws_check_and_transform(part, cg);

                if (is_hit != 0) {
                    // Hit one of the jaws, so scatter
                    double remaining_length = length - LocalParticle_get_s(part);
                    // Scatter
                    EverestData everest = EverestCollimator_init_data(part, coll);
                    energy_out = jaw(everest, part, energy_in, remaining_length, 1);
                    free(everest);
                }

                // Transform back to the lab frame
                hit_jaws_transform_back(is_hit, part, cg);
                LocalParticle_add_to_s(part, s_coll);

                LocalParticle_set_zeta(part, zeta_in);
                // Hit and survived particles need correcting:
                if (is_hit!=0 && LocalParticle_get_state(part)>0){
                    // Update energy; the last flag keeps angles constant (even valid for exact angles!)
                    LocalParticle_add_to_energy(part, energy_out - energy_in, 0);
                    // Update zeta
#ifdef XCOLL_USE_EXACT
                    double xp  = LocalParticle_get_exact_xp(part);
                    double yp  = LocalParticle_get_exact_yp(part);
#else
                    double xp  = LocalParticle_get_xp(part);
                    double yp  = LocalParticle_get_yp(part);
#endif
                    double rvv = LocalParticle_get_rvv(part);
                    // First we drift half the length with the old angles:
                    LocalParticle_add_to_zeta(part, drift_zeta_single(rvv_in, xp_in, yp_in, length/2) );
                    // then half the length with the new angles:
                    LocalParticle_add_to_zeta(part, drift_zeta_single(rvv, xp, yp, length/2) );
                }
            }
        }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    EverestCollimator_free(cg, active);
    free(coll);
}


#endif /* XCOLL_EVEREST_COLL_H */

             static inline
            void EverestCollimator_track_local_particle_with_transformations(EverestCollimatorData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = EverestCollimatorData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = EverestCollimatorData_get__cos_rot_s(el);
    double const shift_x = EverestCollimatorData_get__shift_x(el);
    double const shift_y = EverestCollimatorData_get__shift_y(el);
    double const shift_s = EverestCollimatorData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    EverestCollimator_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = EverestCollimatorData_get__cos_rot_s(el);
    double const shift_x = EverestCollimatorData_get__shift_x(el);
    double const shift_y = EverestCollimatorData_get__shift_y(el);
    double const shift_s = EverestCollimatorData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void EverestCollimator_track_particles(
               EverestCollimatorData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              EverestCollimator_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_BaseCrystalData
#define XOBJ_TYPEDEF_BaseCrystalData
typedef   struct BaseCrystalData_s * BaseCrystalData;
 static inline BaseCrystalData BaseCrystalData_getp(BaseCrystalData restrict  obj){
  int64_t offset=0;
  return (BaseCrystalData)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get_length(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set_length(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp_length(BaseCrystalData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t BaseCrystalData_get_active(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *(( int8_t*) obj+offset);
}
 static inline void BaseCrystalData_set_active(BaseCrystalData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=8;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BaseCrystalData_getp_active(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline int8_t BaseCrystalData_get__record_interactions(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *(( int8_t*) obj+offset);
}
 static inline void BaseCrystalData_set__record_interactions(BaseCrystalData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=16;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BaseCrystalData_getp__record_interactions(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__sin_rot_s(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__sin_rot_s(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__sin_rot_s(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__cos_rot_s(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__cos_rot_s(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__cos_rot_s(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__shift_x(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__shift_x(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__shift_x(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__shift_y(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__shift_y(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__shift_y(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__shift_s(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__shift_s(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__shift_s(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier BaseCrystalData_getp__internal_record_id(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t BaseCrystalData_get__internal_record_id_buffer_id(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__internal_record_id_buffer_id(BaseCrystalData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BaseCrystalData_getp__internal_record_id_buffer_id(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BaseCrystalData_get__internal_record_id_offset(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__internal_record_id_offset(BaseCrystalData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BaseCrystalData_getp__internal_record_id_offset(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__sin_z(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__sin_z(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__sin_z(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__cos_z(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__cos_z(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__cos_z(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__jaw_U(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__jaw_U(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__jaw_U(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__sin_y(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__sin_y(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__sin_y(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__cos_y(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__cos_y(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__cos_y(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__tan_y(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__tan_y(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__tan_y(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t BaseCrystalData_get__side(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *(( int8_t*) obj+offset);
}
 static inline void BaseCrystalData_set__side(BaseCrystalData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=128;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BaseCrystalData_getp__side(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline int8_t BaseCrystalData_get__align(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *(( int8_t*) obj+offset);
}
 static inline void BaseCrystalData_set__align(BaseCrystalData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=136;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* BaseCrystalData_getp__align(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__gap(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__gap(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__gap(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__nemitt_x(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__nemitt_x(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__nemitt_x(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__nemitt_y(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__nemitt_y(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__nemitt_y(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__bending_radius(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__bending_radius(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__bending_radius(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get__bending_angle(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set__bending_angle(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=176;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp__bending_angle(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get_width(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set_width(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=184;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp_width(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return ( double*)(( char*) obj+offset);
}
 static inline double BaseCrystalData_get_height(const BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void BaseCrystalData_set_height(BaseCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BaseCrystalData_getp_height(BaseCrystalData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
InteractionRecordData BaseCrystalData_getp_internal_record(BaseCrystalData el, LocalParticle* part){
    RecordIdentifier record_id = BaseCrystalData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (InteractionRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#ifndef XOBJ_TYPEDEF_EverestCrystalData
#define XOBJ_TYPEDEF_EverestCrystalData
typedef   struct EverestCrystalData_s * EverestCrystalData;
 static inline EverestCrystalData EverestCrystalData_getp(EverestCrystalData restrict  obj){
  int64_t offset=0;
  return (EverestCrystalData)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get_length(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set_length(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp_length(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t EverestCrystalData_get_active(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCrystalData_set_active(EverestCrystalData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=16;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCrystalData_getp_active(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline int8_t EverestCrystalData_get__record_interactions(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCrystalData_set__record_interactions(EverestCrystalData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=24;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCrystalData_getp__record_interactions(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__sin_rot_s(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__sin_rot_s(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__sin_rot_s(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__cos_rot_s(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__cos_rot_s(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__cos_rot_s(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__shift_x(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__shift_x(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__shift_x(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__shift_y(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__shift_y(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__shift_y(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__shift_s(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__shift_s(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__shift_s(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier EverestCrystalData_getp__internal_record_id(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t EverestCrystalData_get__internal_record_id_buffer_id(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__internal_record_id_buffer_id(EverestCrystalData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* EverestCrystalData_getp__internal_record_id_buffer_id(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t EverestCrystalData_get__internal_record_id_offset(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__internal_record_id_offset(EverestCrystalData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* EverestCrystalData_getp__internal_record_id_offset(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__sin_z(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__sin_z(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__sin_z(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__cos_z(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__cos_z(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__cos_z(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__jaw_U(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__jaw_U(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__jaw_U(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__sin_y(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__sin_y(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__sin_y(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__cos_y(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__cos_y(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__cos_y(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__tan_y(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__tan_y(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__tan_y(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t EverestCrystalData_get__side(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCrystalData_set__side(EverestCrystalData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=136;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCrystalData_getp__side(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline int8_t EverestCrystalData_get__align(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCrystalData_set__align(EverestCrystalData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=144;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCrystalData_getp__align(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__gap(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__gap(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__gap(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__nemitt_x(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__nemitt_x(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__nemitt_x(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__nemitt_y(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__nemitt_y(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__nemitt_y(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__bending_radius(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__bending_radius(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=176;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__bending_radius(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__bending_angle(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__bending_angle(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=184;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__bending_angle(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get_width(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set_width(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp_width(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get_height(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set_height(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=200;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp_height(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get_miscut(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set_miscut(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp_miscut(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t EverestCrystalData_get__orient(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCrystalData_set__orient(EverestCrystalData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=216;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCrystalData_getp__orient(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__critical_angle(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__critical_angle(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__critical_angle(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__critical_radius(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__critical_radius(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__critical_radius(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline CrystalMaterialData EverestCrystalData_getp__material(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=328;
  return (CrystalMaterialData)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__material_Z(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=336;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__material_Z(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=336;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__material_Z(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=336;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__material_A(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=344;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__material_A(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=344;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__material_A(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=344;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__material_density(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=352;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__material_density(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=352;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__material_density(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=352;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__material_excitation_energy(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=360;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__material_excitation_energy(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=360;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__material_excitation_energy(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=360;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__material_nuclear_radius(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=368;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__material_nuclear_radius(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=368;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__material_nuclear_radius(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=368;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__material_nuclear_elastic_slope(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=376;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__material_nuclear_elastic_slope(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=376;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__material_nuclear_elastic_slope(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=376;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr6Float64 EverestCrystalData_getp__material_cross_section(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=384;
  return (Arr6Float64)(( char*) obj+offset);
}
 static inline int64_t EverestCrystalData_len__material_cross_section(EverestCrystalData restrict  obj){
  return 6;
}
 static inline double EverestCrystalData_get__material_cross_section(const EverestCrystalData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=384;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__material_cross_section(EverestCrystalData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=384;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp1__material_cross_section(EverestCrystalData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=384;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__material_hcut(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=432;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__material_hcut(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=432;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__material_hcut(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=432;
  return ( double*)(( char*) obj+offset);
}
 static inline  char* EverestCrystalData_getp__material_name(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=488;
  return ( char*)(( char*) obj+offset);
}
 static inline int8_t EverestCrystalData_get__material__only_mcs(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=440;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCrystalData_set__material__only_mcs(EverestCrystalData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=440;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCrystalData_getp__material__only_mcs(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=440;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__material_crystal_radiation_length(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=448;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__material_crystal_radiation_length(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=448;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__material_crystal_radiation_length(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=448;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__material_crystal_nuclear_length(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=456;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__material_crystal_nuclear_length(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=456;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__material_crystal_nuclear_length(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=456;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__material_crystal_plane_distance(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=464;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__material_crystal_plane_distance(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=464;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__material_crystal_plane_distance(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=464;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__material_crystal_potential(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=472;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__material_crystal_potential(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=472;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__material_crystal_potential(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=472;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get__material_nuclear_collision_length(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=480;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set__material_nuclear_collision_length(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=480;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp__material_nuclear_collision_length(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=480;
  return ( double*)(( char*) obj+offset);
}
 static inline RandomRutherfordData EverestCrystalData_getp_rutherford_rng(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return (RandomRutherfordData)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get_rutherford_rng_lower_val(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set_rutherford_rng_lower_val(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp_rutherford_rng_lower_val(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get_rutherford_rng_upper_val(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set_rutherford_rng_upper_val(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp_rutherford_rng_upper_val(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get_rutherford_rng_A(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set_rutherford_rng_A(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=256;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp_rutherford_rng_A(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get_rutherford_rng_B(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set_rutherford_rng_B(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=264;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp_rutherford_rng_B(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t EverestCrystalData_get_rutherford_rng_Newton_iterations(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCrystalData_set_rutherford_rng_Newton_iterations(EverestCrystalData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=272;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCrystalData_getp_rutherford_rng_Newton_iterations(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return ( int8_t*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get_rutherford_rng__sin_rot_s(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set_rutherford_rng__sin_rot_s(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=280;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp_rutherford_rng__sin_rot_s(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get_rutherford_rng__cos_rot_s(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=288;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set_rutherford_rng__cos_rot_s(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=288;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp_rutherford_rng__cos_rot_s(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=288;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get_rutherford_rng__shift_x(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=296;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set_rutherford_rng__shift_x(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=296;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp_rutherford_rng__shift_x(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=296;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get_rutherford_rng__shift_y(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=304;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set_rutherford_rng__shift_y(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=304;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp_rutherford_rng__shift_y(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=304;
  return ( double*)(( char*) obj+offset);
}
 static inline double EverestCrystalData_get_rutherford_rng__shift_s(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=312;
  return *( double*)(( char*) obj+offset);
}
 static inline void EverestCrystalData_set_rutherford_rng__shift_s(EverestCrystalData restrict  obj, double value){
  int64_t offset=0;
  offset+=312;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* EverestCrystalData_getp_rutherford_rng__shift_s(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=312;
  return ( double*)(( char*) obj+offset);
}
 static inline int8_t EverestCrystalData_get__tracking(const EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=320;
  return *(( int8_t*) obj+offset);
}
 static inline void EverestCrystalData_set__tracking(EverestCrystalData restrict  obj, int8_t value){
  int64_t offset=0;
  offset+=320;
  *(( int8_t*) obj+offset)=value;
}
 static inline  int8_t* EverestCrystalData_getp__tracking(EverestCrystalData restrict  obj){
  int64_t offset=0;
  offset+=320;
  return ( int8_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
InteractionRecordData EverestCrystalData_getp_internal_record(EverestCrystalData el, LocalParticle* part){
    RecordIdentifier record_id = EverestCrystalData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (InteractionRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
// copyright ############################### #
// This file is part of the Xcoll package.   #
// Copyright (c) CERN, 2024.                 #
// ######################################### #

#ifndef XCOLL_EVEREST_CRYSTAL_H
#define XCOLL_EVEREST_CRYSTAL_H
#include <math.h>
#include <stdio.h>


 static inline
int8_t EverestCrystalData_get_record_impacts(EverestCrystalData el){
    return EverestCrystalData_get__record_interactions(el) % 2;
}

 static inline
int8_t EverestCrystalData_get_record_exits(EverestCrystalData el){
    return (EverestCrystalData_get__record_interactions(el) >> 1) % 2;
}

 static inline
int8_t EverestCrystalData_get_record_scatterings(EverestCrystalData el){
    return (EverestCrystalData_get__record_interactions(el) >> 2) % 2;
}


void EverestCrystal_set_material(EverestCrystalData el){
    CrystalMaterialData material = EverestCrystalData_getp__material(el);
    RandomRutherfordData rng = EverestCrystalData_getp_rutherford_rng(el);
    RandomRutherford_set_by_xcoll_material(rng, (GeneralMaterialData) material);
}


 static inline
CrystalGeometry EverestCrystal_init_geometry(EverestCrystalData el, LocalParticle* part0, int8_t active){
    CrystalGeometry cg = (CrystalGeometry) malloc(sizeof(CrystalGeometry_));
    if (active){ // This is needed in order to avoid that the initialisation is called during a twiss!
        cg->length = EverestCrystalData_get_length(el);
        cg->side   = EverestCrystalData_get__side(el);
        if (cg->side == 0){
            kill_all_particles(part0, XC_ERR_INVALID_XOFIELD);
            return cg;
        }
        double R   = EverestCrystalData_get__bending_radius(el);
        double t_R = EverestCrystalData_get__bending_angle(el);
        cg->bending_radius = R;
        cg->bending_angle  = t_R;
        cg->miscut_angle   = EverestCrystalData_get_miscut(el);
        cg->width  = EverestCrystalData_get_width(el);
        cg->height = EverestCrystalData_get_height(el);
        cg->jaw_U  = EverestCrystalData_get__jaw_U(el);
        cg->sin_z  = EverestCrystalData_get__sin_z(el);
        cg->cos_z  = EverestCrystalData_get__cos_z(el);
        cg->sin_y  = EverestCrystalData_get__sin_y(el);
        cg->cos_y  = EverestCrystalData_get__cos_y(el);
        // Segments
        if (cg->side == 1){
            cg->segments = create_crystal(cg->bending_radius, cg->width, cg->length, cg->jaw_U, \
                                          cg->sin_y, cg->cos_y);
        } else if (cg->side == -1){
            // jaw_U is the inner corner (shifted if right-sided crystal)
            cg->segments = create_crystal(cg->bending_radius, cg->width, cg->length, cg->jaw_U - cg->width, \
                                          cg->sin_y, cg->cos_y);
        }
        // Bend centre
        cg->s_B = 0;
        cg->x_B = cg->bending_radius;
        // Miscut centre
        cg->s_P = -R*sin(cg->miscut_angle);
        cg->x_P = R*cos(cg->miscut_angle);
        if (cg->side == 1 && R < 0){
            // If R<0, a left-sided crystal bends towards the beam
            cg->x_P = cg->x_P + cg->width;
            cg->x_B = cg->x_B + cg->width;
        } else if (cg->side == -1 && R > 0){
            // If R>0, a right-sided crystal bends towards the beam
            cg->x_P = cg->x_P - cg->width;
            cg->x_B = cg->x_B - cg->width;
        }
        if (cg->side == -1){
            // Mirror the crystal geometry
            cg->bending_radius = -cg->bending_radius;
            cg->bending_angle  = -cg->bending_angle;
            cg->miscut_angle   = -cg->miscut_angle;
            cg->x_P            = -cg->x_P;
            cg->x_B            = -cg->x_B;
        }
        // From here on, crystal geometry parameters can always be treated as left-sided.
        // Note that the segments are not mirrored, which is fine as get_s_of_first_crossing_with_vlimit
        // is absolute (not in the jaw reference frame). It is only after a hit is registered, that we
        // need to transform the particle to the jaw reference frame.
        double Rb;
        if (cg->miscut_angle > 0){
            Rb = R - cg->width;
        } else {
            Rb = R;
        }
        cg->t_VImax = atan( (Rb*sin(t_R) - cg->s_P) / (R - Rb*cos(t_R) - cg->x_P) );
        // Impact table
        cg->record = EverestCrystalData_getp_internal_record(el, part0);
        cg->record_index = NULL;
        cg->record_impacts = 0;
        cg->record_exits = 0;
        if (cg->record){
            cg->record_index = InteractionRecordData_getp__index(cg->record);
            cg->record_impacts = EverestCrystalData_get_record_impacts(el);
            cg->record_exits = EverestCrystalData_get_record_exits(el);
        }
    }

    return cg;
}

 static inline
void EverestCrystal_free(CrystalGeometry restrict cg, int8_t active){
    if (active){
        destroy_crystal(cg->segments);
    }
    free(cg);
}


// TODO: it would be great if we could set EverestData as an xofield, because then we could
// run this function at creation of the collimator instead of every turn
 static inline
EverestCollData EverestCrystal_init(EverestCrystalData el, LocalParticle* part0, int8_t active){
    EverestCollData coll = (EverestCollData) malloc(sizeof(EverestCollData_));
    if (active){ // This is needed in order to avoid that the initialisation is called during a twiss!
        // Random generator and material
        coll->rng = EverestCrystalData_getp_rutherford_rng(el);
        CrystalMaterialData material = EverestCrystalData_getp__material(el);
        coll->exenergy = CrystalMaterialData_get_excitation_energy(material)*1.0e3; // MeV
        coll->rho      = CrystalMaterialData_get_density(material);
        coll->anuc     = CrystalMaterialData_get_A(material);
        coll->zatom    = CrystalMaterialData_get_Z(material);
        coll->bnref    = CrystalMaterialData_get_nuclear_elastic_slope(material);
        coll->csref[0] = CrystalMaterialData_get_cross_section(material, 0);
        coll->csref[1] = CrystalMaterialData_get_cross_section(material, 1);
        coll->csref[5] = CrystalMaterialData_get_cross_section(material, 5);
        coll->only_mcs = CrystalMaterialData_get__only_mcs(material);
        coll->dlri     = CrystalMaterialData_get_crystal_radiation_length(material);
        coll->dlyi     = CrystalMaterialData_get_crystal_nuclear_length(material);
        coll->ai       = CrystalMaterialData_get_crystal_plane_distance(material);
        coll->eum      = CrystalMaterialData_get_crystal_potential(material);
        coll->collnt   = CrystalMaterialData_get_nuclear_collision_length(material);
        coll->eta      = 0.9;  // Hard-coded channeling saturation factor
        coll->orient   = EverestCrystalData_get__orient(el);
        // Impact table
        coll->record = EverestCrystalData_getp_internal_record(el, part0);
        coll->record_index = NULL;
        if (coll->record){
            coll->record_index = InteractionRecordData_getp__index(coll->record);
            coll->record_scatterings = EverestCrystalData_get_record_scatterings(el);
        }
    }
    return coll;
}


 static inline
EverestData EverestCrystal_init_data(LocalParticle* part, EverestCollData restrict coll, CrystalGeometry restrict cg){
    EverestData everest = (EverestData) malloc(sizeof(EverestData_));
    everest->coll = coll;
    everest->rescale_scattering = 1;
    // Preinitialise scattering parameters
    double energy = LocalParticle_get_energy(part) / 1e9; // energy in GeV
    calculate_scattering(everest, energy);
    calculate_ionisation_properties(everest, energy);
    calculate_critical_angle(everest, part, cg, energy);
    calculate_VI_parameters(everest, part, energy);
    return everest;
}


 static inline
void EverestCrystal_track_local_particle(EverestCrystalData el, LocalParticle* part0) {
    int8_t active = EverestCrystalData_get_active(el);
    active       *= EverestCrystalData_get__tracking(el);
    double length = EverestCrystalData_get_length(el);

    // Initialise collimator data
    // TODO: we want this to happen before tracking (instead of every turn), as a separate kernel
    EverestCollData coll = EverestCrystal_init(el, part0, active);
    CrystalGeometry cg   = EverestCrystal_init_geometry(el, part0, active);

    // For info
    double const e0 = LocalParticle_get_energy0(part0);
    double t_c0  = _critical_angle0(coll, e0);
    double Rcrit = _critical_radius(coll, e0);
    double t_c = _critical_angle(coll, t_c0, Rcrit / fabs(cg->bending_radius));
    EverestCrystalData_set__critical_radius(el, Rcrit);
    EverestCrystalData_set__critical_angle(el, t_c);


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

        if (!active){
            // Drift full length
            Drift_single_particle(part, length);

        } else {
            // Check collimator initialisation
            int8_t is_valid = xcoll_check_particle_init(coll->rng, part);

            if (is_valid) {
                // Store s-location of start of crystal
                double const s_coll = LocalParticle_get_s(part);
                LocalParticle_set_s(part, 0);

                // Store initial coordinates for updating later
                double const rvv_in     = LocalParticle_get_rvv(part);
#ifdef XCOLL_USE_EXACT
                double const xp_in      = LocalParticle_get_exact_xp(part);
                double const yp_in      = LocalParticle_get_exact_yp(part);
#else
                double const xp_in      = LocalParticle_get_xp(part);
                double const yp_in      = LocalParticle_get_yp(part);
#endif
                double const zeta_in    = LocalParticle_get_zeta(part);
                double const energy_in  = LocalParticle_get_energy(part);
                double energy_out;

                // Check if hit on jaws
                int8_t is_hit = hit_crystal_check_and_transform(part, cg);

                if (is_hit != 0) {
                    // Hit one of the jaws, so scatter
                    double remaining_length = length - LocalParticle_get_s(part);
                    // Scatter
                    EverestData everest = EverestCrystal_init_data(part, coll, cg);
                    calculate_initial_angle(everest, part, cg);
#ifdef XCOLL_USE_EXACT
                    double const xp = LocalParticle_get_exact_xp(part);
#else
                    double const xp = LocalParticle_get_xp(part);
#endif
                    if (fabs(xp - everest->t_I) < everest->t_c) {
                        energy_out = Channel(everest, part, cg, energy_in/1.e9, remaining_length)*1.e9;
                    } else {
                        energy_out = Amorphous(everest, part, cg, energy_in/1.e9, remaining_length, 1)*1.e9;
                    }
                    free(everest);
                }

                // Transform back to the lab frame
                hit_crystal_transform_back(is_hit, part, cg);
                LocalParticle_add_to_s(part, s_coll);

                LocalParticle_set_zeta(part, zeta_in);
                // Hit and survived particles need correcting:
                if (is_hit!=0 && LocalParticle_get_state(part)>0){
                    // Update energy; the last flag keeps angles constant (even valid for exact angles!)
                    LocalParticle_add_to_energy(part, energy_out - energy_in, 0);
                    // Update zeta
#ifdef XCOLL_USE_EXACT
                    double xp  = LocalParticle_get_exact_xp(part);
                    double yp  = LocalParticle_get_exact_yp(part);
#else
                    double xp  = LocalParticle_get_xp(part);
                    double yp  = LocalParticle_get_yp(part);
#endif
                    double rvv = LocalParticle_get_rvv(part);
                    // First we drift half the length with the old angles:
                    LocalParticle_add_to_zeta(part, drift_zeta_single(rvv_in, xp_in, yp_in, length/2) );
                    // then half the length with the new angles:
                    LocalParticle_add_to_zeta(part, drift_zeta_single(rvv, xp, yp, length/2) );
                }
            }
        }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    EverestCrystal_free(cg, active);
    free(coll);
}


#endif /* XCOLL_EVEREST_CRYSTAL_H */

             static inline
            void EverestCrystal_track_local_particle_with_transformations(EverestCrystalData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = EverestCrystalData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = EverestCrystalData_get__cos_rot_s(el);
    double const shift_x = EverestCrystalData_get__shift_x(el);
    double const shift_y = EverestCrystalData_get__shift_y(el);
    double const shift_s = EverestCrystalData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    EverestCrystal_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = EverestCrystalData_get__cos_rot_s(el);
    double const shift_x = EverestCrystalData_get__shift_x(el);
    double const shift_y = EverestCrystalData_get__shift_y(el);
    double const shift_s = EverestCrystalData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void EverestCrystal_track_particles(
               EverestCrystalData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              EverestCrystal_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ElementRefClass
#define XOBJ_TYPEDEF_ElementRefClass
typedef   struct ElementRefClass_s * ElementRefClass;
enum ElementRefClass_e{ElementRefClass_BeamBeamBiGaussian2DData_t,ElementRefClass_BeamBeamBiGaussian3DData_t,ElementRefClass_BeamPositionMonitorData_t,ElementRefClass_BeamProfileMonitorData_t,ElementRefClass_BeamSizeMonitorData_t,ElementRefClass_BendData_t,ElementRefClass_BlackAbsorberData_t,ElementRefClass_BlowUpData_t,ElementRefClass_CavityData_t,ElementRefClass_DipoleEdgeData_t,ElementRefClass_DriftData_t,ElementRefClass_DriftSliceData_t,ElementRefClass_DriftSliceBendData_t,ElementRefClass_DriftSliceOctupoleData_t,ElementRefClass_DriftSliceQuadrupoleData_t,ElementRefClass_DriftSliceRBendData_t,ElementRefClass_DriftSliceSextupoleData_t,ElementRefClass_ElensData_t,ElementRefClass_EmittanceMonitorData_t,ElementRefClass_EverestBlockData_t,ElementRefClass_EverestCollimatorData_t,ElementRefClass_EverestCrystalData_t,ElementRefClass_ExciterData_t,ElementRefClass_FirstOrderTaylorMapData_t,ElementRefClass_LastTurnsMonitorData_t,ElementRefClass_LimitEllipseData_t,ElementRefClass_LimitPolygonData_t,ElementRefClass_LimitRacetrackData_t,ElementRefClass_LimitRectData_t,ElementRefClass_LimitRectEllipseData_t,ElementRefClass_LineSegmentMapData_t,ElementRefClass_LongitudinalLimitRectData_t,ElementRefClass_MagnetData_t,ElementRefClass_MarkerData_t,ElementRefClass_MultipoleData_t,ElementRefClass_MultipoleEdgeData_t,ElementRefClass_NonLinearLensData_t,ElementRefClass_OctupoleData_t,ElementRefClass_ParticlesMonitorData_t,ElementRefClass_QuadrupoleData_t,ElementRefClass_RBendData_t,ElementRefClass_RFMultipoleData_t,ElementRefClass_ReferenceEnergyIncreaseData_t,ElementRefClass_SRotationData_t,ElementRefClass_SecondOrderTaylorMapData_t,ElementRefClass_SextupoleData_t,ElementRefClass_SimpleThinBendData_t,ElementRefClass_SimpleThinQuadrupoleData_t,ElementRefClass_SolenoidData_t,ElementRefClass_SpaceChargeBiGaussianData_t,ElementRefClass_ThickSliceBendData_t,ElementRefClass_ThickSliceOctupoleData_t,ElementRefClass_ThickSliceQuadrupoleData_t,ElementRefClass_ThickSliceRBendData_t,ElementRefClass_ThickSliceSextupoleData_t,ElementRefClass_ThickSliceSolenoidData_t,ElementRefClass_ThinSliceBendData_t,ElementRefClass_ThinSliceBendEntryData_t,ElementRefClass_ThinSliceBendExitData_t,ElementRefClass_ThinSliceOctupoleData_t,ElementRefClass_ThinSliceOctupoleEntryData_t,ElementRefClass_ThinSliceOctupoleExitData_t,ElementRefClass_ThinSliceQuadrupoleData_t,ElementRefClass_ThinSliceQuadrupoleEntryData_t,ElementRefClass_ThinSliceQuadrupoleExitData_t,ElementRefClass_ThinSliceRBendData_t,ElementRefClass_ThinSliceRBendEntryData_t,ElementRefClass_ThinSliceRBendExitData_t,ElementRefClass_ThinSliceSextupoleData_t,ElementRefClass_ThinSliceSextupoleEntryData_t,ElementRefClass_ThinSliceSextupoleExitData_t,ElementRefClass_WireData_t,ElementRefClass_XRotationData_t,ElementRefClass_XYShiftData_t,ElementRefClass_YRotationData_t,ElementRefClass_ZetaShiftData_t};
 static inline ElementRefClass ElementRefClass_getp(ElementRefClass restrict  obj){
  int64_t offset=0;
  return (ElementRefClass)(( char*) obj+offset);
}
 static inline int64_t ElementRefClass_typeid(const ElementRefClass restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline  void* ElementRefClass_member(const ElementRefClass restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
 return ( void*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_ArrNElementRefClass
#define XOBJ_TYPEDEF_ArrNElementRefClass
typedef   struct ArrNElementRefClass_s * ArrNElementRefClass;
 static inline ArrNElementRefClass ArrNElementRefClass_getp(ArrNElementRefClass restrict  obj){
  int64_t offset=0;
  return (ArrNElementRefClass)(( char*) obj+offset);
}
 static inline int64_t ArrNElementRefClass_len(ArrNElementRefClass restrict  obj){
  int64_t offset=0;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline ElementRefClass ArrNElementRefClass_getp1(ArrNElementRefClass restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*16;
  return (ElementRefClass)(( char*) obj+offset);
}
 static inline int64_t ArrNElementRefClass_typeid(const ArrNElementRefClass restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*16;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline  void* ArrNElementRefClass_member(const ArrNElementRefClass restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*16;
  offset+=*( int64_t*)(( char*) obj+offset);
 return ( void*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_ElementRefData
#define XOBJ_TYPEDEF_ElementRefData
typedef   struct ElementRefData_s * ElementRefData;
 static inline ElementRefData ElementRefData_getp(ElementRefData restrict  obj){
  int64_t offset=0;
  return (ElementRefData)(( char*) obj+offset);
}
 static inline ArrNElementRefClass ElementRefData_getp_elements(ElementRefData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return (ArrNElementRefClass)(( char*) obj+offset);
}
 static inline int64_t ElementRefData_len_elements(ElementRefData restrict  obj){
  int64_t offset=0;
  offset+=16;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline ElementRefClass ElementRefData_getp1_elements(ElementRefData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16;
  offset+=16+i0*16;
  return (ElementRefClass)(( char*) obj+offset);
}
 static inline int64_t ElementRefData_typeid_elements(const ElementRefData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16;
  offset+=16+i0*16;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline  void* ElementRefData_member_elements(const ElementRefData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16;
  offset+=16+i0*16;
  offset+=*( int64_t*)(( char*) obj+offset);
 return ( void*)(( char*) obj+offset);
}
 static inline ArrNString ElementRefData_getp_names(ElementRefData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNString)(( char*) obj+offset);
}
 static inline int64_t ElementRefData_len_names(ElementRefData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline  char* ElementRefData_getp1_names(ElementRefData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset=*( int64_t*)(( char*) obj+offset+16+i0*8);
  return ( char*)(( char*) obj+offset);
}
#endif

             
            void track_line(
                  int8_t* buffer,
                             ElementRefData elem_ref_data,
                             ParticlesData particles,
                             int num_turns,
                             int ele_start,
                             int num_ele_track,
                             int flag_end_turn_actions,
                             int flag_reset_s_at_end_turn,
                             int flag_monitor,
                             int num_ele_line,
                             double line_length,
                  int8_t* buffer_tbt_monitor,
                             int64_t offset_tbt_monitor,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);
                    
                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif
                
                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP
            
//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int chunk = 0; chunk < num_threads; chunk++) {                                //only_for_context cpu_openmp
//            int64_t part_id = chunk * chunk_size;                                              //only_for_context cpu_openmp
//            int64_t end_id = (chunk + 1) * chunk_size;                                         //only_for_context cpu_openmp
//            if (end_id > num_particles_to_track) end_id = num_particles_to_track;              //only_for_context cpu_openmp

            int64_t part_id = 0;                                      //only_for_context cpu_serial
//            int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x;  //only_for_context cuda
//            int64_t part_id = get_global_id(0);                       //only_for_context opencl
            int64_t end_id = 0; // unused outside of openmp           //only_for_context cpu_serial cuda opencl

            LocalParticle lpart;
            lpart.io_buffer = io_buffer;

              int8_t* tbt_mon_pointer =
                            buffer_tbt_monitor + offset_tbt_monitor;
            ParticlesMonitorData tbt_monitor =
                            (ParticlesMonitorData) tbt_mon_pointer;

            int64_t part_capacity = ParticlesData_get__capacity(particles);
            if (part_id<part_capacity){
            Particles_to_LocalParticle(particles, &lpart, part_id, end_id);

            int64_t isactive = check_is_active(&lpart);

            for (int64_t iturn=0; iturn<num_turns; iturn++){

                if (!isactive){
                    break;
                }

                int64_t const ele_stop = ele_start + num_ele_track;

                #if defined(XSUITE_BACKTRACK) || defined(XSUITE_MIRROR)
                int64_t elem_idx = ele_stop - 1;
                int64_t const increm = -1;
                if (flag_end_turn_actions>0){
                    increment_at_turn_backtrack(&lpart, flag_reset_s_at_end_turn,
                                                line_length, num_ele_line);
                }
                #else
                if (flag_monitor==1){
                    ParticlesMonitor_track_local_particle(tbt_monitor, &lpart);
                }
                int64_t elem_idx = ele_start;
                int64_t const increm = 1;
                #endif

                for (; ((elem_idx >= ele_start) && (elem_idx < ele_stop)); elem_idx+=increm){
                        if (flag_monitor==2){
                            ParticlesMonitor_track_local_particle(tbt_monitor, &lpart);
                        }

                        // Get the pointer to and the type id of the `elem_idx`th
                        // element in `element_ref_data.elements`:
                          void* el = ElementRefData_member_elements(elem_ref_data, elem_idx);
                        int64_t elem_type = ElementRefData_typeid_elements(elem_ref_data, elem_idx);

                        switch(elem_type){
        

                        case 0:


                            BeamBeamBiGaussian2D_track_local_particle_with_transformations((BeamBeamBiGaussian2DData) el, &lpart);
                            break;

                        case 1:


                            BeamBeamBiGaussian3D_track_local_particle_with_transformations((BeamBeamBiGaussian3DData) el, &lpart);
                            break;

                        case 2:


                            BeamPositionMonitor_track_local_particle_with_transformations((BeamPositionMonitorData) el, &lpart);
                            break;

                        case 3:


                            BeamProfileMonitor_track_local_particle_with_transformations((BeamProfileMonitorData) el, &lpart);
                            break;

                        case 4:


                            BeamSizeMonitor_track_local_particle_with_transformations((BeamSizeMonitorData) el, &lpart);
                            break;

                        case 5:


                            Bend_track_local_particle_with_transformations((BendData) el, &lpart);
                            break;

                        case 6:


                            BlackAbsorber_track_local_particle_with_transformations((BlackAbsorberData) el, &lpart);
                            break;

                        case 7:


                            BlowUp_track_local_particle_with_transformations((BlowUpData) el, &lpart);
                            break;

                        case 8:


                            Cavity_track_local_particle_with_transformations((CavityData) el, &lpart);
                            break;

                        case 9:


                            DipoleEdge_track_local_particle_with_transformations((DipoleEdgeData) el, &lpart);
                            break;

                        case 10:


                            #ifdef XTRACK_GLOBAL_XY_LIMIT
                            global_aperture_check(&lpart);
                            #endif

                            

                            Drift_track_local_particle_with_transformations((DriftData) el, &lpart);
                            break;

                        case 11:


                            DriftSlice_track_local_particle_with_transformations((DriftSliceData) el, &lpart);
                            break;

                        case 12:


                            DriftSliceBend_track_local_particle_with_transformations((DriftSliceBendData) el, &lpart);
                            break;

                        case 13:


                            DriftSliceOctupole_track_local_particle_with_transformations((DriftSliceOctupoleData) el, &lpart);
                            break;

                        case 14:


                            DriftSliceQuadrupole_track_local_particle_with_transformations((DriftSliceQuadrupoleData) el, &lpart);
                            break;

                        case 15:


                            DriftSliceRBend_track_local_particle_with_transformations((DriftSliceRBendData) el, &lpart);
                            break;

                        case 16:


                            DriftSliceSextupole_track_local_particle_with_transformations((DriftSliceSextupoleData) el, &lpart);
                            break;

                        case 17:


                            Elens_track_local_particle_with_transformations((ElensData) el, &lpart);
                            break;

                        case 18:


                            EmittanceMonitor_track_local_particle_with_transformations((EmittanceMonitorData) el, &lpart);
                            break;

                        case 19:


                            EverestBlock_track_local_particle_with_transformations((EverestBlockData) el, &lpart);
                            break;

                        case 20:


                            EverestCollimator_track_local_particle_with_transformations((EverestCollimatorData) el, &lpart);
                            break;

                        case 21:


                            EverestCrystal_track_local_particle_with_transformations((EverestCrystalData) el, &lpart);
                            break;

                        case 22:


                            Exciter_track_local_particle_with_transformations((ExciterData) el, &lpart);
                            break;

                        case 23:


                            FirstOrderTaylorMap_track_local_particle_with_transformations((FirstOrderTaylorMapData) el, &lpart);
                            break;

                        case 24:


                            LastTurnsMonitor_track_local_particle_with_transformations((LastTurnsMonitorData) el, &lpart);
                            break;

                        case 25:


                            LimitEllipse_track_local_particle_with_transformations((LimitEllipseData) el, &lpart);
                            break;

                        case 26:


                            LimitPolygon_track_local_particle_with_transformations((LimitPolygonData) el, &lpart);
                            break;

                        case 27:


                            LimitRacetrack_track_local_particle_with_transformations((LimitRacetrackData) el, &lpart);
                            break;

                        case 28:


                            LimitRect_track_local_particle_with_transformations((LimitRectData) el, &lpart);
                            break;

                        case 29:


                            LimitRectEllipse_track_local_particle_with_transformations((LimitRectEllipseData) el, &lpart);
                            break;

                        case 30:


                            LineSegmentMap_track_local_particle_with_transformations((LineSegmentMapData) el, &lpart);
                            break;

                        case 31:


                            LongitudinalLimitRect_track_local_particle_with_transformations((LongitudinalLimitRectData) el, &lpart);
                            break;

                        case 32:


                            Magnet_track_local_particle_with_transformations((MagnetData) el, &lpart);
                            break;

                        case 33:


                            Marker_track_local_particle_with_transformations((MarkerData) el, &lpart);
                            break;

                        case 34:


                            Multipole_track_local_particle_with_transformations((MultipoleData) el, &lpart);
                            break;

                        case 35:


                            MultipoleEdge_track_local_particle_with_transformations((MultipoleEdgeData) el, &lpart);
                            break;

                        case 36:


                            NonLinearLens_track_local_particle_with_transformations((NonLinearLensData) el, &lpart);
                            break;

                        case 37:


                            Octupole_track_local_particle_with_transformations((OctupoleData) el, &lpart);
                            break;

                        case 38:


                            ParticlesMonitor_track_local_particle_with_transformations((ParticlesMonitorData) el, &lpart);
                            break;

                        case 39:


                            Quadrupole_track_local_particle_with_transformations((QuadrupoleData) el, &lpart);
                            break;

                        case 40:


                            RBend_track_local_particle_with_transformations((RBendData) el, &lpart);
                            break;

                        case 41:


                            RFMultipole_track_local_particle_with_transformations((RFMultipoleData) el, &lpart);
                            break;

                        case 42:


                            ReferenceEnergyIncrease_track_local_particle_with_transformations((ReferenceEnergyIncreaseData) el, &lpart);
                            break;

                        case 43:


                            SRotation_track_local_particle_with_transformations((SRotationData) el, &lpart);
                            break;

                        case 44:


                            SecondOrderTaylorMap_track_local_particle_with_transformations((SecondOrderTaylorMapData) el, &lpart);
                            break;

                        case 45:


                            Sextupole_track_local_particle_with_transformations((SextupoleData) el, &lpart);
                            break;

                        case 46:


                            SimpleThinBend_track_local_particle_with_transformations((SimpleThinBendData) el, &lpart);
                            break;

                        case 47:


                            SimpleThinQuadrupole_track_local_particle_with_transformations((SimpleThinQuadrupoleData) el, &lpart);
                            break;

                        case 48:


                            Solenoid_track_local_particle_with_transformations((SolenoidData) el, &lpart);
                            break;

                        case 49:


                            SpaceChargeBiGaussian_track_local_particle_with_transformations((SpaceChargeBiGaussianData) el, &lpart);
                            break;

                        case 50:


                            ThickSliceBend_track_local_particle_with_transformations((ThickSliceBendData) el, &lpart);
                            break;

                        case 51:


                            ThickSliceOctupole_track_local_particle_with_transformations((ThickSliceOctupoleData) el, &lpart);
                            break;

                        case 52:


                            ThickSliceQuadrupole_track_local_particle_with_transformations((ThickSliceQuadrupoleData) el, &lpart);
                            break;

                        case 53:


                            ThickSliceRBend_track_local_particle_with_transformations((ThickSliceRBendData) el, &lpart);
                            break;

                        case 54:


                            ThickSliceSextupole_track_local_particle_with_transformations((ThickSliceSextupoleData) el, &lpart);
                            break;

                        case 55:


                            ThickSliceSolenoid_track_local_particle_with_transformations((ThickSliceSolenoidData) el, &lpart);
                            break;

                        case 56:


                            ThinSliceBend_track_local_particle_with_transformations((ThinSliceBendData) el, &lpart);
                            break;

                        case 57:


                            ThinSliceBendEntry_track_local_particle_with_transformations((ThinSliceBendEntryData) el, &lpart);
                            break;

                        case 58:


                            ThinSliceBendExit_track_local_particle_with_transformations((ThinSliceBendExitData) el, &lpart);
                            break;

                        case 59:


                            ThinSliceOctupole_track_local_particle_with_transformations((ThinSliceOctupoleData) el, &lpart);
                            break;

                        case 60:


                            ThinSliceOctupoleEntry_track_local_particle_with_transformations((ThinSliceOctupoleEntryData) el, &lpart);
                            break;

                        case 61:


                            ThinSliceOctupoleExit_track_local_particle_with_transformations((ThinSliceOctupoleExitData) el, &lpart);
                            break;

                        case 62:


                            ThinSliceQuadrupole_track_local_particle_with_transformations((ThinSliceQuadrupoleData) el, &lpart);
                            break;

                        case 63:


                            ThinSliceQuadrupoleEntry_track_local_particle_with_transformations((ThinSliceQuadrupoleEntryData) el, &lpart);
                            break;

                        case 64:


                            ThinSliceQuadrupoleExit_track_local_particle_with_transformations((ThinSliceQuadrupoleExitData) el, &lpart);
                            break;

                        case 65:


                            ThinSliceRBend_track_local_particle_with_transformations((ThinSliceRBendData) el, &lpart);
                            break;

                        case 66:


                            ThinSliceRBendEntry_track_local_particle_with_transformations((ThinSliceRBendEntryData) el, &lpart);
                            break;

                        case 67:


                            ThinSliceRBendExit_track_local_particle_with_transformations((ThinSliceRBendExitData) el, &lpart);
                            break;

                        case 68:


                            ThinSliceSextupole_track_local_particle_with_transformations((ThinSliceSextupoleData) el, &lpart);
                            break;

                        case 69:


                            ThinSliceSextupoleEntry_track_local_particle_with_transformations((ThinSliceSextupoleEntryData) el, &lpart);
                            break;

                        case 70:


                            ThinSliceSextupoleExit_track_local_particle_with_transformations((ThinSliceSextupoleExitData) el, &lpart);
                            break;

                        case 71:


                            Wire_track_local_particle_with_transformations((WireData) el, &lpart);
                            break;

                        case 72:


                            XRotation_track_local_particle_with_transformations((XRotationData) el, &lpart);
                            break;

                        case 73:


                            XYShift_track_local_particle_with_transformations((XYShiftData) el, &lpart);
                            break;

                        case 74:


                            YRotation_track_local_particle_with_transformations((YRotationData) el, &lpart);
                            break;

                        case 75:


                            ZetaShift_track_local_particle_with_transformations((ZetaShiftData) el, &lpart);
                            break;

                        } //switch

                    // Setting the below flag will break particle losses
                    #ifndef DANGER_SKIP_ACTIVE_CHECK_AND_SWAPS

                    isactive = check_is_active(&lpart);
                    if (!isactive){
                        break;
                    }

                    #if defined(XSUITE_BACKTRACK) || defined(XSUITE_MIRROR)
                        increment_at_element(&lpart, -1);
                    #else
                        increment_at_element(&lpart, 1);
                    #endif

                    #endif //DANGER_SKIP_ACTIVE_CHECK_AND_SWAPS

                } // for elements

                if (flag_monitor==2){
                    // End of turn (element-by-element mode)
                    ParticlesMonitor_track_local_particle(tbt_monitor, &lpart);
                }

                #if defined(XSUITE_BACKTRACK) || defined(XSUITE_MIRROR)
                if (flag_monitor==1){
                    ParticlesMonitor_track_local_particle(tbt_monitor, &lpart);
                }
                # else
                if (flag_end_turn_actions>0){
                    if (isactive){
                        increment_at_turn(&lpart, flag_reset_s_at_end_turn);
                    }
                }
                #endif

            } // for turns

            LocalParticle_to_Particles(&lpart, particles, part_id, 1);

            }// if partid
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            count_reorganized_particles(&lpart);                       //only_for_context cpu_openmp
//            LocalParticle_to_Particles(&lpart, particles, 0, capacity);//only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }//kernel
        