#include <stdint.h>
#define XFIELDS_BB3D_NO_BEAMSTR
#define XFIELDS_BB3D_NO_BHABHA
#define XTRACK_GLOBAL_XY_LIMIT 1.0
#define XTRACK_SYNRAD_KICK_SAME_AS_FIRST
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

#ifndef XOBJ_TYPEDEF_ArrNInt64
#define XOBJ_TYPEDEF_ArrNInt64
typedef   struct ArrNInt64_s * ArrNInt64;
 static inline ArrNInt64 ArrNInt64_getp(ArrNInt64 restrict  obj){
  int64_t offset=0;
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ArrNInt64_len(ArrNInt64 restrict  obj){
  int64_t offset=0;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ArrNInt64_get(const ArrNInt64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ArrNInt64_set(ArrNInt64 restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ArrNInt64_getp1(ArrNInt64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_ArrNFloat64
#define XOBJ_TYPEDEF_ArrNFloat64
typedef   struct ArrNFloat64_s * ArrNFloat64;
 static inline ArrNFloat64 ArrNFloat64_getp(ArrNFloat64 restrict  obj){
  int64_t offset=0;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ArrNFloat64_len(ArrNFloat64 restrict  obj){
  int64_t offset=0;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ArrNFloat64_get(const ArrNFloat64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ArrNFloat64_set(ArrNFloat64 restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ArrNFloat64_getp1(ArrNFloat64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_Arr6Float64
#define XOBJ_TYPEDEF_Arr6Float64
typedef   struct Arr6Float64_s * Arr6Float64;
 static inline Arr6Float64 Arr6Float64_getp(Arr6Float64 restrict  obj){
  int64_t offset=0;
  return (Arr6Float64)(( char*) obj+offset);
}
 static inline int64_t Arr6Float64_len(Arr6Float64 restrict  obj){
  return 6;
}
 static inline double Arr6Float64_get(const Arr6Float64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void Arr6Float64_set(Arr6Float64 restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* Arr6Float64_getp1(Arr6Float64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_Arr6x6Float64
#define XOBJ_TYPEDEF_Arr6x6Float64
typedef   struct Arr6x6Float64_s * Arr6x6Float64;
 static inline Arr6x6Float64 Arr6x6Float64_getp(Arr6x6Float64 restrict  obj){
  int64_t offset=0;
  return (Arr6x6Float64)(( char*) obj+offset);
}
 static inline int64_t Arr6x6Float64_len(Arr6x6Float64 restrict  obj){
  return 36;
}
 static inline double Arr6x6Float64_get(const Arr6x6Float64 restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=i0*48+i1*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void Arr6x6Float64_set(Arr6x6Float64 restrict  obj, int64_t i0, int64_t i1, double value){
  int64_t offset=0;
  offset+=i0*48+i1*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* Arr6x6Float64_getp2(Arr6x6Float64 restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=i0*48+i1*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_Arr6x6x6Float64
#define XOBJ_TYPEDEF_Arr6x6x6Float64
typedef   struct Arr6x6x6Float64_s * Arr6x6x6Float64;
 static inline Arr6x6x6Float64 Arr6x6x6Float64_getp(Arr6x6x6Float64 restrict  obj){
  int64_t offset=0;
  return (Arr6x6x6Float64)(( char*) obj+offset);
}
 static inline int64_t Arr6x6x6Float64_len(Arr6x6x6Float64 restrict  obj){
  return 216;
}
 static inline double Arr6x6x6Float64_get(const Arr6x6x6Float64 restrict  obj, int64_t i0, int64_t i1, int64_t i2){
  int64_t offset=0;
  offset+=i0*288+i1*48+i2*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void Arr6x6x6Float64_set(Arr6x6x6Float64 restrict  obj, int64_t i0, int64_t i1, int64_t i2, double value){
  int64_t offset=0;
  offset+=i0*288+i1*48+i2*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* Arr6x6x6Float64_getp3(Arr6x6x6Float64 restrict  obj, int64_t i0, int64_t i1, int64_t i2){
  int64_t offset=0;
  offset+=i0*288+i1*48+i2*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_Arr2Float64
#define XOBJ_TYPEDEF_Arr2Float64
typedef   struct Arr2Float64_s * Arr2Float64;
 static inline Arr2Float64 Arr2Float64_getp(Arr2Float64 restrict  obj){
  int64_t offset=0;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t Arr2Float64_len(Arr2Float64 restrict  obj){
  return 2;
}
 static inline double Arr2Float64_get(const Arr2Float64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void Arr2Float64_set(Arr2Float64 restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* Arr2Float64_getp1(Arr2Float64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_Arr1Float64
#define XOBJ_TYPEDEF_Arr1Float64
typedef   struct Arr1Float64_s * Arr1Float64;
 static inline Arr1Float64 Arr1Float64_getp(Arr1Float64 restrict  obj){
  int64_t offset=0;
  return (Arr1Float64)(( char*) obj+offset);
}
 static inline int64_t Arr1Float64_len(Arr1Float64 restrict  obj){
  return 1;
}
 static inline double Arr1Float64_get(const Arr1Float64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void Arr1Float64_set(Arr1Float64 restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* Arr1Float64_getp1(Arr1Float64 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_RecordIndex
#define XOBJ_TYPEDEF_RecordIndex
typedef   struct RecordIndex_s * RecordIndex;
 static inline RecordIndex RecordIndex_getp(RecordIndex restrict  obj){
  int64_t offset=0;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t RecordIndex_get_capacity(const RecordIndex restrict  obj){
  int64_t offset=0;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RecordIndex_set_capacity(RecordIndex restrict  obj, int64_t value){
  int64_t offset=0;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RecordIndex_getp_capacity(RecordIndex restrict  obj){
  int64_t offset=0;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t RecordIndex_get_num_recorded(const RecordIndex restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void RecordIndex_set_num_recorded(RecordIndex restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=8;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* RecordIndex_getp_num_recorded(RecordIndex restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t RecordIndex_get__dummy(const RecordIndex restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void RecordIndex_set__dummy(RecordIndex restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=16;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* RecordIndex_getp__dummy(RecordIndex restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t RecordIndex_get_buffer_id(const RecordIndex restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RecordIndex_set_buffer_id(RecordIndex restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RecordIndex_getp_buffer_id(RecordIndex restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
#endif


 static inline
int64_t RecordIndex_get_slot(RecordIndex record_index){

    if (record_index == NULL){
        return -2;
    }
    int64_t capacity = RecordIndex_get_capacity(record_index);
      uint32_t* num_recorded = RecordIndex_getp_num_recorded(record_index);

    if(*num_recorded >= capacity){
        return -1;
    }

    uint32_t slot;

//    slot = atomic_add(num_recorded, 1);   //only_for_context opencl
//    slot = atomicAdd(num_recorded, 1);    //only_for_context cuda

//    #pragma omp atomic capture            //only_for_context cpu_openmp
    slot = (*num_recorded)++;             //only_for_context cpu_serial cpu_openmp

    if (slot >= capacity){
        *num_recorded = capacity;
        return -1;
    }
    return (int64_t)slot;
}

#ifndef XOBJ_TYPEDEF_ArrNUint32
#define XOBJ_TYPEDEF_ArrNUint32
typedef   struct ArrNUint32_s * ArrNUint32;
 static inline ArrNUint32 ArrNUint32_getp(ArrNUint32 restrict  obj){
  int64_t offset=0;
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ArrNUint32_len(ArrNUint32 restrict  obj){
  int64_t offset=0;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ArrNUint32_get(const ArrNUint32 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ArrNUint32_set(ArrNUint32 restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ArrNUint32_getp1(ArrNUint32 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_ArrNString
#define XOBJ_TYPEDEF_ArrNString
typedef   struct ArrNString_s * ArrNString;
 static inline ArrNString ArrNString_getp(ArrNString restrict  obj){
  int64_t offset=0;
  return (ArrNString)(( char*) obj+offset);
}
 static inline int64_t ArrNString_len(ArrNString restrict  obj){
  int64_t offset=0;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline  char* ArrNString_getp1(ArrNString restrict  obj, int64_t i0){
  int64_t offset=0;
  offset=*( int64_t*)(( char*) obj+offset+16+i0*8);
  return ( char*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_ArrNFloat32
#define XOBJ_TYPEDEF_ArrNFloat32
typedef   struct ArrNFloat32_s * ArrNFloat32;
 static inline ArrNFloat32 ArrNFloat32_getp(ArrNFloat32 restrict  obj){
  int64_t offset=0;
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t ArrNFloat32_len(ArrNFloat32 restrict  obj){
  int64_t offset=0;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float ArrNFloat32_get(const ArrNFloat32 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void ArrNFloat32_set(ArrNFloat32 restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* ArrNFloat32_getp1(ArrNFloat32 restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_MultiSetterData
#define XOBJ_TYPEDEF_MultiSetterData
typedef   struct MultiSetterData_s * MultiSetterData;
 static inline MultiSetterData MultiSetterData_getp(MultiSetterData restrict  obj){
  int64_t offset=0;
  return (MultiSetterData)(( char*) obj+offset);
}
 static inline ArrNInt64 MultiSetterData_getp_offsets(MultiSetterData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t MultiSetterData_len_offsets(MultiSetterData restrict  obj){
  int64_t offset=0;
  offset+=8;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t MultiSetterData_get_offsets(const MultiSetterData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=8;
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MultiSetterData_set_offsets(MultiSetterData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=8;
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MultiSetterData_getp1_offsets(MultiSetterData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=8;
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
#endif


 
void get_values_at_offsets_float64(
    MultiSetterData data,
      int8_t* buffer,
      double* out){

    int64_t num_offsets = MultiSetterData_len_offsets(data);

for (int ii=0; ii<num_offsets; ii++){ //autovectorized

        int64_t offs = MultiSetterData_get_offsets(data, ii);

        double val = *((  double*)(buffer + offs));
        out[ii] = val;
}//end autovectorized

}

 
void get_values_at_offsets_int64(
    MultiSetterData data,
      int8_t* buffer,
      int64_t* out){

    int64_t num_offsets = MultiSetterData_len_offsets(data);

for (int ii=0; ii<num_offsets; ii++){ //autovectorized

        int64_t offs = MultiSetterData_get_offsets(data, ii);

        int64_t val = *((  int64_t*)(buffer + offs));
        out[ii] = val;
}//end autovectorized

}

 
void set_values_at_offsets_float64(
    MultiSetterData data,
      int8_t* buffer,
      double* input){

    int64_t num_offsets = MultiSetterData_len_offsets(data);

for (int ii=0; ii<num_offsets; ii++){ //autovectorized

        int64_t offs = MultiSetterData_get_offsets(data, ii);

        double val = input[ii];
        *((  double*)(buffer + offs)) = val;
}//end autovectorized

}

 
void set_values_at_offsets_int64(
    MultiSetterData data,
      int8_t* buffer,
      int64_t* input){

    int64_t num_offsets = MultiSetterData_len_offsets(data);

for (int ii=0; ii<num_offsets; ii++){ //autovectorized

        int64_t offs = MultiSetterData_get_offsets(data, ii);

        int64_t val = input[ii];
        *((  int64_t*)(buffer + offs)) = val;
}//end autovectorized

}




#ifndef XOBJ_TYPEDEF_BeamPositionMonitorRecord
#define XOBJ_TYPEDEF_BeamPositionMonitorRecord
typedef   struct BeamPositionMonitorRecord_s * BeamPositionMonitorRecord;
 static inline BeamPositionMonitorRecord BeamPositionMonitorRecord_getp(BeamPositionMonitorRecord restrict  obj){
  int64_t offset=0;
  return (BeamPositionMonitorRecord)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamPositionMonitorRecord_getp_count(BeamPositionMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=24;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorRecord_len_count(BeamPositionMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=24;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamPositionMonitorRecord_get_count(const BeamPositionMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorRecord_set_count(BeamPositionMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=24;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorRecord_getp1_count(BeamPositionMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=24;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamPositionMonitorRecord_getp_x_sum(BeamPositionMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorRecord_len_x_sum(BeamPositionMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamPositionMonitorRecord_get_x_sum(const BeamPositionMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorRecord_set_x_sum(BeamPositionMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorRecord_getp1_x_sum(BeamPositionMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamPositionMonitorRecord_getp_y_sum(BeamPositionMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorRecord_len_y_sum(BeamPositionMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamPositionMonitorRecord_get_y_sum(const BeamPositionMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorRecord_set_y_sum(BeamPositionMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorRecord_getp1_y_sum(BeamPositionMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_BeamSizeMonitorRecord
#define XOBJ_TYPEDEF_BeamSizeMonitorRecord
typedef   struct BeamSizeMonitorRecord_s * BeamSizeMonitorRecord;
 static inline BeamSizeMonitorRecord BeamSizeMonitorRecord_getp(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  return (BeamSizeMonitorRecord)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorRecord_getp_count(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=40;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorRecord_len_count(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=40;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorRecord_get_count(const BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=40;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorRecord_set_count(BeamSizeMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=40;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorRecord_getp1_count(BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=40;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorRecord_getp_x_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorRecord_len_x_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorRecord_get_x_sum(const BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorRecord_set_x_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorRecord_getp1_x_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorRecord_getp_x2_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorRecord_len_x2_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorRecord_get_x2_sum(const BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorRecord_set_x2_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorRecord_getp1_x2_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorRecord_getp_y_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorRecord_len_y_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorRecord_get_y_sum(const BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorRecord_set_y_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorRecord_getp1_y_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorRecord_getp_y2_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorRecord_len_y2_sum(BeamSizeMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorRecord_get_y2_sum(const BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorRecord_set_y2_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorRecord_getp1_y2_sum(BeamSizeMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_BeamProfileMonitorRecord
#define XOBJ_TYPEDEF_BeamProfileMonitorRecord
typedef   struct BeamProfileMonitorRecord_s * BeamProfileMonitorRecord;
 static inline BeamProfileMonitorRecord BeamProfileMonitorRecord_getp(BeamProfileMonitorRecord restrict  obj){
  int64_t offset=0;
  return (BeamProfileMonitorRecord)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamProfileMonitorRecord_getp_counts_x(BeamProfileMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=16;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorRecord_len_counts_x(BeamProfileMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=16;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamProfileMonitorRecord_get_counts_x(const BeamProfileMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorRecord_set_counts_x(BeamProfileMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=16;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorRecord_getp1_counts_x(BeamProfileMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamProfileMonitorRecord_getp_counts_y(BeamProfileMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorRecord_len_counts_y(BeamProfileMonitorRecord restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamProfileMonitorRecord_get_counts_y(const BeamProfileMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorRecord_set_counts_y(BeamProfileMonitorRecord restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorRecord_getp1_counts_y(BeamProfileMonitorRecord restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_SynchrotronRadiationRecordData
#define XOBJ_TYPEDEF_SynchrotronRadiationRecordData
typedef   struct SynchrotronRadiationRecordData_s * SynchrotronRadiationRecordData;
 static inline SynchrotronRadiationRecordData SynchrotronRadiationRecordData_getp(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  return (SynchrotronRadiationRecordData)(( char*) obj+offset);
}
 static inline RecordIndex SynchrotronRadiationRecordData_getp__index(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t SynchrotronRadiationRecordData_get__index_capacity(const SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set__index_capacity(SynchrotronRadiationRecordData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SynchrotronRadiationRecordData_getp__index_capacity(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t SynchrotronRadiationRecordData_get__index_num_recorded(const SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set__index_num_recorded(SynchrotronRadiationRecordData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=16;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* SynchrotronRadiationRecordData_getp__index_num_recorded(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t SynchrotronRadiationRecordData_get__index__dummy(const SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set__index__dummy(SynchrotronRadiationRecordData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=24;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* SynchrotronRadiationRecordData_getp__index__dummy(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t SynchrotronRadiationRecordData_get__index_buffer_id(const SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set__index_buffer_id(SynchrotronRadiationRecordData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SynchrotronRadiationRecordData_getp__index_buffer_id(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 SynchrotronRadiationRecordData_getp_photon_energy(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t SynchrotronRadiationRecordData_len_photon_energy(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=72;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double SynchrotronRadiationRecordData_get_photon_energy(const SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set_photon_energy(SynchrotronRadiationRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SynchrotronRadiationRecordData_getp1_photon_energy(SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNInt64 SynchrotronRadiationRecordData_getp_at_element(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t SynchrotronRadiationRecordData_len_at_element(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t SynchrotronRadiationRecordData_get_at_element(const SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set_at_element(SynchrotronRadiationRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SynchrotronRadiationRecordData_getp1_at_element(SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 SynchrotronRadiationRecordData_getp_at_turn(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t SynchrotronRadiationRecordData_len_at_turn(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t SynchrotronRadiationRecordData_get_at_turn(const SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set_at_turn(SynchrotronRadiationRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SynchrotronRadiationRecordData_getp1_at_turn(SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 SynchrotronRadiationRecordData_getp_particle_id(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t SynchrotronRadiationRecordData_len_particle_id(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t SynchrotronRadiationRecordData_get_particle_id(const SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set_particle_id(SynchrotronRadiationRecordData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SynchrotronRadiationRecordData_getp1_particle_id(SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 SynchrotronRadiationRecordData_getp_particle_delta(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t SynchrotronRadiationRecordData_len_particle_delta(SynchrotronRadiationRecordData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double SynchrotronRadiationRecordData_get_particle_delta(const SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SynchrotronRadiationRecordData_set_particle_delta(SynchrotronRadiationRecordData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SynchrotronRadiationRecordData_getp1_particle_delta(SynchrotronRadiationRecordData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_ParticlesData
#define XOBJ_TYPEDEF_ParticlesData
typedef   struct ParticlesData_s * ParticlesData;
 static inline ParticlesData ParticlesData_getp(ParticlesData restrict  obj){
  int64_t offset=0;
  return (ParticlesData)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_get__capacity(const ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set__capacity(ParticlesData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp__capacity(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_get__num_active_particles(const ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set__num_active_particles(ParticlesData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp__num_active_particles(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_get__num_lost_particles(const ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set__num_lost_particles(ParticlesData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp__num_lost_particles(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_get_start_tracking_at_element(const ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_start_tracking_at_element(ParticlesData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp_start_tracking_at_element(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ParticlesData_get_q0(const ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_q0(ParticlesData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp_q0(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesData_get_mass0(const ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_mass0(ParticlesData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp_mass0(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesData_get_t_sim(const ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_t_sim(ParticlesData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp_t_sim(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_p0c(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=312;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_p0c(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=312;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_p0c(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=312;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_p0c(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=312;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_p0c(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=312;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_gamma0(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_gamma0(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_gamma0(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_gamma0(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_gamma0(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_beta0(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_beta0(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_beta0(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_beta0(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_beta0(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_s(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_s(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_s(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_s(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_s(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_zeta(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_zeta(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_zeta(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_zeta(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_zeta(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_x(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_x(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_x(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_x(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_x(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_y(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_y(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_y(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_y(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_y(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_px(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_px(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_px(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_px(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_px(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_py(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_py(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_py(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_py(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_py(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_ptau(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_ptau(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_ptau(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_ptau(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_ptau(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_delta(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_delta(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_delta(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_delta(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_delta(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_rpp(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_rpp(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_rpp(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_rpp(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_rpp(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_rvv(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_rvv(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_rvv(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_rvv(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_rvv(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_chi(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_chi(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_chi(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_chi(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_chi(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_charge_ratio(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_charge_ratio(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_charge_ratio(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_charge_ratio(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_charge_ratio(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_weight(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_weight(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_weight(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_weight(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_weight(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_ax(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_ax(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_ax(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_ax(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_ax(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_ay(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_ay(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_ay(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_ay(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_ay(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_spin_x(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_spin_x(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_spin_x(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_spin_x(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_spin_x(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_spin_y(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_spin_y(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_spin_y(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_spin_y(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_spin_y(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_spin_z(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_spin_z(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_spin_z(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_spin_z(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_spin_z(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesData_getp_anomalous_magnetic_moment(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_anomalous_magnetic_moment(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesData_get_anomalous_magnetic_moment(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_anomalous_magnetic_moment(ParticlesData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesData_getp1_anomalous_magnetic_moment(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesData_getp_pdg_id(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_pdg_id(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesData_get_pdg_id(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_pdg_id(ParticlesData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp1_pdg_id(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesData_getp_particle_id(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_particle_id(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesData_get_particle_id(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_particle_id(ParticlesData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp1_particle_id(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesData_getp_at_element(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_at_element(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesData_get_at_element(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_at_element(ParticlesData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp1_at_element(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesData_getp_at_turn(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_at_turn(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesData_get_at_turn(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_at_turn(ParticlesData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp1_at_turn(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesData_getp_state(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_state(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesData_get_state(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_state(ParticlesData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp1_state(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesData_getp_parent_particle_id(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len_parent_particle_id(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesData_get_parent_particle_id(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set_parent_particle_id(ParticlesData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesData_getp1_parent_particle_id(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesData_getp__rng_s1(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len__rng_s1(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesData_get__rng_s1(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set__rng_s1(ParticlesData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesData_getp1__rng_s1(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesData_getp__rng_s2(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len__rng_s2(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesData_get__rng_s2(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set__rng_s2(ParticlesData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesData_getp1__rng_s2(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesData_getp__rng_s3(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len__rng_s3(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesData_get__rng_s3(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set__rng_s3(ParticlesData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesData_getp1__rng_s3(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesData_getp__rng_s4(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesData_len__rng_s4(ParticlesData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesData_get__rng_s4(const ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesData_set__rng_s4(ParticlesData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesData_getp1__rng_s4(ParticlesData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2024.                 //
// ######################################### //

#ifndef XTRACK_BASE_RNG_H
#define XTRACK_BASE_RNG_H

#include <headers/track.h>

// Only include if compiled standalone, outside of Xsuite
#ifndef START_PER_PARTICLE_BLOCK
#include <stdint.h>
#endif

// Combined LCG-Thausworthe generator from (example 37-4):
// https://developer.nvidia.com/gpugems/gpugems3/part-vi-gpu-computing/chapter-37-efficient-random-number-generation-and-application
#define MASK 0xffffffffUL
#define TAUSWORTHE(s,a,b,c,d) ((((s) &c) <<d) &MASK) ^ (((((s) <<a) &MASK)^(s)) >>b)
#define LCG(s,A,C) ((((A*(s)) &MASK) + C) &MASK)

GPUFUN
uint32_t rng_get_int32 (uint32_t *s1, uint32_t *s2, uint32_t *s3, uint32_t *s4 ){
  *s1 = TAUSWORTHE (*s1, 13, 19, 4294967294UL, 12);  // p1=2^31-1
  *s2 = TAUSWORTHE (*s2, 2, 25, 4294967288UL, 4);    // p2=2^30-1
  *s3 = TAUSWORTHE (*s3, 3, 11, 4294967280UL, 17);   // p3=2^28-1
  *s4 = LCG(*s4, 1664525, 1013904223UL);             // p4=2^32

  // Combined period is lcm(p1,p2,p3,p4) ~ 2^121
  return ((*s1) ^ (*s2) ^ (*s3) ^ (*s4));
}

#ifndef TWO_TO_32
#define TWO_TO_32 4294967296.0
#endif

GPUFUN
double rng_get (uint32_t *s1, uint32_t *s2, uint32_t *s3, uint32_t *s4 ){

  return rng_get_int32(s1, s2, s3, s4) / TWO_TO_32; // uniform in [0, 1) 1e10 resolution

}

GPUFUN
void rng_set (uint32_t *s1, uint32_t *s2, uint32_t *s3, uint32_t *s4, uint32_t s ){
  *s1 = LCG (s, 69069, 0);
  if (*s1 < 2) *s1 += 2UL;
  *s2 = LCG (*s1, 69069, 0);
  if (*s2 < 8) *s2 += 8UL;
  *s3 = LCG (*s2, 69069, 0);
  if (*s3 < 16) *s3 += 16UL;
  *s4 = LCG (*s3, 69069, 0);

  /* "warm it up" */
  rng_get (s1, s2, s3, s4);
  rng_get (s1, s2, s3, s4);
  rng_get (s1, s2, s3, s4);
  rng_get (s1, s2, s3, s4);
  rng_get (s1, s2, s3, s4);
  rng_get (s1, s2, s3, s4);
  return;
}

#endif /* XTRACK_BASE_RNG_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2024.                 //
// ######################################### //

#ifndef XTRACK_PARTICLES_RNG_H
#define XTRACK_PARTICLES_RNG_H

#include <headers/track.h>

GPUKERN
void Particles_initialize_rand_gen(ParticlesData particles,
    GPUGLMEM uint32_t* seeds, int n_init){

    VECTORIZE_OVER(ii, n_init);

        uint32_t s1, s2, s3, s4, s;
        s = seeds[ii];

        rng_set(&s1, &s2, &s3, &s4, s);

        ParticlesData_set__rng_s1(particles, ii, s1);
        ParticlesData_set__rng_s2(particles, ii, s2);
        ParticlesData_set__rng_s3(particles, ii, s3);
        ParticlesData_set__rng_s4(particles, ii, s4);

    END_VECTORIZE;
}

#endif /* XTRACK_PARTICLES_RNG_H */


 
#define ELECTRON_MASS_EV 510998.95
#define MUON_MASS_EV 105658375.5
#define PION_MASS_EV 139570390.0
#define KAON_MASS_EV 493677000.0
#define PROTON_MASS_EV 938272088.16
#define DEUTERON_MASS_EV 1875612945.0
#define TRITON_MASS_EV 2808921136.68
#define He3_MASS_EV 2808391611.12
#define He4_MASS_EV 3727379411.8
#define U_MASS_EV 931494102.42
#define C10_MASS_EV 9330639707.0
#define C11_MASS_EV 10257084532.0
#define C12_MASS_EV 11177929229.0
#define C13_MASS_EV 12112548340.8
#define C14_MASS_EV 13043937327.9
#define C15_MASS_EV 13982284810.0
#define O14_MASS_EV 13048925215.0
#define O15_MASS_EV 13975267170.0
#define O16_MASS_EV 14899168636.6
#define O17_MASS_EV 15834590977.0
#define O18_MASS_EV 16766111027.3
#define O19_MASS_EV 17701720900.0
#define O20_MASS_EV 18633678340.0
#define Ne19_MASS_EV 17700140000.0
#define Ne20_MASS_EV 18622840116.3
#define Ne21_MASS_EV 19555644383.0
#define Ne22_MASS_EV 20484845538.0
#define Ne23_MASS_EV 21419210320.0
#define Ne24_MASS_EV 22349906830.0
#define Ar35_MASS_EV 32579246300.0
#define Ar36_MASS_EV 33503556145.0
#define Ar37_MASS_EV 34434334110.0
#define Ar38_MASS_EV 35362061070.0
#define Ar39_MASS_EV 36295027800.0
#define Ar40_MASS_EV 37224724197.0
#define Ar41_MASS_EV 38158190689.0
#define Ar42_MASS_EV 39088329600.0
#define Ar43_MASS_EV 40022236600.0
#define Ar44_MASS_EV 40953067200.0
#define Ar45_MASS_EV 41887463810.0
#define Ar46_MASS_EV 42818957400.0
#define Ar47_MASS_EV 43754855500.0
#define Fe52_MASS_EV 48389361230.0
#define Fe53_MASS_EV 49318239900.0
#define Fe54_MASS_EV 50244426920.0
#define Fe55_MASS_EV 51174694210.0
#define Fe56_MASS_EV 52103062570.0
#define Fe57_MASS_EV 53034981820.0
#define Fe58_MASS_EV 53964502670.0
#define Fe59_MASS_EV 54897487080.0
#define Fe60_MASS_EV 55828232900.0
#define Fe61_MASS_EV 56762219700.0
#define Fe62_MASS_EV 57693756300.0
#define Fe63_MASS_EV 58628492800.0
#define Fe64_MASS_EV 59560653000.0
#define Xe112_MASS_EV 104267313200.0
#define Xe113_MASS_EV 105196621000.0
#define Xe114_MASS_EV 106123241000.0
#define Xe115_MASS_EV 107053165000.0
#define Xe116_MASS_EV 107980269000.0
#define Xe117_MASS_EV 108910625000.0
#define Xe118_MASS_EV 109838225000.0
#define Xe119_MASS_EV 110769004000.0
#define Xe120_MASS_EV 111697120000.0
#define Xe121_MASS_EV 112628305000.0
#define Xe122_MASS_EV 113556926000.0
#define Xe123_MASS_EV 114488526100.0
#define Xe124_MASS_EV 115417601300.0
#define Xe125_MASS_EV 116349563400.0
#define Xe126_MASS_EV 117279110518.0
#define Xe127_MASS_EV 118211430100.0
#define Xe128_MASS_EV 119141384575.0
#define Xe129_MASS_EV 120074043142.0
#define Xe130_MASS_EV 121004352839.0
#define Xe131_MASS_EV 121937313842.0
#define Xe132_MASS_EV 122867942545.0
#define Xe133_MASS_EV 123801072000.0
#define Xe134_MASS_EV 124732083890.0
#define Xe135_MASS_EV 125665290400.0
#define Xe136_MASS_EV 126596768759.0
#define Xe137_MASS_EV 127532308620.0
#define Xe138_MASS_EV 128466214000.0
#define Xe139_MASS_EV 129402035700.0
#define Xe140_MASS_EV 130336187900.0
#define Xe141_MASS_EV 131272471200.0
#define Xe142_MASS_EV 132206932900.0
#define Au176_MASS_EV 163924444000.0
#define Au177_MASS_EV 164852911000.0
#define Au178_MASS_EV 165783647000.0
#define Au179_MASS_EV 166712456000.0
#define Au180_MASS_EV 167643312800.0
#define Au181_MASS_EV 168572561000.0
#define Au182_MASS_EV 169503622000.0
#define Au183_MASS_EV 170433229200.0
#define Au184_MASS_EV 171364597000.0
#define Au185_MASS_EV 172294550800.0
#define Au186_MASS_EV 173226188000.0
#define Au187_MASS_EV 174156368000.0
#define Au188_MASS_EV 175088520000.0
#define Au189_MASS_EV 176018803000.0
#define Au190_MASS_EV 176951046200.0
#define Au191_MASS_EV 177881575200.0
#define Au192_MASS_EV 178814096000.0
#define Au193_MASS_EV 179744956500.0
#define Au194_MASS_EV 180677644000.0
#define Au195_MASS_EV 181608782900.0
#define Au196_MASS_EV 182541705200.0
#define Au197_MASS_EV 183473198420.0
#define Au198_MASS_EV 184406251470.0
#define Au199_MASS_EV 185338232650.0
#define Au200_MASS_EV 186271581000.0
#define Au201_MASS_EV 187203914200.0
#define Au202_MASS_EV 188137456000.0
#define Au203_MASS_EV 189070159400.0
#define Au204_MASS_EV 190004410000.0
#define Au205_MASS_EV 190937720000.0
#define Au206_MASS_EV 191873600000.0
#define Au207_MASS_EV 192808640000.0
#define Au208_MASS_EV 193744870000.0
#define Au209_MASS_EV 194680040000.0
#define Au210_MASS_EV 195616440000.0
#define Pb185_MASS_EV 172314868000.0
#define Pb186_MASS_EV 173243222000.0
#define Pb187_MASS_EV 174174410200.0
#define Pb188_MASS_EV 175103080000.0
#define Pb189_MASS_EV 176034542000.0
#define Pb190_MASS_EV 176963463000.0
#define Pb191_MASS_EV 177895082400.0
#define Pb192_MASS_EV 178824315800.0
#define Pb193_MASS_EV 179756133000.0
#define Pb194_MASS_EV 180685648000.0
#define Pb195_MASS_EV 181617612000.0
#define Pb196_MASS_EV 182547495900.0
#define Pb197_MASS_EV 183479592800.0
#define Pb198_MASS_EV 184409764900.0
#define Pb199_MASS_EV 185342094600.0
#define Pb200_MASS_EV 186272570000.0
#define Pb201_MASS_EV 187205043000.0
#define Pb202_MASS_EV 188135868100.0
#define Pb203_MASS_EV 189068516300.0
#define Pb204_MASS_EV 189999687100.0
#define Pb205_MASS_EV 190932520900.0
#define Pb206_MASS_EV 191863999600.0
#define Pb207_MASS_EV 192796827200.0
#define Pb208_MASS_EV 193729024800.0
#define Pb209_MASS_EV 194664652900.0
#define Pb210_MASS_EV 195599033100.0
#define Pb211_MASS_EV 196534762600.0
#define Pb212_MASS_EV 197469200800.0
#define Pb213_MASS_EV 198405040200.0
#define Pb214_MASS_EV 199339554900.0
#define Pb215_MASS_EV 200275575000.0
#define Pb216_MASS_EV 201210230000.0
#define Pb217_MASS_EV 202146480000.0
#define Pb218_MASS_EV 203081340000.0
#define Pb219_MASS_EV 204017830000.0
#define Pb220_MASS_EV 204952840000.0
#define PHOTON_MASS_EV 0.0
#define PION0_MASS_EV 134976800.0
#define KAON0_MASS_EV 497611000.0
#define NEUTRON_MASS_EV 939565420.5
typedef struct {
                 int64_t  _capacity;
                 int64_t  _num_active_particles;
                 int64_t  _num_lost_particles;
                 int64_t  start_tracking_at_element;
                 double  q0;
                 double  mass0;
                 double  t_sim;
      double* p0c;
      double* gamma0;
      double* beta0;
      double* s;
      double* zeta;
      double* x;
      double* y;
      double* px;
      double* py;
      double* ptau;
      double* delta;
      double* rpp;
      double* rvv;
      double* chi;
      double* charge_ratio;
      double* weight;
      double* ax;
      double* ay;
      double* spin_x;
      double* spin_y;
      double* spin_z;
      double* anomalous_magnetic_moment;
      int64_t* pdg_id;
      int64_t* particle_id;
      int64_t* at_element;
      int64_t* at_turn;
      int64_t* state;
      int64_t* parent_particle_id;
      uint32_t* _rng_s1;
      uint32_t* _rng_s2;
      uint32_t* _rng_s3;
      uint32_t* _rng_s4;
                 int64_t ipart;
                 int64_t endpart;
      int8_t* io_buffer;
} LocalParticle;


             static inline
            void LocalParticle_add_to_p0c(LocalParticle* part, double value){
#ifndef FREEZE_VAR_p0c
  part->p0c[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_gamma0(LocalParticle* part, double value){
#ifndef FREEZE_VAR_gamma0
  part->gamma0[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_beta0(LocalParticle* part, double value){
#ifndef FREEZE_VAR_beta0
  part->beta0[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_s(LocalParticle* part, double value){
#ifndef FREEZE_VAR_s
  part->s[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_zeta(LocalParticle* part, double value){
#ifndef FREEZE_VAR_zeta
  part->zeta[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_x(LocalParticle* part, double value){
#ifndef FREEZE_VAR_x
  part->x[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_y(LocalParticle* part, double value){
#ifndef FREEZE_VAR_y
  part->y[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_px(LocalParticle* part, double value){
#ifndef FREEZE_VAR_px
  part->px[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_py(LocalParticle* part, double value){
#ifndef FREEZE_VAR_py
  part->py[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_ptau(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ptau
  part->ptau[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_delta(LocalParticle* part, double value){
#ifndef FREEZE_VAR_delta
  part->delta[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_rpp(LocalParticle* part, double value){
#ifndef FREEZE_VAR_rpp
  part->rpp[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_rvv(LocalParticle* part, double value){
#ifndef FREEZE_VAR_rvv
  part->rvv[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_chi(LocalParticle* part, double value){
#ifndef FREEZE_VAR_chi
  part->chi[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_charge_ratio(LocalParticle* part, double value){
#ifndef FREEZE_VAR_charge_ratio
  part->charge_ratio[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_weight(LocalParticle* part, double value){
#ifndef FREEZE_VAR_weight
  part->weight[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_ax(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ax
  part->ax[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_ay(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ay
  part->ay[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_spin_x(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_x
  part->spin_x[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_spin_y(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_y
  part->spin_y[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_spin_z(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_z
  part->spin_z[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_anomalous_magnetic_moment(LocalParticle* part, double value){
#ifndef FREEZE_VAR_anomalous_magnetic_moment
  part->anomalous_magnetic_moment[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_pdg_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_pdg_id
  part->pdg_id[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_particle_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_particle_id
  part->particle_id[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_at_element(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_at_element
  part->at_element[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_at_turn(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_at_turn
  part->at_turn[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_state(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_state
  part->state[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to_parent_particle_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_parent_particle_id
  part->parent_particle_id[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to__rng_s1(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s1
  part->_rng_s1[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to__rng_s2(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s2
  part->_rng_s2[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to__rng_s3(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s3
  part->_rng_s3[part->ipart] += value;
#endif
}


             static inline
            void LocalParticle_add_to__rng_s4(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s4
  part->_rng_s4[part->ipart] += value;
#endif
}


 static inline
int64_t LocalParticle_get__capacity(LocalParticle* part){
  return part->_capacity;
}
 static inline
int64_t LocalParticle_get__num_active_particles(LocalParticle* part){
  return part->_num_active_particles;
}
 static inline
int64_t LocalParticle_get__num_lost_particles(LocalParticle* part){
  return part->_num_lost_particles;
}
 static inline
int64_t LocalParticle_get_start_tracking_at_element(LocalParticle* part){
  return part->start_tracking_at_element;
}
 static inline
double LocalParticle_get_q0(LocalParticle* part){
  return part->q0;
}
 static inline
double LocalParticle_get_mass0(LocalParticle* part){
  return part->mass0;
}
 static inline
double LocalParticle_get_t_sim(LocalParticle* part){
  return part->t_sim;
}
 static inline
double LocalParticle_get_p0c(LocalParticle* part){
  return part->p0c[part->ipart];
}
 static inline
double LocalParticle_get_gamma0(LocalParticle* part){
  return part->gamma0[part->ipart];
}
 static inline
double LocalParticle_get_beta0(LocalParticle* part){
  return part->beta0[part->ipart];
}
 static inline
double LocalParticle_get_s(LocalParticle* part){
  return part->s[part->ipart];
}
 static inline
double LocalParticle_get_zeta(LocalParticle* part){
  return part->zeta[part->ipart];
}
 static inline
double LocalParticle_get_x(LocalParticle* part){
  return part->x[part->ipart];
}
 static inline
double LocalParticle_get_y(LocalParticle* part){
  return part->y[part->ipart];
}
 static inline
double LocalParticle_get_px(LocalParticle* part){
  return part->px[part->ipart];
}
 static inline
double LocalParticle_get_py(LocalParticle* part){
  return part->py[part->ipart];
}
 static inline
double LocalParticle_get_ptau(LocalParticle* part){
  return part->ptau[part->ipart];
}
 static inline
double LocalParticle_get_delta(LocalParticle* part){
  return part->delta[part->ipart];
}
 static inline
double LocalParticle_get_rpp(LocalParticle* part){
  return part->rpp[part->ipart];
}
 static inline
double LocalParticle_get_rvv(LocalParticle* part){
  return part->rvv[part->ipart];
}
 static inline
double LocalParticle_get_chi(LocalParticle* part){
  return part->chi[part->ipart];
}
 static inline
double LocalParticle_get_charge_ratio(LocalParticle* part){
  return part->charge_ratio[part->ipart];
}
 static inline
double LocalParticle_get_weight(LocalParticle* part){
  return part->weight[part->ipart];
}
 static inline
double LocalParticle_get_ax(LocalParticle* part){
  return part->ax[part->ipart];
}
 static inline
double LocalParticle_get_ay(LocalParticle* part){
  return part->ay[part->ipart];
}
 static inline
double LocalParticle_get_spin_x(LocalParticle* part){
  return part->spin_x[part->ipart];
}
 static inline
double LocalParticle_get_spin_y(LocalParticle* part){
  return part->spin_y[part->ipart];
}
 static inline
double LocalParticle_get_spin_z(LocalParticle* part){
  return part->spin_z[part->ipart];
}
 static inline
double LocalParticle_get_anomalous_magnetic_moment(LocalParticle* part){
  return part->anomalous_magnetic_moment[part->ipart];
}
 static inline
int64_t LocalParticle_get_pdg_id(LocalParticle* part){
  return part->pdg_id[part->ipart];
}
 static inline
int64_t LocalParticle_get_particle_id(LocalParticle* part){
  return part->particle_id[part->ipart];
}
 static inline
int64_t LocalParticle_get_at_element(LocalParticle* part){
  return part->at_element[part->ipart];
}
 static inline
int64_t LocalParticle_get_at_turn(LocalParticle* part){
  return part->at_turn[part->ipart];
}
 static inline
int64_t LocalParticle_get_state(LocalParticle* part){
  return part->state[part->ipart];
}
 static inline
int64_t LocalParticle_get_parent_particle_id(LocalParticle* part){
  return part->parent_particle_id[part->ipart];
}
 static inline
uint32_t LocalParticle_get__rng_s1(LocalParticle* part){
  return part->_rng_s1[part->ipart];
}
 static inline
uint32_t LocalParticle_get__rng_s2(LocalParticle* part){
  return part->_rng_s2[part->ipart];
}
 static inline
uint32_t LocalParticle_get__rng_s3(LocalParticle* part){
  return part->_rng_s3[part->ipart];
}
 static inline
uint32_t LocalParticle_get__rng_s4(LocalParticle* part){
  return part->_rng_s4[part->ipart];
}


             static inline
            void LocalParticle_set_p0c(LocalParticle* part, double value){
#ifndef FREEZE_VAR_p0c
  part->p0c[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_gamma0(LocalParticle* part, double value){
#ifndef FREEZE_VAR_gamma0
  part->gamma0[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_beta0(LocalParticle* part, double value){
#ifndef FREEZE_VAR_beta0
  part->beta0[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_s(LocalParticle* part, double value){
#ifndef FREEZE_VAR_s
  part->s[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_zeta(LocalParticle* part, double value){
#ifndef FREEZE_VAR_zeta
  part->zeta[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_x(LocalParticle* part, double value){
#ifndef FREEZE_VAR_x
  part->x[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_y(LocalParticle* part, double value){
#ifndef FREEZE_VAR_y
  part->y[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_px(LocalParticle* part, double value){
#ifndef FREEZE_VAR_px
  part->px[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_py(LocalParticle* part, double value){
#ifndef FREEZE_VAR_py
  part->py[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_ptau(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ptau
  part->ptau[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_delta(LocalParticle* part, double value){
#ifndef FREEZE_VAR_delta
  part->delta[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_rpp(LocalParticle* part, double value){
#ifndef FREEZE_VAR_rpp
  part->rpp[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_rvv(LocalParticle* part, double value){
#ifndef FREEZE_VAR_rvv
  part->rvv[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_chi(LocalParticle* part, double value){
#ifndef FREEZE_VAR_chi
  part->chi[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_charge_ratio(LocalParticle* part, double value){
#ifndef FREEZE_VAR_charge_ratio
  part->charge_ratio[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_weight(LocalParticle* part, double value){
#ifndef FREEZE_VAR_weight
  part->weight[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_ax(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ax
  part->ax[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_ay(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ay
  part->ay[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_spin_x(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_x
  part->spin_x[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_spin_y(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_y
  part->spin_y[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_spin_z(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_z
  part->spin_z[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_anomalous_magnetic_moment(LocalParticle* part, double value){
#ifndef FREEZE_VAR_anomalous_magnetic_moment
  part->anomalous_magnetic_moment[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_pdg_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_pdg_id
  part->pdg_id[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_particle_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_particle_id
  part->particle_id[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_at_element(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_at_element
  part->at_element[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_at_turn(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_at_turn
  part->at_turn[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_state(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_state
  part->state[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set_parent_particle_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_parent_particle_id
  part->parent_particle_id[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set__rng_s1(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s1
  part->_rng_s1[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set__rng_s2(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s2
  part->_rng_s2[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set__rng_s3(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s3
  part->_rng_s3[part->ipart] = value;
#endif
}

             static inline
            void LocalParticle_set__rng_s4(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s4
  part->_rng_s4[part->ipart] = value;
#endif
}


             static inline
            void LocalParticle_scale_p0c(LocalParticle* part, double value){
#ifndef FREEZE_VAR_p0c
  part->p0c[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_gamma0(LocalParticle* part, double value){
#ifndef FREEZE_VAR_gamma0
  part->gamma0[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_beta0(LocalParticle* part, double value){
#ifndef FREEZE_VAR_beta0
  part->beta0[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_s(LocalParticle* part, double value){
#ifndef FREEZE_VAR_s
  part->s[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_zeta(LocalParticle* part, double value){
#ifndef FREEZE_VAR_zeta
  part->zeta[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_x(LocalParticle* part, double value){
#ifndef FREEZE_VAR_x
  part->x[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_y(LocalParticle* part, double value){
#ifndef FREEZE_VAR_y
  part->y[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_px(LocalParticle* part, double value){
#ifndef FREEZE_VAR_px
  part->px[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_py(LocalParticle* part, double value){
#ifndef FREEZE_VAR_py
  part->py[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_ptau(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ptau
  part->ptau[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_delta(LocalParticle* part, double value){
#ifndef FREEZE_VAR_delta
  part->delta[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_rpp(LocalParticle* part, double value){
#ifndef FREEZE_VAR_rpp
  part->rpp[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_rvv(LocalParticle* part, double value){
#ifndef FREEZE_VAR_rvv
  part->rvv[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_chi(LocalParticle* part, double value){
#ifndef FREEZE_VAR_chi
  part->chi[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_charge_ratio(LocalParticle* part, double value){
#ifndef FREEZE_VAR_charge_ratio
  part->charge_ratio[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_weight(LocalParticle* part, double value){
#ifndef FREEZE_VAR_weight
  part->weight[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_ax(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ax
  part->ax[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_ay(LocalParticle* part, double value){
#ifndef FREEZE_VAR_ay
  part->ay[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_spin_x(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_x
  part->spin_x[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_spin_y(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_y
  part->spin_y[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_spin_z(LocalParticle* part, double value){
#ifndef FREEZE_VAR_spin_z
  part->spin_z[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_anomalous_magnetic_moment(LocalParticle* part, double value){
#ifndef FREEZE_VAR_anomalous_magnetic_moment
  part->anomalous_magnetic_moment[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_pdg_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_pdg_id
  part->pdg_id[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_particle_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_particle_id
  part->particle_id[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_at_element(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_at_element
  part->at_element[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_at_turn(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_at_turn
  part->at_turn[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_state(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_state
  part->state[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale_parent_particle_id(LocalParticle* part, int64_t value){
#ifndef FREEZE_VAR_parent_particle_id
  part->parent_particle_id[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale__rng_s1(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s1
  part->_rng_s1[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale__rng_s2(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s2
  part->_rng_s2[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale__rng_s3(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s3
  part->_rng_s3[part->ipart] *= value;
#endif
}


             static inline
            void LocalParticle_scale__rng_s4(LocalParticle* part, uint32_t value){
#ifndef FREEZE_VAR__rng_s4
  part->_rng_s4[part->ipart] *= value;
#endif
}



         static inline
        void LocalParticle_exchange(LocalParticle* part, int64_t i1, int64_t i2){
        
    {
    double temp = part->p0c[i2];
    part->p0c[i2] = part->p0c[i1];
    part->p0c[i1] = temp;
     }
    {
    double temp = part->gamma0[i2];
    part->gamma0[i2] = part->gamma0[i1];
    part->gamma0[i1] = temp;
     }
    {
    double temp = part->beta0[i2];
    part->beta0[i2] = part->beta0[i1];
    part->beta0[i1] = temp;
     }
    {
    double temp = part->s[i2];
    part->s[i2] = part->s[i1];
    part->s[i1] = temp;
     }
    {
    double temp = part->zeta[i2];
    part->zeta[i2] = part->zeta[i1];
    part->zeta[i1] = temp;
     }
    {
    double temp = part->x[i2];
    part->x[i2] = part->x[i1];
    part->x[i1] = temp;
     }
    {
    double temp = part->y[i2];
    part->y[i2] = part->y[i1];
    part->y[i1] = temp;
     }
    {
    double temp = part->px[i2];
    part->px[i2] = part->px[i1];
    part->px[i1] = temp;
     }
    {
    double temp = part->py[i2];
    part->py[i2] = part->py[i1];
    part->py[i1] = temp;
     }
    {
    double temp = part->ptau[i2];
    part->ptau[i2] = part->ptau[i1];
    part->ptau[i1] = temp;
     }
    {
    double temp = part->delta[i2];
    part->delta[i2] = part->delta[i1];
    part->delta[i1] = temp;
     }
    {
    double temp = part->rpp[i2];
    part->rpp[i2] = part->rpp[i1];
    part->rpp[i1] = temp;
     }
    {
    double temp = part->rvv[i2];
    part->rvv[i2] = part->rvv[i1];
    part->rvv[i1] = temp;
     }
    {
    double temp = part->chi[i2];
    part->chi[i2] = part->chi[i1];
    part->chi[i1] = temp;
     }
    {
    double temp = part->charge_ratio[i2];
    part->charge_ratio[i2] = part->charge_ratio[i1];
    part->charge_ratio[i1] = temp;
     }
    {
    double temp = part->weight[i2];
    part->weight[i2] = part->weight[i1];
    part->weight[i1] = temp;
     }
    {
    double temp = part->ax[i2];
    part->ax[i2] = part->ax[i1];
    part->ax[i1] = temp;
     }
    {
    double temp = part->ay[i2];
    part->ay[i2] = part->ay[i1];
    part->ay[i1] = temp;
     }
    {
    double temp = part->spin_x[i2];
    part->spin_x[i2] = part->spin_x[i1];
    part->spin_x[i1] = temp;
     }
    {
    double temp = part->spin_y[i2];
    part->spin_y[i2] = part->spin_y[i1];
    part->spin_y[i1] = temp;
     }
    {
    double temp = part->spin_z[i2];
    part->spin_z[i2] = part->spin_z[i1];
    part->spin_z[i1] = temp;
     }
    {
    double temp = part->anomalous_magnetic_moment[i2];
    part->anomalous_magnetic_moment[i2] = part->anomalous_magnetic_moment[i1];
    part->anomalous_magnetic_moment[i1] = temp;
     }
    {
    int64_t temp = part->pdg_id[i2];
    part->pdg_id[i2] = part->pdg_id[i1];
    part->pdg_id[i1] = temp;
     }
    {
    int64_t temp = part->particle_id[i2];
    part->particle_id[i2] = part->particle_id[i1];
    part->particle_id[i1] = temp;
     }
    {
    int64_t temp = part->at_element[i2];
    part->at_element[i2] = part->at_element[i1];
    part->at_element[i1] = temp;
     }
    {
    int64_t temp = part->at_turn[i2];
    part->at_turn[i2] = part->at_turn[i1];
    part->at_turn[i1] = temp;
     }
    {
    int64_t temp = part->state[i2];
    part->state[i2] = part->state[i1];
    part->state[i1] = temp;
     }
    {
    int64_t temp = part->parent_particle_id[i2];
    part->parent_particle_id[i2] = part->parent_particle_id[i1];
    part->parent_particle_id[i1] = temp;
     }
    {
    uint32_t temp = part->_rng_s1[i2];
    part->_rng_s1[i2] = part->_rng_s1[i1];
    part->_rng_s1[i1] = temp;
     }
    {
    uint32_t temp = part->_rng_s2[i2];
    part->_rng_s2[i2] = part->_rng_s2[i1];
    part->_rng_s2[i1] = temp;
     }
    {
    uint32_t temp = part->_rng_s3[i2];
    part->_rng_s3[i2] = part->_rng_s3[i1];
    part->_rng_s3[i1] = temp;
     }
    {
    uint32_t temp = part->_rng_s4[i2];
    part->_rng_s4[i2] = part->_rng_s4[i1];
    part->_rng_s4[i1] = temp;
     }}



             static inline
              int8_t* LocalParticle_get_io_buffer(LocalParticle* part){
                return part->io_buffer;
            }

            

             static inline
            void Particles_to_LocalParticle(ParticlesData source,
                                            LocalParticle* dest,
                                            int64_t id,
                                            int64_t eid){
  dest->_capacity = ParticlesData_get__capacity(source);
  dest->_num_active_particles = ParticlesData_get__num_active_particles(source);
  dest->_num_lost_particles = ParticlesData_get__num_lost_particles(source);
  dest->start_tracking_at_element = ParticlesData_get_start_tracking_at_element(source);
  dest->q0 = ParticlesData_get_q0(source);
  dest->mass0 = ParticlesData_get_mass0(source);
  dest->t_sim = ParticlesData_get_t_sim(source);
  dest->p0c = ParticlesData_getp1_p0c(source, 0);
  dest->gamma0 = ParticlesData_getp1_gamma0(source, 0);
  dest->beta0 = ParticlesData_getp1_beta0(source, 0);
  dest->s = ParticlesData_getp1_s(source, 0);
  dest->zeta = ParticlesData_getp1_zeta(source, 0);
  dest->x = ParticlesData_getp1_x(source, 0);
  dest->y = ParticlesData_getp1_y(source, 0);
  dest->px = ParticlesData_getp1_px(source, 0);
  dest->py = ParticlesData_getp1_py(source, 0);
  dest->ptau = ParticlesData_getp1_ptau(source, 0);
  dest->delta = ParticlesData_getp1_delta(source, 0);
  dest->rpp = ParticlesData_getp1_rpp(source, 0);
  dest->rvv = ParticlesData_getp1_rvv(source, 0);
  dest->chi = ParticlesData_getp1_chi(source, 0);
  dest->charge_ratio = ParticlesData_getp1_charge_ratio(source, 0);
  dest->weight = ParticlesData_getp1_weight(source, 0);
  dest->ax = ParticlesData_getp1_ax(source, 0);
  dest->ay = ParticlesData_getp1_ay(source, 0);
  dest->spin_x = ParticlesData_getp1_spin_x(source, 0);
  dest->spin_y = ParticlesData_getp1_spin_y(source, 0);
  dest->spin_z = ParticlesData_getp1_spin_z(source, 0);
  dest->anomalous_magnetic_moment = ParticlesData_getp1_anomalous_magnetic_moment(source, 0);
  dest->pdg_id = ParticlesData_getp1_pdg_id(source, 0);
  dest->particle_id = ParticlesData_getp1_particle_id(source, 0);
  dest->at_element = ParticlesData_getp1_at_element(source, 0);
  dest->at_turn = ParticlesData_getp1_at_turn(source, 0);
  dest->state = ParticlesData_getp1_state(source, 0);
  dest->parent_particle_id = ParticlesData_getp1_parent_particle_id(source, 0);
  dest->_rng_s1 = ParticlesData_getp1__rng_s1(source, 0);
  dest->_rng_s2 = ParticlesData_getp1__rng_s2(source, 0);
  dest->_rng_s3 = ParticlesData_getp1__rng_s3(source, 0);
  dest->_rng_s4 = ParticlesData_getp1__rng_s4(source, 0);
  dest->ipart = id;
  dest->endpart = eid;
}


             static inline
            void LocalParticle_to_Particles(
                                            LocalParticle* source,
                                            ParticlesData dest,
                                            int64_t id,
                                            int64_t set_scalar){
if (set_scalar){
  ParticlesData_set__capacity(dest,      LocalParticle_get__capacity(source));
  ParticlesData_set__num_active_particles(dest,      LocalParticle_get__num_active_particles(source));
  ParticlesData_set__num_lost_particles(dest,      LocalParticle_get__num_lost_particles(source));
  ParticlesData_set_start_tracking_at_element(dest,      LocalParticle_get_start_tracking_at_element(source));
  ParticlesData_set_q0(dest,      LocalParticle_get_q0(source));
  ParticlesData_set_mass0(dest,      LocalParticle_get_mass0(source));
  ParticlesData_set_t_sim(dest,      LocalParticle_get_t_sim(source));
}
  ParticlesData_set_p0c(dest, id,       LocalParticle_get_p0c(source));
  ParticlesData_set_gamma0(dest, id,       LocalParticle_get_gamma0(source));
  ParticlesData_set_beta0(dest, id,       LocalParticle_get_beta0(source));
  ParticlesData_set_s(dest, id,       LocalParticle_get_s(source));
  ParticlesData_set_zeta(dest, id,       LocalParticle_get_zeta(source));
  ParticlesData_set_x(dest, id,       LocalParticle_get_x(source));
  ParticlesData_set_y(dest, id,       LocalParticle_get_y(source));
  ParticlesData_set_px(dest, id,       LocalParticle_get_px(source));
  ParticlesData_set_py(dest, id,       LocalParticle_get_py(source));
  ParticlesData_set_ptau(dest, id,       LocalParticle_get_ptau(source));
  ParticlesData_set_delta(dest, id,       LocalParticle_get_delta(source));
  ParticlesData_set_rpp(dest, id,       LocalParticle_get_rpp(source));
  ParticlesData_set_rvv(dest, id,       LocalParticle_get_rvv(source));
  ParticlesData_set_chi(dest, id,       LocalParticle_get_chi(source));
  ParticlesData_set_charge_ratio(dest, id,       LocalParticle_get_charge_ratio(source));
  ParticlesData_set_weight(dest, id,       LocalParticle_get_weight(source));
  ParticlesData_set_ax(dest, id,       LocalParticle_get_ax(source));
  ParticlesData_set_ay(dest, id,       LocalParticle_get_ay(source));
  ParticlesData_set_spin_x(dest, id,       LocalParticle_get_spin_x(source));
  ParticlesData_set_spin_y(dest, id,       LocalParticle_get_spin_y(source));
  ParticlesData_set_spin_z(dest, id,       LocalParticle_get_spin_z(source));
  ParticlesData_set_anomalous_magnetic_moment(dest, id,       LocalParticle_get_anomalous_magnetic_moment(source));
  ParticlesData_set_pdg_id(dest, id,       LocalParticle_get_pdg_id(source));
  ParticlesData_set_particle_id(dest, id,       LocalParticle_get_particle_id(source));
  ParticlesData_set_at_element(dest, id,       LocalParticle_get_at_element(source));
  ParticlesData_set_at_turn(dest, id,       LocalParticle_get_at_turn(source));
  ParticlesData_set_state(dest, id,       LocalParticle_get_state(source));
  ParticlesData_set_parent_particle_id(dest, id,       LocalParticle_get_parent_particle_id(source));
  ParticlesData_set__rng_s1(dest, id,       LocalParticle_get__rng_s1(source));
  ParticlesData_set__rng_s2(dest, id,       LocalParticle_get__rng_s2(source));
  ParticlesData_set__rng_s3(dest, id,       LocalParticle_get__rng_s3(source));
  ParticlesData_set__rng_s4(dest, id,       LocalParticle_get__rng_s4(source));
}

 static inline
double LocalParticle_get_xp(LocalParticle* part){
    double const px = LocalParticle_get_px(part);
    double const rpp = LocalParticle_get_rpp(part);
    // INFO: this is not the angle, but sin(angle)
    return px*rpp;
}

 static inline
double LocalParticle_get_yp(LocalParticle* part){
    double const py = LocalParticle_get_py(part);
    double const rpp = LocalParticle_get_rpp(part);
    // INFO: this is not the angle, but sin(angle)
    return py*rpp;
}

 static inline
void LocalParticle_set_xp(LocalParticle* part, double xp){
#ifndef FREEZE_VAR_px
    double rpp = LocalParticle_get_rpp(part);
    // INFO: xp is not the angle, but sin(angle)
    LocalParticle_set_px(part, xp/rpp);
#endif
}

 static inline
void LocalParticle_set_yp(LocalParticle* part, double yp){
#ifndef FREEZE_VAR_py
    double rpp = LocalParticle_get_rpp(part);
    // INFO: yp is not the angle, but sin(angle)
    LocalParticle_set_py(part, yp/rpp);
#endif
}

 static inline
void LocalParticle_add_to_xp(LocalParticle* part, double xp){
#ifndef FREEZE_VAR_px
    LocalParticle_set_xp(part, LocalParticle_get_xp(part) + xp);
#endif
}

 static inline
void LocalParticle_scale_xp(LocalParticle* part, double value){
#ifndef FREEZE_VAR_px
    LocalParticle_set_xp(part, LocalParticle_get_xp(part) * value);
#endif
}

 static inline
void LocalParticle_add_to_yp(LocalParticle* part, double yp){
#ifndef FREEZE_VAR_py
    LocalParticle_set_yp(part, LocalParticle_get_yp(part) + yp);
#endif
}

 static inline
void LocalParticle_scale_yp(LocalParticle* part, double value){
#ifndef FREEZE_VAR_py
    LocalParticle_set_yp(part, LocalParticle_get_yp(part) * value);
#endif
}

 static inline
void LocalParticle_set_xp_yp(LocalParticle* part, double xp, double yp){
    double rpp = LocalParticle_get_rpp(part);
#ifndef FREEZE_VAR_px
    LocalParticle_set_px(part, xp/rpp);
#endif
#ifndef FREEZE_VAR_py
    LocalParticle_set_py(part, yp/rpp);
#endif
}

 static inline
void LocalParticle_add_to_xp_yp(LocalParticle* part, double xp, double yp){
    LocalParticle_set_xp_yp(part, LocalParticle_get_xp(part) + xp, LocalParticle_get_yp(part) + yp);
}

 static inline
void LocalParticle_scale_xp_yp(LocalParticle* part, double value_x, double value_y){
    LocalParticle_set_xp_yp(part, LocalParticle_get_xp(part) * value_x, LocalParticle_get_yp(part) * value_y);
}
 static inline
double LocalParticle_get_exact_xp(LocalParticle* part){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);
    double const rpp = 1./sqrt(one_plus_delta*one_plus_delta - px*px - py*py);
    // INFO: this is not the angle, but sin(angle)
    return px*rpp;
}

 static inline
double LocalParticle_get_exact_yp(LocalParticle* part){
    double const py = LocalParticle_get_py(part);
    double const px = LocalParticle_get_px(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);
    double const rpp = 1./sqrt(one_plus_delta*one_plus_delta - px*px - py*py);
    // INFO: this is not the angle, but sin(angle)
    return py*rpp;
}

 static inline
void LocalParticle_set_exact_xp(LocalParticle* part, double xp){
#ifndef FREEZE_VAR_px
    double rpp = LocalParticle_get_rpp(part);
    // Careful! If yp also changes, use LocalParticle_set_exact_xp_yp!
    double const yp = LocalParticle_get_exact_yp(part);
    rpp *= sqrt(1 + xp*xp + yp*yp);
    // INFO: xp is not the angle, but sin(angle)
    LocalParticle_set_px(part, xp/rpp);
#endif
}

 static inline
void LocalParticle_set_exact_yp(LocalParticle* part, double yp){
#ifndef FREEZE_VAR_py
    double rpp = LocalParticle_get_rpp(part);
    // Careful! If xp also changes, use LocalParticle_set_exact_xp_yp!
    double const xp = LocalParticle_get_exact_xp(part);
    rpp *= sqrt(1 + xp*xp + yp*yp);
    // INFO: yp is not the angle, but sin(angle)
    LocalParticle_set_py(part, yp/rpp);
#endif
}

 static inline
void LocalParticle_add_to_exact_xp(LocalParticle* part, double xp){
#ifndef FREEZE_VAR_px
    LocalParticle_set_exact_xp(part, LocalParticle_get_exact_xp(part) + xp);
#endif
}

 static inline
void LocalParticle_scale_exact_xp(LocalParticle* part, double value){
#ifndef FREEZE_VAR_px
    LocalParticle_set_exact_xp(part, LocalParticle_get_exact_xp(part) * value);
#endif
}

 static inline
void LocalParticle_add_to_exact_yp(LocalParticle* part, double yp){
#ifndef FREEZE_VAR_py
    LocalParticle_set_exact_yp(part, LocalParticle_get_exact_yp(part) + yp);
#endif
}

 static inline
void LocalParticle_scale_exact_yp(LocalParticle* part, double value){
#ifndef FREEZE_VAR_py
    LocalParticle_set_exact_yp(part, LocalParticle_get_exact_yp(part) * value);
#endif
}

 static inline
void LocalParticle_set_exact_xp_yp(LocalParticle* part, double xp, double yp){
    double rpp = LocalParticle_get_rpp(part);
    rpp *= sqrt(1 + xp*xp + yp*yp);
#ifndef FREEZE_VAR_px
    LocalParticle_set_px(part, xp/rpp);
#endif
#ifndef FREEZE_VAR_py
    LocalParticle_set_py(part, yp/rpp);
#endif
}

 static inline
void LocalParticle_add_to_exact_xp_yp(LocalParticle* part, double xp, double yp){
    LocalParticle_set_exact_xp_yp(part, LocalParticle_get_exact_xp(part) + xp, LocalParticle_get_exact_yp(part) + yp);
}

 static inline
void LocalParticle_scale_exact_xp_yp(LocalParticle* part, double value_x, double value_y){
    LocalParticle_set_exact_xp_yp(part, LocalParticle_get_exact_xp(part) * value_x, LocalParticle_get_exact_yp(part) * value_y);
}


         static inline
        double LocalParticle_get_energy0(LocalParticle* part){

            double const p0c = LocalParticle_get_p0c(part);
            double const m0  = LocalParticle_get_mass0(part);

            return sqrt( p0c * p0c + m0 * m0 );
        }

         static inline
        void LocalParticle_update_ptau(LocalParticle* part, double new_ptau_value){

            double const beta0 = LocalParticle_get_beta0(part);

            double const ptau = new_ptau_value;

            double const irpp = sqrt(ptau*ptau + 2*ptau/beta0 +1);

            double const new_rpp = 1./irpp;
            LocalParticle_set_delta(part, irpp - 1.);

            double const new_rvv = irpp/(1 + beta0*ptau);
            LocalParticle_set_rvv(part, new_rvv);
            LocalParticle_set_ptau(part, ptau);

            LocalParticle_set_rpp(part, new_rpp );
        }

         static inline
        void LocalParticle_update_delta(LocalParticle* part, double new_delta_value){
            double const beta0 = LocalParticle_get_beta0(part);
            double const delta_beta0 = new_delta_value * beta0;
            double const ptau_beta0  = sqrt( delta_beta0 * delta_beta0 +
                                        2. * delta_beta0 * beta0 + 1. ) - 1.;

            double const one_plus_delta = 1. + new_delta_value;
            double const rvv    = ( one_plus_delta ) / ( 1. + ptau_beta0 );
            double const rpp    = 1. / one_plus_delta;
            double const ptau = ptau_beta0 / beta0;

            LocalParticle_set_delta(part, new_delta_value);

            LocalParticle_set_rvv(part, rvv );
            LocalParticle_set_rpp(part, rpp );
            LocalParticle_set_ptau(part, ptau );

        }

         static inline
        double LocalParticle_get_pzeta(LocalParticle* part){

            double const ptau = LocalParticle_get_ptau(part);
            double const beta0 = LocalParticle_get_beta0(part);

            return ptau/beta0;

        }

         static inline
        void LocalParticle_update_pzeta(LocalParticle* part, double new_pzeta_value){

            double const beta0 = LocalParticle_get_beta0(part);
            LocalParticle_update_ptau(part, beta0*new_pzeta_value);

        }

         static inline
        void increment_at_element(LocalParticle* part0, int64_t const increment){


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

                LocalParticle_add_to_at_element(part, increment);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


        }

         static inline
        void increment_at_turn(LocalParticle* part0, int flag_reset_s){


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            LocalParticle_add_to_at_turn(part, 1);
            LocalParticle_set_at_element(part, 0);
            if (flag_reset_s>0){
                LocalParticle_set_s(part, 0.);
            }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

        }

         static inline
        void increment_at_turn_backtrack(LocalParticle* part0, int flag_reset_s,
                                         double const line_length,
                                         int64_t const num_elements){


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            LocalParticle_add_to_at_turn(part, -1);
            LocalParticle_set_at_element(part, num_elements);
            if (flag_reset_s>0){
                LocalParticle_set_s(part, line_length);
            }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

        }

        // check_is_active has different implementation on CPU and GPU

        #define CPU_SERIAL_IMPLEM //only_for_context cpu_serial
//        #define CPU_OMP_IMPLEM //only_for_context cpu_openmp

        #ifdef CPU_SERIAL_IMPLEM

         static inline
        int64_t check_is_active(LocalParticle* part) {
            int64_t ipart=0;
            while (ipart < part->_num_active_particles){
                #ifdef XSUITE_RESTORE_LOSS
                ipart++;
                #else
                if (part->state[ipart]<1){
                    LocalParticle_exchange(
                        part, ipart, part->_num_active_particles-1);
                    part->_num_active_particles--;
                    part->_num_lost_particles++;
                }
                else{
                    ipart++;
                }
                #endif
            }

            if (part->_num_active_particles==0){
                return 0;//All particles lost
            } else {
                return 1; //Some stable particles are still present
            }
        }

        #else // not CPU_SERIAL_IMPLEM
        #ifdef CPU_OMP_IMPLEM

         static inline
        int64_t check_is_active(LocalParticle* part) {
        #ifndef SKIP_SWAPS
            int64_t ipart = part->ipart;
            int64_t endpart = part->endpart;

            int64_t left = ipart;
            int64_t right = endpart - 1;
            int64_t swap_made = 0;
            int64_t has_alive = 0;

            if (left == right) return part->state[left] > 0;

            while (left < right) {
                if (part->state[left] > 0) {
                    left++;
                    has_alive = 1;
                }
                else if (part->state[right] <= 0) right--;
                else {
                    LocalParticle_exchange(part, left, right);
                    left++;
                    right--;
                    swap_made = 1;
                }
            }

            return swap_made || has_alive;
        #else
            return 1;
        #endif
        }

         static inline
        void count_reorganized_particles(LocalParticle* part) {
            int64_t num_active = 0;
            int64_t num_lost = 0;

            for (int64_t i = part->ipart; i < part->endpart; i++) {
                if (part->state[i] <= -999999999) break;
                else if (part->state[i] > 0) num_active++;
                else num_lost++;
            }

            part->_num_active_particles = num_active;
            part->_num_lost_particles = num_lost;
        }

        #else // not CPU_SERIAL_IMPLEM and not CPU_OMP_IMPLEM

         static inline
        int64_t check_is_active(LocalParticle* part) {
            return LocalParticle_get_state(part)>0;
        };

        #endif // CPU_OMP_IMPLEM
        #endif // CPU_SERIAL_IMPLEM

        #undef CPU_SERIAL_IMPLEM //only_for_context cpu_serial
//        #undef CPU_OMP_IMPLEM //only_for_context cpu_openmp


        
                    #ifdef XTRACK_GLOBAL_XY_LIMIT

                     static inline
                    void global_aperture_check(LocalParticle* part0) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

                            double const x = LocalParticle_get_x(part);
                            double const y = LocalParticle_get_y(part);

                        int64_t const is_alive = (int64_t)(
                                  (x >= -XTRACK_GLOBAL_XY_LIMIT) &&
                                  (x <=  XTRACK_GLOBAL_XY_LIMIT) &&
                                  (y >= -XTRACK_GLOBAL_XY_LIMIT) &&
                                  (y <=  XTRACK_GLOBAL_XY_LIMIT) );

                        // I assume that if I am in the function is because
                            if (!is_alive){
                               LocalParticle_set_state(part, -1);
                        }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

                    }

                    #endif

                     static inline
                    void LocalParticle_add_to_energy(LocalParticle* part, double delta_energy, int pz_only ){
                        double ptau = LocalParticle_get_ptau(part);
                        double const p0c = LocalParticle_get_p0c(part);
                        double const charge_ratio = LocalParticle_get_charge_ratio(part);
                        double const chi = LocalParticle_get_chi(part);
                        double const mass_ratio = charge_ratio / chi;

                        ptau += delta_energy/p0c / mass_ratio;

                        double const old_rpp = LocalParticle_get_rpp(part);

                        LocalParticle_update_ptau(part, ptau);

                        if (!pz_only) {
                            double const new_rpp = LocalParticle_get_rpp(part);
                            double const f = old_rpp / new_rpp;
                            LocalParticle_scale_px(part, f);
                            LocalParticle_scale_py(part, f);
                        }
                    }


                     static inline
                    void LocalParticle_update_p0c(LocalParticle* part, double new_p0c_value){

                        double const mass0 = LocalParticle_get_mass0(part);
                        double const old_p0c = LocalParticle_get_p0c(part);
                        double const old_delta = LocalParticle_get_delta(part);
                        double const old_beta0 = LocalParticle_get_beta0(part);

                        double const ppc = old_p0c * old_delta + old_p0c;
                        double const new_delta = (ppc - new_p0c_value)/new_p0c_value;

                        double const new_energy0 = sqrt(new_p0c_value*new_p0c_value + mass0 * mass0);
                        double const new_beta0 = new_p0c_value / new_energy0;
                        double const new_gamma0 = new_energy0 / mass0;

                        LocalParticle_set_p0c(part, new_p0c_value);
                        LocalParticle_set_gamma0(part, new_gamma0);
                        LocalParticle_set_beta0(part, new_beta0);

                        LocalParticle_update_delta(part, new_delta);

                        LocalParticle_scale_px(part, old_p0c/new_p0c_value);
                        LocalParticle_scale_py(part, old_p0c/new_p0c_value);

                        LocalParticle_scale_zeta(part, new_beta0/old_beta0);

                    }

                     static inline
                    void LocalParticle_kill_particle(LocalParticle* part, int64_t kill_state) {
                        LocalParticle_set_x(part, 1e30);
                        LocalParticle_set_px(part, 1e30);
                        LocalParticle_set_y(part, 1e30);
                        LocalParticle_set_py(part, 1e30);
                        LocalParticle_set_zeta(part, 1e30);
                        LocalParticle_update_delta(part, -1);  // zero energy
                        LocalParticle_set_state(part, kill_state);
                    }
                 

#ifndef XOBJ_TYPEDEF_LastTurnsData
#define XOBJ_TYPEDEF_LastTurnsData
typedef   struct LastTurnsData_s * LastTurnsData;
 static inline LastTurnsData LastTurnsData_getp(LastTurnsData restrict  obj){
  int64_t offset=0;
  return (LastTurnsData)(( char*) obj+offset);
}
 static inline ArrNUint32 LastTurnsData_getp_lost_at_offset(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_lost_at_offset(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=72;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t LastTurnsData_get_lost_at_offset(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_lost_at_offset(LastTurnsData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* LastTurnsData_getp1_lost_at_offset(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 LastTurnsData_getp_particle_id(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_particle_id(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t LastTurnsData_get_particle_id(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_particle_id(LastTurnsData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* LastTurnsData_getp1_particle_id(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 LastTurnsData_getp_at_turn(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_at_turn(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t LastTurnsData_get_at_turn(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_at_turn(LastTurnsData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* LastTurnsData_getp1_at_turn(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsData_getp_x(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_x(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsData_get_x(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_x(LastTurnsData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsData_getp1_x(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsData_getp_px(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_px(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsData_get_px(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_px(LastTurnsData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsData_getp1_px(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsData_getp_y(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_y(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsData_get_y(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_y(LastTurnsData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsData_getp1_y(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsData_getp_py(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_py(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsData_get_py(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_py(LastTurnsData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsData_getp1_py(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsData_getp_delta(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_delta(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsData_get_delta(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_delta(LastTurnsData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsData_getp1_delta(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsData_getp_zeta(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsData_len_zeta(LastTurnsData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsData_get_zeta(const LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsData_set_zeta(LastTurnsData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsData_getp1_zeta(LastTurnsData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_LimitEllipseData
#define XOBJ_TYPEDEF_LimitEllipseData
typedef   struct LimitEllipseData_s * LimitEllipseData;
 static inline LimitEllipseData LimitEllipseData_getp(LimitEllipseData restrict  obj){
  int64_t offset=0;
  return (LimitEllipseData)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get_a_squ(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set_a_squ(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp_a_squ(LimitEllipseData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get_b_squ(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set_b_squ(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp_b_squ(LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get_a_b_squ(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set_a_b_squ(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp_a_b_squ(LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get__sin_rot_s(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set__sin_rot_s(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp__sin_rot_s(LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get__cos_rot_s(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set__cos_rot_s(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp__cos_rot_s(LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get__shift_x(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set__shift_x(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp__shift_x(LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get__shift_y(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set__shift_y(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp__shift_y(LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitEllipseData_get__shift_s(const LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitEllipseData_set__shift_s(LimitEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitEllipseData_getp__shift_s(LimitEllipseData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/apertures_src/limitellipse.h>

             static inline
            void LimitEllipse_track_local_particle_with_transformations(LimitEllipseData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LimitEllipseData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitEllipseData_get__cos_rot_s(el);
    double const shift_x = LimitEllipseData_get__shift_x(el);
    double const shift_y = LimitEllipseData_get__shift_y(el);
    double const shift_s = LimitEllipseData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LimitEllipse_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitEllipseData_get__cos_rot_s(el);
    double const shift_x = LimitEllipseData_get__shift_x(el);
    double const shift_y = LimitEllipseData_get__shift_y(el);
    double const shift_s = LimitEllipseData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LimitEllipse_track_particles(
               LimitEllipseData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LimitEllipse_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_XYShiftData
#define XOBJ_TYPEDEF_XYShiftData
typedef   struct XYShiftData_s * XYShiftData;
 static inline XYShiftData XYShiftData_getp(XYShiftData restrict  obj){
  int64_t offset=0;
  return (XYShiftData)(( char*) obj+offset);
}
 static inline double XYShiftData_get_dx(const XYShiftData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void XYShiftData_set_dx(XYShiftData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XYShiftData_getp_dx(XYShiftData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double XYShiftData_get_dy(const XYShiftData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void XYShiftData_set_dy(XYShiftData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XYShiftData_getp_dy(XYShiftData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/xyshift.h>

             static inline
            void XYShift_track_local_particle_with_transformations(XYShiftData el, LocalParticle* part0){
    XYShift_track_local_particle(el, part0);
}


             
            void XYShift_track_particles(
               XYShiftData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              XYShift_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_MarkerData
#define XOBJ_TYPEDEF_MarkerData
typedef   struct MarkerData_s * MarkerData;
 static inline MarkerData MarkerData_getp(MarkerData restrict  obj){
  int64_t offset=0;
  return (MarkerData)(( char*) obj+offset);
}
 static inline int64_t MarkerData_get__dummy(const MarkerData restrict  obj){
  int64_t offset=0;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MarkerData_set__dummy(MarkerData restrict  obj, int64_t value){
  int64_t offset=0;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MarkerData_getp__dummy(MarkerData restrict  obj){
  int64_t offset=0;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/marker.h>

             static inline
            void Marker_track_local_particle_with_transformations(MarkerData el, LocalParticle* part0){
    Marker_track_local_particle(el, part0);
}


             
            void Marker_track_particles(
               MarkerData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Marker_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_LimitRectData
#define XOBJ_TYPEDEF_LimitRectData
typedef   struct LimitRectData_s * LimitRectData;
 static inline LimitRectData LimitRectData_getp(LimitRectData restrict  obj){
  int64_t offset=0;
  return (LimitRectData)(( char*) obj+offset);
}
 static inline double LimitRectData_get_min_x(const LimitRectData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set_min_x(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp_min_x(LimitRectData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get_max_x(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set_max_x(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp_max_x(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get_min_y(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set_min_y(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp_min_y(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get_max_y(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set_max_y(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp_max_y(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get__sin_rot_s(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set__sin_rot_s(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp__sin_rot_s(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get__cos_rot_s(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set__cos_rot_s(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp__cos_rot_s(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get__shift_x(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set__shift_x(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp__shift_x(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get__shift_y(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set__shift_y(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp__shift_y(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectData_get__shift_s(const LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectData_set__shift_s(LimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectData_getp__shift_s(LimitRectData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/apertures_src/limitrect.h>

             static inline
            void LimitRect_track_local_particle_with_transformations(LimitRectData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LimitRectData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitRectData_get__cos_rot_s(el);
    double const shift_x = LimitRectData_get__shift_x(el);
    double const shift_y = LimitRectData_get__shift_y(el);
    double const shift_s = LimitRectData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LimitRect_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitRectData_get__cos_rot_s(el);
    double const shift_x = LimitRectData_get__shift_x(el);
    double const shift_y = LimitRectData_get__shift_y(el);
    double const shift_s = LimitRectData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LimitRect_track_particles(
               LimitRectData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LimitRect_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_DriftData
#define XOBJ_TYPEDEF_DriftData
typedef   struct DriftData_s * DriftData;
 static inline DriftData DriftData_getp(DriftData restrict  obj){
  int64_t offset=0;
  return (DriftData)(( char*) obj+offset);
}
 static inline double DriftData_get_length(const DriftData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftData_set_length(DriftData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftData_getp_length(DriftData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/drift.h>

             static inline
            void Drift_track_local_particle_with_transformations(DriftData el, LocalParticle* part0){
    Drift_track_local_particle(el, part0);
}


             
            void Drift_track_particles(
               DriftData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Drift_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_MultipoleEdgeData
#define XOBJ_TYPEDEF_MultipoleEdgeData
typedef   struct MultipoleEdgeData_s * MultipoleEdgeData;
 static inline MultipoleEdgeData MultipoleEdgeData_getp(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  return (MultipoleEdgeData)(( char*) obj+offset);
}
 static inline ArrNFloat64 MultipoleEdgeData_getp_kn(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t MultipoleEdgeData_len_kn(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=72;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double MultipoleEdgeData_get_kn(const MultipoleEdgeData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set_kn(MultipoleEdgeData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleEdgeData_getp1_kn(MultipoleEdgeData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=72;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 MultipoleEdgeData_getp_ks(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t MultipoleEdgeData_len_ks(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double MultipoleEdgeData_get_ks(const MultipoleEdgeData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set_ks(MultipoleEdgeData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleEdgeData_getp1_ks(MultipoleEdgeData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t MultipoleEdgeData_get_is_exit(const MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set_is_exit(MultipoleEdgeData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MultipoleEdgeData_getp_is_exit(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MultipoleEdgeData_get_order(const MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set_order(MultipoleEdgeData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MultipoleEdgeData_getp_order(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double MultipoleEdgeData_get__sin_rot_s(const MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set__sin_rot_s(MultipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleEdgeData_getp__sin_rot_s(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleEdgeData_get__cos_rot_s(const MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set__cos_rot_s(MultipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleEdgeData_getp__cos_rot_s(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleEdgeData_get__shift_x(const MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set__shift_x(MultipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleEdgeData_getp__shift_x(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleEdgeData_get__shift_y(const MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set__shift_y(MultipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleEdgeData_getp__shift_y(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleEdgeData_get__shift_s(const MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleEdgeData_set__shift_s(MultipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleEdgeData_getp__shift_s(MultipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/multipoleedge.h>

             static inline
            void MultipoleEdge_track_local_particle_with_transformations(MultipoleEdgeData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = MultipoleEdgeData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = MultipoleEdgeData_get__cos_rot_s(el);
    double const shift_x = MultipoleEdgeData_get__shift_x(el);
    double const shift_y = MultipoleEdgeData_get__shift_y(el);
    double const shift_s = MultipoleEdgeData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    MultipoleEdge_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = MultipoleEdgeData_get__cos_rot_s(el);
    double const shift_x = MultipoleEdgeData_get__shift_x(el);
    double const shift_y = MultipoleEdgeData_get__shift_y(el);
    double const shift_s = MultipoleEdgeData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void MultipoleEdge_track_particles(
               MultipoleEdgeData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              MultipoleEdge_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RFMultipoleData
#define XOBJ_TYPEDEF_RFMultipoleData
typedef   struct RFMultipoleData_s * RFMultipoleData;
 static inline RFMultipoleData RFMultipoleData_getp(RFMultipoleData restrict  obj){
  int64_t offset=0;
  return (RFMultipoleData)(( char*) obj+offset);
}
 static inline int64_t RFMultipoleData_get_order(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_order(RFMultipoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RFMultipoleData_getp_order(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get_voltage(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_voltage(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp_voltage(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get_frequency(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_frequency(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp_frequency(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get_lag(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_lag(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp_lag(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 RFMultipoleData_getp_knl(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t RFMultipoleData_len_knl(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double RFMultipoleData_get_knl(const RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=104;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_knl(RFMultipoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=104;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp1_knl(RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=104;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 RFMultipoleData_getp_ksl(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t RFMultipoleData_len_ksl(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double RFMultipoleData_get_ksl(const RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_ksl(RFMultipoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp1_ksl(RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 RFMultipoleData_getp_pn(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t RFMultipoleData_len_pn(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double RFMultipoleData_get_pn(const RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_pn(RFMultipoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp1_pn(RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 RFMultipoleData_getp_ps(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t RFMultipoleData_len_ps(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double RFMultipoleData_get_ps(const RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set_ps(RFMultipoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp1_ps(RFMultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get__sin_rot_s(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set__sin_rot_s(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp__sin_rot_s(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get__cos_rot_s(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set__cos_rot_s(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp__cos_rot_s(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get__shift_x(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set__shift_x(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp__shift_x(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get__shift_y(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set__shift_y(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp__shift_y(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double RFMultipoleData_get__shift_s(const RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void RFMultipoleData_set__shift_s(RFMultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RFMultipoleData_getp__shift_s(RFMultipoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/rfmultipole.h>

             static inline
            void RFMultipole_track_local_particle_with_transformations(RFMultipoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = RFMultipoleData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = RFMultipoleData_get__cos_rot_s(el);
    double const shift_x = RFMultipoleData_get__shift_x(el);
    double const shift_y = RFMultipoleData_get__shift_y(el);
    double const shift_s = RFMultipoleData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    RFMultipole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = RFMultipoleData_get__cos_rot_s(el);
    double const shift_x = RFMultipoleData_get__shift_x(el);
    double const shift_y = RFMultipoleData_get__shift_y(el);
    double const shift_s = RFMultipoleData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void RFMultipole_track_particles(
               RFMultipoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              RFMultipole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_BeamPositionMonitorData
#define XOBJ_TYPEDEF_BeamPositionMonitorData
typedef   struct BeamPositionMonitorData_s * BeamPositionMonitorData;
 static inline BeamPositionMonitorData BeamPositionMonitorData_getp(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  return (BeamPositionMonitorData)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_get_particle_id_start(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_particle_id_start(BeamPositionMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamPositionMonitorData_getp_particle_id_start(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_get_num_particles(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_num_particles(BeamPositionMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamPositionMonitorData_getp_num_particles(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_get_start_at_turn(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_start_at_turn(BeamPositionMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamPositionMonitorData_getp_start_at_turn(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_get_stop_at_turn(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_stop_at_turn(BeamPositionMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamPositionMonitorData_getp_stop_at_turn(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BeamPositionMonitorData_get_frev(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_frev(BeamPositionMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp_frev(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamPositionMonitorData_get_sampling_frequency(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_sampling_frequency(BeamPositionMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp_sampling_frequency(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIndex BeamPositionMonitorData_getp__index(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_get__index_capacity(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__index_capacity(BeamPositionMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamPositionMonitorData_getp__index_capacity(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamPositionMonitorData_get__index_num_recorded(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__index_num_recorded(BeamPositionMonitorData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=64;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamPositionMonitorData_getp__index_num_recorded(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamPositionMonitorData_get__index__dummy(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__index__dummy(BeamPositionMonitorData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=72;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamPositionMonitorData_getp__index__dummy(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_get__index_buffer_id(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__index_buffer_id(BeamPositionMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamPositionMonitorData_getp__index_buffer_id(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline BeamPositionMonitorRecord BeamPositionMonitorData_getp_data(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return (BeamPositionMonitorRecord)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamPositionMonitorData_getp_data_count(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_len_data_count(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamPositionMonitorData_get_data_count(const BeamPositionMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=152;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_data_count(BeamPositionMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=152;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp1_data_count(BeamPositionMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=152;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamPositionMonitorData_getp_data_x_sum(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_len_data_x_sum(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamPositionMonitorData_get_data_x_sum(const BeamPositionMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_data_x_sum(BeamPositionMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp1_data_x_sum(BeamPositionMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamPositionMonitorData_getp_data_y_sum(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamPositionMonitorData_len_data_y_sum(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamPositionMonitorData_get_data_y_sum(const BeamPositionMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set_data_y_sum(BeamPositionMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp1_data_y_sum(BeamPositionMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamPositionMonitorData_get__sin_rot_s(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__sin_rot_s(BeamPositionMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp__sin_rot_s(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamPositionMonitorData_get__cos_rot_s(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__cos_rot_s(BeamPositionMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp__cos_rot_s(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamPositionMonitorData_get__shift_x(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__shift_x(BeamPositionMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp__shift_x(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamPositionMonitorData_get__shift_y(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__shift_y(BeamPositionMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp__shift_y(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamPositionMonitorData_get__shift_s(const BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamPositionMonitorData_set__shift_s(BeamPositionMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamPositionMonitorData_getp__shift_s(BeamPositionMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef _ATOMICADD_H_
#define _ATOMICADD_H_

#define ATOMICADD_CPU  //only_for_context cpu_serial cpu_openmp
//#define ATOMICADD_OPENCL //only_for_context opencl
// CUDA provides atomicAdd() natively

#ifdef ATOMICADD_CPU
inline void atomicAdd(double *addr, double val)
{
//   #pragma omp atomic //only_for_context cpu_openmp
   *addr = *addr + val;
}
#endif // ATOMICADD_CPU

#ifdef ATOMICADD_OPENCL
#pragma OPENCL EXTENSION cl_khr_int64_base_atomics : enable
inline void atomicAdd(volatile __global double *addr, double val)
{
	union {
		long u64;
		double f64;
	} next, expected, current;
	current.f64 = *addr;
	do {
		expected.f64 = current.f64;
		next.f64 = expected.f64 + val;
		current.u64 = atom_cmpxchg(
			(volatile __global long *)addr,
		        (long) expected.u64,
			(long) next.u64);
	} while( current.u64 != expected.u64 );
}
#endif // ATOMICADD_OPENCL

#endif

// ##################################
// Beam Monitor
// 
// Author: Rahul Singh, Philipp Niedermayer
// Date: 2023-06-10
// ##################################


#ifndef XTRACK_BEAM_POSITION_MONITOR_H
#define XTRACK_BEAM_POSITION_MONITOR_H

#include <headers/track.h>


GPUFUN
void BeamPositionMonitor_track_local_particle(BeamPositionMonitorData el, LocalParticle* part0){

    // get parameters
    int64_t const start_at_turn = BeamPositionMonitorData_get_start_at_turn(el);
    int64_t particle_id_start = BeamPositionMonitorData_get_particle_id_start(el);
    int64_t particle_id_stop = particle_id_start + BeamPositionMonitorData_get_num_particles(el);
    double const frev = BeamPositionMonitorData_get_frev(el);
    double const sampling_frequency = BeamPositionMonitorData_get_sampling_frequency(el);

    BeamPositionMonitorRecord record = BeamPositionMonitorData_getp_data(el);

    int64_t max_slot = BeamPositionMonitorRecord_len_count(record);

    START_PER_PARTICLE_BLOCK(part0, part);
        int64_t particle_id = LocalParticle_get_particle_id(part);
        if (particle_id_stop < 0 || (particle_id_start <= particle_id && particle_id < particle_id_stop))
        {
            // zeta is the absolute path length deviation from the reference particle: zeta = (s - beta0*c*t)
            // but without limits, i.e. it can exceed the circumference (for coasting beams)
            // as the particle falls behind or overtakes the reference particle
            double const zeta = LocalParticle_get_zeta(part);
            double const at_turn = LocalParticle_get_at_turn(part);
            double const beta0 = LocalParticle_get_beta0(part);

            // compute sample index
            int64_t slot = round(sampling_frequency * ( (at_turn-start_at_turn)/frev - zeta/beta0/C_LIGHT ));

            if (slot >= 0 && slot < max_slot){
                double x = LocalParticle_get_x(part);
                double y = LocalParticle_get_y(part);

                GPUGLMEM double * count = BeamPositionMonitorRecord_getp1_count(record, slot);
                atomicAdd(count, 1.0);

                GPUGLMEM double * x_sum = BeamPositionMonitorRecord_getp1_x_sum(record, slot);
                atomicAdd(x_sum, x);

                GPUGLMEM double * y_sum = BeamPositionMonitorRecord_getp1_y_sum(record, slot);
                atomicAdd(y_sum, y);
            }
        }
    END_PER_PARTICLE_BLOCK;
}

#endif



             static inline
            void BeamPositionMonitor_track_local_particle_with_transformations(BeamPositionMonitorData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = BeamPositionMonitorData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamPositionMonitorData_get__cos_rot_s(el);
    double const shift_x = BeamPositionMonitorData_get__shift_x(el);
    double const shift_y = BeamPositionMonitorData_get__shift_y(el);
    double const shift_s = BeamPositionMonitorData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    BeamPositionMonitor_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamPositionMonitorData_get__cos_rot_s(el);
    double const shift_x = BeamPositionMonitorData_get__shift_x(el);
    double const shift_y = BeamPositionMonitorData_get__shift_y(el);
    double const shift_s = BeamPositionMonitorData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void BeamPositionMonitor_track_particles(
               BeamPositionMonitorData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              BeamPositionMonitor_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ParticlesMonitorData
#define XOBJ_TYPEDEF_ParticlesMonitorData
typedef   struct ParticlesMonitorData_s * ParticlesMonitorData;
 static inline ParticlesMonitorData ParticlesMonitorData_getp(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  return (ParticlesMonitorData)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_start_at_turn(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_start_at_turn(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_start_at_turn(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_stop_at_turn(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_stop_at_turn(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_stop_at_turn(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_part_id_start(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_part_id_start(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_part_id_start(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_part_id_end(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_part_id_end(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_part_id_end(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_ebe_mode(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_ebe_mode(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_ebe_mode(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_n_records(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_n_records(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_n_records(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_n_repetitions(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_n_repetitions(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_n_repetitions(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_repetition_period(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_repetition_period(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_repetition_period(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_flag_auto_to_numpy(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_flag_auto_to_numpy(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_flag_auto_to_numpy(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ParticlesData ParticlesMonitorData_getp_data(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return (ParticlesData)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_data__capacity(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data__capacity(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=128;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_data__capacity(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_data__num_active_particles(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data__num_active_particles(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=136;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_data__num_active_particles(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_data__num_lost_particles(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data__num_lost_particles(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_data__num_lost_particles(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_get_data_start_tracking_at_element(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_start_tracking_at_element(ParticlesMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp_data_start_tracking_at_element(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get_data_q0(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_q0(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp_data_q0(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get_data_mass0(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_mass0(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp_data_mass0(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get_data_t_sim(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_t_sim(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=176;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp_data_t_sim(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_p0c(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=432;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_p0c(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=432;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_p0c(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=432;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_p0c(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=432;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_p0c(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=432;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_gamma0(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_gamma0(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_gamma0(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_gamma0(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_gamma0(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_beta0(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_beta0(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+72);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_beta0(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_beta0(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_beta0(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_s(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_s(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+80);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_s(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_s(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_s(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+80);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_zeta(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_zeta(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+88);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_zeta(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_zeta(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_zeta(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+88);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_x(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_x(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+96);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_x(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_x(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_x(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+96);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_y(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_y(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+104);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_y(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_y(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_y(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+104);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_px(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_px(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+112);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_px(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_px(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_px(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_py(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_py(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+120);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_py(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_py(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_py(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+120);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_ptau(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_ptau(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+128);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_ptau(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_ptau(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_ptau(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+128);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_delta(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_delta(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+136);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_delta(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_delta(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_delta(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+136);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_rpp(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_rpp(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+144);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_rpp(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_rpp(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_rpp(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+144);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_rvv(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_rvv(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+152);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_rvv(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_rvv(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_rvv(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+152);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_chi(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_chi(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_chi(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_chi(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_chi(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_charge_ratio(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_charge_ratio(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+168);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_charge_ratio(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_charge_ratio(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_charge_ratio(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+168);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_weight(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_weight(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+176);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_weight(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_weight(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_weight(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+176);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_ax(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_ax(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+184);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_ax(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_ax(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_ax(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+184);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_ay(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_ay(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+192);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_ay(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_ay(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_ay(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+192);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_spin_x(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_spin_x(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+200);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_spin_x(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_spin_x(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_spin_x(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+200);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_spin_y(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_spin_y(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+208);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_spin_y(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_spin_y(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_spin_y(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+208);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_spin_z(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_spin_z(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+216);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_spin_z(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_spin_z(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_spin_z(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+216);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ParticlesMonitorData_getp_data_anomalous_magnetic_moment(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_anomalous_magnetic_moment(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+224);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ParticlesMonitorData_get_data_anomalous_magnetic_moment(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_anomalous_magnetic_moment(ParticlesMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp1_data_anomalous_magnetic_moment(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+224);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesMonitorData_getp_data_pdg_id(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_pdg_id(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+232);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesMonitorData_get_data_pdg_id(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_pdg_id(ParticlesMonitorData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp1_data_pdg_id(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+232);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesMonitorData_getp_data_particle_id(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_particle_id(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+240);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesMonitorData_get_data_particle_id(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_particle_id(ParticlesMonitorData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp1_data_particle_id(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+240);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesMonitorData_getp_data_at_element(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_at_element(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+248);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesMonitorData_get_data_at_element(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_at_element(ParticlesMonitorData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp1_data_at_element(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+248);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesMonitorData_getp_data_at_turn(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_at_turn(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+256);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesMonitorData_get_data_at_turn(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_at_turn(ParticlesMonitorData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp1_data_at_turn(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+256);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesMonitorData_getp_data_state(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_state(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesMonitorData_get_data_state(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_state(ParticlesMonitorData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp1_data_state(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNInt64 ParticlesMonitorData_getp_data_parent_particle_id(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNInt64)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data_parent_particle_id(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline int64_t ParticlesMonitorData_get_data_parent_particle_id(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data_parent_particle_id(ParticlesMonitorData restrict  obj, int64_t i0, int64_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ParticlesMonitorData_getp1_data_parent_particle_id(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesMonitorData_getp_data__rng_s1(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data__rng_s1(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+280);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesMonitorData_get_data__rng_s1(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data__rng_s1(ParticlesMonitorData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesMonitorData_getp1_data__rng_s1(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+280);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesMonitorData_getp_data__rng_s2(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data__rng_s2(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+288);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesMonitorData_get_data__rng_s2(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data__rng_s2(ParticlesMonitorData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesMonitorData_getp1_data__rng_s2(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+288);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesMonitorData_getp_data__rng_s3(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data__rng_s3(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+296);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesMonitorData_get_data__rng_s3(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data__rng_s3(ParticlesMonitorData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesMonitorData_getp1_data__rng_s3(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+296);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 ParticlesMonitorData_getp_data__rng_s4(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t ParticlesMonitorData_len_data__rng_s4(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+304);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t ParticlesMonitorData_get_data__rng_s4(const ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set_data__rng_s4(ParticlesMonitorData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* ParticlesMonitorData_getp1_data__rng_s4(ParticlesMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=*( int64_t*)(( char*) obj+offset+304);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get__sin_rot_s(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set__sin_rot_s(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp__sin_rot_s(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get__cos_rot_s(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set__cos_rot_s(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp__cos_rot_s(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get__shift_x(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set__shift_x(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp__shift_x(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get__shift_y(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set__shift_y(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp__shift_y(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ParticlesMonitorData_get__shift_s(const ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ParticlesMonitorData_set__shift_s(ParticlesMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ParticlesMonitorData_getp__shift_s(ParticlesMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_MONITORS_H
#define XTRACK_MONITORS_H

#include <headers/track.h>


GPUFUN
void ParticlesMonitor_track_local_particle(ParticlesMonitorData el,
                       LocalParticle* part0){

    int64_t const start_at_turn = ParticlesMonitorData_get_start_at_turn(el);
    int64_t const stop_at_turn = ParticlesMonitorData_get_stop_at_turn(el);
    int64_t const part_id_start = ParticlesMonitorData_get_part_id_start(el);
    int64_t const part_id_end= ParticlesMonitorData_get_part_id_end(el);
    int64_t const ebe_mode = ParticlesMonitorData_get_ebe_mode(el);
    int64_t const n_repetitions = ParticlesMonitorData_get_n_repetitions(el);
    int64_t const repetition_period = ParticlesMonitorData_get_repetition_period(el);
    ParticlesData data = ParticlesMonitorData_getp_data(el);

    int64_t n_turns_record = stop_at_turn - start_at_turn;

    START_PER_PARTICLE_BLOCK(part0, part);
        int64_t at_turn;
        if (ebe_mode){
            at_turn = LocalParticle_get_at_element(part);
        }
        else{
            #ifdef XSUITE_BACKTRACK
            return; // do not log (only ebe monitor supported for now in backtrack)
            #else
            at_turn = LocalParticle_get_at_turn(part);
            #endif
        }
        if (n_repetitions == 1){
            if (at_turn>=start_at_turn && at_turn<stop_at_turn){
                int64_t const particle_id = LocalParticle_get_particle_id(part);
                if (particle_id<part_id_end && particle_id>=part_id_start){
                    int64_t const store_at =
                        n_turns_record * (particle_id - part_id_start)
                        + at_turn - start_at_turn;
                    LocalParticle_to_Particles(part, data, store_at, 0);
                }
            }
        }
        else if (n_repetitions > 1){
            if (at_turn < start_at_turn){
//                return; //only_for_context cuda opencl
                break; //only_for_context cpu_serial cpu_openmp
            }
            int64_t const i_frame = (at_turn - start_at_turn) / repetition_period;
            if (i_frame < n_repetitions
                     && at_turn >= start_at_turn + i_frame*repetition_period
                     && at_turn < stop_at_turn + i_frame*repetition_period
                 ){
                int64_t const particle_id = LocalParticle_get_particle_id(part);
                if (particle_id<part_id_end && particle_id>=part_id_start){
                    int64_t const store_at =
                        n_turns_record * (part_id_end  - part_id_start) * i_frame
                        + n_turns_record * (particle_id - part_id_start)
                        + (at_turn - i_frame * repetition_period) - start_at_turn;
                    LocalParticle_to_Particles(part, data, store_at, 0);
                }
            }
        }

        #ifdef XSUITE_RESTORE_LOSS
        LocalParticle_set_state(part, 1);
        #endif
    END_PER_PARTICLE_BLOCK;
}

#endif




             static inline
            void ParticlesMonitor_track_local_particle_with_transformations(ParticlesMonitorData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ParticlesMonitorData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ParticlesMonitorData_get__cos_rot_s(el);
    double const shift_x = ParticlesMonitorData_get__shift_x(el);
    double const shift_y = ParticlesMonitorData_get__shift_y(el);
    double const shift_s = ParticlesMonitorData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ParticlesMonitor_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ParticlesMonitorData_get__cos_rot_s(el);
    double const shift_x = ParticlesMonitorData_get__shift_x(el);
    double const shift_y = ParticlesMonitorData_get__shift_y(el);
    double const shift_s = ParticlesMonitorData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ParticlesMonitor_track_particles(
               ParticlesMonitorData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ParticlesMonitor_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_XRotationData
#define XOBJ_TYPEDEF_XRotationData
typedef   struct XRotationData_s * XRotationData;
 static inline XRotationData XRotationData_getp(XRotationData restrict  obj){
  int64_t offset=0;
  return (XRotationData)(( char*) obj+offset);
}
 static inline double XRotationData_get_sin_angle(const XRotationData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void XRotationData_set_sin_angle(XRotationData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XRotationData_getp_sin_angle(XRotationData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double XRotationData_get_cos_angle(const XRotationData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void XRotationData_set_cos_angle(XRotationData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XRotationData_getp_cos_angle(XRotationData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double XRotationData_get_tan_angle(const XRotationData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void XRotationData_set_tan_angle(XRotationData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* XRotationData_getp_tan_angle(XRotationData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/xrotation.h>

             static inline
            void XRotation_track_local_particle_with_transformations(XRotationData el, LocalParticle* part0){
    XRotation_track_local_particle(el, part0);
}


             
            void XRotation_track_particles(
               XRotationData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              XRotation_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_CavityData
#define XOBJ_TYPEDEF_CavityData
typedef   struct CavityData_s * CavityData;
 static inline CavityData CavityData_getp(CavityData restrict  obj){
  int64_t offset=0;
  return (CavityData)(( char*) obj+offset);
}
 static inline double CavityData_get_voltage(const CavityData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set_voltage(CavityData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp_voltage(CavityData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double CavityData_get_frequency(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set_frequency(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp_frequency(CavityData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double CavityData_get_lag(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set_lag(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp_lag(CavityData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double CavityData_get_lag_taper(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set_lag_taper(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp_lag_taper(CavityData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t CavityData_get_absolute_time(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void CavityData_set_absolute_time(CavityData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* CavityData_getp_absolute_time(CavityData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double CavityData_get__sin_rot_s(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set__sin_rot_s(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp__sin_rot_s(CavityData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double CavityData_get__cos_rot_s(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set__cos_rot_s(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp__cos_rot_s(CavityData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double CavityData_get__shift_x(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set__shift_x(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp__shift_x(CavityData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double CavityData_get__shift_y(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set__shift_y(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp__shift_y(CavityData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double CavityData_get__shift_s(const CavityData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void CavityData_set__shift_s(CavityData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* CavityData_getp__shift_s(CavityData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/cavity.h>

             static inline
            void Cavity_track_local_particle_with_transformations(CavityData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = CavityData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = CavityData_get__cos_rot_s(el);
    double const shift_x = CavityData_get__shift_x(el);
    double const shift_y = CavityData_get__shift_y(el);
    double const shift_s = CavityData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Cavity_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = CavityData_get__cos_rot_s(el);
    double const shift_x = CavityData_get__shift_x(el);
    double const shift_y = CavityData_get__shift_y(el);
    double const shift_s = CavityData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Cavity_track_particles(
               CavityData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Cavity_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_YRotationData
#define XOBJ_TYPEDEF_YRotationData
typedef   struct YRotationData_s * YRotationData;
 static inline YRotationData YRotationData_getp(YRotationData restrict  obj){
  int64_t offset=0;
  return (YRotationData)(( char*) obj+offset);
}
 static inline double YRotationData_get_sin_angle(const YRotationData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void YRotationData_set_sin_angle(YRotationData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* YRotationData_getp_sin_angle(YRotationData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double YRotationData_get_cos_angle(const YRotationData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void YRotationData_set_cos_angle(YRotationData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* YRotationData_getp_cos_angle(YRotationData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double YRotationData_get_tan_angle(const YRotationData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void YRotationData_set_tan_angle(YRotationData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* YRotationData_getp_tan_angle(YRotationData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/yrotation.h>

             static inline
            void YRotation_track_local_particle_with_transformations(YRotationData el, LocalParticle* part0){
    YRotation_track_local_particle(el, part0);
}


             
            void YRotation_track_particles(
               YRotationData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              YRotation_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_WireData
#define XOBJ_TYPEDEF_WireData
typedef   struct WireData_s * WireData;
 static inline WireData WireData_getp(WireData restrict  obj){
  int64_t offset=0;
  return (WireData)(( char*) obj+offset);
}
 static inline double WireData_get_L_phy(const WireData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set_L_phy(WireData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp_L_phy(WireData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get_L_int(const WireData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set_L_int(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp_L_int(WireData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get_current(const WireData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set_current(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp_current(WireData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get_xma(const WireData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set_xma(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp_xma(WireData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get_yma(const WireData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set_yma(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp_yma(WireData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get_post_subtract_px(const WireData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set_post_subtract_px(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp_post_subtract_px(WireData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get_post_subtract_py(const WireData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set_post_subtract_py(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp_post_subtract_py(WireData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get__sin_rot_s(const WireData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set__sin_rot_s(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp__sin_rot_s(WireData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get__cos_rot_s(const WireData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set__cos_rot_s(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp__cos_rot_s(WireData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get__shift_x(const WireData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set__shift_x(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp__shift_x(WireData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get__shift_y(const WireData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set__shift_y(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp__shift_y(WireData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double WireData_get__shift_s(const WireData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void WireData_set__shift_s(WireData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* WireData_getp__shift_s(WireData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/wire.h>

             static inline
            void Wire_track_local_particle_with_transformations(WireData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = WireData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = WireData_get__cos_rot_s(el);
    double const shift_x = WireData_get__shift_x(el);
    double const shift_y = WireData_get__shift_y(el);
    double const shift_s = WireData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Wire_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = WireData_get__cos_rot_s(el);
    double const shift_x = WireData_get__shift_x(el);
    double const shift_y = WireData_get__shift_y(el);
    double const shift_s = WireData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Wire_track_particles(
               WireData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Wire_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ElensData
#define XOBJ_TYPEDEF_ElensData
typedef   struct ElensData_s * ElensData;
 static inline ElensData ElensData_getp(ElensData restrict  obj){
  int64_t offset=0;
  return (ElensData)(( char*) obj+offset);
}
 static inline double ElensData_get_current(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_current(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_current(ElensData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get_inner_radius(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_inner_radius(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_inner_radius(ElensData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get_outer_radius(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_outer_radius(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_outer_radius(ElensData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get_elens_length(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_elens_length(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_elens_length(ElensData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get_voltage(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_voltage(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_voltage(ElensData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get_residual_kick_x(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_residual_kick_x(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_residual_kick_x(ElensData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get_residual_kick_y(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_residual_kick_y(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_residual_kick_y(ElensData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ElensData_getp_coefficients_polynomial(ElensData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ElensData_len_coefficients_polynomial(ElensData restrict  obj){
  int64_t offset=0;
  offset+=112;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ElensData_get_coefficients_polynomial(const ElensData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=112;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_coefficients_polynomial(ElensData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=112;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp1_coefficients_polynomial(ElensData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=112;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get_polynomial_order(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set_polynomial_order(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp_polynomial_order(ElensData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get__sin_rot_s(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set__sin_rot_s(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp__sin_rot_s(ElensData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get__cos_rot_s(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set__cos_rot_s(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp__cos_rot_s(ElensData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get__shift_x(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set__shift_x(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp__shift_x(ElensData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get__shift_y(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set__shift_y(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp__shift_y(ElensData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ElensData_get__shift_s(const ElensData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ElensData_set__shift_s(ElensData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ElensData_getp__shift_s(ElensData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/elens.h>

             static inline
            void Elens_track_local_particle_with_transformations(ElensData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ElensData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ElensData_get__cos_rot_s(el);
    double const shift_x = ElensData_get__shift_x(el);
    double const shift_y = ElensData_get__shift_y(el);
    double const shift_s = ElensData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Elens_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ElensData_get__cos_rot_s(el);
    double const shift_x = ElensData_get__shift_x(el);
    double const shift_y = ElensData_get__shift_y(el);
    double const shift_s = ElensData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Elens_track_particles(
               ElensData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Elens_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ZetaShiftData
#define XOBJ_TYPEDEF_ZetaShiftData
typedef   struct ZetaShiftData_s * ZetaShiftData;
 static inline ZetaShiftData ZetaShiftData_getp(ZetaShiftData restrict  obj){
  int64_t offset=0;
  return (ZetaShiftData)(( char*) obj+offset);
}
 static inline double ZetaShiftData_get_dzeta(const ZetaShiftData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void ZetaShiftData_set_dzeta(ZetaShiftData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ZetaShiftData_getp_dzeta(ZetaShiftData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/zetashift.h>

             static inline
            void ZetaShift_track_local_particle_with_transformations(ZetaShiftData el, LocalParticle* part0){
    ZetaShift_track_local_particle(el, part0);
}


             
            void ZetaShift_track_particles(
               ZetaShiftData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ZetaShift_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_DipoleEdgeData
#define XOBJ_TYPEDEF_DipoleEdgeData
typedef   struct DipoleEdgeData_s * DipoleEdgeData;
 static inline DipoleEdgeData DipoleEdgeData_getp(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  return (DipoleEdgeData)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_r21(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_r21(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_r21(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_r43(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_r43(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_r43(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_hgap(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_hgap(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_hgap(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_k(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_k(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_k(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_e1(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_e1(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_e1(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_e1_fd(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_e1_fd(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_e1_fd(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_fint(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_fint(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_fint(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DipoleEdgeData_get_model(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_model(DipoleEdgeData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DipoleEdgeData_getp_model(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DipoleEdgeData_get_side(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_side(DipoleEdgeData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DipoleEdgeData_getp_side(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get_delta_taper(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set_delta_taper(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp_delta_taper(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get__sin_rot_s(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set__sin_rot_s(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp__sin_rot_s(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get__cos_rot_s(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set__cos_rot_s(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp__cos_rot_s(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get__shift_x(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set__shift_x(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp__shift_x(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get__shift_y(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set__shift_y(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp__shift_y(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double DipoleEdgeData_get__shift_s(const DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void DipoleEdgeData_set__shift_s(DipoleEdgeData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DipoleEdgeData_getp__shift_s(DipoleEdgeData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/dipoleedge.h>

             static inline
            void DipoleEdge_track_local_particle_with_transformations(DipoleEdgeData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = DipoleEdgeData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = DipoleEdgeData_get__cos_rot_s(el);
    double const shift_x = DipoleEdgeData_get__shift_x(el);
    double const shift_y = DipoleEdgeData_get__shift_y(el);
    double const shift_s = DipoleEdgeData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    DipoleEdge_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = DipoleEdgeData_get__cos_rot_s(el);
    double const shift_x = DipoleEdgeData_get__shift_x(el);
    double const shift_y = DipoleEdgeData_get__shift_y(el);
    double const shift_s = DipoleEdgeData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void DipoleEdge_track_particles(
               DipoleEdgeData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              DipoleEdge_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_SRotationData
#define XOBJ_TYPEDEF_SRotationData
typedef   struct SRotationData_s * SRotationData;
 static inline SRotationData SRotationData_getp(SRotationData restrict  obj){
  int64_t offset=0;
  return (SRotationData)(( char*) obj+offset);
}
 static inline double SRotationData_get_cos_z(const SRotationData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void SRotationData_set_cos_z(SRotationData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SRotationData_getp_cos_z(SRotationData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double SRotationData_get_sin_z(const SRotationData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SRotationData_set_sin_z(SRotationData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SRotationData_getp_sin_z(SRotationData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/srotation.h>

             static inline
            void SRotation_track_local_particle_with_transformations(SRotationData el, LocalParticle* part0){
    SRotation_track_local_particle(el, part0);
}


             
            void SRotation_track_particles(
               SRotationData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              SRotation_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_LimitRectEllipseData
#define XOBJ_TYPEDEF_LimitRectEllipseData
typedef   struct LimitRectEllipseData_s * LimitRectEllipseData;
 static inline LimitRectEllipseData LimitRectEllipseData_getp(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  return (LimitRectEllipseData)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get_max_x(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set_max_x(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp_max_x(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get_max_y(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set_max_y(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp_max_y(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get_a_squ(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set_a_squ(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp_a_squ(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get_b_squ(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set_b_squ(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp_b_squ(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get_a_b_squ(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set_a_b_squ(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp_a_b_squ(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get__sin_rot_s(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set__sin_rot_s(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp__sin_rot_s(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get__cos_rot_s(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set__cos_rot_s(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp__cos_rot_s(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get__shift_x(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set__shift_x(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp__shift_x(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get__shift_y(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set__shift_y(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp__shift_y(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRectEllipseData_get__shift_s(const LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRectEllipseData_set__shift_s(LimitRectEllipseData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRectEllipseData_getp__shift_s(LimitRectEllipseData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/apertures_src/limitrectellipse.h>

             static inline
            void LimitRectEllipse_track_local_particle_with_transformations(LimitRectEllipseData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LimitRectEllipseData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitRectEllipseData_get__cos_rot_s(el);
    double const shift_x = LimitRectEllipseData_get__shift_x(el);
    double const shift_y = LimitRectEllipseData_get__shift_y(el);
    double const shift_s = LimitRectEllipseData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LimitRectEllipse_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitRectEllipseData_get__cos_rot_s(el);
    double const shift_x = LimitRectEllipseData_get__shift_x(el);
    double const shift_y = LimitRectEllipseData_get__shift_y(el);
    double const shift_s = LimitRectEllipseData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LimitRectEllipse_track_particles(
               LimitRectEllipseData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LimitRectEllipse_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_SecondOrderTaylorMapData
#define XOBJ_TYPEDEF_SecondOrderTaylorMapData
typedef   struct SecondOrderTaylorMapData_s * SecondOrderTaylorMapData;
 static inline SecondOrderTaylorMapData SecondOrderTaylorMapData_getp(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  return (SecondOrderTaylorMapData)(( char*) obj+offset);
}
 static inline Arr6Float64 SecondOrderTaylorMapData_getp_k(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  return (Arr6Float64)(( char*) obj+offset);
}
 static inline int64_t SecondOrderTaylorMapData_len_k(SecondOrderTaylorMapData restrict  obj){
  return 6;
}
 static inline double SecondOrderTaylorMapData_get_k(const SecondOrderTaylorMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set_k(SecondOrderTaylorMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp1_k(SecondOrderTaylorMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr6x6Float64 SecondOrderTaylorMapData_getp_R(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return (Arr6x6Float64)(( char*) obj+offset);
}
 static inline int64_t SecondOrderTaylorMapData_len_R(SecondOrderTaylorMapData restrict  obj){
  return 36;
}
 static inline double SecondOrderTaylorMapData_get_R(const SecondOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=48;
  offset+=i0*48+i1*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set_R(SecondOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1, double value){
  int64_t offset=0;
  offset+=48;
  offset+=i0*48+i1*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp2_R(SecondOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=48;
  offset+=i0*48+i1*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr6x6x6Float64 SecondOrderTaylorMapData_getp_T(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=336;
  return (Arr6x6x6Float64)(( char*) obj+offset);
}
 static inline int64_t SecondOrderTaylorMapData_len_T(SecondOrderTaylorMapData restrict  obj){
  return 216;
}
 static inline double SecondOrderTaylorMapData_get_T(const SecondOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1, int64_t i2){
  int64_t offset=0;
  offset+=336;
  offset+=i0*288+i1*48+i2*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set_T(SecondOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1, int64_t i2, double value){
  int64_t offset=0;
  offset+=336;
  offset+=i0*288+i1*48+i2*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp3_T(SecondOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1, int64_t i2){
  int64_t offset=0;
  offset+=336;
  offset+=i0*288+i1*48+i2*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double SecondOrderTaylorMapData_get_length(const SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2064;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set_length(SecondOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=2064;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp_length(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2064;
  return ( double*)(( char*) obj+offset);
}
 static inline double SecondOrderTaylorMapData_get__sin_rot_s(const SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2072;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set__sin_rot_s(SecondOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=2072;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp__sin_rot_s(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2072;
  return ( double*)(( char*) obj+offset);
}
 static inline double SecondOrderTaylorMapData_get__cos_rot_s(const SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2080;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set__cos_rot_s(SecondOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=2080;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp__cos_rot_s(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2080;
  return ( double*)(( char*) obj+offset);
}
 static inline double SecondOrderTaylorMapData_get__shift_x(const SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2088;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set__shift_x(SecondOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=2088;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp__shift_x(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2088;
  return ( double*)(( char*) obj+offset);
}
 static inline double SecondOrderTaylorMapData_get__shift_y(const SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2096;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set__shift_y(SecondOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=2096;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp__shift_y(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2096;
  return ( double*)(( char*) obj+offset);
}
 static inline double SecondOrderTaylorMapData_get__shift_s(const SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2104;
  return *( double*)(( char*) obj+offset);
}
 static inline void SecondOrderTaylorMapData_set__shift_s(SecondOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=2104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SecondOrderTaylorMapData_getp__shift_s(SecondOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=2104;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/second_order_taylor_map.h>

             static inline
            void SecondOrderTaylorMap_track_local_particle_with_transformations(SecondOrderTaylorMapData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = SecondOrderTaylorMapData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = SecondOrderTaylorMapData_get__cos_rot_s(el);
    double const shift_x = SecondOrderTaylorMapData_get__shift_x(el);
    double const shift_y = SecondOrderTaylorMapData_get__shift_y(el);
    double const shift_s = SecondOrderTaylorMapData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    SecondOrderTaylorMap_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = SecondOrderTaylorMapData_get__cos_rot_s(el);
    double const shift_x = SecondOrderTaylorMapData_get__shift_x(el);
    double const shift_y = SecondOrderTaylorMapData_get__shift_y(el);
    double const shift_s = SecondOrderTaylorMapData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void SecondOrderTaylorMap_track_particles(
               SecondOrderTaylorMapData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              SecondOrderTaylorMap_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_LimitPolygonData
#define XOBJ_TYPEDEF_LimitPolygonData
typedef   struct LimitPolygonData_s * LimitPolygonData;
 static inline LimitPolygonData LimitPolygonData_getp(LimitPolygonData restrict  obj){
  int64_t offset=0;
  return (LimitPolygonData)(( char*) obj+offset);
}
 static inline ArrNFloat64 LimitPolygonData_getp_x_vertices(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LimitPolygonData_len_x_vertices(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=80;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LimitPolygonData_get_x_vertices(const LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set_x_vertices(LimitPolygonData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=80;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp1_x_vertices(LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LimitPolygonData_getp_y_vertices(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LimitPolygonData_len_y_vertices(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LimitPolygonData_get_y_vertices(const LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set_y_vertices(LimitPolygonData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp1_y_vertices(LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LimitPolygonData_getp_x_normal(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LimitPolygonData_len_x_normal(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LimitPolygonData_get_x_normal(const LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set_x_normal(LimitPolygonData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp1_x_normal(LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LimitPolygonData_getp_y_normal(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LimitPolygonData_len_y_normal(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LimitPolygonData_get_y_normal(const LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set_y_normal(LimitPolygonData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp1_y_normal(LimitPolygonData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+72);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitPolygonData_get_resc_fac(const LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set_resc_fac(LimitPolygonData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp_resc_fac(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitPolygonData_get__sin_rot_s(const LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set__sin_rot_s(LimitPolygonData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp__sin_rot_s(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitPolygonData_get__cos_rot_s(const LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set__cos_rot_s(LimitPolygonData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp__cos_rot_s(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitPolygonData_get__shift_x(const LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set__shift_x(LimitPolygonData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp__shift_x(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitPolygonData_get__shift_y(const LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set__shift_y(LimitPolygonData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp__shift_y(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitPolygonData_get__shift_s(const LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitPolygonData_set__shift_s(LimitPolygonData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitPolygonData_getp__shift_s(LimitPolygonData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/apertures_src/limitpolygon.h>

             static inline
            void LimitPolygon_track_local_particle_with_transformations(LimitPolygonData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LimitPolygonData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitPolygonData_get__cos_rot_s(el);
    double const shift_x = LimitPolygonData_get__shift_x(el);
    double const shift_y = LimitPolygonData_get__shift_y(el);
    double const shift_s = LimitPolygonData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LimitPolygon_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitPolygonData_get__cos_rot_s(el);
    double const shift_x = LimitPolygonData_get__shift_x(el);
    double const shift_y = LimitPolygonData_get__shift_y(el);
    double const shift_s = LimitPolygonData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LimitPolygon_track_particles(
               LimitPolygonData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LimitPolygon_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_BeamSizeMonitorData
#define XOBJ_TYPEDEF_BeamSizeMonitorData
typedef   struct BeamSizeMonitorData_s * BeamSizeMonitorData;
 static inline BeamSizeMonitorData BeamSizeMonitorData_getp(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  return (BeamSizeMonitorData)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_get_particle_id_start(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_particle_id_start(BeamSizeMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamSizeMonitorData_getp_particle_id_start(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_get_num_particles(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_num_particles(BeamSizeMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamSizeMonitorData_getp_num_particles(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_get_start_at_turn(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_start_at_turn(BeamSizeMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamSizeMonitorData_getp_start_at_turn(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_get_stop_at_turn(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_stop_at_turn(BeamSizeMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamSizeMonitorData_getp_stop_at_turn(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BeamSizeMonitorData_get_frev(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_frev(BeamSizeMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp_frev(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamSizeMonitorData_get_sampling_frequency(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_sampling_frequency(BeamSizeMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp_sampling_frequency(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIndex BeamSizeMonitorData_getp__index(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_get__index_capacity(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__index_capacity(BeamSizeMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamSizeMonitorData_getp__index_capacity(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamSizeMonitorData_get__index_num_recorded(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__index_num_recorded(BeamSizeMonitorData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=64;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamSizeMonitorData_getp__index_num_recorded(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamSizeMonitorData_get__index__dummy(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__index__dummy(BeamSizeMonitorData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=72;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamSizeMonitorData_getp__index__dummy(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_get__index_buffer_id(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__index_buffer_id(BeamSizeMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamSizeMonitorData_getp__index_buffer_id(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline BeamSizeMonitorRecord BeamSizeMonitorData_getp_data(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return (BeamSizeMonitorRecord)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorData_getp_data_count(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_len_data_count(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorData_get_data_count(const BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_data_count(BeamSizeMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp1_data_count(BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorData_getp_data_x_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_len_data_x_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorData_get_data_x_sum(const BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_data_x_sum(BeamSizeMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp1_data_x_sum(BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorData_getp_data_x2_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_len_data_x2_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorData_get_data_x2_sum(const BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_data_x2_sum(BeamSizeMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp1_data_x2_sum(BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorData_getp_data_y_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_len_data_y_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+24);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorData_get_data_y_sum(const BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_data_y_sum(BeamSizeMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp1_data_y_sum(BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamSizeMonitorData_getp_data_y2_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamSizeMonitorData_len_data_y2_sum(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+32);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamSizeMonitorData_get_data_y2_sum(const BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set_data_y2_sum(BeamSizeMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp1_data_y2_sum(BeamSizeMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamSizeMonitorData_get__sin_rot_s(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__sin_rot_s(BeamSizeMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp__sin_rot_s(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamSizeMonitorData_get__cos_rot_s(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__cos_rot_s(BeamSizeMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp__cos_rot_s(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamSizeMonitorData_get__shift_x(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__shift_x(BeamSizeMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp__shift_x(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamSizeMonitorData_get__shift_y(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__shift_y(BeamSizeMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp__shift_y(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamSizeMonitorData_get__shift_s(const BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamSizeMonitorData_set__shift_s(BeamSizeMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamSizeMonitorData_getp__shift_s(BeamSizeMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef _ATOMICADD_H_
#define _ATOMICADD_H_

#define ATOMICADD_CPU  //only_for_context cpu_serial cpu_openmp
//#define ATOMICADD_OPENCL //only_for_context opencl
// CUDA provides atomicAdd() natively

#ifdef ATOMICADD_CPU
inline void atomicAdd(double *addr, double val)
{
//   #pragma omp atomic //only_for_context cpu_openmp
   *addr = *addr + val;
}
#endif // ATOMICADD_CPU

#ifdef ATOMICADD_OPENCL
#pragma OPENCL EXTENSION cl_khr_int64_base_atomics : enable
inline void atomicAdd(volatile __global double *addr, double val)
{
	union {
		long u64;
		double f64;
	} next, expected, current;
	current.f64 = *addr;
	do {
		expected.f64 = current.f64;
		next.f64 = expected.f64 + val;
		current.u64 = atom_cmpxchg(
			(volatile __global long *)addr,
		        (long) expected.u64,
			(long) next.u64);
	} while( current.u64 != expected.u64 );
}
#endif // ATOMICADD_OPENCL

#endif

// ##################################
// Beam Size Monitor
// 
// Author: Philipp Niedermayer
// Date: 2023-08-14
// ##################################


#ifndef XTRACK_BEAM_SIZE_MONITOR_H
#define XTRACK_BEAM_SIZE_MONITOR_H

#include <headers/track.h>


GPUFUN
void BeamSizeMonitor_track_local_particle(BeamSizeMonitorData el, LocalParticle* part0){

    // get parameters
    int64_t const start_at_turn = BeamSizeMonitorData_get_start_at_turn(el);
    int64_t particle_id_start = BeamSizeMonitorData_get_particle_id_start(el);
    int64_t particle_id_stop = particle_id_start + BeamSizeMonitorData_get_num_particles(el);
    double const frev = BeamSizeMonitorData_get_frev(el);
    double const sampling_frequency = BeamSizeMonitorData_get_sampling_frequency(el);

    BeamSizeMonitorRecord record = BeamSizeMonitorData_getp_data(el);

    int64_t max_slot = BeamSizeMonitorRecord_len_count(record);

    START_PER_PARTICLE_BLOCK(part0, part);
        int64_t particle_id = LocalParticle_get_particle_id(part);
        if (particle_id_stop < 0 || (particle_id_start <= particle_id && particle_id < particle_id_stop))
        {
            // zeta is the absolute path length deviation from the reference particle: zeta = (s - beta0*c*t)
            // but without limits, i.e. it can exceed the circumference (for coasting beams)
            // as the particle falls behind or overtakes the reference particle
            double const zeta = LocalParticle_get_zeta(part);
            double const at_turn = LocalParticle_get_at_turn(part);
            double const beta0 = LocalParticle_get_beta0(part);

            // compute sample index
            int64_t slot = round(sampling_frequency * ( (at_turn-start_at_turn)/frev - zeta/beta0/C_LIGHT ));

            if (slot >= 0 && slot < max_slot){
                double x = LocalParticle_get_x(part);
                double y = LocalParticle_get_y(part);

                  double* count = BeamSizeMonitorRecord_getp1_count(record, slot);
                atomicAdd(count, 1);

                  double * x_sum = BeamSizeMonitorRecord_getp1_x_sum(record, slot);
                atomicAdd(x_sum, x);

                  double * y_sum = BeamSizeMonitorRecord_getp1_y_sum(record, slot);
                atomicAdd(y_sum, y);

                  double * x2_sum = BeamSizeMonitorRecord_getp1_x2_sum(record, slot);
                atomicAdd(x2_sum, x*x);

                  double * y2_sum = BeamSizeMonitorRecord_getp1_y2_sum(record, slot);
                atomicAdd(y2_sum, y*y);
            }
        }
    END_PER_PARTICLE_BLOCK;
}

#endif



             static inline
            void BeamSizeMonitor_track_local_particle_with_transformations(BeamSizeMonitorData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = BeamSizeMonitorData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamSizeMonitorData_get__cos_rot_s(el);
    double const shift_x = BeamSizeMonitorData_get__shift_x(el);
    double const shift_y = BeamSizeMonitorData_get__shift_y(el);
    double const shift_s = BeamSizeMonitorData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    BeamSizeMonitor_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamSizeMonitorData_get__cos_rot_s(el);
    double const shift_x = BeamSizeMonitorData_get__shift_x(el);
    double const shift_y = BeamSizeMonitorData_get__shift_y(el);
    double const shift_s = BeamSizeMonitorData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void BeamSizeMonitor_track_particles(
               BeamSizeMonitorData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              BeamSizeMonitor_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_SimpleThinQuadrupoleData
#define XOBJ_TYPEDEF_SimpleThinQuadrupoleData
typedef   struct SimpleThinQuadrupoleData_s * SimpleThinQuadrupoleData;
 static inline SimpleThinQuadrupoleData SimpleThinQuadrupoleData_getp(SimpleThinQuadrupoleData restrict  obj){
  int64_t offset=0;
  return (SimpleThinQuadrupoleData)(( char*) obj+offset);
}
 static inline Arr2Float64 SimpleThinQuadrupoleData_getp_knl(SimpleThinQuadrupoleData restrict  obj){
  int64_t offset=0;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t SimpleThinQuadrupoleData_len_knl(SimpleThinQuadrupoleData restrict  obj){
  return 2;
}
 static inline double SimpleThinQuadrupoleData_get_knl(const SimpleThinQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SimpleThinQuadrupoleData_set_knl(SimpleThinQuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SimpleThinQuadrupoleData_getp1_knl(SimpleThinQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/simplethinquadrupole.h>

             static inline
            void SimpleThinQuadrupole_track_local_particle_with_transformations(SimpleThinQuadrupoleData el, LocalParticle* part0){
    SimpleThinQuadrupole_track_local_particle(el, part0);
}


             
            void SimpleThinQuadrupole_track_particles(
               SimpleThinQuadrupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              SimpleThinQuadrupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ReferenceEnergyIncreaseData
#define XOBJ_TYPEDEF_ReferenceEnergyIncreaseData
typedef   struct ReferenceEnergyIncreaseData_s * ReferenceEnergyIncreaseData;
 static inline ReferenceEnergyIncreaseData ReferenceEnergyIncreaseData_getp(ReferenceEnergyIncreaseData restrict  obj){
  int64_t offset=0;
  return (ReferenceEnergyIncreaseData)(( char*) obj+offset);
}
 static inline double ReferenceEnergyIncreaseData_get_Delta_p0c(const ReferenceEnergyIncreaseData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void ReferenceEnergyIncreaseData_set_Delta_p0c(ReferenceEnergyIncreaseData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ReferenceEnergyIncreaseData_getp_Delta_p0c(ReferenceEnergyIncreaseData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/referenceenergyincrease.h>

             static inline
            void ReferenceEnergyIncrease_track_local_particle_with_transformations(ReferenceEnergyIncreaseData el, LocalParticle* part0){
    ReferenceEnergyIncrease_track_local_particle(el, part0);
}


             
            void ReferenceEnergyIncrease_track_particles(
               ReferenceEnergyIncreaseData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ReferenceEnergyIncrease_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_BeamProfileMonitorData
#define XOBJ_TYPEDEF_BeamProfileMonitorData
typedef   struct BeamProfileMonitorData_s * BeamProfileMonitorData;
 static inline BeamProfileMonitorData BeamProfileMonitorData_getp(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  return (BeamProfileMonitorData)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get_particle_id_start(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_particle_id_start(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp_particle_id_start(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get_num_particles(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_num_particles(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp_num_particles(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get_start_at_turn(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_start_at_turn(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp_start_at_turn(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get_stop_at_turn(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_stop_at_turn(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp_stop_at_turn(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get_frev(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_frev(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp_frev(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get_sampling_frequency(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_sampling_frequency(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp_sampling_frequency(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get_nx(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_nx(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp_nx(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get_x_min(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_x_min(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp_x_min(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get_dx(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_dx(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp_dx(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get_ny(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_ny(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp_ny(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get_y_min(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_y_min(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp_y_min(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get_dy(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_dy(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp_dy(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get_sample_size(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_sample_size(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp_sample_size(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline RecordIndex BeamProfileMonitorData_getp__index(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return (RecordIndex)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get__index_capacity(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__index_capacity(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=112;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp__index_capacity(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamProfileMonitorData_get__index_num_recorded(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__index_num_recorded(BeamProfileMonitorData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=120;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamProfileMonitorData_getp__index_num_recorded(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline uint32_t BeamProfileMonitorData_get__index__dummy(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__index__dummy(BeamProfileMonitorData restrict  obj, uint32_t value){
  int64_t offset=0;
  offset+=128;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* BeamProfileMonitorData_getp__index__dummy(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_get__index_buffer_id(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__index_buffer_id(BeamProfileMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=136;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BeamProfileMonitorData_getp__index_buffer_id(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline BeamProfileMonitorRecord BeamProfileMonitorData_getp_data(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return (BeamProfileMonitorRecord)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamProfileMonitorData_getp_data_counts_x(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_len_data_counts_x(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=200;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamProfileMonitorData_get_data_counts_x(const BeamProfileMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=200;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_data_counts_x(BeamProfileMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=200;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp1_data_counts_x(BeamProfileMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=200;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BeamProfileMonitorData_getp_data_counts_y(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=184;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BeamProfileMonitorData_len_data_counts_y(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=184;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BeamProfileMonitorData_get_data_counts_y(const BeamProfileMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=184;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set_data_counts_y(BeamProfileMonitorData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=184;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp1_data_counts_y(BeamProfileMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=184;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get__sin_rot_s(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__sin_rot_s(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp__sin_rot_s(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get__cos_rot_s(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__cos_rot_s(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp__cos_rot_s(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get__shift_x(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__shift_x(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp__shift_x(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get__shift_y(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__shift_y(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp__shift_y(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline double BeamProfileMonitorData_get__shift_s(const BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( double*)(( char*) obj+offset);
}
 static inline void BeamProfileMonitorData_set__shift_s(BeamProfileMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=176;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BeamProfileMonitorData_getp__shift_s(BeamProfileMonitorData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ################################# //
// This file is part of the Xfields Package.   //
// Copyright (c) CERN, 2021.                   //
// ########################################### //

#ifndef _ATOMICADD_H_
#define _ATOMICADD_H_

#define ATOMICADD_CPU  //only_for_context cpu_serial cpu_openmp
//#define ATOMICADD_OPENCL //only_for_context opencl
// CUDA provides atomicAdd() natively

#ifdef ATOMICADD_CPU
inline void atomicAdd(double *addr, double val)
{
//   #pragma omp atomic //only_for_context cpu_openmp
   *addr = *addr + val;
}
#endif // ATOMICADD_CPU

#ifdef ATOMICADD_OPENCL
#pragma OPENCL EXTENSION cl_khr_int64_base_atomics : enable
inline void atomicAdd(volatile __global double *addr, double val)
{
	union {
		long u64;
		double f64;
	} next, expected, current;
	current.f64 = *addr;
	do {
		expected.f64 = current.f64;
		next.f64 = expected.f64 + val;
		current.u64 = atom_cmpxchg(
			(volatile __global long *)addr,
		        (long) expected.u64,
			(long) next.u64);
	} while( current.u64 != expected.u64 );
}
#endif // ATOMICADD_OPENCL

#endif

// ##################################
// Beam Profile Monitor
//
// Author: Philipp Niedermayer
// Date: 2023-08-15
// ##################################


#ifndef XTRACK_BEAM_PROFILE_MONITOR_H
#define XTRACK_BEAM_PROFILE_MONITOR_H

#include <headers/track.h>


GPUFUN
void BeamProfileMonitor_track_local_particle(BeamProfileMonitorData el, LocalParticle* part0){

    // get parameters
    int64_t const start_at_turn = BeamProfileMonitorData_get_start_at_turn(el);
    int64_t particle_id_start = BeamProfileMonitorData_get_particle_id_start(el);
    int64_t particle_id_stop = particle_id_start + BeamProfileMonitorData_get_num_particles(el);
    double const frev = BeamProfileMonitorData_get_frev(el);
    double const sampling_frequency = BeamProfileMonitorData_get_sampling_frequency(el);

    BeamProfileMonitorRecord record = BeamProfileMonitorData_getp_data(el);

    int64_t max_sample = BeamProfileMonitorData_get_sample_size(el);
    int64_t max_slot_x = BeamProfileMonitorRecord_len_counts_x(record);
    int64_t max_slot_y = BeamProfileMonitorRecord_len_counts_y(record);
    int64_t nx = BeamProfileMonitorData_get_nx(el);
    int64_t ny = BeamProfileMonitorData_get_ny(el);
    double x_min = BeamProfileMonitorData_get_x_min(el);
    double dx = BeamProfileMonitorData_get_dx(el);
    double y_min = BeamProfileMonitorData_get_y_min(el);
    double dy = BeamProfileMonitorData_get_dy(el);


    START_PER_PARTICLE_BLOCK(part0, part);
        int64_t particle_id = LocalParticle_get_particle_id(part);
        if (particle_id_stop < 0 || (particle_id_start <= particle_id && particle_id < particle_id_stop))
        {
            // zeta is the absolute path length deviation from the reference particle: zeta = (s - beta0*c*t)
            // but without limits, i.e. it can exceed the circumference (for coasting beams)
            // as the particle falls behind or overtakes the reference particle
            double const zeta = LocalParticle_get_zeta(part);
            double const at_turn = LocalParticle_get_at_turn(part);
            double const beta0 = LocalParticle_get_beta0(part);

            // compute sample index
            int64_t sample = round(sampling_frequency * ( (at_turn-start_at_turn)/frev - zeta/beta0/C_LIGHT ));

            if (sample >= 0 && sample < max_sample){
                double x = LocalParticle_get_x(part);
                double y = LocalParticle_get_y(part);

                // compute bin index in raster
                int64_t bin_x = floor((x - x_min) / dx);
                int64_t bin_y = floor((y - y_min) / dy);

                if (bin_x >= 0 && bin_x < nx){
                    int64_t slot_x = sample * nx + bin_x;

                    if (slot_x >= 0 && slot_x < max_slot_x){
                        GPUGLMEM double* counts_x = BeamProfileMonitorRecord_getp1_counts_x(record, slot_x);
                        atomicAdd(counts_x, 1.);
                    }
                }

                if (bin_y >= 0 && bin_y < ny){
                    int64_t slot_y = sample * ny + bin_y;

                    if (slot_y >= 0 && slot_y < max_slot_y){
                        GPUGLMEM double* counts_y = BeamProfileMonitorRecord_getp1_counts_y(record, slot_y);
                        atomicAdd(counts_y, 1);
                    }
                }
            }
        }
    END_PER_PARTICLE_BLOCK;
}

#endif



             static inline
            void BeamProfileMonitor_track_local_particle_with_transformations(BeamProfileMonitorData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = BeamProfileMonitorData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamProfileMonitorData_get__cos_rot_s(el);
    double const shift_x = BeamProfileMonitorData_get__shift_x(el);
    double const shift_y = BeamProfileMonitorData_get__shift_y(el);
    double const shift_s = BeamProfileMonitorData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    BeamProfileMonitor_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BeamProfileMonitorData_get__cos_rot_s(el);
    double const shift_x = BeamProfileMonitorData_get__shift_x(el);
    double const shift_y = BeamProfileMonitorData_get__shift_y(el);
    double const shift_s = BeamProfileMonitorData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void BeamProfileMonitor_track_particles(
               BeamProfileMonitorData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              BeamProfileMonitor_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_NonLinearLensData
#define XOBJ_TYPEDEF_NonLinearLensData
typedef   struct NonLinearLensData_s * NonLinearLensData;
 static inline NonLinearLensData NonLinearLensData_getp(NonLinearLensData restrict  obj){
  int64_t offset=0;
  return (NonLinearLensData)(( char*) obj+offset);
}
 static inline double NonLinearLensData_get_knll(const NonLinearLensData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void NonLinearLensData_set_knll(NonLinearLensData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* NonLinearLensData_getp_knll(NonLinearLensData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double NonLinearLensData_get_cnll(const NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void NonLinearLensData_set_cnll(NonLinearLensData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* NonLinearLensData_getp_cnll(NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double NonLinearLensData_get__sin_rot_s(const NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void NonLinearLensData_set__sin_rot_s(NonLinearLensData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* NonLinearLensData_getp__sin_rot_s(NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double NonLinearLensData_get__cos_rot_s(const NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void NonLinearLensData_set__cos_rot_s(NonLinearLensData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* NonLinearLensData_getp__cos_rot_s(NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double NonLinearLensData_get__shift_x(const NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void NonLinearLensData_set__shift_x(NonLinearLensData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* NonLinearLensData_getp__shift_x(NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double NonLinearLensData_get__shift_y(const NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void NonLinearLensData_set__shift_y(NonLinearLensData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* NonLinearLensData_getp__shift_y(NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double NonLinearLensData_get__shift_s(const NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void NonLinearLensData_set__shift_s(NonLinearLensData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* NonLinearLensData_getp__shift_s(NonLinearLensData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/nonlinearlens.h>

             static inline
            void NonLinearLens_track_local_particle_with_transformations(NonLinearLensData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = NonLinearLensData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = NonLinearLensData_get__cos_rot_s(el);
    double const shift_x = NonLinearLensData_get__shift_x(el);
    double const shift_y = NonLinearLensData_get__shift_y(el);
    double const shift_s = NonLinearLensData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    NonLinearLens_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = NonLinearLensData_get__cos_rot_s(el);
    double const shift_x = NonLinearLensData_get__shift_x(el);
    double const shift_y = NonLinearLensData_get__shift_y(el);
    double const shift_s = NonLinearLensData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void NonLinearLens_track_particles(
               NonLinearLensData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              NonLinearLens_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_SimpleThinBendData
#define XOBJ_TYPEDEF_SimpleThinBendData
typedef   struct SimpleThinBendData_s * SimpleThinBendData;
 static inline SimpleThinBendData SimpleThinBendData_getp(SimpleThinBendData restrict  obj){
  int64_t offset=0;
  return (SimpleThinBendData)(( char*) obj+offset);
}
 static inline Arr1Float64 SimpleThinBendData_getp_knl(SimpleThinBendData restrict  obj){
  int64_t offset=0;
  return (Arr1Float64)(( char*) obj+offset);
}
 static inline int64_t SimpleThinBendData_len_knl(SimpleThinBendData restrict  obj){
  return 1;
}
 static inline double SimpleThinBendData_get_knl(const SimpleThinBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SimpleThinBendData_set_knl(SimpleThinBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SimpleThinBendData_getp1_knl(SimpleThinBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double SimpleThinBendData_get_hxl(const SimpleThinBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SimpleThinBendData_set_hxl(SimpleThinBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SimpleThinBendData_getp_hxl(SimpleThinBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double SimpleThinBendData_get_length(const SimpleThinBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void SimpleThinBendData_set_length(SimpleThinBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SimpleThinBendData_getp_length(SimpleThinBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/simplethinbend.h>

             static inline
            void SimpleThinBend_track_local_particle_with_transformations(SimpleThinBendData el, LocalParticle* part0){
    SimpleThinBend_track_local_particle(el, part0);
}


             
            void SimpleThinBend_track_particles(
               SimpleThinBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              SimpleThinBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_LongitudinalLimitRectData
#define XOBJ_TYPEDEF_LongitudinalLimitRectData
typedef   struct LongitudinalLimitRectData_s * LongitudinalLimitRectData;
 static inline LongitudinalLimitRectData LongitudinalLimitRectData_getp(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  return (LongitudinalLimitRectData)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get_min_zeta(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set_min_zeta(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp_min_zeta(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get_max_zeta(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set_max_zeta(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp_max_zeta(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get_min_pzeta(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set_min_pzeta(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp_min_pzeta(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get_max_pzeta(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set_max_pzeta(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp_max_pzeta(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get__sin_rot_s(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set__sin_rot_s(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp__sin_rot_s(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get__cos_rot_s(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set__cos_rot_s(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp__cos_rot_s(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get__shift_x(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set__shift_x(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp__shift_x(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get__shift_y(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set__shift_y(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp__shift_y(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double LongitudinalLimitRectData_get__shift_s(const LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void LongitudinalLimitRectData_set__shift_s(LongitudinalLimitRectData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LongitudinalLimitRectData_getp__shift_s(LongitudinalLimitRectData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/apertures_src/longitudinallimitrect.h>

             static inline
            void LongitudinalLimitRect_track_local_particle_with_transformations(LongitudinalLimitRectData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LongitudinalLimitRectData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LongitudinalLimitRectData_get__cos_rot_s(el);
    double const shift_x = LongitudinalLimitRectData_get__shift_x(el);
    double const shift_y = LongitudinalLimitRectData_get__shift_y(el);
    double const shift_s = LongitudinalLimitRectData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LongitudinalLimitRect_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LongitudinalLimitRectData_get__cos_rot_s(el);
    double const shift_x = LongitudinalLimitRectData_get__shift_x(el);
    double const shift_y = LongitudinalLimitRectData_get__shift_y(el);
    double const shift_s = LongitudinalLimitRectData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LongitudinalLimitRect_track_particles(
               LongitudinalLimitRectData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LongitudinalLimitRect_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_LimitRacetrackData
#define XOBJ_TYPEDEF_LimitRacetrackData
typedef   struct LimitRacetrackData_s * LimitRacetrackData;
 static inline LimitRacetrackData LimitRacetrackData_getp(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  return (LimitRacetrackData)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get_min_x(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set_min_x(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp_min_x(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get_max_x(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set_max_x(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp_max_x(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get_min_y(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set_min_y(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp_min_y(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get_max_y(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set_max_y(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp_max_y(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get_a(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set_a(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp_a(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get_b(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set_b(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp_b(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get__sin_rot_s(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set__sin_rot_s(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp__sin_rot_s(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get__cos_rot_s(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set__cos_rot_s(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp__cos_rot_s(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get__shift_x(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set__shift_x(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp__shift_x(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get__shift_y(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set__shift_y(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp__shift_y(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double LimitRacetrackData_get__shift_s(const LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void LimitRacetrackData_set__shift_s(LimitRacetrackData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LimitRacetrackData_getp__shift_s(LimitRacetrackData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/apertures_src/limitracetrack.h>

             static inline
            void LimitRacetrack_track_local_particle_with_transformations(LimitRacetrackData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LimitRacetrackData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitRacetrackData_get__cos_rot_s(el);
    double const shift_x = LimitRacetrackData_get__shift_x(el);
    double const shift_y = LimitRacetrackData_get__shift_y(el);
    double const shift_s = LimitRacetrackData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LimitRacetrack_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LimitRacetrackData_get__cos_rot_s(el);
    double const shift_x = LimitRacetrackData_get__shift_x(el);
    double const shift_y = LimitRacetrackData_get__shift_y(el);
    double const shift_s = LimitRacetrackData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LimitRacetrack_track_particles(
               LimitRacetrackData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LimitRacetrack_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RecordIdentifier
#define XOBJ_TYPEDEF_RecordIdentifier
typedef   struct RecordIdentifier_s * RecordIdentifier;
 static inline RecordIdentifier RecordIdentifier_getp(RecordIdentifier restrict  obj){
  int64_t offset=0;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t RecordIdentifier_get_buffer_id(const RecordIdentifier restrict  obj){
  int64_t offset=0;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RecordIdentifier_set_buffer_id(RecordIdentifier restrict  obj, int64_t value){
  int64_t offset=0;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RecordIdentifier_getp_buffer_id(RecordIdentifier restrict  obj){
  int64_t offset=0;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RecordIdentifier_get_offset(const RecordIdentifier restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RecordIdentifier_set_offset(RecordIdentifier restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RecordIdentifier_getp_offset(RecordIdentifier restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
#endif

 static inline
  int8_t* RecordIdentifier_getp_record(RecordIdentifier record_id, LocalParticle* part){
      int8_t* io_buffer = LocalParticle_get_io_buffer(part);
    if (io_buffer == NULL){
        return NULL;
    }

    int64_t buffer_id = RecordIdentifier_get_buffer_id(record_id);
      int64_t* found_id = (  int64_t*)io_buffer;
    if (buffer_id != (*found_id)){
        printf("Error: buffer_id mismatch!\n");
        return NULL;
    }

    int64_t offset = RecordIdentifier_get_offset(record_id);

    return io_buffer + offset;
    }


#ifndef XOBJ_TYPEDEF_RandomUniformData
#define XOBJ_TYPEDEF_RandomUniformData
typedef   struct RandomUniformData_s * RandomUniformData;
 static inline RandomUniformData RandomUniformData_getp(RandomUniformData restrict  obj){
  int64_t offset=0;
  return (RandomUniformData)(( char*) obj+offset);
}
 static inline uint8_t RandomUniformData_get__dummy(const RandomUniformData restrict  obj){
  int64_t offset=0;
  return *(( uint8_t*) obj+offset);
}
 static inline void RandomUniformData_set__dummy(RandomUniformData restrict  obj, uint8_t value){
  int64_t offset=0;
  *(( uint8_t*) obj+offset)=value;
}
 static inline  uint8_t* RandomUniformData_getp__dummy(RandomUniformData restrict  obj){
  int64_t offset=0;
  return ( uint8_t*)(( char*) obj+offset);
}
 static inline double RandomUniformData_get__sin_rot_s(const RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformData_set__sin_rot_s(RandomUniformData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformData_getp__sin_rot_s(RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformData_get__cos_rot_s(const RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformData_set__cos_rot_s(RandomUniformData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformData_getp__cos_rot_s(RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformData_get__shift_x(const RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformData_set__shift_x(RandomUniformData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformData_getp__shift_x(RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformData_get__shift_y(const RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformData_set__shift_y(RandomUniformData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformData_getp__shift_y(RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformData_get__shift_s(const RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformData_set__shift_s(RandomUniformData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformData_getp__shift_s(RandomUniformData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <random/random_src/uniform.h>

             
            void sample_uniform(
               RandomUniformData el,

                             ParticlesData particles,
    double* samples,  int64_t n_samples_per_seed, 
                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              RandomUniform_sample(el, &lpart, samples, n_samples_per_seed);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_LastTurnsMonitorData
#define XOBJ_TYPEDEF_LastTurnsMonitorData
typedef   struct LastTurnsMonitorData_s * LastTurnsMonitorData;
 static inline LastTurnsMonitorData LastTurnsMonitorData_getp(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  return (LastTurnsMonitorData)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_get_particle_id_start(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_particle_id_start(LastTurnsMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LastTurnsMonitorData_getp_particle_id_start(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_get_num_particles(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_num_particles(LastTurnsMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LastTurnsMonitorData_getp_num_particles(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_get_n_last_turns(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_n_last_turns(LastTurnsMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=24;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LastTurnsMonitorData_getp_n_last_turns(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_get_every_n_turns(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_every_n_turns(LastTurnsMonitorData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LastTurnsMonitorData_getp_every_n_turns(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline LastTurnsData LastTurnsMonitorData_getp_data(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return (LastTurnsData)(( char*) obj+offset);
}
 static inline ArrNUint32 LastTurnsMonitorData_getp_data_lost_at_offset(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_lost_at_offset(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=152;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t LastTurnsMonitorData_get_data_lost_at_offset(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=152;
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_lost_at_offset(LastTurnsMonitorData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=152;
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* LastTurnsMonitorData_getp1_data_lost_at_offset(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=152;
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 LastTurnsMonitorData_getp_data_particle_id(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_particle_id(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t LastTurnsMonitorData_get_data_particle_id(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_particle_id(LastTurnsMonitorData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* LastTurnsMonitorData_getp1_data_particle_id(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNUint32 LastTurnsMonitorData_getp_data_at_turn(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  return (ArrNUint32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_at_turn(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+16);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline uint32_t LastTurnsMonitorData_get_data_at_turn(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*4;
  return *( uint32_t*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_at_turn(LastTurnsMonitorData restrict  obj, int64_t i0, uint32_t value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*4;
  *( uint32_t*)(( char*) obj+offset)=value;
}
 static inline  uint32_t* LastTurnsMonitorData_getp1_data_at_turn(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+16);
  offset+=16+i0*4;
  return ( uint32_t*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsMonitorData_getp_data_x(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_x(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+24);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsMonitorData_get_data_x(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_x(LastTurnsMonitorData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsMonitorData_getp1_data_x(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+24);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsMonitorData_getp_data_px(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_px(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+32);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsMonitorData_get_data_px(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_px(LastTurnsMonitorData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsMonitorData_getp1_data_px(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+32);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsMonitorData_getp_data_y(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_y(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+40);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsMonitorData_get_data_y(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_y(LastTurnsMonitorData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsMonitorData_getp1_data_y(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+40);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsMonitorData_getp_data_py(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_py(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+48);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsMonitorData_get_data_py(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_py(LastTurnsMonitorData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsMonitorData_getp1_data_py(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+48);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsMonitorData_getp_data_delta(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_delta(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+56);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsMonitorData_get_data_delta(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_delta(LastTurnsMonitorData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsMonitorData_getp1_data_delta(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+56);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline ArrNFloat32 LastTurnsMonitorData_getp_data_zeta(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  return (ArrNFloat32)(( char*) obj+offset);
}
 static inline int64_t LastTurnsMonitorData_len_data_zeta(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+64);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline float LastTurnsMonitorData_get_data_zeta(const LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*4;
  return *( float*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set_data_zeta(LastTurnsMonitorData restrict  obj, int64_t i0, float value){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*4;
  *( float*)(( char*) obj+offset)=value;
}
 static inline  float* LastTurnsMonitorData_getp1_data_zeta(LastTurnsMonitorData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=*( int64_t*)(( char*) obj+offset+64);
  offset+=16+i0*4;
  return ( float*)(( char*) obj+offset);
}
 static inline double LastTurnsMonitorData_get__sin_rot_s(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set__sin_rot_s(LastTurnsMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LastTurnsMonitorData_getp__sin_rot_s(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LastTurnsMonitorData_get__cos_rot_s(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set__cos_rot_s(LastTurnsMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LastTurnsMonitorData_getp__cos_rot_s(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LastTurnsMonitorData_get__shift_x(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set__shift_x(LastTurnsMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LastTurnsMonitorData_getp__shift_x(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double LastTurnsMonitorData_get__shift_y(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set__shift_y(LastTurnsMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LastTurnsMonitorData_getp__shift_y(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double LastTurnsMonitorData_get__shift_s(const LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void LastTurnsMonitorData_set__shift_s(LastTurnsMonitorData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LastTurnsMonitorData_getp__shift_s(LastTurnsMonitorData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// ##################################
// Monitor to save particle state
// for last N turns before loss
// 
// Author: Philipp Niedermayer
// Date: 2023-01-19
// ##################################

#ifndef XTRACK_LAST_TURNS_MONITOR_H
#define XTRACK_LAST_TURNS_MONITOR_H

#include <headers/track.h>


GPUFUN
void LastTurnsMonitor_track_local_particle(LastTurnsMonitorData el, LocalParticle* part0){
    int64_t n_last_turns = LastTurnsMonitorData_get_n_last_turns(el);
    int64_t particle_id_start = LastTurnsMonitorData_get_particle_id_start(el);
    int64_t particle_id_stop = particle_id_start + LastTurnsMonitorData_get_num_particles(el);
    int64_t every_n_turns = LastTurnsMonitorData_get_every_n_turns(el);
    LastTurnsData data = LastTurnsMonitorData_getp_data(el);

    START_PER_PARTICLE_BLOCK(part0, part);
        int64_t particle_id = LocalParticle_get_particle_id(part);
        int64_t at_turn = LocalParticle_get_at_turn(part);

        // When the particle is lost, tracking is stopped automatically for it.
        // Therefore we don't need to check for particle state here.
        // But this also means, that he have to save the buffer offset each time
        // as long as the particle is still alive, since it could be the last
        // time we see it.
    
        if (at_turn >= 0 && at_turn%every_n_turns == 0 && particle_id_start <= particle_id && particle_id < particle_id_stop)
        {
            // determine slot in rolling buffer
            int64_t offset = (at_turn / every_n_turns) % n_last_turns;
            int64_t ip = particle_id - particle_id_start;
            int64_t slot = n_last_turns * ip + offset;

            // store buffer offset
            LastTurnsData_set_lost_at_offset(data, ip, offset);

            // store data
            LastTurnsData_set_particle_id(data, slot, particle_id);
            LastTurnsData_set_at_turn(data, slot, at_turn);
            LastTurnsData_set_x(data, slot, LocalParticle_get_x(part));
            LastTurnsData_set_px(data, slot, LocalParticle_get_px(part));
            LastTurnsData_set_y(data, slot, LocalParticle_get_y(part));
            LastTurnsData_set_py(data, slot, LocalParticle_get_py(part));
            LastTurnsData_set_delta(data, slot, LocalParticle_get_delta(part));
            LastTurnsData_set_zeta(data, slot, LocalParticle_get_zeta(part));
        }
    END_PER_PARTICLE_BLOCK;

}

#endif


             static inline
            void LastTurnsMonitor_track_local_particle_with_transformations(LastTurnsMonitorData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LastTurnsMonitorData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LastTurnsMonitorData_get__cos_rot_s(el);
    double const shift_x = LastTurnsMonitorData_get__shift_x(el);
    double const shift_y = LastTurnsMonitorData_get__shift_y(el);
    double const shift_s = LastTurnsMonitorData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LastTurnsMonitor_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LastTurnsMonitorData_get__cos_rot_s(el);
    double const shift_x = LastTurnsMonitorData_get__shift_x(el);
    double const shift_y = LastTurnsMonitorData_get__shift_y(el);
    double const shift_s = LastTurnsMonitorData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LastTurnsMonitor_track_particles(
               LastTurnsMonitorData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LastTurnsMonitor_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RefDriftData
#define XOBJ_TYPEDEF_RefDriftData
typedef   struct RefDriftData_s * RefDriftData;
#endif
#ifndef XOBJ_TYPEDEF_RandomUniformAccurateData
#define XOBJ_TYPEDEF_RandomUniformAccurateData
typedef   struct RandomUniformAccurateData_s * RandomUniformAccurateData;
 static inline RandomUniformAccurateData RandomUniformAccurateData_getp(RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  return (RandomUniformAccurateData)(( char*) obj+offset);
}
 static inline uint8_t RandomUniformAccurateData_get__dummy(const RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  return *(( uint8_t*) obj+offset);
}
 static inline void RandomUniformAccurateData_set__dummy(RandomUniformAccurateData restrict  obj, uint8_t value){
  int64_t offset=0;
  *(( uint8_t*) obj+offset)=value;
}
 static inline  uint8_t* RandomUniformAccurateData_getp__dummy(RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  return ( uint8_t*)(( char*) obj+offset);
}
 static inline double RandomUniformAccurateData_get__sin_rot_s(const RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformAccurateData_set__sin_rot_s(RandomUniformAccurateData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformAccurateData_getp__sin_rot_s(RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformAccurateData_get__cos_rot_s(const RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformAccurateData_set__cos_rot_s(RandomUniformAccurateData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformAccurateData_getp__cos_rot_s(RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformAccurateData_get__shift_x(const RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformAccurateData_set__shift_x(RandomUniformAccurateData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformAccurateData_getp__shift_x(RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformAccurateData_get__shift_y(const RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformAccurateData_set__shift_y(RandomUniformAccurateData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformAccurateData_getp__shift_y(RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomUniformAccurateData_get__shift_s(const RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomUniformAccurateData_set__shift_s(RandomUniformAccurateData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomUniformAccurateData_getp__shift_s(RandomUniformAccurateData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <random/random_src/uniform_accurate.h>

             
            void sample_unif_accuurate(
               RandomUniformAccurateData el,

                             ParticlesData particles,
    double* samples,  int64_t n_samples_per_seed, 
                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              RandomUniformAccurate_sample(el, &lpart, samples, n_samples_per_seed);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RandomExponentialData
#define XOBJ_TYPEDEF_RandomExponentialData
typedef   struct RandomExponentialData_s * RandomExponentialData;
 static inline RandomExponentialData RandomExponentialData_getp(RandomExponentialData restrict  obj){
  int64_t offset=0;
  return (RandomExponentialData)(( char*) obj+offset);
}
 static inline uint8_t RandomExponentialData_get__dummy(const RandomExponentialData restrict  obj){
  int64_t offset=0;
  return *(( uint8_t*) obj+offset);
}
 static inline void RandomExponentialData_set__dummy(RandomExponentialData restrict  obj, uint8_t value){
  int64_t offset=0;
  *(( uint8_t*) obj+offset)=value;
}
 static inline  uint8_t* RandomExponentialData_getp__dummy(RandomExponentialData restrict  obj){
  int64_t offset=0;
  return ( uint8_t*)(( char*) obj+offset);
}
 static inline double RandomExponentialData_get__sin_rot_s(const RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomExponentialData_set__sin_rot_s(RandomExponentialData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomExponentialData_getp__sin_rot_s(RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomExponentialData_get__cos_rot_s(const RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomExponentialData_set__cos_rot_s(RandomExponentialData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomExponentialData_getp__cos_rot_s(RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomExponentialData_get__shift_x(const RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomExponentialData_set__shift_x(RandomExponentialData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomExponentialData_getp__shift_x(RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomExponentialData_get__shift_y(const RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomExponentialData_set__shift_y(RandomExponentialData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomExponentialData_getp__shift_y(RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomExponentialData_get__shift_s(const RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomExponentialData_set__shift_s(RandomExponentialData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomExponentialData_getp__shift_s(RandomExponentialData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <random/random_src/exponential.h>

             
            void sample_exp(
               RandomExponentialData el,

                             ParticlesData particles,
    double* samples,  int64_t n_samples_per_seed, 
                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              RandomExponential_sample(el, &lpart, samples, n_samples_per_seed);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RandomNormalData
#define XOBJ_TYPEDEF_RandomNormalData
typedef   struct RandomNormalData_s * RandomNormalData;
 static inline RandomNormalData RandomNormalData_getp(RandomNormalData restrict  obj){
  int64_t offset=0;
  return (RandomNormalData)(( char*) obj+offset);
}
 static inline uint8_t RandomNormalData_get__dummy(const RandomNormalData restrict  obj){
  int64_t offset=0;
  return *(( uint8_t*) obj+offset);
}
 static inline void RandomNormalData_set__dummy(RandomNormalData restrict  obj, uint8_t value){
  int64_t offset=0;
  *(( uint8_t*) obj+offset)=value;
}
 static inline  uint8_t* RandomNormalData_getp__dummy(RandomNormalData restrict  obj){
  int64_t offset=0;
  return ( uint8_t*)(( char*) obj+offset);
}
 static inline double RandomNormalData_get__sin_rot_s(const RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomNormalData_set__sin_rot_s(RandomNormalData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomNormalData_getp__sin_rot_s(RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomNormalData_get__cos_rot_s(const RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomNormalData_set__cos_rot_s(RandomNormalData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomNormalData_getp__cos_rot_s(RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomNormalData_get__shift_x(const RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomNormalData_set__shift_x(RandomNormalData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomNormalData_getp__shift_x(RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomNormalData_get__shift_y(const RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomNormalData_set__shift_y(RandomNormalData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomNormalData_getp__shift_y(RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double RandomNormalData_get__shift_s(const RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void RandomNormalData_set__shift_s(RandomNormalData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RandomNormalData_getp__shift_s(RandomNormalData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <random/random_src/normal.h>

             
            void sample_gauss(
               RandomNormalData el,

                             ParticlesData particles,
    double* samples,  int64_t n_samples_per_seed, 
                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              RandomNormal_sample(el, &lpart, samples, n_samples_per_seed);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_DriftSliceData
#define XOBJ_TYPEDEF_DriftSliceData
typedef   struct DriftSliceData_s * DriftSliceData;
 static inline DriftSliceData DriftSliceData_getp(DriftSliceData restrict  obj){
  int64_t offset=0;
  return (DriftSliceData)(( char*) obj+offset);
}
 static inline DriftData DriftSliceData_getp__parent(DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (DriftData)(( char*) obj+offset);
}
 static inline double DriftSliceData_get__parent_length(const DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceData_set__parent_length(DriftSliceData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceData_getp__parent_length(DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceData_get_radiation_flag(const DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceData_set_radiation_flag(DriftSliceData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceData_getp_radiation_flag(DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceData_get_delta_taper(const DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceData_set_delta_taper(DriftSliceData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceData_getp_delta_taper(DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceData_get_weight(const DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceData_set_weight(DriftSliceData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceData_getp_weight(DriftSliceData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/drift_slice.h>

             static inline
            void DriftSlice_track_local_particle_with_transformations(DriftSliceData el, LocalParticle* part0){
    DriftSlice_track_local_particle(el, part0);
}


             
            void DriftSlice_track_particles(
               DriftSliceData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              DriftSlice_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RBendData
#define XOBJ_TYPEDEF_RBendData
typedef   struct RBendData_s * RBendData;
 static inline RBendData RBendData_getp(RBendData restrict  obj){
  int64_t offset=0;
  return (RBendData)(( char*) obj+offset);
}
 static inline double RBendData_get_k0(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_k0(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_k0(RBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_k1(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_k1(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_k1(RBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_h(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_h(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_h(RBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_angle(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_angle(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_angle(RBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_length(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_length(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_length(RBendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_model(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_model(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_model(RBendData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_integrator(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_integrator(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_integrator(RBendData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_radiation_flag(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_radiation_flag(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_radiation_flag(RBendData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double RBendData_get_delta_taper(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_delta_taper(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_delta_taper(RBendData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_edge_entry_active(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_entry_active(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_edge_entry_active(RBendData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_edge_exit_active(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_exit_active(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_edge_exit_active(RBendData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_edge_entry_model(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_entry_model(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_edge_entry_model(RBendData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_edge_exit_model(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_exit_model(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_edge_exit_model(RBendData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_entry_angle(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_entry_angle(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_entry_angle(RBendData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_exit_angle(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_exit_angle(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_exit_angle(RBendData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_entry_angle_fdown(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_entry_angle_fdown(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_entry_angle_fdown(RBendData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_exit_angle_fdown(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_exit_angle_fdown(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_exit_angle_fdown(RBendData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_entry_fint(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_entry_fint(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_entry_fint(RBendData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_exit_fint(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_exit_fint(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_exit_fint(RBendData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_entry_hgap(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_entry_hgap(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_entry_hgap(RBendData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get_edge_exit_hgap(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_edge_exit_hgap(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_edge_exit_hgap(RBendData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_num_multipole_kicks(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_num_multipole_kicks(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_num_multipole_kicks(RBendData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get_order(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_order(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp_order(RBendData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double RBendData_get_inv_factorial_order(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_inv_factorial_order(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_inv_factorial_order(RBendData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 RBendData_getp_knl(RBendData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t RBendData_len_knl(RBendData restrict  obj){
  int64_t offset=0;
  offset+=280;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double RBendData_get_knl(const RBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=280;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_knl(RBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=280;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp1_knl(RBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=280;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 RBendData_getp_ksl(RBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t RBendData_len_ksl(RBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double RBendData_get_ksl(const RBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_ksl(RBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp1_ksl(RBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t RBendData_get_k0_from_h(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set_k0_from_h(RBendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* RBendData_getp_k0_from_h(RBendData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double RBendData_get_length_straight(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set_length_straight(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp_length_straight(RBendData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get__sin_rot_s(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set__sin_rot_s(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp__sin_rot_s(RBendData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get__cos_rot_s(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set__cos_rot_s(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp__cos_rot_s(RBendData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get__shift_x(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set__shift_x(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp__shift_x(RBendData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get__shift_y(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set__shift_y(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp__shift_y(RBendData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double RBendData_get__shift_s(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void RBendData_set__shift_s(RBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* RBendData_getp__shift_s(RBendData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier RBendData_getp__internal_record_id(RBendData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t RBendData_get__internal_record_id_buffer_id(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set__internal_record_id_buffer_id(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp__internal_record_id_buffer_id(RBendData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t RBendData_get__internal_record_id_offset(const RBendData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void RBendData_set__internal_record_id_offset(RBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=264;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* RBendData_getp__internal_record_id_offset(RBendData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData RBendData_getp_internal_record(RBendData el, LocalParticle* part){
    RecordIdentifier record_id = RBendData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/rbend.h>

             static inline
            void RBend_track_local_particle_with_transformations(RBendData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = RBendData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = RBendData_get__cos_rot_s(el);
    double const shift_x = RBendData_get__shift_x(el);
    double const shift_y = RBendData_get__shift_y(el);
    double const shift_s = RBendData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    RBend_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = RBendData_get__cos_rot_s(el);
    double const shift_x = RBendData_get__shift_x(el);
    double const shift_y = RBendData_get__shift_y(el);
    double const shift_s = RBendData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void RBend_track_particles(
               RBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              RBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_MultipoleData
#define XOBJ_TYPEDEF_MultipoleData
typedef   struct MultipoleData_s * MultipoleData;
 static inline MultipoleData MultipoleData_getp(MultipoleData restrict  obj){
  int64_t offset=0;
  return (MultipoleData)(( char*) obj+offset);
}
 static inline int64_t MultipoleData_get_order(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_order(MultipoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MultipoleData_getp_order(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double MultipoleData_get_inv_factorial_order(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_inv_factorial_order(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp_inv_factorial_order(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleData_get_length(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_length(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp_length(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleData_get_hxl(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_hxl(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp_hxl(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t MultipoleData_get_radiation_flag(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_radiation_flag(MultipoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MultipoleData_getp_radiation_flag(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double MultipoleData_get_delta_taper(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_delta_taper(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp_delta_taper(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 MultipoleData_getp_knl(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t MultipoleData_len_knl(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double MultipoleData_get_knl(const MultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_knl(MultipoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=120;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp1_knl(MultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=120;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 MultipoleData_getp_ksl(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t MultipoleData_len_ksl(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double MultipoleData_get_ksl(const MultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set_ksl(MultipoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp1_ksl(MultipoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+112);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleData_get__sin_rot_s(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set__sin_rot_s(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp__sin_rot_s(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleData_get__cos_rot_s(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set__cos_rot_s(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp__cos_rot_s(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleData_get__shift_x(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set__shift_x(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp__shift_x(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleData_get__shift_y(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set__shift_y(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp__shift_y(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double MultipoleData_get__shift_s(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void MultipoleData_set__shift_s(MultipoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MultipoleData_getp__shift_s(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier MultipoleData_getp__internal_record_id(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t MultipoleData_get__internal_record_id_buffer_id(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MultipoleData_set__internal_record_id_buffer_id(MultipoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MultipoleData_getp__internal_record_id_buffer_id(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MultipoleData_get__internal_record_id_offset(const MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MultipoleData_set__internal_record_id_offset(MultipoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MultipoleData_getp__internal_record_id_offset(MultipoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData MultipoleData_getp_internal_record(MultipoleData el, LocalParticle* part){
    RecordIdentifier record_id = MultipoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/multipole.h>

             static inline
            void Multipole_track_local_particle_with_transformations(MultipoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = MultipoleData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = MultipoleData_get__cos_rot_s(el);
    double const shift_x = MultipoleData_get__shift_x(el);
    double const shift_y = MultipoleData_get__shift_y(el);
    double const shift_s = MultipoleData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Multipole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = MultipoleData_get__cos_rot_s(el);
    double const shift_x = MultipoleData_get__shift_x(el);
    double const shift_y = MultipoleData_get__shift_y(el);
    double const shift_s = MultipoleData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Multipole_track_particles(
               MultipoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Multipole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_QuadrupoleData
#define XOBJ_TYPEDEF_QuadrupoleData
typedef   struct QuadrupoleData_s * QuadrupoleData;
 static inline QuadrupoleData QuadrupoleData_getp(QuadrupoleData restrict  obj){
  int64_t offset=0;
  return (QuadrupoleData)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get_k1(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_k1(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp_k1(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get_k1s(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_k1s(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp_k1s(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get_length(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_length(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp_length(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_get_num_multipole_kicks(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_num_multipole_kicks(QuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* QuadrupoleData_getp_num_multipole_kicks(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_get_order(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_order(QuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* QuadrupoleData_getp_order(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get_inv_factorial_order(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_inv_factorial_order(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp_inv_factorial_order(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 QuadrupoleData_getp_knl(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_len_knl(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double QuadrupoleData_get_knl(const QuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_knl(QuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp1_knl(QuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 QuadrupoleData_getp_ksl(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_len_ksl(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double QuadrupoleData_get_ksl(const QuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_ksl(QuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp1_ksl(QuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t QuadrupoleData_get_edge_entry_active(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_edge_entry_active(QuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* QuadrupoleData_getp_edge_entry_active(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t QuadrupoleData_get_edge_exit_active(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_edge_exit_active(QuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=64;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* QuadrupoleData_getp_edge_exit_active(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_get_model(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_model(QuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* QuadrupoleData_getp_model(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_get_integrator(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_integrator(QuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* QuadrupoleData_getp_integrator(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_get_radiation_flag(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_radiation_flag(QuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* QuadrupoleData_getp_radiation_flag(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get_delta_taper(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set_delta_taper(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp_delta_taper(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get__sin_rot_s(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set__sin_rot_s(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp__sin_rot_s(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get__cos_rot_s(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set__cos_rot_s(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp__cos_rot_s(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get__shift_x(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set__shift_x(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp__shift_x(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get__shift_y(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set__shift_y(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp__shift_y(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double QuadrupoleData_get__shift_s(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set__shift_s(QuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* QuadrupoleData_getp__shift_s(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier QuadrupoleData_getp__internal_record_id(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_get__internal_record_id_buffer_id(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set__internal_record_id_buffer_id(QuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* QuadrupoleData_getp__internal_record_id_buffer_id(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t QuadrupoleData_get__internal_record_id_offset(const QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void QuadrupoleData_set__internal_record_id_offset(QuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* QuadrupoleData_getp__internal_record_id_offset(QuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData QuadrupoleData_getp_internal_record(QuadrupoleData el, LocalParticle* part){
    RecordIdentifier record_id = QuadrupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/quadrupole.h>

             static inline
            void Quadrupole_track_local_particle_with_transformations(QuadrupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = QuadrupoleData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = QuadrupoleData_get__cos_rot_s(el);
    double const shift_x = QuadrupoleData_get__shift_x(el);
    double const shift_y = QuadrupoleData_get__shift_y(el);
    double const shift_s = QuadrupoleData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Quadrupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = QuadrupoleData_get__cos_rot_s(el);
    double const shift_x = QuadrupoleData_get__shift_x(el);
    double const shift_y = QuadrupoleData_get__shift_y(el);
    double const shift_s = QuadrupoleData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Quadrupole_track_particles(
               QuadrupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Quadrupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_MagnetData
#define XOBJ_TYPEDEF_MagnetData
typedef   struct MagnetData_s * MagnetData;
 static inline MagnetData MagnetData_getp(MagnetData restrict  obj){
  int64_t offset=0;
  return (MagnetData)(( char*) obj+offset);
}
 static inline double MagnetData_get_length(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_length(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_length(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_order(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_order(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=16;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_order(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double MagnetData_get_inv_factorial_order(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_inv_factorial_order(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_inv_factorial_order(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_num_multipole_kicks(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_num_multipole_kicks(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_num_multipole_kicks(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline ArrNFloat64 MagnetData_getp_knl(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=320;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t MagnetData_len_knl(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=320;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double MagnetData_get_knl(const MagnetData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=320;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_knl(MagnetData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=320;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp1_knl(MagnetData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=320;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 MagnetData_getp_ksl(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t MagnetData_len_ksl(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double MagnetData_get_ksl(const MagnetData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_ksl(MagnetData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp1_ksl(MagnetData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+312);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k0(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k0(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k0(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k1(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k1(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k1(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k2(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k2(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k2(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k3(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k3(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k3(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k0s(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k0s(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k0s(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k1s(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k1s(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k1s(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k2s(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k2s(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k2s(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_k3s(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k3s(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_k3s(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_angle(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_angle(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_angle(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_h(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_h(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_h(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t MagnetData_get_k0_from_h(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_k0_from_h(MagnetData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=120;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* MagnetData_getp_k0_from_h(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_edge_entry_active(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_entry_active(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=128;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_edge_entry_active(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_edge_exit_active(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_exit_active(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=136;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_edge_exit_active(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_edge_entry_model(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_entry_model(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_edge_entry_model(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_edge_exit_model(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_exit_model(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_edge_exit_model(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_entry_angle(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_entry_angle(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_entry_angle(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_exit_angle(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_exit_angle(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_exit_angle(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_entry_angle_fdown(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_entry_angle_fdown(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=176;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_entry_angle_fdown(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_exit_angle_fdown(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_exit_angle_fdown(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=184;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_exit_angle_fdown(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_entry_fint(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_entry_fint(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_entry_fint(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_exit_fint(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_exit_fint(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=200;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_exit_fint(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_entry_hgap(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_entry_hgap(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_entry_hgap(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get_edge_exit_hgap(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_edge_exit_hgap(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_edge_exit_hgap(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_model(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_model(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=224;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_model(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_integrator(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_integrator(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=232;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_integrator(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get_radiation_flag(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set_radiation_flag(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=240;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp_radiation_flag(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double MagnetData_get_delta_taper(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set_delta_taper(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp_delta_taper(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get__sin_rot_s(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set__sin_rot_s(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=256;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp__sin_rot_s(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get__cos_rot_s(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set__cos_rot_s(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=264;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp__cos_rot_s(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get__shift_x(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set__shift_x(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=272;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp__shift_x(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get__shift_y(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set__shift_y(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=280;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp__shift_y(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return ( double*)(( char*) obj+offset);
}
 static inline double MagnetData_get__shift_s(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=288;
  return *( double*)(( char*) obj+offset);
}
 static inline void MagnetData_set__shift_s(MagnetData restrict  obj, double value){
  int64_t offset=0;
  offset+=288;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* MagnetData_getp__shift_s(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=288;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier MagnetData_getp__internal_record_id(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=296;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get__internal_record_id_buffer_id(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=296;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set__internal_record_id_buffer_id(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=296;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp__internal_record_id_buffer_id(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=296;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t MagnetData_get__internal_record_id_offset(const MagnetData restrict  obj){
  int64_t offset=0;
  offset+=304;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void MagnetData_set__internal_record_id_offset(MagnetData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=304;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* MagnetData_getp__internal_record_id_offset(MagnetData restrict  obj){
  int64_t offset=0;
  offset+=304;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData MagnetData_getp_internal_record(MagnetData el, LocalParticle* part){
    RecordIdentifier record_id = MagnetData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/magnet.h>

             static inline
            void Magnet_track_local_particle_with_transformations(MagnetData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = MagnetData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = MagnetData_get__cos_rot_s(el);
    double const shift_x = MagnetData_get__shift_x(el);
    double const shift_y = MagnetData_get__shift_y(el);
    double const shift_s = MagnetData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Magnet_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = MagnetData_get__cos_rot_s(el);
    double const shift_x = MagnetData_get__shift_x(el);
    double const shift_y = MagnetData_get__shift_y(el);
    double const shift_s = MagnetData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Magnet_track_particles(
               MagnetData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Magnet_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_OctupoleData
#define XOBJ_TYPEDEF_OctupoleData
typedef   struct OctupoleData_s * OctupoleData;
 static inline OctupoleData OctupoleData_getp(OctupoleData restrict  obj){
  int64_t offset=0;
  return (OctupoleData)(( char*) obj+offset);
}
 static inline double OctupoleData_get_k3(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_k3(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp_k3(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double OctupoleData_get_k3s(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_k3s(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp_k3s(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double OctupoleData_get_length(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_length(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp_length(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_get_order(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_order(OctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* OctupoleData_getp_order(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double OctupoleData_get_inv_factorial_order(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_inv_factorial_order(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp_inv_factorial_order(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 OctupoleData_getp_knl(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_len_knl(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double OctupoleData_get_knl(const OctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_knl(OctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp1_knl(OctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 OctupoleData_getp_ksl(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_len_ksl(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double OctupoleData_get_ksl(const OctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_ksl(OctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp1_ksl(OctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t OctupoleData_get_edge_entry_active(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_edge_entry_active(OctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* OctupoleData_getp_edge_entry_active(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t OctupoleData_get_edge_exit_active(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_edge_exit_active(OctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* OctupoleData_getp_edge_exit_active(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_get_num_multipole_kicks(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_num_multipole_kicks(OctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* OctupoleData_getp_num_multipole_kicks(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_get_model(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_model(OctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* OctupoleData_getp_model(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_get_integrator(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_integrator(OctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* OctupoleData_getp_integrator(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_get_radiation_flag(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_radiation_flag(OctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* OctupoleData_getp_radiation_flag(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double OctupoleData_get_delta_taper(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set_delta_taper(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp_delta_taper(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double OctupoleData_get__sin_rot_s(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set__sin_rot_s(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp__sin_rot_s(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double OctupoleData_get__cos_rot_s(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set__cos_rot_s(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp__cos_rot_s(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double OctupoleData_get__shift_x(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set__shift_x(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp__shift_x(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double OctupoleData_get__shift_y(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set__shift_y(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp__shift_y(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double OctupoleData_get__shift_s(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void OctupoleData_set__shift_s(OctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* OctupoleData_getp__shift_s(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier OctupoleData_getp__internal_record_id(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_get__internal_record_id_buffer_id(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set__internal_record_id_buffer_id(OctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* OctupoleData_getp__internal_record_id_buffer_id(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t OctupoleData_get__internal_record_id_offset(const OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void OctupoleData_set__internal_record_id_offset(OctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* OctupoleData_getp__internal_record_id_offset(OctupoleData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData OctupoleData_getp_internal_record(OctupoleData el, LocalParticle* part){
    RecordIdentifier record_id = OctupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/octupole.h>

             static inline
            void Octupole_track_local_particle_with_transformations(OctupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = OctupoleData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = OctupoleData_get__cos_rot_s(el);
    double const shift_x = OctupoleData_get__shift_x(el);
    double const shift_y = OctupoleData_get__shift_y(el);
    double const shift_s = OctupoleData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Octupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = OctupoleData_get__cos_rot_s(el);
    double const shift_x = OctupoleData_get__shift_x(el);
    double const shift_y = OctupoleData_get__shift_y(el);
    double const shift_s = OctupoleData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Octupole_track_particles(
               OctupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Octupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_SextupoleData
#define XOBJ_TYPEDEF_SextupoleData
typedef   struct SextupoleData_s * SextupoleData;
 static inline SextupoleData SextupoleData_getp(SextupoleData restrict  obj){
  int64_t offset=0;
  return (SextupoleData)(( char*) obj+offset);
}
 static inline double SextupoleData_get_k2(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_k2(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp_k2(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double SextupoleData_get_k2s(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_k2s(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp_k2s(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double SextupoleData_get_length(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_length(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp_length(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_get_order(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_order(SextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SextupoleData_getp_order(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double SextupoleData_get_inv_factorial_order(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_inv_factorial_order(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp_inv_factorial_order(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 SextupoleData_getp_knl(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_len_knl(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double SextupoleData_get_knl(const SextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_knl(SextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp1_knl(SextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 SextupoleData_getp_ksl(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_len_ksl(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double SextupoleData_get_ksl(const SextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_ksl(SextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp1_ksl(SextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t SextupoleData_get_edge_entry_active(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_edge_entry_active(SextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* SextupoleData_getp_edge_entry_active(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t SextupoleData_get_edge_exit_active(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_edge_exit_active(SextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* SextupoleData_getp_edge_exit_active(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_get_num_multipole_kicks(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_num_multipole_kicks(SextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SextupoleData_getp_num_multipole_kicks(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_get_model(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_model(SextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SextupoleData_getp_model(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_get_integrator(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_integrator(SextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SextupoleData_getp_integrator(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_get_radiation_flag(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_radiation_flag(SextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SextupoleData_getp_radiation_flag(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double SextupoleData_get_delta_taper(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set_delta_taper(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp_delta_taper(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double SextupoleData_get__sin_rot_s(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set__sin_rot_s(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp__sin_rot_s(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double SextupoleData_get__cos_rot_s(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set__cos_rot_s(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp__cos_rot_s(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double SextupoleData_get__shift_x(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set__shift_x(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp__shift_x(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double SextupoleData_get__shift_y(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set__shift_y(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp__shift_y(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double SextupoleData_get__shift_s(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void SextupoleData_set__shift_s(SextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SextupoleData_getp__shift_s(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier SextupoleData_getp__internal_record_id(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_get__internal_record_id_buffer_id(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set__internal_record_id_buffer_id(SextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SextupoleData_getp__internal_record_id_buffer_id(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t SextupoleData_get__internal_record_id_offset(const SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SextupoleData_set__internal_record_id_offset(SextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SextupoleData_getp__internal_record_id_offset(SextupoleData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData SextupoleData_getp_internal_record(SextupoleData el, LocalParticle* part){
    RecordIdentifier record_id = SextupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/sextupole.h>

             static inline
            void Sextupole_track_local_particle_with_transformations(SextupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = SextupoleData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = SextupoleData_get__cos_rot_s(el);
    double const shift_x = SextupoleData_get__shift_x(el);
    double const shift_y = SextupoleData_get__shift_y(el);
    double const shift_s = SextupoleData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Sextupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = SextupoleData_get__cos_rot_s(el);
    double const shift_x = SextupoleData_get__shift_x(el);
    double const shift_y = SextupoleData_get__shift_y(el);
    double const shift_s = SextupoleData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Sextupole_track_particles(
               SextupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Sextupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_SolenoidData
#define XOBJ_TYPEDEF_SolenoidData
typedef   struct SolenoidData_s * SolenoidData;
 static inline SolenoidData SolenoidData_getp(SolenoidData restrict  obj){
  int64_t offset=0;
  return (SolenoidData)(( char*) obj+offset);
}
 static inline double SolenoidData_get_length(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_length(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_length(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_ks(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_ks(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_ks(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_ksi(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_ksi(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_ksi(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t SolenoidData_get_radiation_flag(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_radiation_flag(SolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SolenoidData_getp_radiation_flag(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t SolenoidData_get_num_multipole_kicks(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_num_multipole_kicks(SolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SolenoidData_getp_num_multipole_kicks(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t SolenoidData_get_order(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_order(SolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SolenoidData_getp_order(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_inv_factorial_order(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_inv_factorial_order(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_inv_factorial_order(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 SolenoidData_getp_knl(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t SolenoidData_len_knl(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double SolenoidData_get_knl(const SolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_knl(SolenoidData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp1_knl(SolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 SolenoidData_getp_ksl(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t SolenoidData_len_ksl(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double SolenoidData_get_ksl(const SolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_ksl(SolenoidData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp1_ksl(SolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_mult_rot_x_rad(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_mult_rot_x_rad(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_mult_rot_x_rad(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_mult_rot_y_rad(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_mult_rot_y_rad(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_mult_rot_y_rad(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_mult_shift_x(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_mult_shift_x(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_mult_shift_x(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_mult_shift_y(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_mult_shift_y(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_mult_shift_y(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get_mult_shift_s(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set_mult_shift_s(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp_mult_shift_s(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get__sin_rot_s(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set__sin_rot_s(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp__sin_rot_s(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get__cos_rot_s(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set__cos_rot_s(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp__cos_rot_s(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get__shift_x(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set__shift_x(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp__shift_x(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get__shift_y(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set__shift_y(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp__shift_y(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double SolenoidData_get__shift_s(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void SolenoidData_set__shift_s(SolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* SolenoidData_getp__shift_s(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier SolenoidData_getp__internal_record_id(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t SolenoidData_get__internal_record_id_buffer_id(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SolenoidData_set__internal_record_id_buffer_id(SolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SolenoidData_getp__internal_record_id_buffer_id(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t SolenoidData_get__internal_record_id_offset(const SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void SolenoidData_set__internal_record_id_offset(SolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* SolenoidData_getp__internal_record_id_offset(SolenoidData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData SolenoidData_getp_internal_record(SolenoidData el, LocalParticle* part){
    RecordIdentifier record_id = SolenoidData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/solenoid.h>

             static inline
            void Solenoid_track_local_particle_with_transformations(SolenoidData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = SolenoidData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = SolenoidData_get__cos_rot_s(el);
    double const shift_x = SolenoidData_get__shift_x(el);
    double const shift_y = SolenoidData_get__shift_y(el);
    double const shift_s = SolenoidData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Solenoid_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = SolenoidData_get__cos_rot_s(el);
    double const shift_x = SolenoidData_get__shift_x(el);
    double const shift_y = SolenoidData_get__shift_y(el);
    double const shift_s = SolenoidData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Solenoid_track_particles(
               SolenoidData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Solenoid_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_FirstOrderTaylorMapData
#define XOBJ_TYPEDEF_FirstOrderTaylorMapData
typedef   struct FirstOrderTaylorMapData_s * FirstOrderTaylorMapData;
 static inline FirstOrderTaylorMapData FirstOrderTaylorMapData_getp(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  return (FirstOrderTaylorMapData)(( char*) obj+offset);
}
 static inline double FirstOrderTaylorMapData_get_length(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set_length(FirstOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp_length(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr6Float64 FirstOrderTaylorMapData_getp_m0(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return (Arr6Float64)(( char*) obj+offset);
}
 static inline int64_t FirstOrderTaylorMapData_len_m0(FirstOrderTaylorMapData restrict  obj){
  return 6;
}
 static inline double FirstOrderTaylorMapData_get_m0(const FirstOrderTaylorMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=8;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set_m0(FirstOrderTaylorMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=8;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp1_m0(FirstOrderTaylorMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=8;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr6x6Float64 FirstOrderTaylorMapData_getp_m1(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return (Arr6x6Float64)(( char*) obj+offset);
}
 static inline int64_t FirstOrderTaylorMapData_len_m1(FirstOrderTaylorMapData restrict  obj){
  return 36;
}
 static inline double FirstOrderTaylorMapData_get_m1(const FirstOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=56;
  offset+=i0*48+i1*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set_m1(FirstOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1, double value){
  int64_t offset=0;
  offset+=56;
  offset+=i0*48+i1*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp2_m1(FirstOrderTaylorMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=56;
  offset+=i0*48+i1*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double FirstOrderTaylorMapData_get__sin_rot_s(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=344;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set__sin_rot_s(FirstOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=344;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp__sin_rot_s(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=344;
  return ( double*)(( char*) obj+offset);
}
 static inline double FirstOrderTaylorMapData_get__cos_rot_s(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=352;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set__cos_rot_s(FirstOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=352;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp__cos_rot_s(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=352;
  return ( double*)(( char*) obj+offset);
}
 static inline double FirstOrderTaylorMapData_get__shift_x(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=360;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set__shift_x(FirstOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=360;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp__shift_x(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=360;
  return ( double*)(( char*) obj+offset);
}
 static inline double FirstOrderTaylorMapData_get__shift_y(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=368;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set__shift_y(FirstOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=368;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp__shift_y(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=368;
  return ( double*)(( char*) obj+offset);
}
 static inline double FirstOrderTaylorMapData_get__shift_s(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=376;
  return *( double*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set__shift_s(FirstOrderTaylorMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=376;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* FirstOrderTaylorMapData_getp__shift_s(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=376;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier FirstOrderTaylorMapData_getp__internal_record_id(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=384;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t FirstOrderTaylorMapData_get__internal_record_id_buffer_id(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=384;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set__internal_record_id_buffer_id(FirstOrderTaylorMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=384;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* FirstOrderTaylorMapData_getp__internal_record_id_buffer_id(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=384;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t FirstOrderTaylorMapData_get__internal_record_id_offset(const FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=392;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void FirstOrderTaylorMapData_set__internal_record_id_offset(FirstOrderTaylorMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=392;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* FirstOrderTaylorMapData_getp__internal_record_id_offset(FirstOrderTaylorMapData restrict  obj){
  int64_t offset=0;
  offset+=392;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData FirstOrderTaylorMapData_getp_internal_record(FirstOrderTaylorMapData el, LocalParticle* part){
    RecordIdentifier record_id = FirstOrderTaylorMapData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/firstordertaylormap.h>

             static inline
            void FirstOrderTaylorMap_track_local_particle_with_transformations(FirstOrderTaylorMapData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = FirstOrderTaylorMapData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = FirstOrderTaylorMapData_get__cos_rot_s(el);
    double const shift_x = FirstOrderTaylorMapData_get__shift_x(el);
    double const shift_y = FirstOrderTaylorMapData_get__shift_y(el);
    double const shift_s = FirstOrderTaylorMapData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    FirstOrderTaylorMap_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = FirstOrderTaylorMapData_get__cos_rot_s(el);
    double const shift_x = FirstOrderTaylorMapData_get__shift_x(el);
    double const shift_y = FirstOrderTaylorMapData_get__shift_y(el);
    double const shift_s = FirstOrderTaylorMapData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void FirstOrderTaylorMap_track_particles(
               FirstOrderTaylorMapData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              FirstOrderTaylorMap_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_BendData
#define XOBJ_TYPEDEF_BendData
typedef   struct BendData_s * BendData;
 static inline BendData BendData_getp(BendData restrict  obj){
  int64_t offset=0;
  return (BendData)(( char*) obj+offset);
}
 static inline double BendData_get_k0(const BendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_k0(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_k0(BendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_k1(const BendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_k1(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_k1(BendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_h(const BendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_h(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_h(BendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_angle(const BendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_angle(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_angle(BendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_length(const BendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_length(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_length(BendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_model(const BendData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_model(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_model(BendData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_integrator(const BendData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_integrator(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_integrator(BendData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_radiation_flag(const BendData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_radiation_flag(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_radiation_flag(BendData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BendData_get_delta_taper(const BendData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_delta_taper(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_delta_taper(BendData restrict  obj){
  int64_t offset=0;
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_edge_entry_active(const BendData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_entry_active(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_edge_entry_active(BendData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_edge_exit_active(const BendData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_exit_active(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_edge_exit_active(BendData restrict  obj){
  int64_t offset=0;
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_edge_entry_model(const BendData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_entry_model(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_edge_entry_model(BendData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_edge_exit_model(const BendData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_exit_model(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_edge_exit_model(BendData restrict  obj){
  int64_t offset=0;
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_entry_angle(const BendData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_entry_angle(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_entry_angle(BendData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_exit_angle(const BendData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_exit_angle(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_exit_angle(BendData restrict  obj){
  int64_t offset=0;
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_entry_angle_fdown(const BendData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_entry_angle_fdown(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_entry_angle_fdown(BendData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_exit_angle_fdown(const BendData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_exit_angle_fdown(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_exit_angle_fdown(BendData restrict  obj){
  int64_t offset=0;
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_entry_fint(const BendData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_entry_fint(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_entry_fint(BendData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_exit_fint(const BendData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_exit_fint(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_exit_fint(BendData restrict  obj){
  int64_t offset=0;
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_entry_hgap(const BendData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_entry_hgap(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_entry_hgap(BendData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get_edge_exit_hgap(const BendData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_edge_exit_hgap(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_edge_exit_hgap(BendData restrict  obj){
  int64_t offset=0;
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_num_multipole_kicks(const BendData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_num_multipole_kicks(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_num_multipole_kicks(BendData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BendData_get_order(const BendData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_order(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp_order(BendData restrict  obj){
  int64_t offset=0;
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double BendData_get_inv_factorial_order(const BendData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_inv_factorial_order(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp_inv_factorial_order(BendData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BendData_getp_knl(BendData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BendData_len_knl(BendData restrict  obj){
  int64_t offset=0;
  offset+=272;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BendData_get_knl(const BendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=272;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_knl(BendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=272;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp1_knl(BendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=272;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 BendData_getp_ksl(BendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t BendData_len_ksl(BendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double BendData_get_ksl(const BendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set_ksl(BendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp1_ksl(BendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t BendData_get_k0_from_h(const BendData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void BendData_set_k0_from_h(BendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* BendData_getp_k0_from_h(BendData restrict  obj){
  int64_t offset=0;
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double BendData_get__sin_rot_s(const BendData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set__sin_rot_s(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp__sin_rot_s(BendData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get__cos_rot_s(const BendData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set__cos_rot_s(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp__cos_rot_s(BendData restrict  obj){
  int64_t offset=0;
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get__shift_x(const BendData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set__shift_x(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp__shift_x(BendData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get__shift_y(const BendData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set__shift_y(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp__shift_y(BendData restrict  obj){
  int64_t offset=0;
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double BendData_get__shift_s(const BendData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void BendData_set__shift_s(BendData restrict  obj, double value){
  int64_t offset=0;
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* BendData_getp__shift_s(BendData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier BendData_getp__internal_record_id(BendData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t BendData_get__internal_record_id_buffer_id(const BendData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set__internal_record_id_buffer_id(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=248;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp__internal_record_id_buffer_id(BendData restrict  obj){
  int64_t offset=0;
  offset+=248;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t BendData_get__internal_record_id_offset(const BendData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void BendData_set__internal_record_id_offset(BendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* BendData_getp__internal_record_id_offset(BendData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData BendData_getp_internal_record(BendData el, LocalParticle* part){
    RecordIdentifier record_id = BendData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/bend.h>

             static inline
            void Bend_track_local_particle_with_transformations(BendData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = BendData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BendData_get__cos_rot_s(el);
    double const shift_x = BendData_get__shift_x(el);
    double const shift_y = BendData_get__shift_y(el);
    double const shift_s = BendData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    Bend_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = BendData_get__cos_rot_s(el);
    double const shift_x = BendData_get__shift_x(el);
    double const shift_y = BendData_get__shift_y(el);
    double const shift_s = BendData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void Bend_track_particles(
               BendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              Bend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_LineSegmentMapData
#define XOBJ_TYPEDEF_LineSegmentMapData
typedef   struct LineSegmentMapData_s * LineSegmentMapData;
 static inline LineSegmentMapData LineSegmentMapData_getp(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  return (LineSegmentMapData)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_length(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_length(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_length(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_qx(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_qx(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_qx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_qy(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_qy(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_qy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LineSegmentMapData_getp_coeffs_dqx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=1000;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_coeffs_dqx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=1000;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LineSegmentMapData_get_coeffs_dqx(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=1000;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_coeffs_dqx(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=1000;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_coeffs_dqx(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=1000;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LineSegmentMapData_getp_coeffs_dqy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+968);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_coeffs_dqy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+968);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LineSegmentMapData_get_coeffs_dqy(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+968);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_coeffs_dqy(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+968);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_coeffs_dqy(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+968);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_det_xx(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_det_xx(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_det_xx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_det_xy(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_det_xy(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_det_xy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_det_yy(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_det_yy(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_det_yy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_det_yx(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_det_yx(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_det_yx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_betx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=64;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_betx(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_betx(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=64;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_betx(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=64;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_betx(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=64;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_bety(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=80;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_bety(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_bety(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_bety(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=80;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_bety(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=80;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_alfx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=96;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_alfx(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_alfx(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=96;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_alfx(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=96;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_alfx(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=96;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_alfy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=112;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_alfy(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_alfy(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=112;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_alfy(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=112;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_alfy(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=112;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_dx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=128;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_dx(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_dx(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_dx(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=128;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_dx(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=128;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_dpx(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=144;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_dpx(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_dpx(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_dpx(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=144;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_dpx(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=144;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_dy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=160;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_dy(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_dy(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=160;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_dy(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=160;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_dy(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=160;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_dpy(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=176;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_dpy(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_dpy(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=176;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_dpy(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=176;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_dpy(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=176;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_x_ref(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=192;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_x_ref(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_x_ref(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=192;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_x_ref(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=192;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_x_ref(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=192;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_px_ref(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=208;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_px_ref(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_px_ref(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=208;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_px_ref(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=208;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_px_ref(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=208;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_y_ref(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=224;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_y_ref(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_y_ref(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=224;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_y_ref(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=224;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_y_ref(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=224;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline Arr2Float64 LineSegmentMapData_getp_py_ref(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=240;
  return (Arr2Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_py_ref(LineSegmentMapData restrict  obj){
  return 2;
}
 static inline double LineSegmentMapData_get_py_ref(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=240;
  offset+=i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_py_ref(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=240;
  offset+=i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_py_ref(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=240;
  offset+=i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_energy_ref_increment(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_energy_ref_increment(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=256;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_energy_ref_increment(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=256;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_energy_increment(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_energy_increment(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=264;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_energy_increment(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=264;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_get_uncorrelated_rad_damping(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_uncorrelated_rad_damping(LineSegmentMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=272;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LineSegmentMapData_getp_uncorrelated_rad_damping(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=272;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_get_correlated_rad_damping(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_correlated_rad_damping(LineSegmentMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=280;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LineSegmentMapData_getp_correlated_rad_damping(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=280;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline Arr6x6Float64 LineSegmentMapData_getp_damping_factors(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=288;
  return (Arr6x6Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_damping_factors(LineSegmentMapData restrict  obj){
  return 36;
}
 static inline double LineSegmentMapData_get_damping_factors(const LineSegmentMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=288;
  offset+=i0*48+i1*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_damping_factors(LineSegmentMapData restrict  obj, int64_t i0, int64_t i1, double value){
  int64_t offset=0;
  offset+=288;
  offset+=i0*48+i1*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp2_damping_factors(LineSegmentMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=288;
  offset+=i0*48+i1*8;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_get_uncorrelated_gauss_noise(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=576;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_uncorrelated_gauss_noise(LineSegmentMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=576;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LineSegmentMapData_getp_uncorrelated_gauss_noise(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=576;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_get_correlated_gauss_noise(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=584;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_correlated_gauss_noise(LineSegmentMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=584;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LineSegmentMapData_getp_correlated_gauss_noise(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=584;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline Arr6x6Float64 LineSegmentMapData_getp_gauss_noise_matrix(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=592;
  return (Arr6x6Float64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_gauss_noise_matrix(LineSegmentMapData restrict  obj){
  return 36;
}
 static inline double LineSegmentMapData_get_gauss_noise_matrix(const LineSegmentMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=592;
  offset+=i0*48+i1*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_gauss_noise_matrix(LineSegmentMapData restrict  obj, int64_t i0, int64_t i1, double value){
  int64_t offset=0;
  offset+=592;
  offset+=i0*48+i1*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp2_gauss_noise_matrix(LineSegmentMapData restrict  obj, int64_t i0, int64_t i1){
  int64_t offset=0;
  offset+=592;
  offset+=i0*48+i1*8;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_get_longitudinal_mode_flag(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=880;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_longitudinal_mode_flag(LineSegmentMapData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=880;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* LineSegmentMapData_getp_longitudinal_mode_flag(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=880;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_qs(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=888;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_qs(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=888;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_qs(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=888;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_bets(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=896;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_bets(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=896;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_bets(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=896;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_bucket_length(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=904;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_bucket_length(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=904;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_bucket_length(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=904;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_momentum_compaction_factor(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=912;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_momentum_compaction_factor(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=912;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_momentum_compaction_factor(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=912;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get_slippage_length(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=920;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_slippage_length(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=920;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp_slippage_length(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=920;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LineSegmentMapData_getp_voltage_rf(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+976);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_voltage_rf(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+976);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LineSegmentMapData_get_voltage_rf(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+976);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_voltage_rf(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+976);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_voltage_rf(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+976);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LineSegmentMapData_getp_frequency_rf(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+984);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_frequency_rf(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+984);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LineSegmentMapData_get_frequency_rf(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+984);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_frequency_rf(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+984);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_frequency_rf(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+984);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 LineSegmentMapData_getp_lag_rf(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+992);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t LineSegmentMapData_len_lag_rf(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+992);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double LineSegmentMapData_get_lag_rf(const LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+992);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set_lag_rf(LineSegmentMapData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+992);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp1_lag_rf(LineSegmentMapData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+992);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get__sin_rot_s(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=928;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set__sin_rot_s(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=928;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp__sin_rot_s(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=928;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get__cos_rot_s(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=936;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set__cos_rot_s(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=936;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp__cos_rot_s(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=936;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get__shift_x(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=944;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set__shift_x(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=944;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp__shift_x(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=944;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get__shift_y(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=952;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set__shift_y(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=952;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp__shift_y(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=952;
  return ( double*)(( char*) obj+offset);
}
 static inline double LineSegmentMapData_get__shift_s(const LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=960;
  return *( double*)(( char*) obj+offset);
}
 static inline void LineSegmentMapData_set__shift_s(LineSegmentMapData restrict  obj, double value){
  int64_t offset=0;
  offset+=960;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* LineSegmentMapData_getp__shift_s(LineSegmentMapData restrict  obj){
  int64_t offset=0;
  offset+=960;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/linesegmentmap.h>

             static inline
            void LineSegmentMap_track_local_particle_with_transformations(LineSegmentMapData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = LineSegmentMapData_get__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LineSegmentMapData_get__cos_rot_s(el);
    double const shift_x = LineSegmentMapData_get__shift_x(el);
    double const shift_y = LineSegmentMapData_get__shift_y(el);
    double const shift_s = LineSegmentMapData_get__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    LineSegmentMap_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = LineSegmentMapData_get__cos_rot_s(el);
    double const shift_x = LineSegmentMapData_get__shift_x(el);
    double const shift_y = LineSegmentMapData_get__shift_y(el);
    double const shift_s = LineSegmentMapData_get__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void LineSegmentMap_track_particles(
               LineSegmentMapData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              LineSegmentMap_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_RefRBendData
#define XOBJ_TYPEDEF_RefRBendData
typedef   struct RefRBendData_s * RefRBendData;
#endif
#ifndef XOBJ_TYPEDEF_RefQuadrupoleData
#define XOBJ_TYPEDEF_RefQuadrupoleData
typedef   struct RefQuadrupoleData_s * RefQuadrupoleData;
#endif
#ifndef XOBJ_TYPEDEF_RefOctupoleData
#define XOBJ_TYPEDEF_RefOctupoleData
typedef   struct RefOctupoleData_s * RefOctupoleData;
#endif
#ifndef XOBJ_TYPEDEF_RefSextupoleData
#define XOBJ_TYPEDEF_RefSextupoleData
typedef   struct RefSextupoleData_s * RefSextupoleData;
#endif
#ifndef XOBJ_TYPEDEF_RefSolenoidData
#define XOBJ_TYPEDEF_RefSolenoidData
typedef   struct RefSolenoidData_s * RefSolenoidData;
#endif
#ifndef XOBJ_TYPEDEF_RefBendData
#define XOBJ_TYPEDEF_RefBendData
typedef   struct RefBendData_s * RefBendData;
#endif
#ifndef XOBJ_TYPEDEF_DriftSliceRBendData
#define XOBJ_TYPEDEF_DriftSliceRBendData
typedef   struct DriftSliceRBendData_s * DriftSliceRBendData;
 static inline DriftSliceRBendData DriftSliceRBendData_getp(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  return (DriftSliceRBendData)(( char*) obj+offset);
}
 static inline RBendData DriftSliceRBendData_getp__parent(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (RBendData)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_k0(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_k0(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_k0(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_k1(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_k1(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_k1(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_h(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_h(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_h(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_angle(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_angle(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_angle(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_length(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_length(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_length(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_model(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_model(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_model(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_integrator(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_integrator(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_integrator(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_radiation_flag(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_radiation_flag(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_radiation_flag(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_delta_taper(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_delta_taper(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_delta_taper(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_edge_entry_active(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_entry_active(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_edge_entry_active(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_edge_exit_active(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_exit_active(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_edge_exit_active(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_edge_entry_model(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_entry_model(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_edge_entry_model(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_edge_exit_model(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_exit_model(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_edge_exit_model(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_entry_angle(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_entry_angle(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_entry_angle(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_exit_angle(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_exit_angle(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_exit_angle(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_entry_angle_fdown(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_entry_angle_fdown(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_entry_angle_fdown(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_exit_angle_fdown(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_exit_angle_fdown(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_exit_angle_fdown(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_entry_fint(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_entry_fint(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_entry_fint(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_exit_fint(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_exit_fint(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_exit_fint(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_entry_hgap(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_entry_hgap(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_entry_hgap(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_edge_exit_hgap(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_edge_exit_hgap(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_edge_exit_hgap(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_num_multipole_kicks(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_num_multipole_kicks(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_num_multipole_kicks(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent_order(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_order(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent_order(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_inv_factorial_order(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_inv_factorial_order(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_inv_factorial_order(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceRBendData_getp__parent_knl(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_len__parent_knl(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceRBendData_get__parent_knl(const DriftSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_knl(DriftSliceRBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp1__parent_knl(DriftSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceRBendData_getp__parent_ksl(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_len__parent_ksl(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceRBendData_get__parent_ksl(const DriftSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_ksl(DriftSliceRBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp1__parent_ksl(DriftSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceRBendData_get__parent_k0_from_h(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_k0_from_h(DriftSliceRBendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceRBendData_getp__parent_k0_from_h(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent_length_straight(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent_length_straight(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent_length_straight(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent__sin_rot_s(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent__sin_rot_s(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent__sin_rot_s(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent__cos_rot_s(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent__cos_rot_s(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent__cos_rot_s(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent__shift_x(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent__shift_x(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent__shift_x(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent__shift_y(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent__shift_y(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent__shift_y(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get__parent__shift_s(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent__shift_s(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp__parent__shift_s(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier DriftSliceRBendData_getp__parent__internal_record_id(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent__internal_record_id_buffer_id(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent__internal_record_id_buffer_id(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent__internal_record_id_buffer_id(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get__parent__internal_record_id_offset(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set__parent__internal_record_id_offset(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp__parent__internal_record_id_offset(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceRBendData_get_radiation_flag(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set_radiation_flag(DriftSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceRBendData_getp_radiation_flag(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get_delta_taper(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set_delta_taper(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp_delta_taper(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceRBendData_get_weight(const DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceRBendData_set_weight(DriftSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceRBendData_getp_weight(DriftSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/drift_slice_rbend.h>

             static inline
            void DriftSliceRBend_track_local_particle_with_transformations(DriftSliceRBendData el, LocalParticle* part0){
    DriftSliceRBend_track_local_particle(el, part0);
}


             
            void DriftSliceRBend_track_particles(
               DriftSliceRBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              DriftSliceRBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThickSliceRBendData
#define XOBJ_TYPEDEF_ThickSliceRBendData
typedef   struct ThickSliceRBendData_s * ThickSliceRBendData;
 static inline ThickSliceRBendData ThickSliceRBendData_getp(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  return (ThickSliceRBendData)(( char*) obj+offset);
}
 static inline RBendData ThickSliceRBendData_getp__parent(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (RBendData)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_k0(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_k0(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_k0(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_k1(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_k1(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_k1(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_h(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_h(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_h(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_angle(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_angle(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_angle(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_length(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_length(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_length(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_model(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_model(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_model(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_integrator(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_integrator(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_integrator(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_radiation_flag(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_radiation_flag(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_radiation_flag(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_delta_taper(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_delta_taper(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_delta_taper(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_edge_entry_active(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_entry_active(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_edge_entry_active(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_edge_exit_active(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_exit_active(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_edge_exit_active(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_edge_entry_model(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_entry_model(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_edge_entry_model(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_edge_exit_model(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_exit_model(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_edge_exit_model(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_entry_angle(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_entry_angle(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_entry_angle(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_exit_angle(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_exit_angle(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_exit_angle(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_entry_angle_fdown(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_entry_angle_fdown(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_entry_angle_fdown(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_exit_angle_fdown(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_exit_angle_fdown(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_exit_angle_fdown(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_entry_fint(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_entry_fint(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_entry_fint(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_exit_fint(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_exit_fint(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_exit_fint(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_entry_hgap(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_entry_hgap(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_entry_hgap(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_edge_exit_hgap(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_edge_exit_hgap(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_edge_exit_hgap(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_num_multipole_kicks(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_num_multipole_kicks(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_num_multipole_kicks(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent_order(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_order(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent_order(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_inv_factorial_order(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_inv_factorial_order(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_inv_factorial_order(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceRBendData_getp__parent_knl(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_len__parent_knl(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceRBendData_get__parent_knl(const ThickSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_knl(ThickSliceRBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp1__parent_knl(ThickSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceRBendData_getp__parent_ksl(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_len__parent_ksl(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceRBendData_get__parent_ksl(const ThickSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_ksl(ThickSliceRBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp1__parent_ksl(ThickSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceRBendData_get__parent_k0_from_h(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_k0_from_h(ThickSliceRBendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceRBendData_getp__parent_k0_from_h(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent_length_straight(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent_length_straight(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent_length_straight(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent__sin_rot_s(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent__sin_rot_s(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent__sin_rot_s(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent__cos_rot_s(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent__cos_rot_s(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent__cos_rot_s(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent__shift_x(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent__shift_x(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent__shift_x(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent__shift_y(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent__shift_y(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent__shift_y(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get__parent__shift_s(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent__shift_s(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp__parent__shift_s(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceRBendData_getp__parent__internal_record_id(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent__internal_record_id_buffer_id(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent__internal_record_id_buffer_id(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent__internal_record_id_buffer_id(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get__parent__internal_record_id_offset(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set__parent__internal_record_id_offset(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp__parent__internal_record_id_offset(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceRBendData_get_radiation_flag(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set_radiation_flag(ThickSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceRBendData_getp_radiation_flag(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get_delta_taper(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set_delta_taper(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp_delta_taper(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceRBendData_get_weight(const ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceRBendData_set_weight(ThickSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceRBendData_getp_weight(ThickSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thick_slice_rbend.h>

             static inline
            void ThickSliceRBend_track_local_particle_with_transformations(ThickSliceRBendData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThickSliceRBendData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceRBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceRBendData_get__parent__shift_x(el);
    double const shift_y = ThickSliceRBendData_get__parent__shift_y(el);
    double const shift_s = ThickSliceRBendData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThickSliceRBend_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceRBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceRBendData_get__parent__shift_x(el);
    double const shift_y = ThickSliceRBendData_get__parent__shift_y(el);
    double const shift_s = ThickSliceRBendData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThickSliceRBend_track_particles(
               ThickSliceRBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThickSliceRBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceRBendData
#define XOBJ_TYPEDEF_ThinSliceRBendData
typedef   struct ThinSliceRBendData_s * ThinSliceRBendData;
 static inline ThinSliceRBendData ThinSliceRBendData_getp(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  return (ThinSliceRBendData)(( char*) obj+offset);
}
 static inline RBendData ThinSliceRBendData_getp__parent(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (RBendData)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_k0(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_k0(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_k0(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_k1(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_k1(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_k1(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_h(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_h(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_h(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_angle(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_angle(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_angle(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_length(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_length(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_length(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_model(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_model(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_model(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_integrator(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_integrator(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_integrator(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_radiation_flag(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_radiation_flag(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_radiation_flag(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_delta_taper(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_delta_taper(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_delta_taper(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_edge_entry_active(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_entry_active(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_edge_entry_active(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_edge_exit_active(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_exit_active(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_edge_exit_active(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_edge_entry_model(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_entry_model(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_edge_entry_model(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_edge_exit_model(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_exit_model(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_edge_exit_model(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_entry_angle(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_entry_angle(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_entry_angle(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_exit_angle(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_exit_angle(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_exit_angle(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_entry_angle_fdown(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_entry_angle_fdown(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_entry_angle_fdown(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_exit_angle_fdown(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_exit_angle_fdown(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_exit_angle_fdown(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_entry_fint(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_entry_fint(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_entry_fint(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_exit_fint(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_exit_fint(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_exit_fint(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_entry_hgap(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_entry_hgap(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_entry_hgap(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_edge_exit_hgap(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_edge_exit_hgap(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_edge_exit_hgap(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_num_multipole_kicks(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_num_multipole_kicks(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_num_multipole_kicks(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent_order(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_order(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent_order(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_inv_factorial_order(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_inv_factorial_order(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_inv_factorial_order(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceRBendData_getp__parent_knl(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_len__parent_knl(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceRBendData_get__parent_knl(const ThinSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_knl(ThinSliceRBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp1__parent_knl(ThinSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceRBendData_getp__parent_ksl(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_len__parent_ksl(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceRBendData_get__parent_ksl(const ThinSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_ksl(ThinSliceRBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp1__parent_ksl(ThinSliceRBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceRBendData_get__parent_k0_from_h(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_k0_from_h(ThinSliceRBendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceRBendData_getp__parent_k0_from_h(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent_length_straight(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent_length_straight(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent_length_straight(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent__sin_rot_s(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent__sin_rot_s(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent__sin_rot_s(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent__cos_rot_s(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent__cos_rot_s(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent__cos_rot_s(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent__shift_x(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent__shift_x(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent__shift_x(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent__shift_y(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent__shift_y(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent__shift_y(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get__parent__shift_s(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent__shift_s(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp__parent__shift_s(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceRBendData_getp__parent__internal_record_id(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent__internal_record_id_buffer_id(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent__internal_record_id_buffer_id(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent__internal_record_id_buffer_id(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__parent__internal_record_id_offset(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__parent__internal_record_id_offset(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__parent__internal_record_id_offset(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get_radiation_flag(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set_radiation_flag(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp_radiation_flag(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get_delta_taper(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set_delta_taper(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp_delta_taper(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendData_get_weight(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set_weight(ThinSliceRBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendData_getp_weight(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceRBendData_getp__internal_record_id(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__internal_record_id_buffer_id(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__internal_record_id_buffer_id(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__internal_record_id_buffer_id(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendData_get__internal_record_id_offset(const ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendData_set__internal_record_id_offset(ThinSliceRBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendData_getp__internal_record_id_offset(ThinSliceRBendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThinSliceRBendData_getp_internal_record(ThinSliceRBendData el, LocalParticle* part){
    RecordIdentifier record_id = ThinSliceRBendData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/thin_slice_rbend.h>

             static inline
            void ThinSliceRBend_track_local_particle_with_transformations(ThinSliceRBendData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceRBendData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceRBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceRBendData_get__parent__shift_x(el);
    double const shift_y = ThinSliceRBendData_get__parent__shift_y(el);
    double const shift_s = ThinSliceRBendData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceRBend_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceRBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceRBendData_get__parent__shift_x(el);
    double const shift_y = ThinSliceRBendData_get__parent__shift_y(el);
    double const shift_s = ThinSliceRBendData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceRBend_track_particles(
               ThinSliceRBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceRBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceRBendEntryData
#define XOBJ_TYPEDEF_ThinSliceRBendEntryData
typedef   struct ThinSliceRBendEntryData_s * ThinSliceRBendEntryData;
 static inline ThinSliceRBendEntryData ThinSliceRBendEntryData_getp(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  return (ThinSliceRBendEntryData)(( char*) obj+offset);
}
 static inline RBendData ThinSliceRBendEntryData_getp__parent(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (RBendData)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_k0(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_k0(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_k0(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_k1(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_k1(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_k1(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_h(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_h(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_h(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_angle(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_angle(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_angle(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_length(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_length(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_length(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_model(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_model(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_model(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_integrator(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_integrator(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_integrator(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_radiation_flag(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_radiation_flag(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_radiation_flag(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_delta_taper(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_delta_taper(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_delta_taper(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_edge_entry_active(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_entry_active(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_edge_entry_active(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_edge_exit_active(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_exit_active(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_edge_exit_active(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_edge_entry_model(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_entry_model(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_edge_entry_model(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_edge_exit_model(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_exit_model(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_edge_exit_model(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_entry_angle(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_entry_angle(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_entry_angle(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_exit_angle(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_exit_angle(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_exit_angle(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_entry_angle_fdown(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_entry_angle_fdown(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_entry_angle_fdown(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_exit_angle_fdown(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_exit_angle_fdown(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_exit_angle_fdown(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_entry_fint(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_entry_fint(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_entry_fint(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_exit_fint(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_exit_fint(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_exit_fint(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_entry_hgap(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_entry_hgap(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_entry_hgap(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_edge_exit_hgap(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_edge_exit_hgap(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_edge_exit_hgap(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_num_multipole_kicks(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_num_multipole_kicks(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_num_multipole_kicks(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent_order(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_order(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent_order(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_inv_factorial_order(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_inv_factorial_order(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_inv_factorial_order(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceRBendEntryData_getp__parent_knl(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_len__parent_knl(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceRBendEntryData_get__parent_knl(const ThinSliceRBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_knl(ThinSliceRBendEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp1__parent_knl(ThinSliceRBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceRBendEntryData_getp__parent_ksl(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_len__parent_ksl(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceRBendEntryData_get__parent_ksl(const ThinSliceRBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_ksl(ThinSliceRBendEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp1__parent_ksl(ThinSliceRBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceRBendEntryData_get__parent_k0_from_h(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_k0_from_h(ThinSliceRBendEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceRBendEntryData_getp__parent_k0_from_h(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent_length_straight(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent_length_straight(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent_length_straight(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent__sin_rot_s(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent__sin_rot_s(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent__sin_rot_s(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent__cos_rot_s(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent__cos_rot_s(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent__cos_rot_s(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent__shift_x(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent__shift_x(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent__shift_x(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent__shift_y(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent__shift_y(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent__shift_y(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get__parent__shift_s(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent__shift_s(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp__parent__shift_s(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceRBendEntryData_getp__parent__internal_record_id(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent__internal_record_id_buffer_id(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent__internal_record_id_buffer_id(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent__internal_record_id_buffer_id(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get__parent__internal_record_id_offset(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set__parent__internal_record_id_offset(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp__parent__internal_record_id_offset(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendEntryData_get_radiation_flag(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set_radiation_flag(ThinSliceRBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendEntryData_getp_radiation_flag(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get_delta_taper(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set_delta_taper(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp_delta_taper(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendEntryData_get_weight(const ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendEntryData_set_weight(ThinSliceRBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendEntryData_getp_weight(ThinSliceRBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_rbend_entry.h>

             static inline
            void ThinSliceRBendEntry_track_local_particle_with_transformations(ThinSliceRBendEntryData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceRBendEntryData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceRBendEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceRBendEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceRBendEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceRBendEntryData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceRBendEntry_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceRBendEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceRBendEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceRBendEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceRBendEntryData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceRBendEntry_track_particles(
               ThinSliceRBendEntryData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceRBendEntry_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceRBendExitData
#define XOBJ_TYPEDEF_ThinSliceRBendExitData
typedef   struct ThinSliceRBendExitData_s * ThinSliceRBendExitData;
 static inline ThinSliceRBendExitData ThinSliceRBendExitData_getp(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  return (ThinSliceRBendExitData)(( char*) obj+offset);
}
 static inline RBendData ThinSliceRBendExitData_getp__parent(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (RBendData)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_k0(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_k0(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_k0(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_k1(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_k1(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_k1(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_h(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_h(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_h(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_angle(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_angle(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_angle(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_length(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_length(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_length(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_model(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_model(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_model(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_integrator(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_integrator(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_integrator(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_radiation_flag(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_radiation_flag(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_radiation_flag(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_delta_taper(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_delta_taper(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_delta_taper(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_edge_entry_active(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_entry_active(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_edge_entry_active(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_edge_exit_active(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_exit_active(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_edge_exit_active(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_edge_entry_model(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_entry_model(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_edge_entry_model(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_edge_exit_model(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_exit_model(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_edge_exit_model(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_entry_angle(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_entry_angle(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_entry_angle(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_exit_angle(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_exit_angle(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_exit_angle(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_entry_angle_fdown(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_entry_angle_fdown(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_entry_angle_fdown(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_exit_angle_fdown(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_exit_angle_fdown(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_exit_angle_fdown(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_entry_fint(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_entry_fint(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_entry_fint(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_exit_fint(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_exit_fint(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_exit_fint(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_entry_hgap(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_entry_hgap(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_entry_hgap(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_edge_exit_hgap(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_edge_exit_hgap(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_edge_exit_hgap(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_num_multipole_kicks(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_num_multipole_kicks(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_num_multipole_kicks(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent_order(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_order(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent_order(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_inv_factorial_order(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_inv_factorial_order(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_inv_factorial_order(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceRBendExitData_getp__parent_knl(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_len__parent_knl(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceRBendExitData_get__parent_knl(const ThinSliceRBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_knl(ThinSliceRBendExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp1__parent_knl(ThinSliceRBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=280;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceRBendExitData_getp__parent_ksl(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_len__parent_ksl(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceRBendExitData_get__parent_ksl(const ThinSliceRBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_ksl(ThinSliceRBendExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp1__parent_ksl(ThinSliceRBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+272);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceRBendExitData_get__parent_k0_from_h(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_k0_from_h(ThinSliceRBendExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceRBendExitData_getp__parent_k0_from_h(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent_length_straight(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent_length_straight(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent_length_straight(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent__sin_rot_s(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent__sin_rot_s(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent__sin_rot_s(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent__cos_rot_s(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent__cos_rot_s(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent__cos_rot_s(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent__shift_x(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent__shift_x(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent__shift_x(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent__shift_y(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent__shift_y(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent__shift_y(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get__parent__shift_s(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent__shift_s(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp__parent__shift_s(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceRBendExitData_getp__parent__internal_record_id(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent__internal_record_id_buffer_id(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent__internal_record_id_buffer_id(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent__internal_record_id_buffer_id(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get__parent__internal_record_id_offset(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set__parent__internal_record_id_offset(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp__parent__internal_record_id_offset(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=264;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceRBendExitData_get_radiation_flag(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set_radiation_flag(ThinSliceRBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceRBendExitData_getp_radiation_flag(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get_delta_taper(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set_delta_taper(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp_delta_taper(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceRBendExitData_get_weight(const ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceRBendExitData_set_weight(ThinSliceRBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceRBendExitData_getp_weight(ThinSliceRBendExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_rbend_exit.h>

             static inline
            void ThinSliceRBendExit_track_local_particle_with_transformations(ThinSliceRBendExitData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceRBendExitData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceRBendExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceRBendExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceRBendExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceRBendExitData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceRBendExit_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceRBendExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceRBendExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceRBendExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceRBendExitData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceRBendExit_track_particles(
               ThinSliceRBendExitData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceRBendExit_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_DriftSliceQuadrupoleData
#define XOBJ_TYPEDEF_DriftSliceQuadrupoleData
typedef   struct DriftSliceQuadrupoleData_s * DriftSliceQuadrupoleData;
 static inline DriftSliceQuadrupoleData DriftSliceQuadrupoleData_getp(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  return (DriftSliceQuadrupoleData)(( char*) obj+offset);
}
 static inline QuadrupoleData DriftSliceQuadrupoleData_getp__parent(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (QuadrupoleData)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent_k1(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_k1(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent_k1(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent_k1s(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_k1s(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent_k1s(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent_length(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_length(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent_length(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get__parent_num_multipole_kicks(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_num_multipole_kicks(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp__parent_num_multipole_kicks(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get__parent_order(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_order(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp__parent_order(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent_inv_factorial_order(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_inv_factorial_order(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent_inv_factorial_order(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceQuadrupoleData_getp__parent_knl(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_len__parent_knl(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceQuadrupoleData_get__parent_knl(const DriftSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_knl(DriftSliceQuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp1__parent_knl(DriftSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceQuadrupoleData_getp__parent_ksl(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_len__parent_ksl(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceQuadrupoleData_get__parent_ksl(const DriftSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_ksl(DriftSliceQuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp1__parent_ksl(DriftSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceQuadrupoleData_get__parent_edge_entry_active(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_edge_entry_active(DriftSliceQuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceQuadrupoleData_getp__parent_edge_entry_active(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceQuadrupoleData_get__parent_edge_exit_active(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_edge_exit_active(DriftSliceQuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceQuadrupoleData_getp__parent_edge_exit_active(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get__parent_model(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_model(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp__parent_model(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get__parent_integrator(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_integrator(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp__parent_integrator(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get__parent_radiation_flag(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_radiation_flag(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp__parent_radiation_flag(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent_delta_taper(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent_delta_taper(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent_delta_taper(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent__sin_rot_s(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent__sin_rot_s(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent__sin_rot_s(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent__cos_rot_s(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent__cos_rot_s(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent__cos_rot_s(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent__shift_x(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent__shift_x(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent__shift_x(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent__shift_y(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent__shift_y(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent__shift_y(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get__parent__shift_s(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent__shift_s(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp__parent__shift_s(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier DriftSliceQuadrupoleData_getp__parent__internal_record_id(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get__parent__internal_record_id_buffer_id(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent__internal_record_id_buffer_id(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp__parent__internal_record_id_buffer_id(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get__parent__internal_record_id_offset(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set__parent__internal_record_id_offset(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp__parent__internal_record_id_offset(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceQuadrupoleData_get_radiation_flag(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set_radiation_flag(DriftSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceQuadrupoleData_getp_radiation_flag(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get_delta_taper(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set_delta_taper(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp_delta_taper(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceQuadrupoleData_get_weight(const DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceQuadrupoleData_set_weight(DriftSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceQuadrupoleData_getp_weight(DriftSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/drift_slice_quadrupole.h>

             static inline
            void DriftSliceQuadrupole_track_local_particle_with_transformations(DriftSliceQuadrupoleData el, LocalParticle* part0){
    DriftSliceQuadrupole_track_local_particle(el, part0);
}


             
            void DriftSliceQuadrupole_track_particles(
               DriftSliceQuadrupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              DriftSliceQuadrupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThickSliceQuadrupoleData
#define XOBJ_TYPEDEF_ThickSliceQuadrupoleData
typedef   struct ThickSliceQuadrupoleData_s * ThickSliceQuadrupoleData;
 static inline ThickSliceQuadrupoleData ThickSliceQuadrupoleData_getp(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  return (ThickSliceQuadrupoleData)(( char*) obj+offset);
}
 static inline QuadrupoleData ThickSliceQuadrupoleData_getp__parent(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (QuadrupoleData)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent_k1(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_k1(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent_k1(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent_k1s(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_k1s(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent_k1s(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent_length(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_length(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent_length(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get__parent_num_multipole_kicks(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_num_multipole_kicks(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp__parent_num_multipole_kicks(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get__parent_order(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_order(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp__parent_order(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent_inv_factorial_order(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_inv_factorial_order(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent_inv_factorial_order(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceQuadrupoleData_getp__parent_knl(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_len__parent_knl(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceQuadrupoleData_get__parent_knl(const ThickSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_knl(ThickSliceQuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp1__parent_knl(ThickSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceQuadrupoleData_getp__parent_ksl(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_len__parent_ksl(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceQuadrupoleData_get__parent_ksl(const ThickSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_ksl(ThickSliceQuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp1__parent_ksl(ThickSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceQuadrupoleData_get__parent_edge_entry_active(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_edge_entry_active(ThickSliceQuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceQuadrupoleData_getp__parent_edge_entry_active(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceQuadrupoleData_get__parent_edge_exit_active(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_edge_exit_active(ThickSliceQuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceQuadrupoleData_getp__parent_edge_exit_active(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get__parent_model(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_model(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp__parent_model(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get__parent_integrator(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_integrator(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp__parent_integrator(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get__parent_radiation_flag(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_radiation_flag(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp__parent_radiation_flag(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent_delta_taper(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent_delta_taper(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent_delta_taper(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent__sin_rot_s(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent__sin_rot_s(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent__sin_rot_s(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent__cos_rot_s(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent__cos_rot_s(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent__cos_rot_s(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent__shift_x(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent__shift_x(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent__shift_x(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent__shift_y(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent__shift_y(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent__shift_y(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get__parent__shift_s(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent__shift_s(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp__parent__shift_s(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceQuadrupoleData_getp__parent__internal_record_id(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get__parent__internal_record_id_buffer_id(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent__internal_record_id_buffer_id(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp__parent__internal_record_id_buffer_id(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get__parent__internal_record_id_offset(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set__parent__internal_record_id_offset(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp__parent__internal_record_id_offset(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceQuadrupoleData_get_radiation_flag(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set_radiation_flag(ThickSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceQuadrupoleData_getp_radiation_flag(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get_delta_taper(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set_delta_taper(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp_delta_taper(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceQuadrupoleData_get_weight(const ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceQuadrupoleData_set_weight(ThickSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceQuadrupoleData_getp_weight(ThickSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thick_slice_quadrupole.h>

             static inline
            void ThickSliceQuadrupole_track_local_particle_with_transformations(ThickSliceQuadrupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThickSliceQuadrupoleData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceQuadrupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceQuadrupoleData_get__parent__shift_x(el);
    double const shift_y = ThickSliceQuadrupoleData_get__parent__shift_y(el);
    double const shift_s = ThickSliceQuadrupoleData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThickSliceQuadrupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceQuadrupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceQuadrupoleData_get__parent__shift_x(el);
    double const shift_y = ThickSliceQuadrupoleData_get__parent__shift_y(el);
    double const shift_s = ThickSliceQuadrupoleData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThickSliceQuadrupole_track_particles(
               ThickSliceQuadrupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThickSliceQuadrupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceQuadrupoleData
#define XOBJ_TYPEDEF_ThinSliceQuadrupoleData
typedef   struct ThinSliceQuadrupoleData_s * ThinSliceQuadrupoleData;
 static inline ThinSliceQuadrupoleData ThinSliceQuadrupoleData_getp(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  return (ThinSliceQuadrupoleData)(( char*) obj+offset);
}
 static inline QuadrupoleData ThinSliceQuadrupoleData_getp__parent(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (QuadrupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent_k1(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_k1(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent_k1(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent_k1s(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_k1s(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent_k1s(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent_length(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_length(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent_length(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__parent_num_multipole_kicks(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_num_multipole_kicks(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__parent_num_multipole_kicks(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__parent_order(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_order(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__parent_order(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent_inv_factorial_order(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_inv_factorial_order(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent_inv_factorial_order(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceQuadrupoleData_getp__parent_knl(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_len__parent_knl(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceQuadrupoleData_get__parent_knl(const ThinSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_knl(ThinSliceQuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp1__parent_knl(ThinSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceQuadrupoleData_getp__parent_ksl(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_len__parent_ksl(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceQuadrupoleData_get__parent_ksl(const ThinSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_ksl(ThinSliceQuadrupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp1__parent_ksl(ThinSliceQuadrupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceQuadrupoleData_get__parent_edge_entry_active(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_edge_entry_active(ThinSliceQuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceQuadrupoleData_getp__parent_edge_entry_active(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceQuadrupoleData_get__parent_edge_exit_active(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_edge_exit_active(ThinSliceQuadrupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceQuadrupoleData_getp__parent_edge_exit_active(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__parent_model(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_model(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__parent_model(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__parent_integrator(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_integrator(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__parent_integrator(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__parent_radiation_flag(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_radiation_flag(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__parent_radiation_flag(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent_delta_taper(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent_delta_taper(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent_delta_taper(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent__sin_rot_s(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent__sin_rot_s(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent__sin_rot_s(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent__cos_rot_s(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent__cos_rot_s(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent__cos_rot_s(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent__shift_x(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent__shift_x(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent__shift_x(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent__shift_y(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent__shift_y(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent__shift_y(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get__parent__shift_s(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent__shift_s(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp__parent__shift_s(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceQuadrupoleData_getp__parent__internal_record_id(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__parent__internal_record_id_buffer_id(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent__internal_record_id_buffer_id(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__parent__internal_record_id_buffer_id(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__parent__internal_record_id_offset(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__parent__internal_record_id_offset(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__parent__internal_record_id_offset(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get_radiation_flag(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set_radiation_flag(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp_radiation_flag(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get_delta_taper(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set_delta_taper(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp_delta_taper(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleData_get_weight(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set_weight(ThinSliceQuadrupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleData_getp_weight(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceQuadrupoleData_getp__internal_record_id(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__internal_record_id_buffer_id(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__internal_record_id_buffer_id(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__internal_record_id_buffer_id(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleData_get__internal_record_id_offset(const ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleData_set__internal_record_id_offset(ThinSliceQuadrupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleData_getp__internal_record_id_offset(ThinSliceQuadrupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThinSliceQuadrupoleData_getp_internal_record(ThinSliceQuadrupoleData el, LocalParticle* part){
    RecordIdentifier record_id = ThinSliceQuadrupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //
#ifndef XTRACK_THIN_SLICE_QUADRUPOLE_H
#define XTRACK_THIN_SLICE_QUADRUPOLE_H

#include <headers/track.h>
#include <beam_elements/elements_src/track_magnet.h>


GPUFUN
void ThinSliceQuadrupole_track_local_particle(
        ThinSliceQuadrupoleData el,
        LocalParticle* part0
) {
    double weight = ThinSliceQuadrupoleData_get_weight(el);

    int64_t radiation_flag = 0;
    double delta_taper = 0.0;
    SynchrotronRadiationRecordData record = NULL;
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
        radiation_flag = ThinSliceQuadrupoleData_get_radiation_flag(el);
        if (radiation_flag == 10){ // from parent
            radiation_flag = ThinSliceQuadrupoleData_get__parent_radiation_flag(el);
        }
        delta_taper = ThinSliceQuadrupoleData_get_delta_taper(el);
        if (radiation_flag==2){
            record = (SynchrotronRadiationRecordData) ThinSliceQuadrupoleData_getp_internal_record(el, part0);
        }
    #endif

    track_magnet_particles(
        /*part0*/                 part0,
        /*length*/                ThinSliceQuadrupoleData_get__parent_length(el) * weight,
        /*order*/                 ThinSliceQuadrupoleData_get__parent_order(el),
        /*inv_factorial_order*/   ThinSliceQuadrupoleData_get__parent_inv_factorial_order(el),
        /*knl*/                   ThinSliceQuadrupoleData_getp1__parent_knl(el, 0),
        /*ksl*/                   ThinSliceQuadrupoleData_getp1__parent_ksl(el, 0),
        /*factor_knl_ksl*/        weight,
        /*num_multipole_kicks*/   1,
        /*model*/                 -1, // kick only
        /*integrator*/            3, // uniform
        /*radiation_flag*/        radiation_flag,
        /*radiation_record*/      record,
        /*delta_taper*/           delta_taper,
        /*h*/                     0.,
        /*hxl*/                   0.,
        /*k0*/                    0.,
        /*k1*/                    ThinSliceQuadrupoleData_get__parent_k1(el),
        /*k2*/                    0.,
        /*k3*/                    0.,
        /*k0s*/                   0.,
        /*k1s*/                   ThinSliceQuadrupoleData_get__parent_k1s(el),
        /*k2s*/                   0.,
        /*k3s*/                   0.,
        /*edge_entry_active*/     0,
        /*edge_exit_active*/      0,
        /*edge_entry_model*/      0,
        /*edge_exit_model*/       0,
        /*edge_entry_angle*/      0.,
        /*edge_exit_angle*/       0.,
        /*edge_entry_angle_fdown*/0.,
        /*edge_exit_angle_fdown*/ 0.,
        /*edge_entry_fint*/       0.,
        /*edge_exit_fint*/        0.,
        /*edge_entry_hgap*/       0.,
        /*edge_exit_hgap*/        0.
    );
}

#endif


             static inline
            void ThinSliceQuadrupole_track_local_particle_with_transformations(ThinSliceQuadrupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceQuadrupoleData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceQuadrupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceQuadrupoleData_get__parent__shift_x(el);
    double const shift_y = ThinSliceQuadrupoleData_get__parent__shift_y(el);
    double const shift_s = ThinSliceQuadrupoleData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceQuadrupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceQuadrupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceQuadrupoleData_get__parent__shift_x(el);
    double const shift_y = ThinSliceQuadrupoleData_get__parent__shift_y(el);
    double const shift_s = ThinSliceQuadrupoleData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceQuadrupole_track_particles(
               ThinSliceQuadrupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceQuadrupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceQuadrupoleEntryData
#define XOBJ_TYPEDEF_ThinSliceQuadrupoleEntryData
typedef   struct ThinSliceQuadrupoleEntryData_s * ThinSliceQuadrupoleEntryData;
 static inline ThinSliceQuadrupoleEntryData ThinSliceQuadrupoleEntryData_getp(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  return (ThinSliceQuadrupoleEntryData)(( char*) obj+offset);
}
 static inline QuadrupoleData ThinSliceQuadrupoleEntryData_getp__parent(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (QuadrupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent_k1(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_k1(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent_k1(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent_k1s(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_k1s(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent_k1s(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent_length(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_length(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent_length(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get__parent_num_multipole_kicks(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_num_multipole_kicks(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp__parent_num_multipole_kicks(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get__parent_order(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_order(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp__parent_order(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent_inv_factorial_order(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_inv_factorial_order(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent_inv_factorial_order(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceQuadrupoleEntryData_getp__parent_knl(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_len__parent_knl(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent_knl(const ThinSliceQuadrupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_knl(ThinSliceQuadrupoleEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp1__parent_knl(ThinSliceQuadrupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceQuadrupoleEntryData_getp__parent_ksl(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_len__parent_ksl(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent_ksl(const ThinSliceQuadrupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_ksl(ThinSliceQuadrupoleEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp1__parent_ksl(ThinSliceQuadrupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceQuadrupoleEntryData_get__parent_edge_entry_active(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_edge_entry_active(ThinSliceQuadrupoleEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceQuadrupoleEntryData_getp__parent_edge_entry_active(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceQuadrupoleEntryData_get__parent_edge_exit_active(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_edge_exit_active(ThinSliceQuadrupoleEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceQuadrupoleEntryData_getp__parent_edge_exit_active(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get__parent_model(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_model(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp__parent_model(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get__parent_integrator(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_integrator(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp__parent_integrator(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get__parent_radiation_flag(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_radiation_flag(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp__parent_radiation_flag(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent_delta_taper(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent_delta_taper(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent_delta_taper(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent__sin_rot_s(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent__sin_rot_s(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent__sin_rot_s(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent__cos_rot_s(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent__cos_rot_s(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent__cos_rot_s(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent__shift_x(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent__shift_x(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent__shift_x(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent__shift_y(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent__shift_y(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent__shift_y(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get__parent__shift_s(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent__shift_s(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp__parent__shift_s(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceQuadrupoleEntryData_getp__parent__internal_record_id(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get__parent__internal_record_id_buffer_id(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent__internal_record_id_buffer_id(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp__parent__internal_record_id_buffer_id(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get__parent__internal_record_id_offset(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set__parent__internal_record_id_offset(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp__parent__internal_record_id_offset(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleEntryData_get_radiation_flag(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set_radiation_flag(ThinSliceQuadrupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleEntryData_getp_radiation_flag(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get_delta_taper(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set_delta_taper(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp_delta_taper(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleEntryData_get_weight(const ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleEntryData_set_weight(ThinSliceQuadrupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleEntryData_getp_weight(ThinSliceQuadrupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_quadrupole_entry.h>

             static inline
            void ThinSliceQuadrupoleEntry_track_local_particle_with_transformations(ThinSliceQuadrupoleEntryData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceQuadrupoleEntryData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceQuadrupoleEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceQuadrupoleEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceQuadrupoleEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceQuadrupoleEntryData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceQuadrupoleEntry_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceQuadrupoleEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceQuadrupoleEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceQuadrupoleEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceQuadrupoleEntryData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceQuadrupoleEntry_track_particles(
               ThinSliceQuadrupoleEntryData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceQuadrupoleEntry_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceQuadrupoleExitData
#define XOBJ_TYPEDEF_ThinSliceQuadrupoleExitData
typedef   struct ThinSliceQuadrupoleExitData_s * ThinSliceQuadrupoleExitData;
 static inline ThinSliceQuadrupoleExitData ThinSliceQuadrupoleExitData_getp(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  return (ThinSliceQuadrupoleExitData)(( char*) obj+offset);
}
 static inline QuadrupoleData ThinSliceQuadrupoleExitData_getp__parent(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (QuadrupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent_k1(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_k1(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent_k1(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent_k1s(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_k1s(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent_k1s(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent_length(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_length(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent_length(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get__parent_num_multipole_kicks(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_num_multipole_kicks(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp__parent_num_multipole_kicks(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get__parent_order(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_order(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp__parent_order(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent_inv_factorial_order(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_inv_factorial_order(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent_inv_factorial_order(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceQuadrupoleExitData_getp__parent_knl(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_len__parent_knl(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceQuadrupoleExitData_get__parent_knl(const ThinSliceQuadrupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_knl(ThinSliceQuadrupoleExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp1__parent_knl(ThinSliceQuadrupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceQuadrupoleExitData_getp__parent_ksl(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_len__parent_ksl(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceQuadrupoleExitData_get__parent_ksl(const ThinSliceQuadrupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_ksl(ThinSliceQuadrupoleExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp1__parent_ksl(ThinSliceQuadrupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceQuadrupoleExitData_get__parent_edge_entry_active(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_edge_entry_active(ThinSliceQuadrupoleExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceQuadrupoleExitData_getp__parent_edge_entry_active(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceQuadrupoleExitData_get__parent_edge_exit_active(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_edge_exit_active(ThinSliceQuadrupoleExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceQuadrupoleExitData_getp__parent_edge_exit_active(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get__parent_model(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_model(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp__parent_model(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get__parent_integrator(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_integrator(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp__parent_integrator(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get__parent_radiation_flag(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_radiation_flag(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp__parent_radiation_flag(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent_delta_taper(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent_delta_taper(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent_delta_taper(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent__sin_rot_s(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent__sin_rot_s(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent__sin_rot_s(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent__cos_rot_s(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent__cos_rot_s(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent__cos_rot_s(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent__shift_x(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent__shift_x(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent__shift_x(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent__shift_y(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent__shift_y(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent__shift_y(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get__parent__shift_s(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent__shift_s(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp__parent__shift_s(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceQuadrupoleExitData_getp__parent__internal_record_id(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get__parent__internal_record_id_buffer_id(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent__internal_record_id_buffer_id(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp__parent__internal_record_id_buffer_id(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get__parent__internal_record_id_offset(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set__parent__internal_record_id_offset(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp__parent__internal_record_id_offset(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceQuadrupoleExitData_get_radiation_flag(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set_radiation_flag(ThinSliceQuadrupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceQuadrupoleExitData_getp_radiation_flag(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get_delta_taper(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set_delta_taper(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp_delta_taper(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceQuadrupoleExitData_get_weight(const ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceQuadrupoleExitData_set_weight(ThinSliceQuadrupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceQuadrupoleExitData_getp_weight(ThinSliceQuadrupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_quadrupole_exit.h>

             static inline
            void ThinSliceQuadrupoleExit_track_local_particle_with_transformations(ThinSliceQuadrupoleExitData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceQuadrupoleExitData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceQuadrupoleExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceQuadrupoleExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceQuadrupoleExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceQuadrupoleExitData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceQuadrupoleExit_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceQuadrupoleExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceQuadrupoleExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceQuadrupoleExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceQuadrupoleExitData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceQuadrupoleExit_track_particles(
               ThinSliceQuadrupoleExitData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceQuadrupoleExit_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceOctupoleEntryData
#define XOBJ_TYPEDEF_ThinSliceOctupoleEntryData
typedef   struct ThinSliceOctupoleEntryData_s * ThinSliceOctupoleEntryData;
 static inline ThinSliceOctupoleEntryData ThinSliceOctupoleEntryData_getp(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  return (ThinSliceOctupoleEntryData)(( char*) obj+offset);
}
 static inline OctupoleData ThinSliceOctupoleEntryData_getp__parent(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (OctupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent_k3(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_k3(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent_k3(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent_k3s(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_k3s(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent_k3s(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent_length(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_length(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent_length(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get__parent_order(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_order(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp__parent_order(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent_inv_factorial_order(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_inv_factorial_order(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent_inv_factorial_order(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceOctupoleEntryData_getp__parent_knl(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_len__parent_knl(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceOctupoleEntryData_get__parent_knl(const ThinSliceOctupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_knl(ThinSliceOctupoleEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp1__parent_knl(ThinSliceOctupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceOctupoleEntryData_getp__parent_ksl(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_len__parent_ksl(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceOctupoleEntryData_get__parent_ksl(const ThinSliceOctupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_ksl(ThinSliceOctupoleEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp1__parent_ksl(ThinSliceOctupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceOctupoleEntryData_get__parent_edge_entry_active(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_edge_entry_active(ThinSliceOctupoleEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceOctupoleEntryData_getp__parent_edge_entry_active(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceOctupoleEntryData_get__parent_edge_exit_active(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_edge_exit_active(ThinSliceOctupoleEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceOctupoleEntryData_getp__parent_edge_exit_active(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get__parent_num_multipole_kicks(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_num_multipole_kicks(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp__parent_num_multipole_kicks(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get__parent_model(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_model(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp__parent_model(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get__parent_integrator(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_integrator(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp__parent_integrator(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get__parent_radiation_flag(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_radiation_flag(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp__parent_radiation_flag(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent_delta_taper(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent_delta_taper(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent_delta_taper(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent__sin_rot_s(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent__sin_rot_s(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent__sin_rot_s(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent__cos_rot_s(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent__cos_rot_s(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent__cos_rot_s(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent__shift_x(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent__shift_x(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent__shift_x(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent__shift_y(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent__shift_y(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent__shift_y(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get__parent__shift_s(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent__shift_s(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp__parent__shift_s(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceOctupoleEntryData_getp__parent__internal_record_id(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get__parent__internal_record_id_buffer_id(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent__internal_record_id_buffer_id(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp__parent__internal_record_id_buffer_id(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get__parent__internal_record_id_offset(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set__parent__internal_record_id_offset(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp__parent__internal_record_id_offset(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleEntryData_get_radiation_flag(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set_radiation_flag(ThinSliceOctupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleEntryData_getp_radiation_flag(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get_delta_taper(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set_delta_taper(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp_delta_taper(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleEntryData_get_weight(const ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleEntryData_set_weight(ThinSliceOctupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleEntryData_getp_weight(ThinSliceOctupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_octupole_entry.h>

             static inline
            void ThinSliceOctupoleEntry_track_local_particle_with_transformations(ThinSliceOctupoleEntryData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceOctupoleEntryData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceOctupoleEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceOctupoleEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceOctupoleEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceOctupoleEntryData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceOctupoleEntry_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceOctupoleEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceOctupoleEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceOctupoleEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceOctupoleEntryData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceOctupoleEntry_track_particles(
               ThinSliceOctupoleEntryData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceOctupoleEntry_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceOctupoleExitData
#define XOBJ_TYPEDEF_ThinSliceOctupoleExitData
typedef   struct ThinSliceOctupoleExitData_s * ThinSliceOctupoleExitData;
 static inline ThinSliceOctupoleExitData ThinSliceOctupoleExitData_getp(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  return (ThinSliceOctupoleExitData)(( char*) obj+offset);
}
 static inline OctupoleData ThinSliceOctupoleExitData_getp__parent(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (OctupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent_k3(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_k3(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent_k3(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent_k3s(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_k3s(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent_k3s(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent_length(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_length(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent_length(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get__parent_order(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_order(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp__parent_order(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent_inv_factorial_order(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_inv_factorial_order(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent_inv_factorial_order(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceOctupoleExitData_getp__parent_knl(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_len__parent_knl(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceOctupoleExitData_get__parent_knl(const ThinSliceOctupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_knl(ThinSliceOctupoleExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp1__parent_knl(ThinSliceOctupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceOctupoleExitData_getp__parent_ksl(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_len__parent_ksl(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceOctupoleExitData_get__parent_ksl(const ThinSliceOctupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_ksl(ThinSliceOctupoleExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp1__parent_ksl(ThinSliceOctupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceOctupoleExitData_get__parent_edge_entry_active(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_edge_entry_active(ThinSliceOctupoleExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceOctupoleExitData_getp__parent_edge_entry_active(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceOctupoleExitData_get__parent_edge_exit_active(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_edge_exit_active(ThinSliceOctupoleExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceOctupoleExitData_getp__parent_edge_exit_active(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get__parent_num_multipole_kicks(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_num_multipole_kicks(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp__parent_num_multipole_kicks(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get__parent_model(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_model(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp__parent_model(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get__parent_integrator(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_integrator(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp__parent_integrator(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get__parent_radiation_flag(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_radiation_flag(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp__parent_radiation_flag(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent_delta_taper(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent_delta_taper(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent_delta_taper(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent__sin_rot_s(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent__sin_rot_s(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent__sin_rot_s(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent__cos_rot_s(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent__cos_rot_s(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent__cos_rot_s(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent__shift_x(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent__shift_x(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent__shift_x(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent__shift_y(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent__shift_y(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent__shift_y(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get__parent__shift_s(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent__shift_s(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp__parent__shift_s(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceOctupoleExitData_getp__parent__internal_record_id(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get__parent__internal_record_id_buffer_id(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent__internal_record_id_buffer_id(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp__parent__internal_record_id_buffer_id(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get__parent__internal_record_id_offset(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set__parent__internal_record_id_offset(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp__parent__internal_record_id_offset(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleExitData_get_radiation_flag(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set_radiation_flag(ThinSliceOctupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleExitData_getp_radiation_flag(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get_delta_taper(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set_delta_taper(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp_delta_taper(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleExitData_get_weight(const ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleExitData_set_weight(ThinSliceOctupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleExitData_getp_weight(ThinSliceOctupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_octupole_exit.h>

             static inline
            void ThinSliceOctupoleExit_track_local_particle_with_transformations(ThinSliceOctupoleExitData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceOctupoleExitData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceOctupoleExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceOctupoleExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceOctupoleExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceOctupoleExitData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceOctupoleExit_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceOctupoleExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceOctupoleExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceOctupoleExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceOctupoleExitData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceOctupoleExit_track_particles(
               ThinSliceOctupoleExitData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceOctupoleExit_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_DriftSliceOctupoleData
#define XOBJ_TYPEDEF_DriftSliceOctupoleData
typedef   struct DriftSliceOctupoleData_s * DriftSliceOctupoleData;
 static inline DriftSliceOctupoleData DriftSliceOctupoleData_getp(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  return (DriftSliceOctupoleData)(( char*) obj+offset);
}
 static inline OctupoleData DriftSliceOctupoleData_getp__parent(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (OctupoleData)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent_k3(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_k3(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent_k3(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent_k3s(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_k3s(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent_k3s(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent_length(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_length(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent_length(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get__parent_order(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_order(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp__parent_order(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent_inv_factorial_order(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_inv_factorial_order(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent_inv_factorial_order(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceOctupoleData_getp__parent_knl(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_len__parent_knl(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceOctupoleData_get__parent_knl(const DriftSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_knl(DriftSliceOctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp1__parent_knl(DriftSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceOctupoleData_getp__parent_ksl(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_len__parent_ksl(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceOctupoleData_get__parent_ksl(const DriftSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_ksl(DriftSliceOctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp1__parent_ksl(DriftSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceOctupoleData_get__parent_edge_entry_active(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_edge_entry_active(DriftSliceOctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceOctupoleData_getp__parent_edge_entry_active(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceOctupoleData_get__parent_edge_exit_active(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_edge_exit_active(DriftSliceOctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceOctupoleData_getp__parent_edge_exit_active(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get__parent_num_multipole_kicks(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_num_multipole_kicks(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp__parent_num_multipole_kicks(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get__parent_model(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_model(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp__parent_model(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get__parent_integrator(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_integrator(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp__parent_integrator(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get__parent_radiation_flag(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_radiation_flag(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp__parent_radiation_flag(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent_delta_taper(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent_delta_taper(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent_delta_taper(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent__sin_rot_s(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent__sin_rot_s(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent__sin_rot_s(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent__cos_rot_s(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent__cos_rot_s(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent__cos_rot_s(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent__shift_x(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent__shift_x(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent__shift_x(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent__shift_y(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent__shift_y(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent__shift_y(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get__parent__shift_s(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent__shift_s(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp__parent__shift_s(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier DriftSliceOctupoleData_getp__parent__internal_record_id(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get__parent__internal_record_id_buffer_id(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent__internal_record_id_buffer_id(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp__parent__internal_record_id_buffer_id(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get__parent__internal_record_id_offset(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set__parent__internal_record_id_offset(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp__parent__internal_record_id_offset(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceOctupoleData_get_radiation_flag(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set_radiation_flag(DriftSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceOctupoleData_getp_radiation_flag(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get_delta_taper(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set_delta_taper(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp_delta_taper(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceOctupoleData_get_weight(const DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceOctupoleData_set_weight(DriftSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceOctupoleData_getp_weight(DriftSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/drift_slice_octupole.h>

             static inline
            void DriftSliceOctupole_track_local_particle_with_transformations(DriftSliceOctupoleData el, LocalParticle* part0){
    DriftSliceOctupole_track_local_particle(el, part0);
}


             
            void DriftSliceOctupole_track_particles(
               DriftSliceOctupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              DriftSliceOctupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceOctupoleData
#define XOBJ_TYPEDEF_ThinSliceOctupoleData
typedef   struct ThinSliceOctupoleData_s * ThinSliceOctupoleData;
 static inline ThinSliceOctupoleData ThinSliceOctupoleData_getp(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  return (ThinSliceOctupoleData)(( char*) obj+offset);
}
 static inline OctupoleData ThinSliceOctupoleData_getp__parent(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (OctupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent_k3(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_k3(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent_k3(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent_k3s(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_k3s(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent_k3s(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent_length(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_length(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent_length(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__parent_order(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_order(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__parent_order(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent_inv_factorial_order(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_inv_factorial_order(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent_inv_factorial_order(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceOctupoleData_getp__parent_knl(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_len__parent_knl(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceOctupoleData_get__parent_knl(const ThinSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_knl(ThinSliceOctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp1__parent_knl(ThinSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceOctupoleData_getp__parent_ksl(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_len__parent_ksl(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceOctupoleData_get__parent_ksl(const ThinSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_ksl(ThinSliceOctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp1__parent_ksl(ThinSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceOctupoleData_get__parent_edge_entry_active(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_edge_entry_active(ThinSliceOctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceOctupoleData_getp__parent_edge_entry_active(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceOctupoleData_get__parent_edge_exit_active(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_edge_exit_active(ThinSliceOctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceOctupoleData_getp__parent_edge_exit_active(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__parent_num_multipole_kicks(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_num_multipole_kicks(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__parent_num_multipole_kicks(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__parent_model(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_model(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__parent_model(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__parent_integrator(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_integrator(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__parent_integrator(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__parent_radiation_flag(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_radiation_flag(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__parent_radiation_flag(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent_delta_taper(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent_delta_taper(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent_delta_taper(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent__sin_rot_s(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent__sin_rot_s(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent__sin_rot_s(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent__cos_rot_s(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent__cos_rot_s(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent__cos_rot_s(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent__shift_x(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent__shift_x(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent__shift_x(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent__shift_y(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent__shift_y(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent__shift_y(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get__parent__shift_s(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent__shift_s(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp__parent__shift_s(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceOctupoleData_getp__parent__internal_record_id(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__parent__internal_record_id_buffer_id(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent__internal_record_id_buffer_id(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__parent__internal_record_id_buffer_id(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__parent__internal_record_id_offset(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__parent__internal_record_id_offset(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__parent__internal_record_id_offset(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get_radiation_flag(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set_radiation_flag(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp_radiation_flag(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get_delta_taper(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set_delta_taper(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp_delta_taper(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceOctupoleData_get_weight(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set_weight(ThinSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceOctupoleData_getp_weight(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceOctupoleData_getp__internal_record_id(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__internal_record_id_buffer_id(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__internal_record_id_buffer_id(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__internal_record_id_buffer_id(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceOctupoleData_get__internal_record_id_offset(const ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceOctupoleData_set__internal_record_id_offset(ThinSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceOctupoleData_getp__internal_record_id_offset(ThinSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThinSliceOctupoleData_getp_internal_record(ThinSliceOctupoleData el, LocalParticle* part){
    RecordIdentifier record_id = ThinSliceOctupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/thin_slice_octupole.h>

             static inline
            void ThinSliceOctupole_track_local_particle_with_transformations(ThinSliceOctupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceOctupoleData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceOctupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceOctupoleData_get__parent__shift_x(el);
    double const shift_y = ThinSliceOctupoleData_get__parent__shift_y(el);
    double const shift_s = ThinSliceOctupoleData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceOctupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceOctupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceOctupoleData_get__parent__shift_x(el);
    double const shift_y = ThinSliceOctupoleData_get__parent__shift_y(el);
    double const shift_s = ThinSliceOctupoleData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceOctupole_track_particles(
               ThinSliceOctupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceOctupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThickSliceOctupoleData
#define XOBJ_TYPEDEF_ThickSliceOctupoleData
typedef   struct ThickSliceOctupoleData_s * ThickSliceOctupoleData;
 static inline ThickSliceOctupoleData ThickSliceOctupoleData_getp(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  return (ThickSliceOctupoleData)(( char*) obj+offset);
}
 static inline OctupoleData ThickSliceOctupoleData_getp__parent(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (OctupoleData)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent_k3(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_k3(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent_k3(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent_k3s(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_k3s(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent_k3s(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent_length(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_length(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent_length(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__parent_order(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_order(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__parent_order(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent_inv_factorial_order(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_inv_factorial_order(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent_inv_factorial_order(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceOctupoleData_getp__parent_knl(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_len__parent_knl(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceOctupoleData_get__parent_knl(const ThickSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_knl(ThickSliceOctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp1__parent_knl(ThickSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceOctupoleData_getp__parent_ksl(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_len__parent_ksl(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceOctupoleData_get__parent_ksl(const ThickSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_ksl(ThickSliceOctupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp1__parent_ksl(ThickSliceOctupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceOctupoleData_get__parent_edge_entry_active(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_edge_entry_active(ThickSliceOctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceOctupoleData_getp__parent_edge_entry_active(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceOctupoleData_get__parent_edge_exit_active(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_edge_exit_active(ThickSliceOctupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceOctupoleData_getp__parent_edge_exit_active(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__parent_num_multipole_kicks(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_num_multipole_kicks(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__parent_num_multipole_kicks(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__parent_model(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_model(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__parent_model(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__parent_integrator(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_integrator(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__parent_integrator(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__parent_radiation_flag(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_radiation_flag(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__parent_radiation_flag(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent_delta_taper(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent_delta_taper(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent_delta_taper(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent__sin_rot_s(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent__sin_rot_s(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent__sin_rot_s(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent__cos_rot_s(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent__cos_rot_s(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent__cos_rot_s(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent__shift_x(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent__shift_x(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent__shift_x(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent__shift_y(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent__shift_y(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent__shift_y(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get__parent__shift_s(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent__shift_s(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp__parent__shift_s(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceOctupoleData_getp__parent__internal_record_id(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__parent__internal_record_id_buffer_id(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent__internal_record_id_buffer_id(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__parent__internal_record_id_buffer_id(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__parent__internal_record_id_offset(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__parent__internal_record_id_offset(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__parent__internal_record_id_offset(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get_radiation_flag(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set_radiation_flag(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp_radiation_flag(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get_delta_taper(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set_delta_taper(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp_delta_taper(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceOctupoleData_get_weight(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set_weight(ThickSliceOctupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceOctupoleData_getp_weight(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceOctupoleData_getp__internal_record_id(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__internal_record_id_buffer_id(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__internal_record_id_buffer_id(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__internal_record_id_buffer_id(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceOctupoleData_get__internal_record_id_offset(const ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceOctupoleData_set__internal_record_id_offset(ThickSliceOctupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceOctupoleData_getp__internal_record_id_offset(ThickSliceOctupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThickSliceOctupoleData_getp_internal_record(ThickSliceOctupoleData el, LocalParticle* part){
    RecordIdentifier record_id = ThickSliceOctupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/thick_slice_octupole.h>

             static inline
            void ThickSliceOctupole_track_local_particle_with_transformations(ThickSliceOctupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThickSliceOctupoleData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceOctupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceOctupoleData_get__parent__shift_x(el);
    double const shift_y = ThickSliceOctupoleData_get__parent__shift_y(el);
    double const shift_s = ThickSliceOctupoleData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThickSliceOctupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceOctupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceOctupoleData_get__parent__shift_x(el);
    double const shift_y = ThickSliceOctupoleData_get__parent__shift_y(el);
    double const shift_s = ThickSliceOctupoleData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThickSliceOctupole_track_particles(
               ThickSliceOctupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThickSliceOctupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceSextupoleEntryData
#define XOBJ_TYPEDEF_ThinSliceSextupoleEntryData
typedef   struct ThinSliceSextupoleEntryData_s * ThinSliceSextupoleEntryData;
 static inline ThinSliceSextupoleEntryData ThinSliceSextupoleEntryData_getp(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  return (ThinSliceSextupoleEntryData)(( char*) obj+offset);
}
 static inline SextupoleData ThinSliceSextupoleEntryData_getp__parent(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (SextupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent_k2(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_k2(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent_k2(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent_k2s(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_k2s(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent_k2s(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent_length(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_length(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent_length(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get__parent_order(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_order(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp__parent_order(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent_inv_factorial_order(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_inv_factorial_order(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent_inv_factorial_order(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceSextupoleEntryData_getp__parent_knl(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_len__parent_knl(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceSextupoleEntryData_get__parent_knl(const ThinSliceSextupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_knl(ThinSliceSextupoleEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp1__parent_knl(ThinSliceSextupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceSextupoleEntryData_getp__parent_ksl(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_len__parent_ksl(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceSextupoleEntryData_get__parent_ksl(const ThinSliceSextupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_ksl(ThinSliceSextupoleEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp1__parent_ksl(ThinSliceSextupoleEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceSextupoleEntryData_get__parent_edge_entry_active(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_edge_entry_active(ThinSliceSextupoleEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceSextupoleEntryData_getp__parent_edge_entry_active(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceSextupoleEntryData_get__parent_edge_exit_active(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_edge_exit_active(ThinSliceSextupoleEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceSextupoleEntryData_getp__parent_edge_exit_active(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get__parent_num_multipole_kicks(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_num_multipole_kicks(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp__parent_num_multipole_kicks(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get__parent_model(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_model(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp__parent_model(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get__parent_integrator(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_integrator(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp__parent_integrator(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get__parent_radiation_flag(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_radiation_flag(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp__parent_radiation_flag(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent_delta_taper(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent_delta_taper(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent_delta_taper(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent__sin_rot_s(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent__sin_rot_s(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent__sin_rot_s(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent__cos_rot_s(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent__cos_rot_s(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent__cos_rot_s(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent__shift_x(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent__shift_x(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent__shift_x(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent__shift_y(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent__shift_y(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent__shift_y(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get__parent__shift_s(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent__shift_s(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp__parent__shift_s(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceSextupoleEntryData_getp__parent__internal_record_id(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get__parent__internal_record_id_buffer_id(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent__internal_record_id_buffer_id(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp__parent__internal_record_id_buffer_id(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get__parent__internal_record_id_offset(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set__parent__internal_record_id_offset(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp__parent__internal_record_id_offset(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleEntryData_get_radiation_flag(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set_radiation_flag(ThinSliceSextupoleEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleEntryData_getp_radiation_flag(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get_delta_taper(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set_delta_taper(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp_delta_taper(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleEntryData_get_weight(const ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleEntryData_set_weight(ThinSliceSextupoleEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleEntryData_getp_weight(ThinSliceSextupoleEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_sextupole_entry.h>

             static inline
            void ThinSliceSextupoleEntry_track_local_particle_with_transformations(ThinSliceSextupoleEntryData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceSextupoleEntryData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceSextupoleEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceSextupoleEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceSextupoleEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceSextupoleEntryData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceSextupoleEntry_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceSextupoleEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceSextupoleEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceSextupoleEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceSextupoleEntryData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceSextupoleEntry_track_particles(
               ThinSliceSextupoleEntryData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceSextupoleEntry_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceSextupoleExitData
#define XOBJ_TYPEDEF_ThinSliceSextupoleExitData
typedef   struct ThinSliceSextupoleExitData_s * ThinSliceSextupoleExitData;
 static inline ThinSliceSextupoleExitData ThinSliceSextupoleExitData_getp(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  return (ThinSliceSextupoleExitData)(( char*) obj+offset);
}
 static inline SextupoleData ThinSliceSextupoleExitData_getp__parent(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (SextupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent_k2(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_k2(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent_k2(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent_k2s(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_k2s(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent_k2s(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent_length(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_length(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent_length(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get__parent_order(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_order(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp__parent_order(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent_inv_factorial_order(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_inv_factorial_order(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent_inv_factorial_order(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceSextupoleExitData_getp__parent_knl(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_len__parent_knl(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceSextupoleExitData_get__parent_knl(const ThinSliceSextupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_knl(ThinSliceSextupoleExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp1__parent_knl(ThinSliceSextupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceSextupoleExitData_getp__parent_ksl(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_len__parent_ksl(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceSextupoleExitData_get__parent_ksl(const ThinSliceSextupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_ksl(ThinSliceSextupoleExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp1__parent_ksl(ThinSliceSextupoleExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceSextupoleExitData_get__parent_edge_entry_active(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_edge_entry_active(ThinSliceSextupoleExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceSextupoleExitData_getp__parent_edge_entry_active(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceSextupoleExitData_get__parent_edge_exit_active(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_edge_exit_active(ThinSliceSextupoleExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceSextupoleExitData_getp__parent_edge_exit_active(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get__parent_num_multipole_kicks(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_num_multipole_kicks(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp__parent_num_multipole_kicks(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get__parent_model(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_model(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp__parent_model(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get__parent_integrator(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_integrator(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp__parent_integrator(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get__parent_radiation_flag(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_radiation_flag(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp__parent_radiation_flag(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent_delta_taper(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent_delta_taper(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent_delta_taper(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent__sin_rot_s(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent__sin_rot_s(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent__sin_rot_s(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent__cos_rot_s(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent__cos_rot_s(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent__cos_rot_s(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent__shift_x(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent__shift_x(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent__shift_x(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent__shift_y(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent__shift_y(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent__shift_y(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get__parent__shift_s(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent__shift_s(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp__parent__shift_s(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceSextupoleExitData_getp__parent__internal_record_id(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get__parent__internal_record_id_buffer_id(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent__internal_record_id_buffer_id(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp__parent__internal_record_id_buffer_id(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get__parent__internal_record_id_offset(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set__parent__internal_record_id_offset(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp__parent__internal_record_id_offset(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleExitData_get_radiation_flag(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set_radiation_flag(ThinSliceSextupoleExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleExitData_getp_radiation_flag(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get_delta_taper(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set_delta_taper(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp_delta_taper(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleExitData_get_weight(const ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleExitData_set_weight(ThinSliceSextupoleExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleExitData_getp_weight(ThinSliceSextupoleExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_sextupole_exit.h>

             static inline
            void ThinSliceSextupoleExit_track_local_particle_with_transformations(ThinSliceSextupoleExitData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceSextupoleExitData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceSextupoleExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceSextupoleExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceSextupoleExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceSextupoleExitData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceSextupoleExit_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceSextupoleExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceSextupoleExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceSextupoleExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceSextupoleExitData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceSextupoleExit_track_particles(
               ThinSliceSextupoleExitData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceSextupoleExit_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_DriftSliceSextupoleData
#define XOBJ_TYPEDEF_DriftSliceSextupoleData
typedef   struct DriftSliceSextupoleData_s * DriftSliceSextupoleData;
 static inline DriftSliceSextupoleData DriftSliceSextupoleData_getp(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  return (DriftSliceSextupoleData)(( char*) obj+offset);
}
 static inline SextupoleData DriftSliceSextupoleData_getp__parent(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (SextupoleData)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent_k2(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_k2(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent_k2(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent_k2s(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_k2s(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent_k2s(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent_length(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_length(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent_length(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get__parent_order(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_order(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp__parent_order(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent_inv_factorial_order(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_inv_factorial_order(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent_inv_factorial_order(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceSextupoleData_getp__parent_knl(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_len__parent_knl(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceSextupoleData_get__parent_knl(const DriftSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_knl(DriftSliceSextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp1__parent_knl(DriftSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceSextupoleData_getp__parent_ksl(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_len__parent_ksl(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceSextupoleData_get__parent_ksl(const DriftSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_ksl(DriftSliceSextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp1__parent_ksl(DriftSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceSextupoleData_get__parent_edge_entry_active(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_edge_entry_active(DriftSliceSextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceSextupoleData_getp__parent_edge_entry_active(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceSextupoleData_get__parent_edge_exit_active(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_edge_exit_active(DriftSliceSextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceSextupoleData_getp__parent_edge_exit_active(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get__parent_num_multipole_kicks(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_num_multipole_kicks(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp__parent_num_multipole_kicks(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get__parent_model(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_model(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp__parent_model(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get__parent_integrator(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_integrator(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp__parent_integrator(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get__parent_radiation_flag(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_radiation_flag(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp__parent_radiation_flag(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent_delta_taper(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent_delta_taper(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent_delta_taper(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent__sin_rot_s(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent__sin_rot_s(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent__sin_rot_s(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent__cos_rot_s(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent__cos_rot_s(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent__cos_rot_s(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent__shift_x(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent__shift_x(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent__shift_x(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent__shift_y(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent__shift_y(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent__shift_y(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get__parent__shift_s(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent__shift_s(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp__parent__shift_s(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier DriftSliceSextupoleData_getp__parent__internal_record_id(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get__parent__internal_record_id_buffer_id(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent__internal_record_id_buffer_id(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp__parent__internal_record_id_buffer_id(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get__parent__internal_record_id_offset(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set__parent__internal_record_id_offset(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp__parent__internal_record_id_offset(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceSextupoleData_get_radiation_flag(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set_radiation_flag(DriftSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceSextupoleData_getp_radiation_flag(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get_delta_taper(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set_delta_taper(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp_delta_taper(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceSextupoleData_get_weight(const DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceSextupoleData_set_weight(DriftSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceSextupoleData_getp_weight(DriftSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/drift_slice_sextupole.h>

             static inline
            void DriftSliceSextupole_track_local_particle_with_transformations(DriftSliceSextupoleData el, LocalParticle* part0){
    DriftSliceSextupole_track_local_particle(el, part0);
}


             
            void DriftSliceSextupole_track_particles(
               DriftSliceSextupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              DriftSliceSextupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceSextupoleData
#define XOBJ_TYPEDEF_ThinSliceSextupoleData
typedef   struct ThinSliceSextupoleData_s * ThinSliceSextupoleData;
 static inline ThinSliceSextupoleData ThinSliceSextupoleData_getp(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  return (ThinSliceSextupoleData)(( char*) obj+offset);
}
 static inline SextupoleData ThinSliceSextupoleData_getp__parent(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (SextupoleData)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent_k2(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_k2(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent_k2(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent_k2s(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_k2s(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent_k2s(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent_length(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_length(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent_length(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__parent_order(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_order(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__parent_order(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent_inv_factorial_order(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_inv_factorial_order(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent_inv_factorial_order(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceSextupoleData_getp__parent_knl(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_len__parent_knl(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceSextupoleData_get__parent_knl(const ThinSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_knl(ThinSliceSextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp1__parent_knl(ThinSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceSextupoleData_getp__parent_ksl(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_len__parent_ksl(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceSextupoleData_get__parent_ksl(const ThinSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_ksl(ThinSliceSextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp1__parent_ksl(ThinSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceSextupoleData_get__parent_edge_entry_active(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_edge_entry_active(ThinSliceSextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceSextupoleData_getp__parent_edge_entry_active(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceSextupoleData_get__parent_edge_exit_active(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_edge_exit_active(ThinSliceSextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceSextupoleData_getp__parent_edge_exit_active(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__parent_num_multipole_kicks(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_num_multipole_kicks(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__parent_num_multipole_kicks(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__parent_model(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_model(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__parent_model(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__parent_integrator(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_integrator(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__parent_integrator(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__parent_radiation_flag(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_radiation_flag(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__parent_radiation_flag(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent_delta_taper(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent_delta_taper(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent_delta_taper(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent__sin_rot_s(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent__sin_rot_s(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent__sin_rot_s(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent__cos_rot_s(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent__cos_rot_s(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent__cos_rot_s(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent__shift_x(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent__shift_x(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent__shift_x(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent__shift_y(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent__shift_y(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent__shift_y(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get__parent__shift_s(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent__shift_s(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp__parent__shift_s(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceSextupoleData_getp__parent__internal_record_id(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__parent__internal_record_id_buffer_id(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent__internal_record_id_buffer_id(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__parent__internal_record_id_buffer_id(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__parent__internal_record_id_offset(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__parent__internal_record_id_offset(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__parent__internal_record_id_offset(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get_radiation_flag(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set_radiation_flag(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp_radiation_flag(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get_delta_taper(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set_delta_taper(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp_delta_taper(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceSextupoleData_get_weight(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set_weight(ThinSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceSextupoleData_getp_weight(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceSextupoleData_getp__internal_record_id(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__internal_record_id_buffer_id(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__internal_record_id_buffer_id(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__internal_record_id_buffer_id(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceSextupoleData_get__internal_record_id_offset(const ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceSextupoleData_set__internal_record_id_offset(ThinSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceSextupoleData_getp__internal_record_id_offset(ThinSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThinSliceSextupoleData_getp_internal_record(ThinSliceSextupoleData el, LocalParticle* part){
    RecordIdentifier record_id = ThinSliceSextupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/thin_slice_sextupole.h>

             static inline
            void ThinSliceSextupole_track_local_particle_with_transformations(ThinSliceSextupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceSextupoleData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceSextupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceSextupoleData_get__parent__shift_x(el);
    double const shift_y = ThinSliceSextupoleData_get__parent__shift_y(el);
    double const shift_s = ThinSliceSextupoleData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceSextupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceSextupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceSextupoleData_get__parent__shift_x(el);
    double const shift_y = ThinSliceSextupoleData_get__parent__shift_y(el);
    double const shift_s = ThinSliceSextupoleData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceSextupole_track_particles(
               ThinSliceSextupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceSextupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThickSliceSextupoleData
#define XOBJ_TYPEDEF_ThickSliceSextupoleData
typedef   struct ThickSliceSextupoleData_s * ThickSliceSextupoleData;
 static inline ThickSliceSextupoleData ThickSliceSextupoleData_getp(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  return (ThickSliceSextupoleData)(( char*) obj+offset);
}
 static inline SextupoleData ThickSliceSextupoleData_getp__parent(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (SextupoleData)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent_k2(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_k2(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent_k2(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent_k2s(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_k2s(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent_k2s(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent_length(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_length(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent_length(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__parent_order(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_order(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__parent_order(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent_inv_factorial_order(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_inv_factorial_order(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent_inv_factorial_order(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceSextupoleData_getp__parent_knl(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_len__parent_knl(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceSextupoleData_get__parent_knl(const ThickSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_knl(ThickSliceSextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp1__parent_knl(ThickSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceSextupoleData_getp__parent_ksl(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_len__parent_ksl(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceSextupoleData_get__parent_ksl(const ThickSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_ksl(ThickSliceSextupoleData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp1__parent_ksl(ThickSliceSextupoleData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceSextupoleData_get__parent_edge_entry_active(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_edge_entry_active(ThickSliceSextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceSextupoleData_getp__parent_edge_entry_active(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceSextupoleData_get__parent_edge_exit_active(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_edge_exit_active(ThickSliceSextupoleData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceSextupoleData_getp__parent_edge_exit_active(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__parent_num_multipole_kicks(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_num_multipole_kicks(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__parent_num_multipole_kicks(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__parent_model(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_model(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__parent_model(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__parent_integrator(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_integrator(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__parent_integrator(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__parent_radiation_flag(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_radiation_flag(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__parent_radiation_flag(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent_delta_taper(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent_delta_taper(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent_delta_taper(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent__sin_rot_s(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent__sin_rot_s(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent__sin_rot_s(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent__cos_rot_s(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent__cos_rot_s(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent__cos_rot_s(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent__shift_x(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent__shift_x(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent__shift_x(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent__shift_y(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent__shift_y(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent__shift_y(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get__parent__shift_s(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent__shift_s(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp__parent__shift_s(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceSextupoleData_getp__parent__internal_record_id(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__parent__internal_record_id_buffer_id(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent__internal_record_id_buffer_id(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__parent__internal_record_id_buffer_id(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__parent__internal_record_id_offset(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__parent__internal_record_id_offset(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__parent__internal_record_id_offset(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get_radiation_flag(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set_radiation_flag(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp_radiation_flag(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get_delta_taper(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set_delta_taper(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp_delta_taper(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSextupoleData_get_weight(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set_weight(ThickSliceSextupoleData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSextupoleData_getp_weight(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceSextupoleData_getp__internal_record_id(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__internal_record_id_buffer_id(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__internal_record_id_buffer_id(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__internal_record_id_buffer_id(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSextupoleData_get__internal_record_id_offset(const ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSextupoleData_set__internal_record_id_offset(ThickSliceSextupoleData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSextupoleData_getp__internal_record_id_offset(ThickSliceSextupoleData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThickSliceSextupoleData_getp_internal_record(ThickSliceSextupoleData el, LocalParticle* part){
    RecordIdentifier record_id = ThickSliceSextupoleData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/thick_slice_sextupole.h>

             static inline
            void ThickSliceSextupole_track_local_particle_with_transformations(ThickSliceSextupoleData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThickSliceSextupoleData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceSextupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceSextupoleData_get__parent__shift_x(el);
    double const shift_y = ThickSliceSextupoleData_get__parent__shift_y(el);
    double const shift_s = ThickSliceSextupoleData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThickSliceSextupole_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceSextupoleData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceSextupoleData_get__parent__shift_x(el);
    double const shift_y = ThickSliceSextupoleData_get__parent__shift_y(el);
    double const shift_s = ThickSliceSextupoleData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThickSliceSextupole_track_particles(
               ThickSliceSextupoleData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThickSliceSextupole_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThickSliceSolenoidData
#define XOBJ_TYPEDEF_ThickSliceSolenoidData
typedef   struct ThickSliceSolenoidData_s * ThickSliceSolenoidData;
 static inline ThickSliceSolenoidData ThickSliceSolenoidData_getp(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  return (ThickSliceSolenoidData)(( char*) obj+offset);
}
 static inline SolenoidData ThickSliceSolenoidData_getp__parent(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (SolenoidData)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_length(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_length(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_length(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_ks(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_ks(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_ks(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_ksi(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_ksi(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_ksi(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get__parent_radiation_flag(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_radiation_flag(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp__parent_radiation_flag(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get__parent_num_multipole_kicks(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_num_multipole_kicks(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp__parent_num_multipole_kicks(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get__parent_order(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_order(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp__parent_order(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_inv_factorial_order(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_inv_factorial_order(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_inv_factorial_order(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceSolenoidData_getp__parent_knl(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_len__parent_knl(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceSolenoidData_get__parent_knl(const ThickSliceSolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_knl(ThickSliceSolenoidData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp1__parent_knl(ThickSliceSolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceSolenoidData_getp__parent_ksl(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_len__parent_ksl(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceSolenoidData_get__parent_ksl(const ThickSliceSolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_ksl(ThickSliceSolenoidData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp1__parent_ksl(ThickSliceSolenoidData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+160);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_mult_rot_x_rad(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_mult_rot_x_rad(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_mult_rot_x_rad(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_mult_rot_y_rad(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_mult_rot_y_rad(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_mult_rot_y_rad(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_mult_shift_x(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_mult_shift_x(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_mult_shift_x(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_mult_shift_y(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_mult_shift_y(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_mult_shift_y(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent_mult_shift_s(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent_mult_shift_s(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent_mult_shift_s(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent__sin_rot_s(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent__sin_rot_s(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent__sin_rot_s(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent__cos_rot_s(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent__cos_rot_s(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent__cos_rot_s(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent__shift_x(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent__shift_x(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent__shift_x(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent__shift_y(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent__shift_y(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent__shift_y(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get__parent__shift_s(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent__shift_s(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp__parent__shift_s(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceSolenoidData_getp__parent__internal_record_id(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get__parent__internal_record_id_buffer_id(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent__internal_record_id_buffer_id(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp__parent__internal_record_id_buffer_id(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get__parent__internal_record_id_offset(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__parent__internal_record_id_offset(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp__parent__internal_record_id_offset(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get_radiation_flag(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set_radiation_flag(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp_radiation_flag(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get_delta_taper(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set_delta_taper(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp_delta_taper(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceSolenoidData_get_weight(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set_weight(ThickSliceSolenoidData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceSolenoidData_getp_weight(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceSolenoidData_getp__internal_record_id(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get__internal_record_id_buffer_id(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__internal_record_id_buffer_id(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp__internal_record_id_buffer_id(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceSolenoidData_get__internal_record_id_offset(const ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceSolenoidData_set__internal_record_id_offset(ThickSliceSolenoidData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceSolenoidData_getp__internal_record_id_offset(ThickSliceSolenoidData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThickSliceSolenoidData_getp_internal_record(ThickSliceSolenoidData el, LocalParticle* part){
    RecordIdentifier record_id = ThickSliceSolenoidData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/thick_slice_solenoid.h>

             static inline
            void ThickSliceSolenoid_track_local_particle_with_transformations(ThickSliceSolenoidData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThickSliceSolenoidData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceSolenoidData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceSolenoidData_get__parent__shift_x(el);
    double const shift_y = ThickSliceSolenoidData_get__parent__shift_y(el);
    double const shift_s = ThickSliceSolenoidData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThickSliceSolenoid_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceSolenoidData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceSolenoidData_get__parent__shift_x(el);
    double const shift_y = ThickSliceSolenoidData_get__parent__shift_y(el);
    double const shift_s = ThickSliceSolenoidData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThickSliceSolenoid_track_particles(
               ThickSliceSolenoidData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThickSliceSolenoid_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThickSliceBendData
#define XOBJ_TYPEDEF_ThickSliceBendData
typedef   struct ThickSliceBendData_s * ThickSliceBendData;
 static inline ThickSliceBendData ThickSliceBendData_getp(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  return (ThickSliceBendData)(( char*) obj+offset);
}
 static inline BendData ThickSliceBendData_getp__parent(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (BendData)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_k0(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_k0(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_k0(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_k1(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_k1(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_k1(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_h(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_h(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_h(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_angle(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_angle(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_angle(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_length(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_length(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_length(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_model(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_model(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_model(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_integrator(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_integrator(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_integrator(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_radiation_flag(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_radiation_flag(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_radiation_flag(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_delta_taper(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_delta_taper(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_delta_taper(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_edge_entry_active(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_entry_active(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_edge_entry_active(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_edge_exit_active(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_exit_active(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_edge_exit_active(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_edge_entry_model(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_entry_model(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_edge_entry_model(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_edge_exit_model(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_exit_model(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_edge_exit_model(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_entry_angle(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_entry_angle(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_entry_angle(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_exit_angle(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_exit_angle(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_exit_angle(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_entry_angle_fdown(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_entry_angle_fdown(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_entry_angle_fdown(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_exit_angle_fdown(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_exit_angle_fdown(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_exit_angle_fdown(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_entry_fint(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_entry_fint(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_entry_fint(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_exit_fint(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_exit_fint(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_exit_fint(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_entry_hgap(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_entry_hgap(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_entry_hgap(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_edge_exit_hgap(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_edge_exit_hgap(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_edge_exit_hgap(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_num_multipole_kicks(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_num_multipole_kicks(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_num_multipole_kicks(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent_order(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_order(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent_order(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent_inv_factorial_order(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_inv_factorial_order(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent_inv_factorial_order(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceBendData_getp__parent_knl(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_len__parent_knl(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceBendData_get__parent_knl(const ThickSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_knl(ThickSliceBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp1__parent_knl(ThickSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThickSliceBendData_getp__parent_ksl(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_len__parent_ksl(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThickSliceBendData_get__parent_ksl(const ThickSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_ksl(ThickSliceBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp1__parent_ksl(ThickSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThickSliceBendData_get__parent_k0_from_h(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent_k0_from_h(ThickSliceBendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThickSliceBendData_getp__parent_k0_from_h(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent__sin_rot_s(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent__sin_rot_s(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent__sin_rot_s(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent__cos_rot_s(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent__cos_rot_s(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent__cos_rot_s(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent__shift_x(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent__shift_x(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent__shift_x(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent__shift_y(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent__shift_y(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent__shift_y(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get__parent__shift_s(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent__shift_s(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp__parent__shift_s(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThickSliceBendData_getp__parent__internal_record_id(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent__internal_record_id_buffer_id(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent__internal_record_id_buffer_id(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent__internal_record_id_buffer_id(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get__parent__internal_record_id_offset(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set__parent__internal_record_id_offset(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp__parent__internal_record_id_offset(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThickSliceBendData_get_radiation_flag(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set_radiation_flag(ThickSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThickSliceBendData_getp_radiation_flag(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get_delta_taper(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set_delta_taper(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp_delta_taper(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThickSliceBendData_get_weight(const ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThickSliceBendData_set_weight(ThickSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThickSliceBendData_getp_weight(ThickSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thick_slice_bend.h>

             static inline
            void ThickSliceBend_track_local_particle_with_transformations(ThickSliceBendData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThickSliceBendData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceBendData_get__parent__shift_x(el);
    double const shift_y = ThickSliceBendData_get__parent__shift_y(el);
    double const shift_s = ThickSliceBendData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThickSliceBend_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThickSliceBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThickSliceBendData_get__parent__shift_x(el);
    double const shift_y = ThickSliceBendData_get__parent__shift_y(el);
    double const shift_s = ThickSliceBendData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThickSliceBend_track_particles(
               ThickSliceBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThickSliceBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceBendData
#define XOBJ_TYPEDEF_ThinSliceBendData
typedef   struct ThinSliceBendData_s * ThinSliceBendData;
 static inline ThinSliceBendData ThinSliceBendData_getp(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  return (ThinSliceBendData)(( char*) obj+offset);
}
 static inline BendData ThinSliceBendData_getp__parent(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (BendData)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_k0(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_k0(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_k0(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_k1(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_k1(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_k1(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_h(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_h(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_h(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_angle(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_angle(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_angle(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_length(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_length(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_length(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_model(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_model(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_model(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_integrator(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_integrator(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_integrator(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_radiation_flag(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_radiation_flag(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_radiation_flag(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_delta_taper(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_delta_taper(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_delta_taper(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_edge_entry_active(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_entry_active(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_edge_entry_active(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_edge_exit_active(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_exit_active(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_edge_exit_active(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_edge_entry_model(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_entry_model(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_edge_entry_model(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_edge_exit_model(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_exit_model(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_edge_exit_model(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_entry_angle(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_entry_angle(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_entry_angle(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_exit_angle(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_exit_angle(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_exit_angle(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_entry_angle_fdown(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_entry_angle_fdown(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_entry_angle_fdown(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_exit_angle_fdown(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_exit_angle_fdown(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_exit_angle_fdown(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_entry_fint(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_entry_fint(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_entry_fint(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_exit_fint(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_exit_fint(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_exit_fint(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_entry_hgap(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_entry_hgap(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_entry_hgap(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_edge_exit_hgap(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_edge_exit_hgap(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_edge_exit_hgap(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_num_multipole_kicks(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_num_multipole_kicks(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_num_multipole_kicks(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent_order(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_order(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent_order(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent_inv_factorial_order(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_inv_factorial_order(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent_inv_factorial_order(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceBendData_getp__parent_knl(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_len__parent_knl(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceBendData_get__parent_knl(const ThinSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_knl(ThinSliceBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp1__parent_knl(ThinSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceBendData_getp__parent_ksl(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_len__parent_ksl(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceBendData_get__parent_ksl(const ThinSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_ksl(ThinSliceBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp1__parent_ksl(ThinSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceBendData_get__parent_k0_from_h(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent_k0_from_h(ThinSliceBendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceBendData_getp__parent_k0_from_h(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent__sin_rot_s(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent__sin_rot_s(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent__sin_rot_s(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent__cos_rot_s(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent__cos_rot_s(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent__cos_rot_s(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent__shift_x(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent__shift_x(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent__shift_x(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent__shift_y(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent__shift_y(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent__shift_y(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get__parent__shift_s(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent__shift_s(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp__parent__shift_s(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceBendData_getp__parent__internal_record_id(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent__internal_record_id_buffer_id(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent__internal_record_id_buffer_id(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent__internal_record_id_buffer_id(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__parent__internal_record_id_offset(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__parent__internal_record_id_offset(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__parent__internal_record_id_offset(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get_radiation_flag(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set_radiation_flag(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp_radiation_flag(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get_delta_taper(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set_delta_taper(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp_delta_taper(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendData_get_weight(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set_weight(ThinSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendData_getp_weight(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceBendData_getp__internal_record_id(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__internal_record_id_buffer_id(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__internal_record_id_buffer_id(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=32;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__internal_record_id_buffer_id(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=32;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendData_get__internal_record_id_offset(const ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendData_set__internal_record_id_offset(ThinSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=40;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendData_getp__internal_record_id_offset(ThinSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=40;
  return ( int64_t*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */


 static inline
SynchrotronRadiationRecordData ThinSliceBendData_getp_internal_record(ThinSliceBendData el, LocalParticle* part){
    RecordIdentifier record_id = ThinSliceBendData_getp__internal_record_id(el);
    if (RecordIdentifier_get_buffer_id(record_id) <= 0){
        return NULL;
    }
    else{
        return (SynchrotronRadiationRecordData) RecordIdentifier_getp_record(record_id, part);
    }
    }
    
#include <beam_elements/elements_src/thin_slice_bend.h>

             static inline
            void ThinSliceBend_track_local_particle_with_transformations(ThinSliceBendData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceBendData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceBendData_get__parent__shift_x(el);
    double const shift_y = ThinSliceBendData_get__parent__shift_y(el);
    double const shift_s = ThinSliceBendData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceBend_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceBendData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceBendData_get__parent__shift_x(el);
    double const shift_y = ThinSliceBendData_get__parent__shift_y(el);
    double const shift_s = ThinSliceBendData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceBend_track_particles(
               ThinSliceBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceBendEntryData
#define XOBJ_TYPEDEF_ThinSliceBendEntryData
typedef   struct ThinSliceBendEntryData_s * ThinSliceBendEntryData;
 static inline ThinSliceBendEntryData ThinSliceBendEntryData_getp(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  return (ThinSliceBendEntryData)(( char*) obj+offset);
}
 static inline BendData ThinSliceBendEntryData_getp__parent(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (BendData)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_k0(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_k0(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_k0(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_k1(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_k1(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_k1(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_h(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_h(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_h(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_angle(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_angle(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_angle(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_length(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_length(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_length(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_model(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_model(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_model(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_integrator(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_integrator(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_integrator(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_radiation_flag(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_radiation_flag(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_radiation_flag(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_delta_taper(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_delta_taper(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_delta_taper(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_edge_entry_active(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_entry_active(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_edge_entry_active(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_edge_exit_active(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_exit_active(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_edge_exit_active(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_edge_entry_model(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_entry_model(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_edge_entry_model(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_edge_exit_model(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_exit_model(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_edge_exit_model(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_entry_angle(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_entry_angle(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_entry_angle(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_exit_angle(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_exit_angle(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_exit_angle(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_entry_angle_fdown(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_entry_angle_fdown(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_entry_angle_fdown(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_exit_angle_fdown(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_exit_angle_fdown(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_exit_angle_fdown(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_entry_fint(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_entry_fint(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_entry_fint(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_exit_fint(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_exit_fint(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_exit_fint(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_entry_hgap(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_entry_hgap(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_entry_hgap(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_edge_exit_hgap(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_edge_exit_hgap(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_edge_exit_hgap(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_num_multipole_kicks(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_num_multipole_kicks(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_num_multipole_kicks(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent_order(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_order(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent_order(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent_inv_factorial_order(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_inv_factorial_order(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent_inv_factorial_order(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceBendEntryData_getp__parent_knl(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_len__parent_knl(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceBendEntryData_get__parent_knl(const ThinSliceBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_knl(ThinSliceBendEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp1__parent_knl(ThinSliceBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceBendEntryData_getp__parent_ksl(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_len__parent_ksl(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceBendEntryData_get__parent_ksl(const ThinSliceBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_ksl(ThinSliceBendEntryData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp1__parent_ksl(ThinSliceBendEntryData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceBendEntryData_get__parent_k0_from_h(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent_k0_from_h(ThinSliceBendEntryData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceBendEntryData_getp__parent_k0_from_h(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent__sin_rot_s(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent__sin_rot_s(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent__sin_rot_s(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent__cos_rot_s(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent__cos_rot_s(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent__cos_rot_s(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent__shift_x(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent__shift_x(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent__shift_x(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent__shift_y(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent__shift_y(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent__shift_y(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get__parent__shift_s(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent__shift_s(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp__parent__shift_s(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceBendEntryData_getp__parent__internal_record_id(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent__internal_record_id_buffer_id(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent__internal_record_id_buffer_id(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent__internal_record_id_buffer_id(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get__parent__internal_record_id_offset(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set__parent__internal_record_id_offset(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp__parent__internal_record_id_offset(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendEntryData_get_radiation_flag(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set_radiation_flag(ThinSliceBendEntryData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendEntryData_getp_radiation_flag(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get_delta_taper(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set_delta_taper(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp_delta_taper(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendEntryData_get_weight(const ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendEntryData_set_weight(ThinSliceBendEntryData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendEntryData_getp_weight(ThinSliceBendEntryData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_DIPOLEEDGE_NONLINEAR_H
#define XTRACK_TRACK_DIPOLEEDGE_NONLINEAR_H

#include <headers/track.h>


GPUFUN
void DipoleEdgeNonLinear_single_particle(LocalParticle* part,
            double const k, double const e1, double const fint, double const hgap,
            int64_t const side
){

    double sin_, cos_, tan_;
    if (fabs(e1) < 10e-10) {
        sin_ = -999.0; cos_ = -999.0; tan_ = -999.0;
    }
    else{
        sin_ = sin(e1); cos_ = cos(e1); tan_ = tan(e1);
    }

    if (side == 0){ // entry
        if (sin_ > -99.){
            YRotation_single_particle(part, sin_, cos_, tan_);
        }
        DipoleFringe_single_particle(part, fint, hgap, k);
        if (sin_ > -99.){
            Wedge_single_particle(part, -e1, k);
        }
    }
    else if (side == 1){ // exit
        if (sin_ > -99.){
            Wedge_single_particle(part, -e1, k);
        }
        DipoleFringe_single_particle(part, fint, hgap, -k);
        if (sin_ > -99.){
            YRotation_single_particle(part, sin_, cos_, tan_);
        }

    }
}

#endif
#include <beam_elements/elements_src/thin_slice_bend_entry.h>

             static inline
            void ThinSliceBendEntry_track_local_particle_with_transformations(ThinSliceBendEntryData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceBendEntryData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceBendEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceBendEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceBendEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceBendEntryData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceBendEntry_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceBendEntryData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceBendEntryData_get__parent__shift_x(el);
    double const shift_y = ThinSliceBendEntryData_get__parent__shift_y(el);
    double const shift_s = ThinSliceBendEntryData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceBendEntry_track_particles(
               ThinSliceBendEntryData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceBendEntry_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_DriftSliceBendData
#define XOBJ_TYPEDEF_DriftSliceBendData
typedef   struct DriftSliceBendData_s * DriftSliceBendData;
 static inline DriftSliceBendData DriftSliceBendData_getp(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  return (DriftSliceBendData)(( char*) obj+offset);
}
 static inline BendData DriftSliceBendData_getp__parent(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (BendData)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_k0(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_k0(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_k0(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_k1(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_k1(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_k1(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_h(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_h(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_h(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_angle(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_angle(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_angle(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_length(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_length(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_length(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_model(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_model(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_model(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_integrator(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_integrator(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_integrator(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_radiation_flag(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_radiation_flag(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_radiation_flag(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_delta_taper(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_delta_taper(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_delta_taper(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_edge_entry_active(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_entry_active(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_edge_entry_active(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_edge_exit_active(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_exit_active(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_edge_exit_active(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_edge_entry_model(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_entry_model(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_edge_entry_model(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_edge_exit_model(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_exit_model(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_edge_exit_model(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_entry_angle(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_entry_angle(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_entry_angle(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_exit_angle(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_exit_angle(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_exit_angle(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_entry_angle_fdown(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_entry_angle_fdown(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_entry_angle_fdown(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_exit_angle_fdown(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_exit_angle_fdown(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_exit_angle_fdown(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_entry_fint(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_entry_fint(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_entry_fint(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_exit_fint(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_exit_fint(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_exit_fint(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_entry_hgap(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_entry_hgap(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_entry_hgap(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_edge_exit_hgap(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_edge_exit_hgap(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_edge_exit_hgap(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_num_multipole_kicks(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_num_multipole_kicks(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_num_multipole_kicks(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent_order(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_order(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent_order(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent_inv_factorial_order(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_inv_factorial_order(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent_inv_factorial_order(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceBendData_getp__parent_knl(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_len__parent_knl(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceBendData_get__parent_knl(const DriftSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_knl(DriftSliceBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp1__parent_knl(DriftSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 DriftSliceBendData_getp__parent_ksl(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_len__parent_ksl(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double DriftSliceBendData_get__parent_ksl(const DriftSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_ksl(DriftSliceBendData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp1__parent_ksl(DriftSliceBendData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t DriftSliceBendData_get__parent_k0_from_h(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent_k0_from_h(DriftSliceBendData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* DriftSliceBendData_getp__parent_k0_from_h(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent__sin_rot_s(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent__sin_rot_s(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent__sin_rot_s(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent__cos_rot_s(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent__cos_rot_s(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent__cos_rot_s(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent__shift_x(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent__shift_x(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent__shift_x(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent__shift_y(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent__shift_y(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent__shift_y(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get__parent__shift_s(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent__shift_s(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp__parent__shift_s(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier DriftSliceBendData_getp__parent__internal_record_id(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent__internal_record_id_buffer_id(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent__internal_record_id_buffer_id(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent__internal_record_id_buffer_id(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get__parent__internal_record_id_offset(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set__parent__internal_record_id_offset(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp__parent__internal_record_id_offset(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t DriftSliceBendData_get_radiation_flag(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set_radiation_flag(DriftSliceBendData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* DriftSliceBendData_getp_radiation_flag(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get_delta_taper(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set_delta_taper(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp_delta_taper(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double DriftSliceBendData_get_weight(const DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void DriftSliceBendData_set_weight(DriftSliceBendData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* DriftSliceBendData_getp_weight(DriftSliceBendData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/drift_slice_bend.h>

             static inline
            void DriftSliceBend_track_local_particle_with_transformations(DriftSliceBendData el, LocalParticle* part0){
    DriftSliceBend_track_local_particle(el, part0);
}


             
            void DriftSliceBend_track_particles(
               DriftSliceBendData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              DriftSliceBend_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ThinSliceBendExitData
#define XOBJ_TYPEDEF_ThinSliceBendExitData
typedef   struct ThinSliceBendExitData_s * ThinSliceBendExitData;
 static inline ThinSliceBendExitData ThinSliceBendExitData_getp(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  return (ThinSliceBendExitData)(( char*) obj+offset);
}
 static inline BendData ThinSliceBendExitData_getp__parent(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  return (BendData)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_k0(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_k0(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_k0(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=8;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_k1(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_k1(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_k1(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_h(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_h(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_h(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_angle(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_angle(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_angle(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=32;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_length(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_length(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_length(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=40;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_model(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_model(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_model(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=48;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_integrator(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_integrator(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_integrator(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=56;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_radiation_flag(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_radiation_flag(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_radiation_flag(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=64;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_delta_taper(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_delta_taper(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_delta_taper(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=72;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_edge_entry_active(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_entry_active(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_edge_entry_active(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=80;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_edge_exit_active(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_exit_active(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_edge_exit_active(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=88;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_edge_entry_model(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_entry_model(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_edge_entry_model(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=96;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_edge_exit_model(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_exit_model(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_edge_exit_model(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=104;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_entry_angle(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_entry_angle(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_entry_angle(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=112;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_exit_angle(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_exit_angle(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_exit_angle(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=120;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_entry_angle_fdown(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_entry_angle_fdown(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_entry_angle_fdown(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=128;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_exit_angle_fdown(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_exit_angle_fdown(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_exit_angle_fdown(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=136;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_entry_fint(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_entry_fint(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_entry_fint(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=144;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_exit_fint(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_exit_fint(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_exit_fint(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=152;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_entry_hgap(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_entry_hgap(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_entry_hgap(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=160;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_edge_exit_hgap(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_edge_exit_hgap(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_edge_exit_hgap(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=168;
  return ( double*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_num_multipole_kicks(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_num_multipole_kicks(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_num_multipole_kicks(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=176;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent_order(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_order(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent_order(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=184;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent_inv_factorial_order(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_inv_factorial_order(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent_inv_factorial_order(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=192;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceBendExitData_getp__parent_knl(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_len__parent_knl(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceBendExitData_get__parent_knl(const ThinSliceBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_knl(ThinSliceBendExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp1__parent_knl(ThinSliceBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=272;
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline ArrNFloat64 ThinSliceBendExitData_getp__parent_ksl(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  return (ArrNFloat64)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_len__parent_ksl(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline double ThinSliceBendExitData_get__parent_ksl(const ThinSliceBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_ksl(ThinSliceBendExitData restrict  obj, int64_t i0, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp1__parent_ksl(ThinSliceBendExitData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=*( int64_t*)(( char*) obj+offset+264);
  offset+=16+i0*8;
  return ( double*)(( char*) obj+offset);
}
 static inline uint64_t ThinSliceBendExitData_get__parent_k0_from_h(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return *( uint64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent_k0_from_h(ThinSliceBendExitData restrict  obj, uint64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  *( uint64_t*)(( char*) obj+offset)=value;
}
 static inline  uint64_t* ThinSliceBendExitData_getp__parent_k0_from_h(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=200;
  return ( uint64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent__sin_rot_s(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent__sin_rot_s(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent__sin_rot_s(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=208;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent__cos_rot_s(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent__cos_rot_s(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent__cos_rot_s(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=216;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent__shift_x(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent__shift_x(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent__shift_x(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=224;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent__shift_y(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent__shift_y(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent__shift_y(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=232;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get__parent__shift_s(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent__shift_s(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp__parent__shift_s(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=240;
  return ( double*)(( char*) obj+offset);
}
 static inline RecordIdentifier ThinSliceBendExitData_getp__parent__internal_record_id(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return (RecordIdentifier)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent__internal_record_id_buffer_id(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent__internal_record_id_buffer_id(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent__internal_record_id_buffer_id(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=248;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get__parent__internal_record_id_offset(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set__parent__internal_record_id_offset(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp__parent__internal_record_id_offset(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
  offset+=256;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline int64_t ThinSliceBendExitData_get_radiation_flag(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set_radiation_flag(ThinSliceBendExitData restrict  obj, int64_t value){
  int64_t offset=0;
  offset+=8;
  *( int64_t*)(( char*) obj+offset)=value;
}
 static inline  int64_t* ThinSliceBendExitData_getp_radiation_flag(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=8;
  return ( int64_t*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get_delta_taper(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set_delta_taper(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=16;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp_delta_taper(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return ( double*)(( char*) obj+offset);
}
 static inline double ThinSliceBendExitData_get_weight(const ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return *( double*)(( char*) obj+offset);
}
 static inline void ThinSliceBendExitData_set_weight(ThinSliceBendExitData restrict  obj, double value){
  int64_t offset=0;
  offset+=24;
  *( double*)(( char*) obj+offset)=value;
}
 static inline  double* ThinSliceBendExitData_getp_weight(ThinSliceBendExitData restrict  obj){
  int64_t offset=0;
  offset+=24;
  return ( double*)(( char*) obj+offset);
}
#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_CONSTANTS_H
#define XTRACK_CONSTANTS_H

#if !defined( C_LIGHT )
    #define   C_LIGHT ( 299792458.0 )
#endif /* !defined( C_LIGHT ) */

#if !defined( EPSILON_0 )
    #define   EPSILON_0 (8.854187817620e-12)
#endif /* !defined( EPSILON_0 ) */

#if !defined( PI )
    #define PI (3.1415926535897932384626433832795028841971693993751)
#endif /* !defined( PI ) */

#if !defined( MU_0 )
    #define MU_0 (PI*4.0e-7)
#endif /* !defined( MU_0 ) */

#if !defined( DEG2RAD )
    #define DEG2RAD (0.0174532925199432957692369076848861271344287188854)
#endif /* !defiend( DEG2RAD ) */

#if !defined( RAD2DEG )
    #define RAD2DEG (57.29577951308232087679815481410517033240547246656442)
#endif /* !defiend( RAD2DEG ) */

#if !defined( SQRT_PI )
    #define SQRT_PI (1.7724538509055160272981674833411451827975494561224)
#endif /* !defined( SQRT_PI ) */

#if !defined( QELEM )
    #define QELEM (1.60217662e-19)
#endif /* !defined( QELEM ) */

#if !defined( DBL_MAX )
    #define DBL_MAX (1.7976931348623158e+308)
#endif /* !defined( DBL_MAX ) */

#if !defined( DBL_MIN )
    #define DBL_MIN (2.2250738585072014e-308)
#endif /* !defined( DBL_MIN ) */

#if !defined( DBL_EPSILON )
    #define DBL_EPSILON (2.2204460492503131e-16)
#endif /* !defined( DBL_EPSILON ) */

#if !defined( RADIUS_ELECTRON )
    #define RADIUS_ELECTRON (2.8179403262e-15)
#endif /* !defined( RADIUS_ELECTRON ) */

#if !defined( MASS_ELECTRON )
    #define MASS_ELECTRON (9.1093837e-31)
#endif /* !defined( MASS_ELECTRON ) */

#endif /* XTRACK_CONSTANTS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_FUNCTIONS_H
#define XTRACK_FUNCTIONS_H

#include <headers/track.h>


GPUFUN
void kill_all_particles(LocalParticle* part0, int64_t kill_state) {
    START_PER_PARTICLE_BLOCK(part0, part);
        LocalParticle_kill_particle(part, kill_state);
    END_PER_PARTICLE_BLOCK;
}


GPUFUN
int8_t assert_tracking(LocalParticle* part, int64_t kill_state){
    // Whenever we are not tracking, e.g. in a twiss, the particle will be at_turn < 0.
    // We test this to distinguish genuine tracking from twiss.
    if (LocalParticle_get_at_turn(part) < 0){
        LocalParticle_kill_particle(part, kill_state);
        return 0;
    }
    return 1;
}

#endif /* XTRACK_FUNCTIONS_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2023.                 //
// ######################################### //

#ifndef XTRACK_PARTICLE_STATES_H
#define XTRACK_PARTICLE_STATES_H

#define  XT_LOST_ON_APERTURE       0
#define  XT_LOST_ON_LONG_CUT      -2
#define  XT_LOST_ALL_E_IN_SYNRAD -10
#define  RNG_ERR_SEEDS_NOT_SET   -20
#define  RNG_ERR_INVALID_TRACK   -21
#define  RNG_ERR_RUTH_NOT_SET    -22

#endif /* XTRACK_PARTICLE_STATES_H */

// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2025.                 //
// ######################################### //
#ifndef XTRACK_TRACK_SROTATION_H
#define XTRACK_TRACK_SROTATION_H

#include <headers/track.h>


GPUFUN
void SRotation_single_particle(LocalParticle* part, double sin_z, double cos_z){

    double const x  = LocalParticle_get_x(part);
    double const y  = LocalParticle_get_y(part);
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);

    double const x_hat  =  cos_z * x  + sin_z * y;
    double const y_hat  = -sin_z * x  + cos_z * y;
    double const px_hat =  cos_z * px + sin_z * py;
    double const py_hat = -sin_z * px + cos_z * py;

    LocalParticle_set_x(part, x_hat);
    LocalParticle_set_y(part, y_hat);
    LocalParticle_set_px(part, px_hat);
    LocalParticle_set_py(part, py_hat);

}

#endif
// copyright ############################### //
// This file is part of the Xtrack Package.  //
// Copyright (c) CERN, 2021.                 //
// ######################################### //

#ifndef XTRACK_TRACK_DRIFT_H
#define XTRACK_TRACK_DRIFT_H


GPUFUN
void Drift_single_particle_expanded(LocalParticle* part, double length){
    double const rpp    = LocalParticle_get_rpp(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const xp     = LocalParticle_get_px(part) * rpp;
    double const yp     = LocalParticle_get_py(part) * rpp;
    double const dzeta  = 1 - rv0v * ( 1. + ( xp*xp + yp*yp ) / 2. );

    LocalParticle_add_to_x(part, xp * length );
    LocalParticle_add_to_y(part, yp * length );
    LocalParticle_add_to_s(part, length);
    LocalParticle_add_to_zeta(part, length * dzeta );
}


GPUFUN
void Drift_single_particle_exact(LocalParticle* part, double length){
    double const px = LocalParticle_get_px(part);
    double const py = LocalParticle_get_py(part);
    double const rv0v    = 1./LocalParticle_get_rvv(part);
    double const one_plus_delta = 1. + LocalParticle_get_delta(part);

    double const one_over_pz = 1./sqrt(one_plus_delta*one_plus_delta
                                       - px * px - py * py);
    double const dzeta = 1 - rv0v * one_plus_delta * one_over_pz;

    LocalParticle_add_to_x(part, px * one_over_pz * length);
    LocalParticle_add_to_y(part, py * one_over_pz * length);
    LocalParticle_add_to_zeta(part, dzeta * length);
    LocalParticle_add_to_s(part, length);
}


GPUFUN
void Drift_single_particle(LocalParticle* part, double length){
    #ifndef XTRACK_USE_EXACT_DRIFTS
        Drift_single_particle_expanded(part, length);
    #else
        Drift_single_particle_exact(part, length);
    #endif
}


#endif /* XTRACK_TRACK_DRIFT_H */

#include <beam_elements/elements_src/thin_slice_bend_exit.h>

             static inline
            void ThinSliceBendExit_track_local_particle_with_transformations(ThinSliceBendExitData el, LocalParticle* part0){
    // Transform to local frame
double const _sin_rot_s = ThinSliceBendExitData_get__parent__sin_rot_s(el);
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceBendExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceBendExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceBendExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceBendExitData_get__parent__shift_s(el);

    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, -shift_x);
       LocalParticle_add_to_y(part, -shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

          SRotation_single_particle(part, _sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 + _sin_rot_s*spin_y_0;
               double const spin_y_1 = -_sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif

}
    ThinSliceBendExit_track_local_particle(el, part0);
    // Transform back to global frame
if (_sin_rot_s > -2.) {
    double const _cos_rot_s = ThinSliceBendExitData_get__parent__cos_rot_s(el);
    double const shift_x = ThinSliceBendExitData_get__parent__shift_x(el);
    double const shift_y = ThinSliceBendExitData_get__parent__shift_y(el);
    double const shift_s = ThinSliceBendExitData_get__parent__shift_s(el);

    /* Spin tracking is disabled by the synrad compile flag */
    #ifndef XTRACK_MULTIPOLE_NO_SYNRAD
       // Rotate spin

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

           double const spin_x_0 = LocalParticle_get_spin_x(part);
           double const spin_y_0 = LocalParticle_get_spin_y(part);
           if ((spin_x_0 != 0) || (spin_y_0 != 0)){
               double const spin_x_1 = _cos_rot_s*spin_x_0 - _sin_rot_s*spin_y_0;
               double const spin_y_1 = _sin_rot_s*spin_x_0 + _cos_rot_s*spin_y_0;
               LocalParticle_set_spin_x(part, spin_x_1);
               LocalParticle_set_spin_y(part, spin_y_1);
          }

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    #endif


    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       SRotation_single_particle(part, -_sin_rot_s, _cos_rot_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }



    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

       LocalParticle_add_to_x(part, shift_x);
       LocalParticle_add_to_y(part, shift_y);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }


    if (shift_s != 0.) {

    {
//    const int64_t XT_part_block_start_idx = part0->ipart; //only_for_context cpu_openmp
//    const int64_t XT_part_block_end_idx = part0->endpart; //only_for_context cpu_openmp

    const int64_t XT_part_block_start_idx = 0;                                            //only_for_context cpu_serial
    const int64_t XT_part_block_end_idx = LocalParticle_get__num_active_particles(part0); //only_for_context cpu_serial

    //#pragma omp simd // TODO: currently does not work, needs investigating
    for (int64_t XT_part_block_ii = XT_part_block_start_idx; XT_part_block_ii<XT_part_block_end_idx; XT_part_block_ii++) { //only_for_context cpu_openmp cpu_serial

        LocalParticle lpart = *part0;    //only_for_context cpu_serial cpu_openmp
        LocalParticle* part = &lpart;    //only_for_context cpu_serial cpu_openmp
        part->ipart = XT_part_block_ii;  //only_for_context cpu_serial cpu_openmp

//        LocalParticle* part = part0;     //only_for_context opencl cuda

//        if (LocalParticle_get_state(part) > 0) {  //only_for_context cpu_openmp

            Drift_single_particle(part, -shift_s);

//        }  //only_for_context cpu_openmp
    }  //only_for_context cpu_serial cpu_openmp
    }

    }
}
}


             
            void ThinSliceBendExit_track_particles(
               ThinSliceBendExitData el,

                             ParticlesData particles,

                             int64_t flag_increment_at_element,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);

                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif

                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP

//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int64_t batch_id = 0; batch_id < num_threads; batch_id++) {                   //only_for_context cpu_openmp
                LocalParticle lpart;
                lpart.io_buffer = io_buffer;
//                int64_t part_id = batch_id * chunk_size;                                       //only_for_context cpu_openmp
//                int64_t end_id = (batch_id + 1) * chunk_size;                                  //only_for_context cpu_openmp
//                if (end_id > num_particles_to_track) end_id = num_particles_to_track;          //only_for_context cpu_openmp

                int64_t part_id = 0;                    //only_for_context cpu_serial
//                int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x; //only_for_context cuda
//                int64_t part_id = get_global_id(0);                    //only_for_context opencl
                int64_t end_id = 0; // unused outside of openmp  //only_for_context cpu_serial cuda opencl

                int64_t part_capacity = ParticlesData_get__capacity(particles);
                if (part_id<part_capacity){
                    Particles_to_LocalParticle(particles, &lpart, part_id, end_id);
                    if (check_is_active(&lpart)>0){
              ThinSliceBendExit_track_local_particle_with_transformations(el, &lpart);

                    }
                    if (check_is_active(&lpart)>0 && flag_increment_at_element){
                            increment_at_element(&lpart, 1);
                    }
                }
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }

#ifndef XOBJ_TYPEDEF_ElementRefClass
#define XOBJ_TYPEDEF_ElementRefClass
typedef   struct ElementRefClass_s * ElementRefClass;
enum ElementRefClass_e{ElementRefClass_BeamPositionMonitorData_t,ElementRefClass_BeamProfileMonitorData_t,ElementRefClass_BeamSizeMonitorData_t,ElementRefClass_BendData_t,ElementRefClass_CavityData_t,ElementRefClass_DipoleEdgeData_t,ElementRefClass_DriftData_t,ElementRefClass_DriftSliceData_t,ElementRefClass_DriftSliceBendData_t,ElementRefClass_DriftSliceOctupoleData_t,ElementRefClass_DriftSliceQuadrupoleData_t,ElementRefClass_DriftSliceRBendData_t,ElementRefClass_DriftSliceSextupoleData_t,ElementRefClass_ElensData_t,ElementRefClass_FirstOrderTaylorMapData_t,ElementRefClass_LastTurnsMonitorData_t,ElementRefClass_LimitEllipseData_t,ElementRefClass_LimitPolygonData_t,ElementRefClass_LimitRacetrackData_t,ElementRefClass_LimitRectData_t,ElementRefClass_LimitRectEllipseData_t,ElementRefClass_LineSegmentMapData_t,ElementRefClass_LongitudinalLimitRectData_t,ElementRefClass_MagnetData_t,ElementRefClass_MarkerData_t,ElementRefClass_MultipoleData_t,ElementRefClass_MultipoleEdgeData_t,ElementRefClass_NonLinearLensData_t,ElementRefClass_OctupoleData_t,ElementRefClass_ParticlesMonitorData_t,ElementRefClass_QuadrupoleData_t,ElementRefClass_RBendData_t,ElementRefClass_RFMultipoleData_t,ElementRefClass_ReferenceEnergyIncreaseData_t,ElementRefClass_SRotationData_t,ElementRefClass_SecondOrderTaylorMapData_t,ElementRefClass_SextupoleData_t,ElementRefClass_SimpleThinBendData_t,ElementRefClass_SimpleThinQuadrupoleData_t,ElementRefClass_SolenoidData_t,ElementRefClass_ThickSliceBendData_t,ElementRefClass_ThickSliceOctupoleData_t,ElementRefClass_ThickSliceQuadrupoleData_t,ElementRefClass_ThickSliceRBendData_t,ElementRefClass_ThickSliceSextupoleData_t,ElementRefClass_ThickSliceSolenoidData_t,ElementRefClass_ThinSliceBendData_t,ElementRefClass_ThinSliceBendEntryData_t,ElementRefClass_ThinSliceBendExitData_t,ElementRefClass_ThinSliceOctupoleData_t,ElementRefClass_ThinSliceOctupoleEntryData_t,ElementRefClass_ThinSliceOctupoleExitData_t,ElementRefClass_ThinSliceQuadrupoleData_t,ElementRefClass_ThinSliceQuadrupoleEntryData_t,ElementRefClass_ThinSliceQuadrupoleExitData_t,ElementRefClass_ThinSliceRBendData_t,ElementRefClass_ThinSliceRBendEntryData_t,ElementRefClass_ThinSliceRBendExitData_t,ElementRefClass_ThinSliceSextupoleData_t,ElementRefClass_ThinSliceSextupoleEntryData_t,ElementRefClass_ThinSliceSextupoleExitData_t,ElementRefClass_WireData_t,ElementRefClass_XRotationData_t,ElementRefClass_XYShiftData_t,ElementRefClass_YRotationData_t,ElementRefClass_ZetaShiftData_t};
 static inline ElementRefClass ElementRefClass_getp(ElementRefClass restrict  obj){
  int64_t offset=0;
  return (ElementRefClass)(( char*) obj+offset);
}
 static inline int64_t ElementRefClass_typeid(const ElementRefClass restrict  obj){
  int64_t offset=0;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline  void* ElementRefClass_member(const ElementRefClass restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset);
 return ( void*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_ArrNElementRefClass
#define XOBJ_TYPEDEF_ArrNElementRefClass
typedef   struct ArrNElementRefClass_s * ArrNElementRefClass;
 static inline ArrNElementRefClass ArrNElementRefClass_getp(ArrNElementRefClass restrict  obj){
  int64_t offset=0;
  return (ArrNElementRefClass)(( char*) obj+offset);
}
 static inline int64_t ArrNElementRefClass_len(ArrNElementRefClass restrict  obj){
  int64_t offset=0;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline ElementRefClass ArrNElementRefClass_getp1(ArrNElementRefClass restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*16;
  return (ElementRefClass)(( char*) obj+offset);
}
 static inline int64_t ArrNElementRefClass_typeid(const ArrNElementRefClass restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*16;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline  void* ArrNElementRefClass_member(const ArrNElementRefClass restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16+i0*16;
  offset+=*( int64_t*)(( char*) obj+offset);
 return ( void*)(( char*) obj+offset);
}
#endif
#ifndef XOBJ_TYPEDEF_ElementRefData
#define XOBJ_TYPEDEF_ElementRefData
typedef   struct ElementRefData_s * ElementRefData;
 static inline ElementRefData ElementRefData_getp(ElementRefData restrict  obj){
  int64_t offset=0;
  return (ElementRefData)(( char*) obj+offset);
}
 static inline ArrNElementRefClass ElementRefData_getp_elements(ElementRefData restrict  obj){
  int64_t offset=0;
  offset+=16;
  return (ArrNElementRefClass)(( char*) obj+offset);
}
 static inline int64_t ElementRefData_len_elements(ElementRefData restrict  obj){
  int64_t offset=0;
  offset+=16;
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline ElementRefClass ElementRefData_getp1_elements(ElementRefData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16;
  offset+=16+i0*16;
  return (ElementRefClass)(( char*) obj+offset);
}
 static inline int64_t ElementRefData_typeid_elements(const ElementRefData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16;
  offset+=16+i0*16;
  offset+=8;
  return *( int64_t*)(( char*) obj+offset);
}
 static inline  void* ElementRefData_member_elements(const ElementRefData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=16;
  offset+=16+i0*16;
  offset+=*( int64_t*)(( char*) obj+offset);
 return ( void*)(( char*) obj+offset);
}
 static inline ArrNString ElementRefData_getp_names(ElementRefData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  return (ArrNString)(( char*) obj+offset);
}
 static inline int64_t ElementRefData_len_names(ElementRefData restrict  obj){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
   int64_t* arr = ( int64_t*)(( char*) obj+offset);
  return arr[1];
}
 static inline  char* ElementRefData_getp1_names(ElementRefData restrict  obj, int64_t i0){
  int64_t offset=0;
  offset+=*( int64_t*)(( char*) obj+offset+8);
  offset=*( int64_t*)(( char*) obj+offset+16+i0*8);
  return ( char*)(( char*) obj+offset);
}
#endif

             
            void track_line(
                  int8_t* buffer,
                             ElementRefData elem_ref_data,
                             ParticlesData particles,
                             int num_turns,
                             int ele_start,
                             int num_ele_track,
                             int flag_end_turn_actions,
                             int flag_reset_s_at_end_turn,
                             int flag_monitor,
                             int num_ele_line,
                             double line_length,
                  int8_t* buffer_tbt_monitor,
                             int64_t offset_tbt_monitor,
                  int8_t* io_buffer){

//            #define CONTEXT_OPENMP  //only_for_context cpu_openmp
            #ifdef CONTEXT_OPENMP
                const int64_t capacity = ParticlesData_get__capacity(particles);
                const int num_threads = omp_get_max_threads();

                #ifndef XT_OMP_SKIP_REORGANIZE
                    const int64_t num_particles_to_track = ParticlesData_get__num_active_particles(particles);
                    
                    {
                        LocalParticle lpart;
                        lpart.io_buffer = io_buffer;
                        Particles_to_LocalParticle(particles, &lpart, 0, capacity);
                        check_is_active(&lpart);
                        count_reorganized_particles(&lpart);
                        LocalParticle_to_Particles(&lpart, particles, 0, capacity);
                    }
                #else // When we skip reorganize, we cannot just batch active particles
                    const int64_t num_particles_to_track = capacity;
                #endif
                
                const int64_t chunk_size = (num_particles_to_track + num_threads - 1)/num_threads; // ceil division
            #endif // CONTEXT_OPENMP
            
//            #pragma omp parallel for                                                           //only_for_context cpu_openmp
//            for (int chunk = 0; chunk < num_threads; chunk++) {                                //only_for_context cpu_openmp
//            int64_t part_id = chunk * chunk_size;                                              //only_for_context cpu_openmp
//            int64_t end_id = (chunk + 1) * chunk_size;                                         //only_for_context cpu_openmp
//            if (end_id > num_particles_to_track) end_id = num_particles_to_track;              //only_for_context cpu_openmp

            int64_t part_id = 0;                                      //only_for_context cpu_serial
//            int64_t part_id = blockDim.x * blockIdx.x + threadIdx.x;  //only_for_context cuda
//            int64_t part_id = get_global_id(0);                       //only_for_context opencl
            int64_t end_id = 0; // unused outside of openmp           //only_for_context cpu_serial cuda opencl

            LocalParticle lpart;
            lpart.io_buffer = io_buffer;

              int8_t* tbt_mon_pointer =
                            buffer_tbt_monitor + offset_tbt_monitor;
            ParticlesMonitorData tbt_monitor =
                            (ParticlesMonitorData) tbt_mon_pointer;

            int64_t part_capacity = ParticlesData_get__capacity(particles);
            if (part_id<part_capacity){
            Particles_to_LocalParticle(particles, &lpart, part_id, end_id);

            int64_t isactive = check_is_active(&lpart);

            for (int64_t iturn=0; iturn<num_turns; iturn++){

                if (!isactive){
                    break;
                }

                int64_t const ele_stop = ele_start + num_ele_track;

                #if defined(XSUITE_BACKTRACK) || defined(XSUITE_MIRROR)
                int64_t elem_idx = ele_stop - 1;
                int64_t const increm = -1;
                if (flag_end_turn_actions>0){
                    increment_at_turn_backtrack(&lpart, flag_reset_s_at_end_turn,
                                                line_length, num_ele_line);
                }
                #else
                if (flag_monitor==1){
                    ParticlesMonitor_track_local_particle(tbt_monitor, &lpart);
                }
                int64_t elem_idx = ele_start;
                int64_t const increm = 1;
                #endif

                for (; ((elem_idx >= ele_start) && (elem_idx < ele_stop)); elem_idx+=increm){
                        if (flag_monitor==2){
                            ParticlesMonitor_track_local_particle(tbt_monitor, &lpart);
                        }

                        // Get the pointer to and the type id of the `elem_idx`th
                        // element in `element_ref_data.elements`:
                          void* el = ElementRefData_member_elements(elem_ref_data, elem_idx);
                        int64_t elem_type = ElementRefData_typeid_elements(elem_ref_data, elem_idx);

                        switch(elem_type){
        

                        case 0:


                            BeamPositionMonitor_track_local_particle_with_transformations((BeamPositionMonitorData) el, &lpart);
                            break;

                        case 1:


                            BeamProfileMonitor_track_local_particle_with_transformations((BeamProfileMonitorData) el, &lpart);
                            break;

                        case 2:


                            BeamSizeMonitor_track_local_particle_with_transformations((BeamSizeMonitorData) el, &lpart);
                            break;

                        case 3:


                            Bend_track_local_particle_with_transformations((BendData) el, &lpart);
                            break;

                        case 4:


                            Cavity_track_local_particle_with_transformations((CavityData) el, &lpart);
                            break;

                        case 5:


                            DipoleEdge_track_local_particle_with_transformations((DipoleEdgeData) el, &lpart);
                            break;

                        case 6:


                            #ifdef XTRACK_GLOBAL_XY_LIMIT
                            global_aperture_check(&lpart);
                            #endif

                            

                            Drift_track_local_particle_with_transformations((DriftData) el, &lpart);
                            break;

                        case 7:


                            DriftSlice_track_local_particle_with_transformations((DriftSliceData) el, &lpart);
                            break;

                        case 8:


                            DriftSliceBend_track_local_particle_with_transformations((DriftSliceBendData) el, &lpart);
                            break;

                        case 9:


                            DriftSliceOctupole_track_local_particle_with_transformations((DriftSliceOctupoleData) el, &lpart);
                            break;

                        case 10:


                            DriftSliceQuadrupole_track_local_particle_with_transformations((DriftSliceQuadrupoleData) el, &lpart);
                            break;

                        case 11:


                            DriftSliceRBend_track_local_particle_with_transformations((DriftSliceRBendData) el, &lpart);
                            break;

                        case 12:


                            DriftSliceSextupole_track_local_particle_with_transformations((DriftSliceSextupoleData) el, &lpart);
                            break;

                        case 13:


                            Elens_track_local_particle_with_transformations((ElensData) el, &lpart);
                            break;

                        case 14:


                            FirstOrderTaylorMap_track_local_particle_with_transformations((FirstOrderTaylorMapData) el, &lpart);
                            break;

                        case 15:


                            LastTurnsMonitor_track_local_particle_with_transformations((LastTurnsMonitorData) el, &lpart);
                            break;

                        case 16:


                            LimitEllipse_track_local_particle_with_transformations((LimitEllipseData) el, &lpart);
                            break;

                        case 17:


                            LimitPolygon_track_local_particle_with_transformations((LimitPolygonData) el, &lpart);
                            break;

                        case 18:


                            LimitRacetrack_track_local_particle_with_transformations((LimitRacetrackData) el, &lpart);
                            break;

                        case 19:


                            LimitRect_track_local_particle_with_transformations((LimitRectData) el, &lpart);
                            break;

                        case 20:


                            LimitRectEllipse_track_local_particle_with_transformations((LimitRectEllipseData) el, &lpart);
                            break;

                        case 21:


                            LineSegmentMap_track_local_particle_with_transformations((LineSegmentMapData) el, &lpart);
                            break;

                        case 22:


                            LongitudinalLimitRect_track_local_particle_with_transformations((LongitudinalLimitRectData) el, &lpart);
                            break;

                        case 23:


                            Magnet_track_local_particle_with_transformations((MagnetData) el, &lpart);
                            break;

                        case 24:


                            Marker_track_local_particle_with_transformations((MarkerData) el, &lpart);
                            break;

                        case 25:


                            Multipole_track_local_particle_with_transformations((MultipoleData) el, &lpart);
                            break;

                        case 26:


                            MultipoleEdge_track_local_particle_with_transformations((MultipoleEdgeData) el, &lpart);
                            break;

                        case 27:


                            NonLinearLens_track_local_particle_with_transformations((NonLinearLensData) el, &lpart);
                            break;

                        case 28:


                            Octupole_track_local_particle_with_transformations((OctupoleData) el, &lpart);
                            break;

                        case 29:


                            ParticlesMonitor_track_local_particle_with_transformations((ParticlesMonitorData) el, &lpart);
                            break;

                        case 30:


                            Quadrupole_track_local_particle_with_transformations((QuadrupoleData) el, &lpart);
                            break;

                        case 31:


                            RBend_track_local_particle_with_transformations((RBendData) el, &lpart);
                            break;

                        case 32:


                            RFMultipole_track_local_particle_with_transformations((RFMultipoleData) el, &lpart);
                            break;

                        case 33:


                            ReferenceEnergyIncrease_track_local_particle_with_transformations((ReferenceEnergyIncreaseData) el, &lpart);
                            break;

                        case 34:


                            SRotation_track_local_particle_with_transformations((SRotationData) el, &lpart);
                            break;

                        case 35:


                            SecondOrderTaylorMap_track_local_particle_with_transformations((SecondOrderTaylorMapData) el, &lpart);
                            break;

                        case 36:


                            Sextupole_track_local_particle_with_transformations((SextupoleData) el, &lpart);
                            break;

                        case 37:


                            SimpleThinBend_track_local_particle_with_transformations((SimpleThinBendData) el, &lpart);
                            break;

                        case 38:


                            SimpleThinQuadrupole_track_local_particle_with_transformations((SimpleThinQuadrupoleData) el, &lpart);
                            break;

                        case 39:


                            Solenoid_track_local_particle_with_transformations((SolenoidData) el, &lpart);
                            break;

                        case 40:


                            ThickSliceBend_track_local_particle_with_transformations((ThickSliceBendData) el, &lpart);
                            break;

                        case 41:


                            ThickSliceOctupole_track_local_particle_with_transformations((ThickSliceOctupoleData) el, &lpart);
                            break;

                        case 42:


                            ThickSliceQuadrupole_track_local_particle_with_transformations((ThickSliceQuadrupoleData) el, &lpart);
                            break;

                        case 43:


                            ThickSliceRBend_track_local_particle_with_transformations((ThickSliceRBendData) el, &lpart);
                            break;

                        case 44:


                            ThickSliceSextupole_track_local_particle_with_transformations((ThickSliceSextupoleData) el, &lpart);
                            break;

                        case 45:


                            ThickSliceSolenoid_track_local_particle_with_transformations((ThickSliceSolenoidData) el, &lpart);
                            break;

                        case 46:


                            ThinSliceBend_track_local_particle_with_transformations((ThinSliceBendData) el, &lpart);
                            break;

                        case 47:


                            ThinSliceBendEntry_track_local_particle_with_transformations((ThinSliceBendEntryData) el, &lpart);
                            break;

                        case 48:


                            ThinSliceBendExit_track_local_particle_with_transformations((ThinSliceBendExitData) el, &lpart);
                            break;

                        case 49:


                            ThinSliceOctupole_track_local_particle_with_transformations((ThinSliceOctupoleData) el, &lpart);
                            break;

                        case 50:


                            ThinSliceOctupoleEntry_track_local_particle_with_transformations((ThinSliceOctupoleEntryData) el, &lpart);
                            break;

                        case 51:


                            ThinSliceOctupoleExit_track_local_particle_with_transformations((ThinSliceOctupoleExitData) el, &lpart);
                            break;

                        case 52:


                            ThinSliceQuadrupole_track_local_particle_with_transformations((ThinSliceQuadrupoleData) el, &lpart);
                            break;

                        case 53:


                            ThinSliceQuadrupoleEntry_track_local_particle_with_transformations((ThinSliceQuadrupoleEntryData) el, &lpart);
                            break;

                        case 54:


                            ThinSliceQuadrupoleExit_track_local_particle_with_transformations((ThinSliceQuadrupoleExitData) el, &lpart);
                            break;

                        case 55:


                            ThinSliceRBend_track_local_particle_with_transformations((ThinSliceRBendData) el, &lpart);
                            break;

                        case 56:


                            ThinSliceRBendEntry_track_local_particle_with_transformations((ThinSliceRBendEntryData) el, &lpart);
                            break;

                        case 57:


                            ThinSliceRBendExit_track_local_particle_with_transformations((ThinSliceRBendExitData) el, &lpart);
                            break;

                        case 58:


                            ThinSliceSextupole_track_local_particle_with_transformations((ThinSliceSextupoleData) el, &lpart);
                            break;

                        case 59:


                            ThinSliceSextupoleEntry_track_local_particle_with_transformations((ThinSliceSextupoleEntryData) el, &lpart);
                            break;

                        case 60:


                            ThinSliceSextupoleExit_track_local_particle_with_transformations((ThinSliceSextupoleExitData) el, &lpart);
                            break;

                        case 61:


                            Wire_track_local_particle_with_transformations((WireData) el, &lpart);
                            break;

                        case 62:


                            XRotation_track_local_particle_with_transformations((XRotationData) el, &lpart);
                            break;

                        case 63:


                            XYShift_track_local_particle_with_transformations((XYShiftData) el, &lpart);
                            break;

                        case 64:


                            YRotation_track_local_particle_with_transformations((YRotationData) el, &lpart);
                            break;

                        case 65:


                            ZetaShift_track_local_particle_with_transformations((ZetaShiftData) el, &lpart);
                            break;

                        } //switch

                    // Setting the below flag will break particle losses
                    #ifndef DANGER_SKIP_ACTIVE_CHECK_AND_SWAPS

                    isactive = check_is_active(&lpart);
                    if (!isactive){
                        break;
                    }

                    #if defined(XSUITE_BACKTRACK) || defined(XSUITE_MIRROR)
                        increment_at_element(&lpart, -1);
                    #else
                        increment_at_element(&lpart, 1);
                    #endif

                    #endif //DANGER_SKIP_ACTIVE_CHECK_AND_SWAPS

                } // for elements

                if (flag_monitor==2){
                    // End of turn (element-by-element mode)
                    ParticlesMonitor_track_local_particle(tbt_monitor, &lpart);
                }

                #if defined(XSUITE_BACKTRACK) || defined(XSUITE_MIRROR)
                if (flag_monitor==1){
                    ParticlesMonitor_track_local_particle(tbt_monitor, &lpart);
                }
                # else
                if (flag_end_turn_actions>0){
                    if (isactive){
                        increment_at_turn(&lpart, flag_reset_s_at_end_turn);
                    }
                }
                #endif

            } // for turns

            LocalParticle_to_Particles(&lpart, particles, part_id, 1);

            }// if partid
//            } //only_for_context cpu_openmp

            // On OpenMP we want to additionally by default reorganize all
            // the particles.
//            #ifndef XT_OMP_SKIP_REORGANIZE                             //only_for_context cpu_openmp
//            LocalParticle lpart;                                       //only_for_context cpu_openmp
//            lpart.io_buffer = io_buffer;                               //only_for_context cpu_openmp
//            Particles_to_LocalParticle(particles, &lpart, 0, capacity);//only_for_context cpu_openmp
//            check_is_active(&lpart);                                   //only_for_context cpu_openmp
//            count_reorganized_particles(&lpart);                       //only_for_context cpu_openmp
//            LocalParticle_to_Particles(&lpart, particles, 0, capacity);//only_for_context cpu_openmp
//            #endif                                                     //only_for_context cpu_openmp
        }//kernel
        